package QBit::Application::Model::API::Yandex::Passport;

use qbit;

use base qw(QBit::Application::Model::API::HTTP);

use XML::Simple;

sub admsubscribe {
    my ($self, %opts) = @_;

    throw Exception::BadArguments gettext('uid or login must be defined')
      unless defined($opts{'uid'}) || defined($opts{'login'});

    throw Exception::BadArguments gettext('Missed required parameter from') unless defined($opts{'from'});

    my $data = $self->call(
        'passport',
        mode => 'admsubscribe',
        map {$_ => $opts{$_}} grep {defined($opts{$_})} qw(uid login from unsubscribe)
    );

    return XMLin($data);
}

TRUE;
