package ru.yandex.direct.api.v5.entity.adgroupadditionaltargetings;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.api.v5.validation.DefectType;
import ru.yandex.direct.api.v5.validation.DefectTypes;
import ru.yandex.direct.core.entity.adgroupadditionaltargeting.service.validation.AdGroupAdditionalTargetingsDefectTranslations;


@ParametersAreNonnullByDefault
public class AdGroupAdditionalTargetingDefectTypes {
    private AdGroupAdditionalTargetingDefectTypes() {
    }

    private static AdGroupAdditionalTargetingsDefectTranslations adGroupAdditionalTargetingsDefectTranslations() {
        return AdGroupAdditionalTargetingsDefectTranslations.INSTANCE;
    }

    public static DefectType targetingAlreadyExists() {
        return DefectTypes.alreadyExists()
                .withDetailedMessage(adGroupAdditionalTargetingsDefectTranslations().targetingAlreadyExists());
    }

    public static DefectType incorrectVersion() {
        return DefectTypes.invalidValue()
                .withDetailedMessage(adGroupAdditionalTargetingsDefectTranslations().incorrectVersion());
    }
}
