package ru.yandex.direct.binlogbroker.logbrokerwriter.components;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.binlogbroker.logbroker_utils.models.SourceType;

/**
 * Эксклюзивная блокировка для какого-то {@link SourceType}.
 * Сам факт существования экземпляра этого интерфейса говорит о том, что блокировка уже взята. Предоставляется лишь
 * возможность снять блокировку через {@link #close()}.
 */
@FunctionalInterface
@ParametersAreNonnullByDefault
public interface SourceGuard extends AutoCloseable {
}
