package ru.yandex.direct.chassis.entity.telegram.handler

import ru.yandex.direct.chassis.entity.telegram.model.AllowedChats
import ru.yandex.direct.telegram.client.api.Message

interface MessageHandler {
    /**
     * @return `true`, если сообщение должно быть обработано этим [MessageHandler]
     */
    fun matches(update: Message): Boolean

    /**
     * Определяет в каких чатах сообщение может быть обработана этим [MessageHandler]
     */
    val allowedChats: AllowedChats

    fun handle(update: Message)
}
