package ru.yandex.direct.ess.logicobjects.feeds.usagetypes

import com.fasterxml.jackson.annotation.JsonProperty
import ru.yandex.direct.binlog.model.Operation
import ru.yandex.direct.dbschema.ppc.enums.CampaignsType
import ru.yandex.direct.ess.common.models.BaseLogicObject
import java.util.*

/**
 * Используется в 2х контурах
 * Для обновления типов использования фидов, при добавлении фида в группу заполняется campaignsType
 * Для отправки типов использования фидов в MBI campaignsType остается пустым
 */
data class FeedUsageTypesObject(
    @JsonProperty("feed_id")
    val feedId: Long?,
    @JsonProperty("campaigns_type")
    val campaignsType: CampaignsType?,
    @JsonProperty("campaign_id")
    val campaign_id: Long?,
    @JsonProperty("adgroup_id")
    val adgroup_id: Long?,
    @JsonProperty("operation")
    val operation: Operation,
) : BaseLogicObject()
