package ru.yandex.direct.useractionlog.model;

import java.util.LinkedHashMap;

import javax.annotation.Nonnull;

import org.apache.commons.lang3.tuple.Pair;

import ru.yandex.direct.binlogclickhouse.schema.FieldValueList;
import ru.yandex.direct.useractionlog.CampaignId;
import ru.yandex.direct.useractionlog.ClientId;

import static ru.yandex.direct.dbschema.ppc.Ppc.PPC;

public class CampaignRowModel extends RowModel {
    private static final String VERSION = "0";

    private static final String CLIENT_ID_NAME = PPC.CAMPAIGNS.CLIENT_ID.getName();
    private static final String CAMPAIGN_ID_NAME = PPC.CAMPAIGNS.CID.getName();

    public CampaignRowModel() {
    }

    public CampaignRowModel(LinkedHashMap<String, String> map) {

        super(map);
    }

    public CampaignRowModel(FieldValueList list) {
        super(list);
    }

    @Override
    public String getVersion() {
        return VERSION;
    }

    public ClientId getClientId() {
        String value = map.get(CLIENT_ID_NAME);
        if (value == null) {
            return null;
        }
        return new ClientId(Long.parseLong(value));
    }

    public CampaignId getCampaignId() {
        String value = map.get(CAMPAIGN_ID_NAME);
        if (value == null) {
            return null;
        }
        return new CampaignId(Long.parseLong(value));
    }

    @Override
    @Nonnull
    Pair<ClientId, CampaignId> getObjectPathParts() {
        ClientId clientId = getClientId();
        CampaignId campaignId = getCampaignId();
        return Pair.of(clientId, campaignId);
    }
}
