package ru.yandex.autotests.directapi.model.api5.campaigns;

import com.yandex.direct.api.v5.campaigns.DynamicTextCampaignNetworkStrategy;
import com.yandex.direct.api.v5.campaigns.DynamicTextCampaignNetworkStrategyTypeEnum;

public class DynamicTextCampaignNetworkStrategyMap extends DynamicTextCampaignStrategyBaseMap<DynamicTextCampaignNetworkStrategyMap> {
    private final DynamicTextCampaignNetworkStrategy item;

    public DynamicTextCampaignNetworkStrategyMap() {
        this(new DynamicTextCampaignNetworkStrategy());
    }

    public DynamicTextCampaignNetworkStrategyMap(DynamicTextCampaignNetworkStrategy mobileAppCampaignNetworkStrategy) {
        item = mobileAppCampaignNetworkStrategy;
    }

    @Override
    protected DynamicTextCampaignNetworkStrategy getBean() {
        return item;
    }

    @Override
    protected DynamicTextCampaignNetworkStrategyMap self() {
        return this;
    }

    public DynamicTextCampaignNetworkStrategyMap withBiddingStrategyType(
            DynamicTextCampaignNetworkStrategyTypeEnum biddingStrategyType) {
        item.withBiddingStrategyType(biddingStrategyType);
        return this;
    }

    public DynamicTextCampaignNetworkStrategyMap defaultServingOff() {
        return this.withBiddingStrategyType(DynamicTextCampaignNetworkStrategyTypeEnum.SERVING_OFF);
    }
}
