package ru.yandex.autotests.directapi.model.api5.campaigns;

import com.yandex.direct.api.v5.campaigns.StrategyAverageCrrAdd;

public class StrategyAverageCrrAddMap {

    public static final String GOAL_ID = "goalId";
    public static final String CRR = "crr";
    public static final String WEEKLY_SPEND_LIMIT = "weeklySpendLimit";

    public static final Integer DEFAULT_CRR = 100;
    public static final Long DEFAULT_WEEKLY_SPEND_LIMIT = 500_000_000L;
    public static final Integer MIN_CRR = 1;
    public static final Integer MAX_CRR = 500;
    private final StrategyAverageCrrAdd item;

    public StrategyAverageCrrAddMap() {
        this(new StrategyAverageCrrAdd());
    }

    public StrategyAverageCrrAddMap(StrategyAverageCrrAdd strategyAverageCrrAdd) {
        item = strategyAverageCrrAdd;
    }

    public StrategyAverageCrrAdd getBean() {
        return item;
    }

    public StrategyAverageCrrAddMap withGoalId(Long goalId) {
        item.withGoalId(goalId);
        return this;
    }

    public StrategyAverageCrrAddMap withCrr(Integer crr) {
        item.withCrr(crr);
        return this;
    }

    public StrategyAverageCrrAddMap withWeeklySpendLimit(Long weeklySpendLimit) {
        item.withWeeklySpendLimit(weeklySpendLimit);
        return this;
    }

    public StrategyAverageCrrAddMap defaultStrategyAverageCrr() {
        return this
                .withCrr(DEFAULT_CRR)
                .withWeeklySpendLimit(DEFAULT_WEEKLY_SPEND_LIMIT);
    }

}
