package ru.yandex.autotests.directapi.model.api5.general;

import java.util.List;

import com.yandex.direct.api.v5.general.IdsCriteria;

/**
 * Author pavryabov
 * Date 25.06.14
 */
public class IdsCriteriaMap {

    public static final String IDS = "ids";

    public static final int IDS_MAX_LENGTH = 10000;
    public static final int VCARDS_IDS_MAX_LENGTH = 1000;
    public static final int SITELINKS_IDS_MAX_LENGTH = 1000;
    public static final int BID_MODIFIERS_IDS_MAX_LENGTH = 1000;
    public static final int CAMPAIGN_IDS_MAX_LENGTH = 1000;

    private final IdsCriteria item;

    public IdsCriteriaMap() {
        this.item = new IdsCriteria();
    }

    public IdsCriteria getBean() {
        return item;
    }

    public IdsCriteriaMap withIds(Long... ids) {
        item.withIds(ids);
        return this;
    }

    public IdsCriteriaMap withIds(List<Long> ids) {
        item.withIds(ids);
        return this;
    }
}
