package ru.yandex.bannerstorage.messaging.services;

import java.sql.Timestamp;

/**
 * @author egorovmv
 */
public interface QueueMessage {
    /**
     * Идентификатор сообщения
     */
    String getMessageId();

    /**
     * Тип сообщения
     */
    String getMessageType();

    /**
     * Время вставки сообщения в очередь
     */
    Timestamp getEnqueuedTime();

    /**
     * Сообщение
     */
    String getPayload();

    /**
     * Кол-во попыток повторной обработки сообщения
     */
    int getRetryCount();
}
