JAVA_PROGRAM(yandex-direct-canvas-backend)

INCLUDE(${ARCADIA_ROOT}/direct/libs/common.inc)

OWNER(
    g:direct
    g:canvas
)

WITH_KOTLIN()

EXCLUDE(
    contrib/java/ch/qos/logback/logback-classic
    contrib/java/org/springframework/boot/spring-boot-starter-logging
    contrib/java/org/springframework/boot/spring-boot-starter-tomcat
)


PEERDIR(
    direct/libs/async-http
    direct/libs/solomon
    direct/libs/tracing
    direct/libs/test-utils
    direct/libs-internal/config
    direct/libs-internal/smart-client
    direct/libs-internal/tvm-web-mvc
    direct/libs-internal/web-auth
    direct/libs-internal/canvas-tools-client
    direct/libs-internal/bs-dsp-creative
    direct/libs-internal/screenshooter

    contrib/java/org/springframework/boot/spring-boot
    contrib/java/org/springframework/boot/spring-boot-autoconfigure
    contrib/java/org/springframework/boot/spring-boot-starter
    contrib/java/org/springframework/boot/spring-boot-starter-aop
    contrib/java/org/springframework/boot/spring-boot-starter-jetty
    contrib/java/org/springframework/boot/spring-boot-starter-web
    contrib/java/org/mongodb/mongo-java-driver

    contrib/java/org/slf4j/slf4j-api
    contrib/java/org/apache/logging/log4j/log4j-slf4j-impl
    contrib/java/org/apache/logging/log4j/log4j-core
    contrib/java/org/apache/logging/log4j/log4j-api

    contrib/java/com/fasterxml/jackson/datatype/jackson-datatype-jdk8
    contrib/java/com/google/code/gson/gson
    contrib/java/com/google/guava/guava
    contrib/java/com/github/spullara/mustache/java/compiler
    contrib/java/org/apache/poi/poi-ooxml
    contrib/java/org/apache/poi/poi
    contrib/java/org/apache/commons/commons-lang3
    contrib/java/org/jsoup/jsoup
    contrib/java/commons-io/commons-io

    contrib/java/com/typesafe/config

    contrib/java/javax/servlet/javax.servlet-api
    contrib/java/org/springframework/retry/spring-retry
    contrib/java/javax/validation/validation-api

    contrib/java/org/springframework/data/spring-data-mongodb
    contrib/java/org/apache/commons/commons-collections4
    contrib/java/org/jetbrains/annotations
    contrib/java/org/apache/httpcomponents/httpasyncclient
    contrib/java/org/apache/httpcomponents/httpclient
    contrib/java/org/apache/httpcomponents/httpcore-nio

    contrib/java/net/javacrumbs/json-unit/json-unit-spring

    iceberg/inside-mds

    ${ARCADIA_ROOT}/direct/canvas/src/main/resources/video_stock
)

JAVA_SRCS(SRCDIR src/main/java **/*)
JAVA_SRCS(SRCDIR src/main/resources **/*)

END()

RECURSE_FOR_TESTS(ut)
