package ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Active.ActiveCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Archived.ArchivedCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.BlGenerated.BlGeneratedCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Draft.DraftCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.DraftOnModeration.DraftOnModerationCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Moderation.ModerationCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Ok.OkCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Processing.ProcessingCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Stopped.StoppedCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Suspended.SuspendedCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Warning.WarningCounter;

@ParametersAreNonnullByDefault
public final class AdGroupsCounters {
    public final ArchivedCounter archivedCounter;
    public final DraftCounter draftCounter;
    public final SuspendedCounter suspendedCounter;
    public final DraftOnModerationCounter draftOnModerationCounter;
    public final ActiveCounter activeCounter;
    public final ModerationCounter moderationCounter;
    public final WarningCounter warningCounter;
    public final ProcessingCounter processingCounter;
    public final OkCounter okCounter;
    public final BlGeneratedCounter blGeneratedCounter;
    public final StoppedCounter stoppedCounter;

    public AdGroupsCounters(
            ArchivedCounter archivedCounter,
            DraftCounter draftCounter,
            SuspendedCounter suspendedCounter,
            DraftOnModerationCounter draftOnModerationCounter,
            ActiveCounter activeCounter,
            ModerationCounter moderationCounter,
            WarningCounter warningCounter,
            ProcessingCounter processingCounter,
            OkCounter okCounter,
            BlGeneratedCounter blGeneratedCounter,
            StoppedCounter stoppedCounter) {
        this.archivedCounter = archivedCounter;
        this.draftCounter = draftCounter;
        this.suspendedCounter = suspendedCounter;
        this.draftOnModerationCounter = draftOnModerationCounter;
        this.activeCounter = activeCounter;
        this.moderationCounter = moderationCounter;
        this.warningCounter = warningCounter;
        this.processingCounter = processingCounter;
        this.okCounter = okCounter;
        this.blGeneratedCounter = blGeneratedCounter;
        this.stoppedCounter = stoppedCounter;
    }
}
