package ru.yandex.direct.core.aggregatedstatuses.logic.RejectedReasons;

import java.util.Set;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.core.entity.aggregatedstatuses.GdSelfStatusReason;

@ParametersAreNonnullByDefault
public final class EntitiesRejectedReasons {
    public static RejectedReasons campaignRejectedReasons = new EntityRejectedReasons(Set.of(
            GdSelfStatusReason.REJECTED_ON_MODERATION
    ));

    public static RejectedReasons adGroupRejectedReasons = new EntityRejectedReasons(Set.of(
            GdSelfStatusReason.REJECTED_ON_MODERATION,
            GdSelfStatusReason.ADGROUP_REJECTED_ON_MODERATION));

    public static RejectedReasons adRejectedReasons = new EntityRejectedReasons(Set.of(
            GdSelfStatusReason.REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_REJECTED_BUT_PREVIOUS_VERSION_SHOWN,
            GdSelfStatusReason.ADGROUP_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_IMAGE_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_VCARD_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_HAS_REJECTED_CALLOUTS,
            GdSelfStatusReason.AD_HAS_REJECTED_SITELINKS,
            GdSelfStatusReason.AD_DISPLAY_HREF_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_TURBOLANDING_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_VIDEO_ADDITION_REJECTED_ON_MODERATION,
            GdSelfStatusReason.AD_HAS_REJECTED_PLACEMENTS,
            GdSelfStatusReason.AD_LOGO_REJECTED_MODERATION,
            GdSelfStatusReason.AD_BUTTON_REJECTED_MODERATION,
            GdSelfStatusReason.AD_MULTICARD_SET_REJECTRED_MODERATION));

    public static RejectedReasons keywordRejectedReasons = new EntityRejectedReasons(Set.of(
            GdSelfStatusReason.REJECTED_ON_MODERATION));
}
