package ru.yandex.direct.core.aggregatedstatuses.logic.RejectedReasons;

import java.util.List;
import java.util.Set;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.core.entity.aggregatedstatuses.GdSelfStatusReason;

@ParametersAreNonnullByDefault
public final class EntityRejectedReasons implements RejectedReasons {
    private final Set<GdSelfStatusReason> rejectedReasons;

    public EntityRejectedReasons(Set<GdSelfStatusReason> rejectedReasons) {
        this.rejectedReasons = rejectedReasons;
    }

    @Override
    public boolean hasRejectedReason(List<GdSelfStatusReason> reasons) {
        return reasons.stream().anyMatch(rejectedReasons::contains);
    }
}
