package ru.yandex.direct.core.aggregatedstatuses.logic.Status.AdGroup;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.core.aggregatedstatuses.logic.AdvancedCounters.Archived.ArchivedCounter;
import ru.yandex.direct.core.aggregatedstatuses.logic.Status.Status;
import ru.yandex.direct.core.entity.aggregatedstatuses.GdSelfStatusEnum;
import ru.yandex.direct.core.entity.aggregatedstatuses.SelfStatus;

@ParametersAreNonnullByDefault
public final class Archived implements Status {
    private final ArchivedCounter adsArchivedCounter;

    public Archived(ArchivedCounter adsArchivedCounter) {
        this.adsArchivedCounter = adsArchivedCounter;
    }

    @Override
    public boolean isValid() {
        return adsArchivedCounter.isAllArchived();
    }

    @Override
    public SelfStatus selfStatus() {
        return SelfStatus.status(GdSelfStatusEnum.ARCHIVED);
    }
}
