package ru.yandex.direct.core.copyentity.mediators

import org.springframework.stereotype.Component

/**
 * Класс нужен для того, чтобы иметь возможность задавать порядок выполнения медиаторов.
 * Если просто использовать автовайринг всех медиаторов, то порядок их выполнения задать не получится.
 */
@Component
class DefaultCopyMediatorsFacade(
    campaignsWithStrategyCheckMetrikaGoalsMediator: CampaignWithStrategyCheckAccessToMetrikaGoalsMediator,
    adGroupsBidFieldsDefaultValuesResolverMediator: AdGroupsBidFieldsDefaultValuesResolverMediator,
) : CopyMediatorsFacade(
    listOf(
        campaignsWithStrategyCheckMetrikaGoalsMediator,
        adGroupsBidFieldsDefaultValuesResolverMediator,
    )
)
