package ru.yandex.direct.core.copyentity.preprocessors.campaign

import org.springframework.stereotype.Component
import ru.yandex.direct.core.copyentity.CopyOperationContainer
import ru.yandex.direct.core.copyentity.preprocessors.CopyPreprocessorTypeSupport
import ru.yandex.direct.core.entity.campaign.model.CampaignWithAllowedOnAdultContentForbidden

@Component
class CampaignWithAllowedOnAdultContentForbiddenCopyPreprocessor :
    CopyPreprocessorTypeSupport<CampaignWithAllowedOnAdultContentForbidden> {
    override fun getTypeClass() = CampaignWithAllowedOnAdultContentForbidden::class.java

    override fun preprocess(entity: CampaignWithAllowedOnAdultContentForbidden, copyContainer: CopyOperationContainer) {
        entity.isAllowedOnAdultContent = null
    }
}
