package ru.yandex.direct.core.copyentity.preprocessors.campaign

import org.springframework.stereotype.Component
import ru.yandex.direct.core.copyentity.CopyOperationContainer
import ru.yandex.direct.core.copyentity.preprocessors.CopyPreprocessorTypeSupport
import ru.yandex.direct.core.entity.campaign.model.CampaignWithOptionalS2sTrackingForbidden

@Component
class CampaignWithOptionalS2sTrackingForbiddenCopyPreprocessor :
    CopyPreprocessorTypeSupport<CampaignWithOptionalS2sTrackingForbidden> {
    override fun getTypeClass() = CampaignWithOptionalS2sTrackingForbidden::class.java

    override fun preprocess(entity: CampaignWithOptionalS2sTrackingForbidden, copyContainer: CopyOperationContainer) {
        entity.isS2sTrackingEnabled = null
    }
}
