package ru.yandex.direct.core.copyentity.preprocessors.campaign

import org.springframework.stereotype.Component
import ru.yandex.direct.core.copyentity.CopyOperationContainer
import ru.yandex.direct.core.copyentity.preprocessors.CopyPreprocessorTypeSupport
import ru.yandex.direct.core.entity.campaign.model.CampaignWithOrderPhraseLengthPrecedenceForbidden

@Component
class CampaignWithOrderPhraseLengthPrecedenceForbiddenCopyPreprocessor :
    CopyPreprocessorTypeSupport<CampaignWithOrderPhraseLengthPrecedenceForbidden> {
    override fun getTypeClass() = CampaignWithOrderPhraseLengthPrecedenceForbidden::class.java

    override fun preprocess(entity: CampaignWithOrderPhraseLengthPrecedenceForbidden, copyContainer: CopyOperationContainer) {
        entity.isOrderPhraseLengthPrecedenceEnabled = null
    }
}
