package ru.yandex.direct.core.entity.adgroupadditionaltargeting.configuration;

import ru.yandex.direct.core.entity.adgroupadditionaltargeting.model.AdGroupAdditionalTargeting;
import ru.yandex.direct.dbschema.ppc.enums.AdgroupAdditionalTargetingsTargetingType;

/**
 * Обеспечивает доступ к классу таргетинга, типу представления в бд
 * ({@link AdgroupAdditionalTargetingsTargetingType}) и способ его конструирования
 *
 * @param <T> тип таргетинга ({@link AdGroupAdditionalTargeting})
 */
public interface AdGroupAdditionalTargetingTypeAccessor<T extends AdGroupAdditionalTargeting> {

    Class<T> getTargetingClass();

    AdgroupAdditionalTargetingsTargetingType getTargetingType();

    T newTargeting();
}
