package ru.yandex.direct.core.entity.banner.repository.old.filter;

import java.util.Collection;

import javax.annotation.ParametersAreNonnullByDefault;

import org.jooq.Record;
import org.jooq.SelectConditionStep;
import org.jooq.SelectJoinStep;

import static ru.yandex.direct.dbschema.ppc.tables.Banners.BANNERS;

/**
 * Применяется в случаях, когда необходимо сделать условие выборки
 * по id различных баннеров, групп, кампаний или креативов
 */
@ParametersAreNonnullByDefault
public class GroupIdFilter extends IdFilter {

    private final Collection<Long> groupIds;

    GroupIdFilter(Collection<Long> groupIds) {
        this.groupIds = groupIds;
    }

    @Override
    public <R extends Record> SelectConditionStep<R> addWhereClause(SelectJoinStep<R> selectJoinStep) {
        return selectJoinStep.where(BANNERS.PID.in(groupIds));
    }

    @Override
    Collection<Long> ids() {
        return groupIds;
    }

}
