package ru.yandex.direct.core.entity.banner.type.body;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import ru.yandex.direct.core.entity.banner.container.BannersAddOperationContainer;
import ru.yandex.direct.core.entity.banner.model.BannerWithFixedBody;
import ru.yandex.direct.core.entity.banner.service.validation.type.add.AbstractBannerAddValidationTypeSupport;
import ru.yandex.direct.validation.builder.ListValidationBuilder;
import ru.yandex.direct.validation.result.Defect;
import ru.yandex.direct.validation.result.ValidationResult;

@Component
public class BannerWithFixedBodyAddValidationTypeSupport
        extends AbstractBannerAddValidationTypeSupport<BannerWithFixedBody> {

    private final BannerWithFixedBodyValidatorProvider validatorProvider;

    @Autowired
    public BannerWithFixedBodyAddValidationTypeSupport(
            BannerWithFixedBodyValidatorProvider validatorProvider) {
        this.validatorProvider = validatorProvider;
    }

    @Override
    public Class<BannerWithFixedBody> getTypeClass() {
        return BannerWithFixedBody.class;
    }

    @Override
    public ValidationResult<List<BannerWithFixedBody>, Defect> validate(
            BannersAddOperationContainer container, ValidationResult<List<BannerWithFixedBody>, Defect> vr) {
        return new ListValidationBuilder<>(vr)
                .checkEachBy(validatorProvider.bannerWithFixedBodyAddValidator(container))
                .getResult();
    }
}
