package ru.yandex.direct.core.entity.brandsafety.translation;

import ru.yandex.direct.i18n.I18NBundle;
import ru.yandex.direct.i18n.Translatable;
import ru.yandex.direct.i18n.bundle.TranslationBundle;
import ru.yandex.direct.i18n.bundle.TranslationStub;


public interface BrandSafetyTranslations extends TranslationBundle {
    BrandSafetyTranslations INSTANCE = I18NBundle.implement(BrandSafetyTranslations.class);

    @TranslationStub("Контент, противоречащий законодательству РФ")
    Translatable brandsafety_unlawful_name();

    @TranslationStub("Упоминание наркотиков, незаконных товаров и услуг, призывы к розни по любому признаку и т. п.")
    Translatable brandsafety_unlawful_description();

    @TranslationStub("Взрослый контент")
    Translatable brandsafety_adult_name();

    @TranslationStub("Контент, демонстрирующий наготу, явное сексуальное поведение, материалы о сексе. Сексуальный и эротический смысл такого контента является основным.")
    Translatable brandsafety_adult_description();

    @TranslationStub("Материалы о терроризме")
    Translatable brandsafety_terrorism_name();

    @TranslationStub("Упоминание террористических организаций, деятелей, терактов, профилактики терактов, спецподразделений, расследований и фактов о терроризме.")
    Translatable brandsafety_terrorism_description();

    @TranslationStub("Негативный контент")
    Translatable brandsafety_negative_name();

    @TranslationStub("Материалы о болезнях, насилии, несчастных случаях, стихийных бедствиях и других происшествиях без явного упоминания жертв, о жестоком обращении с людьми и животными.")
    Translatable brandsafety_negative_description();

    @TranslationStub("Оружие")
    Translatable brandsafety_weapons_name();

    @TranslationStub("Контент о продаже, производстве, хранении оружия, обсуждение оружия для личного пользования, материалы о военном вооружении, включая исторические.")
    Translatable brandsafety_weapons_description();

    @TranslationStub("Ненормативная лексика")
    Translatable brandsafety_obscene_name();

    @TranslationStub("Использование в материалах грубых и нецензурных выражений, жаргонизмов.")
    Translatable brandsafety_obscene_description();

    @TranslationStub("Политика")
    Translatable brandsafety_politics_name();

    @TranslationStub("Современная политика или упоминания политиков, политическая агитация, расследования, международные дипломатические и военные конфликты.")
    Translatable brandsafety_politics_description();

    @TranslationStub("Детский контент")
    Translatable brandsafety_children_name();

    @TranslationStub("Материалы для детей до 12 лет: мультфильмы, игры, литература, фильмы, сериалы, обучающие материалы и т. п.")
    Translatable brandsafety_children_description();

    @TranslationStub("Азартные игры")
    Translatable brandsafety_gambling_name();

    @TranslationStub("Упоминание азартных игр: карты, казино, игровые автоматы, лотереи, ставки на спорт и т.п.")
    Translatable brandsafety_gambling_description();

    @TranslationStub("Новостной контент")
    Translatable brandsafety_news_name();

    @TranslationStub("Новости, записи новостных программ.")
    Translatable brandsafety_news_description();

    @TranslationStub("Раздача контента")
    Translatable brandsafety_torrent_name();

    @TranslationStub("Упоминание способов нелегального распространения музыки, книг, фильмов, программного обеспечения и другой интеллектуальной собственности.")
    Translatable brandsafety_torrent_description();

    @TranslationStub("Религия")
    Translatable brandsafety_religion_name();

    @TranslationStub("Упоминание религии, религиозной атрибутики и обрядов, религиозных деятелей, почитаемых личностей и объектов.")
    Translatable brandsafety_religion_description();

    @TranslationStub("Видеоигры")
    Translatable brandsafety_videogames_name();

    @TranslationStub("Материалы о видеоиграх, кроме официальных трансляций и записей киберспортивных соревнований.")
    Translatable brandsafety_videogames_description();

    @TranslationStub("Знакомства")
    Translatable brandsafety_dating_name();

    @TranslationStub("Контент о знакомствах, площадках знакомств и т. п.")
    Translatable brandsafety_dating_description();

    @TranslationStub("Медицинский контент")
    Translatable brandsafety_medicine_name();

    @TranslationStub("Медицинские новости и статьи, продажа лекарств, медицинские консультации и форумы, материалы о лекарствах, заболеваниях, процедурах и анализах, упоминание названий клиник и медучреждений.")
    Translatable brandsafety_medicine_description();

    @TranslationStub("Алкоголь")
    Translatable brandsafety_alcohol_name();

    @TranslationStub("Упоминание алкоголя, видов и брендов спиртных напитков, их изготовления, употребления и продажи.")
    Translatable brandsafety_alcohol_description();

    @TranslationStub("Табак")
    Translatable brandsafety_tobacco_name();

    @TranslationStub("Упоминание табака, табачных изделий и брендов, производства, употребления и продажи табачных изделий, аксессуаров и приспособлений для курения.")
    Translatable brandsafety_tobacco_description();

    @TranslationStub("Оккультизм и паранормальные явления")
    Translatable brandsafety_occultism_name();

    @TranslationStub("Материалы о паранормальных явлениях и эзотерике, включая гадания, гороскопы, магию и т. п.")
    Translatable brandsafety_occultism_description();

    @TranslationStub("Международные конфликты")
    Translatable brandsafety_ukraine_name();

    @TranslationStub("Материалы о международных конфликтах")
    Translatable brandsafety_ukraine_description();
}
