package ru.yandex.direct.core.entity.campaign.service.validation;

import ru.yandex.direct.validation.defect.params.NumberDefectParams;
import ru.yandex.direct.validation.result.DefectId;

public class StrategyDefectIds {
    public enum Gen implements DefectId<Void> {
        WEEK_BUDGET_LESS_THAN,
        BID_LESS_THAN_AVG_BID,
        AVG_BID_AND_BID_TOGETHER_PROHIBITED,
        INCORRECT_RESERVE_RETURN,
        CAMPAIGN_STRATEGY_INFO_IS_IGNORED_ON_CAMPAIGN_ADD,
        CAMPAIGN_STRATEGY_INFO_IS_IGNORED_ON_CAMPAIGN_UPDATE,
        NEW_STRATEGY_HAS_BEEN_CREATED,
        CAMPAIGN_NOT_IN_PACKAGE,
        INCONSISTENT_STATE_STRATEGY_AND_STRATEGY_TYPE,
        STRATEGY_INFO_MISSED,
        CAMPAIGNS_WITH_DIFFERENT_TYPES_IN_ONE_PACKAGE,
        INCONSISTENT_STATE_STRATEGY_TYPE_AND_CAMPAIGN_TYPE,
        INCONSISTENT_STATE_STRATEGY_TYPE_AND_AD_GROUP_TYPES,
        INCONSISTENT_STATE_STRATEGY_TYPE_AND_MOBILE_CAMPAIGN_WITHOUT_TRACKING_SYSTEM,
        UNABLE_TO_USE_CURRENT_MEANINGFUL_GOALS_FOR_OPTIMIZATION,
        AVG_CPA_IS_REQUIRED,
        MEANINGFUL_GOALS_VALUES_FROM_METRIKA_NOT_SUPPORTED,
        MEANINGFUL_GOALS_VALUES_FROM_METRIKA_INCONSISTENT_STRATEGY,
        MEANINGFUL_GOALS_VALUES_FROM_METRIKA_ALLOW_ONLY_ALL_GOALS,
        PAY_FOR_CONVERSION_NOT_SUPPORTED,
        PAY_FOR_CONVERSION_DOES_NOT_SUPPORT_BANNERS_WITHOUT_TURBO,
        PAY_FOR_CONVERSION_DOES_NOT_SUPPORT_SITELINKS_WITH_HREFS,
        PAY_FOR_CONVERSION_DOES_NOT_ALLOW_WALLET_DAY_BUDGET,
        PAY_FOR_CONVERSION_DOES_NOT_ALLOW_ALL_GOALS,
        NO_MEANINGFUL_GOAL_AVAILABLE_AFTER_COPY,
        STRATEGY_START_DATE_IS_BEFORE_CAMPAIGN_START_DATE,
        STRATEGY_END_DATE_IS_AFTER_CAMPAIGN_END_DATE,
        INCORRECT_SET_OF_MOBILE_GOALS,
        ALL_GOALS_OPTIMIZATION_PROHIBITED,
        WEEKLY_BUDGET_IS_NOT_SUPPORTED,
        LINKING_NON_PUBLIC_STRATEGY_TO_SEVERAL_CAMPAIGNS,
        UNAVAILABLE_STRATEGY_TYPE_FOR_PUBLICATION,
        PUBLIC_STRATEGY_NOT_SUPPORTED_FOR_CLIENTS_WITHOUT_WALLET,
        CHANGE_PUBLIC_STRATEGY_TO_PRIVATE,
        FLAT_CPC_STRATEGY_NOT_SUPPORTED,
        ARCHIVED_STRATEGY_MODIFICATION,
        STRATEGY_ARCHIVING_NOT_ALLOWED,
        WEEKLY_BUDGET_IS_MANDATORY,
        STRATEGY_NOT_FOUND,
    }

    public enum Num implements DefectId<Number> {
        STRATEGY_CHANGING_LIMIT_WAS_EXCEEDED,
        STRATEGY_PERIOD_DAYS_COUNT_LESS_THAN_MIN,
        STRATEGY_PERIOD_DAYS_COUNT_GREATER_THAN_MAX,
        TOO_MUCH_CAMPAIGNS_LINKED_TO_STRATEGY,
    }

    public enum NumParameters implements DefectId<NumberDefectParams> {
        STRATEGIES_NUMBER_LIMIT_EXCEEDED,
        UNARCHIVED_STRATEGIES_NUMBER_LIMIT_EXCEEDED
    }
}
