package ru.yandex.direct.core.entity.campaign.service.validation.type.add;

import java.util.List;

import javax.annotation.ParametersAreNonnullByDefault;

import org.springframework.stereotype.Component;

import ru.yandex.direct.core.entity.campaign.model.CampaignWithForbiddenStrategy;
import ru.yandex.direct.core.entity.campaign.service.validation.type.container.CampaignValidationContainer;
import ru.yandex.direct.validation.builder.ListValidationBuilder;
import ru.yandex.direct.validation.builder.When;
import ru.yandex.direct.validation.result.Defect;
import ru.yandex.direct.validation.result.ValidationResult;
import ru.yandex.direct.validation.wrapper.ModelItemValidationBuilder;

import static ru.yandex.direct.validation.constraint.CommonConstraints.isNull;

@Component
@ParametersAreNonnullByDefault
public class CampaignWithForbiddenStrategyAddValidationTypeSupport
        extends AbstractCampaignAddValidationTypeSupport<CampaignWithForbiddenStrategy> {

    @Override
    public Class<CampaignWithForbiddenStrategy> getTypeClass() {
        return CampaignWithForbiddenStrategy.class;
    }

    @Override
    public ValidationResult<List<CampaignWithForbiddenStrategy>, Defect> preValidate(
            CampaignValidationContainer container,
            ValidationResult<List<CampaignWithForbiddenStrategy>, Defect> vr) {
        return new ListValidationBuilder<>(vr)
                .checkEachBy(campaign -> {
                    var vb = ModelItemValidationBuilder.of(campaign);
                    vb.item(CampaignWithForbiddenStrategy.STRATEGY)
                            .check(isNull(), When.isFalse(container.isCopy()));
                    return vb.getResult();
                })
                .getResult();
    }

}
