package ru.yandex.direct.core.entity.campaign.service.validation.type.add;

import java.util.List;

import org.springframework.stereotype.Component;

import ru.yandex.direct.core.entity.campaign.model.CampaignWithForbiddenWwManagedOrderFlag;
import ru.yandex.direct.core.entity.campaign.service.validation.type.bean.CampaignWithForbiddenWwManagedOrderFlagValidator;
import ru.yandex.direct.core.entity.campaign.service.validation.type.container.CampaignValidationContainer;
import ru.yandex.direct.validation.builder.ListValidationBuilder;
import ru.yandex.direct.validation.result.Defect;
import ru.yandex.direct.validation.result.ValidationResult;

@Component
public class CampaignWithForbiddenWwManagedOrderFlagAddValidationTypeSupport extends AbstractCampaignAddValidationTypeSupport<CampaignWithForbiddenWwManagedOrderFlag> {
    @Override
    public ValidationResult<List<CampaignWithForbiddenWwManagedOrderFlag>, Defect> validate(
            CampaignValidationContainer container,
            ValidationResult<List<CampaignWithForbiddenWwManagedOrderFlag>, Defect> vr) {
        return new ListValidationBuilder<>(vr)
                .checkEachBy(new CampaignWithForbiddenWwManagedOrderFlagValidator())
                .getResult();
    }

    @Override
    public Class<CampaignWithForbiddenWwManagedOrderFlag> getTypeClass() {
        return CampaignWithForbiddenWwManagedOrderFlag.class;
    }
}
