package ru.yandex.direct.core.entity.campaign.service.validation.type.bean;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.core.entity.campaign.model.CampaignWithSkadNetworkForbidden;
import ru.yandex.direct.core.entity.campaign.model.CommonCampaign;
import ru.yandex.direct.validation.builder.Validator;
import ru.yandex.direct.validation.result.Defect;
import ru.yandex.direct.validation.result.ValidationResult;
import ru.yandex.direct.validation.wrapper.ModelItemValidationBuilder;

import static ru.yandex.direct.core.entity.campaign.service.validation.CampaignDefects.inconsistentCampaignType;
import static ru.yandex.direct.validation.constraint.CommonConstraints.notEqual;

@ParametersAreNonnullByDefault
public class CampaignWithSkadNetworkForbiddenValidator<T extends CommonCampaign> implements Validator<T, Defect> {

    @Override
    public ValidationResult<T, Defect> apply(T campaign) {
        var vb = ModelItemValidationBuilder.of(campaign);
        vb.item(CampaignWithSkadNetworkForbidden.IS_SKAD_NETWORK_ENABLED).check(notEqual(true, inconsistentCampaignType()));
        return vb.getResult();
    }
}
