package ru.yandex.direct.core.entity.crypta.repository

import org.springframework.stereotype.Repository
import ru.yandex.direct.core.entity.crypta.model.CaCryptaSegment
import ru.yandex.direct.core.entity.crypta.ytmodels.generated.YtCryptaSegmentsRow
import ru.yandex.direct.core.entity.crypta.ytmodels.generated.YtDbTables
import ru.yandex.direct.ytwrapper.client.YtProvider
import ru.yandex.direct.ytwrapper.model.YtCluster

@Repository
class CryptaSegmentsYtRepository(private val ytProvider: YtProvider) {

    companion object {
        private val YT_CLUSTER = YtCluster.HAHN
    }

    fun getAll(): List<CaCryptaSegment> = ytProvider.getOperator(YT_CLUSTER)
        .readTableAndMap(YtDbTables.CRYPTASEGMENTS, YtCryptaSegmentsRow(), CryptaSegmentsYtConverter::convertFromYt)
}
