package ru.yandex.direct.core.entity.deal.model;

import javax.annotation.ParametersAreNonnullByDefault;

/**
 * Почему это доп. соглашение в Балансе не подходит для того, чтобы на его основании разрешить
 * клиенту пользоваться частными сделками.
 */
@ParametersAreNonnullByDefault
public enum BalanceCollateralProblem {
    /**
     * ещё не начало действовать
     */
    NOT_STARTED_YET,

    /**
     * уже закончило действовать
     */
    NOT_SIGNED,

    /**
     * расторгнуто
     */
    CANCELLED,

    /**
     * тип отличается от "частные сделки, комиссия агентств"
     */
    WRONG_TYPE
}
