package ru.yandex.direct.core.entity.keyword.service.validation.phrase.keyphrase;

import ru.yandex.direct.validation.defect.params.StringDefectParams;
import ru.yandex.direct.validation.result.DefectId;

public class PhraseDefectIds {

    private PhraseDefectIds() {
    }

    public enum Gen implements DefectId<Void> {
        INVALID_QUOTES,
        INVALID_BRACKETS,
        INVALID_EXCLAMATION_MARK,
        INVALID_PLUS_MARK,
        INVALID_MINUS_MARK,
        INVALID_POINT,
        INVALID_APOSTROPHE,
        BOTH_QUOTES_AND_MINUS_WORDS,
        MINUS_WORD_INSIDE_BRACKETS_OR_QUOTES,
        PLUS_MARK_IN_BRACKETS,
        BRACKETS_IN_MINUS_WORDS,
        NO_PLUS_WORDS,
        ONLY_STOP_WORDS,
        INCORRECT_USE_OF_PARENTHESIS
    }

    public enum String implements DefectId<StringDefectParams> {
        TOO_LONG_KEYWORD,
        TOO_LONG_WORD,
        TOO_LONG_MINUS_WORD,
        TOO_MANY_WORDS,
        ILLEGAL_CHARACTERS,
        MINUS_WORD_DELETE_PLUS_WORD,
        NOT_SINGLE_MINUS_WORD
    }
}
