package ru.yandex.direct.core.entity.moderation;

import javax.annotation.ParametersAreNonnullByDefault;

/**
 * Режим работы с версиями при отправке в модерацию:
 * NORMAL - обычный режим, увеличиваем версию при отправке и пишем в базу.
 * IMMUTABLE - отправляем объект с текущей версией или начальной, если версии ещё не было. В базу не сохраняем.
 */
@ParametersAreNonnullByDefault
public enum ModerationVersionMode {
    NORMAL,
    IMMUTABLE
}
