package ru.yandex.direct.core.entity.moderation.model.cpm.frontpage;

import java.util.List;

import javax.annotation.ParametersAreNonnullByDefault;

import com.fasterxml.jackson.annotation.JsonProperty;

import ru.yandex.direct.core.entity.moderation.model.AspectRatio;
import ru.yandex.direct.core.entity.moderation.model.BannerLink;
import ru.yandex.direct.core.entity.moderation.model.BaseBannerModerationData;

@ParametersAreNonnullByDefault
public class FixcpmYndxFrontpageBannerRequestData extends BaseBannerModerationData {
    private String login;
    private String domain;
    private List<BannerLink> links;
    private long creativeId;
    private String creativePreviewUrl;
    private String livePreviewUrl;
    private AspectRatio aspectRatio;
    private String extendedPreviewUrl;
    private AspectRatio minExtendedAspectRatio;
    private AspectRatio maxExtendedAspectRatio;
    private Long videoDuration;
    private String videoUrl;
    private boolean simplePicture;
    private String geo;
    private String currency;
    private String archiveUrl;
    private String bgrcolor;

    @JsonProperty("login")
    public String getLogin() {
        return login;
    }

    public FixcpmYndxFrontpageBannerRequestData setLogin(String login) {
        this.login = login;
        return this;
    }

    @JsonProperty("domain")
    public String getDomain() {
        return domain;
    }

    public FixcpmYndxFrontpageBannerRequestData setDomain(String domain) {
        this.domain = domain;
        return this;
    }

    @JsonProperty("links")
    public List<BannerLink> getLinks() {
        return links;
    }

    public FixcpmYndxFrontpageBannerRequestData setLinks(List<BannerLink> links) {
        this.links = links;
        return this;
    }

    @JsonProperty("creative_id")
    public long getCreativeId() {
        return creativeId;
    }

    public FixcpmYndxFrontpageBannerRequestData setCreativeId(long creativeId) {
        this.creativeId = creativeId;
        return this;
    }

    @JsonProperty("creative_preview_url")
    public String getCreativePreviewUrl() {
        return creativePreviewUrl;
    }

    public FixcpmYndxFrontpageBannerRequestData setCreativePreviewUrl(String creativePreviewUrl) {
        this.creativePreviewUrl = creativePreviewUrl;
        return this;
    }

    @JsonProperty("live_preview_url")
    public String getLivePreviewUrl() {
        return livePreviewUrl;
    }

    public FixcpmYndxFrontpageBannerRequestData setLivePreviewUrl(String livePreviewUrl) {
        this.livePreviewUrl = livePreviewUrl;
        return this;
    }

    @JsonProperty("extended_preview_url")
    public String getExtendedPreviewUrl() {
        return extendedPreviewUrl;
    }

    public FixcpmYndxFrontpageBannerRequestData setExtendedPreviewUrl(String extendedPreviewUrl) {
        this.extendedPreviewUrl = extendedPreviewUrl;
        return this;
    }

    @JsonProperty("simple_picture")
    public boolean isSimplePicture() {
        return simplePicture;
    }

    public FixcpmYndxFrontpageBannerRequestData setSimplePicture(boolean simplePicture) {
        this.simplePicture = simplePicture;
        return this;
    }

    @JsonProperty("aspect_ratio")
    public AspectRatio getAspectRatio() {
        return aspectRatio;
    }

    public FixcpmYndxFrontpageBannerRequestData setAspectRatio(AspectRatio aspectRatio) {
        this.aspectRatio = aspectRatio;
        return this;
    }

    @JsonProperty("min_extended_aspect_ratio")
    public AspectRatio getMinExtendedAspectRatio() {
        return minExtendedAspectRatio;
    }

    public FixcpmYndxFrontpageBannerRequestData setMinExtendedAspectRatio(AspectRatio minExtendedAspectRatio) {
        this.minExtendedAspectRatio = minExtendedAspectRatio;
        return this;
    }

    @JsonProperty("max_extended_aspect_ratio")
    public AspectRatio getMaxExtendedAspectRatio() {
        return maxExtendedAspectRatio;
    }

    public FixcpmYndxFrontpageBannerRequestData setMaxExtendedAspectRatio(AspectRatio maxExtendedAspectRatio) {
        this.maxExtendedAspectRatio = maxExtendedAspectRatio;
        return this;
    }

    @JsonProperty("video_duration")
    public Long getVideoDuration() {
        return videoDuration;
    }

    public FixcpmYndxFrontpageBannerRequestData setVideoDuration(Long videoDuration) {
        this.videoDuration = videoDuration;
        return this;
    }

    @JsonProperty("video_url")
    public String getVideoUrl() {
        return videoUrl;
    }

    public FixcpmYndxFrontpageBannerRequestData setVideoUrl(String videoUrl) {
        this.videoUrl = videoUrl;
        return this;
    }

    @JsonProperty("geo")
    public String getGeo() {
        return geo;
    }

    public FixcpmYndxFrontpageBannerRequestData setGeo(String geo) {
        this.geo = geo;
        return this;
    }

    @JsonProperty("currency")
    public String getCurrency() {
        return currency;
    }

    public FixcpmYndxFrontpageBannerRequestData setCurrency(String currency) {
        this.currency = currency;
        return this;
    }

    @JsonProperty("archive_url")
    public String getArchiveUrl() {
        return archiveUrl;
    }

    public FixcpmYndxFrontpageBannerRequestData setArchiveUrl(String archiveUrl) {
        this.archiveUrl = archiveUrl;
        return this;
    }

    @JsonProperty("bgrcolor")
    public String getBgrcolor() {
        return bgrcolor;
    }

    public FixcpmYndxFrontpageBannerRequestData setBgrcolor(String bgrcolor) {
        this.bgrcolor = bgrcolor;
        return this;
    }
}
