package ru.yandex.direct.core.entity.moderation.repository.sending;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import ru.yandex.direct.core.entity.banner.type.additionalhrefs.BannerAdditionalHrefsRepository;
import ru.yandex.direct.core.entity.moderation.ModerationOperationModeProvider;
import ru.yandex.direct.dbschema.ppc.enums.BannersBannerType;
import ru.yandex.direct.dbschema.ppc.enums.PhrasesAdgroupType;

@Repository
public class GeoproductHtml5BannerModerationRepository extends Html5BannerModerationRepository {

    @Autowired
    public GeoproductHtml5BannerModerationRepository(
            BannerAdditionalHrefsRepository bannerAdditionalHrefsRepository,
            ModerationOperationModeProvider moderationOperationModeProvider) {
        super(bannerAdditionalHrefsRepository, moderationOperationModeProvider);
    }

    @Override
    protected BannersBannerType getBannerType() {
        return BannersBannerType.cpm_banner;
    }

    @Override
    protected List<PhrasesAdgroupType> getPhrasesAdgroupTypes() {
        return List.of(PhrasesAdgroupType.cpm_geoproduct);
    }
}
