package ru.yandex.direct.core.entity.moderation.service.receiving;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import ru.yandex.direct.common.db.PpcPropertiesSupport;
import ru.yandex.direct.core.entity.adgroup.repository.AdGroupRepository;
import ru.yandex.direct.core.entity.banner.repository.BannerRelationsRepository;
import ru.yandex.direct.core.entity.moderation.repository.receiving.BannersModerationReceivingRepository;
import ru.yandex.direct.core.entity.moderation.service.receiving.processing_configurations.CpmYndxFrontpageOperations;
import ru.yandex.direct.core.entity.moderation.service.receiving.processor.response_parser.BannerResponseParser;
import ru.yandex.direct.dbutil.wrapper.DslContextProvider;

import static org.springframework.beans.factory.config.ConfigurableBeanFactory.SCOPE_PROTOTYPE;

@Service
@Scope(SCOPE_PROTOTYPE)
public class CpmYndxFrontpageModerationReceivingService extends BannerModerationResponsesReceivingService {
    @Autowired
    public CpmYndxFrontpageModerationReceivingService(
            BannerRelationsRepository bannerRelationsRepository,
            AdGroupRepository adGroupRepository,
            DslContextProvider dslContextProvider,
            CpmYndxFrontpageOperations cpmYndxFrontpageOperations,
            BannersModerationReceivingRepository bannersModerationReceivingRepository,
            BannerResponseParser bannerResponseParser,
            BannerChangesValidator bannerChangesValidator,
            PpcPropertiesSupport ppcPropertiesSupport
    ) {
        super(bannerRelationsRepository, adGroupRepository, dslContextProvider,
                bannersModerationReceivingRepository, cpmYndxFrontpageOperations, bannerResponseParser,
                bannerChangesValidator, ppcPropertiesSupport);

    }
}
