package ru.yandex.direct.core.entity.moderation.service.receiving.operations.banners;

import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import ru.yandex.direct.core.entity.moderation.model.asset.BannerVideoAdditionModerationResponse;
import ru.yandex.direct.dbschema.ppc.enums.BannersPerformanceStatusmoderate;
import ru.yandex.direct.dbschema.ppc.tables.records.BannersPerformanceRecord;

import static ru.yandex.direct.dbschema.ppc.Tables.BANNERS_PERFORMANCE;
import static ru.yandex.direct.dbschema.ppc.enums.BannersPerformanceStatusmoderate.No;
import static ru.yandex.direct.dbschema.ppc.enums.BannersPerformanceStatusmoderate.Yes;

@Component
@Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class SetVideoAdditionStatusModerateOp extends BaseSetBannerAssetStatusModerateOp<BannersPerformanceRecord,
        BannersPerformanceStatusmoderate, BannerVideoAdditionModerationResponse> {

    public SetVideoAdditionStatusModerateOp() {
        super(BANNERS_PERFORMANCE.BID, BANNERS_PERFORMANCE.STATUS_MODERATE, Yes, No);
    }
}
