package ru.yandex.direct.core.entity.moderation.service.sending;

import org.springframework.beans.factory.annotation.Autowired;

import ru.yandex.direct.core.entity.campaign.repository.CampaignRepository;
import ru.yandex.direct.core.entity.feature.service.FeatureService;
import ru.yandex.direct.core.entity.moderation.ModerationOperationModeProvider;
import ru.yandex.direct.core.entity.moderation.repository.sending.BusinessUnitModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.CpcCanvasBannerModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.remoderation.RemoderationFlagsRepository;
import ru.yandex.direct.core.entity.moderation.service.sending.banner.ModerationFlagsConverter;
import ru.yandex.direct.core.entity.moderation.service.sending.hrefs.parameterizer.HrefParameterizingService;
import ru.yandex.direct.core.entity.turbolanding.repository.TurboLandingRepository;
import ru.yandex.direct.dbutil.wrapper.DslContextProvider;
import ru.yandex.direct.regions.GeoTreeFactory;

@ModerationSender
public class CpcCanvasBannerSender extends CanvasBannerSender {
    @Autowired
    public CpcCanvasBannerSender(DslContextProvider dslContextProvider,
                                 CpcCanvasBannerModerationRepository cpcCanvasBannerModerationRepository,
                                 GeoTreeFactory geoTreeFactory,
                                 RemoderationFlagsRepository remoderationFlagsRepository,
                                 CampaignRepository campaignRepository,
                                 HrefParameterizingService hrefParameterizingService,
                                 TurboLandingRepository turboLandingRepository,
                                 ModerationOperationModeProvider moderationOperationModeProvider,
                                 FeatureService featureService,
                                 BusinessUnitModerationRepository businessUnitModerationRepository,
                                 ModerationFlagsConverter moderationFlagsConverter) {
        super(dslContextProvider, cpcCanvasBannerModerationRepository, geoTreeFactory, remoderationFlagsRepository,
                campaignRepository, hrefParameterizingService, turboLandingRepository,
                moderationOperationModeProvider, featureService, businessUnitModerationRepository,
                moderationFlagsConverter);
    }
}
