package ru.yandex.direct.core.entity.moderation.service.sending;

import org.springframework.beans.factory.annotation.Autowired;

import ru.yandex.direct.core.entity.campaign.repository.CampaignRepository;
import ru.yandex.direct.core.entity.feature.service.FeatureService;
import ru.yandex.direct.core.entity.moderation.ModerationOperationModeProvider;
import ru.yandex.direct.core.entity.moderation.repository.sending.BusinessUnitModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.CpcInBannerModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.remoderation.RemoderationFlagsRepository;
import ru.yandex.direct.core.entity.moderation.service.sending.banner.ModerationFlagsConverter;
import ru.yandex.direct.core.entity.moderation.service.sending.hrefs.parameterizer.HrefParameterizingService;
import ru.yandex.direct.dbutil.wrapper.DslContextProvider;
import ru.yandex.direct.regions.GeoTreeFactory;

@ModerationSender
public class CpcInBannerSender extends InBannerSender {

    @Autowired
    public CpcInBannerSender(DslContextProvider dslContextProvider,
                             CpcInBannerModerationRepository moderationSendingRepository,
                             RemoderationFlagsRepository remoderationFlagsRepository,
                             CampaignRepository campaignRepository,
                             HrefParameterizingService hrefParameterizingService, GeoTreeFactory geoTreeFactory,
                             FeatureService featureService,
                             BusinessUnitModerationRepository businessUnitModerationRepository,
                             ModerationFlagsConverter moderationFlagsConverter,
                             ModerationOperationModeProvider moderationOperationModeProvider) {
        super(dslContextProvider, moderationSendingRepository, remoderationFlagsRepository, campaignRepository,
                hrefParameterizingService, geoTreeFactory, featureService, businessUnitModerationRepository,
                moderationFlagsConverter, moderationOperationModeProvider);
    }
}
