package ru.yandex.direct.core.entity.moderation.service.sending;

import javax.annotation.ParametersAreNonnullByDefault;

import org.springframework.beans.factory.annotation.Autowired;

import ru.yandex.direct.core.entity.campaign.repository.CampaignRepository;
import ru.yandex.direct.core.entity.feature.service.FeatureService;
import ru.yandex.direct.core.entity.moderation.ModerationOperationModeProvider;
import ru.yandex.direct.core.entity.moderation.repository.sending.BusinessUnitModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.GeoproductHtml5BannerModerationRepository;
import ru.yandex.direct.core.entity.moderation.repository.sending.remoderation.RemoderationFlagsRepository;
import ru.yandex.direct.core.entity.moderation.service.sending.banner.ModerationFlagsConverter;
import ru.yandex.direct.core.entity.moderation.service.sending.hrefs.parameterizer.HrefParameterizingService;
import ru.yandex.direct.core.entity.turbolanding.repository.TurboLandingRepository;
import ru.yandex.direct.dbutil.wrapper.DslContextProvider;
import ru.yandex.direct.regions.GeoTreeFactory;

@ModerationSender
@ParametersAreNonnullByDefault
public class GeoproductHtml5BannerSender extends Html5BannerSender {

    @Autowired
    public GeoproductHtml5BannerSender(
            DslContextProvider dslContextProvider,
            GeoproductHtml5BannerModerationRepository geoproductHtml5BannerModerationRepository,
            GeoTreeFactory geoTreeFactory,
            RemoderationFlagsRepository remoderationFlagsRepository,
            CampaignRepository campaignRepository,
            HrefParameterizingService hrefParameterizingService,
            TurboLandingRepository turboLandingRepository,
            ModerationOperationModeProvider moderationOperationModeProvider, FeatureService featureService,
            BusinessUnitModerationRepository businessUnitModerationRepository,
            ModerationFlagsConverter moderationFlagsConverter) {
        super(dslContextProvider, geoproductHtml5BannerModerationRepository, geoTreeFactory,
                remoderationFlagsRepository, campaignRepository, hrefParameterizingService, turboLandingRepository,
                moderationOperationModeProvider, featureService, businessUnitModerationRepository,
                moderationFlagsConverter);
    }
}
