package ru.yandex.direct.core.entity.strategy.type.autobudgetcrr

import org.springframework.stereotype.Component
import ru.yandex.direct.core.entity.strategy.container.StrategyAddOperationContainer
import ru.yandex.direct.core.entity.strategy.model.AutobudgetCrr
import ru.yandex.direct.core.entity.strategy.validation.add.AbstractStrategyAddValidationTypeSupport
import ru.yandex.direct.validation.builder.ListValidationBuilder
import ru.yandex.direct.validation.result.Defect
import ru.yandex.direct.validation.result.ValidationResult

@Component
class AutobudgetCrrAddValidationTypeSupport : AbstractStrategyAddValidationTypeSupport<AutobudgetCrr>() {
    override fun getTypeClass(): Class<AutobudgetCrr> = AutobudgetCrr::class.java

    override fun validate(container: StrategyAddOperationContainer, vr: ValidationResult<List<AutobudgetCrr>, Defect<*>>): ValidationResult<List<AutobudgetCrr>, Defect<*>> {
        val validator = AutobudgetCrrValidatorProvider.createAddStrategyValidator(container)

        return ListValidationBuilder(vr)
            .checkEachBy(validator)
            .result
    }
}
