package ru.yandex.direct.core.entity.strategy.type.common

import ru.yandex.direct.core.entity.strategy.model.StrategyAttributionModel
import ru.yandex.direct.validation.builder.Validator
import ru.yandex.direct.validation.constraint.CommonConstraints
import ru.yandex.direct.validation.result.Defect
import ru.yandex.direct.validation.result.ValidationResult
import ru.yandex.direct.validation.util.validateObject

object AttributionModelValidator : Validator<StrategyAttributionModel?, Defect<*>> {
    override fun apply(t: StrategyAttributionModel?): ValidationResult<StrategyAttributionModel?, Defect<*>> =
        validateObject(t) {
            check(CommonConstraints.notNull())
        }
}
