package ru.yandex.direct.core.entity.strategy.type.withcustomperiodbudgetandcustombid

import org.springframework.stereotype.Component
import ru.yandex.direct.core.entity.strategy.container.StrategyUpdateOperationContainer
import ru.yandex.direct.core.entity.strategy.model.StrategyWithCustomPeriodBudgetAndAvgCpm
import ru.yandex.direct.core.entity.strategy.service.update.AbstractStrategyUpdateOperationTypeSupport
import ru.yandex.direct.model.AppliedChanges

@Component
class StrategyWithCustomPeriodBudgetAndAvgCpmUpdateTypeSupport : AbstractStrategyUpdateOperationTypeSupport<StrategyWithCustomPeriodBudgetAndAvgCpm>() {
    override fun getTypeClass(): Class<StrategyWithCustomPeriodBudgetAndAvgCpm> = StrategyWithCustomPeriodBudgetAndAvgCpm::class.java

    override fun onChangesApplied(updateContainer: StrategyUpdateOperationContainer,
                                  appliedChanges: List<AppliedChanges<StrategyWithCustomPeriodBudgetAndAvgCpm>>) {
        val helper = StrategyWithCustomPeriodBudgetAndCustomBidChangesHelper()
        appliedChanges.forEach { helper.modifyChanges(updateContainer, it) }
    }
}
