package ru.yandex.direct.core.security.authorization;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import org.springframework.security.access.prepost.PreAuthorize;

import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * Помечает операцию как:
 * 1) Должна выполнятся от имени агенства
 * 2) Требуются права на запись настроек
 */
@Retention(RUNTIME)
@Target(METHOD)
@PreAuthorize("hasPermission(null, 'agency', 'write_settings')")
public @interface PreAuthorizeWriteSettings {
}
