# Когда выкладываются релизы

## Если забыл расписание

Расписание в коде: [здесь](https://a.yandex-team.ru/arcadia/direct/apps/chassis/src/main/java/ru/yandex/direct/chassis/entity/telegram/ScheduledMessages.kt?rev=r9520870#L25)
Строчка с `1-4` в пятой позиции &mdash; понедельник-четверг, строчка с `5` &mdash; пятница.

## Как устроен процесс

Каждый день несколько раз робот в админском чате пишет список релизов,
ожидающих выкладку.
Дежурный app-duty читает напоминалку и отпускает релизы на выкладку по [регламенту](../../processes/regulations_deploy_releases_newci.md).

Текущее расписание напоминалок надежнее всего посмотреть [здесь](https://a.yandex-team.ru/arcadia/direct/apps/chassis/src/main/java/ru/yandex/direct/chassis/entity/telegram/ScheduledMessages.kt?rev=r9520870#L25)

В пятницу напоминаний про выкладку меньше, чем в другие дни: только в первой половине дня.

Релизы-исключения — Репликатор и Зеркализатор, про них робот не напоминает.
У них специфическая, долгая выкладка, и ее согласовывают с продовыми дежурными в индивидуальном порядке.

## Когда выложат мой релиз?

Если не возникнет особых обстоятельств, то скорее всего релиз выложат в ближайшее окно выкладок после того, как релизный тикет перешел в состояние Ready To Deploy.

**Важно:** выкладка в ближайшее окно после Ready To Deploy не гарантируется.

Если почему-то важно релиз выложить к определенному времени/в определенный день — напиши об этом в админском чате с призывом дежурных app-duty:
"Релиз DIRECT-NNNNN надо выложить обязательно сегодня/до 15 часов, потому что ..."
Не пропускай часть "потому что" — про мотивацию все равно будут вопросы, сэкономишь всем время, если напишешь сразу.

Напоминать в админском чате про выкладку релиза "на всякий случай" не надо.
Робот аккуратно находит и пишет про все релизы.


## Что может помешать?

Типичные особые обстоятельства, которые отодвигают выкладку релиза:

- у релиза есть невыполненные релизные зависимости
- есть проблемы с миграциями, которые должны быть выполнены до выкладки
- релиз был проблемным на ТС, выкладку оставляем на утро вместо вечера
- в релизе большая взрывоопасная задача, выкладку оставляем на утро вместо вечера
- прямо сейчас происходит проблема в продакшене
- идут/скоро начнутся учения/регламентные работы NOC

## Тест для самопроверки {#quiz}

Для самопроверки можно ответить на несколько вопросов: [ссылка](https://forms.office.com/Pages/ResponsePage.aspx?id=91gB6oFweEaw7X55tD91WioDI29cj_FKvM5f4YSFsflUNzVJOFhPVjFENVZOTjlWSkMyVEJBSkxKQi4u)

Если опросник не показывается, залогинься по [инструкции](../../guide/basics/howto-office-com-login.md)

## Ссылки

- [Расписание напоминаний о выкладках](https://a.yandex-team.ru/arcadia/direct/apps/chassis/src/main/java/ru/yandex/direct/chassis/entity/telegram/ScheduledMessages.kt?rev=r9520870#L25)
- [Админский чат]({{chat-direct-admin}})

