# Оформление задач в релизе
Все задачи в релизе должны быть оформлены надлежащим образом — это повышает его качество,
экономит время коллег сейчас и в будущем, ускоряет приёмку релиза.

Эта страница уточняет [общий подход](../dev/ticket-workflow.md) к оформлению задач.
Ниже перечислены основные требования, предъявляемые к тикетам в контексте каждого из релизов, в который они попадают.


## Применимость к релизу
По тикету легко понять, затрагивают ли его изменения данный релиз.  
Желательно, чтобы для этого не требовалось заглядывать в код, связанные тикеты или другие страницы.

Обычно это решается заполнением поля **Affected apps** и комментариями в тикете.


## Проверка в релизе
В задаче, относящейся к релизу, может требоваться ручная проверка изменений на тестовой среде.  
Ниже описаны возможные варианты.

### Проверка сделана
В тикете видно, что изменения проверили на ТС и как это сделали.  
Это может быть:

- отдельный комментарий о проверке на ТС и её способе
- описание локальной (или на бете) проверки и указание имени приложения в поле **Tested apps**
 

### Не требуется
Если ручное тестирование задачи в релизе не требуется, тикет должен объяснять почему.

Примеры:

- новая или неиспользуемая функциональность, которая будет проверяться в рамках другой задачи
- изменения покрыты юнит- или авто-тестами
- невозможность или нецелесообразность проверки на тестовой среде

Обычно хватает короткого комментария с описанием ситуации


## Статус тикета
Тикет должен быть в правильном статусе: **Бета-тестирование** или **Закрыт**
