# Советы дежурному по "Релизам + ТС"
Если ты дежуришь первый раз, возможно эти советы тебе пригодятся и сделают твое дежурство немного проще.
1. [Установи автотесты](../guide/initial-setup/autotests-local-setup.md) для локального запуска. Скорее всего их придется
   запускать и смотреть их историю изменений. Возможно именно новые изменения в самих тестах приводят к их падению.
2. Не смотри историю изменений через `Annotate` или `Blame`, они не показывают удаленные строки, и может показаться что файл
   не менялся годами. А на самом деле из него удалили вчера несколько строк и поэтому он падает. Смотри `History`.
3. Если упал какой-то автотест, поищи его имя в [Стартреке](https://st.yandex-team.ru), возможно, кто-то уже сталкивался с его падением и написал рецепт исправления.
   ![no alt](_assets/tracker-search.png "поиск в Стартреке")
4. Так же можно поискать по ключевым словам проблемы [на Вики](https://wiki.yandex-team.ru/), вполне возможно, что проблема известная и решение там есть.
   ![no alt](_assets/wiki-search.png "поиск в Вики")
5. При разборе регрессии, посмотри что было в тикетах по предыдущим разборам той же самой регресии, вожможно все рецепты по решению проблем там уже есть.
6. При перезапуске пака автотестов в AQUA, смотри чтобы тег совпадал с релизом. Некоторые паки имеют одинаковое название, но запускаются
   в разных релизах. Перезапускать упавшие автотесты в паках не своего релиза не нужно.
7. Посмотри на тестовые стэйджи директа на [Yandex.Deploy](https://deploy.yandex-team.ru/projects/direct-np). Весть тест накатывается на них.
8. Сохрани в закладки:
   - Cвой тикет по дежурству (он придет в письме). Если тикет так и не пришел к релиз-стендапу понедельника, [создай его самостоятельно](https://st.yandex-team.ru/createTicket?queue=DIRECT&boards%5B%5D=16386&description=%D0%94%D0%BE%D0%BA%D1%83%D0%BC%D0%B5%D0%BD%D1%82%D0%B0%D1%86%D0%B8%D1%8F+%D0%BF%D0%BE+%D0%B4%D0%B5%D0%B6%D1%83%D1%80%D1%81%D1%82%D0%B2%D1%83%3A+https%3A%2F%2Fdocs.yandex-team.ru%2Fdirect-dev%2Fprocesses%2Fdirect-releases-duty&priority=2&summary=%D0%94%D0%B5%D0%B6%D1%83%D1%80%D1%81%D1%82%D0%B2%D0%BE+%D0%BF%D0%BE+%D1%80%D0%B5%D0%BB%D0%B8%D0%B7%D0%B0%D0%BC+%D0%94%D0%B8%D1%80%D0%B5%D0%BA%D1%82%D0%B0%3A+login+2022-mm-dd&tags%5B%5D=%D0%94%D0%B5%D0%B6%D1%83%D1%80%D1%81%D1%82%D0%B2%D0%BE_%D0%BF%D0%BE_%D1%80%D0%B5%D0%BB%D0%B8%D0%B7%D0%B0%D0%BC_%D0%94%D0%B8%D1%80%D0%B5%D0%BA%D1%82%D0%B0&type=2), и укажи актуальный спринт.
   - [Дашборд по релизам](https://st.yandex-team.ru/agile/board/16497), на нем удобно смотреть, какие релизы робот назначил на тебя.
   - [Как чинить беты](../jeri/guide/fix-ts-deploy.md#beta-unavailable) когда они пятисотят.
   - Как смотреть статистику [по упавшим автотестам перла](../reference/qa/regression-perl.md#autotests).
   - Как [чинить некоторые ошибки из регрессий перла](../guide/troubleshooting/perl-regression-errors.md).
   - Как найти падающий юнит-тест в релизе в [отчете Sandbox-таски](../guide/troubleshooting/unittests-in-release.md).
