# Заведение багов

# Баг в продакшене

Для багов в очереди DIRECT можно воспользоваться [Специальной формой](https://st.yandex-team.ru/createTicket?queue=DIRECT&_form=68328) <br>
Для очереди UC [Другая форма](https://st.yandex-team.ru/createTicket?queue=UC&_form=68233). Заметим, что эта форма не такая полная, часть полей необходимо заполнить самостоятельно.

| **Название поля**        | **Как заполнять**  |
| ------------------------ | ------------------|
| **Queue**                | DIRECT             |
| **Type**                 | Bug                |
| **Priority**             | **Critical/Blocker** — обязательно показать дежурному по поддержке, чинить ASAP<br/>**Normal** — показать менеджеру отвечающему за соответствующую область и уточнить у него приоритет, либо показать дежурному по поддержке<br/>**Minor** — дополнительно уведомлять кого-либо о баге не обязательно |
| **Assignee**             | Если баг на продакшн — оставляем пустым |
| **Tags**                 | 1) Проставляем тег зонтика, к которому относится баг (теги зонтика начинаются с *abcumb:*, при проставлении можно пользоваться [справкой по ZBP](https://docs.yandex-team.ru/direct-dev/reference/who-knows#zbp) <br>2)Ставим тег **old** если баг из старой функциональности <br> 3) При необходимости проставляем один из следующих тэгов для корректного определения приоритета: <br> **direct_money_affected** - в результате бага теряем деньги или баг может привести к потенциальным возвратам средств <br> **direct_lots_crm_per_day** - много жалоб в поддержку в течении дня (от 3 штук) <br> **direct_lots_crm_total** - в целом много жалоб пользователей (от 5 штук за всё время)  <br> **direct_karma** - баг портит репутацию сервиса <br> **direct_high_tier_crm** - есть жалоба от клиента высокого тира  <br> **direct_socialnetwork** - есть жалоба в соцсетях  <br> **direct_legal** - юридические риски|
| **Stage**                | **Production** — баг в проде |
| **Bug Source**           | **Команда** — найдено командой Директа (разработка, тестирование, менеджеры)<br/>**Внешние пользователи** — найдено внешними людьми<br/>**Внутренние пользователи** — принесли коллеги из Яндекса<br/>**Асессоры** — найдено асессорами |
| **Bug Detection Method** | заполняем для Bug Source - Команда <br/>**Manually** — найдено руками<br/>**Autotests** — найдено автотестами<br/> **Monitoring** — мониторинги |
| **Type of Bug**          | **Functional** — функциональный баг<br/>**Visual** — визуальный баг верстки<br/>**Internal** — внутренняя проблема, не отражающаяся явно у пользователя<br/>**Integration** — баг интеграции<br/>**Functionality blocked** — баг, следствием которого является тот факт, что для пользователя становится заблокирован тот или иной функционал (например, некорректная валидация не дает сохранить какую-то настройку совсем)<br/>**Crash** — падение страницы<br/>**Content** — проблема в контенте страницы: опечатки, ошибки орфографические и логические<br/>**Legal** — юридические проблемы: оферта, договоры<br/>**Performance** — баг производительности |
| **Audience scale**       | Охват аудитории (описано в разделе ниже)|

# Баг в релизе

Для багов в очереди DIRECT можно воспользоваться [той же формой](https://st.yandex-team.ru/createTicket?queue=DIRECT&_form=68328), что и выше <br>
Для очереди UC завести руками.

| **Название поля**        | **Как заполнять**  |
| ------------------------ | ------------------|
| **Queue**                | DIRECT        |
| **Type**                 | Bug                |
| **Priority**             | **Critical/Blocker** — существенно ломается текущий функционал<br/>**Normal** — серьезная проблема. Стоит показать менеджеру, отвечающему за зонт, нужно ли чинить проблему asap (чаще всего так и бывает)<br/>**Minor** — стоит показать менеджеру, отвечающему за зонт, можно ли выкатить релиз без починки этого бага |
| **Assignee**             | ставится разработчик, из задачи которого появился баг |
| **Tags**                 | Проставляем тег зонтика, к которому относится баг (теги зонтика начинаются с *abcumb:*, при проставлении можно пользоваться [справкой по ZBP](https://docs.yandex-team.ru/direct-dev/reference/who-knows#zbp) |
| **Stage**                | **Release** — баг в проде |
| **Bug Source**           | **Команда** — найдено командой Директа (разработка, тестирование, менеджеры)<br/>**Внешние пользователи** — найдено внешними людьми<br/>**Внутренние пользователи** — принесли коллеги из Яндекса<br/>**Асессоры** — найдено асессорами |
| **Bug Detection Method** | **Manually** — найдено руками<br/>**Asessors** — найдено асессорами<br/> **Monitoring** — мониторинги |
| **Type of Bug**          | **Functional** — функциональный баг<br/>**Visual** — визуальный баг верстки<br/>**Internal** — внутренняя проблема, не отражающаяся явно у пользователя<br/>**Integration** — баг интеграции<br/>**Functionality blocked** — баг, следствием которого является тот факт, что для пользователя становится заблокирован тот или иной функционал (например, некорректная валидация не дает сохранить какую-то настройку совсем)<br/>**Crash** — падение страницы<br/>**Content** — проблема в контенте страницы: опечатки, ошибки орфографические и логические<br/>**Legal** — юридические проблемы: оферта, договоры<br/>**Performance** — баг производительности |


# Баг на этапе разработки

Баг заводится саб-тикетом к задаче, которая тестируется, и в которой баг был найден.

| **Название поля**        | **Как заполнять**  |
| ------------------------ | ------------------|
| **Queue**                | DIRECT         |
| **Type**                 | Bug                |
| **Priority**             | **Critical/Blocker** — существенно ломается текущий функционал<br/>**Normal** — серьезная проблема<br/>**Minor** — небольшая проблема |
| **Assignee**             | ставится разработчик, из задачи которого появился баг |
| **Tags**                 | Проставляем тег зонтика, к которому относится баг (теги зонтика начинаются с *abcumb:*, при проставлении можно пользоваться [справкой по ZBP](https://docs.yandex-team.ru/direct-dev/reference/who-knows#zbp) |
| **Stage**                | **Development** — баг в проде, но закрыт под фичой|
| **Bug Source**           | **Команда** — найдено командой Директа (разработка, тестирование, менеджеры)<br/>**Внешние пользователи** — найдено внешними людьми<br/>**Внутренние пользователи** — принесли коллеги из Яндекса<br/>**Асессоры** — найдено асессорами |
| **Bug Detection Method** | **Manually** — найдено руками<br/>**Asessors** — найдено асессорами<br/> **Monitoring** — мониторинги |
| **Type of Bug**          | **Functional** — функциональный баг<br/>**Visual** — визуальный баг верстки<br/>**Internal** — внутренняя проблема, не отражающаяся явно у пользователя<br/>**Integration** — баг интеграции<br/>**Functionality blocked** — баг, следствием которого является тот факт, что для пользователя становится заблокирован тот или иной функционал (например, некорректная валидация не дает сохранить какую-то настройку совсем)<br/>**Crash** — падение страницы<br/>**Content** — проблема в контенте страницы: опечатки, ошибки орфографические и логические<br/>**Legal** — юридические проблемы: оферта, договоры<br/>**Performance** — баг производительности |

## Заполнение поля *Audience scale*
Для багов продакшена нам важно понимать, сколько пользователей видит/страдает от этого бага. Для определения охвата аудитории есть ряд инструментов:
* [Error booster](https://error.yandex-team.ru/projects/direct/errors?filter=message%20like%20500&period=month) - если понятен текст ошибки (фронтовой или бэкендовой), то выбрав в Error booster проект "DIRECT" и вписав в строку поиска "message like TEXT_OF_ERROR", можно посмотреть количество пользователей, у которых наблюдалась подобная ошибка
* С помощью "Баобаба" (в данный момент доступно только для dna страниц). [Вот эта иконка в левом нижнем углу](https://jing.yandex-team.ru/files/sudar/06-12-21__13-17-20.png). Клик по иконке, наводим курсор на интересующий элемент, зажимаем Ctrl|Command + клик. Происходит переход в Метрику, где можно посмотреть статистику, сколько раз элемент показывается и сколько раз в него кликают.
* [Статистика по посещаемости страниц](https://metrika.yandex.ru/stat/popular?period=month&accuracy=0.1&id=34&stateHash=60bf2077c47eab00310cf1a2) - по данной странице можно определить ежедневный и ежемесячный траффик на страницу, на которой воспроизводится баг
* [Статистика по браузерам](https://metrika.yandex.ru/stat/browsers?group=day&period=quarter&accuracy=0.1&id=34&stateHash=60ee9d845987f60014df0a97) - по данной статистике можно определить процент пользователей, приходящих в Директ с разных браузеров
* [Статистика по активным кампаниям Директа](https://datalens.yandex-team.ru/tvz4zvw8bcwen-obzor-direkta?tab=OZ) - можно посмотреть открутки по кампаниям в разных и интерфейсах и открутки по кампаниям разных типов

В зависимости от выбранного способа определения охвата оценить охват аудитории можно по следующей таблице:
| **Способ / Охват**    | **Small** | **Normal** | **Big** |
| ------------------------ | ------------------| ------------------| ------------------|
| **Error booster**    | <=2 человека в день| 3-10 человек в день | больше 10 человек в день |
| **Баобаб**    | <=2 человека в день| 3-10 человек в день | больше 10 человек в день |
| **Посещаемость страниц**    | <=0.5% пользователей | 0.6-2% пользователей | больше 2% пользователей |
| **Статистика по браузерам**    | <=0.5% пользователей | 0.6-2% пользователей | больше 2% пользователей |
| **Статистика по активным кампаниям**    | открутки <=0.5% | открутки 0.6-2% | открутки больше 2% |

--
<br>
В случае неактуальности информации на данной странице можно обращаться к [Олегу Судареву](https://staff.yandex-team.ru/sudar)
