# Действия после аварий
TODO: часть творчески смержить с [{#T}](../processes/incidents.md), часть сделать инструкциями

Эта страница описывает наши действия с авариями после их завершения.
Относится ко всем авариям с [1 января 2020 года](https://st.yandex-team.ru/DIRECTINCIDENTS-489).

C 10 ноября 2020 года пробуем оформлять аварии в общеяндексовой очереди [SPI](https://st.yandex-team.ru/SPI/order:updated:false/filter?components=84635).
Процедуры и разметка для неё — отличаются, инструкцию собираем [здесь](spi-ticket.md). Когда "обкатаем" её — отразим изменения и на этой странице.

## Зачем это нужно
Аварии затрагивают все аспекты работы сервиса.
Это ценный источник информации, поэтому мы целенаправлено собираем и структурируем её.

Один из результатов такой работы — [дашборд с историей и статистикой](https://dash.yandex-team.ru/aq299sisay946?mode=tv).  
Он позволяет нам:

- видеть общую картину происходящего в сервисе
- осознавать регулярность проблем и планировать способы уменьшениях их влияния
- понимать насколько хорошо работают наши процессы и при необходимости корректировать их.


## Кто этим занимается { #members }
- [ppalex@](https://staff.yandex-team.ru/ppalex) — ответственный за процесс
- [lena-san@](https://staff.yandex-team.ru/lena-san) — ответственный за app-duty
- [adubinkin@](https://staff.yandex-team.ru/adubinkin)
- [gukserg@](https://staff.yandex-team.ru/gukserg)
- [maxlog@](https://staff.yandex-team.ru/maxlog)
- [yukaba@](https://staff.yandex-team.ru/yukaba)

Над авариями работают [дежурные по продакшену Директа](https://abc.yandex-team.ru/services/direct-app-duty/) (app-duty), они же участвуют в их оформлении и разборе.

Кворум был выбран на регулярной встрече 12.05.2020.
Другие дежурные и остальные неравнодушные коллеги участвуют в процессе по желанию.

## 1. Первоначальное оформление тикета
Делает дежурный, занимавшийся починкой, в течение 1-3 рабочих дней.

Ожидаем заполнения по [инструкции](spi-ticket.md#after-incident) основных полей (источник, impact, временные отметки, влияние на команду и клиентов) 🤝.
За незаполненные — ругать не будем 👌.

При возникновении сложностей, например с оценкой влияния или временем начала,
можно (и нужно) спрашивать совета в канале [#direct-incidents]({{incidents-channel}}).


## 2. Дооформление
Занимается кворум на еженедельной [встрече](https://calendar.yandex-team.ru/event/53871499).  
Цель:

- разметить полностью все тикеты старше трех дней
- договориться об общем видении по спорным вопросам
- собрать критерии или примеры для дополнения ими инструкций.

Ответственный организует подготовку ([пример](https://st.yandex-team.ru/DIRECT-126003)) ко встрече:

1. выбирает несколько заполненных инцидентов (не больше 10-15 штук)
1. в каждый из них призывает участников кворума с просьбой проверить разметку и высказать свое согласие, сомнение или вопросы
1. ждёт несколько дней, напоминает о призывах
1. просматривает эти инциденты, чтобы:
  1. собрать вопросы или разногласия к обсуждению на встрече
  1. пометить "проверенными" (тегом `reviewed`) инциденты, где с разметкой согласны больше трех человек 
  1. остальные инциденты записать к короткому обсуждению


## 3. Разбор аварии
__Процедура прорабатывается__
Ниже описаны договоренности о процессе со
[встречи 15.06.2020](https://calendar.yandex-team.ru/event/51230260?applyToFuture=0&event_date=2020-06-15T15%3A00%3A00&layerId=18932).

Делаем это на еженедельной основе, на отдельных встречах.
Устоявшегося расписания пока нет, предложено использовать один из трех слотов:
"разбор инцидентов с БК" в понедельник,
встречу "разработчиков Директа" во вторник
или "Дизайн-ревью" по средам.

Встречаемся минимальным составом (кворум), дополнительно приглашаем непосредственных участников инцидента
и коллег (из разработки, менеджеров, тестирования), участвовавших в "жизни" фичи.

Разбираем все новые инциденты инциденты, удовлетворяющие **любому** из критериев _(список неокончательный)_:

- высокое влияние на клиентов
- высокое влияние на команду
- инциденты с пугающим потенциалом (размеченные компонентой `#scary`)

На разбор можно добавить и любую другую аварию — для этого
в инцидентном тикете нужно выполнить макрос **нужен разбор этому инциденту**.

Уже случившиеся (раньше 15.06.2020) инциденты будем разбирать от новых к старым по наличию времени и возможности.
Расширять критерии будем, когда отладим процесс и поймём сколько ресурсов (в первую очередь времени) на него требуется.

Разбираем инциденты по [инструкции](analysis.md).
Получение ответов на вопросы, возникшие при разборе инцидента, должно быть запланировано и сделано.

Остальные Action Items нужно взвесить, некоторые из них — запланировать.
Как именно это делать — ещё не придумано.
Договорились сначала накопить Action Items, чтобы предметно обсуждать способы их оценки и планирования.

Определить текущую стадию разбора инцидента можно по значению поля `Разбор ошибок`:

- `—` _(не задано)_ — инцидент ещё не разобран или ему не требуется разбор
- `Нет` — инциденту нужен разбор, ещё не сделан
- `Разобрано` — инцидент разобран, к нему сформулированы все вопросы и Action Items
- `Да` — на все вопросы получены ответы, Action Items обработаны


## 4. Планирование Action Items
__Процедура прорабатывается__


## Полезные ссылки
- [дашборд](https://dash.yandex-team.ru/aq299sisay946?mode=tv) Директ: инциденты
- [инструкция](spi-ticket.md) по заполнению SPI-тикетов
- [инструкция](analysis.md) по разбору инцидента
- [канал в слаке про инциденты]({{incidents-channel}})
- [встреча](https://calendar.yandex-team.ru/event/41165752) Direct incident review
- [черновик](https://wiki.yandex-team.ru/direct/incident-reveiw/process-draft/) процесса по разбору инцидентов
