Статус документа: рабочий черновик.

Будет дорабатываться по мере практического использования.


# Разбор инцидента
Это описание процедуры разбора инцидентов.

В разделах про предотвращение аварии или уменьшение её тяжести
мы фиксируем понимание "как устроена наша система", что с ней в принципе можно сделать,
даже если проблема не выглядит угрожающе частой или наборот починка запретительно дрогая.

Мотивация за использование отдельных тикетов (вместо комментариев) в качестве артефактов разбора:

- не перемешиваются разные ветви дискуссий
- легче и понятнее воспринимаются: участники обсуждения и от кого ожидается ответ
- возможность инструментального понимания количества Action Item и прогресса в их выполнении


## 1. Уточнение обстоятельств
Нужно **восстановить достаточно полную картину происшествия**.
Записать комментариями в инцидентном тикете новые подробности.
При этом некоторые детали бывает трудно выяснить (за небольшое время) при оформлении тикета, такие как:

- почему не сработал мониторинг, хотя известно о его наличии
- что-то работало не так, как задумано
- мотивация (для чего или как реализовано) о функциональности или процессе, затронутых проблемой

На выяснение каждого из таких обстоятельств нужно [завести тикет](https://st.yandex-team.ru/createTicket?queue=DIRECT&priority=2&type=13)
с типом _Исследование_ и прилинковать его к инциденту.


## 2. Предотвращение аварии
Генерируем идеи **что можно сделать, чтобы такая авария не случилась**.  
Примеры направлений:

- сделать код надежнее (добавить ретраев, научиться обрабатывать ошибки)
- повысить надежность инфраструктуры, добавить резерв
- написать юнит- или автотесты, расширить их покрытие
- поменять архитектуру или дизайн системы так, чтобы ошибка стала невозможной или несущественной

Каждую идею записать в отдельный тикет, прилинковать его к инциденту.
Совсем безумные или невыполнимые идеи (_писать код без багов_) можно записать комментарием, без отдельного тикета.


## 3. Уменьшение тяжести аварии
Генерируем идеи что можно сделать для:

- **ускорения обнаружения проблемы** или **упрощение диагностики**
- **уменьшения её тяжести**
- **ускорения починки**

Примеры категорий:

- устройство новых или улучшение существующих мониторингов
- доработки инструментов
- написание инструкций (что делать, куда смотреть, кому писать)
- улучшения процессов и коммуникации
- инструменты для исправления или переотправки данных: их создание и улучшение

Оформляем каждую идею в виде тикета, привязываем к инциденту.


## Инцидент разобран
Планирование уточнений и задач, созданных в результате разбора выходит за рамки этой инструкции.

После того, как все тикеты заведены и привязаны — нужно выполнить в инцидентном тикете макрос **инцидент разобран**.
Это отметит его как разобранный, установив значение  `Разобрано` в поле `Разбор ошибок`
(`Figured out` в английском интерфейсе) раздела `Тестирование`.
