# Регламент: долгие праздники

## Теория, цель руководства { #purpose }

Подготовка, вход и выход для долгих праздников должны делаться предсказуемо и унифицированно. 
Здесь фиксируем ожидания: как именно все это должно делаться.

## Общий порядок

1. Заведи тикет "Подготовка к праздникам", там собираем список всего, что надо сделать, примеры ниже
1. Заведи тикет "Выход из праздников", примеры ниже
1. Обеспечь дежурства на праздники
    1. Заведи страницу для распределения дежурств <https://wiki.yandex-team.ru/jeri/oncall/holidays/>
    1. Определись, по каким подсистемам будут нужны дежурные и какими блоками будут дежурства(праздники целиком, по одному дню, по два)
    1. Сделай таблицу для дежурств, для каждого дежурства назначь ответственного
    1. Напиши ответственным + на direct-heads@ "распределите дежурства пожалуйста"
    1. Если релевантно, напиши тикеты на работу в выходние (уточнять у annaaleks@)
1. Определись, когда прекращать выкладку релизов перед праздниками
1. Определись, когда прекращать автосборку релизов перед праздниками
1. Минимизируй ожидаемую работу в праздники
    1. Опроси аппдьюти: где сейчас больше всего требуется "ручной привод"
    1. Вместе с подходящими специалистами придумай план, что с этим сделать
    1. Присмотри за выполнением плана
1. Контролируй подготовку по тикету из п.1, по необходимости спрашивай статус/напоминай. Выполненные пункты отмечай хорошо заметными значками
1. Контролируй выход из праздников по тикету из п.2


## Пример тикета "Подготовка к праздникам"

```
* распределить дежурства https://wiki.yandex-team.ru/jeri/oncall/holidays/
* логи (ручное удаление)
  * scripts -- большой messages, надо расширять
    * исследовать DIRECTADMIN-9058
    * увеличить диск в контейнерах DIRECTADMIN-9068
  * jobs -- разовая проблема, ничего не делаем
* запаузить автосборки релизов
  * jobs -- 29 днем
  * api5 -- 28 днем
  * intapi -- 29 днем
  * web+dna -- 30 днем
* отключить напоминания про выкладку релизов
* подготовиться к включению всего обратно
  * тикет со списком DIRECT-134842
  * напоминалка (отложенное сообщение в чат аппдьюти на 10 января)
```


## Пример тикета "Выход из праздников"

```
* 10 января -- включить напоминалки про выкладку релизов
* 10 января -- раскомментировать автосборку релизов
* 11 января -- вернуть мониторинг slb как было DIRECTADMIN-9072
```

## Ссылки {#links}

* дежурства в праздники: <https://wiki.yandex-team.ru/jeri/oncall/holidays/>
* пример тикета про подготовку к праздникам: <https://st.yandex-team.ru/DIRECT-134360>
* пример тикета про выход из праздников: <https://st.yandex-team.ru/DIRECT-134842>
