# Автоматизация для кодревью

Для упрощения процесса кодревью начинаем использовать вот эту тулзу [devexp](https://github.yandex-team.ru/devexp/devexp).
Она позволяет автоматизировать такие вещи как автоматический выбор ревьювера, переводы статусов и апдейт полей в тикетах,
поддержка жизненного цикла ревью и проверка выполнения минимальных требований.

## Быстрый старт
1. Создаём ревью с номером тикета в описании, напрмер: "DIRECT-154086: тестирование автоматики кодревью"
2. После публикации ссылка на ревью прилинкуется к тикету, проставится бейджик в описании pull request и назначится ревьювер (в самом ревью он выставится после старта ревью)
3. Если хочется изменить состав ревьюверов, пишем `/add login` `/remove login` или `/change login_from login_to`. По соглашению в директе не убираем автоматически назначенного ревьюера, он может быть как основным так и опциональным(в случае добавления нового)
4. Стартуем ревью `/start`, в этот момент статус ревью изменится на `in progress` а так же отправится уведомление списку ревьюверов
5. Ревьювер пишет комменты и пишет `/!ok`, тем самым меняя статус ревью на `need changes`
6. Автор ревью поправляет код, пишет `/fixed`, статус ревью снова меняется на `in progress`, так же может пингануть ревьюверов `/ping` `/ping login`
7. Ревьювер пишет `/ok`, статус меняется на `completed`
8. Автор фиксит все красные галочки и мержит pull request(это может просиходить автоматически если использовать `automerge`)

* все команды — это коментарии к ревью без открытия issue
* реакция на команды не мгновенная, нужно через несколько секунд обновить страницу
* управлять списком ревьюверов нужно командами, а смотреть текущий статус — по бейджам в описании
* есть свой [дэш](https://developer-dashboard.yandex-team.ru/) (можно использвать [arcanum](https://a.yandex-team.ru/dashboard))

## Статусы ревью и команды
#### /!ok
тикет: `in progress` </br>
ревью: `need changes` </br>

#### /fixed
тикет: `code review` </br>
ревью: `in progress` </br>

#### /ok
если все галочки выставлены: </br>
тикет: `review completed` </br>
ревью: `complete` </br>

#### /stop
тикет: `open` </br>
ревью: `not started` </br>

#### так же в тикет транслируются поля:
`Reviewers`

`Review pending from`

`Review completed by`

## Нотификации
По умолчанию все уведомления будут приходить в почту. </br>
Для уведомлений в телеграм нужно подключить [бота](https://t.me/codereview_bot) (не забываем нажать start)

## Конфигурация
Наши конфиги [тут](https://a.yandex-team.ru/search?search=,%5Edirect.*.devexp.json,,arcadia,,500&repo=arc)

Конфиг во вложенной директории полностью переопределяет поведение ревьюшной автоматики

В ревью не призываются дежурные appduty и дежурные по релизам

## Важно
Сейчас тулза по факту "сбоку": у неё отдельный стейт, в котором хранится статус и список ревьюеров. Список ревьюеров транслируется в одну сторону — из стейта тулзы в арканум, а вот в обратную — нет. Ждем появления этих фичей в аркануме.

## FAQ
с вопросами и предложениями приходите в [чат](https://t.me/joinchat/JeOGtpm7XT5iMWIy)
