# Дизайн-ревью в Директе

## Что это такое и зачем { #theory }

На ранних стадиях проекта обсуждаем основные архитектурные решения ("дизайн системы"). Это дизайн-ревью.

Зачем: уменьшаем архитектурные сюрпризы при крупных внедрениях.  
Примеры сюрпризов:

- функциональность дублируется
- код нерасширяемый
- сразу после запуска приходится начинать большие рефакторинги
- распределение функциональности по приложениями неудачное
- мониторинги заранее не продуманы
- и т.п.



## Как происходит дизайн-ревьюшная встреча { #meeting }

### До встречи { #before-meeting }

1. Разработчик задачи пишет в дизайн-ревьюшный чат "хочу занять ревью в такой-то день под обсуждение такой-то задачи" и "добавьте меня во встречу" (если еще не в приглашалке)
2. Кто-нибудь из постоянных участников ("архитектурный комитет") встречи добавляет разработчика задачи во встречу 
3. Разработчик задачи добавляет во встречу нужных участников
4. Разработчик задачи пишет описание задачи к ревью, тикетом по шаблону (см. раздел "Ссылки")

### На встрече { #during-meeting }

1. (не обязательно) Кто-нибудь из участников встречи через ТГ-бота заводит тикет на встречу
2. Выбирается/назначается участник, кто будет делать записи ("секретарь встречи")
3. Разработчик задачи коротко рассказывает про задачу
4. Участники встречи задают вопросы и высказывают предложения
5. Все важное секретарь встечи записывает в комментарии в дизайн-ревьюшном тикете или в тикете на встречу


### После встречи { #after-meeting }

1. Разработчик задачи заводит необходимые тикеты и учитывает их при разработке
3. что еще?


## Шпаргалка к обсуждению { #to-discuss }

- Необоснованное расширение технологического стека? 
- Повторения функциональности?
- Расширяемость? Легко ли будет делать следующие аналогичные проекты?
- Сложность в поддержке? 
- Что с отказоустойчивостью? От чего будет ломаться, где надо страховаться?


## Ссылки { #links }

- Шаблон дизайн-ревьюшного тикета: <https://st.yandex-team.ru/createTicket?template=4368&queue=DIRECT>
- Дизайн-ревьюшные тикеты: <https://st.yandex-team.ru/DIRECT/order:updated:false/filter?components=70241>
- Тикеты дизайн-ревьюшных встреч (создаются через ТГ-бота): <https://st.yandex-team.ru/DIRECT/order:updated:false/filter?components=70926>
- Чат дизайн-ревью: [ссылка](../reference/chats#design-review)
- Директовый Дизайн-ревьюшный бот: <https://telegram.me/yd_design_review_bot>
- Рассылка: <https://ml.yandex-team.ru/lists/direct-design-review/> (скорее неживая)
- Старая страница на wiki: <https://wiki.yandex-team.ru/direct/development/design-review/>
- [повторяющаяся встреча в календаре](https://calendar.yandex-team.ru/event/53922294) — помогает понять, у каких людей можно найти (и отредактировать) встречу на конкретную дату


