# queue_buggy.campaigns_count
[juggler](https://juggler.yandex-team.ru/check_details/?host=direct.perl_bsexport&service=queue_buggy.campaigns_count&query=&last=1DAY)

## Описание { #description }
Проверяем количество кампаний в buggy-очереди, которых в обычной ситуации не бывает много.

Если это не так и сейчас в очереди кампаний больше пороговых значений (warn 400, crit 2000 штук):
- это может быть признаком заметной поломки: многие кампании с ней сталкиваются и сами перекладываются в buggy-очередь
- из-за того, что кампании "тормозят" не в std—очереди — обычные алерты на тормоза не сработают
- кампании будут отправляться намного дольше обычного, ведь в этой очереди всего 1-2 воркера (а не десяток как в std)

## Диагностика { #diagnostics }
Оценить по [дашборду](https://solomon.yandex-team.ru/?project=direct&dashboard=bs-export-perl&b=6h) общую картину происходящего:
- нет ли массовых ошибок
- какое состояние у других очередей

Можно выполнить yql-запрос с выборкой ошибок из ответов БК, дописав в where условие на последние полчаса-час.

Полезно для нескольких разных кампаний в messages-логах (`method=bsClientData%`) по `message=%<cid>%` поискать сообщения о том,
что привело к перемещению их в buggy.

Или попровать другие способы из [общей инструкции по диагностике экспорта](../bs-export-diag.md#how-to).

## Решение { #solution }
1. Устранить проблему, приводящую к массовому попаданию кампаний в buggy
2. Для ускорения отправки — перенести кампании обратно в обычную (std) очередь

Если нет уверенности, что кампании не сломают снова обычную очередь, можно пробовать переносить их небольшими порциями в очередь **fast** — там есть по одному воркеру на шард, полностью действующих как std. 
