# mysql_trx_max_age

[Примеры проверок](https://juggler.yandex-team.ru/aggregate_checks/?query=namespace%3Ddirect.prod%26service%3Dmysql_trx_max_age).

## Описание { #description }
Проверяется наличие долгих транзакций в базе. Может служить сигналом о зависших транзациях или FULLSCAN.


## Диагностика { #diagnostics }
Зайти на указанную машину с базой. Для примера это будет ppcdata1-01i.yandex.ru с инстансом ppcdata1.

### Вариант 1
Смотрим через innotop и ищем долгие транзации:
```sh
lm ppcdata1 innotop
```

### Вариант 2
Зайти в БД и поискать запросы через PROCESSLIST:
```sh
lm ppcdata1 -A
```
Откроется mysql-клиент в интерактивном режиме. Выполнить:
```sql
pager grep -v Sleep | less; SHOW FULL PROCESSLIST;
```

## Решение { #solution }
Если известно, что выполняется на указанной базе какая-то работа — можно поставить downtime.

В остальных случаях:
- понять что это за транзакции и откуда они
- узнать, действительно ли они могут так долго работать
- оценить, можно ли их прибивать и не приведет ли это к поломке
- если можно, прибить транзакцию
