# Тестирование регрессии в релизах Директа

## Запуск регрессии скриптом

1. Регрессия в релизах dna запускается скриптом через Crowdtest Runner автоматически при переводе релизного тикета в статус _Testing_
1. В комментариях к релизному тикету робот РМП отписывается о результатах выполнения скрипта 

   {% cut "успешное выполнение скрипта" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-10-04_09-03-50.png "успешное выполнение скрипта")

   {% endcut %}

1. Проверить создались ли раны в TestPalm [по ссылке](https://testpalm.yandex-team.ru/dna/testruns) или по ссылке из коммментария робота РМП

   {% cut "раны в Testpalm" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-10-04_09-09-06.png "раны в Testpalm")

   {% endcut %}

1. Проверить запустился ли процесс тестирования в Хитмане [по ссылке](https://hitman.yandex-team.ru/projects/testing_direct/united_assessors_adapter_direct_dna). Дата запуска должна быть актуальной на момент перевода релизного тикета в _Testing_

   {% cut "процесс в Хитмане" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-03-12_11-43-52.png "процесс в Хитмане")

   {% endcut %}

1. В случае если скрипт был выполнен с ошибкой, то: 
- Лог ошибки запуска отправить [next0](https://staff.yandex-team.ru/next0)
- Проверяем раны в Testpalm и процесс в Хитмане: если все стартануло, то ждем окончания выполнения прогона, если ранов или процесса в Хитмане нет, то запускаем вручную по инструкции ниже

1. После окончания выполнения регрессии разбираем баги от асессоров за даты запуска [по фильтру](https://st.yandex-team.ru/issues/?_q=%28Queue%3A+DIRECTAS%2C+DIRECTCLIENTA++AND+Type%3A+Bug%29+AND+%28%22Resolution%22%3A+empty%28%29+AND+%22Components%22%3A+89789%29+%22Sort+By%22%3A+updated+DESC)  
Скоро будет сделан тикет на регрессию к каждому релизу.


## Как запустить вручную (если скрипт не отработал)

{% note alert %}

В релизах Директа регрессия canvas теперь запускается в одном тикете с dna

{% endnote %}

1. **Создать тикет** в очереди DIRECTAS [по шаблону](https://st.yandex-team.ru/createTicket?template=6819&queue=DIRECTAS). Компонента **dna_regress_resolve** у тикета должна быть уже выставлена.   
Если шаблон недоступен, добавьте его себе кликнув [по ссылке](https://st.yandex-team.ru/settings/templates/issues?name=Тестирование%20регрессии%20в%20релизе%20Директа&owner=1120000000014295&queue=DIRECTAS)
1. В названии тикета указать актуальную **версию релиза** 
1. В поле **Assignee** тикета указать себя
1. После того как тикет создан и все готово для запуска задания асессорам, нажимаем кнопку **Run testing by Assessors**, тикет перейдет в статус _Ready For Assessors_ и появится комментарий от робота со ссылкой на конфигурацию. **Переходим по ссылке**

   {% cut "скриншот тикета" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-04-01_15-47-43.png "скрин тикета")

   {% endcut %}

1. В блоках "Информация про стенд" и "Кого призвать в тикет" нмичего не меняем, в них уже выставлены дефолтные значения "Стенд есть в тикете" и "Взять из конфига" соответственно

   {% cut "скриншот" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2022-01-14_14-47-50.png "скрин информация про стенд и кого призывать")

   {% endcut %}

1. Выбрать **Проверить РЕГРЕСС**

   {% cut "скриншот выбора регрессии" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-03-12_17-01-55.png "скрин регресса")

   {% endcut %}

1. Вводим дополнительные условия, если нужно, чтобы асессоры дополнительно обратили на что-то внимание при тестировании (опционально)

   {% cut "скриншот доп условий" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-03-12_17-02-17.png "скрин доп условий")

   {% endcut %}

1. Как запустить регресс -> **Указать сьюты**, чек-бокс **"Создать тикет в асессорской очереди"** должен быть деактивирован

   {% cut "скриншот сьютов" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-10-25_14-38-57.png "скрин указания сьютов")

   {% endcut %}

1. Имя версии в TestPalm - **Использовать имя по-умолчанию**, Хотите ввести код доступа к рану? - **Нет, код на старт не нужен**, Длительность выполнения регресса - 2. Все значения дефолтные - не изменяем

   {% cut "скриншот настроек версии в TestPalm" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2022-01-14_14-54-44.png "скрин настроек версии и рана")

   {% endcut %}

1. Наполняем таблицу сьютами.
   Для запуска полной регрессии
   - выбираем сьют **regression**, по умолчанию для него выбраны браузеры **Firefox, Yandex Browser** - оставляем их, в поле брони выбираем **Использовать бронь из файла** и выбираем в дропдауне регулярную бронь для регрессии Директа _a4fca47c-9d6a-4fc0-b7d0-cc07f22d76b4_ 
   - выбираем сьют **regression_optional**, по умолчанию для него выбран браузер **Safari** - оставляем его, в поле брони выбираем **Использовать бронь из файла** и выбираем в дропдауне регулярную бронь для регрессии в Safari _1e0f8c74-fd95-47b7-85ad-2716aeafe952_ 
   - выбираем сьют **canva_regressions**, по умолчанию для него выбран браузер **Browser** - оставляем его (это рандомный браузер), в поле брони выбираем **Использовать бронь из файла** и выбираем в дропдауне регулярную бронь для регрессии Директа _a4fca47c-9d6a-4fc0-b7d0-cc07f22d76b4_ 

   Сверить регулярные брони можно [в Бронировщике](https://booking.yandex-team.ru/#/bookings?type=regular). Если нет доступа к брони, запросите роль через IDM по [инструкции в Бронировщике](https://booking.yandex-team.ru/#/help?section=quota-control).

   {% cut "скриншот выбранных сьютов" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2022-02-03_15-08-16.png "скрин сьютов"))

   {% endcut %}

   {% note warning %}

   Поскольку Safari - редкое окружение, то есть вероятность большой задержки выполнения регрессии в этом браузере. В таком случае ориентируемся только на ЯБ и Firefox и считаем пак в Safari некритичным для выкатки релиза. Результаты Safari разбираем постфактум.

   {% endnote %}

1. Нажать на кнопку в конце "Закончить конфигурацию".

   {% cut "скриншот завершения конфигурации" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2022-02-03_15-11-51.png "скрин завершения конфигурации")

   {% endcut %}

1. Перевести тикет из п.1 в статус _Testing_

   {% cut "скриншот тикета" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-10-25_14-40-38.png "скрин тикета")

   {% endcut %}

1. В релизный тикет комментарием пишем _"Создан тикеты на регрессию асессорами"_ и прикладываем ссылку на тикет с регрессией dna и canvas.

1. Как только асессоры выполнят регрессию, робот призовет вас в тикет. Разбираем созданные ими баги по правилам, описанным [в документации по разбору](assessors-bugs-resolution.md). Баги можно будет найти в тикете из п.1. или [на релизной борде](https://st.yandex-team.ru/dashboard/50158)
   - Передаем найденные баги в разработку: создаем их в очереди DIRECT (не переносим!!! это важно для статистики команды асессоров). Чиним баги ТС в релизе, процесс тут не меняется.
   - **Проблемы в кейсах и тестовых данных чиним в приоритетном порядке до старта следующей регрессии, чтобы в следующем запуске кейсы выполнились.**

   За процессом выполнения можно следить в [Хитмане по полю "Статус"](https://hitman.yandex-team.ru/projects/testing_direct/direct_dna) или в [TestPalm по полю "Status"](https://testpalm.yandex-team.ru/dna/testruns).

   {% cut "скриншот статуса в Хитмане" %}

   ![alt text](https://jing.yandex-team.ru/files/sonick/2021-03-12_11-43-52.png "скрин статуса в Хитмане")

   {% endcut %}

1. После разбора всех багов тикет на запуск (из п.1 и п.12) закрываем с комментарием. Для комментария используем [шаблон](https://st.yandex-team.ru/settings/templates/comments?name=Результаты%20регрессии%20асессорами&owner=1120000000014295&queue=DIRECTAS): заполняем в нем статистику по найденным багам и проблемам в кейсах.
