# Дайджест документации #10

Продолжаем эксперименты с форматом дайджестов — в этот раз дайджест документации размещен в самой документации!

Натолкнула на эту идею необходимость поддерживать ссылки в актуальном состоянии при рефакторингах документации.
Снаружи, например в этушке, это можно делать только вручную.
А внутри документации (с точностью до страницы) это работает "из коробки" — корректность внутренних ссылок проверяется при каждой сборке.

Другой плюс: опечатки может исправить любой коллега, а не только автор поста.

## Новое
1. В **Справочнике** завели подраздел **Продукт**.  
   Возлагаем на него большие надежды, а пока в нём всего две странички:
   - [{#T}](../../product/about-this-section.md)
   - большое описание про [{#T}](../../product/sprav-organizations.md)
1. Рядом добавили подраздел **Документация**, в него:
   - переехала страничка [{#T}](../achievements.md)
   - добавлена страница [со ссылками на документацию](../external-links.md), давно живущая в репозитории в скрытом виде
   - переехал первый "KNOL" из трекера — DIRECTKNOL-64 — превратившись в справку [{#T}](../statistics.md) и инструкцию [{#T}](../../../guide/analytics/how-to-get-access-to-metrika-counter.md)

   {% note tip "Кстати" %}
   
   Это первый DIRECTKNOL, переехавший из трекера. Осталось перенести ещё 65 штук.
   Помогайте 😉
   
   {% endnote %}
1. В **Руководствах** появился подраздел **Первоначальная настройка**.  
   В него перехала из вики обновленная инструкция по [по созданию GPG-ключей](../../../guide/initial-setup/gpg-key.md)
1. Там же завели подраздел **Общее** и перенесли в него [{#T}](../../../guide/analytics/abc-direct-analytics.md)
1. Завели инструкцию про [{#T}](../../../releases/release-complications.md).  
   Сейчас из неё можно узнать что делать, если [{#T}](../../../releases/release-complications.md#no-links)
   или [{#T}](../../../releases/release-complications.md#create-release-failed )
1. Написали что делать, если [{#T}](../../../guide/troubleshooting/maximum-number-of-campaigns.md).
   _Эта инструкция успела побыть на предыдущей странице про релизы, но ощущалась там "не в тему" и была выделена на свою страницу._
1. Написали инструкцию по [заведению дежурства в ABC](../../../guide/new-abc-duty.md)
1. Рассказали о том, что [таблицы в YT можно создавать по схеме в JSON](../../../guide/jeri/yt-create-table.md)
   и какие команды для этого [писать в файле миграции](../../../jeri/guide/yt-create-table-migr.md)

## Обновления
1. Актуализировали инструкции по сборке релизов [java-web](../../../guide/releases/java-web.md) и [java-intapi](../../../guide/releases/java-intapi.md) с учётом их автоматической сборки
1. Перенесли инструкцию про [Molly](../../../guide/qa/howto_molly.md) из базовых инструкций в раздел "Тестирование", добавили скриншотов.
   Обновите ссылку, если она у вас где-то записана.
1. На страничке со [списком чатов](../../chats.md):
   - Выделили раздел [{#T}](../../chats.md#global-infra)
   - Упомянули чат [Seneca Lounge](../../chats.md#yt)
   - Актуализировали ссылку на [список чатов от Дежсмены](../../chats.md#other-lists)
   - добавили чат [{#T}](../../chats.md#logbroker)
1. Внесли пачку обновлений [инструкции по заполнению инцидентного тикета](../../../incidents/spi-ticket.md):
   - Задокументировали компоненты [#network](../../../incidents/spi-ticket.md#network)
   и [#miscommunication](../../../incidents/spi-ticket.md#miscommunication)
   - Обновили описание [#functional_bug](../../../incidents/spi-ticket.md#functional-bug). Предыдущая версия была очень абстрактной и вызывала много споров
   - Добавили примеров к низкому и среднему [влиянию на команду](../../../incidents/spi-ticket.md#impact-team), в зависимости от вовлеченности в процесс экспертов
   - Записали [как заполнять заголовок тикета](../../../incidents/spi-ticket.md#summray)
1. Записали [необходимые действия при переезде](../../../guide/analytics/abc-direct-analytics.md#workflow) страницы про [получение доступа к данным Директе в YT](../../../guide/analytics/abc-direct-analytics.md)
1. В инструкции к [плановой недоступности ДЦ](../../../jeri/howto-minus-dc.md):
   - поправили вики-разметку [шаблона тикета](../../../jeri/howto-minus-dc.md#paperwork). _Кстати, почему это не шаблон в трекере?_
   - отразили идею о проведнии экспериментов во время регламентных работ
1. В документации по новой выгрузке `home/direct/db`:
   - указали [как теперь их тестировать на ТС и девтест](../../../yt-data/yt-direct-db-add-fields-testing.md#tesing-on-ts-or-devtest) — с учётом их штатного запуска
   - написали о новом [алерте, его диагностике и починке выгрузки](../../../yt-data/yt-direct-db-ops.md#monitoring)
1. Рассказали о том, [откуда берётся](../../../jeri/howto-dctl.md#where-it-comes-from) утилита [dctl](../../../jeri/howto-dctl.md)
1. Добавили [команды управления](../../../releases/concepts-create-release-auto.md#dt-autorelease-ctl) автоматической сборкой релизов
1. Поработали со страницей [juggler-алертов](../../../jeri/reference/juggler-alerts.md):
   - сгруппировали проверки в несколько таблиц по смыслу:
   [{#T}](../../../jeri/reference/juggler-alerts.md#common),
   [{#T}](../../../jeri/reference/juggler-alerts.md#database),
   [{#T}](../../../jeri/reference/juggler-alerts.md#product),
   [{#T}](../../../jeri/reference/juggler-alerts.md#unsorted)
   - вынесли описания на отдельные страницы (примеры: [1](../../alerts/mysql-trx-max-age.md),
   [2](../../alerts/slb-yp-consistency.md), [3](../../alerts/downtime-db.md))
   - завели [шаблон описания для проверки](../../alerts/example.md)
   - добавили подробностей к [{#T}](../../alerts/yandex-ansible-pull.md),
   [{#T}](../../alerts/active-orders-import-job.md),
   [{#T}](../../alerts/mysql-trx-max-age.md)
1. Добавили к [плану тестированию logviewer](../../../guide/releases/logviewer.md#testing) скачивание XLSX
1. Переписали раздел [{#T}](../../../frontend/dna-functional-testing.md#test-cases-in-yml)
   страницы [{#T}](../../../frontend/dna-functional-testing.md) более человеческим язызом
1. На страничке [{#T}](../../../feedback.md) разместили форму прямо так, без ссылки.
   _Правда теперь она перестала открываться локально_

## Ваши впечатления
Напишите в [комментариях](https://clubs.at.yandex-team.ru/direct-dev/616), как вам дайджест в новом формате?
