## BaseTableToQueueResyncJob

### Продукт/подсистема

(Джоба в разработке)

ESS транспорт в БК/CaeSaR.

### Роль в работе продукта/подсистемы

Джоба читает данные из сортированной таблицы HAHN транспорта в БК и перекладывает прочитанные данные в очередь Caesar.
Нужно для того, что если на стороне данные побились, мы бы гарантированно переотправляли бы эти данные раз за некоторые
период

### Датафлоу

- Читает данные с кластера HAHN из таблицы в директории [//home/adv](https://yt.yandex-team.ru/hahn/navigation?path=//home/adv) и пишет в очередь Caesar на Markov, находящуюся в [//home/adv/queues](https://yt.yandex-team.ru/markov/navigation?path=)
- Джоба читает данные из определенного диапазона YtHash исходной таблицы. Диапазон регулируется парамером джобы. То диапазон YtHash делится на столько диапазонов, сколько будет запущено джоб, каждая джоба читает из того диапазона, который соответвует ее параметру. Нужно для параллельности
- Джоба хранит стейт работы в проперте для каждого параметра. Пропертя определяется джобой наследником, имеет вид `*table_to_queue_resync_state*_param_*`
- После каждой итерации джоба делает `sleep()`, его время определяется в проперте джобы наследника вида `job_*_sorted_table_to_queue_relax_time`

### Способы наблюдения за текущим состоянием
- Пропертя состояния джобы `*table_to_queue_resync_state*_param_*`

### Какая функциональность пострадает от отказа джобы

В Caesar не будут переотправляться данные из сортированной таблицы
### Как пользователи (или команда) заметят проблему и через какое время

На пользователей не влияет

### Контакты разработчиков и менеджеров

Разработчики Директа: [Марина Спиридонова](https://staff.yandex-team.ru/mspirit), [Сергей Журавлёв](https://staff.yandex-team.ru/zhur), [Максим Петелин](https://staff.yandex-team.ru/pema4)
Разработчики БК: [Данил Григорьевых](https://staff.yandex-team.ru/danilgrig)

### Желательное время исправления в случае поломки

Несколько дней

### Способы регулирования работы джобы

- Relax time джобы `job_*_sorted_table_to_queue_relax_time`
- Размер чанка на итерации `job_*_table_to_queue_chunk`

### Известные причины поломок

- Проблемы с YT(Markov/Hahn).

### Дополнительно: тонкости и подводные камни
