## EcomDomainStatusesMonitoringJob

### Продукт/подсистема

Превью оферов для еком доменов


### Роль в работе продукта/подсистемы

Собирает данные для графиков статусов еком доменов в solomon'е:
- общее количество
- количество отправленных в MBI
- количество доменов, которые буду отправлены в MBI
- количество доменов, для которых получено превью
- количество доменов, для которых превью давно не обновлялось (более чем ```days_limit_for_updating_preview``` дней)


### Датафлоу

- Из ppc-property читает минимальное количество офферов на хосте (```MIN_OFFERS_COUNT_BY_HOST_FOR_SEND_TO_MBI```), с которым домены должны будут отправиться в MBI (см. ```SendEcomDomainToMBIJob```).
- Из ppc-property читает количество дней, в рамках которых должно происходить обновление офферов в превью ```DAYS_LIMIT_FOR_UPDATING_PREVIEW```
- Получает общее количество записей из ```ppcdict.ecom_domains```
- Получает количество записей, для которых ```market_feed_id is not null```  - домены отправленные в MBI
- Получает количество записей, которые в будущем будут отправлены в MBI джобой ```SendEcomDomainToMBIJob```
- Получает количество записей, для которых ```preview_offers is not null```  - домены с офферами
- Получает количество доменов, оффера для которых не были обновлены за допустимое количество дней (```DAYS_LIMIT_FOR_UPDATING_PREVIEW```). Дата последнего обновления офферов определяется по колонке ```last_modified_preview```
- Отправляет результаты в Solomon (```flow = EcomDomainStatusesMonitoringJob```)


### Способы наблюдения за текущим состоянием

- [Графики в Solomon](https://nda.ya.ru/t/TLOaU90r4VswGo)
- [Juggler-проверка](https://juggler.yandex-team.ru/check_details/?host=checks_auto.direct.yandex.ru&service=jobs.EcomDomainStatusesMonitoringJob.working.production)
- [Логи](https://direct.yandex.ru/logviewer/short/4hIy-6yJ4VsuKA)


### Какая функциональность пострадает от отказа джобы

Не будет новых данных по статусам еком доменов.


### Как пользователи (или команда) заметят проблему и через какое время

Команда может заметить сломанные графики в Solomon.

Пользователи не будут затронуты отказом джобы.


### Контакты разработчиков и менеджеров

Разработчики: [Дмитрий Анощенков](https://staff.yandex-team.ru/dmitanosh) <br/>
Менеджеры: [Дмитрий Уляшев](https://staff.yandex-team.ru/ulyashevda)

### Желательное время исправления в случае поломки

Неделя


### Способы регулирования работы джобы

- Свойство из ppc-property ```MIN_OFFERS_COUNT_BY_HOST_FOR_SEND_TO_MBI``` - задает минимальное количество офферов, домены с которыми будут отправлены в MBI джобой ```SendEcomDomainToMBIJob```.
- Свойство из ppc-property ```DAYS_LIMIT_FOR_UPDATING_PREVIEW``` - задает количество дней, в рамках которых должно происходить обновление офферов в превью джобой ```ReceiveEcomDomainsPreviewsJob```. Еком домены, для которых оффера не обновлялись большее количество дней - отображаются в мониторинге (```ecom_domains_without_updating_preview```)

### Известные причины поломок


### Дополнительно: тонкости и подводные камни
