## ReceiveModerationResponseRouterJob

### Продукт/подсистема

Интеграция с Модерацией (ESS-модерация).


### Роль в работе продукта/подсистемы

Приём вердиктов из Модерации по всем типам рекламных объектов и перенаправление их в различные топики Директа (для улучшения масштабируемости и надежности).


### Датафлоу

- Читает поток сообщений из LogBroker-топика Модерации и раскладывает их в LogBroker-топики Директа (по типам). Топик-источник прописан в [common-production.conf](https://a.yandex-team.ru/arc/trunk/arcadia/direct/libs-internal/config/src/main/resources/common-production.conf) в секции `moderation_service.logbroker.routing.read_topic`. Правила роутинга описаны там же рядом.
- В зависимости от типа объекта сообщение направляется в соответствующий правилу целевой топик. Также по campaignId из ppcdict загружается информация о том, в каких шардах лежат объекты, для которых были присланы вердикты. Эта информация используется для того, чтобы определить, в какую группу партиций целевого топика записать сообщение. Таким образом, джоба работает с LogBroker и mysql ppcdict.


### Способы наблюдения за текущим состоянием

- [Дэшборд нового транспорта с модерацией](https://solomon.yandex-team.ru/?project=direct&dashboard=ess-moderation&project=direct&cluster=app_java-jobs&service=java-monitoring&env=production).
- [Juggler-проверка](https://juggler.yandex-team.ru/check_details/?host=checks_auto.direct.yandex.ru&service=jobs.ReceiveModerationResponseRouterJob.working.production&query=&last=1DAY).
- [Лог джобы](https://direct.yandex.ru/logviewer/#~(logType~'messages~form~(fields~(~'log_time~'host~'service~'method~'trace_id~'span_id~'prefix~'log_level~'class_name~'message)~conditions~(service~'direct.jobs~method~'moderation.ReceiveModerationResponseRouterJob)~limit~100~offset~0~reverseOrder~false~showTraceIdRelated~false))$).


### Какая функциональность пострадает от отказа джобы

Перестанем принимать вердикты. Баннеры будут ожидать модерации и не уедут в показы. Очередь будет расти.


### Как пользователи (или команда) заметят проблему и через какое время

Максимально критично. Пользователи увидят, что их баннеры и другие модерируемые объекты (в том числе отдельные ресурсы баннеров) долго находятся в статусе "На модерации".


### Контакты разработчиков и менеджеров

Разработчики: [Игорь Костромин](https://staff.yandex-team.ru/elwood), [Сергей Белоусов](https://staff.yandex-team.ru/mexicano)<br/>


### Желательное время исправления в случае поломки

Максимально оперативно.


### Способы регулирования работы джобы

Отсутствуют.


### Известные причины поломок

- Падения при обработке сообщений (при запросах к mysql или при записи в LogBroker).
- Проблемы чтения данных из логброкера.


### Дополнительно: тонкости и подводные камни

- Если при обработке джобы возникнет исключение, то она перед падением подождёт некоторое время (сейчас -- несколько минут). Это сделано для того, чтобы обезопасить нас от DDoS'а целевых топиков при повторяющихся падениях джобы. Такой DDoS опасен тем, что следующая джоба, которая уже будет применять вердикты из целевых топиков, может быть сильно перегружена в короткий срок и потом долго разгребать повторяющиеся пачки вердиктов.
