### Продукт/подсистема { #subsystem }
Старый экспорт (перловый) в баннерную крутилку.


### Роль в работе продукта/подсистемы
Инфрастуктура для мониторинга за очередью.
Непосредственно в отправке данных не участвует.

Подготавливает реплику (в YDB) данных о состоянии очередей экспорта во всех шардах.
Поверх этой реплики соседняя джоба [Monitor](Monitor.md) считает агрегированные данные и отправляет их в Solomon.


### Датафлоу
Джоба выбирает все данные из MySQL таблицы `bs_export_queue`
и обновляет ими [таблицу bs_export_queue в YDB](https://ydb.yandex-team.ru/db/ydb-ru/direct/production/maintenance-helpers/browser/bs_export_queue),
а также удаляет из нее все записи, которых нет в MySQL.

Так как у YDB есть ограничение на объем данных в одном запросе, то выборка из MySQL осуществляется с указанием лимита — 150 тысяч записей ([MAX_RECORDS_TO_PROCESS](https://a.yandex-team.ru/arc/trunk/arcadia/direct/jobs/src/main/java/ru/yandex/direct/jobs/bsexportqueue/ReplicateToYdbJob.java#L51) в коде).
Если в базе оказалось больше строк, то джоба вмето ok станет отправлять в juggler WARN'ы.
Получающаяся при этом в YDB картина — не будет полностью отражать состояние очередей в нашей базе.



### Способы наблюдения за текущим состоянием
- [Juggler-проверка](https://juggler.yandex-team.ru/check_details/?host=checks_auto.direct.yandex.ru&service=jobs.ReplicateToYdbJob.working.production&query=&last=1DAY)
- [Логи](https://direct.yandex.ru/logviewer/#~(logType~'messages~form~(fields~(~'log_time~'host~'service~'method~'trace_id~'span_id~'prefix~'log_level~'class_name~'message)~conditions~(service~'direct.jobs~method~'bsexportqueue.ReplicateToYdbJob)~limit~100~offset~0~reverseOrder~true~showTraceIdRelated~false))$)


### Какая функциональность пострадает от отказа джобы
Алерты и графики про состояние очереди, готовые YQL-запросы для диагностики очереди — все они станут выдавать неадекватный результат (устаревшие данные).

### Как пользователи (или команда) заметят проблему и через какое время
Пользователи проблему заметить не могут — прямого влияния у джобы нет.

Разработчики могут увидеть странное (устаревшие или неадекватные) на графиках.


### Контакты разработчиков и менеджеров  { #contacts }
Разработчики: [Александр Дуплищев](https://staff.yandex-team.ru/ppalex)


### Желательное время исправления в случае поломки { #time-to-fix }

Желательно починить в течение часа-полутора.
На большее время без мониторнга состояния очереди оставаться страшно.


### Способы регулирования работы джобы
Отсутствуют


### Известные причины поломок
Если очередь в MySQL базе резко вырастет, то из-за увеличения объема данных запросы станут тормозить и могут перестать укладываться в таймаут.
