## SspPlatformSynchronizerJob

### Продукт/подсистема

Редактирование кампаний, поддерживающих запрет показов на SSP площадках, а так же создание прайсовых пакетов (SSP - supply-side platform)


### Роль в работе продукта/подсистемы

Синхронизация списка SSP-площадок из БК в Директ.


### Датафлоу

- Идет в ручку BS: `/export/export-table.cgi` и читает через нее таблицу `SSPInfo`.
- Добавляет в [ppcdict.ssp_platforms](https://direct-dev.yandex-team.ru/db/ppcdict/tables/ssp_platforms.html) только те площадки, у которых в `Options` написано `production`. Словарь только пополняется, изменение или очистка базы от отсутствующих в БК данных не производится.


### Способы наблюдения за текущим состоянием

- [Juggler-проверка](https://juggler.yandex-team.ru/check_details/?host=checks_auto.direct.yandex.ru&service=jobs.SspPlatformSynchronizerJob.working.production&query=&last=1DAY)
- [Логи](https://direct.yandex.ru/logviewer/#~(logType~'messages~form~(fields~(~'log_time~'host~'service~'method~'trace_id~'span_id~'prefix~'log_level~'class_name~'message)~conditions~(method~'dataimport.SspPlatformSynchronizerJob)~limit~100~offset~0~reverseOrder~false~showTraceIdRelated~false))$)


### Какая функциональность пострадает от отказа джобы

- Возможность указывать новые SSP в редактировании кампаний, поддерживающих запрет показов на SSP площадках. Основной сценарий при этом не будет заблокирован.
- Указывать новые SSP в создании прайсовых пакетов. Для пакетных продаж это может быть важно.


### Как пользователи (или команда) заметят проблему и через какое время

Если подключим (в БК) новую SSP, а джоба не работает, то
- клиенты не смогут запрещать на ней показы
- менеджеры не смогут указывать площадку для пакета

(В обоих случаях будет падать валидация).


### Контакты разработчиков и менеджеров

Менеджеры: [Дмитрий Суворов](https://staff.yandex-team.ru/dmsuvorov)


### Желательное время исправления в случае поломки

Джоба работает раз в день, новые площадки добавляются нерегулярно. Пара дней.


### Способы регулирования работы джобы

- Ppc-property `ssp_platforms_last_run_date` хранит дату последнего успешного обновления. Если её удалить, джоба перечитает все данные (но она только добавляет новые записи).


### Известные причины поломок

Отсутствуют.


### Дополнительно: тонкости и подводные камни

Отсутствуют.
