### Продукт/подсистема
Внутренняя инфраструктура.


### Роль в работе продукта/подсистемы
Собирает статистику по размерам таблиц. Она пригождается при планировании заказа квот/железа, или поиске аномалий в нагрузке.

### Датафлоу
Скрипт обходит все шарды, а также базу ppcdict и monitor.
В каждом из них, используя `SHOW TABLE STATUS` он получает размер таблицы, индексов, число строк.
Эти данные отправляются в ppcgraphite и пишутся в таблички `monitor_*` базы `monitor`.

Пример, как поселектить данные:
```sql
pr:monitor> select measure_time, t.description, value from monitor_targets t join monitor_values_day v using (target_id)  where target_id in (35607, 33558) order by measure_time desc limit 10;;
+---------------------+---------------------------------------------------------------+-------------+
| measure_time        | description                                                   | value       |
+---------------------+---------------------------------------------------------------+-------------+
| 2020-09-29 00:00:00 | Таблица ppc:18.ppc.banners - объём индекса                    | 43072339968 |
| 2020-09-29 00:00:00 | Таблица ppc:18.ppc.banners - объём данных                     | 99637395455 |
| 2020-09-28 00:00:00 | Таблица ppc:18.ppc.banners - объём индекса                    | 42980065280 |
| 2020-09-28 00:00:00 | Таблица ppc:18.ppc.banners - объём данных                     | 99364765696 |
| 2020-09-27 00:00:00 | Таблица ppc:18.ppc.banners - объём индекса                    | 42974822400 |
| 2020-09-27 00:00:00 | Таблица ppc:18.ppc.banners - объём данных                     | 99345891327 |
| 2020-09-26 00:00:00 | Таблица ppc:18.ppc.banners - объём индекса                    | 42964336640 |
| 2020-09-26 00:00:00 | Таблица ppc:18.ppc.banners - объём данных                     | 99263053824 |
| 2020-09-25 00:00:00 | Таблица ppc:18.ppc.banners - объём индекса                    | 42856333312 |
| 2020-09-25 00:00:00 | Таблица ppc:18.ppc.banners - объём данных                     | 99060678655 |
+---------------------+---------------------------------------------------------------+-------------+
10 rows in set (0.02 sec)
```



### Способы наблюдения за текущим состоянием

- [Juggler-проверка](https://juggler.yandex-team.ru/check_details/?host=checks_auto.direct.yandex.ru&service=scripts.ppcMonitorTablesSize.working&last=1DAY&query=)
- [Логи](https://direct.yandex.ru/logviewer/#~(logType~'messages~form~(fields~(~'log_time~'host~'service~'method~'trace_id~'span_id~'prefix~'log_level~'class_name~'message)~conditions~(service~'direct.script~method~'ppcMonitorTablesSize)~limit~100~offset~0~reverseOrder~true~showTraceIdRelated~false))$)


### Какая функциональность пострадает от отказа джобы
Ничего.



### Как пользователи (или команда) заметят проблему и через какое время
На пользователей не влияет.

Команда обнаружит поломку (если игнорировать мониторинг) в тот момент, когда понадобится история собранных данных, а их нет.



### Контакты разработчиков и менеджеров
Разработчики:
- [ppalex@](https://staff.yandex-team.ru/ppalex)
- [zhur@](https://staff.yandex-team.ru/zhur)


### Желательное время исправления в случае поломки
В течение недели.

### Способы регулирования работы джобы
Отсутствуют.

Скрипт отслеживает выполнение своей работы через пропертю `MONITOR_TABLES_SIZE_LASTSTART`, чтобы не собирать данные чаще раза в день.
Если требуется повторный запуск — можно поменять значение в проперте или удалить её.



### Известные причины поломок
Попадаются таблицы на проверку состояния которых не хватает грантов.



### Дополнительно: тонкости и подводные камни
