# Платформа Коммуникации

- Показ информационного попапа списку пользователей

## Общая схема

- Директ отправляет в Цезарь события
- Цезарь обрабатывает события и отправляет сообщения в динамическую табличку
- Директ читаем сообщения из динамической таблички и показывает их пользователю
- Пользователь нажимает кнопки на попапе и Директ отправляет событие в Цезарь
- Цезарь меняет статус сообщения, чтобы директ больше не показывал его

Топик отправки событий в Цезарь ([продакшен](https://logbroker.yandex-team.ru/lbkx/accounts/direct/communication-events) и [тестинг](https://logbroker.yandex-team.ru/lbkx/accounts/direct-np/testing/communication-events))
График событий в Цезаре ([продакшен](https://nda.ya.ru/t/wnO_JBwE4MtkQH) и [тестинг](https://nda.ya.ru/t/4nABSTFz4Mtkp3))

## Как пользоваться

Актуальная инструкция в [комментарии](https://st.yandex-team.ru/DIRECT-143784#60f83f5b0b805112654f3f5e).

Скора запустится способ удобнее:
- [Выбрать данные попапа](#test-popup)
- [Создать событие](#create-event)
- [Создать версию события](#create-event-iteration)
- [Запросить подтверждение](#request-approve-event-iteration)
- [Получить подтверждение](#approve-event-iteration)
- [Запустить версию события](#start-event-iteration)
- [Собирать статистику](#create-event-iteration)

### Тестовый попап { #test-popup }
- Идем во внутренний отчет [Завести тестовое событие на свой аккаунт](https://direct.yandex.ru/internal_tools/#send_personal_event)
- Заполняем данные попапа и жмем "Создать"
- Примерно через 5 секунд текущему пользователю при открытии гридов придет попап.

### Событие {#event}

Все действия с событиями доступны во внутреннем отчете [Управление списками коммуникационных событий](https://direct.yandex.ru/internal_tools/#communication_event_types)

#### Создать {#create-event}
- Выбираем понятное название
- Пишем список внутренних пользователей (логины), которые будут иметь возможность управлять событием.
- Выбираем действие "Создать новый тип события"

### Версия события {#event-iteration}

Все действия с версиями события доступны во внутреннем отчете [Управление списками версий коммуникационных событий](https://direct.yandex.ru/internal_tools/#communication_event_versions)

#### Создать {#create-event-iteration}
- Выбираем действие "Создать"
- Выбираем тип события. Необходимо быть владельцем этого события.
- Выбираем время начала и окончания показов. Валидация проверяет, что оба времени в будущем.
- Выбираем пользователей, которым будет показан попап. Можно указать список логинов через запятую или ссылку на таблицу (в формате cluster://path) с колонкой Uid. Рекомендуется для новых события и при каждой смене параметров попапа делать запуск на себя и коллег, чтобы проверить как будет выглядет попап в продакшене.
- Выбираем параметры попапа (тексты, кнопка, картинка)

#### Запросить подтвеждение {#request-approve-event-iteration}
- Выбираем действие "Запросить подтвеждение"
- Выбираем тип события. Необходимо быть владельцем этого события.
- Заполняем номер итерации.

Если запросить подтверждение на итерацию, в которой пользователи заданы списком логинов и все они являются владельцами события и внутренними пользователями, то итерация будет подтвеждена автоматически.

#### Подтвердить {#approve-event-iteration}
Требуется инструкция для апруверов попапов. Пока что нужно обращатсья к [Саше Дубову](https://staff.yandex-team.ru/a-dubov).

#### Запустить {#start-event-iteration}
Запустить можно только подтвежденную итерацию (статус approved).
- Выбираем действие "Запросить подтвеждение"
- Выбираем тип события. Необходимо быть владельцем этого события.
- Заполняем номер итерации.

Статус изменится на ready. Если нет очереди, то через 5 минут статус станет preparing. Через некоторое время в зависимости от количества пользователей (но не быстрее минуты) статус изменится на activating. Через какое-то время в зависимости от количества пользователей статус изменится на active.

### Статистика {#show-statistic}

Пока что не реализовано
