OWNER(g:sandbox-dev)

LIBRARY()

PEERDIR(
    contrib/python/aniso8601
    contrib/python/colorlog
    contrib/python/futures
    contrib/python/gevent
    contrib/python/kazoo
    contrib/python/msgpack
    contrib/python/paramiko
    contrib/python/progressbar2
    contrib/python/pytest
    contrib/python/requests

    library/python/resource
    library/python/sfx

    skynet/kernel
    skynet/api/copier
    skynet/api/heartbeat
)

IF (NOT OS_WINDOWS)
    # fixme
    PEERDIR(contrib/python/pycrypto)
ENDIF()

PY_SRCS(
    __init__.py
    config.py
    console.py
    crypto.py
    daemon.py
    errors.py
    fs.py
    hash.py
    import_hook.py
    log.py
    mds.py
    name_generator.py
    os.py
    package.py
    patterns.py
    platform.py
    process.py
    profiler.py
    projects_handler.py
    proxy.py
    rest.py
    share.py
    staff.py
    statistics.py
    telegram.py
    threading.py
    upload.py
    utils.py
    zk.py
    collections.py
    lazy.py

    api/__init__.py

    joint/__init__.py
    joint/client.py
    joint/errors.py
    joint/server.py
    joint/socket.py
    joint/utils.py

    types/__init__.py
    types/client.py
    types/database.py
    types/misc.py
    types/notification.py
    types/resource.py
    types/scheduler.py
    types/statistics.py
    types/task.py
    types/user.py

    vcs/__init__.py
    vcs/cache.py
)

END()
