CREATE TABLE `feeds` (
  `feed_id` bigint(20) unsigned NOT NULL,
  `ClientID` int(10) NOT NULL,
  `feed_type` enum('GoogleHotels','GoogleFlights','GoogleMerchant','AutoRu','YandexRealty','TravelBooking','CriteoTurkey','AliExpress','YandexMarket','YandexZen','Alibaba','TurkeyTeknosa','TurkeyJollyTur','TurkeyClient1','TurkeyClient2','TurkeyClient3','TurkeyClient4','TurkeyClient5','TurkeyClient6','TurkeyClient7','TurkeyClient8','TurkeyClient9','TurkeyClient10','TurkeyClient11','TurkeyClient12','TurkeyClient13','TurkeyClient14','TurkeyClient15','TurkeyClient16','TurkeyClient17','TurkeyClient18','TurkeyClient19','TurkeyClient20','TurkeyClient21','TurkeyClient22','TurkeyClient23','TurkeyClient24','TurkeyClient25') DEFAULT NULL,
  `business_type` enum('retail','hotels','realty','auto','flights') NOT NULL DEFAULT 'retail',
  `source` enum('url','file') NOT NULL,
  `name` varchar(255) NOT NULL,
  `url` varchar(1024) DEFAULT NULL,
  `filename` varchar(255) DEFAULT NULL,
  `login` varchar(255) DEFAULT NULL,
  `encrypted_password` varbinary(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `refresh_interval` int(10) NOT NULL,
  `is_remove_utm` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `update_status` enum('New','Outdated','Updating','Done','Error') NOT NULL DEFAULT 'New',
  `cached_file_url` varchar(1024) DEFAULT NULL,
  `cached_file_hash` varchar(22) CHARACTER SET latin1 DEFAULT NULL,
  `fetch_errors_count` tinyint(3) NOT NULL DEFAULT '0',
  `errors_count` int(10) DEFAULT NULL,
  `warnings_count` int(10) DEFAULT NULL,
  `offers_count` int(10) DEFAULT NULL,
  `LastChange` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_refreshed` datetime DEFAULT NULL,
  `offer_examples` text,
  PRIMARY KEY (`feed_id`),
  KEY `update_status` (`update_status`,`last_refreshed`),
  KEY `lastchange` (`LastChange`),
  KEY `ClientID` (`ClientID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
