#dPROFILES

case $(hostname) in
    ppcdom-xtradb*)
       distro="xenial"
       raid["1:/"]="1"
       size["1:/"]="25G"
       unset raid["2:/local"]
       unset size["2:/local"]
    ;;
    ppcmod*|modback*|direct-mod-test*)
       ignoreSSD["default"]=1
       distro="precise"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
    # raid5 example
    #moddb-ssd02e*)
    #   unset size["1:/"]
    #   unset size["2:/local"]
    #   distro="precise"
    #   raid["default"]="5"
    #   spare["default"]="1"
    #   size["1:/"]="10G"
    #   size["2:/local"]="grow"
    #;;
    # lxc host nodes
    *dom0*|*dom-*|partner-dev0?e*)
       ignoreSSD["default"]=1
       distro="trusty"
       unset size["2:/local"]
       size["2:lvm"]="grow"
       raidChunk["2:lvm"]="4096"
    ;;
    bmadaptive*|bmcollect*)
       distro="precise"
       ignoreSSD["default"]=1
       ignoreSSD["4:/opt/yabs_p2p"]=0
       ignoreHDD["4:/opt/yabs_p2p"]=1
       raid["4:/opt/yabs_p2p"]="0"
       size["4:/opt/yabs_p2p"]="grow"
       unset size["2:/local"]
       size["2:/local"]="100G"
       size["3:/opt"]="grow"
    ;;
    advqarc*|back???.advq.yandex.ru|us-load01e.advq*)
       distro="precise"
       ignoreSSD["default"]=0
       raid["1:/"]="1"
       size["1:/"]="25G"
       raid["2:/local"]="10"
       size["2:/local"]="grow"
    ;;
    gen?.advq*|usgen-test-load.advq*)
       distro="trusty"
       ignoreSSD["default"]=1
       raid["1:/"]="1"
       size["1:/"]="25G"
       raid["2:/local"]="6"
       size["2:/local"]="grow"
    ;;
    ppcgraphite-storage*)
       distro="trusty"
       ignoreSSD["default"]=1
       raid["1:/"]="1"
       size["1:/"]="200G"
       raid["2:/local"]="10"
       size["2:/local"]="grow"
    ;;
    mongo-backup*)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="1"
       raid["2:/local"]="10"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
    bmgen03*|bmcache*)
       distro="precise"
       ignoreSSD["default"]=0
       size["1:/"]="50G"
       size["2:/local"]="grow"
       raid["1:/"]="10"
       raid["2:/local"]="0"
    ;;
    uspokazgen*)
       distro="precise"
       ignoreSSD["default"]=0
       size["1:/"]="50G"
       size["2:/local"]="grow"
       raid["1:/"]="10"
       raid["2:/local"]="1"
    ;;
    # zfs backup - only /root partition
    # 8x8tb hdd, 20gb /root + 4tb raid10 /local for arcadia/opt-broadmatching + 26tb zfs
    catalogia-media-gen01k*|catalogia-media-gen01i)
       distro="precise"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       raid["1:/"]="10"
       size["1:/"]="5G"
       raid["2:/local"]="6"
       size["2:/local"]="15G"
    ;;
    # 4x2tb hdd (20gb /root + 4tb raid10 /local) + 15 disk shelf (zfs)
    catalogia-media-gen01e*)
       distro="precise"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       raid["1:/"]="10"
       size["1:/"]="10G"
       unset raid["2:/local"]
       unset size["2:/local"]
    ;;
    # ssd-only standby
    bmdata?-standby*)
       unset size["1:/"]
       unset size["2:/local"]
       distro="precise"
       ignoreSSD["default"]=0
       raid["default"]="10"
       raid["2:lvm"]="0"
       size["1:/"]="10G"
       size["2:lvm"]="grow"
    ;;
    bmdata*)
       distro="precise"
       raid["default"]="5"
       ignoreSSD["default"]=0
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="40G"
       size["2:/local"]="grow"
    ;;
    bmgen01*)
       distro="precise"
       raid["default"]="10"
       ignoreSSD["default"]=1
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
    bmstandby*)
       unset size["1:/"]
       unset size["2:/local"]
       distro="precise"
       raid["default"]="10"
       size["1:/"]="50G"
       size["2:lvm"]="grow"
    ;; 
    bm*)
       ignoreSSD["default"]=1
       distro="precise"
    ;;
    ppcsoap*|ci*|ppcback*|ppcscripts*)
       ignoreSSD["default"]=1
       distro="trusty"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
    bm-bscatalogia*|catalogia-phrases*)
       ignoreSSD["default"]=0
       distro="precise"
       raid["1:/"]="1"
       size["1:/"]="10G"
       raid["2:/local"]="10"
       size["2:/local"]="grow"
    ;;
    partnerdb01*)
       distro="precise"
       raid["1:/"]="1"
       raid["2:/local"]="10"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="10G"
       size["2:/local"]="10G"
    ;;
    partner-rtb-db*|partner-standby02i*)
       distro="trusty"
       raid["1:/"]="10"
       raid["2:/local"]="6"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="3G"
       size["2:/local"]="10G"
    ;;
    # ppclogs direct
    ppclogs0??.ppc.yandex.ru|ppclogs03?.yandex.ru)
       distro="precise"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       raid["1:/"]="1"
       size["1:/"]="10G"
       raid["2:/local"]="10"
       size["2:/local"]="20G" # будет 40gb (4hdd) или 80gb (8hdd)
       # opt mysql, bin/relay logs - zfs
    ;;
    # modlog
    ppclogs01*|partner-heavy*)
       distro="precise"
       raid["default"]="10"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="5G"
       size["2:/local"]="grow"
    ;;
    ppctest-mysql0*|ppctest-load-mysql*|ppctest-ts2-mysql*|ppctest-dev7-mysql*|ppctest-ts1-mysql*|ppctest-devtest-mysql*)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="10"
       raid["2:/local"]="10"
       fsopts["default"]="noatime,nobarrier,discard"
       size["1:/"]="20G"
       size["2:/local"]="75G"
    ;;
    mongo???.mod.yandex.net|mongocfg???.mod.yandex.net|moddb-mongo???.yandex.ru)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       unset size["3:/opt"]
       raid["1:/"]="1"
       raid["2:/local"]="10"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="10G"
       size["2:/local"]="15G"
    ;;
# old mongo
#    moddb-mongo*)
#       distro="trusty"
#       unset size["1:/"]
#       unset size["2:/local"]
#       unset size["3:/opt"]
#       raid["1:/"]="1"
#       raid["2:/local"]="10"
#       raid["3:/opt"]="0"
#       fsopts["default"]="noatime,nobarrier,discard,commit=600"
#       size["1:/"]="10G"
#       size["2:/local"]="15G"
#       size["3:/opt"]="grow"
#    ;;
    # ssd-only standby, raid0
    ppcstandby02e*|ppcstandby01i*)
       unset size["1:/"]
       unset size["2:/local"]
       distro="trusty"
       ignoreSSD["default"]=0
       raid["default"]="10"
       raid["2:lvm"]="0"
       spare["2:lvm"]="0"
       size["1:/"]="20G"
       size["2:lvm"]="grow"
    ;;
    ppcstandby*)
       unset size["1:/"]
       unset size["2:/local"]
       distro="trusty"
       raid["default"]="1"
       raid["3:lvm"]="0"
       ignoreSSD["default"]=1
       ignoreSSD["3:lvm"]=0
       ignoreHDD["3:lvm"]=1
       size["1:/"]="5G"
       size["2:/local"]="grow"
       size["3:lvm"]="grow"
    ;;
    ppc-xtradb-standby*)
       unset size["1:/"]
       unset size["2:/local"]
       ignoreHDD["default"]=1
       distro="precise"
       raid["default"]="0"
       size["1:/"]="5G"
       size["2:lvm"]="grow"
    ;; 
#    partner-standby*)
#       unset size["1:/"]
#       unset size["2:/local"]
#       distro="precise"
#       raid["default"]="10"
#       size["1:/"]="50G"
#       size["2:lvm"]="grow"
#    ;; 
    # zfs - raid 1 root only on hdd
    ppctest-mysql-zfs*)
       distro="trusty"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       raid["1:/"]="1"
       size["1:/"]="10G"
       raid["2:/local"]="10"
       size["2:/local"]="15G"
    ;;
    # zfs - raid 1 root only on hdd
    ppcdata3-02i*)
       distro="trusty"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       ignoreSSD["default"]=1
       raid["1:/"]="1"
       raid["2:/local"]="1"
       size["1:/"]="10G"
       size["2:/local"]="200G"
    ;;
    # ssd-only standby, raid5
    ppcdata-standby*)
       unset size["1:/"]
       unset size["2:/local"]
       distro="trusty"
       ignoreSSD["default"]=0
       raid["default"]="10"
       raid["2:lvm"]="5"
       spare["2:lvm"]="0"
       size["1:/"]="20G"
       size["2:lvm"]="grow"
    ;;
    # ssd-only direct-dbs
    ppcdict-xtradb01i.yandex.ru)
       distro="trusty"
       raid["default"]="10"
       raid["2:/opt"]="0"
       ignoreSSD["default"]=0
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="10G"
       size["2:/opt"]="grow"
    ;;
    # hdd raid 1 + ssd raid0 dbs
    ppcmonitor*|ppcdict*|ppcdata*|moddb*)
       distro="trusty"
       raid["default"]="1"
       raid["3:/opt"]="0"
       ignoreSSD["default"]=1
       ignoreSSD["3:/opt"]=0
       ignoreHDD["3:/opt"]=1
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
       size["1:/"]="20G"
       size["2:/local"]="grow"
       size["3:/opt"]="grow"
    ;;
    april-clickhouse*)
       distro="precise"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="auto"
       size["1:/"]="grow"
       raid["2:/local"]="6"
       spare["2:/local"]="1"
       size["2:/local"]="grow"
       shelf["2:/local"]="1"
    ;;
    ppchouse-alw*)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       ignoreSSD["default"]=1
       raid["1:/"]="1"
       size["1:/"]="20G"
       raid["2:/local"]="10"
       size["2:/local"]="grow"
    ;;
    april-storage*)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="1"
       size["1:/"]="20G"
       raid["2:/local"]="10"
       size["2:/local"]="100G"
    ;;
    clickhouse-parner-code*)
       distro="precise"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
    ppcdev7.ppc*)
       distro="trusty"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="1"
       size["1:/"]="20G"
       raid["2:/local"]="6"
       size["2:/local"]="grow"
    ;;
    ppcdev*)
       distro="trusty"
       raid["default"]="1"
       ignoreSSD["default"]=1
       ignoreSSD["3:/local/var/www"]=0
       ignoreHDD["3:/local/var/www"]=1
       size["3:/local/var/www"]="grow"
       raid["3:/local/var/www"]="0"
       unset size["2:/local"]
       size["2:/local"]="grow"
       unset size["1:/"]
       size["1:/"]="10G"
       fsopts["default"]="noatime,nobarrier,discard,commit=600"
    ;;
    whale*)
       distro="precise"
       ignoreSSD["default"]=1
       size["1:/"]="20G"
       size["2:/local"]="grow"
    ;;
    catalogia-media-gen??t*)
       ignoreSSD["default"]=1
       distro="precise"
       unset size["1:/"]
       unset size["2:/local"]
       raid["1:/"]="1"
       size["1:/"]="20G"
       raid["2:/local"]="10"
       size["2:/local"]="25G"
    ;;
     catalogia*)
       ignoreSSD["default"]=1
       distro="precise"
    ;;
   pi0*|pi-rtb0*)
       distro="precise"
       ignoreSSD["default"]=1
       size["1:/"]="20G"
       size["2:/local"]="grow"
    ;;
    *)
       distro="trusty"
       size["1:/"]="50G"
       size["2:/local"]="grow"
    ;;
esac

#//PROFILES

#MAIN
execute_profile
#//MAIN
