# шелл для релизов в стиле Директа
# 
# Выполни, а лучше впиши в свой шелльный rc:
# 
# будет предполагаться, что директории уже готовы, и перед релизом ты находишься в каталоге packages
# проверки есть, так что ошибиться не получится
# alias release_shell='source release-shell-rc.sh'
#
# 
## Новый релиз
# release_shell
# packages
# tupdate
# jr 
# jr -do
# hotfix
# 
## Работа с существующим релизом
# release_shell -j <jira_release_key>
# или просто
# release_shell  <jira_release_key>
# 
# По умолчанию на ppcdev предполагается релиз Директа, на beta.geocontext -- релиз Геоконтекста (ProjectSpecific.pm)
# Если нужен другой проект: 
# release_shell --project <project>
# 
# Краткая справка доступна по команде help
# Если что-то пойдет криво -- зови на помощь



###############################################
# Дальше читать можно, но совсем не обязательно
###############################################

# странная функция, но нужная, потому что у bash'а проблемы с chdir
function my_cd
{
    cd $1
}


function remember_shell
{
    if [[ -n $ZSH_NAME ]]
    then
        export CONGERIA_SHELL_TO_RETURN_TO='zsh'
    elif [[ -n $BASH ]]
    then
        export CONGERIA_SHELL_TO_RETURN_TO='bash'
    else
        export CONGERIA_SHELL_TO_RETURN_TO=
    fi
}


function run
{
    export CONGERIA_ACTION_OUTPUT_FILE=
    TMPFILE=`mktemp /tmp/temp-ttl/ttl_2d/release_action.XXXXXXXXXX` || return 1
    export CONGERIA_ACTION_OUTPUT_FILE=$TMPFILE

    echo "file:" $CONGERIA_ACTION_OUTPUT_FILE >&2

    # параметры дополнительно заключаем в кавычки -- иначе параметры с пробелами превращаются в несколько 
    local to_eval=
    # вокруг $@ должны быть кавычки -- иначе bash каждое слово считает отдельным параметром невзирая на кавычки в ком. строке
    for i in "$@"
    do 
        to_eval="$to_eval '$i'"
    done 

    eval $to_eval

    local exit_code=$?
    
    source $CONGERIA_ACTION_OUTPUT_FILE

    if [[ -n $CONGERIA_verbose ]]
    then
        echo "file:" $CONGERIA_ACTION_OUTPUT_FILE >&2
    else
       rm $CONGERIA_ACTION_OUTPUT_FILE
    fi

    unset CONGERIA_ACTION_OUTPUT_FILE

    return $exit_code
}


######

# remember path
if [[ -n $ZSH_NAME ]]
then
    releaser_path=${0:A:h}
elif [[ -n $BASH ]]
then
    releaser_path=`dirname $BASH_SOURCE`
else
    echo "   *** Unsupported shell ***"
fi
export CONGERIA_PATH=$( cd $releaser_path ; pwd )
# /remember path

remember_shell

run $CONGERIA_PATH/release-action.pl --action vars_and_aliases $@

set_release_mode $@

