#!/usr/bin/perl 

use warnings;
use strict;

use Test::More;
use Test::Exception;

use Yandex::Runtime;

sub t_list { need_list_context; }
sub t_scalar { need_scalar_context; }
sub t_void { need_void_context; }

lives_ok { [t_list()] } 'list list';
dies_ok { [t_scalar()] } 'list scalar';
dies_ok { [t_void()] } 'list void';

dies_ok { scalar t_list() } 'scalar list';
lives_ok { scalar t_scalar() } 'scalar scalar';
dies_ok { scalar t_void() } 'scalar void';

dies_ok { t_list(); 1; } 'void list';
dies_ok { t_scalar(); 1; } 'void scalar';
lives_ok { t_void(); 1; } 'void void';

done_testing();
