#!/usr/bin/perl

use strict;
use warnings;
use Test::More;
use Test::Exception;


BEGIN { use_ok('Yandex::Trace', qw/current_trace $INDEX $PROFILE_INDEX/) };

lives_ok { current_trace(); } "dummy current_trace lives";
lives_ok { Yandex::Trace::trace_id(); } "dummy trace_id lives";
is(Yandex::Trace::trace_id(), undef, "dummy trace_id is undef");
dies_ok { Yandex::Trace::trace_id(42) } "dummy trace_id dies with param";
lives_ok { my $t = Yandex::Trace::new_profile('dummy_func'); } "dummy profile lives";
lives_ok { my $t = Yandex::Trace::new_profile('dummy_func'); $t->obj_num(42); } "obj_num lives";

done_testing();
