package ru.yandex.market.clickphite.dictionary.dicts.abo.cpa;

import ru.yandex.market.clickhouse.ddl.Column;
import ru.yandex.market.clickhouse.ddl.ColumnType;
import ru.yandex.market.clickphite.dictionary.Dictionary;
import ru.yandex.market.clickphite.dictionary.dicts.DefaultExpr;
import ru.yandex.market.clickphite.dictionary.dicts.MarketstatDb;

import java.util.Arrays;
import java.util.List;

public class RecheckProblem implements Dictionary {
    private static final List<Column> COLUMNS =
        Arrays.asList(
            new Column("id", ColumnType.Int64, DefaultExpr.INT),
            new Column("type_id", ColumnType.Int64, DefaultExpr.INT),
            new Column("user_id", ColumnType.Int64, DefaultExpr.INT),
            new Column("ticket_id", ColumnType.Int64, DefaultExpr.INT),
            new Column("created", ColumnType.DateTime, DefaultExpr.DATETIME),
            new Column("text", ColumnType.String, DefaultExpr.STRING)
        );

    @Override
    public List<Column> getColumns() {
        return COLUMNS;
    }

    @Override
    public String getTable() {
        return "recheck_problem";
    }

    @Override
    public String getDb() {
        return MarketstatDb.DATABASE_MARKETSTAT;
    }
}
