package ru.yandex.direct.intapi.entity.vcards.model;

import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonProperty;

import ru.yandex.direct.core.entity.vcard.model.PointPrecision;
import ru.yandex.direct.core.entity.vcard.model.PointType;

public class IntapiVcard {
    @JsonProperty("id")
    private Long id;

    @JsonProperty("campaign_id")
    private String campaignId;

    @JsonProperty("uid")
    private String uid;

    @JsonProperty("company_name")
    private String companyName;

    @JsonProperty("work_time")
    private String workTime;

    @JsonProperty("worktimes")
    private List<Map<String, String>> workTimeList;

    @JsonProperty("contact_person")
    private String contactPerson;

    @JsonProperty("phone")
    private IntapiPhone phone;

    @JsonProperty("email")
    private String email;

    @JsonProperty("instant_messenger")
    private IntapiInstantMessenger instantMessenger;

    @JsonProperty("extra_message")
    private String extraMessage;

    @JsonProperty("org_details_id")
    private Long orgDetailsId;

    @JsonProperty("ogrn")
    private String ogrn;

    @JsonProperty("geo_id")
    private Long geoId;

    @JsonProperty("country")
    private String country;

    @JsonProperty("city")
    private String city;

    @JsonProperty("street")
    private String street;

    @JsonProperty("house")
    private String house;

    @JsonProperty("build")
    private String build;

    @JsonProperty("apart")
    private String apart;

    @JsonProperty("metro_id")
    private Long metroId;

    @JsonProperty("metro_name")
    private String metroName;

    @JsonProperty("country_geo_id")
    private Long countryGeoId;

    @JsonProperty("manual_point")
    private IntapiPointOnMap manualPoint;

    @JsonProperty("auto_point")
    private IntapiPointOnMap autoPoint;

    @JsonProperty("point_type")
    private PointType pointType;

    @JsonProperty("precision")
    private PointPrecision precision;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public IntapiVcard withId(Long id) {
        setId(id);
        return this;
    }

    public String getCampaignId() {
        return campaignId;
    }

    public void setCampaignId(String campaignId) {
        this.campaignId = campaignId;
    }

    public IntapiVcard withCampaignId(String campaignId) {
        setCampaignId(campaignId);
        return this;
    }

    public String getUid() {
        return uid;
    }

    public void setUid(String uid) {
        this.uid = uid;
    }

    public IntapiVcard withUid(String uid) {
        setUid(uid);
        return this;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public IntapiVcard withCompanyName(String companyName) {
        setCompanyName(companyName);
        return this;
    }

    public String getWorkTime() {
        return workTime;
    }

    public void setWorkTime(String workTime) {
        this.workTime = workTime;
    }

    public IntapiVcard withWorkTime(String workTime) {
        setWorkTime(workTime);
        return this;
    }

    public List<Map<String, String>> getWorkTimeList() {
        return workTimeList;
    }

    public void setWorkTimeList(List<Map<String, String>> workTimeList) {
        this.workTimeList = workTimeList;
    }

    public IntapiVcard withWorkTimeList(List<Map<String, String>> workTimeList) {
        setWorkTimeList(workTimeList);
        return this;
    }

    public String getContactPerson() {
        return contactPerson;
    }

    public void setContactPerson(String contactPerson) {
        this.contactPerson = contactPerson;
    }

    public IntapiVcard withContactPerson(String contactPerson) {
        setContactPerson(contactPerson);
        return this;
    }

    public IntapiPhone getPhone() {
        return phone;
    }

    public void setPhone(IntapiPhone phone) {
        this.phone = phone;
    }

    public IntapiVcard withPhone(IntapiPhone phone) {
        setPhone(phone);
        return this;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public IntapiVcard withEmail(String email) {
        setEmail(email);
        return this;
    }

    public IntapiInstantMessenger getInstantMessenger() {
        return instantMessenger;
    }

    public void setInstantMessenger(IntapiInstantMessenger instantMessenger) {
        this.instantMessenger = instantMessenger;
    }

    public IntapiVcard withInstantMessenger(IntapiInstantMessenger instantMessenger) {
        setInstantMessenger(instantMessenger);
        return this;
    }

    public String getExtraMessage() {
        return extraMessage;
    }

    public void setExtraMessage(String extraMessage) {
        this.extraMessage = extraMessage;
    }

    public IntapiVcard withExtraMessage(String extraMessage) {
        setExtraMessage(extraMessage);
        return this;
    }

    public Long getOrgDetailsId() {
        return orgDetailsId;
    }

    public void setOrgDetailsId(Long orgDetailsId) {
        this.orgDetailsId = orgDetailsId;
    }

    public IntapiVcard withOrgDetailsId(Long orgDetailsId) {
        setOrgDetailsId(orgDetailsId);
        return this;
    }

    public String getOgrn() {
        return ogrn;
    }

    public void setOgrn(String ogrn) {
        this.ogrn = ogrn;
    }

    public IntapiVcard withOgrn(String ogrn) {
        setOgrn(ogrn);
        return this;
    }

    public Long getGeoId() {
        return geoId;
    }

    public void setGeoId(Long geoId) {
        this.geoId = geoId;
    }

    public IntapiVcard withGeoId(Long geoId) {
        setGeoId(geoId);
        return this;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public IntapiVcard withCountry(String country) {
        setCountry(country);
        return this;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public IntapiVcard withCity(String city) {
        setCity(city);
        return this;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public IntapiVcard withStreet(String street) {
        setStreet(street);
        return this;
    }

    public String getHouse() {
        return house;
    }

    public void setHouse(String house) {
        this.house = house;
    }

    public IntapiVcard withHouse(String house) {
        setHouse(house);
        return this;
    }

    public String getBuild() {
        return build;
    }

    public void setBuild(String build) {
        this.build = build;
    }

    public IntapiVcard withBuild(String build) {
        setBuild(build);
        return this;
    }

    public String getApart() {
        return apart;
    }

    public void setApart(String apart) {
        this.apart = apart;
    }

    public IntapiVcard withApart(String apart) {
        setApart(apart);
        return this;
    }

    public Long getMetroId() {
        return metroId;
    }

    public void setMetroId(Long metroId) {
        this.metroId = metroId;
    }

    public IntapiVcard withMetroId(Long metroId) {
        setMetroId(metroId);
        return this;
    }

    public String getMetroName() {
        return metroName;
    }

    public void setMetroName(String metroName) {
        this.metroName = metroName;
    }

    public IntapiVcard withMetroName(String metroName) {
        setMetroName(metroName);
        return this;
    }

    public Long getCountryGeoId() {
        return countryGeoId;
    }

    public void setCountryGeoId(Long countryGeoId) {
        this.countryGeoId = countryGeoId;
    }

    public IntapiVcard withCountryGeoId(Long countryGeoId) {

        setCountryGeoId(countryGeoId);
        return this;
    }

    public IntapiPointOnMap getManualPoint() {
        return manualPoint;
    }

    public void setManualPoint(IntapiPointOnMap manualPoint) {
        this.manualPoint = manualPoint;
    }

    public IntapiVcard withManualPoint(IntapiPointOnMap manualPoint) {
        setManualPoint(manualPoint);
        return this;
    }

    public IntapiPointOnMap getAutoPoint() {
        return autoPoint;
    }

    public void setAutoPoint(IntapiPointOnMap autoPoint) {
        this.autoPoint = autoPoint;
    }

    public IntapiVcard withAutoPoint(IntapiPointOnMap autoPoint) {
        setAutoPoint(autoPoint);
        return this;
    }

    public PointType getPointType() {
        return pointType;
    }

    public void setPointType(PointType pointType) {
        this.pointType = pointType;
    }

    public IntapiVcard withPointType(PointType pointType) {
        setPointType(pointType);
        return this;
    }

    public PointPrecision getPrecision() {
        return precision;
    }

    public void setPrecision(PointPrecision precision) {
        this.precision = precision;
    }

    public IntapiVcard withPrecision(PointPrecision precision) {
        setPrecision(precision);
        return this;
    }
}
