JAVA_PROGRAM(yandex-direct-intapi)

INCLUDE(${ARCADIA_ROOT}/direct/libs/common.inc)
LINT(extended)
WITH_KOTLIN()


OWNER(g:direct)

PEERDIR(
    direct/common
    direct/core
    direct/libs/tracing
    direct/libs/validation
    direct/libs/jcommander-utils
    direct/libs/keyword-utils
    direct/libs/mirror-tools
    direct/libs/solomon
    direct/libs/clickhouse-utils
    direct/libs/communication
    direct/libs/geosearch-client
    direct/libs/uaas
    direct/libs-internal/grid-processing
    direct/libs-internal/tvm-web-mvc
    direct/libs-internal/web-core
    direct/libs-internal/yt-components
    direct/libs-internal/yt-core
    direct/libs-internal/autobudget-restart

    library/java/monlib/metrics

    contrib/java/com/google/guava/guava
    contrib/java/org/slf4j/slf4j-api
    contrib/java/javax/annotation/javax.annotation-api

    contrib/java/org/springframework/spring-core
    contrib/java/org/springframework/spring-context
    contrib/java/org/springframework/spring-web
    contrib/java/org/springframework/spring-webmvc
    contrib/java/org/springframework/spring-jdbc
    contrib/java/org/springframework/spring-tx
    contrib/java/org/springframework/spring-aop

    contrib/java/com/fasterxml/jackson/core/jackson-databind
    contrib/java/org/aspectj/aspectjrt
    contrib/java/org/aspectj/aspectjweaver

    contrib/java/io/springfox/springfox-swagger2/${swagger_version}
    contrib/java/io/springfox/springfox-swagger-ui/${swagger_version}

    contrib/java/org/apache/commons/commons-collections4

    direct/intapi/src/main/java/ru/yandex/direct/intapi/entity/daas/protos
)

JAVA_SRCS(SRCDIR src/main/java **/*)
JAVA_SRCS(SRCDIR src/main/resources **/*)

END()

RECURSE_FOR_TESTS(
    ut
    ut-common
    ut-configuration
    ut-fat
    ut-grut
)
