package ru.yandex.direct.jobs.freelancers.moderation.receiving;

import ru.yandex.direct.jobs.freelancers.moderation.receiving.model.BaseModerationVerdict;
import ru.yandex.direct.jobs.freelancers.moderation.receiving.model.VerdictType;

public interface VerdictHandler<T extends BaseModerationVerdict> {

    /**
     * Применяет полученный вердикт.
     * Возвращает true, если вердикт успешно применён и false в противном случае.
     */
    boolean applyVerdict(String json);

    /**
     * Возвращает тип вердиктов обрабатываемый текущей реализаций обработчика.
     */
    VerdictType getSupportedType();

}
