JAVA_PROGRAM(direct-jobs)

WITH_KOTLIN()
INCLUDE(${ARCADIA_ROOT}/direct/libs/common.inc)

OWNER(g:direct)

EXCLUDE(
    # исключаем junit4, приезжающий транзитивно из libs/curator и libs/balance-client
    contrib/java/junit/junit

    # приезжают транзитивно и шумят своими юнит-тестами
    direct/libs/binlog-reader
    direct/libs/mysql-streaming

    # возникают конфликты с NBannerLand.Phrase
    irt/bannerland/proto/v1/bannerland
)

PEERDIR(
    direct/apps/event-sourcing-system/logicprocessor
    direct/apps/event-sourcing-system/router/proto
    direct/common
    direct/core
    direct/libs/bstransport
    direct/libs/bstransport/proto
    direct/libs/communication
    direct/libs/tracing
    direct/libs/scheduler
    direct/libs/jcommander-utils
    direct/libs/mysql-server
    direct/libs/mysql-slowlog-parser
    direct/libs/sql-normalizer
    direct/libs/juggler
    direct/libs-internal/juggler-check
    direct/libs/ansible-juggler
    direct/libs/balance-client
    direct/libs/banner-system-client
    direct/libs/hourglass-ydb
    direct/libs/yt-wrapper
    direct/libs/mediascope-client
    direct/libs/moderation-client
    direct/libs/ya-audience-client
    direct/libs/solomon
    direct/libs/transfer-manager-utils
    direct/libs-internal/direct-adfox-messaging/transport
    direct/libs/takeout-client
    direct/libs-internal/bstransport
    direct/libs-internal/cloud-iam-service
    direct/libs-internal/cloud-mdb-mysql-api-service
    direct/libs-internal/grid-model
    direct/libs-internal/grid-core
    direct/libs-internal/hourglass-configuration
    direct/libs-internal/mysql-slowlog-writer-states
    direct/libs-internal/ydb
    direct/libs-internal/yt-core
    direct/libs-internal/samovar
    direct/apps/user-action-log/reader

    contrib/java/javax/annotation/javax.annotation-api

    contrib/java/org/springframework/spring-core
    contrib/java/org/springframework/spring-context
    contrib/java/org/springframework/spring-web
    contrib/java/org/springframework/spring-webmvc
    contrib/java/org/springframework/spring-jdbc
    contrib/java/org/springframework/spring-tx
    contrib/java/org/mongodb/mongo-java-driver

    contrib/java/com/google/guava/guava
    contrib/java/com/jcraft/jsch/0.1.55
    contrib/java/org/apache/curator/curator-recipes
    contrib/java/org/apache/zookeeper/zookeeper

    contrib/java/org/apache/poi/poi/3.17
    contrib/java/org/apache/poi/poi-scratchpad/3.17
    contrib/java/org/apache/poi/poi-excelant/3.17
    contrib/java/org/apache/poi/poi-ooxml-schemas/3.17
    contrib/java/org/apache/poi/poi-ooxml/3.17

    contrib/java/org/apache/poi/poi
    contrib/java/org/apache/poi/poi-ooxml
    contrib/java/com/amazonaws/aws-java-sdk-s3

    contrib/java/org/apache/commons/commons-collections4

    contrib/java/org/tmatesoft/svnkit/svnkit/1.10.1

    iceberg/inside-yt
    kikimr/persqueue/sdk/java/v0
    library/java/monlib/metrics
    yt/java/ytclient
    tracker/tracker-java-client/tracker-client/src/main
    irt/bannerland/proto/v2/bannerland
)

JAVA_SRCS(SRCDIR src/main/java **/*)
JAVA_SRCS(SRCDIR src/main/resources **/*)

END()

RECURSE_FOR_TESTS(
    ut
    ut-common
    ut-configuration
    ut-grut
    ut-local-yql
    ut-local-yt
    ut-yql
)
