package ru.yandex.direct.codegen.core.entity.banner;

import java.util.List;

public abstract class AbstractBannerPartModel {

    private String interfaceName;
    private String interfaceVariable;
    private String packageName;

    private List<ModelPropInfo> allProps;
    private List<ModelPropInfo> clientProps;
    private List<ModelPropInfo> mutableProps;
    private ModelPropInfo mainClientProp;

    private TableInfo table;
    private List<ModelPropWithDbFieldInfo> propsWithFields;
    private List<DbFieldInfo> mutableFields;

    private List<ImportInfo> imports;

    public String getInterfaceName() {
        return interfaceName;
    }

    public AbstractBannerPartModel withInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
        return this;
    }

    public String getInterfaceVariable() {
        return interfaceVariable;
    }

    public AbstractBannerPartModel withInterfaceVariable(String interfaceVariable) {
        this.interfaceVariable = interfaceVariable;
        return this;
    }

    public String getPackageName() {
        return packageName;
    }

    public AbstractBannerPartModel withPackageName(String packageName) {
        this.packageName = packageName;
        return this;
    }

    public List<ModelPropInfo> getAllProps() {
        return allProps;
    }

    public AbstractBannerPartModel withAllProps(List<ModelPropInfo> allProps) {
        this.allProps = allProps;
        return this;
    }

    public List<ModelPropInfo> getClientProps() {
        return clientProps;
    }

    public AbstractBannerPartModel withClientProps(List<ModelPropInfo> clientProps) {
        this.clientProps = clientProps;
        return this;
    }

    public List<ModelPropInfo> getMutableProps() {
        return mutableProps;
    }

    public AbstractBannerPartModel withMutableProps(List<ModelPropInfo> mutableProps) {
        this.mutableProps = mutableProps;
        return this;
    }

    public ModelPropInfo getMainClientProp() {
        return mainClientProp;
    }

    public AbstractBannerPartModel withMainClientProp(ModelPropInfo mainClientProp) {
        this.mainClientProp = mainClientProp;
        return this;
    }

    public TableInfo getTable() {
        return table;
    }

    public AbstractBannerPartModel withTable(TableInfo table) {
        this.table = table;
        return this;
    }

    public List<ModelPropWithDbFieldInfo> getPropsWithFields() {
        return propsWithFields;
    }

    public AbstractBannerPartModel withPropsWithFields(List<ModelPropWithDbFieldInfo> propsWithFields) {
        this.propsWithFields = propsWithFields;
        return this;
    }

    public List<DbFieldInfo> getMutableFields() {
        return mutableFields;
    }

    public AbstractBannerPartModel withMutableFields(List<DbFieldInfo> mutableFields) {
        this.mutableFields = mutableFields;
        return this;
    }

    public List<ImportInfo> getImports() {
        return imports;
    }

    public AbstractBannerPartModel withImports(List<ImportInfo> imports) {
        this.imports = imports;
        return this;
    }
}
