package ru.yandex.direct.liveresource;

/**
 * Interface for data loaders, that supports getting and refreshing content from
 * different types of storage: classpath, filesystem
 */
public interface LiveResource {
    /**
     * Get text data from storage
     *
     * @return - content of resource
     */
    String getContent();

    /**
     * Get location of storage
     *
     * @return path to storage
     */
    String getLocation();
}
