// Auto-generated by model-generator, source: bid_modifier.conf
package ru.yandex.direct.core.entity.bidmodifier;

import java.time.LocalDateTime;
import java.util.Objects;
import java.util.Set;

import javax.annotation.Generated;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;

import ru.yandex.direct.model.Entity;
import ru.yandex.direct.model.ModelProperty;
import ru.yandex.direct.model.ModelWithId;

/**
 * Набор корректировок ставок - базовая модель API ядра */
@Generated(
        value = "ru.yandex.direct.model.generator.Tool",
        comments = "generated from bid_modifier.conf"
)
@JsonTypeInfo(
        use = JsonTypeInfo.Id.NAME,
        include = JsonTypeInfo.As.PROPERTY,
        property = "_type",
        visible = true
)
@JsonSubTypes({
        @JsonSubTypes.Type(value = AbstractBidModifierRetargeting.class, name = "AbstractBidModifierRetargeting"),
        @JsonSubTypes.Type(value = BidModifierABSegment.class, name = "BidModifierABSegment"),
        @JsonSubTypes.Type(value = BidModifierBannerType.class, name = "BidModifierBannerType"),
        @JsonSubTypes.Type(value = BidModifierDemographics.class, name = "BidModifierDemographics"),
        @JsonSubTypes.Type(value = BidModifierDesktop.class, name = "BidModifierDesktop"),
        @JsonSubTypes.Type(value = BidModifierDesktopOnly.class, name = "BidModifierDesktopOnly"),
        @JsonSubTypes.Type(value = BidModifierExpression.class, name = "BidModifierExpression"),
        @JsonSubTypes.Type(value = BidModifierGeo.class, name = "BidModifierGeo"),
        @JsonSubTypes.Type(value = BidModifierInventory.class, name = "BidModifierInventory"),
        @JsonSubTypes.Type(value = BidModifierMobile.class, name = "BidModifierMobile"),
        @JsonSubTypes.Type(value = BidModifierPerformanceTgo.class, name = "BidModifierPerformanceTgo"),
        @JsonSubTypes.Type(value = BidModifierSmartTV.class, name = "BidModifierSmartTV"),
        @JsonSubTypes.Type(value = BidModifierTablet.class, name = "BidModifierTablet"),
        @JsonSubTypes.Type(value = BidModifierTrafaretPosition.class, name = "BidModifierTrafaretPosition"),
        @JsonSubTypes.Type(value = BidModifierVideo.class, name = "BidModifierVideo"),
        @JsonSubTypes.Type(value = BidModifierWeather.class, name = "BidModifierWeather")
        })
public abstract class BidModifier implements Entity<Long>, ModelWithId {
    /**
     * идентификатор набора коэффициентов (соответствует `hierarchical_multiplier.id`) */
    public static final ModelProperty<BidModifier, Long> ID =
     ModelProperty.create(BidModifier.class, "id", BidModifier::getId, BidModifier::setId);

    /**
     * кампания, к которой относится набор коэффициентов */
    public static final ModelProperty<BidModifier, Long> CAMPAIGN_ID =
     ModelProperty.create(BidModifier.class, "campaignId", BidModifier::getCampaignId, BidModifier::setCampaignId);

    /**
     * группа, к которой относится набор коэффициентов. Если NULL, то набор коэффициентов относится ко всей кампании */
    public static final ModelProperty<BidModifier, Long> AD_GROUP_ID =
     ModelProperty.create(BidModifier.class, "adGroupId", BidModifier::getAdGroupId, BidModifier::setAdGroupId);

    /**
     * Одно из
     *       - 'mobile_multiplier' - это коэффициент цены для мобильного, нет подчинённых таблиц
     *       - 'demography_multiplier' - данные хранятся в demography_multiplier_values
     *       - 'retargeting_multiplier' - данные хранятся в retargeting_multiplier_values
     *       - 'video_multiplier' - коэффициент для видео, нет подчинённых таблиц
     *       - 'performance_tgo_multiplier' - коэффициент для ТГО объявлений в смарт кампаниях, без подчиненных таблиц
     *       - 'ab_segment_multiplier' - данные хранятся в ab_segment_multiplier_values
     *       - 'banner_type_multiplier' - корректировка по типу баннера, данные в таблице banner_type_multiplier_values
     *       - 'inventory_multiplier' - корректировка по инвентарю, данные в таблице inventory_multiplier_values
     *       - 'distance_multiplier' - пока не поддерживается
     *       - 'desktop_multiplier' - коэффициент для десктопа, нет подчинённых таблиц
     *       - 'traffic_multiplier' - бывшие корректировка на пробки, в процессе удаления
     *       - 'weather_multiplier' - данные хранятся в weather_multiplier_values
     *       - 'express_traffic_multiplier' - корректировка на пробки
     *       - 'express_content_duration_multiplier' - корректировка на длительность контента
     *       - 'trafaret_position_multiplier' - корректировка на формат на поиске
     *       - 'retargeting_filter' - фильтрация по ретаргетингу, данные хранятся в retargeting_multiplier_values
     *       - 'smarttv_multiplier' - - корректировка по SmartTV, без подчиненных таблиц */
    public static final ModelProperty<BidModifier, BidModifierType> TYPE =
     ModelProperty.create(BidModifier.class, "type", BidModifier::getType, BidModifier::setType);

    /**
     * Действие коэффициента можно приостанавливать, не теряя при этом сохранённых в БД данных */
    public static final ModelProperty<BidModifier, Boolean> ENABLED =
     ModelProperty.create(BidModifier.class, "enabled", BidModifier::getEnabled, BidModifier::setEnabled);

    /**
     * дата последнего изменения. Изменения в дочерних таблицах также приводят к обновлению здесь */
    public static final ModelProperty<BidModifier, LocalDateTime> LAST_CHANGE =
     ModelProperty.create(BidModifier.class, "lastChange", BidModifier::getLastChange, BidModifier::setLastChange);

    private Long id;

    private Long campaignId;

    private Long adGroupId;

    private BidModifierType type;

    private Boolean enabled;

    private LocalDateTime lastChange;

    /**
     * идентификатор набора коэффициентов (соответствует `hierarchical_multiplier.id`) */
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public BidModifier withId(Long id) {
        setId(id);
        return this;
    }

    /**
     * кампания, к которой относится набор коэффициентов */
    public Long getCampaignId() {
        return campaignId;
    }

    public void setCampaignId(Long campaignId) {
        this.campaignId = campaignId;
    }

    public BidModifier withCampaignId(Long campaignId) {
        setCampaignId(campaignId);
        return this;
    }

    /**
     * группа, к которой относится набор коэффициентов. Если NULL, то набор коэффициентов относится ко всей кампании */
    public Long getAdGroupId() {
        return adGroupId;
    }

    public void setAdGroupId(Long adGroupId) {
        this.adGroupId = adGroupId;
    }

    public BidModifier withAdGroupId(Long adGroupId) {
        setAdGroupId(adGroupId);
        return this;
    }

    /**
     * Одно из
     *       - 'mobile_multiplier' - это коэффициент цены для мобильного, нет подчинённых таблиц
     *       - 'demography_multiplier' - данные хранятся в demography_multiplier_values
     *       - 'retargeting_multiplier' - данные хранятся в retargeting_multiplier_values
     *       - 'video_multiplier' - коэффициент для видео, нет подчинённых таблиц
     *       - 'performance_tgo_multiplier' - коэффициент для ТГО объявлений в смарт кампаниях, без подчиненных таблиц
     *       - 'ab_segment_multiplier' - данные хранятся в ab_segment_multiplier_values
     *       - 'banner_type_multiplier' - корректировка по типу баннера, данные в таблице banner_type_multiplier_values
     *       - 'inventory_multiplier' - корректировка по инвентарю, данные в таблице inventory_multiplier_values
     *       - 'distance_multiplier' - пока не поддерживается
     *       - 'desktop_multiplier' - коэффициент для десктопа, нет подчинённых таблиц
     *       - 'traffic_multiplier' - бывшие корректировка на пробки, в процессе удаления
     *       - 'weather_multiplier' - данные хранятся в weather_multiplier_values
     *       - 'express_traffic_multiplier' - корректировка на пробки
     *       - 'express_content_duration_multiplier' - корректировка на длительность контента
     *       - 'trafaret_position_multiplier' - корректировка на формат на поиске
     *       - 'retargeting_filter' - фильтрация по ретаргетингу, данные хранятся в retargeting_multiplier_values
     *       - 'smarttv_multiplier' - - корректировка по SmartTV, без подчиненных таблиц */
    public BidModifierType getType() {
        return type;
    }

    public void setType(BidModifierType type) {
        this.type = type;
    }

    public BidModifier withType(BidModifierType type) {
        setType(type);
        return this;
    }

    /**
     * Действие коэффициента можно приостанавливать, не теряя при этом сохранённых в БД данных */
    public Boolean getEnabled() {
        return enabled;
    }

    public void setEnabled(Boolean enabled) {
        this.enabled = enabled;
    }

    public BidModifier withEnabled(Boolean enabled) {
        setEnabled(enabled);
        return this;
    }

    /**
     * дата последнего изменения. Изменения в дочерних таблицах также приводят к обновлению здесь */
    public LocalDateTime getLastChange() {
        return lastChange;
    }

    public void setLastChange(LocalDateTime lastChange) {
        this.lastChange = lastChange;
    }

    public BidModifier withLastChange(LocalDateTime lastChange) {
        setLastChange(lastChange);
        return this;
    }

    public static Set<ModelProperty<?, ?>> allModelProperties() {
        return Set.of(
                ID,
                CAMPAIGN_ID,
                AD_GROUP_ID,
                TYPE,
                ENABLED,
                LAST_CHANGE
                );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("ru.yandex.direct.core.entity.bidmodifier.BidModifier{");
        sb.append("id=").append(id);
        sb.append(", campaignId=").append(campaignId);
        sb.append(", adGroupId=").append(adGroupId);
        sb.append(", type=").append(type);
        sb.append(", enabled=").append(enabled);
        sb.append(", lastChange=").append(lastChange);
        sb.append('}');
        return sb.toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        BidModifier that = (BidModifier) o;
        return Objects.equals(id, that.id)
                 && Objects.equals(campaignId, that.campaignId)
                 && Objects.equals(adGroupId, that.adGroupId)
                 && Objects.equals(type, that.type)
                 && Objects.equals(enabled, that.enabled)
                 && Objects.equals(lastChange, that.lastChange);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                id,
                campaignId,
                adGroupId,
                type,
                enabled,
                lastChange
                );
    }
}
