// Auto-generated by model-generator, source: wallet_rest_money.conf
package ru.yandex.direct.core.entity.campaign.model;

import java.util.Objects;

import javax.annotation.Generated;

import ru.yandex.direct.currency.Money;

/**
 *
 * Деньги на кошельке (общем счёте на кампаниях) – остаток от дневного бюджета.
 * <p>
 * Объект содержит информацию об интегральном балансе на основе данных по кампании-кошельку ({@link WalletCampaign})
 * и всех кампаниях ({@link Campaign}), которые к ней подключены.
 * <p>
 * Предполагается, что если кампания не подключена к общему счёту, ей будет
 * соответствовать значение WalletRestMoney{id=null, rest=ZERO}.
 * <p>
 * Сущность не персистируется в БД, полностью вычислима.
 */
@Generated(
        value = "ru.yandex.direct.model.generator.Tool",
        comments = "generated from wallet_rest_money.conf"
)
public class WalletRestMoney {
    private Long walletId;

    private Money rest;

    /**
     * Идентификатор кампании-кошелька, {@link WalletCampaign}, или {@code null} */
    public Long getWalletId() {
        return walletId;
    }

    public void setWalletId(Long walletId) {
        this.walletId = walletId;
    }

    public WalletRestMoney withWalletId(Long walletId) {
        setWalletId(walletId);
        return this;
    }

    /**
     * Остаток на кошельке. Для кампаний без ОС – нулевое значение. */
    public Money getRest() {
        return rest;
    }

    public void setRest(Money rest) {
        this.rest = rest;
    }

    public WalletRestMoney withRest(Money rest) {
        setRest(rest);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("ru.yandex.direct.core.entity.campaign.model.WalletRestMoney{");
        sb.append("walletId=").append(walletId);
        sb.append(", rest=").append(rest);
        sb.append('}');
        return sb.toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        WalletRestMoney that = (WalletRestMoney) o;
        return Objects.equals(walletId, that.walletId)
                 && Objects.equals(rest, that.rest);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                walletId,
                rest
                );
    }
}
