// Auto-generated by model-generator, source: client_spent.conf
package ru.yandex.direct.core.entity.client.model;

import java.math.BigDecimal;
import java.util.Objects;
import java.util.Set;

import javax.annotation.Generated;

import ru.yandex.direct.dbutil.model.ClientId;
import ru.yandex.direct.model.Model;
import ru.yandex.direct.model.ModelProperty;

/**
 *
 * Информация о тратах ClientID (клиента, бренда целиком или агентства) по статистике и доступном остатке.
 * Все суммы приведены к рублям с НДС.
 */
@Generated(
        value = "ru.yandex.direct.model.generator.Tool",
        comments = "generated from client_spent.conf"
)
public class ClientSpent implements Model {
    /**
     * ClientID клиента, бренда или агентства */
    public static final ModelProperty<ClientSpent, ClientId> CLIENT_ID =
     ModelProperty.create(ClientSpent.class, "clientId", ClientSpent::getClientId, ClientSpent::setClientId);

    /**
     * Для кого рассчитаны данные (сам клиент, весь бренд целиком или агентство) */
    public static final ModelProperty<ClientSpent, AggregationType> TYPE =
     ModelProperty.create(ClientSpent.class, "type", ClientSpent::getType, ClientSpent::setType);

    /**
     * Суммарные траты за все время */
    public static final ModelProperty<ClientSpent, BigDecimal> TOTAL_SUM =
     ModelProperty.create(ClientSpent.class, "totalSum", ClientSpent::getTotalSum, ClientSpent::setTotalSum);

    /**
     * Траты за последние 28 дней активности */
    public static final ModelProperty<ClientSpent, BigDecimal> ACTIVE28_DAYS_SUM =
     ModelProperty.create(ClientSpent.class, "active28DaysSum", ClientSpent::getActive28DaysSum, ClientSpent::setActive28DaysSum);

    /**
     * Приблизительный расход за день, оценка сверху по данным за последний месяц */
    public static final ModelProperty<ClientSpent, BigDecimal> DAILY_SPENT_ESTIMATE =
     ModelProperty.create(ClientSpent.class, "dailySpentEstimate", ClientSpent::getDailySpentEstimate, ClientSpent::setDailySpentEstimate);

    /**
     * Доступные для расхода средств клиента по всем его кампаниям */
    public static final ModelProperty<ClientSpent, BigDecimal> REST_SUM =
     ModelProperty.create(ClientSpent.class, "restSum", ClientSpent::getRestSum, ClientSpent::setRestSum);

    private ClientId clientId;

    private AggregationType type;

    private BigDecimal totalSum;

    private BigDecimal active28DaysSum;

    private BigDecimal dailySpentEstimate;

    private BigDecimal restSum;

    /**
     * ClientID клиента, бренда или агентства */
    public ClientId getClientId() {
        return clientId;
    }

    public void setClientId(ClientId clientId) {
        this.clientId = clientId;
    }

    public ClientSpent withClientId(ClientId clientId) {
        setClientId(clientId);
        return this;
    }

    /**
     * Для кого рассчитаны данные (сам клиент, весь бренд целиком или агентство) */
    public AggregationType getType() {
        return type;
    }

    public void setType(AggregationType type) {
        this.type = type;
    }

    public ClientSpent withType(AggregationType type) {
        setType(type);
        return this;
    }

    /**
     * Суммарные траты за все время */
    public BigDecimal getTotalSum() {
        return totalSum;
    }

    public void setTotalSum(BigDecimal totalSum) {
        this.totalSum = totalSum;
    }

    public ClientSpent withTotalSum(BigDecimal totalSum) {
        setTotalSum(totalSum);
        return this;
    }

    /**
     * Траты за последние 28 дней активности */
    public BigDecimal getActive28DaysSum() {
        return active28DaysSum;
    }

    public void setActive28DaysSum(BigDecimal active28DaysSum) {
        this.active28DaysSum = active28DaysSum;
    }

    public ClientSpent withActive28DaysSum(BigDecimal active28DaysSum) {
        setActive28DaysSum(active28DaysSum);
        return this;
    }

    /**
     * Приблизительный расход за день, оценка сверху по данным за последний месяц */
    public BigDecimal getDailySpentEstimate() {
        return dailySpentEstimate;
    }

    public void setDailySpentEstimate(BigDecimal dailySpentEstimate) {
        this.dailySpentEstimate = dailySpentEstimate;
    }

    public ClientSpent withDailySpentEstimate(BigDecimal dailySpentEstimate) {
        setDailySpentEstimate(dailySpentEstimate);
        return this;
    }

    /**
     * Доступные для расхода средств клиента по всем его кампаниям */
    public BigDecimal getRestSum() {
        return restSum;
    }

    public void setRestSum(BigDecimal restSum) {
        this.restSum = restSum;
    }

    public ClientSpent withRestSum(BigDecimal restSum) {
        setRestSum(restSum);
        return this;
    }

    public static Set<ModelProperty<?, ?>> allModelProperties() {
        return Set.of(
                CLIENT_ID,
                TYPE,
                TOTAL_SUM,
                ACTIVE28_DAYS_SUM,
                DAILY_SPENT_ESTIMATE,
                REST_SUM
                );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("ru.yandex.direct.core.entity.client.model.ClientSpent{");
        sb.append("clientId=").append(clientId);
        sb.append(", type=").append(type);
        sb.append(", totalSum=").append(totalSum);
        sb.append(", active28DaysSum=").append(active28DaysSum);
        sb.append(", dailySpentEstimate=").append(dailySpentEstimate);
        sb.append(", restSum=").append(restSum);
        sb.append('}');
        return sb.toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ClientSpent that = (ClientSpent) o;
        return Objects.equals(clientId, that.clientId)
                 && Objects.equals(type, that.type)
                 && Objects.equals(totalSum, that.totalSum)
                 && Objects.equals(active28DaysSum, that.active28DaysSum)
                 && Objects.equals(dailySpentEstimate, that.dailySpentEstimate)
                 && Objects.equals(restSum, that.restSum);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                clientId,
                type,
                totalSum,
                active28DaysSum,
                dailySpentEstimate,
                restSum
                );
    }
}
