// Auto-generated by model-generator, source: moderation_diag.conf
package ru.yandex.direct.core.entity.moderationdiag.model;

import java.util.Objects;
import java.util.Set;

import javax.annotation.Generated;

import ru.yandex.direct.model.ModelProperty;
import ru.yandex.direct.model.ModelWithId;

/**
 *
 * Модель с причинами отклонения на модерации
 */
@Generated(
        value = "ru.yandex.direct.model.generator.Tool",
        comments = "generated from moderation_diag.conf"
)
public class ModerationDiag implements ModelWithId {
    /**
     * айдишник причины отклонения, уникален на каждый тип причины отклонения */
    public static final ModelProperty<ModerationDiag, Long> ID =
     ModelProperty.create(ModerationDiag.class, "id", ModerationDiag::getId, ModerationDiag::setId);

    /**
     * тип причины отклонения */
    public static final ModelProperty<ModerationDiag, ModerationDiagType> TYPE =
     ModelProperty.create(ModerationDiag.class, "type", ModerationDiag::getType, ModerationDiag::setType);

    /**
     * короткий текст причины отклонения (пример: По политике Яндекса) */
    public static final ModelProperty<ModerationDiag, String> SHORT_TEXT =
     ModelProperty.create(ModerationDiag.class, "shortText", ModerationDiag::getShortText, ModerationDiag::setShortText);

    /**
     * полный текст причины отклонения (пример: Объявление не соответствует рекламной политике Яндекса. Требования к рекламным материалам вы можете прочитать...) */
    public static final ModelProperty<ModerationDiag, String> FULL_TEXT =
     ModelProperty.create(ModerationDiag.class, "fullText", ModerationDiag::getFullText, ModerationDiag::setFullText);

    /**
     * полный текст причины отклонения, или короткий, если нет полного */
    public static final ModelProperty<ModerationDiag, String> DIAG_TEXT =
     ModelProperty.create(ModerationDiag.class, "diagText", ModerationDiag::getDiagText, ModerationDiag::setDiagText);

    /**
     * может ли баннер с такой причиной быть допущен к первой помощи (Yes, негрубые причины отклонения) или нет (No, грубые) */
    public static final ModelProperty<ModerationDiag, Boolean> ALLOW_FIRST_AID =
     ModelProperty.create(ModerationDiag.class, "allowFirstAid", ModerationDiag::getAllowFirstAid, ModerationDiag::setAllowFirstAid);

    /**
     * является ли причина отклонения грубой */
    public static final ModelProperty<ModerationDiag, Boolean> STRONG_REASON =
     ModelProperty.create(ModerationDiag.class, "strongReason", ModerationDiag::getStrongReason, ModerationDiag::setStrongReason);

    /**
     * признак критичной причины отклонения */
    public static final ModelProperty<ModerationDiag, Boolean> UNBAN_IS_PROHIBITED =
     ModelProperty.create(ModerationDiag.class, "unbanIsProhibited", ModerationDiag::getUnbanIsProhibited, ModerationDiag::setUnbanIsProhibited);

    /**
     * короткое текстовое англоязычное название для причины отклонения может быть
     *     одинаковым у нескольких причин используется для определения какой шаблон показыть для причины */
    public static final ModelProperty<ModerationDiag, String> TOKEN =
     ModelProperty.create(ModerationDiag.class, "token", ModerationDiag::getToken, ModerationDiag::setToken);

    private Long id;

    private ModerationDiagType type;

    private String shortText;

    private String fullText;

    private String diagText;

    private Boolean allowFirstAid;

    private Boolean strongReason;

    private Boolean unbanIsProhibited;

    private String token;

    /**
     * айдишник причины отклонения, уникален на каждый тип причины отклонения */
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public ModerationDiag withId(Long id) {
        setId(id);
        return this;
    }

    /**
     * тип причины отклонения */
    public ModerationDiagType getType() {
        return type;
    }

    public void setType(ModerationDiagType type) {
        this.type = type;
    }

    public ModerationDiag withType(ModerationDiagType type) {
        setType(type);
        return this;
    }

    /**
     * короткий текст причины отклонения (пример: По политике Яндекса) */
    public String getShortText() {
        return shortText;
    }

    public void setShortText(String shortText) {
        this.shortText = shortText;
    }

    public ModerationDiag withShortText(String shortText) {
        setShortText(shortText);
        return this;
    }

    /**
     * полный текст причины отклонения (пример: Объявление не соответствует рекламной политике Яндекса. Требования к рекламным материалам вы можете прочитать...) */
    public String getFullText() {
        return fullText;
    }

    public void setFullText(String fullText) {
        this.fullText = fullText;
    }

    public ModerationDiag withFullText(String fullText) {
        setFullText(fullText);
        return this;
    }

    /**
     * полный текст причины отклонения, или короткий, если нет полного */
    public String getDiagText() {
        return diagText;
    }

    public void setDiagText(String diagText) {
        this.diagText = diagText;
    }

    public ModerationDiag withDiagText(String diagText) {
        setDiagText(diagText);
        return this;
    }

    /**
     * может ли баннер с такой причиной быть допущен к первой помощи (Yes, негрубые причины отклонения) или нет (No, грубые) */
    public Boolean getAllowFirstAid() {
        return allowFirstAid;
    }

    public void setAllowFirstAid(Boolean allowFirstAid) {
        this.allowFirstAid = allowFirstAid;
    }

    public ModerationDiag withAllowFirstAid(Boolean allowFirstAid) {
        setAllowFirstAid(allowFirstAid);
        return this;
    }

    /**
     * является ли причина отклонения грубой */
    public Boolean getStrongReason() {
        return strongReason;
    }

    public void setStrongReason(Boolean strongReason) {
        this.strongReason = strongReason;
    }

    public ModerationDiag withStrongReason(Boolean strongReason) {
        setStrongReason(strongReason);
        return this;
    }

    /**
     * признак критичной причины отклонения */
    public Boolean getUnbanIsProhibited() {
        return unbanIsProhibited;
    }

    public void setUnbanIsProhibited(Boolean unbanIsProhibited) {
        this.unbanIsProhibited = unbanIsProhibited;
    }

    public ModerationDiag withUnbanIsProhibited(Boolean unbanIsProhibited) {
        setUnbanIsProhibited(unbanIsProhibited);
        return this;
    }

    /**
     * короткое текстовое англоязычное название для причины отклонения может быть
     *     одинаковым у нескольких причин используется для определения какой шаблон показыть для причины */
    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public ModerationDiag withToken(String token) {
        setToken(token);
        return this;
    }

    public static Set<ModelProperty<?, ?>> allModelProperties() {
        return Set.of(
                ID,
                TYPE,
                SHORT_TEXT,
                FULL_TEXT,
                DIAG_TEXT,
                ALLOW_FIRST_AID,
                STRONG_REASON,
                UNBAN_IS_PROHIBITED,
                TOKEN
                );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("ru.yandex.direct.core.entity.moderationdiag.model.ModerationDiag{");
        sb.append("id=").append(id);
        sb.append(", type=").append(type);
        sb.append(", shortText=").append(shortText);
        sb.append(", fullText=").append(fullText);
        sb.append(", diagText=").append(diagText);
        sb.append(", allowFirstAid=").append(allowFirstAid);
        sb.append(", strongReason=").append(strongReason);
        sb.append(", unbanIsProhibited=").append(unbanIsProhibited);
        sb.append(", token=").append(token);
        sb.append('}');
        return sb.toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ModerationDiag that = (ModerationDiag) o;
        return Objects.equals(id, that.id)
                 && Objects.equals(type, that.type)
                 && Objects.equals(shortText, that.shortText)
                 && Objects.equals(fullText, that.fullText)
                 && Objects.equals(diagText, that.diagText)
                 && Objects.equals(allowFirstAid, that.allowFirstAid)
                 && Objects.equals(strongReason, that.strongReason)
                 && Objects.equals(unbanIsProhibited, that.unbanIsProhibited)
                 && Objects.equals(token, that.token);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                id,
                type,
                shortText,
                fullText,
                diagText,
                allowFirstAid,
                strongReason,
                unbanIsProhibited,
                token
                );
    }
}
