// Auto-generated by model-generator, source: price_packages_filter.conf
package ru.yandex.direct.core.entity.pricepackage.model;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;
import java.util.Objects;
import java.util.Set;

import javax.annotation.Generated;

import ru.yandex.direct.core.entity.adgroup.model.AdGroupType;
import ru.yandex.direct.core.entity.container.LocalDateRange;
import ru.yandex.direct.currency.CurrencyCode;
import ru.yandex.direct.model.Model;
import ru.yandex.direct.model.ModelProperty;

/**
 *
 * Фильтрация прайсовых пакетов
 */
@Generated(
        value = "ru.yandex.direct.model.generator.Tool",
        comments = "generated from price_packages_filter.conf"
)
public class PricePackagesFilter implements Model {
    public static final ModelProperty<PricePackagesFilter, Set<Long>> PACKAGE_ID_IN =
     ModelProperty.create(PricePackagesFilter.class, "packageIdIn", PricePackagesFilter::getPackageIdIn, PricePackagesFilter::setPackageIdIn);

    public static final ModelProperty<PricePackagesFilter, Set<AdGroupType>> AD_GROUP_TYPES =
     ModelProperty.create(PricePackagesFilter.class, "adGroupTypes", PricePackagesFilter::getAdGroupTypes, PricePackagesFilter::setAdGroupTypes);

    public static final ModelProperty<PricePackagesFilter, String> TITLE_CONTAINS =
     ModelProperty.create(PricePackagesFilter.class, "titleContains", PricePackagesFilter::getTitleContains, PricePackagesFilter::setTitleContains);

    public static final ModelProperty<PricePackagesFilter, Set<Long>> BUSINESS_UNIT_ID_IN =
     ModelProperty.create(PricePackagesFilter.class, "businessUnitIdIn", PricePackagesFilter::getBusinessUnitIdIn, PricePackagesFilter::setBusinessUnitIdIn);

    public static final ModelProperty<PricePackagesFilter, Boolean> IS_NOT_BUSINESS_UNIT =
     ModelProperty.create(PricePackagesFilter.class, "isNotBusinessUnit", PricePackagesFilter::getIsNotBusinessUnit, PricePackagesFilter::setIsNotBusinessUnit);

    public static final ModelProperty<PricePackagesFilter, Boolean> IS_PUBLIC =
     ModelProperty.create(PricePackagesFilter.class, "isPublic", PricePackagesFilter::getIsPublic, PricePackagesFilter::setIsPublic);

    public static final ModelProperty<PricePackagesFilter, Boolean> IS_SPECIAL =
     ModelProperty.create(PricePackagesFilter.class, "isSpecial", PricePackagesFilter::getIsSpecial, PricePackagesFilter::setIsSpecial);

    public static final ModelProperty<PricePackagesFilter, Boolean> IS_ARCHIVED =
     ModelProperty.create(PricePackagesFilter.class, "isArchived", PricePackagesFilter::getIsArchived, PricePackagesFilter::setIsArchived);

    /**
     * Логин хотя бы одного из привязанных клиентов содержит переданное значение */
    public static final ModelProperty<PricePackagesFilter, Set<String>> CLIENT_IN =
     ModelProperty.create(PricePackagesFilter.class, "clientIn", PricePackagesFilter::getClientIn, PricePackagesFilter::setClientIn);

    /**
     * Переданное дерево (минус регионы не допускаются) имеет пересечение с деревом, на котором действует пакет. */
    public static final ModelProperty<PricePackagesFilter, Set<Long>> REGION_IDS =
     ModelProperty.create(PricePackagesFilter.class, "regionIds", PricePackagesFilter::getRegionIds, PricePackagesFilter::setRegionIds);

    /**
     * Пакет действует хотя бы 1 день хотя бы одного из переданных интервалов. */
    public static final ModelProperty<PricePackagesFilter, List<LocalDateRange>> ACTIVITY_INTERVALS =
     ModelProperty.create(PricePackagesFilter.class, "activityIntervals", PricePackagesFilter::getActivityIntervals, PricePackagesFilter::setActivityIntervals);

    /**
     * Цена пакета больше либо равна указанной */
    public static final ModelProperty<PricePackagesFilter, BigDecimal> MIN_PRICE =
     ModelProperty.create(PricePackagesFilter.class, "minPrice", PricePackagesFilter::getMinPrice, PricePackagesFilter::setMinPrice);

    /**
     * Цена пакета меньше либо равна указанной */
    public static final ModelProperty<PricePackagesFilter, BigDecimal> MAX_PRICE =
     ModelProperty.create(PricePackagesFilter.class, "maxPrice", PricePackagesFilter::getMaxPrice, PricePackagesFilter::setMaxPrice);

    /**
     * Валюта пакета - одна из переданных */
    public static final ModelProperty<PricePackagesFilter, Set<CurrencyCode>> CURRENCY_IN =
     ModelProperty.create(PricePackagesFilter.class, "currencyIn", PricePackagesFilter::getCurrencyIn, PricePackagesFilter::setCurrencyIn);

    /**
     * statusApprove - один из переданных */
    public static final ModelProperty<PricePackagesFilter, Set<StatusApprove>> STATUS_APPROVE_IN =
     ModelProperty.create(PricePackagesFilter.class, "statusApproveIn", PricePackagesFilter::getStatusApproveIn, PricePackagesFilter::setStatusApproveIn);

    /**
     * платформа (тип устройства) - одна из переданных */
    public static final ModelProperty<PricePackagesFilter, Set<PricePackagePlatform>> PLATFORMS =
     ModelProperty.create(PricePackagesFilter.class, "platforms", PricePackagesFilter::getPlatforms, PricePackagesFilter::setPlatforms);

    /**
     * формат (тип группы объявлений) - один из переданных */
    public static final ModelProperty<PricePackagesFilter, Set<AdGroupType>> FORMATS =
     ModelProperty.create(PricePackagesFilter.class, "formats", PricePackagesFilter::getFormats, PricePackagesFilter::setFormats);

    /**
     * дата окончания раньше искомой даты. Используется для поиска пакетов которые еще актуальны по времени */
    public static final ModelProperty<PricePackagesFilter, LocalDate> DATE_END_AFTER =
     ModelProperty.create(PricePackagesFilter.class, "dateEndAfter", PricePackagesFilter::getDateEndAfter, PricePackagesFilter::setDateEndAfter);

    public static final ModelProperty<PricePackagesFilter, Boolean> IS_CPD =
     ModelProperty.create(PricePackagesFilter.class, "isCpd", PricePackagesFilter::getIsCpd, PricePackagesFilter::setIsCpd);

    private Set<Long> packageIdIn;

    private Set<AdGroupType> adGroupTypes;

    private String titleContains;

    private Set<Long> businessUnitIdIn;

    private Boolean isNotBusinessUnit;

    private Boolean isPublic;

    private Boolean isSpecial;

    private Boolean isArchived;

    private Set<String> clientIn;

    private Set<Long> regionIds;

    private List<LocalDateRange> activityIntervals;

    private BigDecimal minPrice;

    private BigDecimal maxPrice;

    private Set<CurrencyCode> currencyIn;

    private Set<StatusApprove> statusApproveIn;

    private Set<PricePackagePlatform> platforms;

    private Set<AdGroupType> formats;

    private LocalDate dateEndAfter;

    private Boolean isCpd;

    public Set<Long> getPackageIdIn() {
        return packageIdIn;
    }

    public void setPackageIdIn(Set<Long> packageIdIn) {
        this.packageIdIn = packageIdIn;
    }

    public PricePackagesFilter withPackageIdIn(Set<Long> packageIdIn) {
        setPackageIdIn(packageIdIn);
        return this;
    }

    public Set<AdGroupType> getAdGroupTypes() {
        return adGroupTypes;
    }

    public void setAdGroupTypes(Set<AdGroupType> adGroupTypes) {
        this.adGroupTypes = adGroupTypes;
    }

    public PricePackagesFilter withAdGroupTypes(Set<AdGroupType> adGroupTypes) {
        setAdGroupTypes(adGroupTypes);
        return this;
    }

    public String getTitleContains() {
        return titleContains;
    }

    public void setTitleContains(String titleContains) {
        this.titleContains = titleContains;
    }

    public PricePackagesFilter withTitleContains(String titleContains) {
        setTitleContains(titleContains);
        return this;
    }

    public Set<Long> getBusinessUnitIdIn() {
        return businessUnitIdIn;
    }

    public void setBusinessUnitIdIn(Set<Long> businessUnitIdIn) {
        this.businessUnitIdIn = businessUnitIdIn;
    }

    public PricePackagesFilter withBusinessUnitIdIn(Set<Long> businessUnitIdIn) {
        setBusinessUnitIdIn(businessUnitIdIn);
        return this;
    }

    public Boolean getIsNotBusinessUnit() {
        return isNotBusinessUnit;
    }

    public void setIsNotBusinessUnit(Boolean isNotBusinessUnit) {
        this.isNotBusinessUnit = isNotBusinessUnit;
    }

    public PricePackagesFilter withIsNotBusinessUnit(Boolean isNotBusinessUnit) {
        setIsNotBusinessUnit(isNotBusinessUnit);
        return this;
    }

    public Boolean getIsPublic() {
        return isPublic;
    }

    public void setIsPublic(Boolean isPublic) {
        this.isPublic = isPublic;
    }

    public PricePackagesFilter withIsPublic(Boolean isPublic) {
        setIsPublic(isPublic);
        return this;
    }

    public Boolean getIsSpecial() {
        return isSpecial;
    }

    public void setIsSpecial(Boolean isSpecial) {
        this.isSpecial = isSpecial;
    }

    public PricePackagesFilter withIsSpecial(Boolean isSpecial) {
        setIsSpecial(isSpecial);
        return this;
    }

    public Boolean getIsArchived() {
        return isArchived;
    }

    public void setIsArchived(Boolean isArchived) {
        this.isArchived = isArchived;
    }

    public PricePackagesFilter withIsArchived(Boolean isArchived) {
        setIsArchived(isArchived);
        return this;
    }

    /**
     * Логин хотя бы одного из привязанных клиентов содержит переданное значение */
    public Set<String> getClientIn() {
        return clientIn;
    }

    public void setClientIn(Set<String> clientIn) {
        this.clientIn = clientIn;
    }

    public PricePackagesFilter withClientIn(Set<String> clientIn) {
        setClientIn(clientIn);
        return this;
    }

    /**
     * Переданное дерево (минус регионы не допускаются) имеет пересечение с деревом, на котором действует пакет. */
    public Set<Long> getRegionIds() {
        return regionIds;
    }

    public void setRegionIds(Set<Long> regionIds) {
        this.regionIds = regionIds;
    }

    public PricePackagesFilter withRegionIds(Set<Long> regionIds) {
        setRegionIds(regionIds);
        return this;
    }

    /**
     * Пакет действует хотя бы 1 день хотя бы одного из переданных интервалов. */
    public List<LocalDateRange> getActivityIntervals() {
        return activityIntervals;
    }

    public void setActivityIntervals(List<LocalDateRange> activityIntervals) {
        this.activityIntervals = activityIntervals;
    }

    public PricePackagesFilter withActivityIntervals(List<LocalDateRange> activityIntervals) {
        setActivityIntervals(activityIntervals);
        return this;
    }

    /**
     * Цена пакета больше либо равна указанной */
    public BigDecimal getMinPrice() {
        return minPrice;
    }

    public void setMinPrice(BigDecimal minPrice) {
        this.minPrice = minPrice;
    }

    public PricePackagesFilter withMinPrice(BigDecimal minPrice) {
        setMinPrice(minPrice);
        return this;
    }

    /**
     * Цена пакета меньше либо равна указанной */
    public BigDecimal getMaxPrice() {
        return maxPrice;
    }

    public void setMaxPrice(BigDecimal maxPrice) {
        this.maxPrice = maxPrice;
    }

    public PricePackagesFilter withMaxPrice(BigDecimal maxPrice) {
        setMaxPrice(maxPrice);
        return this;
    }

    /**
     * Валюта пакета - одна из переданных */
    public Set<CurrencyCode> getCurrencyIn() {
        return currencyIn;
    }

    public void setCurrencyIn(Set<CurrencyCode> currencyIn) {
        this.currencyIn = currencyIn;
    }

    public PricePackagesFilter withCurrencyIn(Set<CurrencyCode> currencyIn) {
        setCurrencyIn(currencyIn);
        return this;
    }

    /**
     * statusApprove - один из переданных */
    public Set<StatusApprove> getStatusApproveIn() {
        return statusApproveIn;
    }

    public void setStatusApproveIn(Set<StatusApprove> statusApproveIn) {
        this.statusApproveIn = statusApproveIn;
    }

    public PricePackagesFilter withStatusApproveIn(Set<StatusApprove> statusApproveIn) {
        setStatusApproveIn(statusApproveIn);
        return this;
    }

    /**
     * платформа (тип устройства) - одна из переданных */
    public Set<PricePackagePlatform> getPlatforms() {
        return platforms;
    }

    public void setPlatforms(Set<PricePackagePlatform> platforms) {
        this.platforms = platforms;
    }

    public PricePackagesFilter withPlatforms(Set<PricePackagePlatform> platforms) {
        setPlatforms(platforms);
        return this;
    }

    /**
     * формат (тип группы объявлений) - один из переданных */
    public Set<AdGroupType> getFormats() {
        return formats;
    }

    public void setFormats(Set<AdGroupType> formats) {
        this.formats = formats;
    }

    public PricePackagesFilter withFormats(Set<AdGroupType> formats) {
        setFormats(formats);
        return this;
    }

    /**
     * дата окончания раньше искомой даты. Используется для поиска пакетов которые еще актуальны по времени */
    public LocalDate getDateEndAfter() {
        return dateEndAfter;
    }

    public void setDateEndAfter(LocalDate dateEndAfter) {
        this.dateEndAfter = dateEndAfter;
    }

    public PricePackagesFilter withDateEndAfter(LocalDate dateEndAfter) {
        setDateEndAfter(dateEndAfter);
        return this;
    }

    public Boolean getIsCpd() {
        return isCpd;
    }

    public void setIsCpd(Boolean isCpd) {
        this.isCpd = isCpd;
    }

    public PricePackagesFilter withIsCpd(Boolean isCpd) {
        setIsCpd(isCpd);
        return this;
    }

    public static Set<ModelProperty<?, ?>> allModelProperties() {
        return Set.of(
                PACKAGE_ID_IN,
                AD_GROUP_TYPES,
                TITLE_CONTAINS,
                BUSINESS_UNIT_ID_IN,
                IS_NOT_BUSINESS_UNIT,
                IS_PUBLIC,
                IS_SPECIAL,
                IS_ARCHIVED,
                CLIENT_IN,
                REGION_IDS,
                ACTIVITY_INTERVALS,
                MIN_PRICE,
                MAX_PRICE,
                CURRENCY_IN,
                STATUS_APPROVE_IN,
                PLATFORMS,
                FORMATS,
                DATE_END_AFTER,
                IS_CPD
                );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("ru.yandex.direct.core.entity.pricepackage.model.PricePackagesFilter{");
        sb.append("packageIdIn=").append(packageIdIn);
        sb.append(", adGroupTypes=").append(adGroupTypes);
        sb.append(", titleContains=").append(titleContains);
        sb.append(", businessUnitIdIn=").append(businessUnitIdIn);
        sb.append(", isNotBusinessUnit=").append(isNotBusinessUnit);
        sb.append(", isPublic=").append(isPublic);
        sb.append(", isSpecial=").append(isSpecial);
        sb.append(", isArchived=").append(isArchived);
        sb.append(", clientIn=").append(clientIn);
        sb.append(", regionIds=").append(regionIds);
        sb.append(", activityIntervals=").append(activityIntervals);
        sb.append(", minPrice=").append(minPrice);
        sb.append(", maxPrice=").append(maxPrice);
        sb.append(", currencyIn=").append(currencyIn);
        sb.append(", statusApproveIn=").append(statusApproveIn);
        sb.append(", platforms=").append(platforms);
        sb.append(", formats=").append(formats);
        sb.append(", dateEndAfter=").append(dateEndAfter);
        sb.append(", isCpd=").append(isCpd);
        sb.append('}');
        return sb.toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        PricePackagesFilter that = (PricePackagesFilter) o;
        return Objects.equals(packageIdIn, that.packageIdIn)
                 && Objects.equals(adGroupTypes, that.adGroupTypes)
                 && Objects.equals(titleContains, that.titleContains)
                 && Objects.equals(businessUnitIdIn, that.businessUnitIdIn)
                 && Objects.equals(isNotBusinessUnit, that.isNotBusinessUnit)
                 && Objects.equals(isPublic, that.isPublic)
                 && Objects.equals(isSpecial, that.isSpecial)
                 && Objects.equals(isArchived, that.isArchived)
                 && Objects.equals(clientIn, that.clientIn)
                 && Objects.equals(regionIds, that.regionIds)
                 && Objects.equals(activityIntervals, that.activityIntervals)
                 && Objects.equals(minPrice, that.minPrice)
                 && Objects.equals(maxPrice, that.maxPrice)
                 && Objects.equals(currencyIn, that.currencyIn)
                 && Objects.equals(statusApproveIn, that.statusApproveIn)
                 && Objects.equals(platforms, that.platforms)
                 && Objects.equals(formats, that.formats)
                 && Objects.equals(dateEndAfter, that.dateEndAfter)
                 && Objects.equals(isCpd, that.isCpd);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                packageIdIn,
                adGroupTypes,
                titleContains,
                businessUnitIdIn,
                isNotBusinessUnit,
                isPublic,
                isSpecial,
                isArchived,
                clientIn,
                regionIds,
                activityIntervals,
                minPrice,
                maxPrice,
                currencyIn,
                statusApproveIn,
                platforms,
                formats,
                dateEndAfter,
                isCpd
                );
    }
}
