package ru.yandex.direct.core.entity.campaign.model;

import javax.annotation.Nullable;

import ru.yandex.direct.core.entity.promoextension.model.PromoExtension;
import ru.yandex.direct.model.Relationship;

public class CampaignLinkedToPromoExtension implements Relationship<PromoExtension, CampaignWithPromoExtension, Long> {
    @Override
    @Nullable
    public Long getParentId(CampaignWithPromoExtension child) {
        return child.getPromoExtensionId();
    }

    @Override
    public void setParentId(CampaignWithPromoExtension child, @Nullable Long id) {
        child.setPromoExtensionId(id);
    }

    @Override
    public Class<PromoExtension> getParentEntityClass() {
        return PromoExtension.class;
    }

    @Override
    public Class<CampaignWithPromoExtension> getChildEntityClass() {
        return CampaignWithPromoExtension.class;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        return o != null && getClass() == o.getClass();
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
}
