package ru.yandex.direct.grid.processing.model.goal

import ru.yandex.direct.grid.processing.model.api.GdApiResponse

/**
 * Главный представитель клиента, идентифицируемый по логину
 */
data class GdMobileGoalSharingMainRep(
    val login: String
)

/**
 * Запрос добавления доступа к мобильным целям текущего клиента
 * @param mainReps главные представители клиентов, которым нужно предоставить доступ
 */
data class GdMobileGoalSharingReq(
    val mainReps: List<GdMobileGoalSharingMainRep>
)

class GdMobileGoalSharingPayload : GdApiResponse()
