package ru.yandex.direct.grid.processing.service.group.type;

import java.util.Collection;

import javax.annotation.ParametersAreNonnullByDefault;

import com.google.common.collect.ImmutableSet;
import org.springframework.stereotype.Component;

import ru.yandex.direct.dbutil.model.ClientId;
import ru.yandex.direct.grid.model.entity.adgroup.GdAdGroupType;
import ru.yandex.direct.grid.processing.model.banner.GdAdType;
import ru.yandex.direct.grid.processing.model.group.GdDynamicAdGroup;
import ru.yandex.direct.grid.processing.model.showcondition.GdShowConditionType;

@Component
@ParametersAreNonnullByDefault
public class DynamicGroupTypeSupport implements GroupTypeSupport<GdDynamicAdGroup> {
    @Override
    public void setAvailableShowConditionTypesForAdGroup(int shard, ClientId clientId,
                                                         Long operatorUid, Collection<GdDynamicAdGroup> adGroups) {
        adGroups.forEach(adGroup -> adGroup.setAvailableShowConditionTypes(
                ImmutableSet.of(GdShowConditionType.DYNAMIC_TARGETING, GdShowConditionType.FILTERS)));
    }

    @Override
    public GdAdGroupType getAdGroupType() {
        return GdAdGroupType.DYNAMIC;
    }

    @Override
    public void setAvailableBannerTypesForAdGroup(int shard, ClientId clientId, Collection<GdDynamicAdGroup> adGroups) {
        adGroups.forEach(adGroup -> adGroup.setAvailableAdTypes(ImmutableSet.of(GdAdType.DYNAMIC)));
    }
}
