package ru.yandex.direct.grid.processing.service.validation;

import java.util.Collection;

import ru.yandex.direct.validation.result.DefectId;

public enum GridDefectIds implements DefectId<Void> {
    INVALID_UNION,
    MUST_BE_MUTUALLY_EXCLUSIVE,
    MUST_BE_SAME_NULL_STATE,
    DATES_FROM_NOT_AFTER_TO,
    INVALID_MONTH_FORMAT,
    MUST_CONTAIN_NON_NULL_PROPS,
    INVALID_FIND_AND_REPLACE_BANNERS_HREF_PARAMS_TEXT,
    UNSUPPORTED_GROUP_TYPE;

    public enum OfflineReport implements DefectId<Void> {
        MIN_MONTH_FROM,
        MAX_REPORT_PERIOD,
    }

    public enum Pixels implements DefectId<Void> {
        INVALID_AUDIENCE_PIXEL_FORMAT,
        INVALID_AUDIT_PIXEL_FORMAT,
    }

    public enum TimeTarget implements DefectId<Void> {
        INVALID_TIME_BOARD_FORMAT
    }

    public enum Str implements DefectId<String> {
        INVALID_CLIENT_MEASURER
    }

    public enum Ids implements DefectId<Collection<? extends Number>> {
        GOAL_IDS_FROM_ORDER_BY_NOT_FOUND_IN_STAT_REQUIREMENTS
    }

}
