package ru.yandex.direct.internaltools.core.annotations.input;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Аннотация для описания параметров поля ввода c типом checkbox. Игнорируется для всех полей, кроме полей с типом
 * boolean и Boolean, отчеменных как @Input
 */
@Target({ElementType.FIELD})
@Retention(RetentionPolicy.RUNTIME)
public @interface CheckBox {
    /**
     * Должна ли галочка быть отмечена по-умолчанию
     */
    boolean checked();
}
