package ru.yandex.direct.internaltools.core.annotations.input;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Аннотация, делающая поле ввода спрятанным для клиента. Игнорируется для всех полей, кроме полей отчеменных как @Input
 */
@Target({ElementType.FIELD})
@Retention(RetentionPolicy.RUNTIME)
public @interface Hidden {
    /**
     * Значение поля по-умолчанию
     */
    String defaultValue() default "";
}
