package ru.yandex.direct.internaltools.core.exception;

import ru.yandex.direct.validation.result.Defect;
import ru.yandex.direct.validation.result.ValidationResult;

/**
 * Ошибка валидации входных параметров внутренних инструментов
 */
public class InternalToolValidationException extends InternalToolException {
    private ValidationResult<?, Defect> validationResult;

    public InternalToolValidationException(String message) {
        super(message);
    }

    public InternalToolValidationException withValidationResult(
            ValidationResult<?, Defect> validationResult) {
        this.validationResult = validationResult;
        return this;
    }

    public ValidationResult<?, Defect> getValidationResult() {
        return validationResult;
    }
}
