package ru.yandex.direct.ansiblejuggler.model.notifications;

import com.fasterxml.jackson.annotation.JsonValue;

public enum NotificationMethod {
    SMS,
    EMAIL,
    /**
     * Уведомление в телеграм от бота. Может быть человеку или в чат.
     *
     * @see <a href=https://docs.yandex-team.ru/juggler/notifications/on_change#telegram>Про телеграм-уведомления</a>
     * @see <a href=https://docs.yandex-team.ru/juggler/notifications/on_change#telegram-humans>Как включить себе</a>
     */
    TELEGRAM;

    @JsonValue
    @Override
    public String toString() {
        return super.toString().toLowerCase();
    }
}
