package ru.yandex.direct.cloud.mdb.mysql.api.transport;

public abstract class AbstractPagedResponse<ElementType> {
    private final ElementType[] elements;
    private final String nextPageToken;

    AbstractPagedResponse(ElementType[] elements, String nextPageToken) {
        this.elements = elements;
        this.nextPageToken = nextPageToken;
    }

    public ElementType[] getElements() {
        return elements;
    }

    public String getNextPageToken() {
        return nextPageToken;
    }
}
