package ru.yandex.direct.communication.facade;

import java.util.Map;

import ru.yandex.direct.communication.container.AdditionalInfoContainer;
import ru.yandex.direct.communication.container.web.CommunicationMessage;
import ru.yandex.direct.communication.model.Slot;
import ru.yandex.direct.core.entity.communication.model.CommunicationEventVersion;

public interface ActionHandler<Result extends ActionResult<Result>> {

    Result confirm(
            Map<Long, ActionTarget> targets,
            AdditionalInfoContainer additionalInfo,
            Slot slot,
            long buttonId,
            Map<Long, CommunicationMessage> messageById,
            Map<Long, CommunicationEventVersion> eventVersionByMessageId);

    /**
     * @return имя действия
     */
    String getName();
}
