package ru.yandex.direct.landlord.client.converter

import java.lang.reflect.Type
import com.google.protobuf.InvalidProtocolBufferException
import maps_adv.geosmb.landlord.proto.internal.landing_details.LandingDetailsOuterClass.ShowLandingDetailsOutput
import org.asynchttpclient.Response
import org.slf4j.LoggerFactory
import ru.yandex.direct.http.smart.converter.ResponseConverter
import ru.yandex.direct.landlord.client.LandlordApiException

class ShowLandingOutputConverter : ResponseConverter<ShowLandingDetailsOutput?> {

    override fun convert(response: Response, responseType: Type): ShowLandingDetailsOutput? {
        return try {
            val errorOrNull = getErrorOrNull(response)
            if (errorOrNull == null) {
                ShowLandingDetailsOutput.parseFrom(response.responseBodyAsByteBuffer)
            } else {
                logger.error("Cannot get landing details: $errorOrNull")
                null
            }
        } catch (e: InvalidProtocolBufferException) {
            throw LandlordApiException("Cannot deserialize response", e)
        }
    }

    companion object {
        private val logger = LoggerFactory.getLogger(ShowLandingOutputConverter::class.java)
    }
}
