package ru.yandex.direct.model.generator.rewrite

import com.squareup.javapoet.ClassName
import ru.yandex.direct.model.generator.rewrite.conf.AttributeConf

/**
 * Specifies a single prop-holder class
 */
data class PropHolderMeta(
    /**
     * Name of a prop-holder class
     */
    val name: ClassName,
    /**
     * Attribute which this prop-holder holds
     */
    val attribute: AttributeConf,
    /**
     * If `true`, this prop-holder is already generated
     */
    val isAlreadyBuilt: Boolean,
)
