package ru.yandex.direct.mysql.ytsync.synchronizator.operation;

import java.util.List;

import ru.yandex.direct.mysql.ytsync.synchronizator.tableprocessors.TableProcessor;

public class YtPendingTransaction {
    private String gtid;
    private List<YtPendingOperation> pendingOperations;

    public YtPendingTransaction(String gtid,
                                List<YtPendingOperation> pendingOperations) {
        this.gtid = gtid;
        this.pendingOperations = pendingOperations;
    }

    public int apply(TableProcessor processor) {
        int count = 0;
        for (YtPendingOperation op : pendingOperations) {
            count += op.apply(processor);
        }
        return count;
    }
}
