package ru.yandex.direct.yasms;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.direct.asynchttp.Result;
import ru.yandex.direct.yasms.model.YaSmsSendSmsResponse;

import static java.util.Collections.emptyMap;

@ParametersAreNonnullByDefault
public class YaSmsClientCommon implements YaSmsClient {

    private final YaSmsClientImpl yaSmsClientImpl;

    public YaSmsClientCommon(YaSmsClientImpl yaSmsClientImpl) {
        this.yaSmsClientImpl = yaSmsClientImpl;
    }

    @Override
    public Result<YaSmsSendSmsResponse> sendSms(Long uid, Long phoneId, String smsText) {
        return yaSmsClientImpl.sendSms(uid, phoneId, smsText, emptyMap());
    }
}
