import { StateSchema } from 'schema/state/StateSchema';

import { mergeStateUI } from 'mutators/mergeStateUI/mergeStateUI';

import { getUIHiddenColumns } from 'selectors/ui/getUIHiddenColumns/getUIHiddenColumns';

export function mergeStateUIHiddenColumns(state: StateSchema, payload: Dict<boolean>): StateSchema {
    let hiddenColumns = getUIHiddenColumns(state);

    return mergeStateUI(state, {
        hiddenColumns: {
            ...hiddenColumns,
            ...payload,
        },
    });
}
