import { StateSchema } from 'schema/state/StateSchema';
import { UIHistoryPanelSchema } from 'schema/ui/UISchema';

import { mergeStateUI } from 'mutators/mergeStateUI/mergeStateUI';

import { getUIHistoryPanel } from 'selectors/ui/getUIHistoryPanel/getUIHistoryPanel';

export function mergeStateUIHistoryPanel(state: StateSchema, payload: Partial<UIHistoryPanelSchema>): StateSchema {
    let panel = getUIHistoryPanel(state);

    return mergeStateUI(state, {
        historyPanel: {
            ...panel,
            ...payload,
        },
    });
}
