import { StateSchema } from 'schema/state/StateSchema';
import { UIViewInfoSchema } from 'schema/ui/UISchema';

import { mergeStateUI } from 'mutators/mergeStateUI/mergeStateUI';

import { getUIViewInfo } from 'selectors/ui/getUIViewInfo/getUIViewInfo';

export function mergeStateUIViewInfo(state: StateSchema, payload: Partial<UIViewInfoSchema>): StateSchema {
    let info = getUIViewInfo(state);

    return mergeStateUI(state, {
        viewInfo: {
            ...info,
            ...payload,
        },
    });
}
