(function($){

    var iModelsManager = BEM.blocks['i-models-manager'];

BEM.DOM.decl('b-phrases-correction-item', {
    onSetMod: {
        'js': function(){
            this.init();
            this.params.isEdit && this.initOnEdit();
         },

        'mode': function(modName, modVal){
            var code = this.getMod('code');

            this.parent.trigger('toggle-correction', [code, arguments[1], arguments[2]]);
            this.params.isEdit && iModelsManager.eachModel(function(id, model){
                model.set(code, modVal == 'on' ? 1 : 0)
            }, 'campaign&banner:*&phrase:*', 'b-phrases-list-phrase');

        }
    },

    /**
     * необходимо только на странице редактирования ставок
     */
    initOnEdit: function() {
        this.campaignModel = BEM.blocks['i-models-manager'].get('campaign',
            this.params.isMediaplan ? 'b-mediaplan-view' : 'b-campaign-view'
        );
        if (this.campaignModel.get('phrases_inited')) {
            this.toggler.map(function(toggler) {
                toggler.delMod('disabled');
            });
        } else {
            this.campaignModel.onFirst('b-phrases-list-models:init', function() {
                this.toggler.map(function(toggler) {
                    toggler.delMod('disabled');
                })

            }, this);
        }

        return this;
    },

    init: function() {
        var _this = this;

        this.toggler = this.findBlocksInside('b-pseudo-link');

        this.toggler && $.map(this.toggler, function(toggler) {
            toggler.on('click', _this._toggle, _this);
        });

        this.parent = this.findBlockOutside('b-phrases-correction');

        return this;
    },

    _toggle: function(e, data){
        this.toggleMod('mode', 'off', 'on');

    }
}, {

});

BEM.DOM.decl('b-phrases-correction', {
    onSetMod: {
        'js': function(){
            /**/
        }
    }
}, {
    live: function(){
        this.liveInitOnBlockInsideInit('b-phrases-correction-item');
    }
});

})(jQuery);

