<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:lego="https://lego.yandex-team.ru"
    xmlns:exsl="http://exslt.org/common"
    extension-element-prefixes=" exsl "
    exclude-result-prefixes=" lego exsl "
    version="1.0">

    <xsl:include href="../../i-popup/i-popup.convert2xml.xsl"/>
    <xsl:include href="../../i-request/i-request.convert2xml.xsl"/>

    <xsl:template match="lego:b-form-input[@lego:autocomplete = 'yes']">
        <lego:declaration>
            <lego:i-jquery>
                <lego:debounce/>
            </lego:i-jquery>
            <xsl:variable name="i-request">
                <lego:i-request lego:type="ajax"/>
            </xsl:variable>
            <xsl:apply-templates select="exsl:node-set($i-request)"/>
            <xsl:variable name="i-popup">
                <lego:i-popup/>
            </xsl:variable>
            <xsl:apply-templates select="exsl:node-set($i-popup)"/>
            <xsl:copy>
                <xsl:copy-of select="*"/>
                <lego:popup>
                    <xsl:copy-of select="lego:popup/@*"/>
                </lego:popup>
                <lego:dataprovider/>
                <xsl:apply-templates/>
            </xsl:copy>
            <lego:b-autocomplete-item lego:type="nav"/>
            <lego:b-autocomplete-item lego:type="nah"/>
        </lego:declaration>
        <xsl:apply-imports/>
    </xsl:template>

</xsl:stylesheet>
