<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:x="http://www.yandex.ru/xscript"
    xmlns:lego="https://lego.yandex-team.ru"
    exclude-result-prefixes=" x lego "
    version="1.0">

<!-- ############################################################################################################## -->

<!-- TODO: делать x:tolower в препроцессе, заменить value-of на apply-templates -->
<xsl:template match="lego:b-head-name">
    <strong>
        <xsl:apply-templates select="." mode="lego:block-attributes"/>
        <xsl:choose>
            <xsl:when test="$lego:params/lego:index">
                <xsl:apply-templates select="." mode="lego:content"/>
            </xsl:when>
            <xsl:otherwise>
                <a class="{lego:name(.)}__link">
                    <xsl:apply-templates select="." mode="lego:url"/>
                    <xsl:apply-templates select="." mode="lego:content"/>
                </a>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:apply-templates select="lego:beta"/>
    </strong>
</xsl:template>

<xsl:template match="lego:b-head-name" mode="lego:url">
    <xsl:attribute name="href">
        <xsl:apply-templates select="." mode="lego:url-content"/>
    </xsl:attribute>
</xsl:template>

<xsl:template match="lego:b-head-name" mode="lego:url-content">/</xsl:template>

<xsl:template match="lego:b-head-name" mode="lego:content">
    <xsl:value-of select="x:tolower(.)"/>
</xsl:template>

<!-- ############################################################################################################## -->

</xsl:stylesheet>
