// Специальные и пустые клавиши кодируются с помощью \u0000
// Специальные клавиши пронумерованы начиная с 1.
Lego.block['b-keyboard'].lang.tr = {
    id: 'tr',
    label: 'Türkçe',
    normal: {
        keys:   '\u0060' + // `
                '\u0031' + // 1
                '\u0032' + // 2
                '\u0033' + // 3
                '\u0034' + // 4
                '\u0035' + // 5
                '\u0036' + // 6
                '\u0037' + // 7
                '\u0038' + // 8
                '\u0039' + // 9
                '\u0030' + // 0
                '\u002d' + // -
                '\u003d' + // =
                '\u0000' + // backspace
                '\u0040' + // @
                '\u0071' + // q
                '\u0077' + // w
                '\u0065' + // e
                '\u0072' + // r
                '\u0074' + // t
                '\u0079' + // y
                '\u0075' + // u
                '\u0131' + // ı
                '\u006f' + // o
                '\u0070' + // p
                '\u011f' + // ğ
                '\u00fc' + // ü
                '\u2303' + // ⌃
                '\u005c' + // \
                '\u0000' + // capslock
                '\u0061' + // a
                '\u0073' + // s
                '\u0064' + // d
                '\u0066' + // f
                '\u0067' + // g
                '\u0068' + // h
                '\u006a' + // j
                '\u006b' + // k
                '\u006c' + // l
                '\u015f' + // ş
                '\u0069' + // i
                '\u0021' + // !
                '\u0000' + // enter
                '\u000a' + // shift
                '\u007a' + // z
                '\u0078' + // x
                '\u0063' + // c
                '\u0076' + // v
                '\u0062' + // b
                '\u006e' + // n
                '\u006d' + // m
                '\u00f6' + // ö
                '\u00e7' + // ç
                '\u002c' + // ,
                '\u002e' + // .
                '\u0000', // shift
        specialKeys : {
            '14': {type: 'backspace', label: '\u2190'},
            '15': {type: 'atmark', label: '\u0040'},
            '28': {type: 'accent_mod', label: '\u005e'}, // '\u2303' is not supported on Win systems
            '30': {type: 'capslock', label: 'capslock'},
            '43': {type: 'enter', label: 'enter'},
            '44': {type: 'lshift', label: 'shift'},
            '56': {type: 'rshift', label: 'shift'}
        },
        accents : {
            mod : {
                15 : { type: '@', label: '\u0040'},
                22 : { type: 'u', label: '\u00fb'},
                24 : { type: 'o', label: '\u00f4'},
                31 : { type: 'a', label: '\u00e2'},
                41 : { type: 'i', label: '\u00ee'}
            }
        }
    },
    shift: {
        keys:   '\u007e' + // ~
                '\u0021' + // !
                '\u0040' + // @
                '\u0023' + // #
                '\u0024' + // $
                '\u0025' + // %
                '\u005e' + // ^
                '\u0026' + // &
                '\u002a' + // *
                '\u0028' + // (
                '\u0029' + // )
                '\u005f' + // _
                '\u002b' + // +
                '\u0000' + // backspace
                '\u0040' + // @
                '\u0051' + // Q
                '\u0057' + // W
                '\u0045' + // E
                '\u0052' + // R
                '\u0054' + // T
                '\u0059' + // Y
                '\u0055' + // U
                '\u0049' + // I
                '\u004f' + // O
                '\u0050' + // P
                '\u011e' + // Ğ
                '\u00dc' + // Ü
                '\u2303' + // ⌃
                '\u005c' + // \
                '\u0000' + // capslock
                '\u0041' + // A
                '\u0053' + // S
                '\u0044' + // D
                '\u0046' + // F
                '\u0047' + // G
                '\u0048' + // H
                '\u004a' + // J
                '\u004b' + // K
                '\u004c' + // L
                '\u015e' + // Ş
                '\u0130' + // İ
                '\u003f' + // ?
                '\u0000' + // enter
                '\u000a' + // shift
                '\u005a' + // Z
                '\u0058' + // X
                '\u0043' + // C
                '\u0056' + // V
                '\u0042' + // B
                '\u004e' + // N
                '\u004d' + // M
                '\u00d6' + // Ö
                '\u00c7' + // Ç
                '\u003b' + // ;
                '\u003a' + // :
                '\u0000', // shift
        specialKeys : {
            '14': {type: 'backspace', label: '\u2190'},
            '15': {type: 'atmark', label: '\u0040'},
            '28': {type: 'accent_mod', label: '\u005e'},
            '30': {type: 'capslock', label: 'capslock'},
            '43': {type: 'enter', label: 'enter'},
            '44': {type: 'lshift', label: 'shift'},
            '56': {type: 'rshift', label: 'shift'}
        },
        accents : {
            mod : {
                15 : { type: '@', label: '\u0040'},
                22 : { type: 'U', label: '\u00db'},
                24 : { type: 'O', label: '\u00d4'},
                31 : { type: 'A', label: '\u00c2'},
                41 : { type: 'I', label: '\u00ce'}
            }
        }
    },
    alt: {
        keys:   '\u00b0' + // градус
                '\u00b1' + // ±
                '\u00bc' + // 1/4
                '\u00bd' + // 1/2
                '\u00be' + // 3/4
                '\u00a4' + // квадрат
                '\u00ac' + // приставка
                '\u00b2' + // 2
                '\u00b3' + // 3
                '\u00a2' + // c/
                '\u20ac' + // евро
                '\u00a3' + // фунт
                '\u03bc' + // мю
                '\u0000' + // backspace
                '\u0040' + // @
                '\u007e' + // ~
                '\u00a7' + // §
                '\u00b6' + // перенос
                '\u003a' + // :
                '\u003b' + // ;
                '\u0000' + //
                '\u0027' + // '
                '\u0022' + // "
                '\u00ab' + // ёлка
                '\u00bb' + // ёлка2
                '\u005b' + // [
                '\u005d' + // ]
                '\u007b' + // {
                '\u007d' + // }
                '\u0000' + // capslock
                '\u0000\u0000\u0000\u0000' + //
                '\u2018' + // '
                '\u2019' + // '
                '\u201e' + // "
                '\u201c' + // "
                '\u201d' + // "
                '\u0000' + //
                '\u0021' + // !
                '\u003f' + // ?
                '\u0000' + // enter
                '\u000a' + // shift
                '\u0000\u0000\u0000\u0000' + //
                '\u003c' + // <
                '\u003e' + // >
                '\u2013' + // -
                '\u2014' + // —
                '\u005c' + // \
                '\u007c' + // |
                '\u002f' + // /
                '\u0000' // shift
    },
    specialKeys: {
        '14': {type: 'backspace', label: '\u2190'},
        '15': {type: 'atmark', label: '\u0040'},
        '30': {type: 'capslock', label: 'capslock'},
        '43': {type: 'enter', label: 'enter'},
        '44': {type: 'lshift', label: 'shift'},
        '56': {type: 'rshift', label: 'shift'}
    }
};
