<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:x="http://www.yandex.ru/xscript"
    xmlns:lego="https://lego.yandex-team.ru"
    exclude-result-prefixes=" x lego "
    version="1.0">

<!-- ############################################################################################################## -->

<xsl:template match="lego:b-share-wrap">
    <xsl:if test="not(@lego:local = 'yes')">
        <xsl:call-template name="lego:js">
            <xsl:with-param name="js" select="'//yastatic.net/share/share.js'"/>
        </xsl:call-template>
    </xsl:if>
    <div>
        <xsl:apply-templates select="." mode="lego:block-attributes"/>
        <xsl:apply-templates select="." mode="lego:auto-id"/>
    </div>
    <xsl:variable name="share">
        <xsl:text>Ya.share['</xsl:text>
        <xsl:apply-templates select="." mode="lego:auto-id-content"/>
        <xsl:text>']</xsl:text>
    </xsl:variable>
    <xsl:call-template name="lego:js-inline">
        <xsl:with-param name="js">
            <xsl:value-of select="$share"/>
            <xsl:text>=</xsl:text>
            <xsl:value-of select="."/>
            <xsl:text>;</xsl:text>
            <xsl:value-of select="$share"/>
            <xsl:text>.elementID='</xsl:text>
            <xsl:apply-templates select="." mode="lego:auto-id-content"/>
            <xsl:text>';Ya.share(</xsl:text>
            <xsl:value-of select="$share"/>
            <xsl:text>);</xsl:text>
        </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--xsl:template match="/" mode="lego:js-include">
    <xsl:apply-imports/>
    <xsl:call-template name="lego:js">
        <xsl:with-param name="js" select="'//yastatic.net/share/share.js'"/>
    </xsl:call-template>
</xsl:template-->

<!-- ############################################################################################################## -->

</xsl:stylesheet>
