r107276
# Блок отображает выставленные в модерации флаги предупреждений и дает возможность их изменить

####Логика
Блок фильтрует ключи в объекте `value` основываясь на объект `u.consts('AD_WARNINGS')` (отсеивает отсутствующие там ключи, и присутствующие с пометкой `is_common_warn` - общий флаг, не влияющий на другие)
Если флагов предупреждений не выставлено - то добавить их нельзя, не смотря на объект `can` (права) во входных данных
Все возможные значение в `value`, кроме детского питания (`baby_food`), булевы. В детском питании можно выбирать возраст, поэтому он строится отдельным элементом `__baby_food`
Каждое изменение сразу сохраняется на сервере и триггерит событие `flags-change`, которое уже слушает родительский блок `b-banner-preview2`.

###Ответственный###
[cyn](https://staff.yandex-team.ru/cyn)

####Пример
```javascript
{
    block: 'b-banner-adv-alert2',
    value: { // Текущее значение
        age: '12', // это значение будет отсеяно, т.к. !!u.consts('AD_WARNINGS').age.is_common_warn === true
        baby_food: '10'
    },
    can: { // Возможности пользователя
        addRemove: true, // Добавлять или удалять предупреждения
        edit: true // Редактировать выставленные флаги
    }
}
```
