BEM.DOM.decl({ block: 'b-banner-preview2', modName: 'view', modVal: 'search-desktop' }, {

    /**
     * Возвращает объект зависимостей элементов от входных данных
     * Слева название элемента, справа поля view-модели от которых зависит элемент
     * @returns {Object}
     * @private
     */
    _getElemsDepends: function() {
        return {
            title: ['title', 'body', 'url', 'domain', 'vcard', 'phrase', 'titleExt'],
            body: ['title', 'titleExt', 'body', 'phrase'],
            favicon: ['url'],
            rating: ['rating'],
            domain: ['domain', 'vcard', 'displayHref'],
            'v-card': ['vcard'],
            phone: ['phone', 'country_code', 'city_code', 'ext', 'vcard'],
            worktime: ['worktime', 'vcard'],
            callouts: ['callouts'],
            sitelinks: ['sitelinks'],
            metro: [
                'metro',
                'vcard',
                'worktime',
                'city',
                'callouts',
                'phone',
                'country_code',
                'city_code',
                'ext',
                'vcard'
            ],
            city: [
                'city',
                'vcard',
                'worktime',
                'metro',
                'callouts',
                'phone',
                'country_code',
                'city_code',
                'ext',
                'vcard'
            ],
            flags: ['flagsSettings', 'flags', 'bid', 'flagsEditable'],
            'flag-age': ['flagsSettings', 'flags', 'bid']
        };
    }

});
