BEM.DOM.decl({
    block: 'b-chart-filter-control'
}, {

    _initEvents: function() {
        this._subscribe = BEM.create('i-subscription-manager');
    },

    /**
     * Вызывается при изменении фильтра
     * @param {Event} e - событие
     * @param {FilterData.data} data - данные фильтра
     * @private
     */
    _onChange: function(e, data) {
        // будет переопределен в модификаторе
    },

    /**
     * Проверяет выключен ли элемент
     * @private
     */
    _isDisabled: function() {
        // будет переопределен в модификаторе
    },

    /**
     * Возвращает значние фильтра
     * @return {null}
     */
    getValue: function() {
        // будет переопределен в модификаторе
        return null;
    },

    /**
     * Выставляет значение фильтра
     * @param {Array<String>} values - массив значений
     */
    setValue: function(values) {
        // будет переопределен в модификаторе
    },

    /**
     * Включает фильтр
     */
    enable: function() {
        // будет переопределен в модификаторе
    },

    /**
     * Выключает фильтр
     */
    disable: function() {
        // будет переопределен в модификаторе
    },

    /**
     * Включает опции
     * @param {Array<String>} options - массив идентификаторов опций (value)
     */
    enableOptions: function(options) {
        // будет переопределен в модификаторе
    },

    /**
     * Вылючает опции
     * @param {Array<String>} options - массив идентификаторов опций (value)
     */
    disableOptions: function(options) {
        // будет переопределен в модификаторе
    },

    /**
     * Возвращает блок фильтра
     * @return {*|BEM}
     */
    getFilterBlock: function() {
        // будет переопределен в модификаторе
    }

});
