block('b-edit-group-2').elem('rename-group').def()(function() {
    var group = this.group,
        modelParams = {
            id: group.modelId,
            name: this.ctx.modelName || this.groupModelName
        },
        headerType = this.ctx.headerType;

    return {
        attrs: {
            row: { 'data-err-path': this.ctx.errPath }
        },
        mixes: {
            row: [
                {
                    block: 'b-edit-group-2',
                    elem: 'rename-group',
                    elemMods: { single: group.isSingleGroup ? 'yes' : '' }
                },
                {
                    block: 'b-edit-group-header',
                    mods: {
                        type: headerType,
                        'show-inner-row': (group.adgroup_id && !group.isCopyGroup) ? 'yes' : undefined
                    },
                    js: {
                        modelParams: modelParams,
                        banners_quantity: group.banners_quantity
                    }
                }
            ]
        },

        label: {
            block: 'b-edit-group-header',
            attrs: {
                id: 'Group-' + this.group.modelId
            },
            elem: 'label'
        },
        control: [
            {
                block: 'b-edit-group-header',
                elem: 'control',
                inputMix: {
                    block: 'b-errors-presenter2',
                    elem: 'cleaner',
                    js: { block: 'input' }
                },
                group_name: group.group_name,
                groupNumber: group.adgroup_id,
                errorsPrettyMessage: {
                    block: 'b-error-pretty-message',
                    js: true,
                    mods: { theme: 'classic' },
                    mix: { block: 'b-edit-group-2', elem: 'pretty-errors-message' }
                }
            }
        ],
        info: [
            //не создание группы и не копирование одной группы
            !this.isNewGroup && !group.isCopyGroup && {
                block: 'b-edit-group-header',

                elem: 'info',
                text: (function() {
                    var currNum = group.isCopyGroup ?
                        group.banners.length :
                        group.banners.filter(function(banner) {
                            //при копировании нескольких групп нам не надо фильтровать баннеры с нулевыми id
                            return !banner.isNewBanner;
                        }).length,
                        totalNum = group.banners_quantity;

                    return u['b-edit-group-header'].getInfoContentText(currNum, totalNum, headerType);
                })()
            },
            //только для создания новой группы
            group.isSingleGroup && !group.adgroup_id && {
                block: 'b-edit-group-2',
                elem: 'help-text',
                content: this.ctx.helpText || iget2(
                    'b-edit-group-2',
                    'v-gruppe-vy-mozhete',
                    'В группе вы можете создать одно или несколько объявлений с общим набором ключевых фраз и едиными условиями показа.'
                )
            }

        ]
    };
});
