# Блок редактирования группы баннеров #

## Требования к модификаторам блока ##
В шаблоне строки которую можно удалить должен присутствовать микс: `b-edit-group__banner-row_banner-id_<id>`.  

Каждый модификатор должен реализовывать 2 метода:  
`_getAvailableToCreateBannersCount` - возвращает количество баннеров, которые можно добавить в группу;  
`getEditBlockBemjson` - возвращает BEMJSON блока с баннером для добавления.  

Инициализация специфичных для типа группы блоков должна происходить в `*additionalInit`.

## Требования к модификаторам `b-edit-banner2` ##

При удалении должны триггерить событие `remove`.  
При необходимости добавить несколько баннеров должны триггерить `new:banners:needed`.  

## Добавление ##

Кнопка добаления во всех группах - `b-edit-banner-add2`, при ее нажатии вызывается `_onBannerAddRequest`.  
По умолчанию в `_onBannerAddRequest` через `_getNewBannerModel()` создается модель и вызывает `_addBanner`.  
`_addBanner` вызывает:  
  - `_onBeforeBannerAdd` - тут можно, например, обновить количество баннеров в группе, если оно отслеживается отдельно от моделей баннеров;
  - `_updateBannersCount` (обновляет отображаемое количество баннеров, которые можно добавить и пробрасывает это знание во внутренние блоки через `_updateCountInBlocks`); 
  - строит по модели DOM строки (`_buildBannerRow`) и добавляет в контейнер списка (`_getBannersListContainer`);
  - `_onAfterBannerAdd` - тут можно выполнить манипуляции с новосозданным `b-edit-banner2, например, пробросить медиа-ресурсы.

## Удаление ##

- `b-edit-banner-add2` триггерит `remove`;
- вызывается `_onBeforeBannerRemove`;
- вызывается `_updateBannersCount`;
- из DOM удаляется строка.


## Мейнтенеры ##
@alkaline
