r102931
#b-feeds-list#

##Описание##
Блок отображения списка фидов.

При вставке на страницу после инициализации отправляет запрос к серверу для получения списка фидов и обновляет свое содержимое.

###Автор### 
[coffeeich](https://staff.yandex-team.ru/coffeeich)
[eemelin](https://staff.yandex-team.ru/eemelin)

###Где используется###
Используется как основной блок page-блока `p-manage-feeds`. 

###Модели###
Содержимое блока регулируется состоянием его view-модели, которая в свою очередь использует в качестве источника данных
модель данных, способную запрашивать с сервера список фидов. Процесс удаления view-модель так же делегирует модели данных.
    
* `dm-feed-list` - модель с данными списка фидов
* `b-feeds-list.vm` - view-модель списка фидов

##Пример##

BEMHTML:

```
    
    {
        block: 'b-feeds-list'
    }
```

JS:

```

    var block = ...
    
    // переключится на вторую страницу: запрос к серверу через DM и перерисовка
    block.model.set('page', 2);
    
    // поискать что то на второй странице
    block.model.set('search', 'some feed');
    
    // умеет открывать попап добавления фида с привязкой попапа на указанный блок, например, кнопки
    block.openFeedEditPopup(button);
```
