# Блок b-hintable-popup

###Автор###
[grimfrid](https://staff.yandex-team.ru/grimfrid)

## Описание
При нажатии на DOM элемент блока показывает подсказку, которая указывается в параметре hint блока,
либо определяется через публичный метод блока setHintContent. (тоже самое что и b-hintable, только показывает
попап с крестиком и при нажатии, так же позволяет задать направление и миксы для popup )

Блок предназначен для использования как микс к другому блоку.
При подключении блока в шаблоне - обязательно указать js: true, для его инициализации.

## Параметры js

### hint
В параметр hint можно передать содержимое подсказки

### directions
Определение направления показа подсказки (передается в popup), по умолчанию ['right', 'left', 'bottom', 'top']

### onScroll
В параметр onScroll можно передать значение 'close'(передается в popup)
Модификатор on-scroll: 'close' в popup скрывает его при scroll

### mixPopup
миксы для popup (передаются в блок popup)

## Публичные методы

Блок имеет публичный метод setHintContent(content), который устанавливает новый текст подсказки,
в соответсвии с переданным в функцию параметром

## Примеры использования

### Без предустановленной подсказки
```
{
    block: 'oneCoolBlock',
    mix: {
       {
           block: 'b-hintable-popup',
           js: true
       }
    }
}
```

### С предустановленной подсказки
```
{
    block: 'oneCoolBlock',
    elem: 'hisElem',
    mix: {
       {
           block: 'b-hintable-popup',
           js: {
               hint: 'Я подсказка'
           }
       }
    }
}
```
