#b-infoblock#

##Описание##
Блок инфоблока для показа пользователю различных уведомлений-событий (тизеры, новости)

###Автор###
[coffeeich](https://staff.yandex-team.ru/coffeeich)
[a-urukov](https://staff.yandex-team.ru/a-urukov)
[anyakey](https://staff.yandex-team.ru/anyakey)

###Где используется###
В шапке на всех BEMHTML страницах кроме Морды

###Модели###

* `m-infoblock-news` - view-модель с информацией о новости
* `m-infoblock-state` - view-модель состояния инфоблока

##Roadmap & known issues##

Задача на рефакторинг: https://st.yandex-team.ru/DIRECT-64863

Требуется избавиться от сильной связности списка моделей новости/тизера в модели состояния инфоблока, так как это
мешает разделить тесты на более атомарные (сейчас тесты инфоьлока включают в себя тесты на его внутренние блоки)

* нужно перенести транспортный код из `i-infoblock.js` в `b-infoblock.utils.js`
* требуется перенести модель `m-infoblock-state.js` в `b-infoblock.vm.js`
* вместо `models-list` поля `news` использовать поля со списками идентификаторов новостей/тизеров (нужно
сохранить логику удаления этих идентификаторов по аналогии с тем, как сейчас удаляются устаревшие модели)
* разгрузить тесты (в `b-infoblock.test.js` описаны тесты на новости и тизеры, которые надо перенести в соответствующие блоки)

##Пример##

```

    {
        block: 'b-infoblock',
        newsUrl: '/path/to/news/archive/',
        uid: uid, // uid пользователя
        euid: euid // uid пользователя или супера
    }
```

##Как добавить новый тизер##
Смотрите в ``b-teaser.md``
