Блок Яндекс.Метрика2
--------------------

Собирает информацию о достижении цели и параметрах визита
  
**Терминология**
- `метрика` - блок b-metrika
- `блок с метрикой` - блок, на который устанавливается метрика
- `достижение цели` - генерация `блоком с метрикой` ожидаемого `метрикой`, события
- `параметры визита` - генерация `блоком с метрикой` ожидаемого `метрикой`, события



**Использование**
mix с блоком, на котором будем отслеживать событие достижение цели
при миксе нужно передать параметры.
Блок, на котором миксуем, должен тригерить отслеживаемые `БЕМ` события
(подписка методом `on`)
Подписка на `DOM` события(методом `bindTo`) - не подойдет.
 
 

 
**Описание параметров**  

**I вариант. Для одного отслеживаемого события** 
 
```
js: {
    event: {String}         Название события, например, click
                            также можно подписаться на событие изменения модификатора блока
                            
    target: {String}        Название цели для метрики
    [targetParams: {*}]     Параметры визита, передаваемые на сервер при достижении цели. 
                            Если не используется target, targetParams нигде использоватся не будет 
    
    params: {Object}        Параметры визита
    
    [blockName: {String}]   Название блока, который будет тригеррить события
                            блок должет быть на одной DOM ноде с b-metrika
                            поиск блока методом findBlockOn
                            
    [counter: {String}],    id счетчика метрики  
    }
```
> если указано свойство target, данные отправятся через метод ```reachGoal``` объекта счетчика метрики
> если указано свойство params, данные отправятся через метод ``` params```
> можно указывать target и params одновременно - данные будут отправлены в метрику через оба метода



**II вариант. Для 2-х и более отслеживаемых событии**  

```
  js: {
        items: {Array}          Массив объектов из вариант I
        [blockName: {String}]   Название блока, если все события будет тригеррить один блок
```







> ментейнер
>[johnson](https://staff.yandex-team.ru/johnson)
>
>ссылки на используемыем методы яндекс метрики
>[reachGoal](https://yandex.ru/support/metrika/objects/reachgoal.xml)
>[params](https://yandex.ru/support/metrika/objects/params-method.xml)  
