u.register({

    'dm-mcbanner-group': {

        /**
         * Преобразовывает серверные данные группы в модельные
         * @param {Object} options
         * @param {Object} options.group
         * @param {Array} options.campaignTags
         * @returns {*}
         */
        transformData: function(options) {
            var group = options.group,
                campaignTags = options.campaignTags;

            // cyn@TODO: DIRECT-45870: унести на серверсайд
            // TODO: mcbanner?
            group.adgroup_type === 'base' && (group.adgroup_type = 'text');

            var data = [
                'modelId',
                'isBidable',
                'adgroup_id',
                'banners_quantity',
                'group_banners_types',
                'banners_arch_quantity',
                'edit_banners_quantity',
                'has_general_limit_price',
                'cid',
                'is_camp_archived',
                'new_phrases',
                'bannersCount',
                'minus_words',
                'shownBids',
                'group_name',
                'isBannersEditable',
                'showNewBanners',
                'newGroupIndex',
                'isNewGroup',
                'isCopyGroup',
                'isSingleGroup',
                'adgroup_type',
                'statusMetricaStop',
                'statusModerate'
            ].reduce(function(data, name) {
                data[name] = group[name];

                return data;
            }, {});

            if (!data.group_name) data.group_name = iget2('dm-mcbanner-group', 'novaya-gruppa-bannerov', 'Новая группа баннеров');

            //по пришедшим id тегов строим полный массив данных
            if (group.tags && !u._.isArray(group.tags)) {
                data.tags = Object.keys(group.tags).map(function(id) {
                    var cTag = (campaignTags || [])
                        .filter(function(tag) {
                            return tag.id == id;
                        })
                        .pop();

                    return {
                        id: id,
                        value: cTag && cTag.value
                    };
                });
            }

            data.banners = u._.isArray(group.banners) ?
                group.banners.map(function(banner) {
                    return u['dm-mcbanner-group'].transformBannerData({
                        banner: banner,
                        group: group
                    });
                }) :
                [
                    u['dm-mcbanner-group'].transformBannerData({
                        banner: group,
                        group: group
                    })
                ];

            data.phrasesIds = group.phrases ?
                group.phrases.map(function(phrase) {
                    return phrase.modelId;
                }, this) :
                [];

            return data;
        },

        /**
         * Преобразовывает серверные данные баннера в модельные
         * @param {Object} options
         * @param {Object} options.banner
         * @param {Object} options.group
         * @returns {*}
         */
        transformBannerData: function(options) {
            // DIRECT-39276, DIRECT-49050: statusModerate - поле группы, но оно нужно для блока b-banner-status,
            // подобная логике есть в предобработке данных для баннеров/групп i-banners-group-data.bemtree.xjst
            options.banner.groupStatusModerate = options.group.statusModerate;

            // DIRECT-61150 если с сервера не приходит протокол, пытаемся взять из href
            options.banner.url_protocol || (options.banner.url_protocol = u.getUrlProtocol(options.banner.href));

            return u.bannerModelData({
                banner: u.bannerData({
                    banner: options.banner
                }),
                group: options.group,
                loadVCardFromClient: false
            });
        }

    }

});
