block('i-const')(

    def()(function() {
        var data = {};

        function extendConst(opts) {
            for (var name in opts) {
                data[name] = opts[name];
            }
        }

        apply('extendConsts', {
            extendConsts: extendConst
        });

        return data;
    }),

    mod('type', 'dump').def()(function() {
        var publicData,
            iGlobal = this['i-global'];

        publicData = Object.keys(iGlobal)
            .reduce(function(publicData, key) {
                var isPublic = apply('public-params', {
                    name: key
                });

                if (isPublic) {
                    publicData[key] = iGlobal[key];
                }

                return publicData;
            }.bind(this), {});

        return 'window.PAGECONSTS = ' + safeStringify(publicData) + ';';
    }),

    mode('extendConsts')(function() {
        return {};
    }),

    mode('public-params')(false));
