(function() {

    var PAGE_FILTER = /^showCampMultiEdit|addBannerMultiEdit|gobackMultiEdit|addBannerMultiEdit/,
        INLINE_SCRIPTS = [
            'borschik:include:../../node_modules/@yandex-int/rum-counter/dist/inline/interface.min.js',
            'borschik:include:../../node_modules/@yandex-int/rum-counter/dist/inline/io.min.js',
            'borschik:include:../../node_modules/@yandex-int/rum-counter/dist/inline/longtask.min.js',
            'borschik:include:../../node_modules/@yandex-int/rum-counter/dist/bundle/send.min.js'
        ];

    u.register({
        'i-rum-timing': function(isIndex, cmd, reqid, region, isDna, ab_boxes, isProd, operatorUid, tld, context) {
            var pageId,
                rumSettings,
                rumVars;

            pageId = isIndex ? 629 : 861;
            cmd === 'showCamp' && (pageId = 1193); // camp
            cmd === 'showCamps' && (pageId = 1191); // campslist
            cmd === 'apiCertificationRequestsByDate' && (pageId = '1096.3638.3639.355');
            cmd === 'apiCertificationSearchRequest' && (pageId = '1096.3638.153.3639');
            cmd === 'adminPageAg' && (pageId = '3048.143.3641');
            cmd === 'showAgReps' && (pageId = '487.3641.3642');
            cmd === 'ajaxBindingPaymentError' && (pageId = '1201.3643.2348.1030');
            cmd === 'apiCertificationAddRequest' && (pageId = '1096.3638.160.3639');
            cmd === 'apiCertificationEditRequest' && (pageId = '1096.3638.2818.3639');
            cmd === 'apiCertificationUpgradeRequest' && (pageId = '1096.3638.3644.3639');
            cmd === 'apiCertificationShowRequest' && (pageId = '1096.3638.3644.3639');
            cmd === 'apiCertificationGetHistory' && (pageId = '1096.3638.3234.2735');
            cmd === 'apiSettings' && (pageId = '1096.1137');
            cmd === 'saveApiSettings' && (pageId = '691.1096.1137');
            cmd === 'apiApplicationList' && (pageId = '1096.3646.436');
            cmd === 'apiCertificationRequestList' && (pageId = '1096.3638.3639.436');
            cmd === 'apiFinanceSettings' && (pageId = '1096.3283.1137');
            cmd === 'saveApiFinanceSettings' && (pageId = '691.1096.3283.1137');
            cmd === 'dropFinanceOpsCounter' && (pageId = '3647.3283.3648.2566');
            cmd === 'dropMasterToken' && (pageId = '3647.1477.3649');
            cmd === 'apiSandboxSettings' && (pageId = '1096.3030.1137');
            cmd === 'initSandboxUser' && (pageId = '1309.3030.538');
            cmd === 'dropSandboxUser' && (pageId = '3647.3030.538');
            cmd === 'dropSandboxFinanceOpsCounter' && (pageId = '3647.3030.3283.3648.2566');
            cmd === 'getMasterToken' && (pageId = '3234.1477.3649');
            cmd === 'autopaySettings' && (pageId = '3650.1137');
            cmd === 'searchBanners' && (pageId = '153.159');
            cmd === 'ajaxBindingPaymentResponse' && (pageId = '1201.3643.2348.3651');
            cmd === 'orderCampaignOptimizing' && (pageId = '926.3652.3653');
            cmd === 'sendCampaignOptimizingEmail' && (pageId = '2574.3652.3653.1267');
            cmd === 'editCamp' && (pageId = '2818.1193');
            cmd === 'saveCamp' && (pageId = '691.1193');
            cmd === 'saveNewCamp' && (pageId = '691.228.1193');
            cmd === 'showCampSettings' && (pageId = '487.1193.1137');
            cmd === 'showCampStat' && (pageId = '487.1193.989');
            cmd === 'showStat' && (pageId = '487.989');
            cmd === 'showCampStatOfflineMessage' && (pageId = '487.1193.989.2470.1304');
            cmd === 'showSubClientCamps' && (pageId = '487.3654.2989.3655');
            cmd === 'showRegisterLoginPage' && (pageId = '487.727.290.143');
            cmd === 'showClReps' && (pageId = '487.2187.3642');
            cmd === 'clientWallet' && (pageId = '2989.3656');
            cmd === 'showClients' && (pageId = '487.3046');
            cmd === 'showArchClient' && (pageId = '487.3657.2989');
            cmd === 'error' && (pageId = '1030');
            cmd === 'showCompetitors' && (pageId = '487.3658');
            cmd === 'createLogin' && (pageId = '3237.290');
            cmd === 'showBlockedDomainsTitles' && (pageId = '487.3659.3582.3660');
            cmd === 'dnaSaveSuccess' && (pageId = '3200.691.2052');
            cmd === 'showCreatives' && (pageId = '487.3661');
            cmd === 'editCampaignTags' && (pageId = '2818.3652.2092');
            cmd === 'saveCampaignTags' && (pageId = '691.3652.2092');
            cmd === 'editVCard' && (pageId = '2818.975');
            cmd === 'errorPage' && (pageId = '1030.143');
            cmd === 'showFeedHistory' && (pageId = '487.3003.2735');
            cmd === 'findUsersByDomain' && (pageId = '3662.3585.2481');
            cmd === 'listWarnPlace' && (pageId = '436.3663.31');
            cmd === 'manageClientsOfAgency' && (pageId = '3318.3046.3664.3640');
            cmd === 'showFeeds' && (pageId = '487.3665');
            cmd === 'manageSurveys' && (pageId = '3318.3666');
            cmd === 'manageVCards' && (pageId = '3318.975');
            cmd === 'showManagerMyClients' && (pageId = '487.3667.2189.3046');
            cmd === 'massBlockUsers' && (pageId = '3668.2314.3585');
            cmd === 'modifyUser' && (pageId = '3670.538');
            cmd === 'showRegisterLoginPage' && (pageId = '487.727.290.143');
            cmd === 'addAgRep' && (pageId = '160.3641.3671');
            cmd === 'stepZero' && (pageId = '3672.1485');
            cmd === 'addClRep' && (pageId = '160.2187.3671');
            cmd === 'getOfficeContacts' && (pageId = '3234.3673.1802');
            cmd === 'showAgencyOfflineReports' && (pageId = '487.3640.3673.3381');
            cmd === 'listOfflineReports' && (pageId = '436.3673.3381');
            cmd === 'orderCamp' && (pageId = '926.1193');
            cmd === 'pay' && (pageId = '3674');
            cmd === 'showPddError' && (pageId = '487.3592.1030');
            cmd === 'newClientPotentialReport' && (pageId = '228.2989.3675.3254');
            cmd === 'proveNewAgencyClients' && (pageId = '3676.228.3640.3046');
            cmd === 'showDiag' && (pageId = '487.3677');
            cmd === 'showRetargetingCond' && (pageId = '487.3678.3679');
            cmd === 'showSearchPage' && (pageId = '487.153.143');
            cmd === 'search' && (pageId = '143');
            cmd === 'agSearch' && (pageId = '3641.143');
            cmd === 'showExperiments' && (pageId = '487.3680');
            cmd === 'showTurboLandings' && (pageId = '487.2719.3681');
            cmd === 'newPdfReport' && (pageId = '228.3213.3254');
            cmd === 'switchClChief' && (pageId = '1387.2187.3682');
            cmd === 'transfer' && (pageId = '1574');
            cmd === 'transferStepZero' && (pageId = '1574.3672.1485');
            cmd === 'showUploadModerationDocs' && (pageId = '487.3683.3684.3685');
            cmd === 'uploadModerationDocs' && (pageId = '3683.3684.3685');
            cmd === 'userSettings' && (pageId = '538.1137');
            cmd === 'showContactInfo' && (pageId = '487.3289.1275');
            cmd === 'chooseCountryCurrency' && (pageId = '2333.219.1982');
            cmd === 'importCampXLS' && (pageId = '3590.1193.3216');
            cmd === 'importCampSuccess' && (pageId = '3590.1193.2052');
            cmd === 'showExportedXlsList' && (pageId = '487.3686.3216.436');
            cmd === 'yaDirect_setUp_service' && (pageId = '3687');
            cmd === 'showCampsYaMoney' && (pageId = '487.3655.3688.1052');
            cmd === 'addAdGroupsCpmBanner' && (pageId = '160.1.1360.3689.1599');
            cmd === 'editAdGroupsCpmBanner' && (pageId = '2818.1.1360.3689.1599');
            cmd === 'copyAdGroupsCpmBanner' && (pageId = '1276.1.1360.3689.1599');
            cmd === 'addDynamicAdGroups' && (pageId = '160.876.1.1360');
            cmd === 'editDynamicAdGroups' && (pageId = '2818.876.1.1360');
            cmd === 'addAdGroupsPerformance' && (pageId = '160.1.1360.3690');
            cmd === 'editAdGroupsPerformance' && (pageId = '2818.1.1360.3690');
            cmd === 'addMediaAdGroups' && (pageId = '160.2528.1.1360');
            cmd === 'saveMediaAdGroups' && (pageId = '691.2528.1.1360');
            cmd === 'editMediaAdGroups' && (pageId = '2818.2528.1.1360');
            cmd === 'copyMediaAdGroups' && (pageId = '1276.2528.1.1360');
            cmd === 'addAdGroupsMobileContent' && (pageId = '160.1.1360.1006.2103');
            cmd === 'editAdGroupsMobileContent' && (pageId = '2818.1.1360.1006.2103');
            cmd === 'showCampMultiEdit' && (pageId = '487.1193.1192');
            cmd === 'addBannerMultiEdit' && (pageId = '160.1599.1192');
            cmd === 'gobackMultiEdit' && (pageId = '3693.1192');
            cmd === 'bannersMultiSave' && (pageId = '1599.1192');
            cmd === 'parallelLimit' && (pageId = '419.3694');
            cmd === 'errorRbac' && (pageId = '1030.3695');
            cmd === 'retryLater' && (pageId = '3545.3696');
            cmd === 'showQuestion' && (pageId = '487.244');

            var isMobile = u.consts('isMobile'),
                isTablet = u.consts('isTablet');

            if (isDna && (isMobile || isTablet)) {
                pageId = '3200.584';
            } else if (isDna) {
                pageId = '3200';
            }

            rumSettings = {
                reqid: reqid,
                slots: ab_boxes || [],
                clck: 'https://yandex.ru/clck/click',
                sendClientUa: true,
                sendBeforeBemInited: true,
                sendUrlInResTiming: true,
                sendAutoResTiming: true,
                sendFirstRaf: true,
                sendAutoElementTiming: true,
                scrollMetric: true,
                scrollLatencyMetric: true
            };

            rumVars = {
                143: '28.155.' + pageId,
                rum_id: tld + '.direct.desktop.' + pageId,
                287: region,
                region: region,
                '-project': 'direct',
                '-page': isDna ? context : pageId,
                '-env': isProd ? 'production' : 'testing',
                '-platform': 'desktop',
                '-uid': operatorUid,
                '-additional': JSON.stringify({
                    isDna: isDna
                }),
            };

            return []
                .concat(INLINE_SCRIPTS)
                .concat([
                    '(function(){',
                    'var rumSettings = ' + JSON.stringify(rumSettings) + ';',
                    'rumSettings.beacon = !!navigator.sendBeacon;',
                    'var rumVars = ' + JSON.stringify(rumVars) + ';',
                    'Ya.Rum.init(rumSettings, rumVars);',
                    '})()'
                ]).join('');
        }
    });
})();
