([
    {
        tech: 'js',
        mustDeps: [
            {
                block: 'i-bem',
                elem: 'html',
                tech: 'bemhtml'
            },
            {
                block: 'b-group-tags-popup-content',
                tech: 'bemhtml'
            },
            {
                block: 'b-group-tags-groupedit',
                tech: 'bemhtml'
            },
            {
                block: 'b-banner-age-labels-edit',
                tech: 'bemhtml'
            },
            {
                block: 'b-banner-baby-food-labels-edit',
                tech: 'bemhtml'
            },
            {
                block: 'b-campaign-info-panel',
                mods: { type: ['errors', 'corrections'] },
                tech: 'bemhtml'
            },
            {
                block: 'b-campaign-strategy2',
                tech: 'bemhtml'
            },
            {
                block: 'b-groups-set-autotargeting',
                tech: 'bemhtml'
            },
            {
                block: 'b-day-budget-recommendation-notification',
                tech: 'bemhtml'
            }
        ]
    },
    {
        mustDeps: [
            { block: 'i-glue' },
            { block: 'i-adjustment-rates-data' },
            {
                block: 'i-utils',
                elems: [
                    'lodash',
                    'function',
                    'grasp-self',
                    'server-data',
                    'url',
                    'context-limit',
                    'currencies',
                    'dynamic-groups-data',
                    'normalize',
                    'campaign',
                    'validation',
                    'image-ad',
                    'moment',
                    'campaign',
                    'sepcial-urls',
                    'm-organization'
                ]
            },
            { block: 'b-confirm' },
            {
                block: 'b-campaign-menu',
                elems: [
                    'navigation',
                    'banner-actions',
                    'special-actions',
                    'media-panel',
                    { elem: 'navigation', mods: { type: 'mobile-content-camp', border: 'yes' } },
                    { elem: 'navigation', mods: { type: 'camp', border: 'yes' } },
                    { elem: 'banner-actions', mods: { type: 'mobile-content-camp' } },
                    { elem: 'special-actions', mods: { type: 'mobile-content-camp' } }
                ]
            },
            {
                block: 'b-campaign-info',
                elems: [
                    'header',
                    'optimize-ready',
                    'brief',
                    'menu',
                    'details',
                    'actions-bar'
                ]
            },
            { block: 'b-campaign-state' },
            { block: 'b-campaign-state', mods: { with: 'direct-warning' } },
            { block: 'i-phrases-separate-into-groups' },
            { block: 'b-campaign-edit-panel' },
            { block: 'm-campaign' },
            { block: 'dm-dynamic-media-campaign' },
            { block: 'dm-mobile-content-campaign' },
            { block: 'dm-cpm-banner-campaign' },
            { block: 'dm-cpm-yndx-frontpage-campaign' },
            { block: 'dm-cpm-price-campaign' },
            { block: 'dm-dynamic-media-group' },
            { block: 'dm-dynamic-group' },
            { block: 'dm-cpm-banner-group' },
            { block: 'dm-cpm-yndx-frontpage-banner-group' },
            { block: 'dm-cpm-price-banner-group' },
            { block: 'b-campaign-strategy2' },
            { block: 'b-groups-list' },
            {
                block: 'b-groups-list',
                elems: ['banner-preview', 'banner-phrases']
            },
            { block: 'b-mass-actions', mods: { type: 'camp' } },
            { block: 'b-banner-age-labels-edit' },
            { block: 'b-banner-baby-food-labels-edit' },
            { block: 'b-groups-set-autotargeting' },
            { block: 'b-campaign-platform-switcher' },
            {
                block: 'b-online-set-phrases-prices',
                mods: {
                    type: [
                        'dynamic-groups',
                        'performance',
                        'content-promotion'
                    ]
                }
            },
            { block: 'b-group-tags-popup-content' },
            { block: 'b-group-tags-groupedit' },
            {
                block: 'l-page',
                mods: { layout: '72-20' }
            },
            {
                block: 'b-layout-table',
                mods: { layout: '22-78' },
                elems: ['thead', 'tbody']
            },
            {
                block: 'b-menu-horiz',
                mods: { preset: 'shadow', layout: 'complex' }
            },
            { block: 'b-campaign-tabs' },
            {
                block: 'b-campaign-info-panel',
                mods: { type: ['errors', 'corrections'] }
            },
            { block: 'b-floater', mods: { 'never-fixed': 'yes', fixed: 'yes', to: 'bottom', theme: 'grey-always', resizable: 'yes' } },
            { block: 'icon', mods: { 'size-16': 'alert', 'size-13': 'alert',  'size-18': 'alert-white' } },
            { block: 'b-pager', mods: { theme: 'embossed' } },
            { block: 'icon-text', mods: { theme: 'alert', size: ['ms', 's'] } },
            { block: 'b-banners-per-page' },
            { block: 'i-request', mods: { type: 'form' } },
            { block: 'b-group-tag-button', mods: { size: 'big' } },
            { block: 'b-minus-words-popup', mods: { type: 'group' } },
            { block: 'b-moderation-doc-informer' },
            { block: 'i-banners-group-data' },
            { block: 'cpm-yndx-frontpage-min-price' }
        ],
        shouldDeps: [
            {
                elems: [
                    'info',
                    'models-data',
                    'license-warning',
                    'hierarchical-multipliers-warning',
                    'budget-limit-notification',
                    'content-promotion-warning'
                ]
            },
            { block: 'b-header-title-portal-dna' },
            { block: 'b-page-warning' },
            { block: 'b-minus-words-control', mods: { switcher: 'link' } },
            { block: 'i-jquery', elem: 'cookie' },
            { block: 'i-model-aggregator' },
            { block: 'i-model' },
            { block: 'b-metrica-stop-warning' },
            { block: 'i-consts', elems: ['rights'] },
            { block: 'b-checkboxes-group' },
            { block: 'popup', mods: {
                type: 'modal',
                position: 'fixed',
                autoclosable: 'no',
                'body-scroll': 'no',
                'has-close': 'yes'
            } },
            { block: 'b-link' },
            {
                block: 'button2',
                mods: {
                    tone: 'transparent',
                    view: 'default',
                    size: 'm',
                    type: 'link',
                    theme: 'normal'
                }
            },
            { block: 'b-dna-header' },
            { block: 'b-beta', mods: { type: 'symbol' } },
            { block: 'copy-group-link' },
            { block: 'b-day-budget-recommendation-notification' },
            { block: 'b-moderation-message-dna' }
        ]
    }
])
