match(function() {
    return (/^(addAdGroupsCpmBanner|editAdGroupsCpmBanner|copyAdGroupsCpmBanner)$/).test(this.data.cmd) &&
        this.data.campaign.mediaType === 'cpm_yndx_frontpage';
})(

    block('app-main')(

        mode('preprocess')(function() {
            var data = this.data,
                campaignTags = data.campaign.tags || [],
                form = data.FORM,
                copyRegexp = RegExp('.*\\(' + iget2('p-multiedit2', 'kopiya', 'копия') + '\\)$', 'gi');

            data.errorPath = 'groups';

            //отключение клиентской валидации
            if (this.data.COOKIES.disable_client_validation && this.data.is_beta) {
                data.disable_client_validation = 1;
            }

            this.isSingleGroup = !!(!data.campaign.groups || data.campaign.groups.length <= 1);
            this.isNewGroup = data.campaign.groups[0] && !data.campaign.groups[0].adgroup_id;
            this.isCopyGroup = !!data.is_groups_copy_action;
            this.isCreatingNewCamp = !!(data.statusEmpty == 'Yes' || form.from_newCamp);

            this.data.prev_banner && this.data.prev_banner.title && (this.data.prev_banner.modelId = 'prev');

            data.campaign.groups && data.campaign.groups.forEach(function(group, i) {
                var groupName;

                //DIRECT-44701: ссылка на сайт сохраняется с лишним http
                group.banners.forEach(function(banner) {
                    banner.href = banner.href ? u.stripHttp(banner.href) : '';
                });

                //DIRECT-40991: Редактирование пустых групп
                if (!group.banners.length) {
                    group.banners.push({
                        bid: 0
                    });

                    group.banners_quantity = 1;
                }

                // Для получения модели кампании из модели группы, например, при создании новой группы
                group.cid = group.cid || data.campaign.cid;

                if (group.is_group_copy_action) {
                    groupName = group.group_name || '';

                    if (!groupName || !groupName.match(copyRegexp)) {
                        group.group_name = groupName + ' (' + iget2('p-multiedit2', 'kopiya', 'копия') + ')';
                    }
                }

                // @skywhale в рамках DIRECT-80774 было решено не трогать поле adgroup_type,
                // подтип группы для мейдийных кампаний определяет cpm_yndx_frontpages_type
                group.cpmGroupType = group.cpm_yndx_frontpages_type || 'cpm_yndx_frontpage';

                group = u['i-banners-group-data'].patch({
                    hasPrevBanner: data.prev_banner && data.prev_banner.title,
                    prevBanner: data.prev_banner,
                    count: i,
                    bannersGroup: group,
                    isNewGroup: this.isNewGroup,
                    isCopyGroup: this.isCopyGroup,
                    isSingleGroup: this.isSingleGroup,
                    campaignTags: campaignTags
                }, data);
            }, this);

            data.campaign.common_geo_set = !!data.campaign.common_geo;

            data = u['i-phrases-separate-into-groups'].patch(data, {
                hasSuspended: true,
                isNotBiddable: true
            });
            data = u['i-process-campaign-data'].patch(data);

            return data;
        }),

        mode('page-block')({
            block: 'p-multiedit2',
            mods: {
                type: 'cpm-yndx-frontpage'
            }
        })
    ),

    block('b-page')(
        mode('content-only')(function() {
            return this.data.FORM.popupMode === '1';
        }),

        def().match(function() {
            return !this.pageParams;
        })(function() {
            var bannerStatus = this.data.FORM.banner_status,
                title;

            if (this.isNewGroup || this.isCopyGroup) {
                title = iget2('p-multiedit2', 'sozdanie-gruppy-obyavleniy', 'Создание группы объявлений');
            } else {
                switch (bannerStatus) {
                    case 'all':
                        title = this.data.campaign.groups && this.data.campaign.groups.length == 1 ?
                            iget2('p-multiedit2', 'redaktirovanie-gruppy-obyavleniy', 'Редактирование группы объявлений') :
                            iget2('p-multiedit2', 'redaktirovanie-grupp-obyavleniy', 'Редактирование групп объявлений');
                        break;
                    case 'wait':
                        title = iget2('p-multiedit2', 'redaktirovanie-obyavleniy-na-moderacii', 'Редактирование объявлений на модерации');
                        break;
                    case 'decline':
                        title = iget2('p-multiedit2', 'redaktirovanie-otklonyonnyh-obyavleniy', 'Редактирование отклонённых объявлений');
                        break;
                    case 'off':
                        title = iget2('p-multiedit2', 'redaktirovanie-ostanovlennyh-obyavleniy', 'Редактирование остановленных объявлений');
                        break;
                    case 'draft':
                        title = iget2('p-multiedit2', 'redaktirovanie-obyavleniy-chernovikov', 'Редактирование объявлений-черновиков');
                        break;
                    case 'arch':
                        title = iget2('p-multiedit2', 'redaktirovanie-arhivnyh-obyavleniy', 'Редактирование архивных объявлений');
                        break;
                    default:
                        title = iget2('p-multiedit2', 'redaktirovanie-aktivnyh-obyavleniy', 'Редактирование активных объявлений');
                }
            }

            return applyNext({
                pageParams: {
                    title: title
                }
            });
        }),

        mode('title')(function() {
            return this.pageParams.title;
        }),

        elem('foot-js').content()(function() {
            var result = applyNext(),
                langList = {
                    ru: 'ru-RU',
                    en: 'en-US',
                    tr: 'tr-TR',
                    ua: 'uk-UA'
                };

            result.push({
                elem: 'js',
                url: u.formatUrl({
                    host: '//api-maps.yandex.ru',
                    path: '2.1',
                    query: {
                        lang: langList[this.data.lang] || langList.ru,
                        coordorder: 'longlat'
                    }
                })
            });

            return result;
        })
    )

);

block('p-multiedit2').mod('type', 'cpm-yndx-frontpage')(

    addJs()(function() {
        return u._.extend(
            u['p-multiedit2'].getPageJsParams(u._.extend({}, this.data, {
                cmd: 'saveCpmBannerAdGroups',
                autoPrice: 1
            })),
            {
                isFirstCampaign: this.data.is_first_camp,
                promoCodeDomains: this.data.promocode_domains,
                popupMode: this.data.FORM.popupMode === '1'
            }
        );
    }),

    content()(function() {
        var campaign = this.data.campaign,
            isCampaignModerated = campaign.statusModerate && campaign.statusModerate !== 'New';

        return [
            {
                elem: 'models-data'
            },
            {
                block: 'b-retargetings-data'
            },
            {
                block: 'l-page',
                mix: [{
                    block: 'p-multiedit2',
                    elem: 'content-layout'
                }],
                mods: {
                    layout: '16-60-16'
                },
                content: [
                    {
                        elem: 'tbody',
                        mix: [
                            { block: 'b-errors-presenter2' },
                            {
                                block: 'p-multiedit2',
                                elem: 'errors-presenter',
                                elemMods: { position: 'navigation' }
                            }
                        ],
                        tag: 'tbody',
                        content: [
                            {
                                elem: 'row',
                                left: true,
                                center: [
                                    {
                                        block: 'b-page-title',
                                        mix: [{
                                            block: 'p-multiedit2',
                                            elem: 'title'
                                        }],
                                        content: (function() {
                                            var title = {
                                                elem: 'title',
                                                content: this.pageParams.title
                                            };

                                            return [
                                                this.isCreatingNewCamp && {
                                                    elem: 'steps-title',
                                                    content: iget2('p-multiedit2', 'shag-2-iz-2', 'Шаг 2 из 2')
                                                },
                                                title
                                            ];
                                        }.call(this))
                                    },
                                    {
                                        block: 'p-multiedit2',
                                        elem: 'campaign-title',
                                        elemMods: {
                                            'is-new': this.isNewGroup || this.isCopyGroup ? 'yes' : 'no'
                                        }
                                    },
                                    {
                                        block: 'b-edit-groups-arch-warning'
                                    },
                                    {
                                        block: 'b-error-pretty-message',
                                        mods: { theme: 'classic' },
                                        mix: {
                                            block: 'p-multiedit2',
                                            elem: 'pretty-message',
                                            elemMods: { position: 'main-errors-title' }
                                        },
                                        attrs: { 'data-err-path': 'mainErrorsTitle' }
                                    },
                                    {
                                        block: 'b-error-pretty-message',
                                        mods: { theme: 'classic' },
                                        mix: { block: 'p-multiedit2', elem: 'pretty-message' },
                                        attrs: { 'data-err-path': 'groupsErrorsNavigation' }
                                    },
                                    {
                                        block: 'b-error-pretty-message',
                                        mods: { theme: 'classic' },
                                        mix: { block: 'p-multiedit2', elem: 'pretty-message' },
                                        attrs: { 'data-err-path': 'groupNameErrors' }
                                    },
                                    {
                                        block: 'b-error-pretty-message',
                                        mods: { theme: 'classic' },
                                        mix: { block: 'p-multiedit2', elem: 'pretty-message' },
                                        attrs: { 'data-err-path': 'bannersErrorsNavigation' }
                                    }
                                ],
                                rgap: true,
                                right: true
                            }
                        ]
                    },
                    {
                        elem: 'tbody',
                        mix: [
                            { block: 'b-errors-presenter2' },
                            {
                                block: 'p-multiedit2',
                                elem: 'errors-presenter',
                                elemMods: { position: 'groups' }
                            }
                        ],
                        tag: 'tbody',
                        content: [
                            {
                                elem: 'row',
                                left: true,
                                center: {
                                    block: 'b-error-pretty-message',
                                    mods: { theme: 'classic' },
                                    mix: { block: 'p-multiedit2', elem: 'pretty-message' },
                                    attrs: { 'data-err-path': '' }
                                },
                                ctxCells: {
                                    center: {
                                        attrs: {
                                            colspan: 4
                                        }
                                    }
                                },
                                rgap: true,
                                right: true
                            },
                            {
                                elem: 'row',
                                center: {
                                    elem: 'separator',
                                    mix: [{
                                        block: 'p-multiedit2',
                                        elem: 'separator'
                                    }]
                                },
                                ctxCells: {
                                    center: {
                                        attrs: {
                                            colspan: 4
                                        }
                                    }
                                }
                            },
                            applyCtx({
                                block: 'p-multiedit2',
                                elem: 'mass-actions',
                                isSingleGroup: this.isSingleGroup
                            }),
                            {
                                elem: 'row',
                                mix: [{
                                    block: 'p-multiedit2',
                                    elem: 'form-container'
                                }],
                                center: applyCtx({
                                    block: 'p-multiedit2',
                                    elem: 'multiedit-container',
                                    type: 'cpm-yndx-frontpage',
                                    hasMediaResources: true,
                                    formData: {
                                        cmd: 'bannersMultiSave'
                                    },
                                    editData: {
                                        type: 'cpm-yndx-frontpage-full'
                                    },
                                    buttonsData: {
                                        disabled: 'yes',
                                        isCampaignModerated: isCampaignModerated,
                                        buttons: [
                                            this.isCreatingNewCamp && 'back',
                                            'submit'
                                        ]
                                    },
                                    hintData: {
                                        hint: {
                                            block: 'p-multiedit2',
                                            elem: 'loading',
                                            elemMods: { hidden: 'yes' },
                                            content: [
                                                {
                                                    block: 'spin2',
                                                    mods: { size: 'xxs', progress: 'yes' },
                                                    mix: {
                                                        block: 'p-multiedit2',
                                                        elem: 'loading-spin'
                                                    }
                                                },
                                                iget2('p-multiedit2', 'idyot-proverka-ssylki', 'Идёт проверка ссылки')
                                            ]
                                        }
                                    }
                                }),
                                ctxCells: {
                                    center: {
                                        attrs: {
                                            colspan: 4
                                        }
                                    }
                                }
                            }
                        ]
                    }
                ]
            },
            {
                block: 'b-minus-words-control',
                elem: 'popup',
                for: 'groups',
                minusWordsMods: { type: 'cpm-yndx-frontpage' }
            },
            {
                elem: 'outboard-popup',
                elemMods: {
                    type: 'wordstat-control'
                },
                innerBlock: {
                    block: 'b-wordstat',
                    js: {
                        modelName: 'dm-cpm-yndx-frontpage-banner-group',
                        isMobile: false
                    }
                }
            }
        ];
    }),

    elem('models-data').content()(function() {
        var data = this.data,
            campaign = data.campaign;

        return [
            {
                block: 'i-model-aggregator',
                content: {
                    block: 'i-model',
                    modelParams: {
                        name: 'dm-cpm-yndx-frontpage-campaign',
                        id: campaign.cid,
                        data: applyCtx({
                            block: 'dm-cpm-yndx-frontpage-campaign',
                            isCreatingNewCamp: this.isCreatingNewCamp
                        })
                    }
                }
            },
            campaign.groups.map(function(group) {
                return {
                    block: 'i-model',
                    modelParams: {
                        name: 'dm-cpm-yndx-frontpage-banner-group',
                        id: group.modelId,
                        data: u['dm-cpm-yndx-frontpage-banner-group'].transformData({
                            isAllowFrontpageProfile: hasEnabledFeatures('cpm_yndx_frontpage_profile'),
                            group: group,
                            campaignTags: campaign.tags,
                            currency: campaign.currency
                        })
                    }
                };
            }, this),
            !!campaign.common_geo_set && {
                block: 'i-model',
                modelParams: {
                    name: 'm-geo-regions',
                    id: 'common',
                    data: {
                        geo: campaign.geo,
                        geo_names: campaign.geo_names
                    }
                }
            }
        ];
    })

);
