BEM.DOM.decl('p-offline-agency-reports', {
    onSetMod: {
        js: function() {
            if (!window.dna) {
                throw new Error('An error has occurred in loading DNA dependencies');
            }

            this._renderDna();
        }
    },

    /**
    * Удаляет блок и подписки на события
    */
    destruct: function() {
        this._subscriptionManager.dispose();

        return this.__base.apply(this, arguments);
    },

    /**
     * Render DNA root component
     */
    _renderDna: function() {
        var dna = window.dna,
            params = this.params,
            dnaRootComponent;

        if (dna.components.Root.initStore) {
            dna.components.Root.initStore({
                login: params.login,
                perlReqId: params.reqid,
                page: params.page,
                devInfo: params.devInfo,
                csrfToken: params.csrfToken,
            });
        }

        dnaRootComponent = dna.reactCreateElement(dna.components.Root, {
            login: params.login,
            reportsParams: {
                showAdditionalColumns: !!(params.showAdditionalColumns)
            },
            enableSidebar: !!params.enableSidebar
        }, null);

        dna.reactDOMRender(dnaRootComponent, this.elem('grid')[0]);
    }
});
