# Блок b-hintable

###Автор###
[evolkowa](https://staff.yandex-team.ru/evolkowa)

## Описание
При наведении на DOM элемент блока показывает подсказку, которая указывается в параметре hint блока,
либо определяется через публичный метод блока setHintContent

Блок предназначен для использования как микс к другому блоку.
При подключении блока в шаблоне - обязательно указать js: true, для его инициализации.

## Параметры js

### hint
В параметр hint можно передать содержимое подсказки

### onScroll
В параметр onScroll можно передать значение 'close'(передается в popup)
Модификатор on-scroll: 'close' в popup скрывает его при scroll

## Публичные методы

Блок имеет публичный метод setHintContent(content), который устанавливает новый текст подсказки,
в соответсвии с переданным в функцию параметром

## Модификаторы

### hoverable
С модификатором hoverable: yes на блок можно навестись и добавлять туда кликабельные элементы (например, ссылки)
```
    {
        block: 'b-hintable',
        js: true,
        mods: { hoverable: 'yes' }
    }
```

## Примеры использования

### Без предустановленной подсказки
```
{
    block: 'oneCoolBlock',
    mix: {
       {
           block: 'b-hintable',
           js: true
       }
    }
}
```

### С предустановленной подсказкой
```
{
    block: 'oneCoolBlock',
    elem: 'hisElem',
    mix: {
       {
           block: 'b-hintable',
           js: {
               hint: 'Я подсказка'
           }
       }
    }
}
```
