#b-regions-tree#

##Описание##
Блок с деревом регионов, используется внутри блока b-regions для отображения дерева и выбора в нем элементов.
На основе древовидной структуры регионов переданной в параметре `regions` строит ее отображение в интерфейсе, при этом
запрещает выбор регионов переданных в параметре `disableRegions`.
Параметр `independentRegions` содержит список регионов, которые:
1) Не нужно выбирать если пользователь выбрал родительский регион региона из independentRegions
2) Если independentRegions уже были ранее выбраны в рамках родительского, то при снятии галки с родительского, с independentRegions тоже снимается галка

Параметр `isCommon` указывет на то, что контрол является контролом массового редактирования для всех групп кампании.
При указании этого флага рядом с регионами, имеющих различия в значениях выбранности для разных групп появляются появляется
информация об этом. При попытке изменить значение такого региона - появится предупреждение, о том, что значение измениться для
всех групп кампании.

## Модификаторы
* `bids-corrections: 'yes'` - дерево с возможностью указания и просмотра ставок для регионов. Если передан параметр 
`disableEditBids` - ставки можно только просматривать.

##Меинтейнеры##
[evolkowa](https://staff.yandex-team.ru/evolkowa)
[a-urukov](https://staff.yandex-team.ru/a-urukov)
[ngraf](https://staff.yandex-team.ru/ngraf)

##Пример##
```javascript
{
    block: 'b-regions-tree',
    disableRegions: [225, 123],
    independentRegions: [377],
    regions: [{ id: 100, name: "Россия", inner: [{ id: 101, name: "Москва" }] }]
}
```
