/**
 * @typedef {Object} CommonErrorData
 * @property {String} text текст ошибки
 * @property {String} [description] более подробное чем текст ошибки, её описание
 */

/**
 * Интерфейс класса для блоков вывода ошибок
 * @interface IErrorViewInterface
 */
BEM.INTERFACE.decl('i-error-view-interface', [

    /**
     * Показывает ошибки
     * @param {CommonErrorData[]} [errors]
     * @returns {BEM}
     */
    'showErrors',

    /**
     * Сбрасывает ошибки
     * @returns {BEM}
     */
    'clearErrors'

]);
