#!/bin/bash

TEST_REALPATH=`which realpath`

if [ -z "$TEST_REALPATH" ] ; then

    echo 'недоступна функция realapth'
    echo 'нужен пакет coreutils'
    echo 'установка:'
    echo 'brew install coreutils'
    echo 'или'
    echo 'sudo apt-get install coreutils'

    exit 1
fi

PCODE_VER=`node -e "const a = $(curl https://static.yandex.net/partner-code/loaders/banner_versions.json); console.log(a.code.reduce((max, cur) => max.percent < cur.percent ? cur : max, { percent: -1 }).id);"`

if [[ -z "$PCODE_VER" ]] || [ $PCODE_VER -eq -1 ] ; then

    echo 'недоступен или пуст файл с версиями партнерского кода'

else

    SCRIPT=`realpath $0`
    SCRIPTPATH=`dirname $SCRIPT`
    FILEPATH="$SCRIPTPATH/../desktop.blocks/i-utils/__auto-pcode/i-utils__auto-pcode.utils.js"

    echo "/* !ВНИМАНИЕ! */"                   > $FILEPATH
    echo "// этот файл генерится скриптом"   >> $FILEPATH
    echo "// cd data3 && make pcode-ver-up"  >> $FILEPATH
    echo "// руками менять его не надо"      >> $FILEPATH
    echo "u.register({"                      >> $FILEPATH
    echo "    'auto-code': {"                >> $FILEPATH
    echo "        getVersion: function() {"  >> $FILEPATH
    echo "            return $PCODE_VER;"    >> $FILEPATH
    echo "        }"                         >> $FILEPATH
    echo "    }"                             >> $FILEPATH
    echo "});"                               >> $FILEPATH
    echo ""                                  >> $FILEPATH

    echo "============================="
    echo "версия партнерского кода обновлена"
    echo "файл: $FILEPATH"
    echo ""
    cat "$FILEPATH"

fi

