#!/usr/bin/perl

#
# Скрипт обновит поле domain_login в таблице internal_users
#
# Запустить нужно после обновления программного кода (время выполнения ~ 3 сек)
#
# Для обновления необходимо запустить скрипт -
# perl /var/www/ppc.yandex.ru/deploy/20100604_update_domain_logins.pl
#


use strict;
use warnings;

use FindBin qw/$Bin/;
use lib "$Bin/../protected/";

use Settings;
use DBTools;

while (my $line = <DATA>) {
    my ($login, $domain_login) = split(/\s/, $line);
    my $uid = get_one_field_sql(PPC,'SELECT uid FROM users WHERE login = ?', $login);
    if ($uid){
        do_sql(PPC, "
                INSERT INTO internal_users
                (uid, domain_login) VALUES (?, ?)
                ON DUPLICATE KEY UPDATE domain_login = ?
                ;
            ",
            $uid,
            $domain_login,
            $domain_login,

          );
    }

}

__DATA__
a045	oz
aandrosov-cuport	aandrosov
aandrosov-cuport	aandrosov
ADomanitskaya-adm	domanickaya
ae-safonova	safonova
aetikhonov	tikhonov
agava	itkina
aizima	aizima
a-khizhov	khizhov
akirpichnikov-manage	akirpichnikov
akirpichnikov-tl	akirpichnikov
akirpichnikov-tl	akirpichnikov
akozhano	kozhanova
ALemeshevski-sup	lemeshevsky
aless-io	sottovoce
alex0908tismenetsky	tismenetsky
alex0908tismenetsky	tismenetsky
alexey-opara	alexopara
alexeyvanisimov	anisimov
alexgoncharova	goncharova
alex-nem1	nem
alex-nem1	nem
allamu	allam
alnasonow	nasonov
amines	nadine
amines	nadine
ananna3-adm	caesarea
ananna3-mdpl	caesarea
ananna3-mdpl1	caesarea
ananna3-mng	caesarea
ananna3-mng1	caesarea
ananna3-mngstl	caesarea
ananna3-mngstl	caesarea
ananna3-mngtl	caesarea
ananna3-mngtl	caesarea
ananna3-supp	caesarea
ananna3-vsh	caesarea
ananna3-vsh	caesarea
ananna-smotr	caesarea
anastasiavavilova	vavilova
ancientfire	domanickaya
andreykozachenko	akozachenko
andreykozachenko	akozachenko
AngelNad	angel
AngelNad	angel
anisnast	aniskova
annablinova2007	blinova
anna-domanickaya	domanickaya
anna-superreader	domanickaya
anuta-jakovleva	blinova
aridona	spiridonova
artem-zateev	zateev
asyasukhova	sukhova
at-direct-media	labiva
at-direct-mngr	gestir
at-direct-mngr-full	labiva
at-direct-smotr	labiva
at-direct-stlead	labiva
at-direct-stlead	labiva
at-direct-stl-full	labiva
at-direct-stl-full	labiva
at-direct-super	labiva
at-direct-supp	labiva
at-direct-teamlead	labiva
at-direct-teamlead	labiva
at-direct-tl-full	labiva
at-direct-tl-full	labiva
at-direct-vesh	labiva
avaksatwork	avaks
avaksmanager	avaks
avaksmedia	avaks
avakssuper	avaks
avaksvesh	avaks
avgustikus	avgusta
balakinan	a-balakina
balakinan-m	a-balakina
balakinan-mp	a-balakina
balakinan-sp	a-balakina
balakinan-tm	a-balakina
balakinan-tm	a-balakina
balakinan-v	a-balakina
bannikovaanna	annban
baymanager	inna-kudelkina
blonskiy2008	ablonskiy
brookva	apolyakova
chichi-20031	chichi
chupiro	chupiro
dalexeev-manager	dalexeev
dalexeev-media	dalexeev
dalexeev-super	dalexeev
dalexeev-support	dalexeev
darkhipovv	darkhipov
darkhipovv	darkhipov
direct-manager	galeeva
direct-mediaplan	galeeva
direct-moderator	galeeva
direct-solnik	solnik
direct-super	galeeva
direct-tester0	artkoshelev
direct-tester1	labiva
direct-work	solodovnikova
dnmaraev	maraev
dubov-leonid	dubov
dushkin-vit	dushkin
edl2	eml
ekamenskaya	lkamenskaya
ekamosina	sad
e-karev	ekarev
ekaterina-askerova	askerova
ekaterinaisaenko	isaenko
e-kur	ekur
e-kur	ekur
elena-kilunina	lioty
elpo2010	a-balakina
e-reizina	ereizina
evsiutina	evsiutina
extropy1-direct	extropy
extropy2-direct	extropy
ezshenka	e-egorova
fetisov0310	fetisov
firuzau	firuza
galina-vityuk	vityuk
gera-media	gerich
gerich-man	gerich
gerich-manager	gerich
gerich-media	gerich
gerich-stl	gerich
gerich-stl	gerich
gerich-super	gerich
gerich-tl	gerich
gerich-tl	gerich
gestir-admi	gestir
gestir-smotr	gestir
gestir-test-manager	gestir
gestir-test-mdplan	gestir
gestir-test-stmld24	gestir
gestir-test-stmld24	gestir
gestir-test-sup	gestir
gestir-test-teamld49	gestir
gestir-test-teamld49	gestir
ginkage	ginkage
gjgjdf	julia
gorbunovoi	gorbunova
goreev-konstantin	goreev
goreev-manager	goreev
goreev-media	goreev
goreev-sm	goreev
goreev-ves	goreev
gray	gray
g-vityuk	vityuk
happyou	baraban
harly2378	kate
harly2378	kate
helha-manager	heliarian
helha-mediaplaner	heliarian
helha-placer	heliarian
helha-super-direct	heliarian 
helha-superteamleade	heliarian
helha-superteamleade	heliarian
helha-suppor	heliarian
helha-teamlead	heliarian
helha-teamlead	heliarian
home-webmaster	belyan
ignatelena84	ignatieva
il-adilia	iladilia
ilanju	ailina
innakolchina	ikolchina
ira-ledyaeva	ledjaeva
ishwestdirect	ishwest
ishwestdirectheadofd	ishwest
ishwestdirectheadofd	ishwest
ishwestdirectmediapl	ishwest
ishwestdirectteamlea	ishwest
ishwestdirectteamlea	ishwest
ishwestdirhang	ishwest
ishwestdirhang	ishwest
ishwestdirman	ishwest
ishwestdirsup	ishwest
iv-lumenes	ivakarchuk
janetim09	jane-t
janetim09	jane-t
johnyh88	johnyh
juli	uskova
juliykim	jkim
kan-direct	akozachenko
katrus777	kation
kdoroshenko	doroshenko
keepitrealdude	vasilyev
kimberley-manager2	eboguslavskaya 
kimberley-mplanner1	eboguslavskaya 
kimberley-super	eboguslavskaya 
kkhrapilina	ksuzhi
kmadich	kmadich
knatalia13	natali
kolesnikov-media	kolesnikov
kolesnikov-mngr	kolesnikov
kolesnikov-super	kolesnikov
kolesnikov-support	kolesnikov
komevgenia	komarova
komevgenia	komarova
kosarevatatiana	kosarevat
kotlyarelen	ekotlyar
kotlyarelen	ekotlyar
kozunov-manager	kozunov
kozunov-super	kozunov
krispybayan	aliho
Krokodilgena1984	elenapopova
Kruglovakb	ksu
ksanych3107	ksanych
ksanych3107	ksanych
k-shumeykin	lemon
kvn-test-adm	vovichek62
kvn-test-mdpl	vovichek62
kvn-test-mng	vovichek63
kvn-test-mng1	vovichek64
kvn-test-mngstl	vovichek65
kvn-test-mngstl	vovichek66
kvn-test-mngtl	vovichek67
kvn-test-mngtl	vovichek68
kvn-test-smotr	vovichek69
kvn-test-supp	vovichek70
kvn-test-vesh	vovichek71
labiva-mng	labiva
ldanilushkina	danilushkina
lena-san-manager	lena-san
lena-san-media	lena-san
lena-san-placer	lena-san
lena-san-super	lena-san
lena-san-superreader	lena-san
lena-san-supp	lena-san
leonya-direct	leonya
levmanager	lev
lia264	emoiseeva
lipano	delta
l-maslij	lmaslij
lonzya	brazhnikov
lookmore-art	artkoshelev
lubsia80	lubsia
lx-manager	lx
LyubaPlanner	itkina
lyudmiborisova	borisova
makishvili-manager	makishvili
makishvili-media	makishvili
makishvili-super	makishvili
makishvili-support	makishvili
manager2-direct-client	avaks
manager-direct-client	avaks
manalom	eml
mari-boyarskaya	boyarskaya
marimorozz	miamore
mariyapershko	turbo
mariya-sidenko	msidenko
mashasty	galaksora
max581	kuzmin
max581client	kuzmin
max581-dman-1	kuzmin
max581-man-1	kuzmin
max581-man-2	kuzmin
max581-med-1	kuzmin
max581-sup	kuzmin
max581-vesh	kuzmin
max-post	maksim
meaygul2	mersiyapova
medialom	eml
mediaplaner-art	artkoshelev
medlom	eml
megasuperdirect	skreling
mirage-manager	mirage
mirage-managers	mirage
mirage-media	mirage
mirage-placer	mirage
mirage-placer	mirage
mirage-super	mirage
mirage-supp	mirage
mirage-teamliader	mirage
mirage-teamliader	mirage
mish-gest	gestir
mish-gest3	gestir
mister-goreev	goreev
mlenasysoeva	esysoeva
mnaperstak	marina
mngr-art1	artkoshelev
mngr-art2	artkoshelev
msa-manager	msa
msa-manager1	msa
msa-manager3	msa
msa-media	msa
msa-placer	msa
msa-placer	msa
msa-soopport	msa
msa-super	msa
msa-super-teamleader	msa
msa-super-teamleader	msa
msa-teamleader	msa
msa-teamleader	msa
murzilka1977	olesya
mybuka	buka
myma79	trotsenko
myma79	trotsenko
namakr	natal-kryuko
naperstak	marina
nastico2008	avgusta
nastico2008	avgusta
nata50	nata
nata50	nata
natafenechka	fenina
nataly	ufaeva
nataly	ufaeva
nat-frolova2009	nvfrolova
nattali13	natali
nattali13	natali
new-direct-ui	moiseyev
nop7001	nop
nsorkin	nicola
nsorkin	nicola
oandreevskikh	olgun
olga-bulahova	bulahova
olga-clcl	kiev
olga-clcl	kiev
Olga-ksan	ksanych
olga-lid	kiev
olga-lid	kiev
olga-lid-super	kiev
olga-lid-super	kiev
olga-man-1	kiev
olga-medi	kiev
olga-mentop	kiev
olgaprosto-manager	kiev
olgashaleva4813	shaleva
olga-sto	kiev
olga-viss	kiev
olgavys	kiev
olgazbor-mn1	oz
olgazbor-mn2	oz
olpe317	olpe
osinav	osin
otmgalina	otmahova
ozbor-super	oz
pav-marie	vmpavlova
peter-lymar	peter-lymar
pozd-yulia	pozdeeva
quiz-test	pachkova
rah-man	rahman
razuvaev-direct	razuvaev
reizin	reizin
renzyaev1	renzyaev
rmstd1	italiano 
rokki2004	viktorova
rozayul	rozanova
salhi-direct	salhi
santa-tree	itkina
seminarim	ablonskiy
sergei-anisov	anisov 
sergeygershtein	gershtein
sergeygershtein	gershtein
sergeysl-manager	sergeysl
sergeysl-super	sergeysl
sezory	avasilevski
s-georgievskaya	sgeorgievskaya
sgolovko-agency	sgolovko
sgolovko-agency	sgolovko
shenick	shen
shenick	shen
shestakovNN	shen
shurek2005	alext
shurek2005	alext
silicon-eye	anisov 
sirina0	sirina0
sivkovpetr	sivkov
skreling-manager	skreling
solara7	lsobkevich
sottovoce-manager	sottovoce
sppt1	kiev
staskiba	skiba
stiopic	stiopic
stiopic	stiopic
stl-direct-client	avaks
stl-direct-client	avaks
subdir2	akimov
sukhovaya	suhovaya
sup-direct	galeeva
superlom2004	eml
supersmot	tretyakova
super-sottovoce	sottovoce
supertmld-art	artkoshelev
superview	ufaeva, nadine
superview	ufaeva, nadine
supp-art	artkoshelev
supr1-crm	sleeper
SurenSB	suren
svetla-dem	dsvetla
svetlana-rozhnova	svetik
sweik-al	al
ta-ka84	kalinina
Tanushk	tag
tanya-galeeva	tanu
tazetdinovagulnara	gulnarat 
tazetdinovagulnara	gulnarat 
tbog	tbog
tbog	tbog
tch-darya	cherdn
teamld-art	artkoshelev
terabeatle	mgagarin
teromanya	tr
tivakhnova	tatiana
tl-direct-client	avaks
tl-direct-client	avaks
tokinokaze	domanickaya
tor-aiden	domanickaya
tor-aiden2	domanickaya
tor-aiden2	domanickaya
tosha-adm	tosha
tosha-manager	tosha
tosha-mplanner	tosha
tosha-processing	tosha
tosha-processing	tosha
tosha-sup	tosha
tretya-e	elya
tretyakovalidia	tretyakova
tretyakovalidia	tretyakova
tr-manager	tr
T-ykb77	yakobi
u-belyaeva	ul-ya
udivigital	divo
ufaevastat	ufaeva
ufiruza	firuza
ufiruza	firuza
vasiljevanadya	n-vasilieva
vbogdan1	fabriq
verabee	anoshko
veracity-adv	suslova
veracity-dir	suslova
vera-kobrinchuk	vkobrinchuk
veshal-art	artkoshelev
viana	viana
viselnic	eml
vladbro4	vladbro
vod-i02	vod-i
vovk-galina	vovk
vovk-marina	trim3
whatami	riks
xsandr-vas	alba
yackovlevv	vyakovlev
ya-irso	siva
ya-kinst	ya-kinst
yana-kolesnikova2402	yana-kolesnikova
yapromo	boulochka
yarkima	msmirnova
yaSaint	saint
ya-trainer	danko
yb-manager-2	ashvedunov
yb-manager-3	ashvedunov
yebobrova	bobrova
yulia-holodova2	holy
zahacker	zahacker
Zamaraikina73	ludmila
zankin-sup	zankin
zavyalova-e	ezav
zhur-manager	zhur
zhur-manager2	zhur
zhur-media	zhur
zhur-placer	zhur
zhur-super	zhur
zhur-supp	zhur
zolotare-va	zoloto