#!/usr/bin/perl

use my_inc "..";


=head1 DEPLOY

# approved by zhur
# .migr
[
  {
    type => 'sql',
    webstop => "0",
    db => "ppcdict",
    when => 'before',
    time_estimate => "1 секунда",
    sql => "CREATE TABLE IF NOT EXISTS `inc_crm_queue_id` (
                `crm_queue_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                PRIMARY KEY (`crm_queue_id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;"
  },
  {
    type => 'manual',
    when => 'instructions',
    instructions => 'см. описание',
    time_estimate => '5 минут до пакетов, 5 минут после',
    text => q!

  1. Инициализируем таблицу inc_crm_queue_id достаточно большим id.
  На один из  ppcback'ов выложить пакет yandex-direct-deploy-files релизной версии 
  Важно: выкладывать только этот один пакет, остальной Директ не обновлять.
  Выполнить скрипт, 2 секунды 
    
  perl -I/var/www/ppc.yandex.ru/protected/ /opt/ppc-data/deploy-files/deploy/20131218_shard_crm_queue.pl --inc

  Следующий пункт нужно делать сразу же после первого, пауза не больше 5 минут, если что - можно перезапустить

  2. Меняем offset'ы в ppc и ppcdict, чтобы во время выкладки не было коллизий

  В базе ppc 
  lm ppcdata1 sql 'set global auto_increment_increment = 2; set global auto_increment_offset = 1;'

  В базе ppcdict
  lm ppcdict sql 'set global auto_increment_increment = 2; set global auto_increment_offset = 2;'

  на одном из ppcback
  direct-clus PERL apache-reload
  Важно, чтобы время между установкой автоинкрементов и релоадом было минимальным

  Для контроля:
  Запускаем
  LOG_TEE=1 perl /opt/ppc-data/deploy-files/deploy/20131218_shard_crm_queue.pl --check1
  Работает несколько минут. Если скрипт написал "OK", идем дальше. Если скрипт сообщил "FAIL": повторить запуск еще раз. 
  Если три запуска дают ошибки - сообщить релиз-менеджеру.
  Релиз-менеджеру же обратиться к ppalex@

  3. Пакеты
  
  Проверяем id:
  Запускаем
  LOG_TEE=1 perl /opt/ppc-data/deploy-files/deploy/20131218_shard_crm_queue.pl --check2
  Работает несколько минут. Если скрипт написал "OK", идем дальше. Если скрипт сообщил "FAIL": повторить запуск еще раз. 
  Если три запуска дают ошибки - сообщить релиз-менеджеру.
  Релиз-менеджеру же обратиться к ppalex@

  4. Меняем offset'ы обратно:
  
  на мастере ppcdata1
  lm ppcdata1 sql 'set global auto_increment_increment = 1; set global auto_increment_offset = 1;'

  на мастере ppcdict
  lm ppcdict sql 'set global auto_increment_increment = 1; set global auto_increment_offset = 1;'

  на одном из ppcback
  direct-clus PERL apache-reload

Если придется откатывать полностью выложенный релиз: 
Установить разные оффсеты на ppc и ppcdict (п. 2), 
откатить пакеты, 
вернуть offset=1 для ppc и ppcdict (п.4)

Повторная выкладка: 
в целом все надо повторить, но точную инструкцию надо будет составлять с учетом возникших проблем и того, насколько полностью все выложили в первый раз. 
    !,
  },
]
=cut


use strict;
use warnings;

use FindBin qw/$Bin/;
use lib "$Bin/../protected/";

use Settings;
use Yandex::DBTools;
use ScriptHelper;
use CheckShardMetabaseId;

use utf8;

$Yandex::DBShards::STRICT_SHARD_DBNAMES = 0;

my $INIT_INCREMENT = 0;
my $CHECK1 = 0;
my $CHECK2 = 0;

GetOptions("inc" => \$INIT_INCREMENT,
           "check1" => \$CHECK1,
           "check2" => \$CHECK2,
          );

my %tables = ('id'            => 'crm_queue',
             );


my $OFFSET = 50_000;

if ($INIT_INCREMENT) {
    $log->out('INIT START');

    my $max_id = get_one_field_sql(PPC, "select max(id)+$OFFSET from crm_queue") || $OFFSET;
    $log->out("init inc_crm_queue_id auto_increment with $max_id");
    do_sql(PPCDICT, "replace into inc_crm_queue_id values ($max_id)");

    $log->out("INIT FINISH");
    exit;
}
if ($CHECK1) {
    CheckShardMetabaseId::check(0, \%tables, $log);
    exit;
}
if ($CHECK2) {
    CheckShardMetabaseId::check(1, \%tables, $log);
    exit;
}

exit;
