package Direct::Model::AdGroupMobileContent::Role::Extended;

use Direct::Modern;
use Mouse::Role;

# Количество ключевых фраз в группе
has 'keywords_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество условий беcфразного таргетинга
has 'relevance_matches_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество условий ретаргетинга в группе
has 'retargetings_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество активных ключевых фраз в группе
has 'active_keywords_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество активных условий беcфразного таргетинга
has 'active_relevance_matches_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество активных условий ретаргетинга в группе
has 'active_retargetings_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

# Количество активных условий таргетинга по интересам в группе
has 'active_target_interests_count' => (
    traits     => [qw/Yandex::ORM::Meta::Attribute::Trait::Column/],
    is         => 'rw',
    isa        => 'Int',
    lazy_build => 1,
);

1;
