package Direct::Model::AgencyClientRelation;

use Direct::Modern;
use Mouse;

extends 'Yandex::ORM::Model::Base';

__PACKAGE__->_setup(
    default_table  => 'agency_client_relations',

    fields => [
        agency_client_id    => { type => 'Id' },
        client_client_id    => { type => 'Id' },
        bind                => { type => 'Enum', values => [qw/Yes No/] },
        client_archived     => { type => 'Enum', values => [qw/Yes No/] },
        client_description  => { type => 'Maybe[Str]' },
    ],

    relations => [
        agency  => { type => 'Direct::Model::AgencyClient' },
    ],
);

1;
