package Direct::Model::BannerDynamic::Manager;

use Direct::Modern;
use Mouse;

extends 'Direct::Model::Banner::Manager';

use Settings;

use Yandex::DBTools;

use Direct::Model::BannerDynamic;

has '+items' => (isa => 'ArrayRef[Direct::Model::BannerDynamic]');

sub _delete_in_shard { croak "Unimplemented!"; }

sub _do_check_redirect {
    my ($self, $shard, $banners) = @_;
    return;
}

sub _do_update_filter_domain {
    my ($self, $shard, $banners) = @_;
    return;
}

sub _do_update_adgroups {
    my ($self, $shard, $banners) = @_;

    $self->SUPER::_do_update_adgroups($shard, $banners);

    my %values;
    for my $banner (@$banners) {
        # Выставление статуса генерации фраз в BannerLand
        if (my $status = $banner->do_set_adgroup_bl_status) {
            $values{$banner->adgroup_id}->{statusBlGenerated} = $status;
        }
    }

    do_mass_update_sql(PPC(shard => $shard), 'adgroups_dynamic', 'pid', \%values) if %values;

    return;
}

__PACKAGE__->meta->make_immutable;

1;
