package Direct::Model::BannerText::Manager;

use Direct::Modern;
use Mouse;

extends 'Direct::Model::Banner::Manager';

use Settings;

use Direct::Model::BannerText;

has '+items' => (isa => 'ArrayRef[Direct::Model::BannerText]');

sub _delete_in_shard { croak "Unimplemented!"; }

after '_create_in_shard' => sub {
        my ($self, $shard, $banners) = @_;
        $self->_do_moderate_creatives($shard, $banners);
        $self->_save_banner_creatives($shard, $banners);
        $self->_do_update_video_resources($shard, $banners);
};

after '_update_in_shard' => sub {
        my ($self, $shard, $banners) = @_;
        $self->_do_moderate_creatives($shard, $banners);
        $self->_save_banner_creatives($shard, $banners);
        $self->_do_update_video_resources($shard, $banners);
};

__PACKAGE__->meta->make_immutable;

1;
