package Direct::Model::ImagePool::Manager;

use Direct::Modern;
use Mouse;

extends 'Yandex::ORM::Model::Manager::Base';

use Settings;

use Direct::Model::ImagePool;
use BannerImages::Pool;

has 'items' => (
    is  => 'ro',
    isa => 'ArrayRef[Direct::Model::ImagePool]',
);

=head2 create

=cut

sub create
{
    my $self = shift;
    my $items = BannerImages::Pool::add_items([ map { $_->to_db_hash } @{$self->items} ]);
    for my $i (0 .. $#$items) {
        $self->items->[$i]->pool_id($items->[$i]->{imp_id});
    }
    return;
}

1;

