package Direct::Validation::InternalPagesDomains;

use Direct::Modern;

# Временно захардкоженный список внутренних площадок Яндекса, потом будем формировать его на основе таблицы ppcdict.pages.
# Нужен для выдачи в API предупреждений о том, что запрет на эти площадки не применяется в сетях.

our %INTERNAL_PAGES_DOMAINS = map {$_ => 1} qw#
    2010.yandex.ru
    adnet.club
    adv.yandex.ru
    advertising.yandex.ru
    afisha-main
    afisha-other
    afisha-rubric
    afisha.yandex.ru
    androids-apps
    auto-brands
    auto-main
    auto.ru
    auto.yandex.ru
    auto2.yandex.ru
    avia.yandex.ru
    bar-suggest
    bar.yandex.ru
    browser.yandex.ru
    brozen.yandex.ru
    business.yandex.ru
    cards-category
    cards-main
    catalogue-cy
    catalogue-main
    ceviri.yandex.com.tr
    click-confirmation-test
    collections.yandex.ru
    com.android.browser
    com.cma.launcher.lite
    com.edadeal.android
    com.gau.go.launcherex
    com.hola.launcher
    com.s-g-i.edadeal
    com.tplink.browser
    com.yandex.browser
    com.yandex.browser.alpha
    com.yandex.browser.beta
    com.yandex.browser.broteam
    com.yandex.browser.canary
    com.yandex.launcher
    com.yandex.mobile.job
    com.yandex.mobile.realty
    com.yandex.zen
    dict-article
    dict-main
    dict-search
    direct-campaigns
    direct-contacts
    direct.yandex.ru
    directintegration
    disk.yandex.com.tr
    disk.yandex.ru
    download.yandex.ru
    edadeal.ru
    ege.yandex.ru
    euro-main
    euro-photos
    eurovision.yandex.ru
    fotki.yandex.ru
    frontend.vh.yandex.ru
    game.yandex.ru
    games.yandex.ru
    go.mail.ru/search_images
    gorod.yandex.ru
    gorsel.yandex.com.tr
    h14.yandex.ru
    harita.yandex.com.tr
    hava.yandex.com.tr
    health.yandex.ru
    holyday-category
    holyday-main
    images.yandex.by
    images.yandex.com
    images.yandex.com.tr
    images.yandex.kz
    images.yandex.r
    images.yandex.ru
    images.yandex.ua
    images.yandex.uz
    internet.yandex.ru
    js-lib
    kinopoisk.ru
    lego
    lig.yandex.com.tr
    local.yandex.ru
    m.adv.yandex.ru
    m.afisha.yandex.ru
    m.auto.ru
    m.auto.yandex.ru
    m.avia.yandex.ru
    m.avia.yandex.tr
    m.blogs.yandex.ru
    m.collections.yandex.ru
    m.disk.yandex.com.tr
    m.disk.yandex.ru
    m.edadeal.ru
    m.games.news.ru
    m.games.yandex.net
    m.games.yandex.ru
    m.gorod.yandex.ru
    m.harita.yandex.com.tr
    m.hava.yandex.com.tr
    m.health.yandex.ru
    m.images.yandex.by
    m.images.yandex.com
    m.images.yandex.com.tr
    m.images.yandex.kz
    m.images.yandex.ru
    m.images.yandex.ua
    m.images.yandex.uz
    m.internet.yandex.ru
    m.kinopoisk.ru
    m.local.yandex.ru
    m.mail.yandex.ru
    m.maps.yandex.ru
    m.mirror.yandex.ru
    m.money.yandex.ru
    m.music.yandex.ru
    m.navi.yandex.ru
    m.news.yandex.ru
    m.pogoda.yandex.com
    m.pogoda.yandex.ru
    m.q.yandex.ru
    m.rabota.yandex.ru
    m.rasp.yandex.ru
    m.slovari.yandex.ru
    m.sport.yandex.ru
    m.talk.yandex.ru
    m.thequestion.ru
    m.trains.yandex.ru
    m.translate.yandex.ru
    m.tune.yandex.ru
    m.tutor.yandex.ru
    m.tv.yandex.ru
    m.uslugi.yandex.ru
    m.video.yandex.by
    m.video.yandex.com
    m.video.yandex.com.tr
    m.video.yandex.kz
    m.video.yandex.ru
    m.video.yandex.ua
    m.video.yandex.uz
    m.woman.yandex.ru
    m.yandex.by
    m.yandex.com.tr
    m.yandex.kz
    m.yandex.ru
    m.yandex.ua
    m.yandex.uz
    m.zen.yandex.com
    m.znatoki.yandex.ru
    mail.yandex.com.tr
    mail.yandex.ru
    maps
    maps-beta
    maps-index
    maps-others
    maps-panorama
    maps-traffic
    maps-ua
    maps.yandex.com.tr
    maps.yandex.ru
    maps.yandex.ru/wizard
    maps.yandex.ua
    market-category
    market-category-models
    market-main
    market.yandex.ru
    metrica.yandex.ru
    metro.yandex.ru
    microsoft-desktop-morda-zenlib-rtb
    microsoft.yandex.ru
    mirror.yandex.ru
    mobi.mgeek.tunnybrowser
    mobile.yandex.com.tr
    mobile.yandex.ru
    mobile.yandex.ua
    moikrug-main
    moikrug-topics
    money-a-ya
    money-cards
    money-doc
    money-main
    money-p2p
    money-pay-success
    money-prepaid
    money-shops
    money-success
    money-success-prepaid
    money-success-win
    money.yandex.ru
    mp3-counting
    music.yandex.ru
    n.maps.yandex.ru
    narod.yandex.ru
    news-category
    news-main
    news-search
    news.yandex.ru
    old.yandex.ru
    olymp2010.yandex.ru
    partner-code.yandex.ru
    partner2.yandex.ru
    pcode-ci.mds.yandex.net
    pcode-ci.s3.mds.yandex.net
    pda-afisha-main
    pda-auto
    pda-blogs
    pda-fotki
    pda-mail
    pda-mail-done
    pda-main
    pda-maps-address
    pda-maps-main
    pda-maps-metro
    pda-market
    pda-rasp
    people.yandex.ru
    play-main
    play-other
    pogoda.yandex.com
    pogoda.yandex.com.tr
    pogoda.yandex.ru
    pogoda.yandex.ua
    q.yandex.ru
    rabota.yandex.ru
    radio.yandex.ru
    rasp.yandex.com.tr
    rasp.yandex.ru
    realty.yandex.ru
    ru.autoru
    ru.auto.ara
    ru.kinopoisk
    ru.yandex.disk
    ru.yandex.khamovniki
    ru.yandex.mail
    ru.yandex.metro
    ru.yandex.mobile
    ru.yandex.mobile.metricasample
    ru.yandex.mobile.gasstations
    ru.yandex.mobile.metro
    ru.yandex.mobile.music
    ru.yandex.mobile.navigator
    ru.yandex.mobile.realty
    ru.yandex.mobile.search
    ru.yandex.mobile.search.ipad
    ru.yandex.mobile.translate
    ru.yandex.mobile.transport
    ru.yandex.mobile.weather
    ru.yandex.mobile.weather-v2
    ru.yandex.rasp
    ru.yandex.searchplugin
    ru.yandex.searchplugin.alice
    ru.yandex.searchplugin.beta
    ru.yandex.traffic
    ru.yandex.translate
    ru.yandex.weatherplugin
    ru.yandex.yandexbus
    ru.yandex.yandexmaps
    ru.yandex.yandexnavi
    ru.yandex.yandexnavi.inhouse
    ru.yandex.yandexnavi.sandbox
    ru.yandex.ymarket
    search.yaca.yandex.ru
    site.yandex.ru
    slider
    slider-beta
    slovari.yandex.ru
    so-main
    sport.yandex.ru
    sprav.yandex.ru
    stream.yandex.ru
    stripe
    t.rasp.yandex.ru
    talk.yandex.ru
    taxi.yandex.ru
    tel.yandex.ru
    thequestion.ru
    ticket.yandex.ru
    ticket.yandex.tr
    toloka.yandex.ru
    touch-apps
    tr.yandex.mobile.metro
    trains.yandex.ru
    translate.yandex.ru
    translate.yandex.ru/m/translate
    translate.yandex.tr
    transport.yandex.ru
    travel.yandex.ru
    tune.yandex.ru
    tutor.yandex.ru
    tv-main
    tv.m.yandex.ru
    tv.yandex.ru
    uslugi.yandex.ru
    video-upload
    video.yandex.by
    video.yandex.com
    video.yandex.com.tr
    video.yandex.kz
    video.yandex.ru
    video.yandex.ua
    video.yandex.uz
    wc2010.yandex.ru
    wdevx.yandex.ru
    weather-main
    webmaster-addurl
    www.yandex.com.tr
    ya.ru
    yaca.yandex.ru
    yan-test.yandex.net
    yandex-2009-main
    yandex-2009-others
    yandex-main
    yandex-main-app
    yandex-main-lite
    yandex-mobile
    yandex-school
    yandex-ua-main
    yandex-ua-main-lite
    yandex.by
    yandex.com
    yandex.com.tr
    yandex.ee
    yandex.fi
    yandex.kz
    yandex.lt
    yandex.lv
    yandex.pl
    yandex.ru
    yandex.ru/news
    yandex.ru/search
    yandex.tr
    yandex.ua
    yandex.uz
    yandexadexchange.net
    zen.yadnex.ru
    zen.yandex.com
    zen.yandex.com.tr
    zen.yandex.ru
    zen.yandex.ua
    znatoki.yandex.ru
#;

1;

