#!/usr/bin/perl

=head1 NAME

=head1 DESCRIPTION

    Нужно добавить двести строк и заполнить колонку parent_id в таблице crypta_goals.
    Так таблица еще не используется, проще всего ее очистить и заполнить заново.

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

$log->out('START');

$log->out("going to delete all records from crypta_goals");

do_sql(PPCDICT, "delete from crypta_goals");

my $DATA = [
    [2499000001, 2499000021, "Мужчины", "social_demo", "crypta_gender_male_name", "crypta_gender_male_description", "long-term", "", "616", "0", "", ""],
    [2499000002, 2499000021, "Женщины", "social_demo", "crypta_gender_female_name", "crypta_gender_female_description", "long-term", "", "616", "1", "", ""],
    [2499000003, 2499000022, "<18", "social_demo", "crypta_age_segment_0_17_name", "crypta_age_segment_0_17_description", "long-term", "", "617", "0", "", ""],
    [2499000004, 2499000022, "18-24", "social_demo", "crypta_age_segment_18_24_name", "crypta_age_segment_18_24_description", "long-term", "", "617", "1", "", ""],
    [2499000005, 2499000022, "25-34", "social_demo", "crypta_age_segment_25_34_name", "crypta_age_segment_25_34_description", "long-term", "", "617", "2", "", ""],
    [2499000006, 2499000022, "35-44", "social_demo", "crypta_age_segment_35_44_name", "crypta_age_segment_35_44_description", "long-term", "", "617", "3", "", ""],
    [2499000007, 2499000022, "45-54", "social_demo", "crypta_age_segment_45_54_name", "crypta_age_segment_45_54_description", "long-term", "", "617", "4", "", ""],
    [2499000008, 2499000022, "55+", "social_demo", "crypta_age_segment_55_99_name", "crypta_age_segment_55_99_description", "long-term", "", "617", "5", "", ""],
    [2499000009, 2499000023, "Низкий", "social_demo", "crypta_income_segment_a_name", "crypta_income_segment_a_description", "long-term", "", "618", "0", "", ""],
    [2499000010, 2499000023, "Средний", "social_demo", "crypta_income_segment_b1_name", "crypta_income_segment_b1_description", "long-term", "", "618", "1", "", ""],
    [2499000012, 2499000023, "Высокий", "social_demo", "crypta_income_segment_c1_name", "crypta_income_segment_c1_description", "long-term", "", "618", "3", "", ""],
    [2499000013, 2499000023, "Премиум", "social_demo", "crypta_income_segment_c2_name", "crypta_income_segment_c2_description", "long-term", "", "618", "4", "", ""],
    [2499000021, 0, "Пол", "social_demo", "0", "0", "long-term", "", "0", "0", "", ""],
    [2499000022, 0, "Возраст", "social_demo", "0", "0", "long-term", "", "0", "0", "", ""],
    [2499000023, 0, "Доход", "social_demo", "0", "0", "long-term", "", "0", "0", "", ""],
    [2499000100, 0, "Семейное положение", "family", "0", "0", "", "", "0", "0", "", ""],
    [2499000101, 2499000100, "Состоят в браке", "family", "crypta_family_status_married_name", "crypta_family_status_married_description", "long-term", "", "0", "0", "", ""],
    [2499000102, 2499000100, "Не состоят в браке", "family", "crypta_family_status_not_married_name", "crypta_family_status_not_married_description", "long-term", "", "217", "109", "", ""],
    [2499000110, 0, "Наличие детей", "family", "0", "0", "", "", "0", "0", "", ""],
    [2499000111, 2499000110, "Планируют беременность или ждут рождение ребенка", "family", "crypta_family_planning_children_name", "crypta_family_planning_children_description", "long-term", "", "217", "565", "", ""],
    [2499000112, 2499000110, "Есть дети до 1 года", "family", "crypta_family_has_infants_name", "crypta_family_has_infants_description", "long-term", "", "217", "567", "", ""],
    [2499000113, 2499000110, "Есть дети 1–3 лет", "family", "crypta_family_has_children_1_3_name", "crypta_family_has_children_1_3_description", "long-term", "", "217", "580", "", ""],
    [2499000114, 2499000110, "Есть дети 3-6 лет", "family", "crypta_family_has_children_3_6_name", "crypta_family_has_children_3_6_description", "long-term", "", "217", "581", "", ""],
    [2499000115, 2499000110, "Есть дети 6-11 лет", "family", "crypta_family_has_children_6_11_name", "crypta_family_has_children_6_11_description", "long-term", "", "217", "582", "", ""],
    [2499000116, 2499000110, "Есть дети 11-16 лет", "family", "crypta_family_has_children_11_16_name", "crypta_family_has_children_11_16_description", "long-term", "", "217", "583", "", ""],
    [2499000120, 0, "Профессии", "family", "0", "0", "", "", "0", "0", "", ""],
    [2499000121, 2499000120, "Таксисты", "family", "crypta_profession_taxi_driver_name", "crypta_profession_taxi_driver_description", "long-term", "", "216", "542", "", ""],
    [2499000122, 2499000120, "Маркетологи", "family", "crypta_profession_marketer_name", "crypta_profession_marketer_description", "long-term", "", "216", "628", "", ""],
    [2499000123, 2499000120, "Дизайнеры", "family", "crypta_profession_designer_name", "crypta_profession_designer_description", "long-term", "", "216", "634", "", ""],
    [2499000124, 2499000120, "Врачи", "family", "crypta_profession_medic_name", "crypta_profession_medic_description", "long-term", "", "216", "679", "", ""],
    [2499000125, 2499000120, "Юристы", "family", "crypta_profession_lawyer_name", "crypta_profession_lawyer_description", "long-term", "", "216", "680", "", ""],
    [2499000126, 2499000120, "Менеджеры по персоналу", "family", "crypta_profession_hr_specialist_name", "crypta_profession_hr_specialist_description", "long-term", "", "216", "681", "", ""],
    [2499000127, 2499000120, "Преподаватели", "family", "crypta_profession_teacher_name", "crypta_profession_teacher_description", "long-term", "", "216", "682", "", ""],
    [2499000128, 2499000120, "Финансисты", "family", "crypta_profession_financier_name", "crypta_profession_financier_description", "long-term", "", "216", "684", "", ""],
    [2499000129, 2499000120, "Разработчики", "family", "crypta_profession_software_developer_name", "crypta_profession_software_developer_description", "long-term", "", "216", "685", "", ""],
    [2499000130, 2499000120, "Менеджеры по закупкам", "family", "crypta_profession_purchasing_manager_name", "crypta_profession_purchasing_manager_description", "long-term", "", "216", "117", "", ""],
    [2499001100, 2499001143, "Аксессуары", "interests", "crypta_interest_accessories_name", "crypta_interest_accessories_description", "all", "", "601", "194", "602", "194"],
    [2499001101, 2499001126, "Бухгалтерские услуги", "interests", "crypta_interest_accounting_services_name", "crypta_interest_accounting_services_description", "all", "", "601", "17", "602", "17"],
    [2499001102, 2499001170, "Дополнительное образование, курсы", "interests", "crypta_interest_additional_education_name", "crypta_interest_additional_education_description", "all", "", "602", "167", "601", "167"],
    [2499001103, 2499001126, "Реклама", "interests", "crypta_interest_advertising_name", "crypta_interest_advertising_description", "all", "", "602", "24", "601", "24"],
    [2499001104, 2499001213, "Климатическое оборудование для дома", "interests", "crypta_interest_air_conditioners_name", "crypta_interest_air_conditioners_description", "all", "", "601", "185", "602", "185"],
    [2499001105, 0, "Бытовая техника", "interests", "crypta_interest_appliances_name", "crypta_interest_appliances_description", "all", "", "602", "211", "601", "211"],
    [2499001106, 2499001213, "Техника для ухода за собой", "interests", "crypta_interest_appliances_for_personal_care_name", "crypta_interest_appliances_for_personal_care_description", "all", "", "601", "79", "602", "79"],
    [2499001107, 2499001243, "Квадроциклы", "interests", "crypta_interest_atvs_name", "crypta_interest_atvs_description", "all", "", "601", "199", "602", "199"],
    [2499001108, 2499001171, "Аудио- и видеотехника", "interests", "crypta_interest_audio_and_video_equipment_name", "crypta_interest_audio_and_video_equipment_description", "all", "", "601", "187", "602", "187"],
    [2499001109, 2499001306, "Авто", "interests", "crypta_interest_auto_name", "crypta_interest_auto_description", "all", "", "601", "78", "602", "78"],
    [2499001110, 2499001142, "Детская одежда", "interests", "crypta_interest_baby_clothes_name", "crypta_interest_baby_clothes_description", "all", "", "601", "99", "602", "99"],
    [2499001111, 2499001176, "Детское питание", "interests", "crypta_interest_baby_food_name", "crypta_interest_baby_food_description", "all", "", "602", "180", "601", "180"],
    [2499001112, 2499001176, "Услуги няни", "interests", "crypta_interest_babysitting_service_name", "crypta_interest_babysitting_service_description", "all", "", "601", "25", "602", "25"],
    [2499001113, 2499001100, "Сумки и чемоданы", "interests", "crypta_interest_bags_name", "crypta_interest_bags_description", "all", "", "602", "27", "601", "27"],
    [2499001114, 2499001178, "Банковские вклады", "interests", "crypta_interest_bank_deposits_name", "crypta_interest_bank_deposits_description", "all", "", "602", "77", "601", "77"],
    [2499001115, 2499001286, "Баскетбол", "interests", "crypta_interest_basketball_name", "crypta_interest_basketball_description", "all", "", "602", "93", "601", "93"],
    [2499001116, 2499001189, "Мебель для ванной", "interests", "crypta_interest_bathroom_furniture_name", "crypta_interest_bathroom_furniture_description", "all", "", "602", "172", "601", "172"],
    [2499001117, 0, "Красота и здоровье", "interests", "crypta_interest_beauty_and_health_name", "crypta_interest_beauty_and_health_description", "all", "", "601", "183", "602", "183"],
    [2499001118, 2499001189, "Мебель для спальни", "interests", "crypta_interest_bedroom_furniture_name", "crypta_interest_bedroom_furniture_description", "all", "", "601", "63", "602", "63"],
    [2499001119, 2499001189, "Кровати", "interests", "crypta_interest_beds_name", "crypta_interest_beds_description", "all", "", "602", "175", "601", "175"],
    [2499001120, 2499001255, "Птицы", "interests", "crypta_interest_birds_name", "crypta_interest_birds_description", "all", "", "602", "107", "601", "107"],
    [2499001121, 2499001282, "Блендеры", "interests", "crypta_interest_blenders_name", "crypta_interest_blenders_description", "all", "", "602", "195", "601", "195"],
    [2499001122, 2499001117, "Уход за телом", "interests", "crypta_interest_body_care_name", "crypta_interest_body_care_description", "all", "", "601", "30", "602", "30"],
    [2499001123, 2499001268, "Строительные инструменты", "interests", "crypta_interest_building_tools_name", "crypta_interest_building_tools_description", "all", "", "602", "10", "601", "10"],
    [2499001124, 2499001224, "Встраиваемые духовые шкафы", "interests", "crypta_interest_builtin_ovens_name", "crypta_interest_builtin_ovens_description", "all", "", "602", "177", "601", "177"],
    [2499001125, 2499001224, "Встраиваемые рабочие поверхности", "interests", "crypta_interest_builtin_work_surfaces_name", "crypta_interest_builtin_work_surfaces_description", "all", "", "601", "28", "602", "28"],
    [2499001126, 0, "Бизнес", "interests", "crypta_interest_business_name", "crypta_interest_business_description", "all", "", "602", "173", "601", "173"],
    [2499001127, 2499001189, "Шкафы", "interests", "crypta_interest_cabinets_name", "crypta_interest_cabinets_description", "all", "", "601", "22", "602", "22"],
    [2499001128, 2499001171, "Фото- и видеокамеры", "interests", "crypta_interest_cameras_name", "crypta_interest_cameras_description", "all", "", "601", "119", "602", "119"],
    [2499001129, 2499001109, "Автострахование", "interests", "crypta_interest_car_insurance_name", "crypta_interest_car_insurance_description", "all", "", "602", "157", "601", "157"],
    [2499001130, 2499001109, "Автозапчасти и аксессуары", "interests", "crypta_interest_car_parts_name", "crypta_interest_car_parts_description", "all", "", "601", "38", "602", "38"],
    [2499001131, 2499001266, "Прокат автомобилей", "interests", "crypta_interest_car_rental_name", "crypta_interest_car_rental_description", "all", "", "602", "74", "601", "74"],
    [2499001132, 2499001109, "Автомобили", "interests", "crypta_interest_cars_name", "crypta_interest_cars_description", "all", "", "602", "91", "601", "91"],
    [2499001133, 2499001109, "Техобслуживание автомобилей", "interests", "crypta_interest_car_service_name", "crypta_interest_car_service_description", "all", "", "602", "67", "601", "67"],
    [2499001134, 2499001179, "Расчетно-кассовое обслуживание", "interests", "crypta_interest_cash_services_name", "crypta_interest_cash_services_description", "all", "", "601", "191", "602", "191"],
    [2499001135, 2499001255, "Кошки", "interests", "crypta_interest_cats_name", "crypta_interest_cats_description", "all", "", "602", "162", "601", "162"],
    [2499001136, 2499001171, "Мобильные телефоны", "interests", "crypta_interest_cell_phones_name", "crypta_interest_cell_phones_description", "all", "", "601", "146", "602", "146"],
    [2499001137, 2499001189, "Стулья", "interests", "crypta_interest_chairs_name", "crypta_interest_chairs_description", "all", "", "602", "221", "601", "221"],
    [2499001138, 2499001266, "Детский отдых", "interests", "crypta_interest_childrens_holidays_name", "crypta_interest_childrens_holidays_description", "all", "", "601", "113", "602", "113"],
    [2499001139, 2499001278, "Детская обувь", "interests", "crypta_interest_childrens_shoes_name", "crypta_interest_childrens_shoes_description", "all", "", "601", "16", "602", "16"],
    [2499001140, 2499001226, "Кино", "interests", "crypta_interest_cinema_name", "crypta_interest_cinema_description", "all", "", "601", "26", "602", "26"],
    [2499001141, 2499001286, "Скалолазание и альпинизм", "interests", "crypta_interest_climbing_name", "crypta_interest_climbing_description", "all", "", "602", "182", "601", "182"],
    [2499001142, 2499001143, "Одежда", "interests", "crypta_interest_clothing_name", "crypta_interest_clothing_description", "all", "", "602", "197", "601", "197"],
    [2499001143, 0, "Одежда, обувь и аксессуары", "interests", "crypta_interest_clothing_shoes_accessories_name", "crypta_interest_clothing_shoes_accessories_description", "all", "", "601", "141", "602", "141"],
    [2499001144, 2499001184, "Кофе", "interests", "crypta_interest_coffee_name", "crypta_interest_coffee_description", "all", "", "602", "137", "601", "137"],
    [2499001145, 2499001282, "Кофеварки и кофемашины", "interests", "crypta_interest_coffee_machines_name", "crypta_interest_coffee_machines_description", "all", "", "602", "165", "601", "165"],
    [2499001146, 2499001265, "Коммерческая недвижимость", "interests", "crypta_interest_commercial_property_name", "crypta_interest_commercial_property_description", "all", "", "601", "223", "602", "223"],
    [2499001147, 2499001194, "Компьютерные игры", "interests", "crypta_interest_computer_games_name", "crypta_interest_computer_games_description", "all", "", "601", "6", "602", "6"],
    [2499001148, 2499001171, "Компьютерная техника", "interests", "crypta_interest_computers_name", "crypta_interest_computers_description", "all", "", "602", "12", "601", "12"],
    [2499001149, 2499001247, "Концерты", "interests", "crypta_interest_concerts_name", "crypta_interest_concerts_description", "all", "", "601", "111", "602", "111"],
    [2499001150, 2499001194, "Консольные игры", "interests", "crypta_interest_console_games_name", "crypta_interest_console_games_description", "all", "", "602", "7", "601", "7"],
    [2499001151, 0, "Строительство, обустройство и ремонт", "interests", "crypta_interest_construction_installation_and_repair_name", "crypta_interest_construction_installation_and_repair_description", "all", "", "602", "115", "601", "115"],
    [2499001152, 2499001233, "Контактные линзы", "interests", "crypta_interest_contact_lenses_name", "crypta_interest_contact_lenses_description", "all", "", "602", "181", "601", "181"],
    [2499001153, 2499001184, "Кулинария", "interests", "crypta_interest_cooking_name", "crypta_interest_cooking_description", "all", "", "602", "112", "601", "112"],
    [2499001154, 2499001117, "Декоративная косметика", "interests", "crypta_interest_cosmetics_name", "crypta_interest_cosmetics_description", "all", "", "601", "19", "602", "19"],
    [2499001155, 2499001265, "Загородная недвижимость", "interests", "crypta_interest_country_estate_name", "crypta_interest_country_estate_description", "all", "", "601", "124", "602", "124"],
    [2499001156, 2499001126, "Создание и продвижение сайтов", "interests", "crypta_interest_creation_and_promotion_of_sites_name", "crypta_interest_creation_and_promotion_of_sites_description", "all", "", "602", "225", "601", "225"],
    [2499001157, 2499001178, "Кредитные карты", "interests", "crypta_interest_credit_cards_name", "crypta_interest_credit_cards_description", "all", "", "601", "108", "602", "108"],
    [2499001158, 2499001266, "Круизы", "interests", "crypta_interest_cruises_name", "crypta_interest_cruises_description", "all", "", "602", "178", "601", "178"],
    [2499001159, 2499001189, "Мягкая мебель", "interests", "crypta_interest_cushioned_furniture_name", "crypta_interest_cushioned_furniture_description", "all", "", "602", "125", "601", "125"],
    [2499001160, 2499001226, "Танцы", "interests", "crypta_interest_dancing_name", "crypta_interest_dancing_description", "all", "", "602", "47", "601", "47"],
    [2499001161, 2499001184, "Доставка готовых блюд", "interests", "crypta_interest_delivery_food_name", "crypta_interest_delivery_food_description", "all", "", "602", "57", "601", "57"],
    [2499001162, 2499001179, "Депозиты для бизнеса", "interests", "crypta_interest_deposits_for_business_name", "crypta_interest_deposits_for_business_description", "all", "", "601", "59", "602", "59"],
    [2499001163, 2499001148, "Настольные компьютеры", "interests", "crypta_interest_desktops_name", "crypta_interest_desktops_description", "all", "", "601", "204", "602", "204"],
    [2499001164, 2499001233, "Диагностическое оборудование", "interests", "crypta_interest_diagnostic_equipment_name", "crypta_interest_diagnostic_equipment_description", "all", "", "601", "41", "602", "41"],
    [2499001165, 2499001224, "Посудомоечные машины", "interests", "crypta_interest_dishwashers_name", "crypta_interest_dishwashers_description", "all", "", "602", "155", "601", "155"],
    [2499001166, 2499001286, "Дайвинг", "interests", "crypta_interest_diving_name", "crypta_interest_diving_description", "all", "", "602", "40", "601", "40"],
    [2499001167, 2499001255, "Собаки", "interests", "crypta_interest_dogs_name", "crypta_interest_dogs_description", "all", "", "602", "170", "601", "170"],
    [2499001168, 2499001268, "Двери", "interests", "crypta_interest_doors_name", "crypta_interest_doors_description", "all", "", "602", "102", "601", "102"],
    [2499001169, 2499001109, "Подготовка водителей", "interests", "crypta_interest_driver_training_name", "crypta_interest_driver_training_description", "all", "", "601", "64", "602", "64"],
    [2499001170, 0, "Образование", "interests", "crypta_interest_education_name", "crypta_interest_education_description", "all", "", "601", "1", "602", "1"],
    [2499001171, 0, "Электроника", "interests", "crypta_interest_electronics_name", "crypta_interest_electronics_description", "all", "", "601", "192", "602", "192"],
    [2499001172, 2499001154, "Декоративная косметика для глаз", "interests", "crypta_interest_eye_makeup_name", "crypta_interest_eye_makeup_description", "all", "", "602", "85", "601", "85"],
    [2499001173, 2499001268, "Сайдинг и фасадные панели", "interests", "crypta_interest_facade_panels_name", "crypta_interest_facade_panels_description", "all", "", "602", "215", "601", "215"],
    [2499001174, 2499001117, "Уход за лицом", "interests", "crypta_interest_face_care_name", "crypta_interest_face_care_description", "all", "", "601", "81", "602", "81"],
    [2499001175, 2499001154, "Декоративная косметика для лица", "interests", "crypta_interest_face_cosmetics_name", "crypta_interest_face_cosmetics_description", "all", "", "601", "65", "602", "65"],
    [2499001176, 0, "Семья и дети", "interests", "crypta_interest_family_name", "crypta_interest_family_description", "all", "", "602", "34", "601", "34"],
    [2499001177, 2499001286, "Фигурное катание", "interests", "crypta_interest_figure_skating_name", "crypta_interest_figure_skating_description", "all", "", "602", "69", "601", "69"],
    [2499001178, 0, "Финансы", "interests", "crypta_interest_finance_name", "crypta_interest_finance_description", "all", "", "601", "76", "602", "76"],
    [2499001179, 2499001178, "Финансовые услуги для бизнеса", "interests", "crypta_interest_financial_services_for_business_name", "crypta_interest_financial_services_for_business_description", "all", "", "602", "48", "601", "48"],
    [2499001180, 2499001255, "Рыбы", "interests", "crypta_interest_fish_name", "crypta_interest_fish_description", "all", "", "601", "104", "602", "104"],
    [2499001181, 2499001286, "Фитнес", "interests", "crypta_interest_fitness_name", "crypta_interest_fitness_description", "all", "", "601", "186", "602", "186"],
    [2499001182, 2499001266, "Авиабилеты", "interests", "crypta_interest_flight_tickets_name", "crypta_interest_flight_tickets_description", "all", "", "602", "142", "601", "142"],
    [2499001183, 2499001268, "Напольные покрытия", "interests", "crypta_interest_floor_coverings_name", "crypta_interest_floor_coverings_description", "all", "", "601", "18", "602", "18"],
    [2499001184, 0, "Еда и напитки", "interests", "crypta_interest_food_and_drink_name", "crypta_interest_food_and_drink_description", "all", "", "601", "55", "602", "55"],
    [2499001185, 2499001282, "Мясорубки, кухонные комбайны и измельчители", "interests", "crypta_interest_food_processors_name", "crypta_interest_food_processors_description", "all", "", "601", "140", "602", "140"],
    [2499001186, 2499001286, "Футбол", "interests", "crypta_interest_football_name", "crypta_interest_football_description", "all", "", "602", "226", "601", "226"],
    [2499001187, 2499001178, "Форекс", "interests", "crypta_interest_forex_name", "crypta_interest_forex_description", "all", "", "602", "82", "601", "82"],
    [2499001188, 2499001224, "Холодильники", "interests", "crypta_interest_fridges_name", "crypta_interest_fridges_description", "all", "", "601", "106", "602", "106"],
    [2499001189, 2499001151, "Мебель", "interests", "crypta_interest_furniture_name", "crypta_interest_furniture_description", "all", "", "601", "61", "602", "61"],
    [2499001190, 2499001189, "Мебель для прихожей", "interests", "crypta_interest_furniture_for_anteroom_name", "crypta_interest_furniture_for_anteroom_description", "all", "", "602", "134", "601", "134"],
    [2499001191, 2499001189, "Мебель для детской", "interests", "crypta_interest_furniture_for_children_name", "crypta_interest_furniture_for_children_description", "all", "", "601", "149", "602", "149"],
    [2499001192, 2499001189, "Мебель для кухни", "interests", "crypta_interest_furniture_for_kitchen_name", "crypta_interest_furniture_for_kitchen_description", "all", "", "601", "109", "602", "109"],
    [2499001193, 2499001189, "Мебель для гостиной", "interests", "crypta_interest_furniture_for_living_room_name", "crypta_interest_furniture_for_living_room_description", "all", "", "601", "126", "602", "126"],
    [2499001194, 2499001226, "Игры", "interests", "crypta_interest_games_name", "crypta_interest_games_description", "all", "", "602", "5", "601", "5"],
    [2499001195, 2499001171, "Игровые приставки", "interests", "crypta_interest_gaming_consoles_name", "crypta_interest_gaming_consoles_description", "all", "", "602", "83", "601", "83"],
    [2499001196, 2499001292, "Садовая техника", "interests", "crypta_interest_garden_machinery_name", "crypta_interest_garden_machinery_description", "all", "", "602", "203", "601", "203"],
    [2499001197, 2499001292, "Садовый инвентарь", "interests", "crypta_interest_garden_tools_name", "crypta_interest_garden_tools_description", "all", "", "601", "110", "602", "110"],
    [2499001198, 2499001100, "Очки", "interests", "crypta_interest_glasses_name", "crypta_interest_glasses_description", "all", "", "601", "105", "602", "105"],
    [2499001199, 2499001255, "Товары для животных", "interests", "crypta_interest_goods_for_pets_name", "crypta_interest_goods_for_pets_description", "all", "", "601", "179", "602", "179"],
    [2499001200, 2499001117, "Уход за волосами", "interests", "crypta_interest_hair_care_name", "crypta_interest_hair_care_description", "all", "", "602", "54", "601", "54"],
    [2499001201, 2499001108, "Наушники", "interests", "crypta_interest_headphones_name", "crypta_interest_headphones_description", "all", "", "601", "153", "602", "153"],
    [2499001202, 2499001170, "Вуз", "interests", "crypta_interest_higher_education_name", "crypta_interest_higher_education_description", "all", "", "602", "3", "601", "3"],
    [2499001203, 2499001266, "Походный отдых", "interests", "crypta_interest_hiking_holidays_name", "crypta_interest_hiking_holidays_description", "all", "", "601", "73", "602", "73"],
    [2499001204, 2499001286, "Хоккей", "interests", "crypta_interest_hockey_name", "crypta_interest_hockey_description", "all", "", "601", "70", "602", "70"],
    [2499001205, 2499001266, "Отдых в Африке", "interests", "crypta_interest_holidays_in_africa_name", "crypta_interest_holidays_in_africa_description", "all", "", "601", "144", "602", "144"],
    [2499001206, 2499001266, "Отдых в Америке", "interests", "crypta_interest_holidays_in_america_name", "crypta_interest_holidays_in_america_description", "all", "", "601", "174", "602", "174"],
    [2499001207, 2499001266, "Отдых в Азии", "interests", "crypta_interest_holidays_in_asia_name", "crypta_interest_holidays_in_asia_description", "all", "", "601", "151", "602", "151"],
    [2499001208, 2499001266, "Отдых в Австралии и Океании", "interests", "crypta_interest_holidays_in_australia_and_oceania_name", "crypta_interest_holidays_in_australia_and_oceania_description", "all", "", "602", "123", "601", "123"],
    [2499001209, 2499001266, "Отдых в Европе", "interests", "crypta_interest_holidays_in_europe_name", "crypta_interest_holidays_in_europe_description", "all", "", "601", "103", "602", "103"],
    [2499001210, 2499001266, "Отдых в России и СНГ", "interests", "crypta_interest_holydays_in_russia_name", "crypta_interest_holydays_in_russia_description", "all", "", "601", "39", "602", "39"],
    [2499001211, 2499001286, "Конный спорт", "interests", "crypta_interest_horseback_riding_name", "crypta_interest_horseback_riding_description", "all", "", "602", "222", "601", "222"],
    [2499001212, 2499001266, "Отели", "interests", "crypta_interest_hotels_name", "crypta_interest_hotels_description", "all", "", "602", "219", "601", "219"],
    [2499001213, 2499001105, "Бытовая техника для дома", "interests", "crypta_interest_household_appliances_name", "crypta_interest_household_appliances_description", "all", "", "601", "193", "602", "193"],
    [2499001214, 2499001266, "Автовокзалы", "interests", "crypta_interest_intercity_buses_name", "crypta_interest_intercity_buses_description", "all", "", "601", "201", "602", "201"],
    [2499001215, 2499001151, "Дизайн интерьера", "interests", "crypta_interest_interior_design_name", "crypta_interest_interior_design_description", "all", "", "601", "23", "602", "23"],
    [2499001216, 2499001299, "Доступ в интернет", "interests", "crypta_interest_internet_providers_name", "crypta_interest_internet_providers_description", "all", "", "601", "209", "602", "209"],
    [2499001217, 2499001178, "Инвестиции", "interests", "crypta_interest_investments_name", "crypta_interest_investments_description", "all", "", "602", "9", "601", "9"],
    [2499001218, 0, "Работа", "interests", "crypta_interest_jobs_name", "crypta_interest_jobs_description", "all", "", "601", "189", "602", "189"],
    [2499001219, 2499001218, "Поиск работы", "interests", "crypta_interest_job_search_name", "crypta_interest_job_search_description", "all", "", "602", "87", "601", "87"],
    [2499001220, 2499001282, "Соковыжималки", "interests", "crypta_interest_juicers_name", "crypta_interest_juicers_description", "all", "", "601", "139", "602", "139"],
    [2499001221, 2499001224, "Кухонные вытяжки", "interests", "crypta_interest_kitchen_hoods_name", "crypta_interest_kitchen_hoods_description", "all", "", "602", "53", "601", "53"],
    [2499001222, 2499001224, "Кухонные плиты", "interests", "crypta_interest_kitchen_stoves_name", "crypta_interest_kitchen_stoves_description", "all", "", "602", "97", "601", "97"],
    [2499001223, 2499001148, "Ноутбуки", "interests", "crypta_interest_laptops_name", "crypta_interest_laptops_description", "all", "", "602", "122", "601", "122"],
    [2499001224, 2499001105, "Крупная бытовая техника для кухни", "interests", "crypta_interest_large_kitchen_appliances_name", "crypta_interest_large_kitchen_appliances_description", "all", "", "602", "127", "601", "127"],
    [2499001225, 2499001126, "Юридическая поддержка", "interests", "crypta_interest_legal_support_name", "crypta_interest_legal_support_description", "all", "", "602", "130", "601", "130"],
    [2499001226, 0, "Досуг", "interests", "crypta_interest_leisure_name", "crypta_interest_leisure_description", "all", "", "602", "4", "601", "4"],
    [2499001227, 2499001154, "Декоративная косметика для губ", "interests", "crypta_interest_lips_cosmetics_name", "crypta_interest_lips_cosmetics_description", "all", "", "602", "138", "601", "138"],
    [2499001228, 2499001178, "Кредиты", "interests", "crypta_interest_loans_name", "crypta_interest_loans_description", "all", "", "601", "118", "602", "118"],
    [2499001229, 2499001179, "Кредиты для бизнеса", "interests", "crypta_interest_loans_for_business_name", "crypta_interest_loans_for_business_description", "all", "", "601", "116", "602", "116"],
    [2499001230, 2499001171, "Манипуляторы и клавиатуры", "interests", "crypta_interest_manipulators_and_keyboards_name", "crypta_interest_manipulators_and_keyboards_description", "all", "", "601", "214", "602", "214"],
    [2499001231, 2499001286, "Единоборства", "interests", "crypta_interest_martial_arts_name", "crypta_interest_martial_arts_description", "all", "", "602", "72", "601", "72"],
    [2499001232, 2499001189, "Матрасы", "interests", "crypta_interest_mattresses_name", "crypta_interest_mattresses_description", "all", "", "602", "152", "601", "152"],
    [2499001233, 2499001117, "Медицинские товары", "interests", "crypta_interest_medical_goods_name", "crypta_interest_medical_goods_description", "all", "", "602", "208", "601", "208"],
    [2499001234, 2499001142, "Мужская одежда", "interests", "crypta_interest_mens_clothing_name", "crypta_interest_mens_clothing_description", "all", "", "602", "220", "601", "220"],
    [2499001235, 2499001253, "Мужская парфюмерия", "interests", "crypta_interest_mens_perfumes_name", "crypta_interest_mens_perfumes_description", "all", "", "602", "160", "601", "160"],
    [2499001236, 2499001278, "Мужская обувь", "interests", "crypta_interest_mens_shoes_name", "crypta_interest_mens_shoes_description", "all", "", "602", "200", "601", "200"],
    [2499001237, 2499001282, "Пароварки, аэрогрили, мини-печи и ростеры, хлебопечи ", "interests", "crypta_interest_miniovens_name", "crypta_interest_miniovens_description", "all", "", "602", "131", "601", "131"],
    [2499001238, 2499001109, "Минивэны", "interests", "crypta_interest_minivans_name", "crypta_interest_minivans_description", "all", "", "601", "31", "602", "31"],
    [2499001239, 2499001299, "Мобильная связь", "interests", "crypta_interest_mobiles_carriers_name", "crypta_interest_mobiles_carriers_description", "all", "", "602", "163", "601", "163"],
    [2499001240, 2499001148, "Мониторы", "interests", "crypta_interest_monitors_name", "crypta_interest_monitors_description", "all", "", "601", "166", "602", "166"],
    [2499001241, 2499001243, "Мопеды", "interests", "crypta_interest_mopeds_name", "crypta_interest_mopeds_description", "all", "", "602", "98", "601", "98"],
    [2499001242, 2499001178, "Ипотека", "interests", "crypta_interest_mortgage_name", "crypta_interest_mortgage_description", "all", "", "602", "44", "601", "44"],
    [2499001243, 2499001306, "Мото", "interests", "crypta_interest_moto_name", "crypta_interest_moto_description", "all", "", "601", "224", "602", "224"],
    [2499001244, 2499001243, "Мотоциклы", "interests", "crypta_interest_motorcycles_name", "crypta_interest_motorcycles_description", "all", "", "602", "218", "601", "218"],
    [2499001245, 2499001282, "Мультиварки", "interests", "crypta_interest_multicooker_name", "crypta_interest_multicooker_description", "all", "", "602", "94", "601", "94"],
    [2499001246, 2499001226, "Музеи", "interests", "crypta_interest_museums_name", "crypta_interest_museums_description", "all", "", "601", "15", "602", "15"],
    [2499001247, 2499001226, "Музыка", "interests", "crypta_interest_music_name", "crypta_interest_music_description", "all", "", "601", "148", "602", "148"],
    [2499001248, 2499001247, "Музыкальные инструменты", "interests", "crypta_interest_musical_instruments_name", "crypta_interest_musical_instruments_description", "all", "", "602", "52", "601", "52"],
    [2499001249, 2499001154, "Декоративная косметика для ногтей", "interests", "crypta_interest_nails_cosmetics_name", "crypta_interest_nails_cosmetics_description", "all", "", "601", "156", "602", "156"],
    [2499001250, 2499001189, "Мебель для офиса и кабинета", "interests", "crypta_interest_office_furniture_name", "crypta_interest_office_furniture_description", "all", "", "602", "171", "601", "171"],
    [2499001251, 2499001142, "Верхняя одежда", "interests", "crypta_interest_outerwear_name", "crypta_interest_outerwear_description", "all", "", "602", "212", "601", "212"],
    [2499001252, 2499001268, "Лакокрасочные материалы", "interests", "crypta_interest_paints_name", "crypta_interest_paints_description", "all", "", "601", "20", "602", "20"],
    [2499001253, 2499001117, "Парфюмерия", "interests", "crypta_interest_perfumery_name", "crypta_interest_perfumery_description", "all", "", "601", "51", "602", "51"],
    [2499001254, 2499001255, "Корма для животных", "interests", "crypta_interest_pet_food_name", "crypta_interest_pet_food_description", "all", "", "601", "207", "602", "207"],
    [2499001255, 0, "Животные", "interests", "crypta_interest_pets_name", "crypta_interest_pets_description", "all", "", "602", "202", "601", "202"],
    [2499001256, 2499001109, "Пикапы", "interests", "crypta_interest_pickup_trucks_name", "crypta_interest_pickup_trucks_description", "all", "", "601", "46", "602", "46"],
    [2499001257, 2499001292, "Растения и семена", "interests", "crypta_interest_plants_and_seeds_name", "crypta_interest_plants_and_seeds_description", "all", "", "601", "86", "602", "86"],
    [2499001258, 2499001108, "Портативная аудиотехника", "interests", "crypta_interest_portable_audio_equipment_name", "crypta_interest_portable_audio_equipment_description", "all", "", "602", "37", "601", "37"],
    [2499001259, 2499001286, "Силовые виды спорта", "interests", "crypta_interest_power_sports_name", "crypta_interest_power_sports_description", "all", "", "601", "145", "602", "145"],
    [2499001260, 2499001176, "Беременность и роды", "interests", "crypta_interest_pregnancy_name", "crypta_interest_pregnancy_description", "all", "", "601", "100", "602", "100"],
    [2499001261, 2499001265, "Жилая недвижимость премиум-класса", "interests", "crypta_interest_premium_property_name", "crypta_interest_premium_property_description", "all", "", "602", "80", "601", "80"],
    [2499001262, 2499001171, "Принтеры и МФУ", "interests", "crypta_interest_printers_name", "crypta_interest_printers_description", "all", "", "602", "88", "601", "88"],
    [2499001263, 2499001176, "Товары для детей", "interests", "crypta_interest_products_for_children_name", "crypta_interest_products_for_children_description", "all", "", "602", "14", "601", "14"],
    [2499001264, 2499001286, "Автоспорт", "interests", "crypta_interest_racing_name", "crypta_interest_racing_description", "all", "", "602", "114", "601", "114"],
    [2499001265, 0, "Недвижимость", "interests", "crypta_interest_realty_name", "crypta_interest_realty_description", "all", "", "602", "210", "601", "210"],
    [2499001266, 0, "Отдых и путешествия", "interests", "crypta_interest_recreation_and_travel_name", "crypta_interest_recreation_and_travel_description", "all", "", "602", "128", "601", "128"],
    [2499001267, 2499001265, "Аренда недвижимости", "interests", "crypta_interest_rental_property_name", "crypta_interest_rental_property_description", "all", "", "602", "120", "601", "120"],
    [2499001268, 2499001151, "Ремонт", "interests", "crypta_interest_repairs_name", "crypta_interest_repairs_description", "all", "", "601", "84", "602", "84"],
    [2499001269, 2499001265, "Жилая недвижимость", "interests", "crypta_interest_residential_properties_name", "crypta_interest_residential_properties_description", "all", "", "602", "35", "601", "35"],
    [2499001270, 2499001226, "Рестораны", "interests", "crypta_interest_restaurants_name", "crypta_interest_restaurants_description", "all", "", "602", "8", "601", "8"],
    [2499001271, 2499001255, "Грызуны и рептилии", "interests", "crypta_interest_rodents_and_reptiles_name", "crypta_interest_rodents_and_reptiles_description", "all", "", "602", "75", "601", "75"],
    [2499001272, 2499001268, "Кровля и водосток", "interests", "crypta_interest_roof_and_drain_name", "crypta_interest_roof_and_drain_description", "all", "", "602", "50", "601", "50"],
    [2499001273, 2499001268, "Сантехника", "interests", "crypta_interest_sanitary_engineering_name", "crypta_interest_sanitary_engineering_description", "all", "", "602", "13", "601", "13"],
    [2499001274, 2499001299, "Спутниковое и кабельное телевидение", "interests", "crypta_interest_satellite_and_cable_tv_name", "crypta_interest_satellite_and_cable_tv_description", "all", "", "601", "36", "602", "36"],
    [2499001275, 2499001170, "Школа", "interests", "crypta_interest_school_name", "crypta_interest_school_description", "all", "", "602", "2", "601", "2"],
    [2499001276, 2499001243, "Скутеры", "interests", "crypta_interest_scooters_name", "crypta_interest_scooters_description", "all", "", "601", "184", "602", "184"],
    [2499001277, 2499001151, "Системы охраны и сигнализации", "interests", "crypta_interest_security_systems_name", "crypta_interest_security_systems_description", "all", "", "601", "56", "602", "56"],
    [2499001278, 2499001143, "Обувь", "interests", "crypta_interest_shoes_name", "crypta_interest_shoes_description", "all", "", "601", "154", "602", "154"],
    [2499001279, 2499001286, "Стрельба", "interests", "crypta_interest_shooting_name", "crypta_interest_shooting_description", "all", "", "601", "101", "602", "101"],
    [2499001280, 2499001266, "Горнолыжный отдых", "interests", "crypta_interest_ski_holidays_name", "crypta_interest_ski_holidays_description", "all", "", "601", "129", "602", "129"],
    [2499001281, 2499001286, "Лыжный спорт", "interests", "crypta_interest_skiing_name", "crypta_interest_skiing_description", "all", "", "602", "45", "601", "45"],
    [2499001282, 2499001105, "Мелкая бытовая техника для кухни", "interests", "crypta_interest_small_kitchen_appliances_name", "crypta_interest_small_kitchen_appliances_description", "all", "", "601", "161", "602", "161"],
    [2499001283, 2499001151, "Системы «Умный дом»", "interests", "crypta_interest_smart_home_name", "crypta_interest_smart_home_description", "all", "", "601", "71", "602", "71"],
    [2499001284, 2499001171, "Умные часы и браслеты", "interests", "crypta_interest_smart_watches_and_bracelets_name", "crypta_interest_smart_watches_and_bracelets_description", "all", "", "601", "21", "602", "21"],
    [2499001285, 2499001243, "Снегоходы", "interests", "crypta_interest_snowmobiles_name", "crypta_interest_snowmobiles_description", "all", "", "602", "213", "601", "213"],
    [2499001286, 0, "Спорт", "interests", "crypta_interest_sport_name", "crypta_interest_sport_description", "all", "", "602", "216", "601", "216"],
    [2499001287, 2499001278, "Спортивная обувь", "interests", "crypta_interest_sport_shoes_name", "crypta_interest_sport_shoes_description", "all", "", "602", "49", "601", "49"],
    [2499001288, 2499001142, "Спортивная одежда", "interests", "crypta_interest_sportswear_name", "crypta_interest_sportswear_description", "all", "", "601", "159", "602", "159"],
    [2499001289, 2499001108, "Стационарная аудиотехника", "interests", "crypta_interest_stationary_audio_equipment_name", "crypta_interest_stationary_audio_equipment_description", "all", "", "601", "95", "602", "95"],
    [2499001290, 2499001268, "Натяжные потолки", "interests", "crypta_interest_stretch_ceiling_name", "crypta_interest_stretch_ceiling_description", "all", "", "601", "121", "602", "121"],
    [2499001291, 2499001170, "Обучение за рубежом", "interests", "crypta_interest_study_abroad_name", "crypta_interest_study_abroad_description", "all", "", "601", "164", "602", "164"],
    [2499001292, 2499001151, "Дача и сад", "interests", "crypta_interest_summer_house_garden_name", "crypta_interest_summer_house_garden_description", "all", "", "602", "58", "601", "58"],
    [2499001293, 2499001109, "Внедорожники", "interests", "crypta_interest_suvs_name", "crypta_interest_suvs_description", "all", "", "601", "68", "602", "68"],
    [2499001294, 2499001286, "Плавание", "interests", "crypta_interest_swimming_name", "crypta_interest_swimming_description", "all", "", "601", "62", "602", "62"],
    [2499001295, 2499001189, "Столы", "interests", "crypta_interest_tables_name", "crypta_interest_tables_description", "all", "", "602", "168", "601", "168"],
    [2499001296, 2499001286, "Настольный теннис", "interests", "crypta_interest_table_tennis_name", "crypta_interest_table_tennis_description", "all", "", "601", "60", "602", "60"],
    [2499001297, 2499001148, "Планшеты", "interests", "crypta_interest_tablets_name", "crypta_interest_tablets_description", "all", "", "601", "169", "602", "169"],
    [2499001298, 2499001184, "Чай", "interests", "crypta_interest_tea_name", "crypta_interest_tea_description", "all", "", "601", "158", "602", "158"],
    [2499001299, 0, "Телеком", "interests", "crypta_interest_telecom_name", "crypta_interest_telecom_description", "all", "", "602", "43", "601", "43"],
    [2499001300, 2499001226, "Телевидение", "interests", "crypta_interest_television_name", "crypta_interest_television_description", "all", "", "601", "190", "602", "190"],
    [2499001301, 2499001286, "Большой теннис", "interests", "crypta_interest_tennis_name", "crypta_interest_tennis_description", "all", "", "602", "29", "601", "29"],
    [2499001302, 2499001226, "Театры", "interests", "crypta_interest_theaters_name", "crypta_interest_theaters_description", "all", "", "602", "32", "601", "32"],
    [2499001303, 2499001268, "Плитка", "interests", "crypta_interest_tile_name", "crypta_interest_tile_description", "all", "", "602", "133", "601", "133"],
    [2499001304, 2499001109, "Шины и диски", "interests", "crypta_interest_tires_and_wheels_name", "crypta_interest_tires_and_wheels_description", "all", "", "602", "132", "601", "132"],
    [2499001305, 2499001266, "Билеты на поезд", "interests", "crypta_interest_train_tickets_name", "crypta_interest_train_tickets_description", "all", "", "602", "217", "601", "217"],
    [2499001306, 0, "Транспорт", "interests", "crypta_interest_transport_name", "crypta_interest_transport_description", "all", "", "602", "176", "601", "176"],
    [2499001307, 2499001126, "Грузоперевозки и транспортные услуги", "interests", "crypta_interest_transport_services_name", "crypta_interest_transport_services_description", "all", "", "602", "205", "601", "205"],
    [2499001308, 2499001266, "Страхование путешественников", "interests", "crypta_interest_travel_insurance_name", "crypta_interest_travel_insurance_description", "all", "", "602", "135", "601", "135"],
    [2499001309, 2499001108, "Телевизоры и плазменные панели", "interests", "crypta_interest_tv_sets_name", "crypta_interest_tv_sets_description", "all", "", "601", "11", "602", "11"],
    [2499001310, 2499001109, "Подержанные автомобили", "interests", "crypta_interest_used_cars_name", "crypta_interest_used_cars_description", "all", "", "601", "33", "602", "33"],
    [2499001311, 2499001213, "Пылесосы", "interests", "crypta_interest_vacuum_cleaners_name", "crypta_interest_vacuum_cleaners_description", "all", "", "601", "150", "602", "150"],
    [2499001312, 2499001286, "Волейбол", "interests", "crypta_interest_volleyball_name", "crypta_interest_volleyball_description", "all", "", "601", "227", "602", "227"],
    [2499001313, 2499001109, "Универсалы", "interests", "crypta_interest_wagons_name", "crypta_interest_wagons_description", "all", "", "602", "89", "601", "89"],
    [2499001314, 2499001268, "Обои", "interests", "crypta_interest_wallpaper_name", "crypta_interest_wallpaper_description", "all", "", "602", "42", "601", "42"],
    [2499001315, 2499001213, "Стиральные машины", "interests", "crypta_interest_washing_machines_name", "crypta_interest_washing_machines_description", "all", "", "601", "196", "602", "196"],
    [2499001316, 2499001100, "Часы", "interests", "crypta_interest_watches_name", "crypta_interest_watches_description", "all", "", "601", "206", "602", "206"],
    [2499001317, 2499001184, "Доставка воды", "interests", "crypta_interest_water_delivery_name", "crypta_interest_water_delivery_description", "all", "", "601", "96", "602", "96"],
    [2499001318, 2499001176, "Свадьба", "interests", "crypta_interest_wedding_name", "crypta_interest_wedding_description", "all", "", "601", "66", "602", "66"],
    [2499001319, 2499001266, "Свадебный отдых", "interests", "crypta_interest_wedding_holidays_name", "crypta_interest_wedding_holidays_description", "all", "", "601", "143", "602", "143"],
    [2499001320, 2499001268, "Окна", "interests", "crypta_interest_windows_name", "crypta_interest_windows_description", "all", "", "602", "136", "601", "136"],
    [2499001321, 2499001142, "Женская одежда", "interests", "crypta_interest_womens_clothing_name", "crypta_interest_womens_clothing_description", "all", "", "601", "198", "602", "198"],
    [2499001322, 2499001253, "Женская парфюмерия", "interests", "crypta_interest_womens_perfumes_name", "crypta_interest_womens_perfumes_description", "all", "", "601", "188", "602", "188"],
    [2499001323, 2499001278, "Женская обувь", "interests", "crypta_interest_womens_shoes_name", "crypta_interest_womens_shoes_description", "all", "", "601", "147", "602", "147"],
    [2499001324, 2499001218, "Работа за рубежом", "interests", "crypta_interest_work_abroad_name", "crypta_interest_work_abroad_description", "all", "", "602", "117", "601", "117"],
    [2499001325, 2499001218, "Работа на дому", "interests", "crypta_interest_work_at_home_name", "crypta_interest_work_at_home_description", "all", "", "602", "92", "601", "92"],
    [2499001326, 2499001286, "Яхтенный спорт", "interests", "crypta_interest_yachting_name", "crypta_interest_yachting_description", "all", "", "602", "90", "601", "90"],
];

$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, tags, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short) values %s', $DATA);

$log->out("FINISH");
