#!/usr/bin/perl

=head1 DESCRIPTION

=cut

use Direct::Modern;
use Yandex::DBTools;
use my_inc "../..";
use ScriptHelper;
use Settings;

$log->out('START');

my $feature_settings = '{"is_accessible_after_disabling":false,"roles":["SUPER","SUPERREADER"],"percent":0}';

my $DATA = [
    ["recommendation_availability",                  "Доступность рекомендаций в целом",                                                                        $feature_settings],
    ["recommendation_daily_budget",                  "Доступность рекомендации 'Повысьте ограничение бюджета эффективных кампаний'",                            $feature_settings],
    ["recommendation_remove_pages_from_black_list",  "Доступность рекомендации 'Уберите качественные площадки из запрещённых'",                                 $feature_settings],
    ["recommendation_send_licenses_banks",           "Доступность рекомендации 'Отправьте гарантийное письмо по запрещённой тематике — банковские услуги'",     $feature_settings],
    ["recommendation_send_licenses_pharmacy",        "Доступность рекомендации 'Отправьте гарантийное письмо по запрещённой тематике — аптеки и лекарства'",    $feature_settings],
    ["recommendation_send_licenses_med_services",    "Доступность рекомендации 'Отправьте гарантийное письмо по запрещённой тематике — медицинские услуги'",    $feature_settings],
    ["recommendation_switch_on_autotargeting",       "Доступность рекомендации 'Включите автотаргетинг'",                                                       $feature_settings],
    ["recommendation_add_more_pictures_to_adgroup",  "Доступность рекомендации 'Добавьте форматы картинок'",                                                    $feature_settings],
    ["recommendation_change_adgroup_for_moderation", "Доступность рекомендации 'Измените объявления, чтобы они прошли модерацию'",                              $feature_settings],
    ["recommendation_change_adgroup_with_low_stat",  "Доступность рекомендации 'Исправьте объявления, по которым мало показов'",                                $feature_settings],
];

$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into features (feature_text_id, feature_public_name, settings) values %s', $DATA);

$log->out("FINISH");

