#!/usr/bin/perl

=head1 NAME

=head1 DESCRIPTION

    Нужно добавить 36 строк в таблицу ppdict.crypta_goals.

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

$log->out('START');

$log->out("going to delete records from crypta_goals to prevent duplicates");

do_sql(PPCDICT, "delete from crypta_goals where crypta_goal_type = 'interests' and tanker_name_key in ('crypta_interest_snowboarding_name', 'crypta_interest_skateboarding_name', 'crypta_interest_roller_skates_name', 'crypta_interest_fishing_name', 'crypta_interest_hunting_name', 'crypta_interest_decor_name', 'crypta_interest_books_name', 'crypta_interest_franchising_name', 'crypta_interest_loan_refinancing_name', 'crypta_interest_leasing_name', 'crypta_interest_cybersport_name', 'crypta_interest_baby_car_seats_name', 'crypta_interest_jewelry_name', 'crypta_interest_healthy_eating_name', 'crypta_interest_sports_nutrition_name', 'crypta_interest_opening_a_business_name', 'crypta_interest_childrens_books_name', 'crypta_interest_clothes_for_babies_name', 'crypta_interest_baby_carriages_name', 'crypta_interest_kids_toys_name', 'crypta_interest_toys_for_babies_name', 'crypta_interest_childrens_bicycles_name', 'crypta_interest_childrens_scooters_name', 'crypta_interest_teeth_care_appliances_name', 'crypta_interest_mens_electric_shaver_name', 'crypta_interest_womens_electric_shavers_name', 'crypta_interest_hair_styling_appliances_name', 'crypta_interest_hair_shampoos_name', 'crypta_interest_hair_care_products_name', 'crypta_interest_hair_styling_name', 'crypta_interest_hair_coloring_products_name', 'crypta_interest_online_banking_name', 'crypta_interest_8d9ae7ac_name', 'crypta_interest_mobile_games_name', 'crypta_interest_payment_technologies_name')");

my $DATA = [
    [2499001376,2499001286,"Сноубординг","interests","crypta_interest_snowboarding_name","crypta_interest_snowboarding_description","all",601,289,602,289],
    [2499001377,2499001286,"Скейтбординг","interests","crypta_interest_skateboarding_name","crypta_interest_skateboarding_description","all",601,290,602,290],
    [2499001378,2499001286,"Роликовые коньки","interests","crypta_interest_roller_skates_name","crypta_interest_roller_skates_description","all",601,291,602,291],
    [2499001379,2499001226,"Рыбалка","interests","crypta_interest_fishing_name","crypta_interest_fishing_description","all",601,298,602,298],
    [2499001380,2499001226,"Охота","interests","crypta_interest_hunting_name","crypta_interest_hunting_description","all",601,299,602,299],
    [2499001381,2499001226,"Декор","interests","crypta_interest_decor_name","crypta_interest_decor_description","all",601,302,602,302],
    [2499001382,2499001226,"Книги","interests","crypta_interest_books_name","crypta_interest_books_description","all",601,300,602,300],
    [2499001383,2499001126,"Франчайзинг","interests","crypta_interest_franchising_name","crypta_interest_franchising_description","all",601,306,602,306],
    [2499001384,2499001178,"Рефинансирование кредитов","interests","crypta_interest_loan_refinancing_name","crypta_interest_loan_refinancing_description","all",601,277,602,277],
    [2499001385,2499001109,"Лизинг автомобилей и спецтехники","interests","crypta_interest_leasing_name","crypta_interest_leasing_description","all",601,278,602,287],
    [2499001386,2499001194,"Киберспорт","interests","crypta_interest_cybersport_name","crypta_interest_cybersport_description","all",601,301,602,301],
    [2499001387,2499001109,"Детские автокресла","interests","crypta_interest_baby_car_seats_name","crypta_interest_baby_car_seats_description","all",601,288,602,288],
    [2499001388,2499001100,"Ювелирные украшения","interests","crypta_interest_jewelry_name","crypta_interest_jewelry_description","all",601,304,602,304],
    [2499001389,2499001117,"Здоровое питание","interests","crypta_interest_healthy_eating_name","crypta_interest_healthy_eating_description","all",601,315,602,315],
    [2499001390,2499001286,"Спортивное питание","interests","crypta_interest_sports_nutrition_name","crypta_interest_sports_nutrition_description","all",601,316,602,316],
    [2499001391,2499001126,"Открытие бизнеса","interests","crypta_interest_opening_a_business_name","crypta_interest_opening_a_business_description","all",601,314,602,314],
    [2499001392,2499001263,"Детские книги","interests","crypta_interest_childrens_books_name","crypta_interest_childrens_books_description","all",601,295,602,295],
    [2499001393,2499001142,"Одежда для малышей","interests","crypta_interest_clothes_for_babies_name","crypta_interest_clothes_for_babies_description","all",601,303,602,303],
    [2499001395,2499001263,"Детские коляски","interests","crypta_interest_baby_carriages_name","crypta_interest_baby_carriages_description","all",601,294,602,294],
    [2499001396,2499001263,"Детские игрушки","interests","crypta_interest_kids_toys_name","crypta_interest_kids_toys_description","all",601,296,602,296],
    [2499001397,2499001263,"Игрушки для малышей","interests","crypta_interest_toys_for_babies_name","crypta_interest_toys_for_babies_description","all",601,292,602,292],
    [2499001398,2499001263,"Детские велосипеды","interests","crypta_interest_childrens_bicycles_name","crypta_interest_childrens_bicycles_description","all",601,297,602,297],
    [2499001399,2499001263,"Детские самокаты","interests","crypta_interest_childrens_scooters_name","crypta_interest_childrens_scooters_description","all",601,293,602,293],
    [2499001400,2499001106,"Устройства для ухода за полостью рта","interests","crypta_interest_teeth_care_appliances_name","crypta_interest_teeth_care_appliances_description","all",601,310,602,310],
    [2499001401,2499001106,"Мужские электробритвы","interests","crypta_interest_mens_electric_shaver_name","crypta_interest_mens_electric_shaver_description","all",601,308,602,308],
    [2499001402,2499001106,"Женские электробритвы и эпиляторы","interests","crypta_interest_womens_electric_shavers_name","crypta_interest_womens_electric_shavers_description","all",601,307,602,307],
    [2499001403,2499001106,"Приборы для укладки волос","interests","crypta_interest_hair_styling_appliances_name","crypta_interest_hair_styling_appliances_description","all",601,309,602,309],
    [2499001404,2499001200,"Шампуни для волос","interests","crypta_interest_hair_shampoos_name","crypta_interest_hair_shampoos_description","all",601,305,602,305],
    [2499001405,2499001200,"Уход после мытья волос","interests","crypta_interest_hair_care_products_name","crypta_interest_hair_care_products_description","all",601,313,602,313],
    [2499001406,2499001200,"Укладка волос","interests","crypta_interest_hair_styling_name","crypta_interest_hair_styling_description","all",601,312,602,312],
    [2499001407,2499001200,"Окрашивание волос","interests","crypta_interest_hair_coloring_products_name","crypta_interest_hair_coloring_products_description","all",601,311,602,311],
    [2499001408,2499001178,"Интернет-банкинг","interests","crypta_interest_online_banking_name","crypta_interest_online_banking_description","all",601,317,602,317],
    [2499001409,2499001109,"Фуры","interests","crypta_interest_8d9ae7ac_name","crypta_interest_8d9ae7ac_description","all",601,276,602,276],
    [2499001410,2499001194,"Мобильные игры","interests","crypta_interest_mobile_games_name","crypta_interest_mobile_games_description","all",601,319,602,319],
    [2499001411,2499001178,"Современные платежные технологии","interests","crypta_interest_payment_technologies_name","crypta_interest_payment_technologies_description","all",601,318,602,318]
];
$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short) values %s', $DATA);

$log->out("FINISH");
