#!/usr/bin/perl

=head1 NAME

=head1 DESCRIPTION

    Нужно добавить 53 строки в таблицу ppdict.crypta_goals.

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

$log->out('START');

$log->out("going to delete records from crypta_goals to prevent duplicates");

do_sql(PPCDICT, "delete from crypta_goals where crypta_goal_type = 'behaviors' and tanker_name_key in ('crypta_group-8130912a_name', 'crypta_visited-fastfood-houses_name', 'crypta_visited-cafes-houses_name', "
."'crypta_visited-coffee-houses_name', 'crypta_visited-pizzeria_name', 'crypta_visited-restaurants_name', 'crypta_visited-canteens-houses_name', 'crypta_visited-sushi-bars_name', 'crypta_visited-alco-shops_name', "
."'crypta_visited-appliances-shops_name', 'crypta_visited-children-shops_name', 'crypta_visited-pet-shops_name', 'crypta_visited-computer-shops_name', 'crypta_visited-furniture-shops_name', 'crypta_visited-clothes-shops_name', "
."'crypta_visited-property-agencies_name', 'crypta_visited-new-apartments_name', 'crypta_visited-commercial-property_name', 'crypta_visited-repairs_name', 'crypta_visited-higher-education_name', 'crypta_visited-kindergartens_name', "
."'crypta_visited-additional-education_name', 'crypta_visited-special-education_name', 'crypta_visited-schools_name', 'crypta_visited-bathhouses_name', 'crypta_visited-bars_name', 'crypta_visited-zoos_name', 'crypta_visited-hookah-bars_name', "
."'crypta_visited-сinemas_name', 'crypta_visited-museums_name', 'crypta_visited-night-clubs_name', 'crypta_visited-parks_name', 'crypta_segment-697486a3_name', 'crypta_segment-4e27e523_name', 'crypta_visited-entertainment-centers_name', "
."'crypta_visited-theaters_name', 'crypta_segment-32b18ad0_name', 'crypta_visited-water-sports_name', 'crypta_visited-sports-shops_name', 'crypta_visited-sport-objects_name', 'crypta_visited-fitness-yoga_name', "
."'crypta_visited-car-service_name', 'crypta_visited-fuel-parking_name', 'crypta_visited-parts-shops_name', 'crypta_visited-cars-sales_name', 'crypta_visited-hotels_name', 'crypta_visited-resorts_name', "
."'crypta_visited-hostels_name', 'crypta_visited-courts-service_name', 'crypta_visited-bank-service_name', 'crypta_visited-post-service_name', 'crypta_visited-selfcare-service_name', 'crypta_visited-legal-service_name')");

my $DATA = [
    [2499000265, 0, "behaviors", "Посещения организаций", "crypta_group-8130912a_name", "crypta_group-8130912a_description", "all", 0, 0, 0, 0],
    [2499000266, 2499000265, "behaviors", "Быстрое питание", "crypta_visited-fastfood-houses_name", "crypta_visited-fastfood-houses_description", "all", 547, 1088, 547, 1088],
    [2499000267, 2499000265, "behaviors", "Кафе", "crypta_visited-cafes-houses_name", "crypta_visited-cafes-houses_description", "all", 547, 1087, 547, 1087],
    [2499000268, 2499000265, "behaviors", "Кофейни", "crypta_visited-coffee-houses_name", "crypta_visited-coffee-houses_description", "all", 547, 1086, 547, 1086],
    [2499000269, 2499000265, "behaviors", "Пиццерии", "crypta_visited-pizzeria_name", "crypta_visited-pizzeria_description", "all", 547, 1084, 547, 1084],
    [2499000270, 2499000265, "behaviors", "Рестораны", "crypta_visited-restaurants_name", "crypta_visited-restaurants_description", "all", 547, 1085, 547, 1085],
    [2499000271, 2499000265, "behaviors", "Столовые", "crypta_visited-canteens-houses_name", "crypta_visited-canteens-houses_description", "all", 547, 1089, 547, 1089],
    [2499000272, 2499000265, "behaviors", "Японская кухня", "crypta_visited-sushi-bars_name", "crypta_visited-sushi-bars_description", "all", 547, 1090, 547, 1090],
    [2499000273, 2499000265, "behaviors", "Магазины алкоголя", "crypta_visited-alco-shops_name", "crypta_visited-alco-shops_description", "all", 547, 1077, 547, 1077],
    [2499000274, 2499000265, "behaviors", "Магазины бытовой техники", "crypta_visited-appliances-shops_name", "crypta_visited-appliances-shops_description", "all", 547, 1075, 547, 1075],
    [2499000275, 2499000265, "behaviors", "Магазины детских товаров", "crypta_visited-children-shops_name", "crypta_visited-children-shops_description", "all", 547, 1074, 547, 1074],
    [2499000276, 2499000265, "behaviors", "Магазины для домашних животных и ветеринария", "crypta_visited-pet-shops_name", "crypta_visited-pet-shops_description", "all", 547, 1078, 547, 1078],
    [2499000277, 2499000265, "behaviors", "Магазины компьютеров", "crypta_visited-computer-shops_name", "crypta_visited-computer-shops_description", "all", 547, 1071, 547, 1071],
    [2499000278, 2499000265, "behaviors", "Магазины мебели и предметов интерьера", "crypta_visited-furniture-shops_name", "crypta_visited-furniture-shops_description", "all", 547, 1073, 547, 1073],
    [2499000279, 2499000265, "behaviors", "Магазины одежды, обуви, аксессуаров", "crypta_visited-clothes-shops_name", "crypta_visited-clothes-shops_description", "all", 547, 1072, 547, 1072],
    [2499000280, 2499000265, "behaviors", "Агентства недвижимости", "crypta_visited-property-agencies_name", "crypta_visited-property-agencies_description", "all", 547, 1116, 547, 1116],
    [2499000281, 2499000265, "behaviors", "Офисы продаж квартир в новостройках", "crypta_visited-new-apartments_name", "crypta_visited-new-apartments_description", "all", 547, 1115, 547, 1115],
    [2499000282, 2499000265, "behaviors", "Продажа и аренда коммерческой недвижимости", "crypta_visited-commercial-property_name", "crypta_visited-commercial-property_description", "all", 547, 1114, 547, 1114],
    [2499000283, 2499000265, "behaviors", "Ремонт, отделка, стройматериалы, проектирование", "crypta_visited-repairs_name", "crypta_visited-repairs_description", "all", 547, 1113, 547, 1113],
    [2499000284, 2499000265, "behaviors", "Высшее образование", "crypta_visited-higher-education_name", "crypta_visited-higher-education_description", "all", 547, 1111, 547, 1111],
    [2499000285, 2499000265, "behaviors", "Детские сады", "crypta_visited-kindergartens_name", "crypta_visited-kindergartens_description", "all", 547, 1108, 547, 1108],
    [2499000286, 2499000265, "behaviors", "Дополнительное образование", "crypta_visited-additional-education_name", "crypta_visited-additional-education_description", "all", 547, 1110, 547, 1110],
    [2499000287, 2499000265, "behaviors", "Среднее специальное образование", "crypta_visited-special-education_name", "crypta_visited-special-education_description", "all", 547, 1112, 547, 1112],
    [2499000288, 2499000265, "behaviors", "Школы", "crypta_visited-schools_name", "crypta_visited-schools_description", "all", 547, 1109, 547, 1109],
    [2499000289, 2499000265, "behaviors", "Бани и сауны", "crypta_visited-bathhouses_name", "crypta_visited-bathhouses_description", "all", 547, 1100, 547, 1100],
    [2499000290, 2499000265, "behaviors", "Бары", "crypta_visited-bars_name", "crypta_visited-bars_description", "all", 547, 1098, 547, 1098],
    [2499000291, 2499000265, "behaviors", "Зоопарки, дельфинарии, океанариумы", "crypta_visited-zoos_name", "crypta_visited-zoos_description", "all", 547, 1101, 547, 1101],
    [2499000292, 2499000265, "behaviors", "Кальянные", "crypta_visited-hookah-bars_name", "crypta_visited-hookah-bars_description", "all", 547, 1099, 547, 1099],
    [2499000293, 2499000265, "behaviors", "Кинотеатры", "crypta_visited-сinemas_name", "crypta_visited-сinemas_description", "all", 547, 1095, 547, 1095],
    [2499000294, 2499000265, "behaviors", "Музеи", "crypta_visited-museums_name", "crypta_visited-museums_description", "all", 547, 1097, 547, 1097],
    [2499000295, 2499000265, "behaviors", "Ночные клубы", "crypta_visited-night-clubs_name", "crypta_visited-night-clubs_description", "all", 547, 1103, 547, 1103],
    [2499000296, 2499000265, "behaviors", "Парки", "crypta_visited-parks_name", "crypta_visited-parks_description", "all", 547, 1102, 547, 1102],
    [2499000297, 2499000265, "behaviors", "Парки аттракционов", "crypta_segment-697486a3_name", "crypta_segment-697486a3_description", "all", 547, 1265, 547, 1265],
    [2499000298, 2499000265, "behaviors", "Развлекательные комплексы и игротеки для детей", "crypta_segment-4e27e523_name", "crypta_segment-4e27e523_description", "all", 547, 1264, 547, 1264],
    [2499000299, 2499000265, "behaviors", "Развлекательные центры", "crypta_visited-entertainment-centers_name", "crypta_visited-entertainment-centers_description", "all", 547, 1104, 547, 1104],
    [2499000300, 2499000265, "behaviors", "Театры", "crypta_visited-theaters_name", "crypta_visited-theaters_description", "all", 547, 1096, 547, 1096],
    [2499000301, 2499000265, "behaviors", "Цирки", "crypta_segment-32b18ad0_name", "crypta_segment-32b18ad0_description", "all", 547, 1263, 547, 1263],
    [2499000302, 2499000265, "behaviors", "Водный спорт", "crypta_visited-water-sports_name", "crypta_visited-water-sports_description", "all", 547, 1093, 547, 1093],
    [2499000303, 2499000265, "behaviors", "Магазины спортивных товаров", "crypta_visited-sports-shops_name", "crypta_visited-sports-shops_description", "all", 547, 1094, 547, 1094],
    [2499000304, 2499000265, "behaviors", "Спортивные сооружения", "crypta_visited-sport-objects_name", "crypta_visited-sport-objects_description", "all", 547, 1091, 547, 1091],
    [2499000305, 2499000265, "behaviors", "Фитнес и йога", "crypta_visited-fitness-yoga_name", "crypta_visited-fitness-yoga_description", "all", 547, 1092, 547, 1092],
    [2499000306, 2499000265, "behaviors", "Автосервисы", "crypta_visited-car-service_name", "crypta_visited-car-service_description", "all", 547, 1070, 547, 1070],
    [2499000307, 2499000265, "behaviors", "Заправки и автостоянки", "crypta_visited-fuel-parking_name", "crypta_visited-fuel-parking_description", "all", 547, 1068, 547, 1068],
    [2499000308, 2499000265, "behaviors", "Магазины запчастей", "crypta_visited-parts-shops_name", "crypta_visited-parts-shops_description", "all", 547, 1069, 547, 1069],
    [2499000309, 2499000265, "behaviors", "Продажа автомобилей", "crypta_visited-cars-sales_name", "crypta_visited-cars-sales_description", "all", 547, 1067, 547, 1067],
    [2499000310, 2499000265, "behaviors", "Гостиницы", "crypta_visited-hotels_name", "crypta_visited-hotels_description", "all", 547, 1105, 547, 1105],
    [2499000311, 2499000265, "behaviors", "Санатории и дома отдыха", "crypta_visited-resorts_name", "crypta_visited-resorts_description", "all", 547, 1106, 547, 1106],
    [2499000312, 2499000265, "behaviors", "Хостелы", "crypta_visited-hostels_name", "crypta_visited-hostels_description", "all", 547, 1107, 547, 1107],
    [2499000313, 2499000265, "behaviors", "Суды", "crypta_visited-courts-service_name", "crypta_visited-courts-service_description", "all", 547, 1083, 547, 1083],
    [2499000314, 2499000265, "behaviors", "Банки и банкоматы", "crypta_visited-bank-service_name", "crypta_visited-bank-service_description", "all", 547, 1081, 547, 1081],
    [2499000315, 2499000265, "behaviors", "Почтовые и курьерские службы", "crypta_visited-post-service_name", "crypta_visited-post-service_description", "all", 547, 1080, 547, 1080],
    [2499000316, 2499000265, "behaviors", "Уход за внешностью", "crypta_visited-selfcare-service_name", "crypta_visited-selfcare-service_description", "all", 547, 1079, 547, 1079],
    [2499000317, 2499000265, "behaviors", "Юридические услуги", "crypta_visited-legal-service_name", "crypta_visited-legal-service_description", "all", 547, 1082, 547, 1082]
];
$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, crypta_goal_type, name, tanker_name_key, tanker_description_key, interest_type, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short) values %s', $DATA);

$log->out("FINISH");
