#!/usr/bin/perl

=head1 NAME

=head1 DESCRIPTION

    Нужно добавить 64 строк в таблицу ppdict.crypta_goals.

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

$log->out('START');

$log->out("going to delete records from crypta_goals to prevent duplicates");

do_sql(PPCDICT, "delete from crypta_goals where crypta_goal_type in ('content_category', 'content_genre')");

my $DATA = [
    [4294968296,0,"Авто","content_category","content_genre_auto_name","content_genre_auto_description","all","content_category",4294968296,4294968296,4294968296,'common'],
    [4294968297,0,"Бизнес и промышленность","content_category","content_genre_industry_name","content_genre_industry_description","all","content_category",4294968297,4294968297,4294968297,'common'],
    [4294968298,0,"География и путешествия","content_category","content_genre_travel_name","content_genre_travel_description","all","content_category",4294968298,4294968298,4294968298,'common'],
    [4294968299,4294968298,"Зарубежный туризм","content_category","content_genre_foreign_tourism_name","content_genre_foreign_tourism_description","all","content_category",4294968299,4294968299,4294968299,'common'],
    [4294968300,4294968298,"Отечественный туризм","content_category","content_genre_domestic_tourism_name","content_genre_domestic_tourism_description","all","content_category",4294968300,4294968300,4294968300,'common'],
    [4294968301,4294968298,"Авиабилеты и гостиницы","content_category","content_genre_flights_name","content_genre_flights_description","all","content_category",4294968301,4294968301,4294968301,'common'],
    [4294968302,0,"Дом и сад","content_category","content_genre_house_name","content_genre_house_description","all","content_category",4294968302,4294968302,4294968302,'common'],
    [4294968303,4294968302,"Интерьер","content_category","content_genre_interior_name","content_genre_interior_description","all","content_category",4294968303,4294968303,4294968303,'common'],
    [4294968304,4294968302,"Загород","content_category","content_genre_garden_name","content_genre_garden_description","all","content_category",4294968304,4294968304,4294968304,'common'],
    [4294968305,0,"Домашние животные","content_category","content_genre_pets_name","content_genre_pets_description","all","content_category",4294968305,4294968305,4294968305,'common'],
    [4294968306,4294968305,"Кошки","content_category","content_genre_cats_name","content_genre_cats_description","all","content_category",4294968306,4294968306,4294968306,'common'],
    [4294968307,4294968305,"Собаки","content_category","content_genre_dogs_name","content_genre_dogs_description","all","content_category",4294968307,4294968307,4294968307,'common'],
    [4294968308,0,"Еда и напитки","content_category","content_genre_food_name","content_genre_food_description","all","content_category",4294968308,4294968308,4294968308,'common'],
    [4294968309,4294968308,"Рестораны и бары","content_category","content_genre_bars_name","content_genre_bars_description","all","content_category",4294968309,4294968309,4294968309,'common'],
    [4294968310,4294968308,"Кулинария","content_category","content_genre_cooking_name","content_genre_cooking_description","all","content_category",4294968310,4294968310,4294968310,'common'],
    [4294968311,4294968308,"Кафе и фастфуд","content_category","content_genre_cafe_name","content_genre_cafe_description","all","content_category",4294968311,4294968311,4294968311,'common'],
    [4294968312,4294968308,"Правильное питание","content_category","content_genre_healthy_food_name","content_genre_healthy_food_description","all","content_category",4294968312,4294968312,4294968312,'common'],
    [4294968313,0,"Закон и право","content_category","content_genre_law_name","content_genre_law_description","all","content_category",4294968313,4294968313,4294968313,'common'],
    [4294968314,0,"Игры","content_category","content_genre_games_name","content_genre_games_description","all","content_category",4294968314,4294968314,4294968314,'common'],
    [4294968315,4294968314,"Киберспорт","content_category","content_genre_esport_name","content_genre_esport_description","all","content_category",4294968315,4294968315,4294968315,'common'],
    [4294968316,4294968314,"Обзоры и летсплеи","content_category","content_genre_letsplay_name","content_genre_letsplay_description","all","content_category",4294968316,4294968316,4294968316,'common'],
    [4294968317,0,"Интернет и телекоммуникации","content_category","content_genre_internet_name","content_genre_internet_description","all","content_category",4294968317,4294968317,4294968317,'common'],
    [4294968318,0,"Искусство и развлечения","content_category","content_genre_art_name","content_genre_art_description","all","content_category",4294968318,4294968318,4294968318,'common'],
    [4294968319,0,"Книги и литература","content_category","content_genre_literature_name","content_genre_literature_description","all","content_category",4294968319,4294968319,4294968319,'common'],
    [4294968320,4294968319,"Отечественная литература","content_category","content_genre_domestic_literature_name","content_genre_domestic_literature_description","all","content_category",4294968320,4294968320,4294968320,'common'],
    [4294968321,4294968319,"Зарубежная литература","content_category","content_genre_foreign_literature_name","content_genre_foreign_literature_description","all","content_category",4294968321,4294968321,4294968321,'common'],
    [4294968322,4294968319,"Детская литература","content_category","content_genre_childrens_literature_name","content_genre_childrens_literature_description","all","content_category",4294968322,4294968322,4294968322,'common'],
    [4294968323,0,"Компьютеры и электроника","content_category","content_genre_computers_name","content_genre_computers_description","all","content_category",4294968323,4294968323,4294968323,'common'],
    [4294968324,0,"Красота и здоровье","content_category","content_genre_beauty_name","content_genre_beauty_description","all","content_category",4294968324,4294968324,4294968324,'common'],
    [4294968325,4294968324,"Спорт и Фитнес","content_category","content_genre_fitness_name","content_genre_fitness_description","all","content_category",4294968325,4294968325,4294968325,'common'],
    [4294968326,4294968324,"Здоровье","content_category","content_genre_health_name","content_genre_health_description","all","content_category",4294968326,4294968326,4294968326,'common'],
    [4294968327,4294968324,"Косметика","content_category","content_genre_cosmetics_name","content_genre_cosmetics_description","all","content_category",4294968327,4294968327,4294968327,'common'],
    [4294968328,0,"Люди и общество","content_category","content_genre_society_name","content_genre_society_description","all","content_category",4294968328,4294968328,4294968328,'common'],
    [4294968329,0,"Наука","content_category","content_genre_science_name","content_genre_science_description","all","content_category",4294968329,4294968329,4294968329,'common'],
    [4294968330,4294968329,"Популярная наука","content_category","content_genre_popular_science_name","content_genre_popular_science_description","all","content_category",4294968330,4294968330,4294968330,'common'],
    [4294968331,0,"Недвижимость","content_category","content_genre_estate_name","content_genre_estate_description","all","content_category",4294968331,4294968331,4294968331,'common'],
    [4294968332,0,"Новости","content_category","content_genre_news_name","content_genre_news_description","all","content_category",4294968332,4294968332,4294968332,'common'],
    [4294968333,0,"Работа","content_category","content_genre_job_name","content_genre_job_description","all","content_category",4294968333,4294968333,4294968333,'common'],
    [4294968334,0,"Образование","content_category","content_genre_education_name","content_genre_education_description","all","content_category",4294968334,4294968334,4294968334,'common'],
    [4294968335,0,"Спорт","content_category","content_genre_sport_name","content_genre_sport_description","all","content_category",4294968335,4294968335,4294968335,'common'],
    [4294968336,4294968335,"Футбол","content_category","content_genre_football_name","content_genre_football_description","all","content_category",4294968336,4294968336,4294968336,'common'],
    [4294968337,4294968335,"Хоккей","content_category","content_genre_hockey_name","content_genre_hockey_description","all","content_category",4294968337,4294968337,4294968337,'common'],
    [4294968338,4294968335,"Баскетбол","content_category","content_genre_basketball_name","content_genre_basketball_description","all","content_category",4294968338,4294968338,4294968338,'common'],
    [4294968339,4294968335,"Единоборства","content_category","content_genre_martial_arts_name","content_genre_martial_arts_description","all","content_category",4294968339,4294968339,4294968339,'common'],
    [4294968340,4294968335,"Аутдор и Экстремальные виды спорта","content_category","content_genre_extreme_name","content_genre_extreme_description","all","content_category",4294968340,4294968340,4294968340,'common'],
    [4294968341,0,"Бизнес, банкинг, финансы","content_category","content_genre_finance_name","content_genre_finance_description","all","content_category",4294968341,4294968341,4294968341,'common'],
    [4294968342,0,"Хобби и отдых","content_category","content_genre_relaxation_name","content_genre_relaxation_description","all","content_category",4294968342,4294968342,4294968342,'common'],
    [4294968343,4294968342,"Активный отдых","content_category","content_genre_leisure_name","content_genre_leisure_description","all","content_category",4294968343,4294968343,4294968343,'common'],
    [4294968344,4294968342,"Хобби","content_category","content_genre_hobby_name","content_genre_hobby_description","all","content_category",4294968344,4294968344,4294968344,'common'],
    [4294968345,0,"Шоппинг, покупки","content_category","content_genre_shopping_name","content_genre_shopping_description","all","content_category",4294968345,4294968345,4294968345,'common'],
    [4294968346,4294968345,"Одежда","content_category","content_genre_clothes_name","content_genre_clothes_description","all","content_category",4294968346,4294968346,4294968346,'common'],
    [4294968347,4294968345,"Товары для дома","content_category","content_genre_household_products_name","content_genre_household_products_description","all","content_category",4294968347,4294968347,4294968347,'common'],
    [4294968348,4294968345,"Продукты","content_category","content_genre_products_name","content_genre_products_description","all","content_category",4294968348,4294968348,4294968348,'common'],
    [4294970296,0,"Советское кино","content_genre","content_genre_soviet_cinema_name","content_genre_soviet_cinema_description","all","content_category",4294970296,4294970296,4294970296,'common'],
    [4294970297,0,"Зарубежное кино","content_genre","content_genre_foreign_cinema_name","content_genre_foreign_cinema_description","all","content_category",4294970297,4294970297,4294970297,'common'],
    [4294970298,0,"Мультфильмы","content_genre","content_genre_cartoon_name","content_genre_cartoon_description","all","content_category",4294970298,4294970298,4294970298,'common'],
    [4294970299,0,"Российское кино","content_genre","content_genre_russian_cinema_name","content_genre_russian_cinema_description","all","content_category",4294970299,4294970299,4294970299,'common'],
    [4294970300,0,"Комедии","content_genre","content_genre_comedy_name","content_genre_comedy_description","all","content_category",4294970300,4294970300,4294970300,'common'],
    [4294970301,0,"Мелодрамы","content_genre","content_genre_melodrama_name","content_genre_melodrama_description","all","content_category",4294970301,4294970301,4294970301,'common'],
    [4294970302,0,"Ужасы","content_genre","content_genre_horror_name","content_genre_horror_description","all","content_category",4294970302,4294970302,4294970302,'common'],
    [4294970303,0,"Боевики","content_genre","content_genre_action_name","content_genre_action_description","all","content_category",4294970303,4294970303,4294970303,'common'],
    [4294970304,0,"Фантастика","content_genre","content_genre_fantasy_name","content_genre_fantasy_description","all","content_category",4294970304,4294970304,4294970304,'common'],
    [4294970305,0,"Триллеры","content_genre","content_genre_thriller_name","content_genre_thriller_description","all","content_category",4294970305,4294970305,4294970305,'common'],
    [4294970306,0,"Детективы","content_genre","content_genre_detective_name","content_genre_detective_description","all","content_category",4294970306,4294970306,4294970306,'common']
];
$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short, scope) values %s', $DATA);

$log->out("FINISH");
