#!/usr/bin/perl

=head1 NAME

=head1 DESCRIPTION

    Нужно добавить 25 строк а заменить 2 в таблице ppdict.crypta_goals.

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

$log->out('START');

$log->out("going to delete records from crypta_goals to prevent duplicates");

do_sql(PPCDICT, "delete from crypta_goals where crypta_goal_type='content_category' and tanker_name_key in ('content_genre_law_name','content_genre_fitness_name','content_genre_female_name','content_genre_female_name','content_genre_bodybuilding_name','content_genre_rest_name')");

my $DATA = [
    [4294968313,0,"Закон, политика и право","content_category","content_genre_law_name","content_genre_law_description","all","content_category",4294968313,4294968313,4294968313,'common'],
    [4294968325,4294968324,"Фитнес","content_category","content_genre_fitness_name","content_genre_fitness_description","all","content_category",4294968325,4294968325,4294968325,'common'],
    [4294968350,4294968349,"Контент для мам","content_category","content_genre_female_name","content_genre_female_description","all","content_category",4294968350,4294968350,4294968350,'common'],
    [4294968352,4294968335,"Культуристский спорт","content_category","content_genre_bodybuilding_name","content_genre_bodybuilding_description","all","content_category",4294968352,4294968352,4294968352,'common'],
    [4294968353,4294968296,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968353,4294968353,4294968353,'common'],
    [4294968354,4294968297,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968354,4294968354,4294968354,'common'],
    [4294968355,4294968298,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968355,4294968355,4294968355,'common'],
    [4294968356,4294968302,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968356,4294968356,4294968356,'common'],
    [4294968357,4294968305,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968357,4294968357,4294968357,'common'],
    [4294968358,4294968308,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968358,4294968358,4294968358,'common'],
    [4294968359,4294968313,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968359,4294968359,4294968359,'common'],
    [4294968360,4294968314,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968360,4294968360,4294968360,'common'],
    [4294968361,4294968317,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968361,4294968361,4294968361,'common'],
    [4294968362,4294968318,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968362,4294968362,4294968362,'common'],
    [4294968363,4294968319,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968363,4294968363,4294968363,'common'],
    [4294968364,4294968323,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968364,4294968364,4294968364,'common'],
    [4294968365,4294968324,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968365,4294968365,4294968365,'common'],
    [4294968366,4294968328,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968366,4294968366,4294968366,'common'],
    [4294968367,4294968329,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968367,4294968367,4294968367,'common'],
    [4294968368,4294968331,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968368,4294968368,4294968368,'common'],
    [4294968369,4294968332,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968369,4294968369,4294968369,'common'],
    [4294968370,4294968333,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968370,4294968370,4294968370,'common'],
    [4294968371,4294968334,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968371,4294968371,4294968371,'common'],
    [4294968372,4294968335,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968372,4294968372,4294968372,'common'],
    [4294968373,4294968341,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968373,4294968373,4294968373,'common'],
    [4294968374,4294968342,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968374,4294968374,4294968374,'common'],
    [4294968375,4294968345,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968375,4294968375,4294968375,'common'],
    [4294968376,4294968349,"Остальное","content_category","content_genre_rest_name","content_genre_rest_description","all","content_category",4294968376,4294968376,4294968376,'common']
];
$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short, scope) values %s', $DATA);

$log->out("FINISH");
