#!/usr/bin/perl

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

my $DATA = [

    # 1. Новые группы
    [ 2499000118, 0,          "События в жизни", "family", "crypta_group-0da31649_name", "crypta_group-0da31649_description", "all", "0", "0", "", "", "common" ],
    [ 2499000355, 0,          "Путешествия",     "behaviors", "crypta_group-2baee07e_name", "crypta_group-2baee07e_description", "all", "0", "0", "", "", "common" ],

    # 2. События в жизни
    [ 2499000119, 2499000118, "Скоро день рождения", "family", "crypta_segment-768ea217_name", "crypta_segment-768ea217_description", "all", "547", "2134", "", "", "common" ],

    # 3. Путешествия
    [ 2499000328, 2499000355, "Путешествуют по миру",   "behaviors", "crypta_segment-20f8a577_name", "crypta_segment-20f8a577_description", "all", "547", "1192", "", "", "common" ],
    [ 2499000329, 2499000355, "Путешествуют по стране", "behaviors", "crypta_segment-0ca1964d_name", "crypta_segment-0ca1964d_description", "all", "547", "1193", "", "", "common" ],

    # 4. Оффлайн покупки
    [ 2499000330, 2499000318, "Сладости",                         "behaviors", "crypta_segment-c4e425e7_name", "crypta_segment-c4e425e7_description", "all", 547, 2207, "", "", "common" ],
    [ 2499000331, 2499000318, "Средства для посудомоечных машин", "behaviors", "crypta_segment-b987ee55_name", "crypta_segment-b987ee55_description", "all", 547, 2211, "", "", "common" ],
    [ 2499000332, 2499000318, "Снеки",                            "behaviors", "crypta_segment-b84159a4_name", "crypta_segment-b84159a4_description", "all", 547, 2208, "", "", "common" ],
    [ 2499000333, 2499000318, "Вода",                             "behaviors", "crypta_segment-a69ec37e_name", "crypta_segment-a69ec37e_description", "all", 547, 2202, "", "", "common" ],
    [ 2499000334, 2499000318, "Сыр",                              "behaviors", "crypta_segment-a572bcb1_name", "crypta_segment-a572bcb1_description", "all", 547, 2213, "", "", "common" ],
    [ 2499000335, 2499000318, "Чай",                              "behaviors", "crypta_segment-9b30b629_name", "crypta_segment-9b30b629_description", "all", 547, 2215, "", "", "common" ],
    [ 2499000336, 2499000318, "Энергетики",                       "behaviors", "crypta_segment-8e7d6da9_name", "crypta_segment-8e7d6da9_description", "all", 547, 2217, "", "", "common" ],
    [ 2499000337, 2499000318, "Холодный чай",                     "behaviors", "crypta_segment-7eb4be4b_name", "crypta_segment-7eb4be4b_description", "all", 547, 2214, "", "", "common" ],
    [ 2499000338, 2499000318, "Средства для бритья",              "behaviors", "crypta_segment-7c397376_name", "crypta_segment-7c397376_description", "all", 547, 2209, "", "", "common" ],
    [ 2499000339, 2499000318, "Товары для собак",                 "behaviors", "crypta_segment-58253735_name", "crypta_segment-58253735_description", "all", 547, 1921, "", "", "common" ],
    [ 2499000340, 2499000318, "Соки дороже 80 ₽ за литр",         "behaviors", "crypta_segment-498b9aad_name", "crypta_segment-498b9aad_description", "all", 547, 2206, "", "", "common" ],
    [ 2499000341, 2499000318, "Детские подгузники",               "behaviors", "crypta_segment-466194b0_name", "crypta_segment-466194b0_description", "all", 547, 2203, "", "", "common" ],
    [ 2499000342, 2499000318, "Молочные продукты",                "behaviors", "crypta_segment-4651bb66_name", "crypta_segment-4651bb66_description", "all", 547, 2205, "", "", "common" ],
    [ 2499000343, 2499000318, "Бытовая химия",                    "behaviors", "crypta_segment-3c93c885_name", "crypta_segment-3c93c885_description", "all", 547, 2201, "", "", "common" ],
    [ 2499000344, 2499000318, "Средства для волос",               "behaviors", "crypta_segment-27306a61_name", "crypta_segment-27306a61_description", "all", 547, 2210, "", "", "common" ],
    [ 2499000345, 2499000318, "Чипсы",                            "behaviors", "crypta_segment-21c1c8c2_name", "crypta_segment-21c1c8c2_description", "all", 547, 2216, "", "", "common" ],
    [ 2499000346, 2499000318, "Средства для стирки",              "behaviors", "crypta_segment-1480b80a_name", "crypta_segment-1480b80a_description", "all", 547, 2212, "", "", "common" ],
    [ 2499000347, 2499000318, "Йогурты",                          "behaviors", "crypta_segment-098c85b9_name", "crypta_segment-098c85b9_description", "all", 547, 2204, "", "", "common" ],

    # 6. Демография
    [ 2499000117, 2499000110, "С детьми любого возраста", "family", "crypta_segment-d021966a_name", "crypta_segment-d021966a_description", "all", 547, 1918, "", "", "common" ],

    # 7. Посещение организаций
    [ 2499000348, 2499000265, "Торговые центры",            "behaviors", "crypta_segment-visited-trade-centers_name", "crypta_segment-visited-trade-centers_description", "all", 547, 1720, "", "", "common" ],
    [ 2499000349, 2499000265, "Филармонии",                 "behaviors", "crypta_segment-visited-philharmonic_name",  "crypta_segment-visited-philharmonic_description",  "all", 547, 1723, "", "", "common" ],
    [ 2499000350, 2499000265, "Музыкальные клубы",          "behaviors", "crypta_segment-visited-music-clubs_name",   "crypta_segment-visited-music-clubs_description",   "all", 547, 1724, "", "", "common" ],
    [ 2499000351, 2499000265, "Консерватории",              "behaviors", "crypta_segment-visited-conservatory_name",  "crypta_segment-visited-conservatory_description",  "all", 547, 1722, "", "", "common" ],
    [ 2499000352, 2499000265, "Концертные залы",            "behaviors", "crypta_segment-visited-concert-halls_name", "crypta_segment-visited-concert-halls_description", "all", 547, 1989, "", "", "common" ],
    [ 2499000353, 2499000265, "Табачные магазины",          "behaviors", "crypta_segment-b5815171_name",              "crypta_segment-b5815171_description",              "all", 547, 1321, "", "", "common" ],
    [ 2499000354, 2499000265, "Микрокредитные организации", "behaviors", "crypta_segment-5959c268_name",              "crypta_segment-5959c268_description",              "all", 547, 1777, "", "", "common" ],

    # 8. Профессии
    [ 2499000131, 2499000120, "ML-разработчики",                   "family", "crypta_segment-e203e0c1_name", "crypta_segment-e203e0c1_description", "all", 547, 2224, "", "", "common" ],
    [ 2499000132, 2499000120, "Фронтенд-разработчики",             "family", "crypta_segment-ceea2721_name", "crypta_segment-ceea2721_description", "all", 547, 2225, "", "", "common" ],
    [ 2499000133, 2499000120, "SEO-специалисты",                   "family", "crypta_segment-c54a79ec_name", "crypta_segment-c54a79ec_description", "all", 547, 2226, "", "", "common" ],
    [ 2499000134, 2499000120, "Разработчики мобильных приложений", "family", "crypta_segment-a3059c9d_name", "crypta_segment-a3059c9d_description", "all", 547, 1788, "", "", "common" ],
    [ 2499000135, 2499000120, "Провизоры",                         "family", "crypta_segment-7bad6380_name", "crypta_segment-7bad6380_description", "all", 547, 1750, "", "", "common" ],

    # 9. Интересы
    [ 2499001414, 2499001268, "Ворота",                                      "interests", "crypta_interest_gates_name",    "crypta_interest_gates_description",    "all", 601, 334, 602, 334, "common" ],
    [ 2499001415, 2499001268, "Заборы",                                      "interests", "crypta_interest_fences_name",   "crypta_interest_fences_description",   "all", 601, 333, 602, 333, "common" ],
    [ 2499001416, 2499001254, "Корма для грызунов",                          "interests", "crypta_interest_ee00317c_name", "crypta_interest_ee00317c_description", "all", 601, 354, 602, 354, "common" ],
    [ 2499001417, 2499001254, "Корма для собак",                             "interests", "crypta_interest_e0de0aba_name", "crypta_interest_e0de0aba_description", "all", 601, 358, 602, 358, "common" ],
    [ 2499001418, 2499001254, "Корма для кошек",                             "interests", "crypta_interest_e09d0871_name", "crypta_interest_e09d0871_description", "all", 601, 355, 602, 355, "common" ],
    [ 2499001419, 2499001254, "Корма для рыб",                               "interests", "crypta_interest_c9e16168_name", "crypta_interest_c9e16168_description", "all", 601, 357, 602, 357, "common" ],
    [ 2499001420, 2499001254, "Корма для птиц",                              "interests", "crypta_interest_28e02324_name", "crypta_interest_28e02324_description", "all", 601, 356, 602, 356, "common" ],
    [ 2499001421, 2499001109, "Автострахование ОСАГО",                       "interests", "crypta_interest_da484cb5_name", "crypta_interest_da484cb5_description", "all", 601, 337, 602, 337, "common" ],
    [ 2499001422, 2499001109, "Кроссоверы",                                  "interests", "crypta_interest_6c0bb3c3_name", "crypta_interest_6c0bb3c3_description", "all", 601, 340, 602, 340, "common" ],
    [ 2499001423, 2499001109, "Моторные масла",                              "interests", "crypta_interest_36e43811_name", "crypta_interest_36e43811_description", "all", 601, 363, 602, 363, "common" ],
    [ 2499001424, 2499001267, "Аренда загородной недвижимости",              "interests", "crypta_interest_d9bb10ab_name", "crypta_interest_d9bb10ab_description", "all", 601, 342, 602, 342, "common" ],
    [ 2499001425, 2499001267, "Посуточная и почасовая аренда квартир",       "interests", "crypta_interest_c1a52a1d_name", "crypta_interest_c1a52a1d_description", "all", 601, 352, 602, 352, "common" ],
    [ 2499001426, 2499001267, "Аренда квартир и комнат",                     "interests", "crypta_interest_b8e63679_name", "crypta_interest_b8e63679_description", "all", 601, 344, 602, 344, "common" ],
    [ 2499001427, 2499001267, "Посуточная аренда загородной недвижимости",   "interests", "crypta_interest_87ba5032_name", "crypta_interest_87ba5032_description", "all", 601, 350, 602, 350, "common" ],
    [ 2499001428, 2499001267, "Коммерческая аренда",                         "interests", "crypta_interest_43d045a9_name", "crypta_interest_43d045a9_description", "all", 601, 348, 602, 348, "common" ],
    [ 2499001429, 2499001267, "Аренда помещений для мероприятий",            "interests", "crypta_interest_ab29c54e_name", "crypta_interest_ab29c54e_description", "all", 601, 346, 602, 346, "common" ],
    [ 2499001430, 2499001286, "Йога",                                        "interests", "crypta_interest_acd72cde_name", "crypta_interest_acd72cde_description", "all", 601, 359, 602, 359, "common" ],
    [ 2499001431, 2499001286, "Спортивные товары",                           "interests", "crypta_interest_0196b8b6_name", "crypta_interest_0196b8b6_description", "all", 601, 360, 602, 360, "common" ],
    [ 2499001432, 0,          "Канцелярские товары",                         "interests", "crypta_interest_56d8ade2_name", "crypta_interest_56d8ade2_description", "all", 601, 353, 602, 353, "common" ],
    [ 2499001433, 0,          "Сельскохозяйственное оборудование и техника", "interests", "crypta_interest_1d439903_name", "crypta_interest_1d439903_description", "all", 601, 364, 602, 364, "common" ],
    [ 2499001434, 2499001340, "Системы для хранения мелочей",                "interests", "crypta_interest_eb19ac50_name", "crypta_interest_eb19ac50_description", "all", 601, 361, 602, 361, "common" ],
    [ 2499001435, 2499001104, "Настенные кондиционеры и сплит-системы",      "interests", "crypta_interest_d79304c2_name", "crypta_interest_d79304c2_description", "all", 601, 335, 602, 335, "common" ],
    [ 2499001436, 2499001143, "Одежда, обувь и аксессуары премиум класса",   "interests", "crypta_interest_9abc788d_name", "crypta_interest_9abc788d_description", "all", 601, 338, 602, 338, "common" ],
    [ 2499001437, 2499001263, "Подгузники",                                  "interests", "crypta_interest_00b186cc_name", "crypta_interest_00b186cc_description", "all", 601, 362, 602, 362, "common" ]

];


$log->out("going to insert:", $DATA);

    do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short, scope) values %s', $DATA);

$log->out("FINISH");

