#!/usr/bin/perl

=head1 NAME


=head1 DESCRIPTION

=cut

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

use utf8;

$log->out('START');

my $DATA = [ 
    [2499000200, 0, "Телевидение", "behaviors", "crypta_behaviors_tv_name", "crypta_behaviors_tv_description", "long-term", "", "0", "0", "", ""],
    [2499000201, 2499000200, "Не смотрят или мало смотрят телевизор", "behaviors", "crypta_segment-70374da5_name", "crypta_segment-70374da5_description", "long-term", "", "547", "1042", "", ""],
    [2499000202, 2499000200, "Много смотрят телевизор",               "behaviors", "crypta_segment-bb239906_name", "crypta_segment-bb239906_description", "long-term", "", "547", "1041", "", ""],
    [2499000220, 0, "Интернет", "behaviors", "crypta_behaviors_internet_name", "crypta_behaviors_internet_description", "long-term", "", "0", "0", "", ""],
    [2499000221, 2499000220, "Используют Wi-Fi c мобильных устройств",   "behaviors", "crypta_segment-647009ee_name", "crypta_segment-647009ee_description", "long-term", "", "547", "1045", "", ""],
    [2499000222, 2499000220, "Много пользуются мобильным интернетом",    "behaviors", "crypta_segment-bd2f8563_name", "crypta_segment-bd2f8563_description", "long-term", "", "547", "1043", "", ""],
    [2499000223, 2499000220, "Проводят много времени в интернете",       "behaviors", "crypta_segment-77272017_name", "crypta_segment-77272017_description", "long-term", "", "547", "1049", "", ""],
    [2499000224, 2499000220, "Проводят мало времени в интернете",        "behaviors", "crypta_segment-07804b5b_name", "crypta_segment-07804b5b_description", "long-term", "", "547", "1048", "", ""],
    [2499000225, 2499000220, "Много пользуются интернетом на смартфоне", "behaviors", "crypta_segment-e9402061_name", "crypta_segment-e9402061_description", "long-term", "", "547", "1047", "", ""],
    [2499000226, 2499000220, "Мало пользуются интернетом на смартфоне",  "behaviors", "crypta_segment-a2ca4eec_name", "crypta_segment-a2ca4eec_description", "long-term", "", "547", "1046", "", ""],
    [2499000227, 2499000220, "Активны в социальных сетях",               "behaviors", "crypta_segment-38a187f2_name", "crypta_segment-38a187f2_description", "long-term", "", "547", "1044", "", ""],
    [2499000228, 2499000220, "Покупают в интернете",                     "behaviors", "crypta_segment-dff46ae2_name", "crypta_segment-dff46ae2_description", "long-term", "", "547", "1050", "", ""],
    [2499000240, 0, "Устройства", "behaviors", "crypta_behaviors_devices_name", "crypta_behaviors_devices_description", "long-term", "", "0", "0", "", ""],
    [2499000241, 2499000240, "Пользуются смартфонами до 15 тыс. руб.",    "behaviors", "crypta_segment-5c3ec7d2_name", "crypta_segment-5c3ec7d2_description", "long-term", "", "547", "1062", "", ""],
    [2499000242, 2499000240, "Пользуются смартфонами за 15–25 тыс. руб.", "behaviors", "crypta_segment-b1ca29ad_name", "crypta_segment-b1ca29ad_description", "long-term", "", "547", "1063", "", ""],
    [2499000243, 2499000240, "Пользуются смартфонами за 25–35 тыс. руб.", "behaviors", "crypta_segment-a9b0483c_name", "crypta_segment-a9b0483c_description", "long-term", "", "547", "1064", "", ""],
    [2499000244, 2499000240, "Пользуются смартфонами за 35–50 тыс. руб.", "behaviors", "crypta_segment-b65d65a0_name", "crypta_segment-b65d65a0_description", "long-term", "", "547", "1065", "", ""],
    [2499000245, 2499000240, "Пользуются смартфонами от 50 тыс. руб.",    "behaviors", "crypta_segment-2d89bcc9_name", "crypta_segment-2d89bcc9_description", "long-term", "", "547", "1066", "", ""],
    [2499000246, 2499000240, "Пользуются смартфонами на Android",         "behaviors", "crypta_segment-c2c9fa67_name", "crypta_segment-c2c9fa67_description", "long-term", "", "547", "1058", "", ""],
    [2499000247, 2499000240, "Пользуются смартфонами на iOS",             "behaviors", "crypta_segment-c65e8ebf_name", "crypta_segment-c65e8ebf_description", "long-term", "", "547", "1059", "", ""],
    [2499000248, 2499000240, "Пользуются смартфонами на Windows",         "behaviors", "crypta_segment-de5ae29b_name", "crypta_segment-de5ae29b_description", "long-term", "", "547", "1060", "", ""],
    [2499000249, 2499000240, "Пользуются планшетами на Android",          "behaviors", "crypta_segment-e45e2096_name", "crypta_segment-e45e2096_description", "long-term", "", "547", "1055", "", ""],
    [2499000250, 2499000240, "Пользуются планшетами на iOS",              "behaviors", "crypta_segment-bfe1ae3a_name", "crypta_segment-bfe1ae3a_description", "long-term", "", "547", "1056", "", ""],
    [2499000251, 2499000240, "Пользуются планшетами на Windows",          "behaviors", "crypta_segment-86d40600_name", "crypta_segment-86d40600_description", "long-term", "", "547", "1057", "", ""],
    [2499000252, 2499000240, "Пользуются Smart TV",                       "behaviors", "crypta_segment-5a0e35a3_name", "crypta_segment-5a0e35a3_description", "long-term", "", "547", "1061", "", ""],
    [2499000260, 0, "Транспорт", "behaviors", "crypta_behaviors_transport_name", "crypta_behaviors_transport_description", "long-term", "", "0", "0", "", ""],
    [2499000261, 2499000260, "Автомобилисты",   "behaviors", "crypta_segment-a8ad04fd_name", "crypta_segment-a8ad04fd_description", "long-term", "", "547", "1051", "", ""],
    [2499000262, 2499000260, "Велосипедисты",   "behaviors", "crypta_segment-6c01be34_name", "crypta_segment-6c01be34_description", "long-term", "", "547", "1052", "", ""],
    [2499000263, 2499000260, "Мотоциклисты",    "behaviors", "crypta_segment-2d55a577_name", "crypta_segment-2d55a577_description", "long-term", "", "547", "1053", "", ""],
    [2499000264, 2499000260, "Пассажиры такси", "behaviors", "crypta_segment-3727135b_name", "crypta_segment-3727135b_description", "long-term", "", "547", "1054", "", ""]
];

$log->out("going to insert:", $DATA);

do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, tags, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short) values %s', $DATA);

$log->out("FINISH");

