#!/usr/bin/perl

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

my @rows = (
    ["RUB", 0, 25.00, "frontpage_mobile"],
    ["USD", 0, 0.36, "frontpage_mobile"],
    ["EUR", 0, 0.31, "frontpage_mobile"],
    ["UAH", 0, 9.96, "frontpage_mobile"],
    ["CHF", 0, 0.35, "frontpage_mobile"],
    ["TRY", 0, 1.89, "frontpage_mobile"],
    ["BYN", 0, 0.78, "frontpage_mobile"],
    ["KZT", 0, 138.89, "frontpage_mobile"],
    ["RUB", 0, 25.00, "frontpage"],
    ["USD", 0, 0.36, "frontpage"],
    ["EUR", 0, 0.31, "frontpage"],
    ["UAH", 0, 9.96, "frontpage"],
    ["CHF", 0, 0.35, "frontpage"],
    ["TRY", 0, 1.89, "frontpage"],
    ["BYN", 0, 0.78, "frontpage"],
    ["KZT", 0, 138.89, "frontpage"],
    ["RUB", 0, 25.00, "browser_new_tab"],
    ["USD", 0, 0.36, "browser_new_tab"],
    ["EUR", 0, 0.31, "browser_new_tab"],
    ["UAH", 0, 9.96, "browser_new_tab"],
    ["CHF", 0, 0.35, "browser_new_tab"],
    ["TRY", 0, 1.89, "browser_new_tab"],
    ["BYN", 0, 0.78, "browser_new_tab"],
    ["KZT", 0, 138.89, "browser_new_tab"],
    ["RUB", 159, 65.00, "frontpage_mobile"],
    ["USD", 159, 0.93, "frontpage_mobile"],
    ["EUR", 159, 0.81, "frontpage_mobile"],
    ["UAH", 159, 25.90, "frontpage_mobile"],
    ["CHF", 159, 0.92, "frontpage_mobile"],
    ["TRY", 159, 4.92, "frontpage_mobile"],
    ["BYN", 159, 2.02, "frontpage_mobile"],
    ["KZT", 159, 361.11, "frontpage_mobile"],
    ["RUB", 159, 140.00, "frontpage"],
    ["USD", 159, 2.01, "frontpage"],
    ["EUR", 159, 1.75, "frontpage"],
    ["UAH", 159, 55.78, "frontpage"],
    ["CHF", 159, 1.99, "frontpage"],
    ["TRY", 159, 10.61, "frontpage"],
    ["BYN", 159, 4.35, "frontpage"],
    ["KZT", 159, 777.78, "frontpage"],
    ["RUB", 159, 140.00, "browser_new_tab"],
    ["USD", 159, 2.01, "browser_new_tab"],
    ["EUR", 159, 1.75, "browser_new_tab"],
    ["UAH", 159, 55.78, "browser_new_tab"],
    ["CHF", 159, 1.99, "browser_new_tab"],
    ["TRY", 159, 10.61, "browser_new_tab"],
    ["BYN", 159, 4.35, "browser_new_tab"],
    ["KZT", 159, 777.78, "browser_new_tab"],
    ["RUB", 149, 130.00, "frontpage_mobile"],
    ["USD", 149, 1.87, "frontpage_mobile"],
    ["EUR", 149, 1.63, "frontpage_mobile"],
    ["UAH", 149, 51.79, "frontpage_mobile"],
    ["CHF", 149, 1.84, "frontpage_mobile"],
    ["TRY", 149, 9.85, "frontpage_mobile"],
    ["BYN", 149, 4.04, "frontpage_mobile"],
    ["KZT", 149, 722.22, "frontpage_mobile"],
    ["RUB", 149, 185.00, "frontpage"],
    ["USD", 149, 2.65, "frontpage"],
    ["EUR", 149, 2.31, "frontpage"],
    ["UAH", 149, 73.71, "frontpage"],
    ["CHF", 149, 2.62, "frontpage"],
    ["TRY", 149, 14.02, "frontpage"],
    ["BYN", 149, 5.75, "frontpage"],
    ["KZT", 149, 1027.78, "frontpage"],
    ["RUB", 149, 185.00, "browser_new_tab"],
    ["USD", 149, 2.65, "browser_new_tab"],
    ["EUR", 149, 2.31, "browser_new_tab"],
    ["UAH", 149, 73.71, "browser_new_tab"],
    ["CHF", 149, 2.62, "browser_new_tab"],
    ["TRY", 149, 14.02, "browser_new_tab"],
    ["BYN", 149, 5.75, "browser_new_tab"],
    ["KZT", 149, 1027.78, "browser_new_tab"],
    ["RUB", 225, 180.00, "frontpage_mobile"],
    ["USD", 225, 2.58, "frontpage_mobile"],
    ["EUR", 225, 2.25, "frontpage_mobile"],
    ["UAH", 225, 71.71, "frontpage_mobile"],
    ["CHF", 225, 2.55, "frontpage_mobile"],
    ["TRY", 225, 13.64, "frontpage_mobile"],
    ["BYN", 225, 5.59, "frontpage_mobile"],
    ["KZT", 225, 1000.00, "frontpage_mobile"],
    ["RUB", 225, 225.00, "frontpage"],
    ["USD", 225, 3.73, "frontpage"],
    ["EUR", 225, 3.25, "frontpage"],
    ["UAH", 225, 103.59, "frontpage"],
    ["CHF", 225, 3.69, "frontpage"],
    ["TRY", 225, 19.70, "frontpage"],
    ["BYN", 225, 8.08, "frontpage"],
    ["KZT", 225, 1444.44, "frontpage"],
    ["RUB", 225, 220.00, "browser_new_tab"],
    ["USD", 225, 3.73, "browser_new_tab"],
    ["EUR", 225, 3.25, "browser_new_tab"],
    ["UAH", 225, 103.59, "browser_new_tab"],
    ["CHF", 225, 3.69, "browser_new_tab"],
    ["TRY", 225, 19.70, "browser_new_tab"],
    ["BYN", 225, 8.08, "browser_new_tab"],
    ["KZT", 225, 1444.44, "browser_new_tab"],
    ["RUB", 1, 180.00, "frontpage_mobile"],
    ["USD", 1, 3.09, "frontpage_mobile"],
    ["EUR", 1, 2.69, "frontpage_mobile"],
    ["UAH", 1, 85.66, "frontpage_mobile"],
    ["CHF", 1, 3.05, "frontpage_mobile"],
    ["TRY", 1, 16.29, "frontpage_mobile"],
    ["BYN", 1, 6.68, "frontpage_mobile"],
    ["KZT", 1, 1194.44, "frontpage_mobile"],
    ["RUB", 1, 320.00, "frontpage"],
    ["USD", 1, 4.66, "frontpage"],
    ["EUR", 1, 4.06, "frontpage"],
    ["UAH", 1, 129.48, "frontpage"],
    ["CHF", 1, 4.61, "frontpage"],
    ["TRY", 1, 24.62, "frontpage"],
    ["BYN", 1, 10.10, "frontpage"],
    ["KZT", 1, 1805.56, "frontpage"],
    ["RUB", 1, 285.00, "browser_new_tab"],
    ["USD", 1, 4.66, "browser_new_tab"],
    ["EUR", 1, 4.06, "browser_new_tab"],
    ["UAH", 1, 129.48, "browser_new_tab"],
    ["CHF", 1, 4.61, "browser_new_tab"],
    ["TRY", 1, 24.62, "browser_new_tab"],
    ["BYN", 1, 10.10, "browser_new_tab"],
    ["KZT", 1, 1805.56, "browser_new_tab"]
);
do_mass_insert_sql(PPCDICT,
        'REPLACE INTO cpm_yndx_frontpage_min_bids (currency, region_id, min_bid, frontpage_type) VALUES %s',
        \@rows);
