#!/usr/bin/perl
## no critic (TestingAndDebugging::RequireUseStrict, TestingAndDebugging::RequireUseWarnings)

use my_inc "../..";


#
#   chown pdf reports to chief reps 
#   run after DIRECTSUP-2268 or DIRECT-4272 related task is commited
#

my $oktorun = 0;
die "Remove this debug line before run!\n" unless $oktorun;

use warnings;
use strict;

use Settings;
use Yandex::DBTools;
use RBACElementary;
use RBAC2::Extended;
local $Yandex::DBShards::STRICT_SHARD_DBNAMES = 0;

my $rbac = RBAC2::Extended->get_singleton(1);

my $data = get_all_sql(PPC, "select distinct(uid) uid from pdf_reports")||[];

for my $report (@$data) {
    $report->{chief_uid} = rbac_get_chief_rep_of_client_rep($report->{uid});

    if ( $report->{chief_uid} ne $report->{uid} ) {
        print "mooving $report->{uid} => $report->{chief_uid}\n";
        do_sql(PPC,"update pdf_reports set uid = ? where uid = ?", $report->{chief_uid}, $report->{uid});
    }
}

exit 0;

#
#   Author: Georgy Ivanov
#
#

