package ru.yandex.autotests.directintapi.bstransport.main.phrase.parameters.bid;

import java.util.Arrays;
import java.util.Collection;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;

import ru.yandex.aqua.annotations.project.Aqua;
import ru.yandex.autotests.direct.utils.tags.TagDictionary;
import ru.yandex.autotests.directapi.model.api5.campaigns.TextCampaignSearchStrategyAddMap;
import ru.yandex.autotests.directintapi.bstransport.FeatureNames;
import ru.yandex.autotests.directintapi.bstransport.StoriesNames;
import ru.yandex.qatools.Tag;
import ru.yandex.qatools.allure.annotations.Features;
import ru.yandex.qatools.allure.annotations.Stories;
import ru.yandex.qatools.allure.annotations.Title;

@Aqua.Test
@Tag(TagDictionary.TRUNK)
@Tag(TagDictionary.RELEASE)
@Title("Транспорт: проверка отправки ставки на поиске для новой фразы " +
        "в синхронизированной группе (для ручных стратегий) (2)")
@Stories(StoriesNames.PHRASE_PARAMS_BID)
@Features(FeatureNames.PHRASES)
@RunWith(Parameterized.class)
public class BsTransportOfBidForNewPhraseInSyncedGroupTest2
        extends BsTransportOfBidForNewPhraseInSyncedGroupBaseTest
{

    @Parameterized.Parameters(name = "Стратегия = {0}")
    public static Collection<Object[]> data() {
        Object[][] data = new Object[][]{
                {new TextCampaignSearchStrategyAddMap().defaultHighestPosition()}
        };
        return Arrays.asList(data);
    }
}
