package ru.yandex.autotests.direct.db.beans.ads.internal;

import java.util.Arrays;
import java.util.Map;
import java.util.stream.Collectors;

import javax.annotation.Nullable;

public enum TemplateResourceOption {
    REQUIRED("required"),

    BANANA_URL("banana_url"),

    BANANA_IMAGE("banana_image");

    private static final Map<String, TemplateResourceOption> ENUMS = Arrays.stream(values())
            .collect(Collectors.toMap(TemplateResourceOption::getTypedValue, e -> e));

    private final String typedValue;

    TemplateResourceOption(String typedValue) {
        this.typedValue = typedValue;
    }

    public String getTypedValue() {
        return typedValue;
    }

    public static TemplateResourceOption fromTypedValue(@Nullable String typedValue) {
        if (typedValue == null) {
            return null;
        }
        TemplateResourceOption result = ENUMS.get(typedValue);
        if (result == null) {
            throw new IllegalArgumentException("Unknown enum typed value " + typedValue);
        }
        return result;
    }
}
