package ru.yandex.autotests.directapi.model.api5.campaignsext;

import com.yandex.direct.api.v5.campaignsext.AddRequest;

import ru.yandex.autotests.direct.utils.converter.BeanMapToBeanConverter;
import ru.yandex.autotests.direct.utils.model.ModelBeanMap;

import static ch.lambdaj.Lambda.convert;

/**
 * Created by pavryabov on 05.08.15.
 */
public class AddRequestMap extends ModelBeanMap<AddRequestMap> {

    public static final String CAMPAIGNS = "campaigns";

    public static final int MAX_AMOUNT_OF_CAMPAIGNS_IN_REQUEST = 10;

    public AddRequestMap() {
        super();
        setBean(new AddRequest());
    }

    public AddRequestMap(AddRequest addRequest) {
        super();
        setBean(addRequest);
    }

    public AddRequestMap put(String fieldName, Object value) {
        super.put(fieldName, value);
        return this;
    }

    public AddRequestMap withCampaigns(CampaignAddItemMap... campaignsext) {
        this.put(CAMPAIGNS, (campaignsext == null) ? null : convert(campaignsext, new BeanMapToBeanConverter()));
        return this;
    }
}
