package ru.yandex.autotests.directapi.model.finances;

import java.util.AbstractMap;

/**
 * Created by IntelliJ IDEA.
 * User: mariabye
 * Date: 03.09.12
 * Time: 11:17
 * To change this template use File | Settings | File Templates.
 */
public final class Contracts {
    public static final String sandBoxContract = "11111/00";
    public static final String sandBoxPaymentToken =
            "12345678901234.1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF1234567890ABCDEF";

    /**
     * Контракты для at-direct-ag-full
     */
    /**
     * Постоплатный дефолтный с лимитом 100000
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractPayAfterDefault =
            new AbstractMap.SimpleEntry<Integer, String>(176878, "23598/13");

    /**
     * Постоплатный с лимитом 100000
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractPayAfter =
            new AbstractMap.SimpleEntry<Integer, String>(176879, "23600/13");

    /**
     * Предоплатный
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractPayBefore =
            new AbstractMap.SimpleEntry<Integer, String>(176876, "23596/13");

    /**
     * Просроченный (дата окончания договора раньше текущей)
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractExpired =
            new AbstractMap.SimpleEntry<Integer, String>(176880, "23601/12");

    /**
     * Аннулированный
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractDisabled =
            new AbstractMap.SimpleEntry<Integer, String>(176881, "23602/13");

    /**
     * С лимитом для постоплаты = 0
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractNoAvailableLimit =
            new AbstractMap.SimpleEntry<Integer, String>(176898, "23603/13");

    /**
     * Постолатный, с лимитом 100000 для агентства at-direct-ag-another
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractAnotherAgency =
            new AbstractMap.SimpleEntry<Integer, String>(176899, "23604/13");
    /**
     * Постоплатный, с лимитом 100000 для агентства at-agency-invoice1
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractInvoice1 =
            new AbstractMap.SimpleEntry<Integer, String>(195619, "39184/13");
    /**
     * Постоплатный, с лимитом 100000 для агентства at-agency-invoice2
     */
    public static AbstractMap.SimpleEntry<Integer, String> contractInvoice2 =
            new AbstractMap.SimpleEntry<Integer, String>(195638, "39185/13");
}
