OWNER(g:direct)

PY3_LIBRARY()

PY_SRCS(
    __init__.py

    balancer/__init__.py
    balancer/http_errors.py
    balancer/http_web_5xx_errors.py

    java_apps/__init__.py
    java_apps/communication_platform.py
    java_apps/mysql_connection_pool.py

    jobs/__init__.py
    jobs/active_orders.py
    jobs/aggr_statuses.py
    jobs/bs_transport_ess.py
    jobs/ess.py
    jobs/health.py
    jobs/hourglass_utilization.py
    jobs/moderation_export_ess.py
    jobs/mysql2grut_replication.py

    infra/__init__.py
    infra/chassis_jobs.py
    infra/common.py
    infra/direct_mmm/__init__.py
    infra/direct_mmm/common.py
    infra/lifeline/__init__.py
    infra/lifeline/common.py
    infra/lifeline/threshold.py
    infra/lifeline/has_problem.py
    infra/logshatter/__init__.py
    infra/logshatter/common.py
    infra/mdb/common.py
    infra/mdb/mongo/__init__.py
    infra/mdb/redis/__init__.py
    infra/mdb/mysql/__init__.py
    infra/mdb/mysql/common.py
    infra/mdb/mysql/ptkill.py
    infra/mdb/tm/__init__.py
    infra/mysql_binlog_age/__init__.py
    infra/memcached/__init__.py
    infra/memcached/common.py
    infra/lbmoderation/__init__.py
    infra/lbmoderation/common.py
    infra/solomon_ppc/__init__.py
    infra/push_client/__init__.py
    infra/unified_agent/__init__.py
    infra/ydb/__init__.py
    infra/ydb/health.py
    infra/ydb/resources.py

    integrations/__init__.py
    integrations/metrika.py
    integrations/sprav.py
    integrations/yt.py

    errorbooster/__init__.py

    mds/__init__.py

    transport_queues/__init__.py
    transport_queues/perl_bsexport.py
)

RESOURCE_FILES(
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogmetrikaUnoptimized-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogmetrikaUnoptimized-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogmetrikaUnoptimized-direct.intapi.json

    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogExternalService-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogMultiShard-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogMultiShard-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/has_problem/traceLogYqlExecute-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/test/has_problem/traceLogYqlExecute-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogCpu-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbReadCalls-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogDbWriteCalls-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogMem-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpent-direct.web.perl.json

    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.api5.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.canvas.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.intapi.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.web.grid.api.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.web.grid.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.web.java.json
    direct/solo/registered/alert/infra/lifeline/config/production/threshold/traceLogTimeSpentRest-direct.web.perl.json
)

PEERDIR(
    direct/solo/registered/sensors
    direct/solo/registered/channel
    direct/solo/registered/project
    direct/solo/registered/sensors
    library/python/monitoring/solo/objects/solomon/v2
    library/python/monitoring/solo/objects/solomon/sensor
    contrib/python/juggler_sdk
)

END()

