package ru.yandex.direct.web.entity.vcard.model;

import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonProperty;

public class DeprecatedWebVcard {

    public static final String ID_FIELD_NAME = "vcard_id";
    public static final String CAMPAIGN_ID_FIELD_NAME = "cid";
    public static final String UID_FIELD_NAME = "uid";

    public static final String COMPANY_NAME_FIELD_NAME = "name";
    public static final String CONTACT_PERSON_FIELD_NAME = "contactperson";
    public static final String EMAIL_FIELD_NAME = "contact_email";
    public static final String WORK_TIME_FIELD_NAME = "worktime";
    public static final String WORK_TIME_LIST_FIELD_NAME = "worktimes";
    public static final String EXTRA_MESSAGE_FIELD_NAME = "extra_message";
    public static final String ORG_DETAILS_ID_FIELD_NAME = "org_details_id";
    public static final String OGRN_FIELD_NAME = "ogrn";

    public static final String COUNTRY_FIELD_NAME = "country";
    public static final String CITY_FIELD_NAME = "city";
    public static final String STREET_FIELD_NAME = "street";
    public static final String HOUSE_FIELD_NAME = "house";
    public static final String BUILD_FIELD_NAME = "build";
    public static final String APART_FIELD_NAME = "apart";
    public static final String METRO_ID_FIELD_NAME = "metro";
    public static final String METRO_NAME_FIELD_NAME = "metro_name";

    public static final String GEO_ID_FIELD_NAME = "geo_id";
    public static final String COUNTRY_GEO_ID_FIELD_NAME = "country_geo_id";

    // phone
    public static final String COUNTRY_CODE_FIELD_NAME = "country_code";
    public static final String CITY_CODE_FIELD_NAME = "city_code";
    public static final String PHONE_NUMBER_FIELD_NAME = "phone";
    public static final String EXTENSION_FIELD_NAME = "ext";

    // instant_messenger
    public static final String INSTANT_MESSENGER_TYPE_FIELD_NAME = "im_client";
    public static final String INSTANT_MESSENGER_LOGIN_FIELD_NAME = "im_login";

    // manual_point, auto_point
    public static final String MANUAL_POINT_FIELD_NAME = "manual_point";
    public static final String MANUAL_BOUNDS_FIELD_NAME = "manual_bounds";
    public static final String AUTO_POINT_FIELD_NAME = "auto_point";
    public static final String AUTO_BOUNDS_FIELD_NAME = "auto_bounds";
    public static final String PRECISION_FIELD_NAME = "auto_precision";

    @JsonProperty(ID_FIELD_NAME)
    private Long id;

    @JsonProperty(CAMPAIGN_ID_FIELD_NAME)
    private String campaignId;

    @JsonProperty(UID_FIELD_NAME)
    private String uid;

    @JsonProperty(COMPANY_NAME_FIELD_NAME)
    private String companyName;

    @JsonProperty(CONTACT_PERSON_FIELD_NAME)
    private String contactPerson;

    @JsonProperty(EMAIL_FIELD_NAME)
    private String email;

    @JsonProperty(WORK_TIME_FIELD_NAME)
    private String workTime;

    @JsonProperty(WORK_TIME_LIST_FIELD_NAME)
    private List<Map<String, String>> workTimeList;

    @JsonProperty(EXTRA_MESSAGE_FIELD_NAME)
    private String extraMessage;

    @JsonProperty(ORG_DETAILS_ID_FIELD_NAME)
    private Long orgDetailsId;

    @JsonProperty(OGRN_FIELD_NAME)
    private String ogrn;

    @JsonProperty(COUNTRY_FIELD_NAME)
    private String country;

    @JsonProperty(CITY_FIELD_NAME)
    private String city;

    @JsonProperty(STREET_FIELD_NAME)
    private String street;

    @JsonProperty(HOUSE_FIELD_NAME)
    private String house;

    @JsonProperty(BUILD_FIELD_NAME)
    private String build;

    @JsonProperty(APART_FIELD_NAME)
    private String apart;

    @JsonProperty(METRO_ID_FIELD_NAME)
    private Long metroId;

    @JsonProperty(METRO_NAME_FIELD_NAME)
    private String metroName;

    @JsonProperty(GEO_ID_FIELD_NAME)
    private Long geoId;

    @JsonProperty(COUNTRY_GEO_ID_FIELD_NAME)
    private Long countryGeoId;

    @JsonProperty(COUNTRY_CODE_FIELD_NAME)
    private String countryCode;

    @JsonProperty(CITY_CODE_FIELD_NAME)
    private String cityCode;

    @JsonProperty(PHONE_NUMBER_FIELD_NAME)
    private String phoneNumber;

    @JsonProperty(EXTENSION_FIELD_NAME)
    private String extension;

    @JsonProperty(INSTANT_MESSENGER_TYPE_FIELD_NAME)
    private String instantMessengerType;

    @JsonProperty(INSTANT_MESSENGER_LOGIN_FIELD_NAME)
    private String instantMessengerLogin;

    @JsonProperty(MANUAL_POINT_FIELD_NAME)
    private String manualPoint;

    @JsonProperty(MANUAL_BOUNDS_FIELD_NAME)
    private String manualBounds;

    @JsonProperty(AUTO_POINT_FIELD_NAME)
    private String autoPoint;

    @JsonProperty(AUTO_BOUNDS_FIELD_NAME)
    private String autoBounds;

    @JsonProperty(PRECISION_FIELD_NAME)
    private String precision;

    public Long getId() {
        return id;
    }

    public DeprecatedWebVcard withId(Long id) {
        this.id = id;
        return this;
    }

    public String getCampaignId() {
        return campaignId;
    }

    public DeprecatedWebVcard withCampaignId(String campaignId) {
        this.campaignId = campaignId;
        return this;
    }

    public String getUid() {
        return uid;
    }

    public DeprecatedWebVcard withUid(String uid) {
        this.uid = uid;
        return this;
    }

    public String getCompanyName() {
        return companyName;
    }

    public DeprecatedWebVcard withCompanyName(String companyName) {
        this.companyName = companyName;
        return this;
    }

    public String getContactPerson() {
        return contactPerson;
    }

    public DeprecatedWebVcard withContactPerson(String contactPerson) {
        this.contactPerson = contactPerson;
        return this;
    }

    public String getEmail() {
        return email;
    }

    public DeprecatedWebVcard withEmail(String email) {
        this.email = email;
        return this;
    }

    public String getWorkTime() {
        return workTime;
    }

    public DeprecatedWebVcard withWorkTime(String workTime) {
        this.workTime = workTime;
        return this;
    }

    public List<Map<String, String>> getWorkTimeList() {
        return workTimeList;
    }

    public DeprecatedWebVcard withWorkTimeList(
            List<Map<String, String>> workTimeList) {
        this.workTimeList = workTimeList;
        return this;
    }

    public String getExtraMessage() {
        return extraMessage;
    }

    public DeprecatedWebVcard withExtraMessage(String extraMessage) {
        this.extraMessage = extraMessage;
        return this;
    }

    public Long getOrgDetailsId() {
        return orgDetailsId;
    }

    public DeprecatedWebVcard withOrgDetailsId(Long orgDetailsId) {
        this.orgDetailsId = orgDetailsId;
        return this;
    }

    public String getOgrn() {
        return ogrn;
    }

    public DeprecatedWebVcard withOgrn(String ogrn) {
        this.ogrn = ogrn;
        return this;
    }

    public String getCountry() {
        return country;
    }

    public DeprecatedWebVcard withCountry(String country) {
        this.country = country;
        return this;
    }

    public String getCity() {
        return city;
    }

    public DeprecatedWebVcard withCity(String city) {
        this.city = city;
        return this;
    }

    public String getStreet() {
        return street;
    }

    public DeprecatedWebVcard withStreet(String street) {
        this.street = street;
        return this;
    }

    public String getHouse() {
        return house;
    }

    public DeprecatedWebVcard withHouse(String house) {
        this.house = house;
        return this;
    }

    public String getBuild() {
        return build;
    }

    public DeprecatedWebVcard withBuild(String build) {
        this.build = build;
        return this;
    }

    public String getApart() {
        return apart;
    }

    public DeprecatedWebVcard withApart(String apart) {
        this.apart = apart;
        return this;
    }

    public Long getMetroId() {
        return metroId;
    }

    public DeprecatedWebVcard withMetroId(Long metroId) {
        this.metroId = metroId;
        return this;
    }

    public String getMetroName() {
        return metroName;
    }

    public DeprecatedWebVcard withMetroName(String metroName) {
        this.metroName = metroName;
        return this;
    }

    public Long getGeoId() {
        return geoId;
    }

    public DeprecatedWebVcard withGeoId(Long geoId) {
        this.geoId = geoId;
        return this;
    }

    public Long getCountryGeoId() {
        return countryGeoId;
    }

    public DeprecatedWebVcard withCountryGeoId(Long countryGeoId) {
        this.countryGeoId = countryGeoId;
        return this;
    }

    public String getCountryCode() {
        return countryCode;
    }

    public DeprecatedWebVcard withCountryCode(String countryCode) {
        this.countryCode = countryCode;
        return this;
    }

    public String getCityCode() {
        return cityCode;
    }

    public DeprecatedWebVcard withCityCode(String cityCode) {
        this.cityCode = cityCode;
        return this;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public DeprecatedWebVcard withPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
        return this;
    }

    public String getExtension() {
        return extension;
    }

    public DeprecatedWebVcard withExtension(String extension) {
        this.extension = extension;
        return this;
    }

    public String getInstantMessengerType() {
        return instantMessengerType;
    }

    public DeprecatedWebVcard withInstantMessengerType(String instantMessengerType) {
        this.instantMessengerType = instantMessengerType;
        return this;
    }

    public String getInstantMessengerLogin() {
        return instantMessengerLogin;
    }

    public DeprecatedWebVcard withInstantMessengerLogin(String instantMessengerLogin) {
        this.instantMessengerLogin = instantMessengerLogin;
        return this;
    }

    public String getManualPoint() {
        return manualPoint;
    }

    public DeprecatedWebVcard withManualPoint(String manualPoint) {
        this.manualPoint = manualPoint;
        return this;
    }

    public String getManualBounds() {
        return manualBounds;
    }

    public DeprecatedWebVcard withManualBounds(String manualBounds) {
        this.manualBounds = manualBounds;
        return this;
    }

    public String getAutoPoint() {
        return autoPoint;
    }

    public DeprecatedWebVcard withAutoPoint(String autoPoint) {
        this.autoPoint = autoPoint;
        return this;
    }

    public String getAutoBounds() {
        return autoBounds;
    }

    public DeprecatedWebVcard withAutoBounds(String autoBounds) {
        this.autoBounds = autoBounds;
        return this;
    }

    public String getPrecision() {
        return precision;
    }

    public DeprecatedWebVcard withPrecision(String precision) {
        this.precision = precision;
        return this;
    }
}
