package ru.yandex.direct.web.entity.vcard.model;

import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonProperty;

import ru.yandex.direct.core.entity.vcard.model.PointPrecision;
import ru.yandex.direct.core.entity.vcard.model.PointType;

public class WebVcard {
    public static final String ID_FIELD_NAME = "id";
    public static final String CAMPAIGN_ID_FIELD_NAME = "campaign_id";
    public static final String UID_FIELD_NAME = "uid";
    public static final String COMPANY_NAME_FIELD_NAME = "company_name";
    public static final String WORK_TIME_FIELD_NAME = "work_time";
    public static final String WORK_TIME_LIST_FIELD_NAME = "worktimes";
    public static final String CONTACT_PERSON_FIELD_NAME = "contact_person";
    public static final String PHONE_FIELD_NAME = "phone";
    public static final String EMAIL_FIELD_NAME = "email";
    public static final String INSTANT_MESSENGER_FIELD_NAME = "instant_messenger";
    public static final String EXTRA_MESSAGE_FIELD_NAME = "extra_message";
    public static final String ORG_DETAILS_ID_FIELD_NAME = "org_details_id";
    public static final String OGRN_FIELD_NAME = "ogrn";
    public static final String GEO_ID_FIELD_NAME = "geo_id";
    public static final String COUNTRY_FIELD_NAME = "country";
    public static final String CITY_FIELD_NAME = "city";
    public static final String STREET_FIELD_NAME = "street";
    public static final String HOUSE_FIELD_NAME = "house";
    public static final String BUILD_FIELD_NAME = "build";
    public static final String APART_FIELD_NAME = "apart";
    public static final String METRO_ID_FIELD_NAME = "metro_id";
    public static final String METRO_NAME_FIELD_NAME = "metro_name";
    public static final String COUNTRY_GEO_ID_FIELD_NAME = "country_geo_id";
    public static final String MANUAL_POINT_FIELD_NAME = "manual_point";
    public static final String AUTO_POINT_FIELD_NAME = "auto_point";
    public static final String POINT_TYPE_FIELD_NAME = "point_type";
    public static final String PRECISION_FIELD_NAME = "precision";

    @JsonProperty(ID_FIELD_NAME)
    private Long id;

    @JsonProperty(CAMPAIGN_ID_FIELD_NAME)
    private Long campaignId;

    @JsonProperty(UID_FIELD_NAME)
    private Long uid;

    @JsonProperty(COMPANY_NAME_FIELD_NAME)
    private String companyName;

    @JsonProperty(WORK_TIME_FIELD_NAME)
    private String workTime;

    @JsonProperty(WORK_TIME_LIST_FIELD_NAME)
    private List<Map<String, String>> workTimeList;

    @JsonProperty(CONTACT_PERSON_FIELD_NAME)
    private String contactPerson;

    @JsonProperty(PHONE_FIELD_NAME)
    private WebPhone phone;

    @JsonProperty(EMAIL_FIELD_NAME)
    private String email;

    @JsonProperty(INSTANT_MESSENGER_FIELD_NAME)
    private WebInstantMessenger instantMessenger;

    @JsonProperty(EXTRA_MESSAGE_FIELD_NAME)
    private String extraMessage;

    @JsonProperty(ORG_DETAILS_ID_FIELD_NAME)
    private Long orgDetailsId;

    @JsonProperty(OGRN_FIELD_NAME)
    private String ogrn;

    @JsonProperty(GEO_ID_FIELD_NAME)
    private Long geoId;

    @JsonProperty(COUNTRY_FIELD_NAME)
    private String country;

    @JsonProperty(CITY_FIELD_NAME)
    private String city;

    @JsonProperty(STREET_FIELD_NAME)
    private String street;

    @JsonProperty(HOUSE_FIELD_NAME)
    private String house;

    @JsonProperty(BUILD_FIELD_NAME)
    private String build;

    @JsonProperty(APART_FIELD_NAME)
    private String apart;

    @JsonProperty(METRO_ID_FIELD_NAME)
    private Long metroId;

    @JsonProperty(METRO_NAME_FIELD_NAME)
    private String metroName;

    @JsonProperty(COUNTRY_GEO_ID_FIELD_NAME)
    private Long countryGeoId;

    @JsonProperty(MANUAL_POINT_FIELD_NAME)
    private WebPointOnMap manualPoint;

    @JsonProperty(AUTO_POINT_FIELD_NAME)
    private WebPointOnMap autoPoint;

    @JsonProperty(POINT_TYPE_FIELD_NAME)
    private PointType pointType;

    @JsonProperty(PRECISION_FIELD_NAME)
    private PointPrecision precision;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public WebVcard withId(Long id) {
        setId(id);
        return this;
    }

    public Long getCampaignId() {
        return campaignId;
    }

    public void setCampaignId(Long campaignId) {
        this.campaignId = campaignId;
    }

    public WebVcard withCampaignId(Long campaignId) {
        setCampaignId(campaignId);
        return this;
    }

    public Long getUid() {
        return uid;
    }

    public void setUid(Long uid) {
        this.uid = uid;
    }

    public WebVcard withUid(Long uid) {
        setUid(uid);
        return this;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public WebVcard withCompanyName(String companyName) {
        setCompanyName(companyName);
        return this;
    }

    public String getWorkTime() {
        return workTime;
    }

    public void setWorkTime(String workTime) {
        this.workTime = workTime;
    }

    public WebVcard withWorkTime(String workTime) {
        setWorkTime(workTime);
        return this;
    }

    public List<Map<String, String>> getWorkTimeList() {
        return workTimeList;
    }

    public void setWorkTimeList(List<Map<String, String>> workTimeList) {
        this.workTimeList = workTimeList;
    }

    public WebVcard withWorkTimeList(List<Map<String, String>> workTimeList) {
        setWorkTimeList(workTimeList);
        return this;
    }

    public String getContactPerson() {
        return contactPerson;
    }

    public void setContactPerson(String contactPerson) {
        this.contactPerson = contactPerson;
    }

    public WebVcard withContactPerson(String contactPerson) {
        setContactPerson(contactPerson);
        return this;
    }

    public WebPhone getPhone() {
        return phone;
    }

    public void setPhone(WebPhone phone) {
        this.phone = phone;
    }

    public WebVcard withPhone(WebPhone phone) {
        setPhone(phone);
        return this;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public WebVcard withEmail(String email) {
        setEmail(email);
        return this;
    }

    public WebInstantMessenger getInstantMessenger() {
        return instantMessenger;
    }

    public void setInstantMessenger(WebInstantMessenger instantMessenger) {
        this.instantMessenger = instantMessenger;
    }

    public WebVcard withInstantMessenger(WebInstantMessenger instantMessenger) {
        setInstantMessenger(instantMessenger);
        return this;
    }

    public String getExtraMessage() {
        return extraMessage;
    }

    public void setExtraMessage(String extraMessage) {
        this.extraMessage = extraMessage;
    }

    public WebVcard withExtraMessage(String extraMessage) {
        setExtraMessage(extraMessage);
        return this;
    }

    public Long getOrgDetailsId() {
        return orgDetailsId;
    }

    public void setOrgDetailsId(Long orgDetailsId) {
        this.orgDetailsId = orgDetailsId;
    }

    public WebVcard withOrgDetailsId(Long orgDetailsId) {
        setOrgDetailsId(orgDetailsId);
        return this;
    }

    public String getOgrn() {
        return ogrn;
    }

    public void setOgrn(String ogrn) {
        this.ogrn = ogrn;
    }

    public WebVcard withOgrn(String ogrn) {
        setOgrn(ogrn);
        return this;
    }

    public Long getGeoId() {
        return geoId;
    }

    public void setGeoId(Long geoId) {
        this.geoId = geoId;
    }

    public WebVcard withGeoId(Long geoId) {
        setGeoId(geoId);
        return this;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public WebVcard withCountry(String country) {
        setCountry(country);
        return this;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public WebVcard withCity(String city) {
        setCity(city);
        return this;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public WebVcard withStreet(String street) {
        setStreet(street);
        return this;
    }

    public String getHouse() {
        return house;
    }

    public void setHouse(String house) {
        this.house = house;
    }

    public WebVcard withHouse(String house) {
        setHouse(house);
        return this;
    }

    public String getBuild() {
        return build;
    }

    public void setBuild(String build) {
        this.build = build;
    }

    public WebVcard withBuild(String build) {
        setBuild(build);
        return this;
    }

    public String getApart() {
        return apart;
    }

    public void setApart(String apart) {
        this.apart = apart;
    }

    public WebVcard withApart(String apart) {
        setApart(apart);
        return this;
    }

    public Long getMetroId() {
        return metroId;
    }

    public void setMetroId(Long metroId) {
        this.metroId = metroId;
    }

    public WebVcard withMetroId(Long metroId) {
        setMetroId(metroId);
        return this;
    }

    public String getMetroName() {
        return metroName;
    }

    public void setMetroName(String metroName) {
        this.metroName = metroName;
    }

    public WebVcard withMetroName(String metroName) {
        setMetroName(metroName);
        return this;
    }

    public Long getCountryGeoId() {
        return countryGeoId;
    }

    public void setCountryGeoId(Long countryGeoId) {
        this.countryGeoId = countryGeoId;
    }

    public WebVcard withCountryGeoId(Long countryGeoId) {
        setCountryGeoId(countryGeoId);
        return this;
    }

    public WebPointOnMap getManualPoint() {
        return manualPoint;
    }

    public void setManualPoint(WebPointOnMap manualPoint) {
        this.manualPoint = manualPoint;
    }

    public WebVcard withManualPoint(WebPointOnMap manualPoint) {
        setManualPoint(manualPoint);
        return this;
    }

    public WebPointOnMap getAutoPoint() {
        return autoPoint;
    }

    public void setAutoPoint(WebPointOnMap autoPoint) {
        this.autoPoint = autoPoint;
    }

    public WebVcard withAutoPoint(WebPointOnMap autoPoint) {
        setAutoPoint(autoPoint);
        return this;
    }

    public PointType getPointType() {
        return pointType;
    }

    public void setPointType(PointType pointType) {
        this.pointType = pointType;
    }

    public WebVcard withPointType(PointType pointType) {
        setPointType(pointType);
        return this;
    }

    public PointPrecision getPrecision() {
        return precision;
    }

    public void setPrecision(PointPrecision precision) {
        this.precision = precision;
    }

    public WebVcard withPrecision(PointPrecision precision) {
        setPrecision(precision);
        return this;
    }
}
