#!/usr/bin/perl

use Direct::Modern;

use Yandex::DBTools;

use my_inc "../..";

use ScriptHelper;
use Settings;

my $CATEGORIES = [
    [ 2499980001, 0, "Сегменты пользователей", "internal", "crypta_root-users_name", "crypta_root-users_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980002, 0, "Сегменты Крипты", "internal", "crypta_root-crypta_name", "crypta_root-crypta_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980003, 2499980002, "Оффлайн покупки", "internal", "crypta_group-4bd86371_name", "crypta_group-4bd86371_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980004, 2499980002, "Интересы 2.0", "internal", "crypta_group-d0802a75_name", "crypta_group-d0802a75_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980005, 2499980002, "Категории общие", "internal", "crypta_group-62df3c1e_name", "crypta_group-62df3c1e_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980006, 2499980002, "Категории внешние", "internal", "crypta_group-d82d0705_name", "crypta_group-d82d0705_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980007, 2499980002, "Категории внутренние", "internal", "crypta_group-125d9976_name", "crypta_group-125d9976_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980008, 2499980002, "Посещения организаций", "internal", "crypta_group-8130912a_name", "crypta_group-8130912a_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980009, 2499980004, "Спорт", "internal", "crypta_segment-sport_name", "crypta_segment-sport_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980010, 2499980004, "Подарки и цветы", "internal", "crypta_segment-73ce984c_name", "crypta_segment-73ce984c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980011, 2499980004, "Образование", "internal", "crypta_segment-education_name", "crypta_segment-education_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980012, 2499980004, "Работа", "internal", "crypta_segment-jobs_name", "crypta_segment-jobs_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980013, 2499980004, "Красота и здоровье", "internal", "crypta_segment-beauty_and_health_name", "crypta_segment-beauty_and_health_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980014, 2499980004, "Одежда, обувь и аксессуары", "internal", "crypta_segment-clothing_shoes_accessories_name", "crypta_segment-clothing_shoes_accessories_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980015, 2499980004, "Бизнес", "internal", "crypta_segment-business_name", "crypta_segment-business_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980016, 2499980004, "Строительство, обустройство и ремонт", "internal", "crypta_segment-construction_installation_and_repair_name", "crypta_segment-construction_installation_and_repair_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980017, 2499980004, "Транспорт", "internal", "crypta_segment-transport_name", "crypta_segment-transport_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980018, 2499980004, "Электроника", "internal", "crypta_segment-electronics_name", "crypta_segment-electronics_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980019, 2499980004, "Бытовая техника", "internal", "crypta_segment-appliances_name", "crypta_segment-appliances_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980020, 2499980004, "Отдых и путешествия", "internal", "crypta_segment-recreation_and_travel_name", "crypta_segment-recreation_and_travel_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980021, 2499980004, "Финансы", "internal", "crypta_segment-finance_name", "crypta_segment-finance_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980022, 2499980004, "Телеком", "internal", "crypta_segment-telecom_name", "crypta_segment-telecom_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980023, 2499980004, "Развлечения и досуг", "internal", "crypta_segment-leisure_name", "crypta_segment-leisure_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980024, 2499980004, "Еда и напитки", "internal", "crypta_segment-food_and_drink_name", "crypta_segment-food_and_drink_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980025, 2499980004, "Недвижимость", "internal", "crypta_segment-realty_name", "crypta_segment-realty_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980026, 2499980004, "Семья и дети", "internal", "crypta_segment-family_name", "crypta_segment-family_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980027, 2499980004, "Животные", "internal", "crypta_segment-pets_name", "crypta_segment-pets_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980028, 2499980005, "Поколения", "internal", "crypta_group-2b44c228_name", "crypta_group-2b44c228_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980029, 2499980005, "Траты", "internal", "crypta_group-e988eef6_name", "crypta_group-e988eef6_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980030, 2499980005, "Семейное положение", "internal", "crypta_group-5d73960f_name", "crypta_group-5d73960f_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980031, 2499980005, "Обустройство и ремонт", "internal", "crypta_group-26a81741_name", "crypta_group-26a81741_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980032, 2499980005, "Кулинария", "internal", "crypta_group-8f9bdc1c_name", "crypta_group-8f9bdc1c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980033, 2499980005, "Электроника и бытовая техника", "internal", "crypta_group-fd20b8bb_name", "crypta_group-fd20b8bb_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980034, 2499980005, "Кино и телевизор", "internal", "crypta_group-3db5367c_name", "crypta_group-3db5367c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980035, 2499980005, "Транспорт", "internal", "crypta_group-5e109344_name", "crypta_group-5e109344_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980036, 2499980005, "Финансы", "internal", "crypta_group-d220768c_name", "crypta_group-d220768c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980037, 2499980005, "Спорт", "internal", "crypta_group-32d968ad_name", "crypta_group-32d968ad_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980038, 2499980005, "Игры", "internal", "crypta_group-e98fe366_name", "crypta_group-e98fe366_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980039, 2499980005, "Род деятельности", "internal", "crypta_group-7b929c59_name", "crypta_group-7b929c59_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980040, 2499980005, "Наличие детей", "internal", "crypta_group-6109162c_name", "crypta_group-6109162c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980041, 2499980005, "Недвижимость", "internal", "crypta_group-f50d8718_name", "crypta_group-f50d8718_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980042, 2499980005, "Культурный отдых", "internal", "crypta_group-2ab6ed10_name", "crypta_group-2ab6ed10_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980043, 2499980005, "Авто", "internal", "crypta_group-a5f17b71_name", "crypta_group-a5f17b71_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980044, 2499980005, "Устройства и телеком", "internal", "crypta_group-72ceb39c_name", "crypta_group-72ceb39c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980045, 2499980005, "Хобби и образ жизни", "internal", "crypta_group-f6c42cb8_name", "crypta_group-f6c42cb8_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980046, 2499980006, "Недвижимость", "internal", "crypta_group-1e4b3a11_name", "crypta_group-1e4b3a11_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980047, 2499980006, "Лексус", "internal", "crypta_group-a2666aa6_name", "crypta_group-a2666aa6_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980048, 2499980006, "Myprotein", "internal", "crypta_group-44253bc1_name", "crypta_group-44253bc1_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980049, 2499980006, "Мазда", "internal", "crypta_group-3c592e0b_name", "crypta_group-3c592e0b_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980050, 2499980006, "Тойота", "internal", "crypta_group-e884a441_name", "crypta_group-e884a441_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980051, 2499980006, "Mastercard", "internal", "crypta_group-7d96ce01_name", "crypta_group-7d96ce01_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980052, 2499980006, "Адамас", "internal", "crypta_group-b15270d2_name", "crypta_group-b15270d2_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980053, 2499980006, "Пользователи Алисы", "internal", "crypta_group-542c3100_name", "crypta_group-542c3100_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980054, 2499980006, "Wargaming", "internal", "crypta_group-480b9374_name", "crypta_group-480b9374_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980055, 2499980006, "P&G", "internal", "crypta_group-ec884ae6_name", "crypta_group-ec884ae6_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980056, 2499980006, "L'Oreal", "internal", "crypta_group-36ea2a3a_name", "crypta_group-36ea2a3a_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980057, 2499980006, "Клиенты мобильных операторов", "internal", "crypta_group-e1a2818a_name", "crypta_group-e1a2818a_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980058, 2499980006, "Radisson", "internal", "crypta_group-0909a243_name", "crypta_group-0909a243_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980059, 2499980006, "Лада", "internal", "crypta_group-d90bc225_name", "crypta_group-d90bc225_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980060, 2499980006, "Ауди", "internal", "crypta_group-3a82baa4_name", "crypta_group-3a82baa4_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980061, 2499980006, "Фольксваген", "internal", "crypta_group-03073645_name", "crypta_group-03073645_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980062, 2499980007, "Интересуются компьютерными играми", "internal", "crypta_group-b2607b4b_name", "crypta_group-b2607b4b_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980063, 2499980007, "Трекер", "internal", "crypta_group-2dca8b12_name", "crypta_group-2dca8b12_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980064, 2499980007, "Музыкальные жанры", "internal", "crypta_group-6d205b21_name", "crypta_group-6d205b21_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980065, 2499980007, "Взгляд", "internal", "crypta_group-ea318ea0_name", "crypta_group-ea318ea0_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980066, 2499980007, "Ищут работу (Таланты)", "internal", "crypta_group-e2922001_name", "crypta_group-e2922001_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980067, 2499980007, "Кинопоиск", "internal", "crypta_group-e5d85b98_name", "crypta_group-e5d85b98_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980068, 2499980007, "Такси", "internal", "crypta_group-3571e7d4_name", "crypta_group-3571e7d4_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980069, 2499980007, "Еда", "internal", "crypta_group-9deb10d5_name", "crypta_group-9deb10d5_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980070, 2499980007, "Толока", "internal", "crypta_group-518b1252_name", "crypta_group-518b1252_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980071, 2499980007, "Музыка", "internal", "crypta_group-4d9d25b1_name", "crypta_group-4d9d25b1_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980072, 2499980007, "Деньги", "internal", "crypta_group-7b3ed401_name", "crypta_group-7b3ed401_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980073, 2499980007, "Футбольные болельщики", "internal", "crypta_group-d726ba7a_name", "crypta_group-d726ba7a_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980074, 2499980007, "Телефония", "internal", "crypta_group-3e7bbe4d_name", "crypta_group-3e7bbe4d_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980075, 2499980007, "Карты", "internal", "crypta_group-c58a3671_name", "crypta_group-c58a3671_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980076, 2499980007, "Поисковое приложение", "internal", "crypta_group-01317be0_name", "crypta_group-01317be0_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980077, 2499980007, "Работа", "internal", "crypta_group-ad8e7a66_name", "crypta_group-ad8e7a66_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980078, 2499980007, "Авиабилеты", "internal", "crypta_group-b0814839_name", "crypta_group-b0814839_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980079, 2499980007, "Облако", "internal", "crypta_group-d461029b_name", "crypta_group-d461029b_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980080, 2499980007, "Яндекс.Плюс", "internal", "crypta_group-a88a43d3_name", "crypta_group-a88a43d3_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980081, 2499980007, "Яндекс.Практикум", "internal", "crypta_group-386354a3_name", "crypta_group-386354a3_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980082, 2499980007, "Геосервисы", "internal", "crypta_group-cc86a551_name", "crypta_group-cc86a551_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980083, 2499980007, "Samsung", "internal", "crypta_group-9bb60d3c_name", "crypta_group-9bb60d3c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980084, 2499980007, "Новые авторы Я.Района", "internal", "crypta_group-240e7bdb_name", "crypta_group-240e7bdb_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980085, 2499980007, "Яндекс.Станция", "internal", "crypta_group-78882ebb_name", "crypta_group-78882ebb_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980086, 2499980007, "ОФД", "internal", "crypta_group-b9d0ad05_name", "crypta_group-b9d0ad05_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980087, 2499980007, "Драйв", "internal", "crypta_group-826c4e17_name", "crypta_group-826c4e17_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980088, 2499980007, "Вебмастер", "internal", "crypta_group-8a9a5dec_name", "crypta_group-8a9a5dec_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980089, 2499980007, "Браузер", "internal", "crypta_group-d460a8b8_name", "crypta_group-d460a8b8_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980090, 2499980007, "Директ", "internal", "crypta_group-b44629a6_name", "crypta_group-b44629a6_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980091, 2499980007, "Ретаргетинг шоу Эфира", "internal", "crypta_group-037902ab_name", "crypta_group-037902ab_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980092, 2499980007, "СуперАпп", "internal", "crypta_group-24e7e381_name", "crypta_group-24e7e381_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980093, 2499980007, "Bookalook", "internal", "crypta_group-6a784e25_name", "crypta_group-6a784e25_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980094, 2499980007, "Афиша", "internal", "crypta_group-a7e254db_name", "crypta_group-a7e254db_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980095, 2499980007, "Маркет", "internal", "crypta_group-c75b778d_name", "crypta_group-c75b778d_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980096, 2499980008, "Транспорт", "internal", "crypta_group-1bade06d_name", "crypta_group-1bade06d_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980097, 2499980008, "Спорт", "internal", "crypta_group-cc3d7302_name", "crypta_group-cc3d7302_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980098, 2499980008, "Отдых и развлечения", "internal", "crypta_group-c518b39c_name", "crypta_group-c518b39c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980099, 2499980008, "Услуги", "internal", "crypta_group-5402c62c_name", "crypta_group-5402c62c_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980100, 2499980008, "Недвижимость", "internal", "crypta_group-ad1beaad_name", "crypta_group-ad1beaad_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980101, 2499980008, "Образование", "internal", "crypta_group-db40a5a5_name", "crypta_group-db40a5a5_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980102, 2499980008, "Магазины", "internal", "crypta_group-114be6c4_name", "crypta_group-114be6c4_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980103, 2499980008, "Еда", "internal", "crypta_group-48605aa7_name", "crypta_group-48605aa7_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980104, 2499980008, "Туризм", "internal", "crypta_group-a93b1881_name", "crypta_group-a93b1881_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980105, 2499980013, "Уход за волосами", "internal", "crypta_segment-hair_care_name", "crypta_segment-hair_care_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980106, 2499980013, "Парфюмерия", "internal", "crypta_segment-perfumery_name", "crypta_segment-perfumery_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980107, 2499980013, "Медицинские товары", "internal", "crypta_segment-medical_goods_name", "crypta_segment-medical_goods_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980108, 2499980013, "Декоративная косметика", "internal", "crypta_segment-cosmetics_name", "crypta_segment-cosmetics_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980109, 2499980014, "Аксессуары", "internal", "crypta_segment-accessories_name", "crypta_segment-accessories_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980110, 2499980014, "Обувь", "internal", "crypta_segment-shoes_name", "crypta_segment-shoes_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980111, 2499980014, "Одежда", "internal", "crypta_segment-clothing_name", "crypta_segment-clothing_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980112, 2499980016, "Товары для дома", "internal", "crypta_segment-9428314a_name", "crypta_segment-9428314a_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980113, 2499980016, "Мебель", "internal", "crypta_segment-furniture_name", "crypta_segment-furniture_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980114, 2499980016, "Дача и сад", "internal", "crypta_segment-summer_house_garden_name", "crypta_segment-summer_house_garden_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980115, 2499980016, "Ремонт", "internal", "crypta_segment-repairs_name", "crypta_segment-repairs_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980116, 2499980017, "Мото", "internal", "crypta_segment-moto_name", "crypta_segment-moto_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980117, 2499980017, "Авто", "internal", "crypta_segment-auto_name", "crypta_segment-auto_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980118, 2499980018, "Компьютерная техника", "internal", "crypta_segment-computers_name", "crypta_segment-computers_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980119, 2499980018, "Аудио- и видеотехника", "internal", "crypta_segment-audio_and_video_equipment_name", "crypta_segment-audio_and_video_equipment_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980120, 2499980018, "Мобильные телефоны и смартфоны", "internal", "crypta_segment-cell_phones_name", "crypta_segment-cell_phones_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980121, 2499980019, "Крупная техника для кухни", "internal", "crypta_segment-large_kitchen_appliances_name", "crypta_segment-large_kitchen_appliances_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980122, 2499980019, "Мелкая техника для кухни", "internal", "crypta_segment-small_kitchen_appliances_name", "crypta_segment-small_kitchen_appliances_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980123, 2499980019, "Техника для дома", "internal", "crypta_segment-household_appliances_name", "crypta_segment-household_appliances_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980124, 2499980019, "Техника для красоты и здоровья", "internal", "crypta_segment-appliances_for_personal_care_name", "crypta_segment-appliances_for_personal_care_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980125, 2499980021, "Финансовые услуги для бизнеса", "internal", "crypta_segment-financial_services_for_business_name", "crypta_segment-financial_services_for_business_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980126, 2499980023, "Музыка", "internal", "crypta_segment-music_name", "crypta_segment-music_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980127, 2499980023, "Кино", "internal", "crypta_segment-cinema_name", "crypta_segment-cinema_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980128, 2499980023, "Игры", "internal", "crypta_segment-games_name", "crypta_segment-games_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980129, 2499980026, "Товары для детей", "internal", "crypta_segment-products_for_children_name", "crypta_segment-products_for_children_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980130, 2499980034, "Жанры", "internal", "crypta_group-3db37c33_name", "crypta_group-3db37c33_description", "", "", "0", "0", "", "", "internal_ad" ],
    [ 2499980131, 2499980091, "Промо шоу с Беляевым", "internal", "crypta_group-b2ca23de_name", "crypta_group-b2ca23de_description", "", "", "0", "0", "", "", "internal_ad" ]
];

my $SEGMENTS = [
    [ 2499000011, 2499000023, "Выше среднего", "social_demo", "crypta_income_segment_b2_name", "crypta_income_segment_b2_description", "long-term", "", "618", "2", "", "", "internal_ad" ],

    [ 2499980501, 2499980089, "Пользовались мобильным браузером 0—15 дней назад", "internal", "crypta_segment-0a08c563_name", "crypta_segment-0a08c563_description", "all", "", "549", "1268", "", "", "internal_ad" ],
    [ 2499980502, 2499980089, "Лояльны к Яндекс.Браузеру в Казахстане", "internal", "crypta_segment-50de8911_name", "crypta_segment-50de8911_description", "all", "", "281", "231", "", "", "internal_ad" ],
    [ 2499980503, 2499980089, "Лояльны к Яндекс.Браузеру в Беларуси", "internal", "crypta_segment-5686565a_name", "crypta_segment-5686565a_description", "all", "", "281", "230", "", "", "internal_ad" ],
    [ 2499980504, 2499980089, "Лояльны к Яндекс.Браузеру в России", "internal", "crypta_segment-979ba25b_name", "crypta_segment-979ba25b_description", "all", "", "281", "218", "", "", "internal_ad" ],
    [ 2499980505, 2499980089, "Пользовались мобильным браузером 31—60 дней назад", "internal", "crypta_segment-aebc8a30_name", "crypta_segment-aebc8a30_description", "all", "", "549", "1270", "", "", "internal_ad" ],
    [ 2499980506, 2499980089, "Пользовались мобильным браузером 16—30 дней назад", "internal", "crypta_segment-ea60cd23_name", "crypta_segment-ea60cd23_description", "all", "", "549", "1269", "", "", "internal_ad" ],
];

my $OTHER_SEGMENTS = [
    [ 2499980507, 2499980001, "Авто.ру: Тойота Королла", "internal", "crypta_segment-0617b920_name", "crypta_segment-0617b920_description", "all", "", "549", "1360", "", "", "internal_ad" ],
    [ 2499980508, 2499980001, "Авто.ру: Митсубиси Аутлендер", "internal", "crypta_segment-062608cb_name", "crypta_segment-062608cb_description", "all", "", "549", "1363", "", "", "internal_ad" ],
    [ 2499980509, 2499980001, "Авто.ру: Форд Фокус", "internal", "crypta_segment-06ed6e6b_name", "crypta_segment-06ed6e6b_description", "all", "", "549", "1338", "", "", "internal_ad" ],
    [ 2499980510, 2499980001, "Авто.ру: БМВ 5", "internal", "crypta_segment-11b9ca98_name", "crypta_segment-11b9ca98_description", "all", "", "549", "1370", "", "", "internal_ad" ],
    [ 2499980511, 2499980001, "Знатоки: английский язык", "internal", "crypta_segment-1234ae43_name", "crypta_segment-1234ae43_description", "all", "", "549", "1332", "", "", "internal_ad" ],
    [ 2499980512, 2499980001, "Интересуются скидками (Едадил)", "internal", "crypta_segment-1ecce96d_name", "crypta_segment-1ecce96d_description", "all", "", "557", "11378794", "", "", "internal_ad" ],
    [ 2499980513, 2499980001, "Интересуются скидками (Едадил)", "internal", "crypta_segment-1ecce96d_name", "crypta_segment-1ecce96d_description", "all", "", "549", "1258", "", "", "internal_ad" ],
    [ 2499980514, 2499980001, "Авто.ру: БМВ Х5", "internal", "crypta_segment-3370b1d2_name", "crypta_segment-3370b1d2_description", "all", "", "549", "1369", "", "", "internal_ad" ],
    [ 2499980515, 2499980001, "Авто.ру: Опель Астра", "internal", "crypta_segment-361ec533_name", "crypta_segment-361ec533_description", "all", "", "549", "1362", "", "", "internal_ad" ],
    [ 2499980516, 2499980001, "Авто.ру: Хендай Солярис", "internal", "crypta_segment-384ac3e8_name", "crypta_segment-384ac3e8_description", "all", "", "549", "1353", "", "", "internal_ad" ],
    [ 2499980517, 2499980001, "Регистрация исполнителей для Услуг", "internal", "crypta_segment-3a751807_name", "crypta_segment-3a751807_description", "all", "", "549", "1282", "", "", "internal_ad" ],
    [ 2499980518, 2499980001, "Регистрация исполнителей для Услуг", "internal", "crypta_segment-3a751807_name", "crypta_segment-3a751807_description", "all", "", "557", "11567143", "", "", "internal_ad" ],
    [ 2499980519, 2499980001, "Авто.ру: Мерседес Е-класс", "internal", "crypta_segment-3e33a562_name", "crypta_segment-3e33a562_description", "all", "", "549", "1365", "", "", "internal_ad" ],
    [ 2499980520, 2499980001, "Игры общие (запросы)", "internal", "crypta_segment-451b018b_name", "crypta_segment-451b018b_description", "all", "", "549", "1643", "", "", "internal_ad" ],
    [ 2499980521, 2499980001, "Знатоки: Детский вопрой", "internal", "crypta_segment-478d29ca_name", "crypta_segment-478d29ca_description", "all", "", "549", "1380", "", "", "internal_ad" ],
    [ 2499980522, 2499980001, "Знатоки: архитектура", "internal", "crypta_segment-4a578985_name", "crypta_segment-4a578985_description", "all", "", "549", "1334", "", "", "internal_ad" ],
    [ 2499980523, 2499980001, "Авто.ру: Фольксваген Поло", "internal", "crypta_segment-4b0c914c_name", "crypta_segment-4b0c914c_description", "all", "", "549", "1356", "", "", "internal_ad" ],
    [ 2499980524, 2499980001, "Посетители сайтов технопарков", "internal", "crypta_segment-4b2d1028_name", "crypta_segment-4b2d1028_description", "all", "", "557", "13066237", "", "", "internal_ad" ],
    [ 2499980525, 2499980001, "Посетители сайтов технопарков", "internal", "crypta_segment-4b2d1028_name", "crypta_segment-4b2d1028_description", "all", "", "549", "1656", "", "", "internal_ad" ],
    [ 2499980526, 2499980001, "Знатоки: Учителя", "internal", "crypta_segment-4c23d08a_name", "crypta_segment-4c23d08a_description", "all", "", "549", "1381", "", "", "internal_ad" ],
    [ 2499980527, 2499980001, "Знатоки: Психологи", "internal", "crypta_segment-4e0081a4_name", "crypta_segment-4e0081a4_description", "all", "", "549", "1323", "", "", "internal_ad" ],
    [ 2499980528, 2499980001, "Знатоки: Apple", "internal", "crypta_segment-574d7dce_name", "crypta_segment-574d7dce_description", "all", "", "549", "1324", "", "", "internal_ad" ],
    [ 2499980529, 2499980001, "Знатоки: астрономия", "internal", "crypta_segment-5ca897d5_name", "crypta_segment-5ca897d5_description", "all", "", "549", "1337", "", "", "internal_ad" ],
    [ 2499980530, 2499980001, "Авто.ру: БМВ 3", "internal", "crypta_segment-63e91375_name", "crypta_segment-63e91375_description", "all", "", "549", "1371", "", "", "internal_ad" ],
    [ 2499980531, 2499980001, "Знатоки: анатомия", "internal", "crypta_segment-6ccb1480_name", "crypta_segment-6ccb1480_description", "all", "", "549", "1331", "", "", "internal_ad" ],
    [ 2499980532, 2499980001, "Авто.ру: Фольксваген Тигуан", "internal", "crypta_segment-6d617601_name", "crypta_segment-6d617601_description", "all", "", "549", "1355", "", "", "internal_ad" ],
    [ 2499980533, 2499980001, "Авто.ру: Фольксваген Пассат", "internal", "crypta_segment-758d440e_name", "crypta_segment-758d440e_description", "all", "", "549", "1357", "", "", "internal_ad" ],
    [ 2499980534, 2499980001, "Авто.ру: Тойота Камри", "internal", "crypta_segment-800d84b3_name", "crypta_segment-800d84b3_description", "all", "", "549", "1361", "", "", "internal_ad" ],
    [ 2499980535, 2499980001, "Игры Головоломки (запросы)", "internal", "crypta_segment-83de4a15_name", "crypta_segment-83de4a15_description", "all", "", "549", "1646", "", "", "internal_ad" ],
    [ 2499980536, 2499980001, "Едадил: интересуются скидками", "internal", "crypta_segment-888ac845_name", "crypta_segment-888ac845_description", "all", "", "549", "1376", "", "", "internal_ad" ],
    [ 2499980537, 2499980001, "Ищут дом на Новый год", "internal", "crypta_segment-8a0a1a6b_name", "crypta_segment-8a0a1a6b_description", "all", "", "549", "1318", "", "", "internal_ad" ],
    [ 2499980538, 2499980001, "Игра Престолов ", "internal", "crypta_segment-9c04e801_name", "crypta_segment-9c04e801_description", "all", "", "549", "1400", "", "", "internal_ad" ],
    [ 2499980539, 2499980001, "Авто.ру: Мерседес Ц-класс", "internal", "crypta_segment-a4495e0b_name", "crypta_segment-a4495e0b_description", "all", "", "549", "1364", "", "", "internal_ad" ],
    [ 2499980540, 2499980001, "Авто.ру: Тойота Ленд Крузер", "internal", "crypta_segment-abc910bc_name", "crypta_segment-abc910bc_description", "all", "", "549", "1359", "", "", "internal_ad" ],
    [ 2499980541, 2499980001, "Авто.ру: Шкода Октавия", "internal", "crypta_segment-acd76307_name", "crypta_segment-acd76307_description", "all", "", "549", "1354", "", "", "internal_ad" ],
    [ 2499980542, 2499980001, "Посетители сайтов курсов разработки и продакта", "internal", "crypta_segment-b5761682_name", "crypta_segment-b5761682_description", "all", "", "557", "13066246", "", "", "internal_ad" ],
    [ 2499980543, 2499980001, "Посетители сайтов курсов разработки и продакта", "internal", "crypta_segment-b5761682_name", "crypta_segment-b5761682_description", "all", "", "549", "1657", "", "", "internal_ad" ],
    [ 2499980544, 2499980001, "Покупают онлайн", "internal", "crypta_segment-b8216633_name", "crypta_segment-b8216633_description", "all", "", "549", "1622", "", "", "internal_ad" ],
    [ 2499980545, 2499980001, "Авто.ру: Киа Рио", "internal", "crypta_segment-ba64e259_name", "crypta_segment-ba64e259_description", "all", "", "549", "1368", "", "", "internal_ad" ],
    [ 2499980546, 2499980001, "Игры Гонки", "internal", "crypta_segment-bc8ddd7c_name", "crypta_segment-bc8ddd7c_description", "all", "", "549", "1642", "", "", "internal_ad" ],
    [ 2499980547, 2499980001, "Знатоки: android", "internal", "crypta_segment-bcd02d17_name", "crypta_segment-bcd02d17_description", "all", "", "549", "1257", "", "", "internal_ad" ],
    [ 2499980548, 2499980001, "Знатоки: seo", "internal", "crypta_segment-bee6d27e_name", "crypta_segment-bee6d27e_description", "all", "", "549", "1328", "", "", "internal_ad" ],
    [ 2499980549, 2499980001, "Авто.ру: Киа Спортэйдж", "internal", "crypta_segment-c1b242c3_name", "crypta_segment-c1b242c3_description", "all", "", "549", "1367", "", "", "internal_ad" ],
    [ 2499980550, 2499980001, "Знатоки: 9 мая", "internal", "crypta_segment-c1da3c70_name", "crypta_segment-c1da3c70_description", "all", "", "549", "1325", "", "", "internal_ad" ],
    [ 2499980551, 2499980001, "Пользователи образовательных платформ", "internal", "crypta_segment-c223c575_name", "crypta_segment-c223c575_description", "all", "", "557", "11831179", "", "", "internal_ad" ],
    [ 2499980552, 2499980001, "Игры Симуляторы (запросы)", "internal", "crypta_segment-c2ea991b_name", "crypta_segment-c2ea991b_description", "all", "", "549", "1647", "", "", "internal_ad" ],
    [ 2499980553, 2499980001, "Игры карточные (запросы)", "internal", "crypta_segment-c4b6b587_name", "crypta_segment-c4b6b587_description", "all", "", "549", "1645", "", "", "internal_ad" ],
    [ 2499980554, 2499980001, "Знатоки: авто", "internal", "crypta_segment-c8db915a_name", "crypta_segment-c8db915a_description", "all", "", "549", "1329", "", "", "internal_ad" ],
    [ 2499980555, 2499980001, "Знатоки: актеры", "internal", "crypta_segment-c9c63e62_name", "crypta_segment-c9c63e62_description", "all", "", "549", "1330", "", "", "internal_ad" ],
    [ 2499980556, 2499980001, "Авто.ру: Тойота Рав4", "internal", "crypta_segment-cbed1a3d_name", "crypta_segment-cbed1a3d_description", "all", "", "549", "1358", "", "", "internal_ad" ],
    [ 2499980557, 2499980001, "Пользователи учительских сервисов", "internal", "crypta_segment-d187c107_name", "crypta_segment-d187c107_description", "all", "", "557", "11831185", "", "", "internal_ad" ],
    [ 2499980558, 2499980001, "Знатоки: астрология", "internal", "crypta_segment-d25c9389_name", "crypta_segment-d25c9389_description", "all", "", "549", "1335", "", "", "internal_ad" ],
    [ 2499980559, 2499980001, "Знатоки: анимэ", "internal", "crypta_segment-e4bdb68e_name", "crypta_segment-e4bdb68e_description", "all", "", "549", "1333", "", "", "internal_ad" ],
    [ 2499980560, 2499980001, "Авто.ру: Лада 4х4", "internal", "crypta_segment-e6ae981e_name", "crypta_segment-e6ae981e_description", "all", "", "549", "1366", "", "", "internal_ad" ],
    [ 2499980561, 2499980001, "Пользователи образовательных сайтов", "internal", "crypta_segment-e6e453a5_name", "crypta_segment-e6e453a5_description", "all", "", "549", "1298", "", "", "internal_ad" ],
    [ 2499980562, 2499980001, "Знатоки: Excel", "internal", "crypta_segment-e99b63a9_name", "crypta_segment-e99b63a9_description", "all", "", "549", "1327", "", "", "internal_ad" ],
    [ 2499980563, 2499980003, "Покупали йогурты оффлайн", "internal", "crypta_segment-098c85b9_name", "crypta_segment-098c85b9_description", "all", "", "547", "1342", "", "", "internal_ad" ],
    [ 2499980564, 2499980003, "Покупали товары для кошек оффлайн", "internal", "crypta_segment-20195855_name", "crypta_segment-20195855_description", "all", "", "547", "1168", "", "", "internal_ad" ],
    [ 2499980565, 2499980003, "Покупали чипсы оффлайн", "internal", "crypta_segment-21c1c8c2_name", "crypta_segment-21c1c8c2_description", "all", "", "547", "1349", "", "", "internal_ad" ],
    [ 2499980566, 2499980003, "Покупали соки оффлайн", "internal", "crypta_segment-2dc3c13a_name", "crypta_segment-2dc3c13a_description", "all", "", "547", "1346", "", "", "internal_ad" ],
    [ 2499980567, 2499980003, "Покупали бытовую химию оффлайн", "internal", "crypta_segment-3c93c885_name", "crypta_segment-3c93c885_description", "all", "", "547", "1172", "", "", "internal_ad" ],
    [ 2499980568, 2499980003, "Покупали молочные продукты оффлайн", "internal", "crypta_segment-4651bb66_name", "crypta_segment-4651bb66_description", "all", "", "547", "1343", "", "", "internal_ad" ],
    [ 2499980569, 2499980003, "Покупали детские подгузники оффлайн", "internal", "crypta_segment-466194b0_name", "crypta_segment-466194b0_description", "all", "", "547", "1165", "", "", "internal_ad" ],
    [ 2499980570, 2499980003, "Покупали премиальных соков оффлайн", "internal", "crypta_segment-498b9aad_name", "crypta_segment-498b9aad_description", "all", "", "547", "1351", "", "", "internal_ad" ],
    [ 2499980571, 2499980003, "Покупали товары для собак оффлайн", "internal", "crypta_segment-58253735_name", "crypta_segment-58253735_description", "all", "", "547", "1169", "", "", "internal_ad" ],
    [ 2499980572, 2499980003, "Покупали детские товары оффлайн", "internal", "crypta_segment-6c1e832c_name", "crypta_segment-6c1e832c_description", "all", "", "547", "1164", "", "", "internal_ad" ],
    [ 2499980573, 2499980003, "Покупали масс-маркет косметику оффлайн", "internal", "crypta_segment-707b76a4_name", "crypta_segment-707b76a4_description", "all", "", "547", "1171", "", "", "internal_ad" ],
    [ 2499980574, 2499980003, "Покупали холодный чай оффлайн", "internal", "crypta_segment-7eb4be4b_name", "crypta_segment-7eb4be4b_description", "all", "", "547", "1348", "", "", "internal_ad" ],
    [ 2499980575, 2499980003, "Покупали детскую еду оффлайн", "internal", "crypta_segment-861720b8_name", "crypta_segment-861720b8_description", "all", "", "547", "1166", "", "", "internal_ad" ],
    [ 2499980576, 2499980003, "Покупали детские игрушки оффлайн", "internal", "crypta_segment-872cc87c_name", "crypta_segment-872cc87c_description", "all", "", "547", "1167", "", "", "internal_ad" ],
    [ 2499980577, 2499980003, "Покупали энергетики оффлайн", "internal", "crypta_segment-8e7d6da9_name", "crypta_segment-8e7d6da9_description", "all", "", "547", "1350", "", "", "internal_ad" ],
    [ 2499980578, 2499980003, "Покупали кофе оффлайн", "internal", "crypta_segment-9b0ac48b_name", "crypta_segment-9b0ac48b_description", "all", "", "547", "1170", "", "", "internal_ad" ],
    [ 2499980579, 2499980003, "Покупали кофе оффлайн", "internal", "crypta_segment-9b0ac48b_name", "crypta_segment-9b0ac48b_description", "all", "", "557", "11950468", "", "", "internal_ad" ],
    [ 2499980580, 2499980003, "Покупали чай оффлайн", "internal", "crypta_segment-9b30b629_name", "crypta_segment-9b30b629_description", "all", "", "547", "1248", "", "", "internal_ad" ],
    [ 2499980581, 2499980003, "Покупали чай оффлайн", "internal", "crypta_segment-9b30b629_name", "crypta_segment-9b30b629_description", "all", "", "557", "11950474", "", "", "internal_ad" ],
    [ 2499980582, 2499980003, "Покупали сыр оффлайн", "internal", "crypta_segment-a572bcb1_name", "crypta_segment-a572bcb1_description", "all", "", "547", "1347", "", "", "internal_ad" ],
    [ 2499980583, 2499980003, "Покупали воду оффлайн", "internal", "crypta_segment-a69ec37e_name", "crypta_segment-a69ec37e_description", "all", "", "547", "1340", "", "", "internal_ad" ],
    [ 2499980584, 2499980003, "Покупали газированные напитки оффлайн", "internal", "crypta_segment-aae3d9a1_name", "crypta_segment-aae3d9a1_description", "all", "", "547", "1341", "", "", "internal_ad" ],
    [ 2499980585, 2499980003, "Покупали снеки оффлайн", "internal", "crypta_segment-b84159a4_name", "crypta_segment-b84159a4_description", "all", "", "547", "1345", "", "", "internal_ad" ],
    [ 2499980586, 2499980003, "Покупали слабоалкогольные напитки оффлайн", "internal", "crypta_segment-c45c5092_name", "crypta_segment-c45c5092_description", "all", "", "547", "1344", "", "", "internal_ad" ],
    [ 2499980587, 2499980003, "Покупали сладости оффлайн", "internal", "crypta_segment-c4e425e7_name", "crypta_segment-c4e425e7_description", "all", "", "547", "1173", "", "", "internal_ad" ],
    [ 2499980588, 2499980004, "Подарки и цветы", "internal", "crypta_segment-73ce984c_name", "crypta_segment-73ce984c_description", "all", "", "557", "12156625", "", "", "internal_ad" ],
    [ 2499980589, 2499980004, "Подарки и цветы", "internal", "crypta_segment-73ce984c_name", "crypta_segment-73ce984c_description", "all", "", "601", "241", "", "", "internal_ad" ],
    [ 2499980590, 2499980004, "Подарки и цветы", "internal", "crypta_segment-73ce984c_name", "crypta_segment-73ce984c_description", "all", "", "602", "241", "", "", "internal_ad" ],
    [ 2499980591, 2499980004, "Бытовая техника", "internal", "crypta_segment-appliances_name", "crypta_segment-appliances_description", "all", "", "601", "211", "", "", "internal_ad" ],
    [ 2499980592, 2499980004, "Бытовая техника", "internal", "crypta_segment-appliances_name", "crypta_segment-appliances_description", "all", "", "557", "10964785", "", "", "internal_ad" ],
    [ 2499980593, 2499980004, "Бытовая техника", "internal", "crypta_segment-appliances_name", "crypta_segment-appliances_description", "all", "", "602", "211", "", "", "internal_ad" ],
    [ 2499980594, 2499980004, "Красота и здоровье", "internal", "crypta_segment-beauty_and_health_name", "crypta_segment-beauty_and_health_description", "all", "", "601", "183", "", "", "internal_ad" ],
    [ 2499980595, 2499980004, "Красота и здоровье", "internal", "crypta_segment-beauty_and_health_name", "crypta_segment-beauty_and_health_description", "all", "", "602", "183", "", "", "internal_ad" ],
    [ 2499980596, 2499980004, "Бизнес", "internal", "crypta_segment-business_name", "crypta_segment-business_description", "all", "", "601", "173", "", "", "internal_ad" ],
    [ 2499980597, 2499980004, "Бизнес", "internal", "crypta_segment-business_name", "crypta_segment-business_description", "all", "", "602", "173", "", "", "internal_ad" ],
    [ 2499980598, 2499980004, "Бизнес", "internal", "crypta_segment-business_name", "crypta_segment-business_description", "all", "", "557", "3997067", "", "", "internal_ad" ],
    [ 2499980599, 2499980004, "Одежда, обувь и аксессуары", "internal", "crypta_segment-clothing_shoes_accessories_name", "crypta_segment-clothing_shoes_accessories_description", "all", "", "602", "141", "", "", "internal_ad" ],
    [ 2499980600, 2499980004, "Одежда, обувь и аксессуары", "internal", "crypta_segment-clothing_shoes_accessories_name", "crypta_segment-clothing_shoes_accessories_description", "all", "", "601", "141", "", "", "internal_ad" ],
    [ 2499980601, 2499980004, "Строительство, обустройство и ремонт", "internal", "crypta_segment-construction_installation_and_repair_name", "crypta_segment-construction_installation_and_repair_description", "all", "", "557", "5232403", "", "", "internal_ad" ],
    [ 2499980602, 2499980004, "Строительство, обустройство и ремонт", "internal", "crypta_segment-construction_installation_and_repair_name", "crypta_segment-construction_installation_and_repair_description", "all", "", "602", "115", "", "", "internal_ad" ],
    [ 2499980603, 2499980004, "Строительство, обустройство и ремонт", "internal", "crypta_segment-construction_installation_and_repair_name", "crypta_segment-construction_installation_and_repair_description", "all", "", "601", "115", "", "", "internal_ad" ],
    [ 2499980604, 2499980004, "Образование", "internal", "crypta_segment-education_name", "crypta_segment-education_description", "all", "", "602", "1", "", "", "internal_ad" ],
    [ 2499980605, 2499980004, "Образование", "internal", "crypta_segment-education_name", "crypta_segment-education_description", "all", "", "601", "1", "", "", "internal_ad" ],
    [ 2499980606, 2499980004, "Электроника", "internal", "crypta_segment-electronics_name", "crypta_segment-electronics_description", "all", "", "601", "192", "", "", "internal_ad" ],
    [ 2499980607, 2499980004, "Электроника", "internal", "crypta_segment-electronics_name", "crypta_segment-electronics_description", "all", "", "557", "11197012", "", "", "internal_ad" ],
    [ 2499980608, 2499980004, "Электроника", "internal", "crypta_segment-electronics_name", "crypta_segment-electronics_description", "all", "", "602", "192", "", "", "internal_ad" ],
    [ 2499980609, 2499980004, "Семья и дети", "internal", "crypta_segment-family_name", "crypta_segment-family_description", "all", "", "602", "34", "", "", "internal_ad" ],
    [ 2499980610, 2499980004, "Семья и дети", "internal", "crypta_segment-family_name", "crypta_segment-family_description", "all", "", "601", "34", "", "", "internal_ad" ],
    [ 2499980611, 2499980004, "Финансы", "internal", "crypta_segment-finance_name", "crypta_segment-finance_description", "all", "", "602", "76", "", "", "internal_ad" ],
    [ 2499980612, 2499980004, "Финансы", "internal", "crypta_segment-finance_name", "crypta_segment-finance_description", "all", "", "601", "76", "", "", "internal_ad" ],
    [ 2499980613, 2499980004, "Еда и напитки", "internal", "crypta_segment-food_and_drink_name", "crypta_segment-food_and_drink_description", "all", "", "602", "55", "", "", "internal_ad" ],
    [ 2499980614, 2499980004, "Еда и напитки", "internal", "crypta_segment-food_and_drink_name", "crypta_segment-food_and_drink_description", "all", "", "601", "55", "", "", "internal_ad" ],
    [ 2499980615, 2499980004, "Работа", "internal", "crypta_segment-jobs_name", "crypta_segment-jobs_description", "all", "", "601", "189", "", "", "internal_ad" ],
    [ 2499980616, 2499980004, "Работа", "internal", "crypta_segment-jobs_name", "crypta_segment-jobs_description", "all", "", "602", "189", "", "", "internal_ad" ],
    [ 2499980617, 2499980004, "Развлечения и досуг", "internal", "crypta_segment-leisure_name", "crypta_segment-leisure_description", "all", "", "601", "4", "", "", "internal_ad" ],
    [ 2499980618, 2499980004, "Развлечения и досуг", "internal", "crypta_segment-leisure_name", "crypta_segment-leisure_description", "all", "", "602", "4", "", "", "internal_ad" ],
    [ 2499980619, 2499980004, "Животные", "internal", "crypta_segment-pets_name", "crypta_segment-pets_description", "all", "", "602", "202", "", "", "internal_ad" ],
    [ 2499980620, 2499980004, "Животные", "internal", "crypta_segment-pets_name", "crypta_segment-pets_description", "all", "", "601", "202", "", "", "internal_ad" ],
    [ 2499980621, 2499980004, "Недвижимость", "internal", "crypta_segment-realty_name", "crypta_segment-realty_description", "all", "", "601", "210", "", "", "internal_ad" ],
    [ 2499980622, 2499980004, "Недвижимость", "internal", "crypta_segment-realty_name", "crypta_segment-realty_description", "all", "", "602", "210", "", "", "internal_ad" ],
    [ 2499980623, 2499980004, "Отдых и путешествия", "internal", "crypta_segment-recreation_and_travel_name", "crypta_segment-recreation_and_travel_description", "all", "", "602", "128", "", "", "internal_ad" ],
    [ 2499980624, 2499980004, "Отдых и путешествия", "internal", "crypta_segment-recreation_and_travel_name", "crypta_segment-recreation_and_travel_description", "all", "", "601", "128", "", "", "internal_ad" ],
    [ 2499980625, 2499980004, "Спорт", "internal", "crypta_segment-sport_name", "crypta_segment-sport_description", "all", "", "601", "216", "", "", "internal_ad" ],
    [ 2499980626, 2499980004, "Спорт", "internal", "crypta_segment-sport_name", "crypta_segment-sport_description", "all", "", "602", "216", "", "", "internal_ad" ],
    [ 2499980627, 2499980004, "Телеком", "internal", "crypta_segment-telecom_name", "crypta_segment-telecom_description", "all", "", "602", "43", "", "", "internal_ad" ],
    [ 2499980628, 2499980004, "Телеком", "internal", "crypta_segment-telecom_name", "crypta_segment-telecom_description", "all", "", "601", "43", "", "", "internal_ad" ],
    [ 2499980629, 2499980004, "Транспорт", "internal", "crypta_segment-transport_name", "crypta_segment-transport_description", "all", "", "601", "176", "", "", "internal_ad" ],
    [ 2499980630, 2499980004, "Транспорт", "internal", "crypta_segment-transport_name", "crypta_segment-transport_description", "all", "", "602", "176", "", "", "internal_ad" ],
    [ 2499980631, 2499980006, "Курильщики", "internal", "crypta_segment-175b0b3d_name", "crypta_segment-175b0b3d_description", "all", "", "557", "7240433", "", "", "internal_ad" ],
    [ 2499980632, 2499980006, "Курильщики", "internal", "crypta_segment-175b0b3d_name", "crypta_segment-175b0b3d_description", "all", "", "281", "319", "", "", "internal_ad" ],
    [ 2499980633, 2499980006, "Пользователи карт Visa", "internal", "crypta_segment-1b569513_name", "crypta_segment-1b569513_description", "all", "", "216", "635", "", "", "internal_ad" ],
    [ 2499980634, 2499980006, "Пользователи карт Visa", "internal", "crypta_segment-1b569513_name", "crypta_segment-1b569513_description", "all", "", "557", "6998965", "", "", "internal_ad" ],
    [ 2499980635, 2499980006, "Московские студенты из Нижнего Новгорода", "internal", "crypta_segment-1ce4951b_name", "crypta_segment-1ce4951b_description", "all", "", "557", "12188185", "", "", "internal_ad" ],
    [ 2499980636, 2499980006, "Модники (YOOX)", "internal", "crypta_segment-34cb7b59_name", "crypta_segment-34cb7b59_description", "all", "", "557", "11831386", "", "", "internal_ad" ],
    [ 2499980637, 2499980006, "Пользователи смартфонов Samsung", "internal", "crypta_segment-407dced7_name", "crypta_segment-407dced7_description", "all", "", "216", "616", "", "", "internal_ad" ],
    [ 2499980638, 2499980006, "Скорее всего, держат дома кошек", "internal", "crypta_segment-54a7beab_name", "crypta_segment-54a7beab_description", "all", "", "557", "4778287", "", "", "internal_ad" ],
    [ 2499980639, 2499980006, "Пользователи планшетов Samsung", "internal", "crypta_segment-5d6b5ba5_name", "crypta_segment-5d6b5ba5_description", "all", "", "216", "615", "", "", "internal_ad" ],
    [ 2499980640, 2499980006, "Интересуются Тинькофф или Альфа-Банком", "internal", "crypta_segment-5f32b897_name", "crypta_segment-5f32b897_description", "all", "", "216", "559", "", "", "internal_ad" ],
    [ 2499980641, 2499980006, "Курильщики (расширенный)", "internal", "crypta_segment-6d6d082d_name", "crypta_segment-6d6d082d_description", "all", "", "557", "11682883", "", "", "internal_ad" ],
    [ 2499980642, 2499980006, "Покупают канцелярию", "internal", "crypta_segment-6ee92452_name", "crypta_segment-6ee92452_description", "all", "", "557", "11221900", "", "", "internal_ad" ],
    [ 2499980643, 2499980006, "Интересуются Renault Kaptur", "internal", "crypta_segment-735ad894_name", "crypta_segment-735ad894_description", "all", "", "557", "6966571", "", "", "internal_ad" ],
    [ 2499980644, 2499980006, "Интересуются новостными ресурсами", "internal", "crypta_segment-792dab89_name", "crypta_segment-792dab89_description", "all", "", "557", "12990205", "", "", "internal_ad" ],
    [ 2499980645, 2499980006, "Интересуются сервисами по продаже авиабилетов (Skyscanner)", "internal", "crypta_segment-7da527b8_name", "crypta_segment-7da527b8_description", "all", "", "557", "12444595", "", "", "internal_ad" ],
    [ 2499980646, 2499980006, "Скорее всего, держат дома собак", "internal", "crypta_segment-8820c544_name", "crypta_segment-8820c544_description", "all", "", "557", "4778317", "", "", "internal_ad" ],
    [ 2499980647, 2499980006, "Пользователи карт MasterCard", "internal", "crypta_segment-890059f0_name", "crypta_segment-890059f0_description", "all", "", "557", "6816497", "", "", "internal_ad" ],
    [ 2499980648, 2499980006, "Пользователи карт MasterCard", "internal", "crypta_segment-890059f0_name", "crypta_segment-890059f0_description", "all", "", "216", "601", "", "", "internal_ad" ],
    [ 2499980649, 2499980006, "Планируют завести домашнее животное", "internal", "crypta_segment-8961299a_name", "crypta_segment-8961299a_description", "all", "", "557", "4778185", "", "", "internal_ad" ],
    [ 2499980650, 2499980006, "Интересуются мультивалютными картами", "internal", "crypta_segment-90ca51e5_name", "crypta_segment-90ca51e5_description", "all", "", "557", "9162397", "", "", "internal_ad" ],
    [ 2499980651, 2499980006, "Интересуются заболеваниями печени", "internal", "crypta_segment-9809aa5a_name", "crypta_segment-9809aa5a_description", "all", "", "557", "11191534", "", "", "internal_ad" ],
    [ 2499980652, 2499980006, "Интересуются современными банками", "internal", "crypta_segment-9a2075f6_name", "crypta_segment-9a2075f6_description", "all", "", "216", "597", "", "", "internal_ad" ],
    [ 2499980653, 2499980006, "Интересуются фургонами (ГАЗ)", "internal", "crypta_segment-a91778ca_name", "crypta_segment-a91778ca_description", "all", "", "557", "12217180", "", "", "internal_ad" ],
    [ 2499980654, 2499980006, "Пользователи MacOS", "internal", "crypta_segment-b179ecaa_name", "crypta_segment-b179ecaa_description", "all", "", "557", "5468482", "", "", "internal_ad" ],
    [ 2499980655, 2499980006, "Фанаты «Звездных войн»", "internal", "crypta_segment-bff15505_name", "crypta_segment-bff15505_description", "all", "", "557", "7929730", "", "", "internal_ad" ],
    [ 2499980656, 2499980006, "Малый и средний бизнес для Касперского", "internal", "crypta_segment-c5c2120e_name", "crypta_segment-c5c2120e_description", "all", "", "557", "10963801", "", "", "internal_ad" ],
    [ 2499980657, 2499980006, "Супермаркеты: акции и скидки", "internal", "crypta_segment-d3845d9d_name", "crypta_segment-d3845d9d_description", "all", "", "557", "8253865", "", "", "internal_ad" ],
    [ 2499980658, 2499980007, "Интересуются шоу Парфенова", "internal", "crypta_segment-046a5c16_name", "crypta_segment-046a5c16_description", "all", "", "549", "1267", "", "", "internal_ad" ],
    [ 2499980659, 2499980007, "Ищут работу курьером", "internal", "crypta_segment-08623136_name", "crypta_segment-08623136_description", "all", "", "546", "1379", "", "", "internal_ad" ],
    [ 2499980660, 2499980007, "Ищут работу курьером", "internal", "crypta_segment-08623136_name", "crypta_segment-08623136_description", "all", "", "549", "1259", "", "", "internal_ad" ],
    [ 2499980661, 2499980007, "Покупали 2 билета в кино", "internal", "crypta_segment-0eb35ed7_name", "crypta_segment-0eb35ed7_description", "all", "", "557", "12908974", "", "", "internal_ad" ],
    [ 2499980662, 2499980007, "Смотрят спорт в Яндекс.Эфире", "internal", "crypta_segment-1442d506_name", "crypta_segment-1442d506_description", "all", "", "557", "11166772", "", "", "internal_ad" ],
    [ 2499980663, 2499980007, "Работают в Яндексе", "internal", "crypta_segment-1550b136_name", "crypta_segment-1550b136_description", "all", "", "557", "12379201", "", "", "internal_ad" ],
    [ 2499980664, 2499980007, "Работают в Яндексе", "internal", "crypta_segment-1550b136_name", "crypta_segment-1550b136_description", "all", "", "549", "1410", "", "", "internal_ad" ],
    [ 2499980665, 2499980007, "Пользователи ноутбуков", "internal", "crypta_segment-177a1cdc_name", "crypta_segment-177a1cdc_description", "all", "", "549", "1152", "", "", "internal_ad" ],
    [ 2499980666, 2499980007, "Партнеры рекламной сети Яндекс", "internal", "crypta_segment-1ac1379b_name", "crypta_segment-1ac1379b_description", "all", "", "281", "296", "", "", "internal_ad" ],
    [ 2499980667, 2499980007, "Искали телефонные номера", "internal", "crypta_segment-21becec6_name", "crypta_segment-21becec6_description", "all", "", "549", "1207", "", "", "internal_ad" ],
    [ 2499980668, 2499980007, "Интересуются ювелирными украшениями", "internal", "crypta_segment-2402c34e_name", "crypta_segment-2402c34e_description", "all", "", "281", "314", "", "", "internal_ad" ],
    [ 2499980669, 2499980007, "Искали корпоративное питание", "internal", "crypta_segment-2a9e9246_name", "crypta_segment-2a9e9246_description", "all", "", "549", "1230", "", "", "internal_ad" ],
    [ 2499980670, 2499980007, "Пользователи Яндекс.Эфира", "internal", "crypta_segment-2de62bca_name", "crypta_segment-2de62bca_description", "all", "", "557", "7558393", "", "", "internal_ad" ],
    [ 2499980671, 2499980007, "Пользователи Яндекс.Эфира", "internal", "crypta_segment-2de62bca_name", "crypta_segment-2de62bca_description", "all", "", "549", "1150", "", "", "internal_ad" ],
    [ 2499980672, 2499980007, "Пользователи Яндекс.Эфира", "internal", "crypta_segment-2de62bca_name", "crypta_segment-2de62bca_description", "all", "", "546", "1208", "", "", "internal_ad" ],
    [ 2499980673, 2499980007, "Молодожены", "internal", "crypta_segment-327c5710_name", "crypta_segment-327c5710_description", "all", "", "557", "12907864", "", "", "internal_ad" ],
    [ 2499980674, 2499980007, "С предустановленным Я.Бро на телефоне", "internal", "crypta_segment-3745e01c_name", "crypta_segment-3745e01c_description", "all", "", "549", "1200", "", "", "internal_ad" ],
    [ 2499980675, 2499980007, "Школьники 14-17 лет", "internal", "crypta_segment-3843a7a0_name", "crypta_segment-3843a7a0_description", "all", "", "549", "1151", "", "", "internal_ad" ],
    [ 2499980676, 2499980007, "Школьники 14-17 лет", "internal", "crypta_segment-3843a7a0_name", "crypta_segment-3843a7a0_description", "all", "", "557", "7558375", "", "", "internal_ad" ],
    [ 2499980677, 2499980007, "Читают глянцевые журналы", "internal", "crypta_segment-4653768e_name", "crypta_segment-4653768e_description", "all", "", "281", "317", "", "", "internal_ad" ],
    [ 2499980678, 2499980007, "Мастера в области красоты", "internal", "crypta_segment-476c70cd_name", "crypta_segment-476c70cd_description", "all", "", "549", "1159", "", "", "internal_ad" ],
    [ 2499980679, 2499980007, "Пользователи Советника", "internal", "crypta_segment-48b7ba83_name", "crypta_segment-48b7ba83_description", "all", "", "281", "282", "", "", "internal_ad" ],
    [ 2499980680, 2499980007, "Владельцы бизнеса", "internal", "crypta_segment-491880e1_name", "crypta_segment-491880e1_description", "all", "", "557", "5994829", "", "", "internal_ad" ],
    [ 2499980681, 2499980007, "Владельцы бизнеса", "internal", "crypta_segment-491880e1_name", "crypta_segment-491880e1_description", "all", "", "281", "168", "", "", "internal_ad" ],
    [ 2499980682, 2499980007, "Смотрят короткие видео на Эфире", "internal", "crypta_segment-4a25399c_name", "crypta_segment-4a25399c_description", "all", "", "546", "1275", "", "", "internal_ad" ],
    [ 2499980683, 2499980007, "Смотрят короткие видео на Эфире", "internal", "crypta_segment-4a25399c_name", "crypta_segment-4a25399c_description", "all", "", "549", "1274", "", "", "internal_ad" ],
    [ 2499980684, 2499980007, "Похожие на пользователей Я.Репетитора", "internal", "crypta_segment-6a1540d1_name", "crypta_segment-6a1540d1_description", "all", "", "546", "1119", "", "", "internal_ad" ],
    [ 2499980685, 2499980007, "Увлекаются рыбалкой", "internal", "crypta_segment-706c0c53_name", "crypta_segment-706c0c53_description", "all", "", "281", "300", "", "", "internal_ad" ],
    [ 2499980686, 2499980007, "Похожи на владельцев бизнеса", "internal", "crypta_segment-725a2705_name", "crypta_segment-725a2705_description", "all", "", "281", "151", "", "", "internal_ad" ],
    [ 2499980687, 2499980007, "Интересуются регистрацией брака", "internal", "crypta_segment-7471baa6_name", "crypta_segment-7471baa6_description", "all", "", "557", "12908341", "", "", "internal_ad" ],
    [ 2499980688, 2499980007, "Интересуются конкурсами по разработке", "internal", "crypta_segment-80829abd_name", "crypta_segment-80829abd_description", "all", "", "549", "1216", "", "", "internal_ad" ],
    [ 2499980689, 2499980007, "Интересуются окрашиванием волос", "internal", "crypta_segment-87d6215e_name", "crypta_segment-87d6215e_description", "all", "", "281", "313", "", "", "internal_ad" ],
    [ 2499980690, 2499980007, "СЕО специалисты", "internal", "crypta_segment-8b805781_name", "crypta_segment-8b805781_description", "all", "", "557", "5994841", "", "", "internal_ad" ],
    [ 2499980691, 2499980007, "СЕО специалисты", "internal", "crypta_segment-8b805781_name", "crypta_segment-8b805781_description", "all", "", "281", "208", "", "", "internal_ad" ],
    [ 2499980692, 2499980007, "Интересуются самокатами", "internal", "crypta_segment-9724d1ec_name", "crypta_segment-9724d1ec_description", "all", "", "281", "301", "", "", "internal_ad" ],
    [ 2499980693, 2499980007, "Интересуются 14 февраля", "internal", "crypta_segment-977d08d5_name", "crypta_segment-977d08d5_description", "all", "", "557", "12907702", "", "", "internal_ad" ],
    [ 2499980694, 2499980007, "Владельцы Яндекс.Телефонов", "internal", "crypta_segment-ac511388_name", "crypta_segment-ac511388_description", "all", "", "281", "299", "", "", "internal_ad" ],
    [ 2499980695, 2499980007, "Интересуются историей СССР", "internal", "crypta_segment-b9cc2e29_name", "crypta_segment-b9cc2e29_description", "all", "", "549", "1254", "", "", "internal_ad" ],
    [ 2499980696, 2499980007, "Похожи на асессоров и толокеров", "internal", "crypta_segment-bacaa6e4_name", "crypta_segment-bacaa6e4_description", "all", "", "546", "1121", "", "", "internal_ad" ],
    [ 2499980697, 2499980007, "Интересуются новостями", "internal", "crypta_segment-bb0e918c_name", "crypta_segment-bb0e918c_description", "all", "", "281", "297", "", "", "internal_ad" ],
    [ 2499980698, 2499980007, "CRYPTAUP-1589", "internal", "crypta_segment-bce50a9e_name", "crypta_segment-bce50a9e_description", "all", "", "549", "1206", "", "", "internal_ad" ],
    [ 2499980699, 2499980007, "Скейтеры", "internal", "crypta_segment-c14dd539_name", "crypta_segment-c14dd539_description", "all", "", "281", "302", "", "", "internal_ad" ],
    [ 2499980700, 2499980007, "Репетиторы", "internal", "crypta_segment-c68a3517_name", "crypta_segment-c68a3517_description", "all", "", "549", "1158", "", "", "internal_ad" ],
    [ 2499980701, 2499980007, "Rammstein", "internal", "crypta_segment-ca1889cd_name", "crypta_segment-ca1889cd_description", "all", "", "549", "1255", "", "", "internal_ad" ],
    [ 2499980702, 2499980007, "Интересуютcя накрутками seo", "internal", "crypta_segment-ca23e588_name", "crypta_segment-ca23e588_description", "all", "", "549", "1641", "", "", "internal_ad" ],
    [ 2499980703, 2499980007, "Посещают сайты экологической тематики", "internal", "crypta_segment-ca8ccb23_name", "crypta_segment-ca8ccb23_description", "all", "", "281", "312", "", "", "internal_ad" ],
    [ 2499980704, 2499980007, "Охотники за купонами и промокодами", "internal", "crypta_segment-cde20c75_name", "crypta_segment-cde20c75_description", "all", "", "557", "8647867", "", "", "internal_ad" ],
    [ 2499980705, 2499980007, "Фронтенд разработчики", "internal", "crypta_segment-ceea2721_name", "crypta_segment-ceea2721_description", "all", "", "281", "298", "", "", "internal_ad" ],
    [ 2499980706, 2499980007, "Фронтенд разработчики", "internal", "crypta_segment-ceea2721_name", "crypta_segment-ceea2721_description", "all", "", "557", "8909929", "", "", "internal_ad" ],
    [ 2499980707, 2499980007, "Интересуются обучением в школе и программированием", "internal", "crypta_segment-d14210b9_name", "crypta_segment-d14210b9_description", "all", "", "281", "294", "", "", "internal_ad" ],
    [ 2499980708, 2499980007, "С предустановленным ПП на телефоне", "internal", "crypta_segment-d1a00b10_name", "crypta_segment-d1a00b10_description", "all", "", "549", "1201", "", "", "internal_ad" ],
    [ 2499980709, 2499980007, "Пользователи с привязанными к паспорту картами", "internal", "crypta_segment-d52872b5_name", "crypta_segment-d52872b5_description", "all", "", "557", "12537385", "", "", "internal_ad" ],
    [ 2499980710, 2499980007, "Пользователи с привязанными к паспорту картами", "internal", "crypta_segment-d52872b5_name", "crypta_segment-d52872b5_description", "all", "", "549", "1614", "", "", "internal_ad" ],
    [ 2499980711, 2499980007, "Любители бега", "internal", "crypta_segment-e0600a4b_name", "crypta_segment-e0600a4b_description", "all", "", "281", "311", "", "", "internal_ad" ],
    [ 2499980712, 2499980007, "Интересовались доставкой продуктов", "internal", "crypta_segment-eb8169d0_name", "crypta_segment-eb8169d0_description", "all", "", "549", "1625", "", "", "internal_ad" ],
    [ 2499980713, 2499980007, "Интересуются НХЛ", "internal", "crypta_segment-edc3c4e5_name", "crypta_segment-edc3c4e5_description", "all", "", "557", "11166739", "", "", "internal_ad" ],
    [ 2499980714, 2499980007, "Авторы постов в Дзене", "internal", "crypta_segment-zen-publishers_name", "crypta_segment-zen-publishers_description", "all", "", "557", "8310457", "", "", "internal_ad" ],
    [ 2499980715, 2499980009, "Велоспорт", "internal", "crypta_segment-512e7d13_name", "crypta_segment-512e7d13_description", "all", "", "601", "239", "", "", "internal_ad" ],
    [ 2499980716, 2499980009, "Велоспорт", "internal", "crypta_segment-512e7d13_name", "crypta_segment-512e7d13_description", "all", "", "602", "239", "", "", "internal_ad" ],
    [ 2499980717, 2499980009, "Баскетбол", "internal", "crypta_segment-basketball_name", "crypta_segment-basketball_description", "all", "", "601", "93", "", "", "internal_ad" ],
    [ 2499980718, 2499980009, "Баскетбол", "internal", "crypta_segment-basketball_name", "crypta_segment-basketball_description", "all", "", "602", "93", "", "", "internal_ad" ],
    [ 2499980719, 2499980009, "Баскетбол", "internal", "crypta_segment-basketball_name", "crypta_segment-basketball_description", "all", "", "557", "7105739", "", "", "internal_ad" ],
    [ 2499980720, 2499980009, "Скалолазание и альпинизм", "internal", "crypta_segment-climbing_name", "crypta_segment-climbing_description", "all", "", "557", "8910298", "", "", "internal_ad" ],
    [ 2499980721, 2499980009, "Скалолазание и альпинизм", "internal", "crypta_segment-climbing_name", "crypta_segment-climbing_description", "all", "", "602", "182", "", "", "internal_ad" ],
    [ 2499980722, 2499980009, "Скалолазание и альпинизм", "internal", "crypta_segment-climbing_name", "crypta_segment-climbing_description", "all", "", "601", "182", "", "", "internal_ad" ],
    [ 2499980723, 2499980009, "Дайвинг", "internal", "crypta_segment-diving_name", "crypta_segment-diving_description", "all", "", "602", "40", "", "", "internal_ad" ],
    [ 2499980724, 2499980009, "Дайвинг", "internal", "crypta_segment-diving_name", "crypta_segment-diving_description", "all", "", "601", "40", "", "", "internal_ad" ],
    [ 2499980725, 2499980009, "Фигурное катание", "internal", "crypta_segment-figure_skating_name", "crypta_segment-figure_skating_description", "all", "", "602", "69", "", "", "internal_ad" ],
    [ 2499980726, 2499980009, "Фигурное катание", "internal", "crypta_segment-figure_skating_name", "crypta_segment-figure_skating_description", "all", "", "601", "69", "", "", "internal_ad" ],
    [ 2499980727, 2499980009, "Фитнес", "internal", "crypta_segment-fitness_name", "crypta_segment-fitness_description", "all", "", "602", "186", "", "", "internal_ad" ],
    [ 2499980728, 2499980009, "Фитнес", "internal", "crypta_segment-fitness_name", "crypta_segment-fitness_description", "all", "", "601", "186", "", "", "internal_ad" ],
    [ 2499980729, 2499980009, "Футбол", "internal", "crypta_segment-football_name", "crypta_segment-football_description", "all", "", "557", "5994937", "", "", "internal_ad" ],
    [ 2499980730, 2499980009, "Футбол", "internal", "crypta_segment-football_name", "crypta_segment-football_description", "all", "", "601", "226", "", "", "internal_ad" ],
    [ 2499980731, 2499980009, "Футбол", "internal", "crypta_segment-football_name", "crypta_segment-football_description", "all", "", "602", "226", "", "", "internal_ad" ],
    [ 2499980732, 2499980009, "Хоккей", "internal", "crypta_segment-hockey_name", "crypta_segment-hockey_description", "all", "", "557", "11166520", "", "", "internal_ad" ],
    [ 2499980733, 2499980009, "Хоккей", "internal", "crypta_segment-hockey_name", "crypta_segment-hockey_description", "all", "", "602", "70", "", "", "internal_ad" ],
    [ 2499980734, 2499980009, "Хоккей", "internal", "crypta_segment-hockey_name", "crypta_segment-hockey_description", "all", "", "601", "70", "", "", "internal_ad" ],
    [ 2499980735, 2499980009, "Конный спорт", "internal", "crypta_segment-horseback_riding_name", "crypta_segment-horseback_riding_description", "all", "", "601", "222", "", "", "internal_ad" ],
    [ 2499980736, 2499980009, "Конный спорт", "internal", "crypta_segment-horseback_riding_name", "crypta_segment-horseback_riding_description", "all", "", "602", "222", "", "", "internal_ad" ],
    [ 2499980737, 2499980009, "Единоборства", "internal", "crypta_segment-martial_arts_name", "crypta_segment-martial_arts_description", "all", "", "602", "72", "", "", "internal_ad" ],
    [ 2499980738, 2499980009, "Единоборства", "internal", "crypta_segment-martial_arts_name", "crypta_segment-martial_arts_description", "all", "", "601", "72", "", "", "internal_ad" ],
    [ 2499980739, 2499980009, "Силовые виды спорта", "internal", "crypta_segment-power_sports_name", "crypta_segment-power_sports_description", "all", "", "601", "145", "", "", "internal_ad" ],
    [ 2499980740, 2499980009, "Силовые виды спорта", "internal", "crypta_segment-power_sports_name", "crypta_segment-power_sports_description", "all", "", "602", "145", "", "", "internal_ad" ],
    [ 2499980741, 2499980009, "Автоспорт", "internal", "crypta_segment-racing_name", "crypta_segment-racing_description", "all", "", "601", "114", "", "", "internal_ad" ],
    [ 2499980742, 2499980009, "Автоспорт", "internal", "crypta_segment-racing_name", "crypta_segment-racing_description", "all", "", "557", "10950220", "", "", "internal_ad" ],
    [ 2499980743, 2499980009, "Автоспорт", "internal", "crypta_segment-racing_name", "crypta_segment-racing_description", "all", "", "602", "114", "", "", "internal_ad" ],
    [ 2499980744, 2499980009, "Роликовые коньки", "internal", "crypta_segment-roller_skates_name", "crypta_segment-roller_skates_description", "all", "", "602", "291", "", "", "internal_ad" ],
    [ 2499980745, 2499980009, "Роликовые коньки", "internal", "crypta_segment-roller_skates_name", "crypta_segment-roller_skates_description", "all", "", "601", "291", "", "", "internal_ad" ],
    [ 2499980746, 2499980009, "Стрельба", "internal", "crypta_segment-shooting_name", "crypta_segment-shooting_description", "all", "", "602", "101", "", "", "internal_ad" ],
    [ 2499980747, 2499980009, "Стрельба", "internal", "crypta_segment-shooting_name", "crypta_segment-shooting_description", "all", "", "601", "101", "", "", "internal_ad" ],
    [ 2499980748, 2499980009, "Скейтбординг", "internal", "crypta_segment-skateboarding_name", "crypta_segment-skateboarding_description", "all", "", "601", "290", "", "", "internal_ad" ],
    [ 2499980749, 2499980009, "Скейтбординг", "internal", "crypta_segment-skateboarding_name", "crypta_segment-skateboarding_description", "all", "", "602", "290", "", "", "internal_ad" ],
    [ 2499980750, 2499980009, "Лыжный спорт", "internal", "crypta_segment-skiing_name", "crypta_segment-skiing_description", "all", "", "601", "45", "", "", "internal_ad" ],
    [ 2499980751, 2499980009, "Лыжный спорт", "internal", "crypta_segment-skiing_name", "crypta_segment-skiing_description", "all", "", "602", "45", "", "", "internal_ad" ],
    [ 2499980752, 2499980009, "Сноубординг", "internal", "crypta_segment-snowboarding_name", "crypta_segment-snowboarding_description", "all", "", "602", "289", "", "", "internal_ad" ],
    [ 2499980753, 2499980009, "Сноубординг", "internal", "crypta_segment-snowboarding_name", "crypta_segment-snowboarding_description", "all", "", "601", "289", "", "", "internal_ad" ],
    [ 2499980754, 2499980009, "Спортивное питание", "internal", "crypta_segment-sports_nutrition_name", "crypta_segment-sports_nutrition_description", "all", "", "602", "316", "", "", "internal_ad" ],
    [ 2499980755, 2499980009, "Спортивное питание", "internal", "crypta_segment-sports_nutrition_name", "crypta_segment-sports_nutrition_description", "all", "", "601", "316", "", "", "internal_ad" ],
    [ 2499980756, 2499980009, "Плавание", "internal", "crypta_segment-swimming_name", "crypta_segment-swimming_description", "all", "", "602", "62", "", "", "internal_ad" ],
    [ 2499980757, 2499980009, "Плавание", "internal", "crypta_segment-swimming_name", "crypta_segment-swimming_description", "all", "", "601", "62", "", "", "internal_ad" ],
    [ 2499980758, 2499980009, "Настольный теннис", "internal", "crypta_segment-table_tennis_name", "crypta_segment-table_tennis_description", "all", "", "602", "60", "", "", "internal_ad" ],
    [ 2499980759, 2499980009, "Настольный теннис", "internal", "crypta_segment-table_tennis_name", "crypta_segment-table_tennis_description", "all", "", "601", "60", "", "", "internal_ad" ],
    [ 2499980760, 2499980009, "Большой теннис", "internal", "crypta_segment-tennis_name", "crypta_segment-tennis_description", "all", "", "602", "29", "", "", "internal_ad" ],
    [ 2499980761, 2499980009, "Большой теннис", "internal", "crypta_segment-tennis_name", "crypta_segment-tennis_description", "all", "", "557", "13027698", "", "", "internal_ad" ],
    [ 2499980762, 2499980009, "Большой теннис", "internal", "crypta_segment-tennis_name", "crypta_segment-tennis_description", "all", "", "601", "29", "", "", "internal_ad" ],
    [ 2499980763, 2499980009, "Волейбол", "internal", "crypta_segment-volleyball_name", "crypta_segment-volleyball_description", "all", "", "601", "227", "", "", "internal_ad" ],
    [ 2499980764, 2499980009, "Волейбол", "internal", "crypta_segment-volleyball_name", "crypta_segment-volleyball_description", "all", "", "602", "227", "", "", "internal_ad" ],
    [ 2499980765, 2499980009, "Парусный спорт", "internal", "crypta_segment-yachting_name", "crypta_segment-yachting_description", "all", "", "602", "90", "", "", "internal_ad" ],
    [ 2499980766, 2499980009, "Парусный спорт", "internal", "crypta_segment-yachting_name", "crypta_segment-yachting_description", "all", "", "601", "90", "", "", "internal_ad" ],
    [ 2499980767, 2499980010, "Подарки", "internal", "crypta_segment-b125551a_name", "crypta_segment-b125551a_description", "all", "", "601", "243", "", "", "internal_ad" ],
    [ 2499980768, 2499980010, "Подарки", "internal", "crypta_segment-b125551a_name", "crypta_segment-b125551a_description", "all", "", "602", "243", "", "", "internal_ad" ],
    [ 2499980769, 2499980010, "Цветы", "internal", "crypta_segment-d13081c1_name", "crypta_segment-d13081c1_description", "all", "", "602", "242", "", "", "internal_ad" ],
    [ 2499980770, 2499980010, "Цветы", "internal", "crypta_segment-d13081c1_name", "crypta_segment-d13081c1_description", "all", "", "601", "242", "", "", "internal_ad" ],
    [ 2499980771, 2499980011, "Дополнительное образование и курсы", "internal", "crypta_segment-additional_education_name", "crypta_segment-additional_education_description", "all", "", "602", "167", "", "", "internal_ad" ],
    [ 2499980772, 2499980011, "Дополнительное образование и курсы", "internal", "crypta_segment-additional_education_name", "crypta_segment-additional_education_description", "all", "", "601", "167", "", "", "internal_ad" ],
    [ 2499980773, 2499980011, "Вуз", "internal", "crypta_segment-higher_education_name", "crypta_segment-higher_education_description", "all", "", "602", "3", "", "", "internal_ad" ],
    [ 2499980774, 2499980011, "Вуз", "internal", "crypta_segment-higher_education_name", "crypta_segment-higher_education_description", "all", "", "601", "3", "", "", "internal_ad" ],
    [ 2499980775, 2499980011, "Школа", "internal", "crypta_segment-school_name", "crypta_segment-school_description", "all", "", "602", "2", "", "", "internal_ad" ],
    [ 2499980776, 2499980011, "Школа", "internal", "crypta_segment-school_name", "crypta_segment-school_description", "all", "", "601", "2", "", "", "internal_ad" ],
    [ 2499980777, 2499980011, "Обучение за рубежом", "internal", "crypta_segment-study_abroad_name", "crypta_segment-study_abroad_description", "all", "", "602", "164", "", "", "internal_ad" ],
    [ 2499980778, 2499980011, "Обучение за рубежом", "internal", "crypta_segment-study_abroad_name", "crypta_segment-study_abroad_description", "all", "", "601", "164", "", "", "internal_ad" ],
    [ 2499980779, 2499980012, "Поиск работы", "internal", "crypta_segment-job_search_name", "crypta_segment-job_search_description", "all", "", "557", "5994892", "", "", "internal_ad" ],
    [ 2499980780, 2499980012, "Поиск работы", "internal", "crypta_segment-job_search_name", "crypta_segment-job_search_description", "all", "", "601", "87", "", "", "internal_ad" ],
    [ 2499980781, 2499980012, "Поиск работы", "internal", "crypta_segment-job_search_name", "crypta_segment-job_search_description", "all", "", "602", "87", "", "", "internal_ad" ],
    [ 2499980782, 2499980012, "Работа за рубежом", "internal", "crypta_segment-work_abroad_name", "crypta_segment-work_abroad_description", "all", "", "601", "117", "", "", "internal_ad" ],
    [ 2499980783, 2499980012, "Работа за рубежом", "internal", "crypta_segment-work_abroad_name", "crypta_segment-work_abroad_description", "all", "", "602", "117", "", "", "internal_ad" ],
    [ 2499980784, 2499980012, "Работа на дому", "internal", "crypta_segment-work_at_home_name", "crypta_segment-work_at_home_description", "all", "", "601", "92", "", "", "internal_ad" ],
    [ 2499980785, 2499980012, "Работа на дому", "internal", "crypta_segment-work_at_home_name", "crypta_segment-work_at_home_description", "all", "", "557", "5994898", "", "", "internal_ad" ],
    [ 2499980786, 2499980012, "Работа на дому", "internal", "crypta_segment-work_at_home_name", "crypta_segment-work_at_home_description", "all", "", "602", "92", "", "", "internal_ad" ],
    [ 2499980787, 2499980013, "Уход за телом", "internal", "crypta_segment-body_care_name", "crypta_segment-body_care_description", "all", "", "601", "30", "", "", "internal_ad" ],
    [ 2499980788, 2499980013, "Уход за телом", "internal", "crypta_segment-body_care_name", "crypta_segment-body_care_description", "all", "", "602", "30", "", "", "internal_ad" ],
    [ 2499980789, 2499980013, "Декоративная косметика", "internal", "crypta_segment-cosmetics_name", "crypta_segment-cosmetics_description", "all", "", "557", "11706451", "", "", "internal_ad" ],
    [ 2499980790, 2499980013, "Декоративная косметика", "internal", "crypta_segment-cosmetics_name", "crypta_segment-cosmetics_description", "all", "", "602", "19", "", "", "internal_ad" ],
    [ 2499980791, 2499980013, "Декоративная косметика", "internal", "crypta_segment-cosmetics_name", "crypta_segment-cosmetics_description", "all", "", "601", "19", "", "", "internal_ad" ],
    [ 2499980792, 2499980013, "Уход за лицом", "internal", "crypta_segment-face_care_name", "crypta_segment-face_care_description", "all", "", "602", "81", "", "", "internal_ad" ],
    [ 2499980793, 2499980013, "Уход за лицом", "internal", "crypta_segment-face_care_name", "crypta_segment-face_care_description", "all", "", "601", "81", "", "", "internal_ad" ],
    [ 2499980794, 2499980013, "Уход за волосами", "internal", "crypta_segment-hair_care_name", "crypta_segment-hair_care_description", "all", "", "601", "54", "", "", "internal_ad" ],
    [ 2499980795, 2499980013, "Уход за волосами", "internal", "crypta_segment-hair_care_name", "crypta_segment-hair_care_description", "all", "", "602", "54", "", "", "internal_ad" ],
    [ 2499980796, 2499980013, "Здоровое питание", "internal", "crypta_segment-healthy_eating_name", "crypta_segment-healthy_eating_description", "all", "", "602", "315", "", "", "internal_ad" ],
    [ 2499980797, 2499980013, "Здоровое питание", "internal", "crypta_segment-healthy_eating_name", "crypta_segment-healthy_eating_description", "all", "", "601", "315", "", "", "internal_ad" ],
    [ 2499980798, 2499980013, "Медицинские товары", "internal", "crypta_segment-medical_goods_name", "crypta_segment-medical_goods_description", "all", "", "602", "208", "", "", "internal_ad" ],
    [ 2499980799, 2499980013, "Медицинские товары", "internal", "crypta_segment-medical_goods_name", "crypta_segment-medical_goods_description", "all", "", "601", "208", "", "", "internal_ad" ],
    [ 2499980800, 2499980013, "Парфюмерия", "internal", "crypta_segment-perfumery_name", "crypta_segment-perfumery_description", "all", "", "602", "51", "", "", "internal_ad" ],
    [ 2499980801, 2499980013, "Парфюмерия", "internal", "crypta_segment-perfumery_name", "crypta_segment-perfumery_description", "all", "", "601", "51", "", "", "internal_ad" ],
    [ 2499980802, 2499980014, "Аксессуары", "internal", "crypta_segment-accessories_name", "crypta_segment-accessories_description", "all", "", "602", "194", "", "", "internal_ad" ],
    [ 2499980803, 2499980014, "Аксессуары", "internal", "crypta_segment-accessories_name", "crypta_segment-accessories_description", "all", "", "601", "194", "", "", "internal_ad" ],
    [ 2499980804, 2499980014, "Одежда", "internal", "crypta_segment-clothing_name", "crypta_segment-clothing_description", "all", "", "602", "197", "", "", "internal_ad" ],
    [ 2499980805, 2499980014, "Одежда", "internal", "crypta_segment-clothing_name", "crypta_segment-clothing_description", "all", "", "601", "197", "", "", "internal_ad" ],
    [ 2499980806, 2499980014, "Обувь", "internal", "crypta_segment-shoes_name", "crypta_segment-shoes_description", "all", "", "602", "154", "", "", "internal_ad" ],
    [ 2499980807, 2499980014, "Обувь", "internal", "crypta_segment-shoes_name", "crypta_segment-shoes_description", "all", "", "601", "154", "", "", "internal_ad" ],
    [ 2499980808, 2499980015, "Бухгалтерские услуги", "internal", "crypta_segment-accounting_services_name", "crypta_segment-accounting_services_description", "all", "", "602", "17", "", "", "internal_ad" ],
    [ 2499980809, 2499980015, "Бухгалтерские услуги", "internal", "crypta_segment-accounting_services_name", "crypta_segment-accounting_services_description", "all", "", "601", "17", "", "", "internal_ad" ],
    [ 2499980810, 2499980015, "Реклама", "internal", "crypta_segment-advertising_name", "crypta_segment-advertising_description", "all", "", "601", "24", "", "", "internal_ad" ],
    [ 2499980811, 2499980015, "Реклама", "internal", "crypta_segment-advertising_name", "crypta_segment-advertising_description", "all", "", "602", "24", "", "", "internal_ad" ],
    [ 2499980812, 2499980015, "Реклама", "internal", "crypta_segment-advertising_name", "crypta_segment-advertising_description", "all", "", "557", "5994874", "", "", "internal_ad" ],
    [ 2499980813, 2499980015, "Создание и продвижение сайтов", "internal", "crypta_segment-creation_and_promotion_of_sites_name", "crypta_segment-creation_and_promotion_of_sites_description", "all", "", "557", "5994931", "", "", "internal_ad" ],
    [ 2499980814, 2499980015, "Создание и продвижение сайтов", "internal", "crypta_segment-creation_and_promotion_of_sites_name", "crypta_segment-creation_and_promotion_of_sites_description", "all", "", "602", "225", "", "", "internal_ad" ],
    [ 2499980815, 2499980015, "Создание и продвижение сайтов", "internal", "crypta_segment-creation_and_promotion_of_sites_name", "crypta_segment-creation_and_promotion_of_sites_description", "all", "", "601", "225", "", "", "internal_ad" ],
    [ 2499980816, 2499980015, "Франчайзинг", "internal", "crypta_segment-franchising_name", "crypta_segment-franchising_description", "all", "", "601", "306", "", "", "internal_ad" ],
    [ 2499980817, 2499980015, "Франчайзинг", "internal", "crypta_segment-franchising_name", "crypta_segment-franchising_description", "all", "", "602", "306", "", "", "internal_ad" ],
    [ 2499980818, 2499980015, "Юридическая поддержка", "internal", "crypta_segment-legal_support_name", "crypta_segment-legal_support_description", "all", "", "601", "130", "", "", "internal_ad" ],
    [ 2499980819, 2499980015, "Юридическая поддержка", "internal", "crypta_segment-legal_support_name", "crypta_segment-legal_support_description", "all", "", "602", "130", "", "", "internal_ad" ],
    [ 2499980820, 2499980015, "Открытие бизнеса", "internal", "crypta_segment-opening_a_business_name", "crypta_segment-opening_a_business_description", "all", "", "602", "314", "", "", "internal_ad" ],
    [ 2499980821, 2499980015, "Открытие бизнеса", "internal", "crypta_segment-opening_a_business_name", "crypta_segment-opening_a_business_description", "all", "", "557", "12150853", "", "", "internal_ad" ],
    [ 2499980822, 2499980015, "Открытие бизнеса", "internal", "crypta_segment-opening_a_business_name", "crypta_segment-opening_a_business_description", "all", "", "601", "314", "", "", "internal_ad" ],
    [ 2499980823, 2499980015, "Грузоперевозки и транспортные услуги", "internal", "crypta_segment-transport_services_name", "crypta_segment-transport_services_description", "all", "", "601", "205", "", "", "internal_ad" ],
    [ 2499980824, 2499980015, "Грузоперевозки и транспортные услуги", "internal", "crypta_segment-transport_services_name", "crypta_segment-transport_services_description", "all", "", "602", "205", "", "", "internal_ad" ],
    [ 2499980825, 2499980015, "Грузоперевозки и транспортные услуги", "internal", "crypta_segment-transport_services_name", "crypta_segment-transport_services_description", "all", "", "557", "8767828", "", "", "internal_ad" ],
    [ 2499980826, 2499980016, "Оборудование для очистки воды", "internal", "crypta_segment-6280bd9c_name", "crypta_segment-6280bd9c_description", "all", "", "601", "269", "", "", "internal_ad" ],
    [ 2499980827, 2499980016, "Оборудование для очистки воды", "internal", "crypta_segment-6280bd9c_name", "crypta_segment-6280bd9c_description", "all", "", "602", "269", "", "", "internal_ad" ],
    [ 2499980828, 2499980016, "Товары для дома", "internal", "crypta_segment-9428314a_name", "crypta_segment-9428314a_description", "all", "", "557", "11287759", "", "", "internal_ad" ],
    [ 2499980829, 2499980016, "Товары для дома", "internal", "crypta_segment-9428314a_name", "crypta_segment-9428314a_description", "all", "", "601", "244", "", "", "internal_ad" ],
    [ 2499980830, 2499980016, "Товары для дома", "internal", "crypta_segment-9428314a_name", "crypta_segment-9428314a_description", "all", "", "602", "244", "", "", "internal_ad" ],
    [ 2499980831, 2499980016, "Мебель", "internal", "crypta_segment-furniture_name", "crypta_segment-furniture_description", "all", "", "557", "11287735", "", "", "internal_ad" ],
    [ 2499980832, 2499980016, "Мебель", "internal", "crypta_segment-furniture_name", "crypta_segment-furniture_description", "all", "", "601", "61", "", "", "internal_ad" ],
    [ 2499980833, 2499980016, "Мебель", "internal", "crypta_segment-furniture_name", "crypta_segment-furniture_description", "all", "", "602", "61", "", "", "internal_ad" ],
    [ 2499980834, 2499980016, "Дизайн интерьера", "internal", "crypta_segment-interior_design_name", "crypta_segment-interior_design_description", "all", "", "557", "12150907", "", "", "internal_ad" ],
    [ 2499980835, 2499980016, "Дизайн интерьера", "internal", "crypta_segment-interior_design_name", "crypta_segment-interior_design_description", "all", "", "602", "23", "", "", "internal_ad" ],
    [ 2499980836, 2499980016, "Дизайн интерьера", "internal", "crypta_segment-interior_design_name", "crypta_segment-interior_design_description", "all", "", "601", "23", "", "", "internal_ad" ],
    [ 2499980837, 2499980016, "Ремонт", "internal", "crypta_segment-repairs_name", "crypta_segment-repairs_description", "all", "", "602", "84", "", "", "internal_ad" ],
    [ 2499980838, 2499980016, "Ремонт", "internal", "crypta_segment-repairs_name", "crypta_segment-repairs_description", "all", "", "557", "5232373", "", "", "internal_ad" ],
    [ 2499980839, 2499980016, "Ремонт", "internal", "crypta_segment-repairs_name", "crypta_segment-repairs_description", "all", "", "601", "84", "", "", "internal_ad" ],
    [ 2499980840, 2499980016, "Системы охраны и сигнализации", "internal", "crypta_segment-security_systems_name", "crypta_segment-security_systems_description", "all", "", "602", "56", "", "", "internal_ad" ],
    [ 2499980841, 2499980016, "Системы охраны и сигнализации", "internal", "crypta_segment-security_systems_name", "crypta_segment-security_systems_description", "all", "", "601", "56", "", "", "internal_ad" ],
    [ 2499980842, 2499980016, "Системы «Умный дом»", "internal", "crypta_segment-smart_home_name", "crypta_segment-smart_home_description", "all", "", "601", "71", "", "", "internal_ad" ],
    [ 2499980843, 2499980016, "Системы «Умный дом»", "internal", "crypta_segment-smart_home_name", "crypta_segment-smart_home_description", "all", "", "557", "7757131", "", "", "internal_ad" ],
    [ 2499980844, 2499980016, "Системы «Умный дом»", "internal", "crypta_segment-smart_home_name", "crypta_segment-smart_home_description", "all", "", "602", "71", "", "", "internal_ad" ],
    [ 2499980845, 2499980016, "Дача и сад", "internal", "crypta_segment-summer_house_garden_name", "crypta_segment-summer_house_garden_description", "all", "", "557", "5232325", "", "", "internal_ad" ],
    [ 2499980846, 2499980016, "Дача и сад", "internal", "crypta_segment-summer_house_garden_name", "crypta_segment-summer_house_garden_description", "all", "", "601", "58", "", "", "internal_ad" ],
    [ 2499980847, 2499980016, "Дача и сад", "internal", "crypta_segment-summer_house_garden_name", "crypta_segment-summer_house_garden_description", "all", "", "602", "58", "", "", "internal_ad" ],
    [ 2499980848, 2499980017, "Авто", "internal", "crypta_segment-auto_name", "crypta_segment-auto_description", "all", "", "602", "78", "", "", "internal_ad" ],
    [ 2499980849, 2499980017, "Авто", "internal", "crypta_segment-auto_name", "crypta_segment-auto_description", "all", "", "557", "5232352", "", "", "internal_ad" ],
    [ 2499980850, 2499980017, "Авто", "internal", "crypta_segment-auto_name", "crypta_segment-auto_description", "all", "", "601", "78", "", "", "internal_ad" ],
    [ 2499980851, 2499980017, "Мото", "internal", "crypta_segment-moto_name", "crypta_segment-moto_description", "all", "", "602", "224", "", "", "internal_ad" ],
    [ 2499980852, 2499980017, "Мото", "internal", "crypta_segment-moto_name", "crypta_segment-moto_description", "all", "", "601", "224", "", "", "internal_ad" ],
    [ 2499980853, 2499980018, "Аудио- и видеотехника", "internal", "crypta_segment-audio_and_video_equipment_name", "crypta_segment-audio_and_video_equipment_description", "all", "", "601", "187", "", "", "internal_ad" ],
    [ 2499980854, 2499980018, "Аудио- и видеотехника", "internal", "crypta_segment-audio_and_video_equipment_name", "crypta_segment-audio_and_video_equipment_description", "all", "", "557", "11197006", "", "", "internal_ad" ],
    [ 2499980855, 2499980018, "Аудио- и видеотехника", "internal", "crypta_segment-audio_and_video_equipment_name", "crypta_segment-audio_and_video_equipment_description", "all", "", "602", "187", "", "", "internal_ad" ],
    [ 2499980856, 2499980018, "Фото- и видеокамеры", "internal", "crypta_segment-cameras_name", "crypta_segment-cameras_description", "all", "", "602", "119", "", "", "internal_ad" ],
    [ 2499980857, 2499980018, "Фото- и видеокамеры", "internal", "crypta_segment-cameras_name", "crypta_segment-cameras_description", "all", "", "601", "119", "", "", "internal_ad" ],
    [ 2499980858, 2499980018, "Фото- и видеокамеры", "internal", "crypta_segment-cameras_name", "crypta_segment-cameras_description", "all", "", "557", "5232412", "", "", "internal_ad" ],
    [ 2499980859, 2499980018, "Мобильные телефоны и смартфоны", "internal", "crypta_segment-cell_phones_name", "crypta_segment-cell_phones_description", "all", "", "601", "146", "", "", "internal_ad" ],
    [ 2499980860, 2499980018, "Мобильные телефоны и смартфоны", "internal", "crypta_segment-cell_phones_name", "crypta_segment-cell_phones_description", "all", "", "557", "10964773", "", "", "internal_ad" ],
    [ 2499980861, 2499980018, "Мобильные телефоны и смартфоны", "internal", "crypta_segment-cell_phones_name", "crypta_segment-cell_phones_description", "all", "", "602", "146", "", "", "internal_ad" ],
    [ 2499980862, 2499980018, "Компьютерная техника", "internal", "crypta_segment-computers_name", "crypta_segment-computers_description", "all", "", "602", "12", "", "", "internal_ad" ],
    [ 2499980863, 2499980018, "Компьютерная техника", "internal", "crypta_segment-computers_name", "crypta_segment-computers_description", "all", "", "601", "12", "", "", "internal_ad" ],
    [ 2499980864, 2499980018, "Игровые приставки", "internal", "crypta_segment-gaming_consoles_name", "crypta_segment-gaming_consoles_description", "all", "", "601", "83", "", "", "internal_ad" ],
    [ 2499980865, 2499980018, "Игровые приставки", "internal", "crypta_segment-gaming_consoles_name", "crypta_segment-gaming_consoles_description", "all", "", "602", "83", "", "", "internal_ad" ],
    [ 2499980866, 2499980018, "Клавиатуры и манипуляторы", "internal", "crypta_segment-manipulators_and_keyboards_name", "crypta_segment-manipulators_and_keyboards_description", "all", "", "602", "214", "", "", "internal_ad" ],
    [ 2499980867, 2499980018, "Клавиатуры и манипуляторы", "internal", "crypta_segment-manipulators_and_keyboards_name", "crypta_segment-manipulators_and_keyboards_description", "all", "", "601", "214", "", "", "internal_ad" ],
    [ 2499980868, 2499980018, "Принтеры и МФУ", "internal", "crypta_segment-printers_name", "crypta_segment-printers_description", "all", "", "602", "88", "", "", "internal_ad" ],
    [ 2499980869, 2499980018, "Принтеры и МФУ", "internal", "crypta_segment-printers_name", "crypta_segment-printers_description", "all", "", "601", "88", "", "", "internal_ad" ],
    [ 2499980870, 2499980018, "Умные часы и браслеты", "internal", "crypta_segment-smart_watches_and_bracelets_name", "crypta_segment-smart_watches_and_bracelets_description", "all", "", "557", "8782747", "", "", "internal_ad" ],
    [ 2499980871, 2499980018, "Умные часы и браслеты", "internal", "crypta_segment-smart_watches_and_bracelets_name", "crypta_segment-smart_watches_and_bracelets_description", "all", "", "602", "21", "", "", "internal_ad" ],
    [ 2499980872, 2499980018, "Умные часы и браслеты", "internal", "crypta_segment-smart_watches_and_bracelets_name", "crypta_segment-smart_watches_and_bracelets_description", "all", "", "601", "21", "", "", "internal_ad" ],
    [ 2499980873, 2499980019, "Техника для красоты и здоровья", "internal", "crypta_segment-appliances_for_personal_care_name", "crypta_segment-appliances_for_personal_care_description", "all", "", "602", "79", "", "", "internal_ad" ],
    [ 2499980874, 2499980019, "Техника для красоты и здоровья", "internal", "crypta_segment-appliances_for_personal_care_name", "crypta_segment-appliances_for_personal_care_description", "all", "", "601", "79", "", "", "internal_ad" ],
    [ 2499980875, 2499980019, "Техника для дома", "internal", "crypta_segment-household_appliances_name", "crypta_segment-household_appliances_description", "all", "", "602", "193", "", "", "internal_ad" ],
    [ 2499980876, 2499980019, "Техника для дома", "internal", "crypta_segment-household_appliances_name", "crypta_segment-household_appliances_description", "all", "", "601", "193", "", "", "internal_ad" ],
    [ 2499980877, 2499980019, "Крупная техника для кухни", "internal", "crypta_segment-large_kitchen_appliances_name", "crypta_segment-large_kitchen_appliances_description", "all", "", "602", "127", "", "", "internal_ad" ],
    [ 2499980878, 2499980019, "Крупная техника для кухни", "internal", "crypta_segment-large_kitchen_appliances_name", "crypta_segment-large_kitchen_appliances_description", "all", "", "601", "127", "", "", "internal_ad" ],
    [ 2499980879, 2499980019, "Мелкая техника для кухни", "internal", "crypta_segment-small_kitchen_appliances_name", "crypta_segment-small_kitchen_appliances_description", "all", "", "601", "161", "", "", "internal_ad" ],
    [ 2499980880, 2499980019, "Мелкая техника для кухни", "internal", "crypta_segment-small_kitchen_appliances_name", "crypta_segment-small_kitchen_appliances_description", "all", "", "602", "161", "", "", "internal_ad" ],
    [ 2499980881, 2499980020, "Прокат автомобилей", "internal", "crypta_segment-car_rental_name", "crypta_segment-car_rental_description", "all", "", "601", "74", "", "", "internal_ad" ],
    [ 2499980882, 2499980020, "Прокат автомобилей", "internal", "crypta_segment-car_rental_name", "crypta_segment-car_rental_description", "all", "", "602", "74", "", "", "internal_ad" ],
    [ 2499980883, 2499980020, "Детский отдых", "internal", "crypta_segment-childrens_holidays_name", "crypta_segment-childrens_holidays_description", "all", "", "601", "113", "", "", "internal_ad" ],
    [ 2499980884, 2499980020, "Детский отдых", "internal", "crypta_segment-childrens_holidays_name", "crypta_segment-childrens_holidays_description", "all", "", "602", "113", "", "", "internal_ad" ],
    [ 2499980885, 2499980020, "Круизы", "internal", "crypta_segment-cruises_name", "crypta_segment-cruises_description", "all", "", "602", "178", "", "", "internal_ad" ],
    [ 2499980886, 2499980020, "Круизы", "internal", "crypta_segment-cruises_name", "crypta_segment-cruises_description", "all", "", "601", "178", "", "", "internal_ad" ],
    [ 2499980887, 2499980020, "Авиабилеты", "internal", "crypta_segment-flight_tickets_name", "crypta_segment-flight_tickets_description", "all", "", "602", "142", "", "", "internal_ad" ],
    [ 2499980888, 2499980020, "Авиабилеты", "internal", "crypta_segment-flight_tickets_name", "crypta_segment-flight_tickets_description", "all", "", "601", "142", "", "", "internal_ad" ],
    [ 2499980889, 2499980020, "Походы и спортивный туризм", "internal", "crypta_segment-hiking_holidays_name", "crypta_segment-hiking_holidays_description", "all", "", "601", "73", "", "", "internal_ad" ],
    [ 2499980890, 2499980020, "Походы и спортивный туризм", "internal", "crypta_segment-hiking_holidays_name", "crypta_segment-hiking_holidays_description", "all", "", "602", "73", "", "", "internal_ad" ],
    [ 2499980891, 2499980020, "Отдых в Африке", "internal", "crypta_segment-holidays_in_africa_name", "crypta_segment-holidays_in_africa_description", "all", "", "602", "144", "", "", "internal_ad" ],
    [ 2499980892, 2499980020, "Отдых в Африке", "internal", "crypta_segment-holidays_in_africa_name", "crypta_segment-holidays_in_africa_description", "all", "", "601", "144", "", "", "internal_ad" ],
    [ 2499980893, 2499980020, "Отдых в Америке", "internal", "crypta_segment-holidays_in_america_name", "crypta_segment-holidays_in_america_description", "all", "", "601", "174", "", "", "internal_ad" ],
    [ 2499980894, 2499980020, "Отдых в Америке", "internal", "crypta_segment-holidays_in_america_name", "crypta_segment-holidays_in_america_description", "all", "", "602", "174", "", "", "internal_ad" ],
    [ 2499980895, 2499980020, "Отдых в Азии", "internal", "crypta_segment-holidays_in_asia_name", "crypta_segment-holidays_in_asia_description", "all", "", "602", "151", "", "", "internal_ad" ],
    [ 2499980896, 2499980020, "Отдых в Азии", "internal", "crypta_segment-holidays_in_asia_name", "crypta_segment-holidays_in_asia_description", "all", "", "601", "151", "", "", "internal_ad" ],
    [ 2499980897, 2499980020, "Отдых в Австралии и Океании", "internal", "crypta_segment-holidays_in_australia_and_oceania_name", "crypta_segment-holidays_in_australia_and_oceania_description", "all", "", "601", "123", "", "", "internal_ad" ],
    [ 2499980898, 2499980020, "Отдых в Австралии и Океании", "internal", "crypta_segment-holidays_in_australia_and_oceania_name", "crypta_segment-holidays_in_australia_and_oceania_description", "all", "", "602", "123", "", "", "internal_ad" ],
    [ 2499980899, 2499980020, "Отдых в Европе", "internal", "crypta_segment-holidays_in_europe_name", "crypta_segment-holidays_in_europe_description", "all", "", "601", "103", "", "", "internal_ad" ],
    [ 2499980900, 2499980020, "Отдых в Европе", "internal", "crypta_segment-holidays_in_europe_name", "crypta_segment-holidays_in_europe_description", "all", "", "602", "103", "", "", "internal_ad" ],
    [ 2499980901, 2499980020, "Отдых в России и СНГ", "internal", "crypta_segment-holydays_in_russia_name", "crypta_segment-holydays_in_russia_description", "all", "", "602", "39", "", "", "internal_ad" ],
    [ 2499980902, 2499980020, "Отдых в России и СНГ", "internal", "crypta_segment-holydays_in_russia_name", "crypta_segment-holydays_in_russia_description", "all", "", "601", "39", "", "", "internal_ad" ],
    [ 2499980903, 2499980020, "Отели", "internal", "crypta_segment-hotels_name", "crypta_segment-hotels_description", "all", "", "602", "219", "", "", "internal_ad" ],
    [ 2499980904, 2499980020, "Отели", "internal", "crypta_segment-hotels_name", "crypta_segment-hotels_description", "all", "", "601", "219", "", "", "internal_ad" ],
    [ 2499980905, 2499980020, "Автовокзалы", "internal", "crypta_segment-intercity_buses_name", "crypta_segment-intercity_buses_description", "all", "", "602", "201", "", "", "internal_ad" ],
    [ 2499980906, 2499980020, "Автовокзалы", "internal", "crypta_segment-intercity_buses_name", "crypta_segment-intercity_buses_description", "all", "", "601", "201", "", "", "internal_ad" ],
    [ 2499980907, 2499980020, "Горнолыжный отдых", "internal", "crypta_segment-ski_holidays_name", "crypta_segment-ski_holidays_description", "all", "", "601", "129", "", "", "internal_ad" ],
    [ 2499980908, 2499980020, "Горнолыжный отдых", "internal", "crypta_segment-ski_holidays_name", "crypta_segment-ski_holidays_description", "all", "", "602", "129", "", "", "internal_ad" ],
    [ 2499980909, 2499980020, "Билеты на поезд", "internal", "crypta_segment-train_tickets_name", "crypta_segment-train_tickets_description", "all", "", "601", "217", "", "", "internal_ad" ],
    [ 2499980910, 2499980020, "Билеты на поезд", "internal", "crypta_segment-train_tickets_name", "crypta_segment-train_tickets_description", "all", "", "602", "217", "", "", "internal_ad" ],
    [ 2499980911, 2499980020, "Страхование путешественников", "internal", "crypta_segment-travel_insurance_name", "crypta_segment-travel_insurance_description", "all", "", "601", "135", "", "", "internal_ad" ],
    [ 2499980912, 2499980020, "Страхование путешественников", "internal", "crypta_segment-travel_insurance_name", "crypta_segment-travel_insurance_description", "all", "", "602", "135", "", "", "internal_ad" ],
    [ 2499980913, 2499980020, "Свадебный отдых", "internal", "crypta_segment-wedding_holidays_name", "crypta_segment-wedding_holidays_description", "all", "", "601", "143", "", "", "internal_ad" ],
    [ 2499980914, 2499980020, "Свадебный отдых", "internal", "crypta_segment-wedding_holidays_name", "crypta_segment-wedding_holidays_description", "all", "", "602", "143", "", "", "internal_ad" ],
    [ 2499980915, 2499980021, "Банковские вклады", "internal", "crypta_segment-bank_deposits_name", "crypta_segment-bank_deposits_description", "all", "", "601", "77", "", "", "internal_ad" ],
    [ 2499980916, 2499980021, "Банковские вклады", "internal", "crypta_segment-bank_deposits_name", "crypta_segment-bank_deposits_description", "all", "", "602", "77", "", "", "internal_ad" ],
    [ 2499980917, 2499980021, "Кредитные карты", "internal", "crypta_segment-credit_cards_name", "crypta_segment-credit_cards_description", "all", "", "602", "108", "", "", "internal_ad" ],
    [ 2499980918, 2499980021, "Кредитные карты", "internal", "crypta_segment-credit_cards_name", "crypta_segment-credit_cards_description", "all", "", "601", "108", "", "", "internal_ad" ],
    [ 2499980919, 2499980021, "Финансовые услуги для бизнеса", "internal", "crypta_segment-financial_services_for_business_name", "crypta_segment-financial_services_for_business_description", "all", "", "557", "8711332", "", "", "internal_ad" ],
    [ 2499980920, 2499980021, "Финансовые услуги для бизнеса", "internal", "crypta_segment-financial_services_for_business_name", "crypta_segment-financial_services_for_business_description", "all", "", "602", "48", "", "", "internal_ad" ],
    [ 2499980921, 2499980021, "Финансовые услуги для бизнеса", "internal", "crypta_segment-financial_services_for_business_name", "crypta_segment-financial_services_for_business_description", "all", "", "601", "48", "", "", "internal_ad" ],
    [ 2499980922, 2499980021, "Форекс", "internal", "crypta_segment-forex_name", "crypta_segment-forex_description", "all", "", "602", "82", "", "", "internal_ad" ],
    [ 2499980923, 2499980021, "Форекс", "internal", "crypta_segment-forex_name", "crypta_segment-forex_description", "all", "", "601", "82", "", "", "internal_ad" ],
    [ 2499980924, 2499980021, "Инвестиции", "internal", "crypta_segment-investments_name", "crypta_segment-investments_description", "all", "", "602", "9", "", "", "internal_ad" ],
    [ 2499980925, 2499980021, "Инвестиции", "internal", "crypta_segment-investments_name", "crypta_segment-investments_description", "all", "", "601", "9", "", "", "internal_ad" ],
    [ 2499980926, 2499980021, "Рефинансирование кредитов", "internal", "crypta_segment-loan_refinancing_name", "crypta_segment-loan_refinancing_description", "all", "", "602", "277", "", "", "internal_ad" ],
    [ 2499980927, 2499980021, "Рефинансирование кредитов", "internal", "crypta_segment-loan_refinancing_name", "crypta_segment-loan_refinancing_description", "all", "", "601", "277", "", "", "internal_ad" ],
    [ 2499980928, 2499980021, "Кредиты", "internal", "crypta_segment-loans_name", "crypta_segment-loans_description", "all", "", "602", "118", "", "", "internal_ad" ],
    [ 2499980929, 2499980021, "Кредиты", "internal", "crypta_segment-loans_name", "crypta_segment-loans_description", "all", "", "601", "118", "", "", "internal_ad" ],
    [ 2499980930, 2499980021, "Ипотека", "internal", "crypta_segment-mortgage_name", "crypta_segment-mortgage_description", "all", "", "601", "44", "", "", "internal_ad" ],
    [ 2499980931, 2499980021, "Ипотека", "internal", "crypta_segment-mortgage_name", "crypta_segment-mortgage_description", "all", "", "602", "44", "", "", "internal_ad" ],
    [ 2499980932, 2499980021, "Интернет-банкинг", "internal", "crypta_segment-online_banking_name", "crypta_segment-online_banking_description", "all", "", "602", "317", "", "", "internal_ad" ],
    [ 2499980933, 2499980021, "Интернет-банкинг", "internal", "crypta_segment-online_banking_name", "crypta_segment-online_banking_description", "all", "", "601", "317", "", "", "internal_ad" ],
    [ 2499980934, 2499980021, "Современные платежные технологии", "internal", "crypta_segment-payment_technologies_name", "crypta_segment-payment_technologies_description", "all", "", "602", "318", "", "", "internal_ad" ],
    [ 2499980935, 2499980021, "Современные платежные технологии", "internal", "crypta_segment-payment_technologies_name", "crypta_segment-payment_technologies_description", "all", "", "601", "318", "", "", "internal_ad" ],
    [ 2499980936, 2499980022, "Доступ в интернет", "internal", "crypta_segment-internet_providers_name", "crypta_segment-internet_providers_description", "all", "", "602", "209", "", "", "internal_ad" ],
    [ 2499980937, 2499980022, "Доступ в интернет", "internal", "crypta_segment-internet_providers_name", "crypta_segment-internet_providers_description", "all", "", "601", "209", "", "", "internal_ad" ],
    [ 2499980938, 2499980022, "Мобильная связь", "internal", "crypta_segment-mobiles_carriers_name", "crypta_segment-mobiles_carriers_description", "all", "", "601", "163", "", "", "internal_ad" ],
    [ 2499980939, 2499980022, "Мобильная связь", "internal", "crypta_segment-mobiles_carriers_name", "crypta_segment-mobiles_carriers_description", "all", "", "602", "163", "", "", "internal_ad" ],
    [ 2499980940, 2499980022, "Спутниковое и кабельное телевидение", "internal", "crypta_segment-satellite_and_cable_tv_name", "crypta_segment-satellite_and_cable_tv_description", "all", "", "601", "36", "", "", "internal_ad" ],
    [ 2499980941, 2499980022, "Спутниковое и кабельное телевидение", "internal", "crypta_segment-satellite_and_cable_tv_name", "crypta_segment-satellite_and_cable_tv_description", "all", "", "602", "36", "", "", "internal_ad" ],
    [ 2499980942, 2499980023, "Книги", "internal", "crypta_segment-books_name", "crypta_segment-books_description", "all", "", "602", "300", "", "", "internal_ad" ],
    [ 2499980943, 2499980023, "Книги", "internal", "crypta_segment-books_name", "crypta_segment-books_description", "all", "", "601", "300", "", "", "internal_ad" ],
    [ 2499980944, 2499980023, "Кино", "internal", "crypta_segment-cinema_name", "crypta_segment-cinema_description", "all", "", "601", "26", "", "", "internal_ad" ],
    [ 2499980945, 2499980023, "Кино", "internal", "crypta_segment-cinema_name", "crypta_segment-cinema_description", "all", "", "602", "26", "", "", "internal_ad" ],
    [ 2499980946, 2499980023, "Танцы", "internal", "crypta_segment-dancing_name", "crypta_segment-dancing_description", "all", "", "602", "47", "", "", "internal_ad" ],
    [ 2499980947, 2499980023, "Танцы", "internal", "crypta_segment-dancing_name", "crypta_segment-dancing_description", "all", "", "601", "47", "", "", "internal_ad" ],
    [ 2499980948, 2499980023, "Декор", "internal", "crypta_segment-decor_name", "crypta_segment-decor_description", "all", "", "601", "302", "", "", "internal_ad" ],
    [ 2499980949, 2499980023, "Декор", "internal", "crypta_segment-decor_name", "crypta_segment-decor_description", "all", "", "602", "302", "", "", "internal_ad" ],
    [ 2499980950, 2499980023, "Рыбалка", "internal", "crypta_segment-fishing_name", "crypta_segment-fishing_description", "all", "", "601", "298", "", "", "internal_ad" ],
    [ 2499980951, 2499980023, "Рыбалка", "internal", "crypta_segment-fishing_name", "crypta_segment-fishing_description", "all", "", "602", "298", "", "", "internal_ad" ],
    [ 2499980952, 2499980023, "Игры", "internal", "crypta_segment-games_name", "crypta_segment-games_description", "all", "", "601", "5", "", "", "internal_ad" ],
    [ 2499980953, 2499980023, "Игры", "internal", "crypta_segment-games_name", "crypta_segment-games_description", "all", "", "602", "5", "", "", "internal_ad" ],
    [ 2499980954, 2499980023, "Охота", "internal", "crypta_segment-hunting_name", "crypta_segment-hunting_description", "all", "", "601", "299", "", "", "internal_ad" ],
    [ 2499980955, 2499980023, "Охота", "internal", "crypta_segment-hunting_name", "crypta_segment-hunting_description", "all", "", "602", "299", "", "", "internal_ad" ],
    [ 2499980956, 2499980023, "Музеи", "internal", "crypta_segment-museums_name", "crypta_segment-museums_description", "all", "", "601", "15", "", "", "internal_ad" ],
    [ 2499980957, 2499980023, "Музеи", "internal", "crypta_segment-museums_name", "crypta_segment-museums_description", "all", "", "602", "15", "", "", "internal_ad" ],
    [ 2499980958, 2499980023, "Музыка", "internal", "crypta_segment-music_name", "crypta_segment-music_description", "all", "", "601", "148", "", "", "internal_ad" ],
    [ 2499980959, 2499980023, "Музыка", "internal", "crypta_segment-music_name", "crypta_segment-music_description", "all", "", "602", "148", "", "", "internal_ad" ],
    [ 2499980960, 2499980023, "Рестораны", "internal", "crypta_segment-restaurants_name", "crypta_segment-restaurants_description", "all", "", "601", "8", "", "", "internal_ad" ],
    [ 2499980961, 2499980023, "Рестораны", "internal", "crypta_segment-restaurants_name", "crypta_segment-restaurants_description", "all", "", "602", "8", "", "", "internal_ad" ],
    [ 2499980962, 2499980023, "Телевидение", "internal", "crypta_segment-television_name", "crypta_segment-television_description", "all", "", "602", "190", "", "", "internal_ad" ],
    [ 2499980963, 2499980023, "Телевидение", "internal", "crypta_segment-television_name", "crypta_segment-television_description", "all", "", "601", "190", "", "", "internal_ad" ],
    [ 2499980964, 2499980023, "Театры", "internal", "crypta_segment-theaters_name", "crypta_segment-theaters_description", "all", "", "601", "32", "", "", "internal_ad" ],
    [ 2499980965, 2499980023, "Театры", "internal", "crypta_segment-theaters_name", "crypta_segment-theaters_description", "all", "", "557", "7749658", "", "", "internal_ad" ],
    [ 2499980966, 2499980023, "Театры", "internal", "crypta_segment-theaters_name", "crypta_segment-theaters_description", "all", "", "602", "32", "", "", "internal_ad" ],
    [ 2499980967, 2499980024, "Доставка продуктов", "internal", "crypta_segment-bee4b3c3_name", "crypta_segment-bee4b3c3_description", "all", "", "602", "249", "", "", "internal_ad" ],
    [ 2499980968, 2499980024, "Доставка продуктов", "internal", "crypta_segment-bee4b3c3_name", "crypta_segment-bee4b3c3_description", "all", "", "601", "249", "", "", "internal_ad" ],
    [ 2499980969, 2499980024, "Кофе", "internal", "crypta_segment-coffee_name", "crypta_segment-coffee_description", "all", "", "602", "137", "", "", "internal_ad" ],
    [ 2499980970, 2499980024, "Кофе", "internal", "crypta_segment-coffee_name", "crypta_segment-coffee_description", "all", "", "601", "137", "", "", "internal_ad" ],
    [ 2499980971, 2499980024, "Кулинария", "internal", "crypta_segment-cooking_name", "crypta_segment-cooking_description", "all", "", "557", "11706463", "", "", "internal_ad" ],
    [ 2499980972, 2499980024, "Кулинария", "internal", "crypta_segment-cooking_name", "crypta_segment-cooking_description", "all", "", "602", "112", "", "", "internal_ad" ],
    [ 2499980973, 2499980024, "Кулинария", "internal", "crypta_segment-cooking_name", "crypta_segment-cooking_description", "all", "", "601", "112", "", "", "internal_ad" ],
    [ 2499980974, 2499980024, "Доставка готовых блюд", "internal", "crypta_segment-delivery_food_name", "crypta_segment-delivery_food_description", "all", "", "557", "12217558", "", "", "internal_ad" ],
    [ 2499980975, 2499980024, "Доставка готовых блюд", "internal", "crypta_segment-delivery_food_name", "crypta_segment-delivery_food_description", "all", "", "602", "57", "", "", "internal_ad" ],
    [ 2499980976, 2499980024, "Доставка готовых блюд", "internal", "crypta_segment-delivery_food_name", "crypta_segment-delivery_food_description", "all", "", "601", "57", "", "", "internal_ad" ],
    [ 2499980977, 2499980024, "Доставка готовых блюд", "internal", "crypta_segment-delivery_food_name", "crypta_segment-delivery_food_description", "all", "", "557", "12242692", "", "", "internal_ad" ],
    [ 2499980978, 2499980024, "Чай", "internal", "crypta_segment-tea_name", "crypta_segment-tea_description", "all", "", "601", "158", "", "", "internal_ad" ],
    [ 2499980979, 2499980024, "Чай", "internal", "crypta_segment-tea_name", "crypta_segment-tea_description", "all", "", "602", "158", "", "", "internal_ad" ],
    [ 2499980980, 2499980024, "Доставка воды", "internal", "crypta_segment-water_delivery_name", "crypta_segment-water_delivery_description", "all", "", "601", "96", "", "", "internal_ad" ],
    [ 2499980981, 2499980024, "Доставка воды", "internal", "crypta_segment-water_delivery_name", "crypta_segment-water_delivery_description", "all", "", "602", "96", "", "", "internal_ad" ],
    [ 2499980982, 2499980025, "Жилая недвижимость в новостройках", "internal", "crypta_segment-2324b3a4_name", "crypta_segment-2324b3a4_description", "all", "", "601", "270", "", "", "internal_ad" ],
    [ 2499980983, 2499980025, "Жилая недвижимость в новостройках", "internal", "crypta_segment-2324b3a4_name", "crypta_segment-2324b3a4_description", "all", "", "557", "11870821", "", "", "internal_ad" ],
    [ 2499980984, 2499980025, "Жилая недвижимость в новостройках", "internal", "crypta_segment-2324b3a4_name", "crypta_segment-2324b3a4_description", "all", "", "602", "270", "", "", "internal_ad" ],
    [ 2499980985, 2499980025, "Коммерческая недвижимость", "internal", "crypta_segment-commercial_property_name", "crypta_segment-commercial_property_description", "all", "", "602", "223", "", "", "internal_ad" ],
    [ 2499980986, 2499980025, "Коммерческая недвижимость", "internal", "crypta_segment-commercial_property_name", "crypta_segment-commercial_property_description", "all", "", "601", "223", "", "", "internal_ad" ],
    [ 2499980987, 2499980025, "Загородная недвижимость", "internal", "crypta_segment-country_estate_name", "crypta_segment-country_estate_description", "all", "", "602", "124", "", "", "internal_ad" ],
    [ 2499980988, 2499980025, "Загородная недвижимость", "internal", "crypta_segment-country_estate_name", "crypta_segment-country_estate_description", "all", "", "601", "124", "", "", "internal_ad" ],
    [ 2499980989, 2499980025, "Загородная недвижимость", "internal", "crypta_segment-country_estate_name", "crypta_segment-country_estate_description", "all", "", "557", "11870815", "", "", "internal_ad" ],
    [ 2499980990, 2499980025, "Жилая недвижимость премиум-класса", "internal", "crypta_segment-premium_property_name", "crypta_segment-premium_property_description", "all", "", "557", "8782915", "", "", "internal_ad" ],
    [ 2499980991, 2499980025, "Жилая недвижимость премиум-класса", "internal", "crypta_segment-premium_property_name", "crypta_segment-premium_property_description", "all", "", "601", "80", "", "", "internal_ad" ],
    [ 2499980992, 2499980025, "Жилая недвижимость премиум-класса", "internal", "crypta_segment-premium_property_name", "crypta_segment-premium_property_description", "all", "", "602", "80", "", "", "internal_ad" ],
    [ 2499980993, 2499980025, "Аренда недвижимости", "internal", "crypta_segment-rental_property_name", "crypta_segment-rental_property_description", "all", "", "601", "120", "", "", "internal_ad" ],
    [ 2499980994, 2499980025, "Аренда недвижимости", "internal", "crypta_segment-rental_property_name", "crypta_segment-rental_property_description", "all", "", "557", "11870827", "", "", "internal_ad" ],
    [ 2499980995, 2499980025, "Аренда недвижимости", "internal", "crypta_segment-rental_property_name", "crypta_segment-rental_property_description", "all", "", "602", "120", "", "", "internal_ad" ],
    [ 2499980996, 2499980025, "Жилая недвижимость", "internal", "crypta_segment-residential_properties_name", "crypta_segment-residential_properties_description", "all", "", "601", "35", "", "", "internal_ad" ],
    [ 2499980997, 2499980025, "Жилая недвижимость", "internal", "crypta_segment-residential_properties_name", "crypta_segment-residential_properties_description", "all", "", "602", "35", "", "", "internal_ad" ],
    [ 2499980998, 2499980025, "Жилая недвижимость", "internal", "crypta_segment-residential_properties_name", "crypta_segment-residential_properties_description", "all", "", "557", "11870809", "", "", "internal_ad" ],
    [ 2499980999, 2499980026, "Детское питание", "internal", "crypta_segment-baby_food_name", "crypta_segment-baby_food_description", "all", "", "601", "180", "", "", "internal_ad" ],
    [ 2499981000, 2499980026, "Детское питание", "internal", "crypta_segment-baby_food_name", "crypta_segment-baby_food_description", "all", "", "602", "180", "", "", "internal_ad" ],
    [ 2499981001, 2499980026, "Детское питание", "internal", "crypta_segment-baby_food_name", "crypta_segment-baby_food_description", "all", "", "557", "5232451", "", "", "internal_ad" ],
    [ 2499981002, 2499980026, "Услуги няни", "internal", "crypta_segment-babysitting_service_name", "crypta_segment-babysitting_service_description", "all", "", "602", "25", "", "", "internal_ad" ],
    [ 2499981003, 2499980026, "Услуги няни", "internal", "crypta_segment-babysitting_service_name", "crypta_segment-babysitting_service_description", "all", "", "601", "25", "", "", "internal_ad" ],
    [ 2499981004, 2499980026, "Беременность и роды", "internal", "crypta_segment-pregnancy_name", "crypta_segment-pregnancy_description", "all", "", "601", "100", "", "", "internal_ad" ],
    [ 2499981005, 2499980026, "Беременность и роды", "internal", "crypta_segment-pregnancy_name", "crypta_segment-pregnancy_description", "all", "", "602", "100", "", "", "internal_ad" ],
    [ 2499981006, 2499980026, "Товары для детей", "internal", "crypta_segment-products_for_children_name", "crypta_segment-products_for_children_description", "all", "", "602", "14", "", "", "internal_ad" ],
    [ 2499981007, 2499980026, "Товары для детей", "internal", "crypta_segment-products_for_children_name", "crypta_segment-products_for_children_description", "all", "", "557", "5232319", "", "", "internal_ad" ],
    [ 2499981008, 2499980026, "Товары для детей", "internal", "crypta_segment-products_for_children_name", "crypta_segment-products_for_children_description", "all", "", "601", "14", "", "", "internal_ad" ],
    [ 2499981009, 2499980026, "Свадьба", "internal", "crypta_segment-wedding_name", "crypta_segment-wedding_description", "all", "", "557", "12930187", "", "", "internal_ad" ],
    [ 2499981010, 2499980026, "Свадьба", "internal", "crypta_segment-wedding_name", "crypta_segment-wedding_description", "all", "", "602", "66", "", "", "internal_ad" ],
    [ 2499981011, 2499980026, "Свадьба", "internal", "crypta_segment-wedding_name", "crypta_segment-wedding_description", "all", "", "601", "66", "", "", "internal_ad" ],
    [ 2499981012, 2499980027, "Птицы", "internal", "crypta_segment-birds_name", "crypta_segment-birds_description", "all", "", "602", "107", "", "", "internal_ad" ],
    [ 2499981013, 2499980027, "Птицы", "internal", "crypta_segment-birds_name", "crypta_segment-birds_description", "all", "", "601", "107", "", "", "internal_ad" ],
    [ 2499981014, 2499980027, "Кошки", "internal", "crypta_segment-cats_name", "crypta_segment-cats_description", "all", "", "601", "162", "", "", "internal_ad" ],
    [ 2499981015, 2499980027, "Кошки", "internal", "crypta_segment-cats_name", "crypta_segment-cats_description", "all", "", "557", "11510350", "", "", "internal_ad" ],
    [ 2499981016, 2499980027, "Кошки", "internal", "crypta_segment-cats_name", "crypta_segment-cats_description", "all", "", "602", "162", "", "", "internal_ad" ],
    [ 2499981017, 2499980027, "Собаки", "internal", "crypta_segment-dogs_name", "crypta_segment-dogs_description", "all", "", "602", "170", "", "", "internal_ad" ],
    [ 2499981018, 2499980027, "Собаки", "internal", "crypta_segment-dogs_name", "crypta_segment-dogs_description", "all", "", "601", "170", "", "", "internal_ad" ],
    [ 2499981019, 2499980027, "Рыбы", "internal", "crypta_segment-fish_name", "crypta_segment-fish_description", "all", "", "602", "104", "", "", "internal_ad" ],
    [ 2499981020, 2499980027, "Рыбы", "internal", "crypta_segment-fish_name", "crypta_segment-fish_description", "all", "", "601", "104", "", "", "internal_ad" ],
    [ 2499981021, 2499980027, "Товары для животных", "internal", "crypta_segment-goods_for_pets_name", "crypta_segment-goods_for_pets_description", "all", "", "601", "179", "", "", "internal_ad" ],
    [ 2499981022, 2499980027, "Товары для животных", "internal", "crypta_segment-goods_for_pets_name", "crypta_segment-goods_for_pets_description", "all", "", "602", "179", "", "", "internal_ad" ],
    [ 2499981023, 2499980027, "Корма для животных", "internal", "crypta_segment-pet_food_name", "crypta_segment-pet_food_description", "all", "", "602", "207", "", "", "internal_ad" ],
    [ 2499981024, 2499980027, "Корма для животных", "internal", "crypta_segment-pet_food_name", "crypta_segment-pet_food_description", "all", "", "601", "207", "", "", "internal_ad" ],
    [ 2499981025, 2499980027, "Грызуны и рептилии", "internal", "crypta_segment-rodents_and_reptiles_name", "crypta_segment-rodents_and_reptiles_description", "all", "", "602", "75", "", "", "internal_ad" ],
    [ 2499981026, 2499980027, "Грызуны и рептилии", "internal", "crypta_segment-rodents_and_reptiles_name", "crypta_segment-rodents_and_reptiles_description", "all", "", "601", "75", "", "", "internal_ad" ],
    [ 2499981027, 2499980028, "Поколение Миллениум", "internal", "crypta_segment-3957661d_name", "crypta_segment-3957661d_description", "all", "", "216", "548", "", "", "internal_ad" ],
    [ 2499981028, 2499980028, "Поколение X", "internal", "crypta_segment-c58a806f_name", "crypta_segment-c58a806f_description", "all", "", "216", "547", "", "", "internal_ad" ],
    [ 2499981029, 2499980028, "Поколение беби-бумеров", "internal", "crypta_segment-f3559220_name", "crypta_segment-f3559220_description", "all", "", "216", "546", "", "", "internal_ad" ],
    [ 2499981030, 2499980031, "Интересуются системами охраны и сигнализации", "internal", "crypta_segment-6b262f61_name", "crypta_segment-6b262f61_description", "all", "", "216", "594", "", "", "internal_ad" ],
    [ 2499981031, 2499980033, "Покупатели планшетов", "internal", "crypta_segment-32e3b288_name", "crypta_segment-32e3b288_description", "all", "", "216", "533", "", "", "internal_ad" ],
    [ 2499981032, 2499980033, "Покупатели ноутбуков", "internal", "crypta_segment-355bada4_name", "crypta_segment-355bada4_description", "all", "", "216", "531", "", "", "internal_ad" ],
    [ 2499981033, 2499980033, "Покупатели холодильников", "internal", "crypta_segment-4a3e1e2d_name", "crypta_segment-4a3e1e2d_description", "all", "", "216", "530", "", "", "internal_ad" ],
    [ 2499981034, 2499980033, "Покупатели бытовой техники и электроники", "internal", "crypta_segment-4a9b9bd3_name", "crypta_segment-4a9b9bd3_description", "all", "", "216", "529", "", "", "internal_ad" ],
    [ 2499981035, 2499980033, "Покупатели смартфонов", "internal", "crypta_segment-667e4f88_name", "crypta_segment-667e4f88_description", "all", "", "216", "532", "", "", "internal_ad" ],
    [ 2499981036, 2499980033, "Покупатели телевизоров и плазменных панелей", "internal", "crypta_segment-eba742cb_name", "crypta_segment-eba742cb_description", "all", "", "216", "534", "", "", "internal_ad" ],
    [ 2499981037, 2499980033, "Покупатели телевизоров и плазменных панелей", "internal", "crypta_segment-eba742cb_name", "crypta_segment-eba742cb_description", "all", "", "557", "8783971", "", "", "internal_ad" ],
    [ 2499981038, 2499980034, "Ходят в кино", "internal", "crypta_segment-01ff8869_name", "crypta_segment-01ff8869_description", "all", "", "216", "600", "", "", "internal_ad" ],
    [ 2499981039, 2499980034, "Ходят в кино", "internal", "crypta_segment-01ff8869_name", "crypta_segment-01ff8869_description", "all", "", "557", "3231220", "", "", "internal_ad" ],
    [ 2499981040, 2499980034, "Ходят в кино часто", "internal", "crypta_segment-6e9ac82c_name", "crypta_segment-6e9ac82c_description", "all", "", "557", "11165425", "", "", "internal_ad" ],
    [ 2499981041, 2499980035, "Пассажиры городского наземного транспорта", "internal", "crypta_segment-cc484062_name", "crypta_segment-cc484062_description", "all", "", "547", "1174", "", "", "internal_ad" ],
    [ 2499981042, 2499980036, "Жертвуют на благотворительность", "internal", "crypta_segment-2c8fd96f_name", "crypta_segment-2c8fd96f_description", "all", "", "216", "585", "", "", "internal_ad" ],
    [ 2499981043, 2499980036, "Интересуются дебетовыми картами", "internal", "crypta_segment-7cd7cd7a_name", "crypta_segment-7cd7cd7a_description", "all", "", "557", "6982771", "", "", "internal_ad" ],
    [ 2499981044, 2499980036, "Делают ставки в букмекерских конторах", "internal", "crypta_segment-7dc139a2_name", "crypta_segment-7dc139a2_description", "all", "", "216", "691", "", "", "internal_ad" ],
    [ 2499981045, 2499980036, "Используют электронный кошелек", "internal", "crypta_segment-ac82c482_name", "crypta_segment-ac82c482_description", "all", "", "557", "6401896", "", "", "internal_ad" ],
    [ 2499981046, 2499980036, "Используют электронный кошелек", "internal", "crypta_segment-ac82c482_name", "crypta_segment-ac82c482_description", "all", "", "216", "606", "", "", "internal_ad" ],
    [ 2499981047, 2499980037, "Следят за боксом", "internal", "crypta_segment-23790304_name", "crypta_segment-23790304_description", "all", "", "216", "623", "", "", "internal_ad" ],
    [ 2499981048, 2499980037, "Увлекаются альпинизмом", "internal", "crypta_segment-3b3eb31c_name", "crypta_segment-3b3eb31c_description", "all", "", "557", "8910286", "", "", "internal_ad" ],
    [ 2499981049, 2499980037, "Увлекаются альпинизмом", "internal", "crypta_segment-3b3eb31c_name", "crypta_segment-3b3eb31c_description", "all", "", "216", "584", "", "", "internal_ad" ],
    [ 2499981050, 2499980037, "Следят за гонками \"Формулы-1\"", "internal", "crypta_segment-53a9c22a_name", "crypta_segment-53a9c22a_description", "all", "", "216", "624", "", "", "internal_ad" ],
    [ 2499981051, 2499980037, "Следят за хоккеем", "internal", "crypta_segment-742e306d_name", "crypta_segment-742e306d_description", "all", "", "216", "621", "", "", "internal_ad" ],
    [ 2499981052, 2499980037, "Следят за киберспортом", "internal", "crypta_segment-80629998_name", "crypta_segment-80629998_description", "all", "", "557", "11040160", "", "", "internal_ad" ],
    [ 2499981053, 2499980037, "Следят за киберспортом", "internal", "crypta_segment-80629998_name", "crypta_segment-80629998_description", "all", "", "216", "648", "", "", "internal_ad" ],
    [ 2499981054, 2499980037, "Следят за футболом", "internal", "crypta_segment-8413821c_name", "crypta_segment-8413821c_description", "all", "", "557", "5994820", "", "", "internal_ad" ],
    [ 2499981055, 2499980037, "Следят за футболом", "internal", "crypta_segment-8413821c_name", "crypta_segment-8413821c_description", "all", "", "216", "620", "", "", "internal_ad" ],
    [ 2499981056, 2499980037, "Следят за баскетболом", "internal", "crypta_segment-84ebeed4_name", "crypta_segment-84ebeed4_description", "all", "", "216", "622", "", "", "internal_ad" ],
    [ 2499981057, 2499980037, "Следят за единоборствами", "internal", "crypta_segment-b2bb9503_name", "crypta_segment-b2bb9503_description", "all", "", "216", "626", "", "", "internal_ad" ],
    [ 2499981058, 2499980037, "Следят за биатлоном", "internal", "crypta_segment-b7dee137_name", "crypta_segment-b7dee137_description", "all", "", "216", "625", "", "", "internal_ad" ],
    [ 2499981059, 2499980037, "Следят за теннисом", "internal", "crypta_segment-e3e587ca_name", "crypta_segment-e3e587ca_description", "all", "", "216", "647", "", "", "internal_ad" ],
    [ 2499981060, 2499980037, "Следят за волейболом", "internal", "crypta_segment-eb678367_name", "crypta_segment-eb678367_description", "all", "", "216", "627", "", "", "internal_ad" ],
    [ 2499981061, 2499980038, "Играют на мобильных устройствах", "internal", "crypta_segment-925852b0_name", "crypta_segment-925852b0_description", "all", "", "216", "613", "", "", "internal_ad" ],
    [ 2499981062, 2499980038, "Играют на мобильных устройствах", "internal", "crypta_segment-925852b0_name", "crypta_segment-925852b0_description", "all", "", "557", "11924677", "", "", "internal_ad" ],
    [ 2499981063, 2499980038, "Геймеры", "internal", "crypta_segment-adfc45ba_name", "crypta_segment-adfc45ba_description", "all", "", "216", "614", "", "", "internal_ad" ],
    [ 2499981064, 2499980038, "Геймеры", "internal", "crypta_segment-adfc45ba_name", "crypta_segment-adfc45ba_description", "all", "", "557", "3296818", "", "", "internal_ad" ],
    [ 2499981065, 2499980038, "Играют на приставке", "internal", "crypta_segment-d74b33ff_name", "crypta_segment-d74b33ff_description", "all", "", "216", "610", "", "", "internal_ad" ],
    [ 2499981066, 2499980038, "Играют на компьютере", "internal", "crypta_segment-d8747ac8_name", "crypta_segment-d8747ac8_description", "all", "", "216", "609", "", "", "internal_ad" ],
    [ 2499981067, 2499980039, "Фрилансеры", "internal", "crypta_segment-36cb32b6_name", "crypta_segment-36cb32b6_description", "all", "", "557", "6067882", "", "", "internal_ad" ],
    [ 2499981068, 2499980039, "Фрилансеры", "internal", "crypta_segment-36cb32b6_name", "crypta_segment-36cb32b6_description", "all", "", "216", "687", "", "", "internal_ad" ],
    [ 2499981069, 2499980039, "Представители малого и среднего бизнеса", "internal", "crypta_segment-37fa1a4b_name", "crypta_segment-37fa1a4b_description", "all", "", "557", "1785390", "", "", "internal_ad" ],
    [ 2499981070, 2499980039, "Представители малого и среднего бизнеса", "internal", "crypta_segment-37fa1a4b_name", "crypta_segment-37fa1a4b_description", "all", "", "216", "520", "", "", "internal_ad" ],
    [ 2499981071, 2499980039, "Ищут работу", "internal", "crypta_segment-538a2ae1_name", "crypta_segment-538a2ae1_description", "all", "", "216", "603", "", "", "internal_ad" ],
    [ 2499981072, 2499980039, "Ищут работу", "internal", "crypta_segment-538a2ae1_name", "crypta_segment-538a2ae1_description", "all", "", "557", "5994811", "", "", "internal_ad" ],
    [ 2499981073, 2499980039, "Интересуются обучением в школе", "internal", "crypta_segment-5b41c386_name", "crypta_segment-5b41c386_description", "all", "", "216", "637", "", "", "internal_ad" ],
    [ 2499981074, 2499980039, "Дальнобойщики", "internal", "crypta_segment-699e1c7e_name", "crypta_segment-699e1c7e_description", "all", "", "216", "686", "", "", "internal_ad" ],
    [ 2499981075, 2499980039, "Интересуются вузами", "internal", "crypta_segment-7c3d93ab_name", "crypta_segment-7c3d93ab_description", "all", "", "216", "641", "", "", "internal_ad" ],
    [ 2499981076, 2499980039, "Интересуются обучением онлайн", "internal", "crypta_segment-7e229548_name", "crypta_segment-7e229548_description", "all", "", "547", "1118", "", "", "internal_ad" ],
    [ 2499981077, 2499980039, "Интересуются обучением онлайн", "internal", "crypta_segment-7e229548_name", "crypta_segment-7e229548_description", "all", "", "557", "7942720", "", "", "internal_ad" ],
    [ 2499981078, 2499980039, "Представители малого и среднего бизнеса (по правилу)", "internal", "crypta_segment-d61e50d8_name", "crypta_segment-d61e50d8_description", "all", "", "547", "1629", "", "", "internal_ad" ],
    [ 2499981079, 2499980040, "Есть дети", "internal", "crypta_segment-132dc2d0_name", "crypta_segment-132dc2d0_description", "all", "", "217", "566", "", "", "internal_ad" ],
    [ 2499981080, 2499980040, "Планируют беременность, ждут рождение ребенка или есть дети до года", "internal", "crypta_segment-bb496b91_name", "crypta_segment-bb496b91_description", "all", "", "217", "612", "", "", "internal_ad" ],
    [ 2499981081, 2499980041, "Ищут квартиры в новостройках Москвы и МО", "internal", "crypta_segment-f71203f8_name", "crypta_segment-f71203f8_description", "all", "", "557", "7070773", "", "", "internal_ad" ],
    [ 2499981082, 2499980041, "Ищут квартиры в новостройках Москвы и МО", "internal", "crypta_segment-f71203f8_name", "crypta_segment-f71203f8_description", "all", "", "216", "537", "", "", "internal_ad" ],
    [ 2499981083, 2499980043, "Планируют купить автомобиль C-класса", "internal", "crypta_segment-2c9bc0e1_name", "crypta_segment-2c9bc0e1_description", "all", "", "216", "639", "", "", "internal_ad" ],
    [ 2499981084, 2499980043, "Планируют купить автомобиль D-класса", "internal", "crypta_segment-361c3064_name", "crypta_segment-361c3064_description", "all", "", "216", "640", "", "", "internal_ad" ],
    [ 2499981085, 2499980043, "Хотят купить автомобиль дороже 2 млн руб.", "internal", "crypta_segment-85c8ef62_name", "crypta_segment-85c8ef62_description", "all", "", "216", "611", "", "", "internal_ad" ],
    [ 2499981086, 2499980043, "Планируют купить автомобиль J-класса", "internal", "crypta_segment-b3e74599_name", "crypta_segment-b3e74599_description", "all", "", "216", "657", "", "", "internal_ad" ],
    [ 2499981087, 2499980043, "Планируют купить автомобиль B-класса", "internal", "crypta_segment-c964e548_name", "crypta_segment-c964e548_description", "all", "", "216", "658", "", "", "internal_ad" ],
    [ 2499981088, 2499980043, "Платят штрафы за нарушение ПДД онлайн", "internal", "crypta_segment-cb54679a_name", "crypta_segment-cb54679a_description", "all", "", "216", "605", "", "", "internal_ad" ],
    [ 2499981089, 2499980043, "Планируют купить автомобиль дороже 1 млн руб.", "internal", "crypta_segment-fd9313d2_name", "crypta_segment-fd9313d2_description", "all", "", "216", "563", "", "", "internal_ad" ],
    [ 2499981090, 2499980044, "Планируют поменять интернет-провайдера", "internal", "crypta_segment-43a67116_name", "crypta_segment-43a67116_description", "all", "", "216", "659", "", "", "internal_ad" ],
    [ 2499981091, 2499980044, "Пользователи планшетов", "internal", "crypta_segment-477d86be_name", "crypta_segment-477d86be_description", "all", "", "216", "561", "", "", "internal_ad" ],
    [ 2499981092, 2499980044, "Планируют купить смартфон за 15–25 тыс. руб.", "internal", "crypta_segment-4ab601eb_name", "crypta_segment-4ab601eb_description", "all", "", "216", "663", "", "", "internal_ad" ],
    [ 2499981093, 2499980044, "Пользователи «умных» устройств с сим-картами", "internal", "crypta_segment-4d862b27_name", "crypta_segment-4d862b27_description", "all", "", "216", "535", "", "", "internal_ad" ],
    [ 2499981094, 2499980044, "Пользователи мобильных устройств на Windows", "internal", "crypta_segment-561d11b6_name", "crypta_segment-561d11b6_description", "all", "", "216", "551", "", "", "internal_ad" ],
    [ 2499981095, 2499980044, "Пользователи смартфонов", "internal", "crypta_segment-7d8f088a_name", "crypta_segment-7d8f088a_description", "all", "", "216", "562", "", "", "internal_ad" ],
    [ 2499981096, 2499980044, "Планируют купить смартфон за 25–35 тыс. руб.", "internal", "crypta_segment-886566d6_name", "crypta_segment-886566d6_description", "all", "", "216", "664", "", "", "internal_ad" ],
    [ 2499981097, 2499980044, "Планируют купить смартфон от 50 тыс. руб.", "internal", "crypta_segment-978ba69b_name", "crypta_segment-978ba69b_description", "all", "", "216", "666", "", "", "internal_ad" ],
    [ 2499981098, 2499980044, "Планируют купить смартфон за 35–50 тыс. руб.", "internal", "crypta_segment-bde457c3_name", "crypta_segment-bde457c3_description", "all", "", "216", "665", "", "", "internal_ad" ],
    [ 2499981099, 2499980044, "Планируют купить смартфон до 15 тыс. руб.", "internal", "crypta_segment-c3a4c526_name", "crypta_segment-c3a4c526_description", "all", "", "216", "662", "", "", "internal_ad" ],
    [ 2499981100, 2499980044, "Планируют купить смартфон до 15 тыс. руб.", "internal", "crypta_segment-c3a4c526_name", "crypta_segment-c3a4c526_description", "all", "", "557", "6957901", "", "", "internal_ad" ],
    [ 2499981101, 2499980044, "Пользователи мобильных устройств на iOS", "internal", "crypta_segment-c7dbcf62_name", "crypta_segment-c7dbcf62_description", "all", "", "557", "8782777", "", "", "internal_ad" ],
    [ 2499981102, 2499980044, "Пользователи мобильных устройств на iOS", "internal", "crypta_segment-c7dbcf62_name", "crypta_segment-c7dbcf62_description", "all", "", "216", "550", "", "", "internal_ad" ],
    [ 2499981103, 2499980044, "Пользователи мобильных устройств", "internal", "crypta_segment-f112980b_name", "crypta_segment-f112980b_description", "all", "", "216", "560", "", "", "internal_ad" ],
    [ 2499981104, 2499980044, "Пользователи мобильных устройств на Android", "internal", "crypta_segment-f452cf6d_name", "crypta_segment-f452cf6d_description", "all", "", "216", "549", "", "", "internal_ad" ],
    [ 2499981105, 2499980044, "Выбирают или хотят сменить оператора связи", "internal", "crypta_segment-ffc68849_name", "crypta_segment-ffc68849_description", "all", "", "216", "544", "", "", "internal_ad" ],
    [ 2499981106, 2499980045, "Интересуются татуировками", "internal", "crypta_segment-0d6ad1c5_name", "crypta_segment-0d6ad1c5_description", "all", "", "216", "676", "", "", "internal_ad" ],
    [ 2499981107, 2499980045, "Интересуются политикой и обществом", "internal", "crypta_segment-21714171_name", "crypta_segment-21714171_description", "all", "", "216", "689", "", "", "internal_ad" ],
    [ 2499981108, 2499980045, "Ухаживают за собой", "internal", "crypta_segment-5a4b0142_name", "crypta_segment-5a4b0142_description", "all", "", "557", "11706511", "", "", "internal_ad" ],
    [ 2499981109, 2499980045, "Ухаживают за собой", "internal", "crypta_segment-5a4b0142_name", "crypta_segment-5a4b0142_description", "all", "", "216", "636", "", "", "internal_ad" ],
    [ 2499981110, 2499980045, "Интересуются историей", "internal", "crypta_segment-7aa80614_name", "crypta_segment-7aa80614_description", "all", "", "216", "690", "", "", "internal_ad" ],
    [ 2499981111, 2499980045, "Держат дома кошек", "internal", "crypta_segment-8dd22242_name", "crypta_segment-8dd22242_description", "all", "", "557", "4778326", "", "", "internal_ad" ],
    [ 2499981112, 2499980045, "Интересуются прическами", "internal", "crypta_segment-a2a0a9b7_name", "crypta_segment-a2a0a9b7_description", "all", "", "216", "675", "", "", "internal_ad" ],
    [ 2499981113, 2499980045, "Интересуются изучением английского языка", "internal", "crypta_segment-b49e5529_name", "crypta_segment-b49e5529_description", "all", "", "557", "2291277", "", "", "internal_ad" ],
    [ 2499981114, 2499980045, "Интересуются изучением английского языка", "internal", "crypta_segment-b49e5529_name", "crypta_segment-b49e5529_description", "all", "", "216", "661", "", "", "internal_ad" ],
    [ 2499981115, 2499980045, "Лидеры общественного мнения", "internal", "crypta_segment-bec9474c_name", "crypta_segment-bec9474c_description", "all", "", "557", "11949361", "", "", "internal_ad" ],
    [ 2499981116, 2499980045, "Лидеры общественного мнения", "internal", "crypta_segment-bec9474c_name", "crypta_segment-bec9474c_description", "all", "", "216", "709", "", "", "internal_ad" ],
    [ 2499981117, 2499980045, "Держат дома собак", "internal", "crypta_segment-d00bd473_name", "crypta_segment-d00bd473_description", "all", "", "557", "4778128", "", "", "internal_ad" ],
    [ 2499981118, 2499980045, "Дачники", "internal", "crypta_segment-dec6802b_name", "crypta_segment-dec6802b_description", "all", "", "216", "541", "", "", "internal_ad" ],
    [ 2499981119, 2499980046, "Планируют купить двух- или трехкомнатную квартиру бизнес-класса (для LevelGroup)", "internal", "crypta_segment-758255e7_name", "crypta_segment-758255e7_description", "all", "", "216", "710", "", "", "internal_ad" ],
    [ 2499981120, 2499980046, "Планируют купить двух- или трехкомнатную квартиру бизнес-класса (для LevelGroup)", "internal", "crypta_segment-758255e7_name", "crypta_segment-758255e7_description", "all", "", "557", "4009676", "", "", "internal_ad" ],
    [ 2499981121, 2499980046, "Планируют купить квартиру в новостройке (для LevelGroup)", "internal", "crypta_segment-8dde6de5_name", "crypta_segment-8dde6de5_description", "all", "", "557", "4009688", "", "", "internal_ad" ],
    [ 2499981122, 2499980046, "Планируют купить квартиру в новостройке (для LevelGroup)", "internal", "crypta_segment-8dde6de5_name", "crypta_segment-8dde6de5_description", "all", "", "216", "711", "", "", "internal_ad" ],
    [ 2499981123, 2499980046, "Планируют купить квартиру в новостройке (Переделкино Ближнее, Абсолют)", "internal", "crypta_segment-8ea6ac23_name", "crypta_segment-8ea6ac23_description", "all", "", "557", "11207416", "", "", "internal_ad" ],
    [ 2499981124, 2499980046, "Планируют купить квартиру в новостройке (AFI)", "internal", "crypta_segment-90d7d47c_name", "crypta_segment-90d7d47c_description", "all", "", "557", "6966316", "", "", "internal_ad" ],
    [ 2499981125, 2499980046, "Планируют купить квартиру в новостройке (Эталон)", "internal", "crypta_segment-ee1a70e2_name", "crypta_segment-ee1a70e2_description", "all", "", "557", "6966301", "", "", "internal_ad" ],
    [ 2499981126, 2499980047, "Планируют купить автомобиль Lexus GX", "internal", "crypta_segment-4e6c70c1_name", "crypta_segment-4e6c70c1_description", "all", "", "557", "7011040", "", "", "internal_ad" ],
    [ 2499981127, 2499980047, "Планируют купить автомобиль Lexus LX", "internal", "crypta_segment-83c46a6e_name", "crypta_segment-83c46a6e_description", "all", "", "557", "7011046", "", "", "internal_ad" ],
    [ 2499981128, 2499980047, "Планируют купить автомобиль Lexus ES", "internal", "crypta_segment-8c50019a_name", "crypta_segment-8c50019a_description", "all", "", "557", "7011031", "", "", "internal_ad" ],
    [ 2499981129, 2499980047, "Планируют купить Lexus", "internal", "crypta_segment-bb98c48d_name", "crypta_segment-bb98c48d_description", "all", "", "557", "7011034", "", "", "internal_ad" ],
    [ 2499981130, 2499980047, "Планируют купить автомобиль Lexus UX", "internal", "crypta_segment-c26e0823_name", "crypta_segment-c26e0823_description", "all", "", "557", "7528909", "", "", "internal_ad" ],
    [ 2499981131, 2499980047, "Планируют купить автомобиль Lexus NX", "internal", "crypta_segment-e21a6bd3_name", "crypta_segment-e21a6bd3_description", "all", "", "557", "6999178", "", "", "internal_ad" ],
    [ 2499981132, 2499980047, "Планируют купить автомобиль Lexus RX", "internal", "crypta_segment-ea424933_name", "crypta_segment-ea424933_description", "all", "", "557", "7011025", "", "", "internal_ad" ],
    [ 2499981133, 2499980048, "Интересуются спортивным питанием", "internal", "crypta_segment-0c04ae0b_name", "crypta_segment-0c04ae0b_description", "all", "", "557", "12211438", "", "", "internal_ad" ],
    [ 2499981134, 2499980048, "Искали iherb в поиске", "internal", "crypta_segment-2e5cbed5_name", "crypta_segment-2e5cbed5_description", "all", "", "557", "12217114", "", "", "internal_ad" ],
    [ 2499981135, 2499980048, "Искали производителей спортивного питания", "internal", "crypta_segment-a159751a_name", "crypta_segment-a159751a_description", "all", "", "557", "12211639", "", "", "internal_ad" ],
    [ 2499981136, 2499980049, "Планируют купить Mazda 3", "internal", "crypta_segment-532998c3_name", "crypta_segment-532998c3_description", "all", "", "557", "8595820", "", "", "internal_ad" ],
    [ 2499981137, 2499980049, "Планируют купить Mazda CX-9", "internal", "crypta_segment-5368ca53_name", "crypta_segment-5368ca53_description", "all", "", "557", "8343424", "", "", "internal_ad" ],
    [ 2499981138, 2499980049, "Планируют купить Mazda CX-5", "internal", "crypta_segment-b437793b_name", "crypta_segment-b437793b_description", "all", "", "557", "6677753", "", "", "internal_ad" ],
    [ 2499981139, 2499980049, "Планируют купить Mazda 6", "internal", "crypta_segment-eec32ba4_name", "crypta_segment-eec32ba4_description", "all", "", "557", "6677739", "", "", "internal_ad" ],
    [ 2499981140, 2499980050, "Интересуются покупкой Toyota LC 200", "internal", "crypta_segment-2605a418_name", "crypta_segment-2605a418_description", "all", "", "557", "6067996", "", "", "internal_ad" ],
    [ 2499981141, 2499980050, "Интересуются покупкой Toyota C-HR", "internal", "crypta_segment-26876524_name", "crypta_segment-26876524_description", "all", "", "557", "6067972", "", "", "internal_ad" ],
    [ 2499981142, 2499980050, "Интересуются покупкой Toyota RAV 4", "internal", "crypta_segment-be9e6d99_name", "crypta_segment-be9e6d99_description", "all", "", "557", "6067987", "", "", "internal_ad" ],
    [ 2499981143, 2499980051, "Wo", "internal", "crypta_segment-2d5b990b_name", "crypta_segment-2d5b990b_description", "all", "", "557", "13048774", "", "", "internal_ad" ],
    [ 2499981144, 2499980051, "Go", "internal", "crypta_segment-5cae02b3_name", "crypta_segment-5cae02b3_description", "all", "", "557", "13048759", "", "", "internal_ad" ],
    [ 2499981145, 2499980051, "BusST", "internal", "crypta_segment-67a09468_name", "crypta_segment-67a09468_description", "all", "", "557", "13048756", "", "", "internal_ad" ],
    [ 2499981146, 2499980051, "Pl", "internal", "crypta_segment-68dc342e_name", "crypta_segment-68dc342e_description", "all", "", "557", "13048765", "", "", "internal_ad" ],
    [ 2499981147, 2499980051, "BusCor", "internal", "crypta_segment-a340ca62_name", "crypta_segment-a340ca62_description", "all", "", "557", "13048750", "", "", "internal_ad" ],
    [ 2499981148, 2499980051, "WE", "internal", "crypta_segment-bcc29384_name", "crypta_segment-bcc29384_description", "all", "", "557", "13048771", "", "", "internal_ad" ],
    [ 2499981149, 2499980051, "BusPr", "internal", "crypta_segment-cbb07baa_name", "crypta_segment-cbb07baa_description", "all", "", "557", "13048753", "", "", "internal_ad" ],
    [ 2499981150, 2499980051, "BE", "internal", "crypta_segment-d1b4a672_name", "crypta_segment-d1b4a672_description", "all", "", "557", "13048747", "", "", "internal_ad" ],
    [ 2499981151, 2499980051, "St", "internal", "crypta_segment-dc8ae81d_name", "crypta_segment-dc8ae81d_description", "all", "", "557", "13048768", "", "", "internal_ad" ],
    [ 2499981152, 2499980052, "Искали ювелирные украшения", "internal", "crypta_segment-6ba61574_name", "crypta_segment-6ba61574_description", "all", "", "557", "12943858", "", "", "internal_ad" ],
    [ 2499981153, 2499980052, "Интересуются производителями ювелирных украшений", "internal", "crypta_segment-bc03382c_name", "crypta_segment-bc03382c_description", "all", "", "557", "12943855", "", "", "internal_ad" ],
    [ 2499981154, 2499980053, "Пользователи Алисы (indevice)", "internal", "crypta_segment-3db05c9a_name", "crypta_segment-3db05c9a_description", "all", "", "557", "7059511", "", "", "internal_ad" ],
    [ 2499981155, 2499980053, "Пользователи Алисы на устройствах с экранами", "internal", "crypta_segment-752540da_name", "crypta_segment-752540da_description", "all", "", "557", "11207263", "", "", "internal_ad" ],
    [ 2499981156, 2499980053, "Пользователи Алисы (cross-device)", "internal", "crypta_segment-7ee47003_name", "crypta_segment-7ee47003_description", "all", "", "549", "1231", "", "", "internal_ad" ],
    [ 2499981157, 2499980054, "Любители шутеров, танков, самолетов в категории Action", "internal", "crypta_segment-27987205_name", "crypta_segment-27987205_description", "all", "", "557", "12013381", "", "", "internal_ad" ],
    [ 2499981158, 2499980054, "Платежеспособные геймеры", "internal", "crypta_segment-307440e6_name", "crypta_segment-307440e6_description", "all", "", "557", "12150007", "", "", "internal_ad" ],
    [ 2499981159, 2499980055, "С детьми от 4 до 10 месяцев", "internal", "crypta_segment-69b6e8e4_name", "crypta_segment-69b6e8e4_description", "all", "", "557", "9606130", "", "", "internal_ad" ],
    [ 2499981160, 2499980055, "С детьми до 3 месяцев", "internal", "crypta_segment-8632dd9a_name", "crypta_segment-8632dd9a_description", "all", "", "557", "9606121", "", "", "internal_ad" ],
    [ 2499981161, 2499980056, "Non conformist princess", "internal", "crypta_segment-349a3b9a_name", "crypta_segment-349a3b9a_description", "all", "", "281", "335", "", "", "internal_ad" ],
    [ 2499981162, 2499980056, "Non conformist princess", "internal", "crypta_segment-349a3b9a_name", "crypta_segment-349a3b9a_description", "all", "", "557", "10264723", "", "", "internal_ad" ],
    [ 2499981163, 2499980056, "Social status seekers", "internal", "crypta_segment-4771b423_name", "crypta_segment-4771b423_description", "all", "", "281", "336", "", "", "internal_ad" ],
    [ 2499981164, 2499980056, "Social status seekers", "internal", "crypta_segment-4771b423_name", "crypta_segment-4771b423_description", "all", "", "557", "10264726", "", "", "internal_ad" ],
    [ 2499981165, 2499980056, "Alternative arty girl", "internal", "crypta_segment-544c9868_name", "crypta_segment-544c9868_description", "all", "", "281", "329", "", "", "internal_ad" ],
    [ 2499981166, 2499980056, "Alternative arty girl", "internal", "crypta_segment-544c9868_name", "crypta_segment-544c9868_description", "all", "", "557", "10264732", "", "", "internal_ad" ],
    [ 2499981167, 2499980056, "Holistic wellness lovers", "internal", "crypta_segment-60ac3980_name", "crypta_segment-60ac3980_description", "all", "", "281", "333", "", "", "internal_ad" ],
    [ 2499981168, 2499980056, "Holistic wellness lovers", "internal", "crypta_segment-60ac3980_name", "crypta_segment-60ac3980_description", "all", "", "557", "10264714", "", "", "internal_ad" ],
    [ 2499981169, 2499980056, "Creative rebel", "internal", "crypta_segment-699cb873_name", "crypta_segment-699cb873_description", "all", "", "281", "318", "", "", "internal_ad" ],
    [ 2499981170, 2499980056, "Creative rebel", "internal", "crypta_segment-699cb873_name", "crypta_segment-699cb873_description", "all", "", "557", "6990544", "", "", "internal_ad" ],
    [ 2499981171, 2499980056, "High energy diva", "internal", "crypta_segment-7a35688d_name", "crypta_segment-7a35688d_description", "all", "", "557", "10264720", "", "", "internal_ad" ],
    [ 2499981172, 2499980056, "High energy diva", "internal", "crypta_segment-7a35688d_name", "crypta_segment-7a35688d_description", "all", "", "281", "332", "", "", "internal_ad" ],
    [ 2499981173, 2499980056, "Cute dreamer", "internal", "crypta_segment-bbda699d_name", "crypta_segment-bbda699d_description", "all", "", "557", "10264735", "", "", "internal_ad" ],
    [ 2499981174, 2499980056, "Cute dreamer", "internal", "crypta_segment-bbda699d_name", "crypta_segment-bbda699d_description", "all", "", "281", "331", "", "", "internal_ad" ],
    [ 2499981175, 2499980056, "Success driven queen", "internal", "crypta_segment-c4100138_name", "crypta_segment-c4100138_description", "all", "", "281", "337", "", "", "internal_ad" ],
    [ 2499981176, 2499980056, "Success driven queen", "internal", "crypta_segment-c4100138_name", "crypta_segment-c4100138_description", "all", "", "557", "10264738", "", "", "internal_ad" ],
    [ 2499981177, 2499980056, "Natural health protectors", "internal", "crypta_segment-ead5a2b4_name", "crypta_segment-ead5a2b4_description", "all", "", "557", "10264717", "", "", "internal_ad" ],
    [ 2499981178, 2499980056, "Natural health protectors", "internal", "crypta_segment-ead5a2b4_name", "crypta_segment-ead5a2b4_description", "all", "", "281", "334", "", "", "internal_ad" ],
    [ 2499981179, 2499980057, "Клиенты Мегафона", "internal", "crypta_segment-1fa8d522_name", "crypta_segment-1fa8d522_description", "all", "", "216", "9", "", "", "internal_ad" ],
    [ 2499981180, 2499980057, "Клиенты МТС (по префиксу)", "internal", "crypta_segment-3e1a772e_name", "crypta_segment-3e1a772e_description", "all", "", "547", "1292", "", "", "internal_ad" ],
    [ 2499981181, 2499980057, "Клиенты Мегафона (по префиксу)", "internal", "crypta_segment-783ae965_name", "crypta_segment-783ae965_description", "all", "", "547", "1293", "", "", "internal_ad" ],
    [ 2499981182, 2499980057, "Клиенты МТС", "internal", "crypta_segment-90761209_name", "crypta_segment-90761209_description", "all", "", "557", "6696992", "", "", "internal_ad" ],
    [ 2499981183, 2499980057, "Клиенты МТС", "internal", "crypta_segment-90761209_name", "crypta_segment-90761209_description", "all", "", "216", "10", "", "", "internal_ad" ],
    [ 2499981184, 2499980057, "Клиенты Tele2", "internal", "crypta_segment-a40ce7ac_name", "crypta_segment-a40ce7ac_description", "all", "", "216", "516", "", "", "internal_ad" ],
    [ 2499981185, 2499980057, "Клиенты Tele2", "internal", "crypta_segment-a40ce7ac_name", "crypta_segment-a40ce7ac_description", "all", "", "557", "6730073", "", "", "internal_ad" ],
    [ 2499981186, 2499980057, "Клиенты Tele2 (по префиксу)", "internal", "crypta_segment-a5b4e446_name", "crypta_segment-a5b4e446_description", "all", "", "547", "1290", "", "", "internal_ad" ],
    [ 2499981187, 2499980057, "Клиенты Билайн (по префиксу)", "internal", "crypta_segment-a983cb3e_name", "crypta_segment-a983cb3e_description", "all", "", "547", "1291", "", "", "internal_ad" ],
    [ 2499981188, 2499980057, "Клиенты Билайн", "internal", "crypta_segment-ef10918f_name", "crypta_segment-ef10918f_description", "all", "", "216", "11", "", "", "internal_ad" ],
    [ 2499981189, 2499980057, "Клиенты Билайн", "internal", "crypta_segment-ef10918f_name", "crypta_segment-ef10918f_description", "all", "", "557", "7879465", "", "", "internal_ad" ],
    [ 2499981190, 2499980058, "Икали помещение или оборудование для конференций", "internal", "crypta_segment-0e222a42_name", "crypta_segment-0e222a42_description", "all", "", "557", "12026692", "", "", "internal_ad" ],
    [ 2499981191, 2499980058, "Бизнес-путешественники", "internal", "crypta_segment-c2dc5187_name", "crypta_segment-c2dc5187_description", "all", "", "557", "12676609", "", "", "internal_ad" ],
    [ 2499981192, 2499980059, "Планируют купить Lada Granta", "internal", "crypta_segment-22bee64d_name", "crypta_segment-22bee64d_description", "all", "", "557", "8453815", "", "", "internal_ad" ],
    [ 2499981193, 2499980060, "Искали Ауди на поиске, сейчас ходят по сайтам дилерских центров", "internal", "crypta_segment-3ceb4230_name", "crypta_segment-3ceb4230_description", "all", "", "557", "10926193", "", "", "internal_ad" ],
    [ 2499981194, 2499980061, "Планируют купить Volkswagen Tiguan", "internal", "crypta_segment-1e305ec2_name", "crypta_segment-1e305ec2_description", "all", "", "557", "4567348", "", "", "internal_ad" ],
    [ 2499981195, 2499980061, "Планируют купить Volkswagen Teramont", "internal", "crypta_segment-294c8090_name", "crypta_segment-294c8090_description", "all", "", "557", "4567342", "", "", "internal_ad" ],
    [ 2499981196, 2499980061, "Планируют купить Volkswagen онлайн (узкий)", "internal", "crypta_segment-499b9c42_name", "crypta_segment-499b9c42_description", "all", "", "557", "7627714", "", "", "internal_ad" ],
    [ 2499981197, 2499980061, "Планируют купить Volkswagen онлайн", "internal", "crypta_segment-59ed1b9d_name", "crypta_segment-59ed1b9d_description", "all", "", "557", "7601152", "", "", "internal_ad" ],
    [ 2499981198, 2499980061, "Планируют купить Volkswagen Jetta", "internal", "crypta_segment-64d4e814_name", "crypta_segment-64d4e814_description", "all", "", "557", "4567360", "", "", "internal_ad" ],
    [ 2499981199, 2499980061, "Планируют купить Volkswagen Touareg", "internal", "crypta_segment-9c139e16_name", "crypta_segment-9c139e16_description", "all", "", "557", "4567336", "", "", "internal_ad" ],
    [ 2499981200, 2499980061, "Планируют купить Volkswagen Passat", "internal", "crypta_segment-bb03976e_name", "crypta_segment-bb03976e_description", "all", "", "557", "4567330", "", "", "internal_ad" ],
    [ 2499981201, 2499980061, "Планируют купить Volkswagen Polo", "internal", "crypta_segment-e96c7ea6_name", "crypta_segment-e96c7ea6_description", "all", "", "557", "4567351", "", "", "internal_ad" ],
    [ 2499981202, 2499980062, "Следят за World of Warcraft", "internal", "crypta_segment-285646c6_name", "crypta_segment-285646c6_description", "all", "", "281", "257", "", "", "internal_ad" ],
    [ 2499981203, 2499980062, "Следят за World of Warcraft", "internal", "crypta_segment-285646c6_name", "crypta_segment-285646c6_description", "all", "", "557", "12444286", "", "", "internal_ad" ],
    [ 2499981204, 2499980062, "Следят за League of Legends", "internal", "crypta_segment-50a89606_name", "crypta_segment-50a89606_description", "all", "", "281", "259", "", "", "internal_ad" ],
    [ 2499981205, 2499980062, "Следят за Hearthstone", "internal", "crypta_segment-6ed1ad0a_name", "crypta_segment-6ed1ad0a_description", "all", "", "281", "261", "", "", "internal_ad" ],
    [ 2499981206, 2499980062, "Следят за Dota", "internal", "crypta_segment-9b9d2030_name", "crypta_segment-9b9d2030_description", "all", "", "281", "256", "", "", "internal_ad" ],
    [ 2499981207, 2499980062, "Следят за Fortnite", "internal", "crypta_segment-ad431375_name", "crypta_segment-ad431375_description", "all", "", "281", "263", "", "", "internal_ad" ],
    [ 2499981208, 2499980062, "Следят за Counter Strike", "internal", "crypta_segment-b5c8d4ec_name", "crypta_segment-b5c8d4ec_description", "all", "", "281", "258", "", "", "internal_ad" ],
    [ 2499981209, 2499980062, "Следят за Overwatch", "internal", "crypta_segment-ca533751_name", "crypta_segment-ca533751_description", "all", "", "281", "260", "", "", "internal_ad" ],
    [ 2499981210, 2499980062, "Следят за PlayerUnknown’s Battlegrounds", "internal", "crypta_segment-cc7ece0a_name", "crypta_segment-cc7ece0a_description", "all", "", "281", "262", "", "", "internal_ad" ],
    [ 2499981211, 2499980063, "Неактивные админы ПДД", "internal", "crypta_segment-269463c8_name", "crypta_segment-269463c8_description", "all", "", "549", "1157", "", "", "internal_ad" ],
    [ 2499981212, 2499980063, "Активные админы ПДД", "internal", "crypta_segment-77e62842_name", "crypta_segment-77e62842_description", "all", "", "557", "11384548", "", "", "internal_ad" ],
    [ 2499981213, 2499980063, "Активные админы ПДД", "internal", "crypta_segment-77e62842_name", "crypta_segment-77e62842_description", "all", "", "549", "1156", "", "", "internal_ad" ],
    [ 2499981214, 2499980063, "Видели сервисы управления проектами в поисковой выдаче", "internal", "crypta_segment-b1b2a8ca_name", "crypta_segment-b1b2a8ca_description", "all", "", "281", "292", "", "", "internal_ad" ],
    [ 2499981215, 2499980063, "Похожи на админов Трекера", "internal", "crypta_segment-c6612228_name", "crypta_segment-c6612228_description", "all", "", "281", "287", "", "", "internal_ad" ],
    [ 2499981216, 2499980064, "Любители джаза", "internal", "crypta_segment-0133ce80_name", "crypta_segment-0133ce80_description", "all", "", "557", "7856587", "", "", "internal_ad" ],
    [ 2499981217, 2499980064, "Любители джаза", "internal", "crypta_segment-0133ce80_name", "crypta_segment-0133ce80_description", "all", "", "547", "1123", "", "", "internal_ad" ],
    [ 2499981218, 2499980064, "Любители джаза", "internal", "crypta_segment-0133ce80_name", "crypta_segment-0133ce80_description", "all", "", "281", "175", "", "", "internal_ad" ],
    [ 2499981219, 2499980064, "Похожи на тех, кто слушает металл на Яндекс.Музыке", "internal", "crypta_segment-03158bc1_name", "crypta_segment-03158bc1_description", "all", "", "281", "237", "", "", "internal_ad" ],
    [ 2499981220, 2499980064, "Похожи на тех, кто слушает металл на Яндекс.Музыке", "internal", "crypta_segment-03158bc1_name", "crypta_segment-03158bc1_description", "all", "", "546", "1146", "", "", "internal_ad" ],
    [ 2499981221, 2499980064, "Любители рок-н-ролла", "internal", "crypta_segment-074123d4_name", "crypta_segment-074123d4_description", "all", "", "557", "12667015", "", "", "internal_ad" ],
    [ 2499981222, 2499980064, "Любители рок-н-ролла", "internal", "crypta_segment-074123d4_name", "crypta_segment-074123d4_description", "all", "", "547", "1624", "", "", "internal_ad" ],
    [ 2499981223, 2499980064, "Похожи на тех, кто слушает поп-музыку на Яндекс.Музыке", "internal", "crypta_segment-110d51a4_name", "crypta_segment-110d51a4_description", "all", "", "281", "235", "", "", "internal_ad" ],
    [ 2499981224, 2499980064, "Похожи на тех, кто слушает поп-музыку на Яндекс.Музыке", "internal", "crypta_segment-110d51a4_name", "crypta_segment-110d51a4_description", "all", "", "546", "1144", "", "", "internal_ad" ],
    [ 2499981225, 2499980064, "Похожи на тех, кто слушает поп-музыку на Яндекс.Музыке", "internal", "crypta_segment-110d51a4_name", "crypta_segment-110d51a4_description", "all", "", "557", "12943846", "", "", "internal_ad" ],
    [ 2499981226, 2499980064, "Похожи на тех, кто слушает танцевальную музыку на Яндекс.Музыке", "internal", "crypta_segment-1355d5bd_name", "crypta_segment-1355d5bd_description", "all", "", "546", "1145", "", "", "internal_ad" ],
    [ 2499981227, 2499980064, "Похожи на тех, кто слушает танцевальную музыку на Яндекс.Музыке", "internal", "crypta_segment-1355d5bd_name", "crypta_segment-1355d5bd_description", "all", "", "281", "236", "", "", "internal_ad" ],
    [ 2499981228, 2499980064, "Любители R&B", "internal", "crypta_segment-1cd6ab97_name", "crypta_segment-1cd6ab97_description", "all", "", "557", "7856599", "", "", "internal_ad" ],
    [ 2499981229, 2499980064, "Любители R&B", "internal", "crypta_segment-1cd6ab97_name", "crypta_segment-1cd6ab97_description", "all", "", "281", "181", "", "", "internal_ad" ],
    [ 2499981230, 2499980064, "Любители R&B", "internal", "crypta_segment-1cd6ab97_name", "crypta_segment-1cd6ab97_description", "all", "", "547", "1129", "", "", "internal_ad" ],
    [ 2499981231, 2499980064, "Похожи на тех, кто слушает музыку инди на Яндекс.Музыке", "internal", "crypta_segment-35d302c6_name", "crypta_segment-35d302c6_description", "all", "", "546", "1148", "", "", "internal_ad" ],
    [ 2499981232, 2499980064, "Похожи на тех, кто слушает музыку инди на Яндекс.Музыке", "internal", "crypta_segment-35d302c6_name", "crypta_segment-35d302c6_description", "all", "", "281", "239", "", "", "internal_ad" ],
    [ 2499981233, 2499980064, "Любители шансона", "internal", "crypta_segment-3cd57744_name", "crypta_segment-3cd57744_description", "all", "", "281", "192", "", "", "internal_ad" ],
    [ 2499981234, 2499980064, "Любители шансона", "internal", "crypta_segment-3cd57744_name", "crypta_segment-3cd57744_description", "all", "", "547", "1140", "", "", "internal_ad" ],
    [ 2499981235, 2499980064, "Любители шансона", "internal", "crypta_segment-3cd57744_name", "crypta_segment-3cd57744_description", "all", "", "557", "7856626", "", "", "internal_ad" ],
    [ 2499981236, 2499980064, "Любители регги", "internal", "crypta_segment-3de08ee6_name", "crypta_segment-3de08ee6_description", "all", "", "557", "7856617", "", "", "internal_ad" ],
    [ 2499981237, 2499980064, "Любители регги", "internal", "crypta_segment-3de08ee6_name", "crypta_segment-3de08ee6_description", "all", "", "547", "1135", "", "", "internal_ad" ],
    [ 2499981238, 2499980064, "Любители регги", "internal", "crypta_segment-3de08ee6_name", "crypta_segment-3de08ee6_description", "all", "", "281", "187", "", "", "internal_ad" ],
    [ 2499981239, 2499980064, "Любители блюза", "internal", "crypta_segment-424bdc9c_name", "crypta_segment-424bdc9c_description", "all", "", "547", "1131", "", "", "internal_ad" ],
    [ 2499981240, 2499980064, "Любители блюза", "internal", "crypta_segment-424bdc9c_name", "crypta_segment-424bdc9c_description", "all", "", "557", "7856605", "", "", "internal_ad" ],
    [ 2499981241, 2499980064, "Любители блюза", "internal", "crypta_segment-424bdc9c_name", "crypta_segment-424bdc9c_description", "all", "", "281", "183", "", "", "internal_ad" ],
    [ 2499981242, 2499980064, "Любители классической музыки", "internal", "crypta_segment-505a9d67_name", "crypta_segment-505a9d67_description", "all", "", "281", "177", "", "", "internal_ad" ],
    [ 2499981243, 2499980064, "Любители классической музыки", "internal", "crypta_segment-505a9d67_name", "crypta_segment-505a9d67_description", "all", "", "557", "7856590", "", "", "internal_ad" ],
    [ 2499981244, 2499980064, "Любители классической музыки", "internal", "crypta_segment-505a9d67_name", "crypta_segment-505a9d67_description", "all", "", "547", "1125", "", "", "internal_ad" ],
    [ 2499981245, 2499980064, "Любители танцевальной музыки", "internal", "crypta_segment-52468819_name", "crypta_segment-52468819_description", "all", "", "557", "7856596", "", "", "internal_ad" ],
    [ 2499981246, 2499980064, "Любители танцевальной музыки", "internal", "crypta_segment-52468819_name", "crypta_segment-52468819_description", "all", "", "547", "1128", "", "", "internal_ad" ],
    [ 2499981247, 2499980064, "Любители танцевальной музыки", "internal", "crypta_segment-52468819_name", "crypta_segment-52468819_description", "all", "", "281", "180", "", "", "internal_ad" ],
    [ 2499981248, 2499980064, "Любители rap музыки", "internal", "crypta_segment-5709d120_name", "crypta_segment-5709d120_description", "all", "", "557", "7856593", "", "", "internal_ad" ],
    [ 2499981249, 2499980064, "Любители rap музыки", "internal", "crypta_segment-5709d120_name", "crypta_segment-5709d120_description", "all", "", "547", "1126", "", "", "internal_ad" ],
    [ 2499981250, 2499980064, "Любители rap музыки", "internal", "crypta_segment-5709d120_name", "crypta_segment-5709d120_description", "all", "", "281", "178", "", "", "internal_ad" ],
    [ 2499981251, 2499980064, "Любители русского рэпа", "internal", "crypta_segment-5e760401_name", "crypta_segment-5e760401_description", "all", "", "557", "12666943", "", "", "internal_ad" ],
    [ 2499981252, 2499980064, "Любители русского рэпа", "internal", "crypta_segment-5e760401_name", "crypta_segment-5e760401_description", "all", "", "547", "1623", "", "", "internal_ad" ],
    [ 2499981253, 2499980064, "Любители фолк музыки", "internal", "crypta_segment-60a91d95_name", "crypta_segment-60a91d95_description", "all", "", "557", "7856584", "", "", "internal_ad" ],
    [ 2499981254, 2499980064, "Любители фолк музыки", "internal", "crypta_segment-60a91d95_name", "crypta_segment-60a91d95_description", "all", "", "281", "174", "", "", "internal_ad" ],
    [ 2499981255, 2499980064, "Любители фолк музыки", "internal", "crypta_segment-60a91d95_name", "crypta_segment-60a91d95_description", "all", "", "547", "1122", "", "", "internal_ad" ],
    [ 2499981256, 2499980064, "Любители авторской песни", "internal", "crypta_segment-6b41c246_name", "crypta_segment-6b41c246_description", "all", "", "281", "190", "", "", "internal_ad" ],
    [ 2499981257, 2499980064, "Любители авторской песни", "internal", "crypta_segment-6b41c246_name", "crypta_segment-6b41c246_description", "all", "", "557", "7856629", "", "", "internal_ad" ],
    [ 2499981258, 2499980064, "Любители авторской песни", "internal", "crypta_segment-6b41c246_name", "crypta_segment-6b41c246_description", "all", "", "547", "1138", "", "", "internal_ad" ],
    [ 2499981259, 2499980064, "Похожи на тех, кто слушает альтернативу на Яндекс.Музыке", "internal", "crypta_segment-75361cbc_name", "crypta_segment-75361cbc_description", "all", "", "546", "1143", "", "", "internal_ad" ],
    [ 2499981260, 2499980064, "Похожи на тех, кто слушает альтернативу на Яндекс.Музыке", "internal", "crypta_segment-75361cbc_name", "crypta_segment-75361cbc_description", "all", "", "281", "234", "", "", "internal_ad" ],
    [ 2499981261, 2499980064, "Любители электронной музыки", "internal", "crypta_segment-7c05d033_name", "crypta_segment-7c05d033_description", "all", "", "547", "1127", "", "", "internal_ad" ],
    [ 2499981262, 2499980064, "Любители электронной музыки", "internal", "crypta_segment-7c05d033_name", "crypta_segment-7c05d033_description", "all", "", "557", "7856581", "", "", "internal_ad" ],
    [ 2499981263, 2499980064, "Любители электронной музыки", "internal", "crypta_segment-7c05d033_name", "crypta_segment-7c05d033_description", "all", "", "281", "179", "", "", "internal_ad" ],
    [ 2499981264, 2499980064, "Любители инди музыки", "internal", "crypta_segment-98a80106_name", "crypta_segment-98a80106_description", "all", "", "281", "188", "", "", "internal_ad" ],
    [ 2499981265, 2499980064, "Любители инди музыки", "internal", "crypta_segment-98a80106_name", "crypta_segment-98a80106_description", "all", "", "547", "1136", "", "", "internal_ad" ],
    [ 2499981266, 2499980064, "Любители инди музыки", "internal", "crypta_segment-98a80106_name", "crypta_segment-98a80106_description", "all", "", "557", "7856620", "", "", "internal_ad" ],
    [ 2499981267, 2499980064, "Похожи на тех, кто слушает рок на Яндекс.Музыке", "internal", "crypta_segment-99332179_name", "crypta_segment-99332179_description", "all", "", "557", "12326680", "", "", "internal_ad" ],
    [ 2499981268, 2499980064, "Похожи на тех, кто слушает рок на Яндекс.Музыке", "internal", "crypta_segment-99332179_name", "crypta_segment-99332179_description", "all", "", "281", "233", "", "", "internal_ad" ],
    [ 2499981269, 2499980064, "Похожи на тех, кто слушает рок на Яндекс.Музыке", "internal", "crypta_segment-99332179_name", "crypta_segment-99332179_description", "all", "", "546", "1142", "", "", "internal_ad" ],
    [ 2499981270, 2499980064, "Любители эстрадной музыки", "internal", "crypta_segment-9d9e059d_name", "crypta_segment-9d9e059d_description", "all", "", "547", "1132", "", "", "internal_ad" ],
    [ 2499981271, 2499980064, "Любители эстрадной музыки", "internal", "crypta_segment-9d9e059d_name", "crypta_segment-9d9e059d_description", "all", "", "557", "7856608", "", "", "internal_ad" ],
    [ 2499981272, 2499980064, "Любители эстрадной музыки", "internal", "crypta_segment-9d9e059d_name", "crypta_segment-9d9e059d_description", "all", "", "281", "184", "", "", "internal_ad" ],
    [ 2499981273, 2499980064, "Любители поп музыки", "internal", "crypta_segment-9e0751be_name", "crypta_segment-9e0751be_description", "all", "", "557", "7720882", "", "", "internal_ad" ],
    [ 2499981274, 2499980064, "Любители поп музыки", "internal", "crypta_segment-9e0751be_name", "crypta_segment-9e0751be_description", "all", "", "281", "185", "", "", "internal_ad" ],
    [ 2499981275, 2499980064, "Любители поп музыки", "internal", "crypta_segment-9e0751be_name", "crypta_segment-9e0751be_description", "all", "", "547", "1133", "", "", "internal_ad" ],
    [ 2499981276, 2499980064, "Похожи на тех, кто слушает рэп на Яндекс.Музыке", "internal", "crypta_segment-9e82070b_name", "crypta_segment-9e82070b_description", "all", "", "546", "1141", "", "", "internal_ad" ],
    [ 2499981277, 2499980064, "Похожи на тех, кто слушает рэп на Яндекс.Музыке", "internal", "crypta_segment-9e82070b_name", "crypta_segment-9e82070b_description", "all", "", "281", "232", "", "", "internal_ad" ],
    [ 2499981278, 2499980064, "Любители метал музыки", "internal", "crypta_segment-a919ad7c_name", "crypta_segment-a919ad7c_description", "all", "", "547", "1134", "", "", "internal_ad" ],
    [ 2499981279, 2499980064, "Любители метал музыки", "internal", "crypta_segment-a919ad7c_name", "crypta_segment-a919ad7c_description", "all", "", "281", "186", "", "", "internal_ad" ],
    [ 2499981280, 2499980064, "Любители метал музыки", "internal", "crypta_segment-a919ad7c_name", "crypta_segment-a919ad7c_description", "all", "", "557", "7856611", "", "", "internal_ad" ],
    [ 2499981281, 2499980064, "Любители легкой музыки", "internal", "crypta_segment-ab8665a5_name", "crypta_segment-ab8665a5_description", "all", "", "281", "191", "", "", "internal_ad" ],
    [ 2499981282, 2499980064, "Любители легкой музыки", "internal", "crypta_segment-ab8665a5_name", "crypta_segment-ab8665a5_description", "all", "", "547", "1139", "", "", "internal_ad" ],
    [ 2499981283, 2499980064, "Любители легкой музыки", "internal", "crypta_segment-ab8665a5_name", "crypta_segment-ab8665a5_description", "all", "", "557", "7856632", "", "", "internal_ad" ],
    [ 2499981284, 2499980064, "Любители альтернативной музыки", "internal", "crypta_segment-ad7d9c1a_name", "crypta_segment-ad7d9c1a_description", "all", "", "281", "182", "", "", "internal_ad" ],
    [ 2499981285, 2499980064, "Любители альтернативной музыки", "internal", "crypta_segment-ad7d9c1a_name", "crypta_segment-ad7d9c1a_description", "all", "", "557", "7856602", "", "", "internal_ad" ],
    [ 2499981286, 2499980064, "Любители альтернативной музыки", "internal", "crypta_segment-ad7d9c1a_name", "crypta_segment-ad7d9c1a_description", "all", "", "547", "1130", "", "", "internal_ad" ],
    [ 2499981287, 2499980064, "Похожи на тех, кто слушает электронную музыку на Яндекс.Музыке", "internal", "crypta_segment-b0ca99cd_name", "crypta_segment-b0ca99cd_description", "all", "", "546", "1147", "", "", "internal_ad" ],
    [ 2499981288, 2499980064, "Похожи на тех, кто слушает электронную музыку на Яндекс.Музыке", "internal", "crypta_segment-b0ca99cd_name", "crypta_segment-b0ca99cd_description", "all", "", "557", "12943849", "", "", "internal_ad" ],
    [ 2499981289, 2499980064, "Похожи на тех, кто слушает электронную музыку на Яндекс.Музыке", "internal", "crypta_segment-b0ca99cd_name", "crypta_segment-b0ca99cd_description", "all", "", "281", "238", "", "", "internal_ad" ],
    [ 2499981290, 2499980064, "Любители панк музыки", "internal", "crypta_segment-e1d95000_name", "crypta_segment-e1d95000_description", "all", "", "557", "7856623", "", "", "internal_ad" ],
    [ 2499981291, 2499980064, "Любители панк музыки", "internal", "crypta_segment-e1d95000_name", "crypta_segment-e1d95000_description", "all", "", "281", "189", "", "", "internal_ad" ],
    [ 2499981292, 2499980064, "Любители панк музыки", "internal", "crypta_segment-e1d95000_name", "crypta_segment-e1d95000_description", "all", "", "547", "1137", "", "", "internal_ad" ],
    [ 2499981293, 2499980064, "Любители рока", "internal", "crypta_segment-e6d34242_name", "crypta_segment-e6d34242_description", "all", "", "547", "1124", "", "", "internal_ad" ],
    [ 2499981294, 2499980064, "Любители рока", "internal", "crypta_segment-e6d34242_name", "crypta_segment-e6d34242_description", "all", "", "281", "176", "", "", "internal_ad" ],
    [ 2499981295, 2499980064, "Любители рока", "internal", "crypta_segment-e6d34242_name", "crypta_segment-e6d34242_description", "all", "", "557", "7720858", "", "", "internal_ad" ],
    [ 2499981296, 2499980065, "Представители индустрии \"retail\"", "internal", "crypta_segment-06288a2d_name", "crypta_segment-06288a2d_description", "all", "", "557", "11604217", "", "", "internal_ad" ],
    [ 2499981297, 2499980065, "Представители индустрии \"рестораны и кафе\"", "internal", "crypta_segment-3389c8a3_name", "crypta_segment-3389c8a3_description", "all", "", "557", "11585740", "", "", "internal_ad" ],
    [ 2499981298, 2499980065, "Пользователи Яндекс.Взгляд", "internal", "crypta_segment-36d829b0_name", "crypta_segment-36d829b0_description", "all", "", "557", "11032021", "", "", "internal_ad" ],
    [ 2499981299, 2499980065, "Пользователи Я.Справочника", "internal", "crypta_segment-41a81009_name", "crypta_segment-41a81009_description", "all", "", "557", "11552104", "", "", "internal_ad" ],
    [ 2499981300, 2499980065, "Интересуются проведением опросов", "internal", "crypta_segment-45beb84d_name", "crypta_segment-45beb84d_description", "all", "", "557", "10964545", "", "", "internal_ad" ],
    [ 2499981301, 2499980065, "Интересуются проведением опросов", "internal", "crypta_segment-45beb84d_name", "crypta_segment-45beb84d_description", "all", "", "547", "1204", "", "", "internal_ad" ],
    [ 2499981302, 2499980065, "Представители индустрии \"фитнес\"", "internal", "crypta_segment-80a891b8_name", "crypta_segment-80a891b8_description", "all", "", "557", "12076858", "", "", "internal_ad" ],
    [ 2499981303, 2499980065, "Посетители Яндекс.Взгляд", "internal", "crypta_segment-8142ec54_name", "crypta_segment-8142ec54_description", "all", "", "557", "11032369", "", "", "internal_ad" ],
    [ 2499981304, 2499980065, "Представители индустрии \"фармакология\"", "internal", "crypta_segment-eb8ab763_name", "crypta_segment-eb8ab763_description", "all", "", "557", "11587873", "", "", "internal_ad" ],
    [ 2499981305, 2499980066, "Официант, сотрудник ресторана", "internal", "crypta_segment-0131466e_name", "crypta_segment-0131466e_description", "all", "", "602", "322", "", "", "internal_ad" ],
    [ 2499981306, 2499980066, "Без опыта", "internal", "crypta_segment-08cd871b_name", "crypta_segment-08cd871b_description", "all", "", "602", "331", "", "", "internal_ad" ],
    [ 2499981307, 2499980066, "Грузчик", "internal", "crypta_segment-0bd7475a_name", "crypta_segment-0bd7475a_description", "all", "", "602", "329", "", "", "internal_ad" ],
    [ 2499981308, 2499980066, "Вахта", "internal", "crypta_segment-1b2c3a01_name", "crypta_segment-1b2c3a01_description", "all", "", "602", "330", "", "", "internal_ad" ],
    [ 2499981309, 2499980066, "Оператор колл-центра, службы поддержки", "internal", "crypta_segment-2244773b_name", "crypta_segment-2244773b_description", "all", "", "602", "321", "", "", "internal_ad" ],
    [ 2499981310, 2499980066, "Для студентов", "internal", "crypta_segment-24095c00_name", "crypta_segment-24095c00_description", "all", "", "602", "332", "", "", "internal_ad" ],
    [ 2499981311, 2499980066, "Кассир", "internal", "crypta_segment-5b66b695_name", "crypta_segment-5b66b695_description", "all", "", "602", "325", "", "", "internal_ad" ],
    [ 2499981312, 2499980066, "Специалист по продажам, консультант", "internal", "crypta_segment-6e6cce21_name", "crypta_segment-6e6cce21_description", "all", "", "602", "323", "", "", "internal_ad" ],
    [ 2499981313, 2499980066, "Страховой агент", "internal", "crypta_segment-7ea3c372_name", "crypta_segment-7ea3c372_description", "all", "", "602", "320", "", "", "internal_ad" ],
    [ 2499981314, 2499980066, "Курьер", "internal", "crypta_segment-a15514e9_name", "crypta_segment-a15514e9_description", "all", "", "602", "326", "", "", "internal_ad" ],
    [ 2499981315, 2499980066, "Повар", "internal", "crypta_segment-d928e624_name", "crypta_segment-d928e624_description", "all", "", "602", "324", "", "", "internal_ad" ],
    [ 2499981316, 2499980066, "Водитель", "internal", "crypta_segment-e0a38d85_name", "crypta_segment-e0a38d85_description", "all", "", "602", "327", "", "", "internal_ad" ],
    [ 2499981317, 2499980066, "Кредитный специалист", "internal", "crypta_segment-e9e4a1ca_name", "crypta_segment-e9e4a1ca_description", "all", "", "602", "328", "", "", "internal_ad" ],
    [ 2499981318, 2499980067, "Подписчики Кинопоиска (c Амедиатекой)", "internal", "crypta_segment-0629010d_name", "crypta_segment-0629010d_description", "all", "", "549", "1161", "", "", "internal_ad" ],
    [ 2499981319, 2499980067, "Подписчики Кинопоиска (c Амедиатекой)", "internal", "crypta_segment-0629010d_name", "crypta_segment-0629010d_description", "all", "", "557", "8009542", "", "", "internal_ad" ],
    [ 2499981320, 2499980067, "Отвалились от подписки Кинопоиска", "internal", "crypta_segment-486ac182_name", "crypta_segment-486ac182_description", "all", "", "557", "12150574", "", "", "internal_ad" ],
    [ 2499981321, 2499980067, "Отвалились от подписки Кинопоиска", "internal", "crypta_segment-486ac182_name", "crypta_segment-486ac182_description", "all", "", "549", "1194", "", "", "internal_ad" ],
    [ 2499981322, 2499980067, "Отвалились от подписки Кинопоиска (с Амедиатекой)", "internal", "crypta_segment-48bd9b89_name", "crypta_segment-48bd9b89_description", "all", "", "549", "1195", "", "", "internal_ad" ],
    [ 2499981323, 2499980067, "Похожи на пользователей Кинопоиска онлайн", "internal", "crypta_segment-6dc298e4_name", "crypta_segment-6dc298e4_description", "all", "", "546", "1377", "", "", "internal_ad" ],
    [ 2499981324, 2499980067, "Подписка КП+Амедиатека - отвальщики", "internal", "crypta_segment-752baac7_name", "crypta_segment-752baac7_description", "all", "", "549", "1320", "", "", "internal_ad" ],
    [ 2499981325, 2499980067, "Подписчики Кинопоиска", "internal", "crypta_segment-b31b09e1_name", "crypta_segment-b31b09e1_description", "all", "", "549", "1160", "", "", "internal_ad" ],
    [ 2499981326, 2499980067, "Подписчики Кинопоиска", "internal", "crypta_segment-b31b09e1_name", "crypta_segment-b31b09e1_description", "all", "", "557", "8009545", "", "", "internal_ad" ],
    [ 2499981327, 2499980067, "ЗВ для продажи фильмов", "internal", "crypta_segment-b3d62c94_name", "crypta_segment-b3d62c94_description", "all", "", "549", "1399", "", "", "internal_ad" ],
    [ 2499981328, 2499980067, "Аккаунт на Кинопоиске с привязанным Паспортом", "internal", "crypta_segment-c23b9698_name", "crypta_segment-c23b9698_description", "all", "", "557", "12150601", "", "", "internal_ad" ],
    [ 2499981329, 2499980067, "Аккаунт на Кинопоиске с привязанным Паспортом", "internal", "crypta_segment-c23b9698_name", "crypta_segment-c23b9698_description", "all", "", "557", "4791001", "", "", "internal_ad" ],
    [ 2499981330, 2499980067, "ЗВ для продажи билетов", "internal", "crypta_segment-c5776402_name", "crypta_segment-c5776402_description", "all", "", "549", "1398", "", "", "internal_ad" ],
    [ 2499981331, 2499980067, "Залогины Kinopoisk на SmartTV", "internal", "crypta_segment-kinopoisk_smarttv_logins_name", "crypta_segment-kinopoisk_smarttv_logins_description", "all", "", "281", "271", "", "", "internal_ad" ],
    [ 2499981332, 2499980068, "Пассажиры Яндекс.Такси", "internal", "crypta_segment-03ca0268_name", "crypta_segment-03ca0268_description", "all", "", "557", "11171197", "", "", "internal_ad" ],
    [ 2499981333, 2499980068, "Пассажиры Яндекс.Такси", "internal", "crypta_segment-03ca0268_name", "crypta_segment-03ca0268_description", "all", "", "546", "1223", "", "", "internal_ad" ],
    [ 2499981334, 2499980068, "Пассажиры Яндекс.Такси", "internal", "crypta_segment-03ca0268_name", "crypta_segment-03ca0268_description", "all", "", "557", "11612452", "", "", "internal_ad" ],
    [ 2499981335, 2499980068, "Пассажиры Яндекс.Такси", "internal", "crypta_segment-03ca0268_name", "crypta_segment-03ca0268_description", "all", "", "549", "1219", "", "", "internal_ad" ],
    [ 2499981336, 2499980068, "Пользователи Инстаграма", "internal", "crypta_segment-3e37de6c_name", "crypta_segment-3e37de6c_description", "all", "", "557", "11610610", "", "", "internal_ad" ],
    [ 2499981337, 2499980068, "Глухие и слабослышащие (по приложениям)", "internal", "crypta_segment-4e233b9a_name", "crypta_segment-4e233b9a_description", "all", "", "557", "11244208", "", "", "internal_ad" ],
    [ 2499981338, 2499980068, "Ищут про доставку", "internal", "crypta_segment-65749274_name", "crypta_segment-65749274_description", "all", "", "557", "10973404", "", "", "internal_ad" ],
    [ 2499981339, 2499980068, "Глухие и слабослышащие (по запросам)", "internal", "crypta_segment-8ac2dbe9_name", "crypta_segment-8ac2dbe9_description", "all", "", "557", "11392141", "", "", "internal_ad" ],
    [ 2499981340, 2499980068, "Глухие и слабослышащие (по сайтам)", "internal", "crypta_segment-ccd18493_name", "crypta_segment-ccd18493_description", "all", "", "557", "11244199", "", "", "internal_ad" ],
    [ 2499981341, 2499980068, "Посещают сайты про доставку", "internal", "crypta_segment-d6e178b6_name", "crypta_segment-d6e178b6_description", "all", "", "557", "10973410", "", "", "internal_ad" ],
    [ 2499981342, 2499980069, "Похожие на пользователей Я.Еды", "internal", "crypta_segment-2d28b575_name", "crypta_segment-2d28b575_description", "all", "", "546", "1374", "", "", "internal_ad" ],
    [ 2499981343, 2499980069, "Похожие на пользователей Я.Еды", "internal", "crypta_segment-2d28b575_name", "crypta_segment-2d28b575_description", "all", "", "546", "1373", "", "", "internal_ad" ],
    [ 2499981344, 2499980069, "Похожие на пользователей Я.Еды", "internal", "crypta_segment-2d28b575_name", "crypta_segment-2d28b575_description", "all", "", "546", "1375", "", "", "internal_ad" ],
    [ 2499981345, 2499980069, "Похожие на пользователей Я.Еды", "internal", "crypta_segment-2d28b575_name", "crypta_segment-2d28b575_description", "all", "", "557", "12217564", "", "", "internal_ad" ],
    [ 2499981346, 2499980069, "Интересовались доставкой еды", "internal", "crypta_segment-d3d1a0e8_name", "crypta_segment-d3d1a0e8_description", "all", "", "557", "12242770", "", "", "internal_ad" ],
    [ 2499981347, 2499980070, "Интересуются денежными переводами в Казахстан, Узбекистан или Беларусь", "internal", "crypta_segment-91be23e7_name", "crypta_segment-91be23e7_description", "all", "", "549", "1250", "", "", "internal_ad" ],
    [ 2499981348, 2499980070, "Регулярно ездят в Казахстан, Узбекистан или Беларусь", "internal", "crypta_segment-a6cd4751_name", "crypta_segment-a6cd4751_description", "all", "", "549", "1249", "", "", "internal_ad" ],
    [ 2499981349, 2499980070, "Ищут низкооплачиваемую работу", "internal", "crypta_segment-c569eed8_name", "crypta_segment-c569eed8_description", "all", "", "549", "1378", "", "", "internal_ad" ],
    [ 2499981350, 2499980071, "Похожи на тех, кто достигал цели PLAY", "internal", "crypta_segment-5e9e62b6_name", "crypta_segment-5e9e62b6_description", "all", "", "546", "1155", "", "", "internal_ad" ],
    [ 2499981351, 2499980071, "Любители музыки 80-х", "internal", "crypta_segment-628c91cb_name", "crypta_segment-628c91cb_description", "all", "", "549", "1283", "", "", "internal_ad" ],
    [ 2499981352, 2499980071, "Черная пятница на Музыке", "internal", "crypta_segment-da5b1eee_name", "crypta_segment-da5b1eee_description", "all", "", "549", "1339", "", "", "internal_ad" ],
    [ 2499981353, 2499980072, "Пользователи Яндекс.Кассы", "internal", "crypta_segment-347ab9b4_name", "crypta_segment-347ab9b4_description", "all", "", "549", "1209", "", "", "internal_ad" ],
    [ 2499981354, 2499980072, "Владельцы живых кошельков", "internal", "crypta_segment-4eced972_name", "crypta_segment-4eced972_description", "all", "", "549", "1294", "", "", "internal_ad" ],
    [ 2499981355, 2499980072, "Владельцы живых кошельков", "internal", "crypta_segment-4eced972_name", "crypta_segment-4eced972_description", "all", "", "557", "8725507", "", "", "internal_ad" ],
    [ 2499981356, 2499980072, "Владельцы мертвых кошельков", "internal", "crypta_segment-8ba503ac_name", "crypta_segment-8ba503ac_description", "all", "", "549", "1295", "", "", "internal_ad" ],
    [ 2499981357, 2499980072, "Владельцы мертвых кошельков", "internal", "crypta_segment-8ba503ac_name", "crypta_segment-8ba503ac_description", "all", "", "557", "8725510", "", "", "internal_ad" ],
    [ 2499981358, 2499980072, "Живые кошельки, которые активны в других сервисах", "internal", "crypta_segment-8d85e4e2_name", "crypta_segment-8d85e4e2_description", "all", "", "557", "9337771", "", "", "internal_ad" ],
    [ 2499981359, 2499980072, "Пользуются интернет-эквайрингом", "internal", "crypta_segment-c99b32a1_name", "crypta_segment-c99b32a1_description", "all", "", "557", "6982777", "", "", "internal_ad" ],
    [ 2499981360, 2499980072, "Недавно зарегистрированные в Я.Паспорте", "internal", "crypta_segment-recently-registred-puids_name", "crypta_segment-recently-registred-puids_description", "all", "", "281", "290", "", "", "internal_ad" ],
    [ 2499981361, 2499980073, "Болеют за ФК «Динамо» (Москва)", "internal", "crypta_segment-09d002ac_name", "crypta_segment-09d002ac_description", "all", "", "549", "1235", "", "", "internal_ad" ],
    [ 2499981362, 2499980073, "Болеют за ФК «Крылья Советов»", "internal", "crypta_segment-1bd3e811_name", "crypta_segment-1bd3e811_description", "all", "", "549", "1244", "", "", "internal_ad" ],
    [ 2499981363, 2499980073, "Болеют за ФК «Ахмат»", "internal", "crypta_segment-205a95a1_name", "crypta_segment-205a95a1_description", "all", "", "549", "1234", "", "", "internal_ad" ],
    [ 2499981364, 2499980073, "Болеют за ФК «Локомотив»", "internal", "crypta_segment-2db5930d_name", "crypta_segment-2db5930d_description", "all", "", "549", "1238", "", "", "internal_ad" ],
    [ 2499981365, 2499980073, "Болеют за ПФК ЦСКА", "internal", "crypta_segment-30722b00_name", "crypta_segment-30722b00_description", "all", "", "557", "11650516", "", "", "internal_ad" ],
    [ 2499981366, 2499980073, "Болеют за ПФК ЦСКА", "internal", "crypta_segment-30722b00_name", "crypta_segment-30722b00_description", "all", "", "549", "1232", "", "", "internal_ad" ],
    [ 2499981367, 2499980073, "Болеют за ФК «Арсенал» (Тула)", "internal", "crypta_segment-30a53522_name", "crypta_segment-30a53522_description", "all", "", "549", "1233", "", "", "internal_ad" ],
    [ 2499981368, 2499980073, "Болеют за ФК «Урал»", "internal", "crypta_segment-32755dd1_name", "crypta_segment-32755dd1_description", "all", "", "549", "1242", "", "", "internal_ad" ],
    [ 2499981369, 2499980073, "Болеют за ФК «Уфа»", "internal", "crypta_segment-52e46799_name", "crypta_segment-52e46799_description", "all", "", "549", "1243", "", "", "internal_ad" ],
    [ 2499981370, 2499980073, "Болеют за ФК «Оренбург»", "internal", "crypta_segment-57e0a9b8_name", "crypta_segment-57e0a9b8_description", "all", "", "549", "1245", "", "", "internal_ad" ],
    [ 2499981371, 2499980073, "Болеют за ФК «Рубин»", "internal", "crypta_segment-711b8d5b_name", "crypta_segment-711b8d5b_description", "all", "", "549", "1240", "", "", "internal_ad" ],
    [ 2499981372, 2499980073, "Болеют за ФК «Сочи»", "internal", "crypta_segment-7210155a_name", "crypta_segment-7210155a_description", "all", "", "549", "1246", "", "", "internal_ad" ],
    [ 2499981373, 2499980073, "Болеют за ФК «Зенит»", "internal", "crypta_segment-73ee53ed_name", "crypta_segment-73ee53ed_description", "all", "", "549", "1236", "", "", "internal_ad" ],
    [ 2499981374, 2499980073, "Болеют за ФК «Краснодар»", "internal", "crypta_segment-840541d3_name", "crypta_segment-840541d3_description", "all", "", "549", "1237", "", "", "internal_ad" ],
    [ 2499981375, 2499980073, "Болеют за ФК «Спартак»", "internal", "crypta_segment-a864abde_name", "crypta_segment-a864abde_description", "all", "", "549", "1241", "", "", "internal_ad" ],
    [ 2499981376, 2499980073, "Болеют за ФК «Ростов»", "internal", "crypta_segment-c5ab0946_name", "crypta_segment-c5ab0946_description", "all", "", "549", "1239", "", "", "internal_ad" ],
    [ 2499981377, 2499980073, "Болеют за ФК «Тамбов»", "internal", "crypta_segment-e8222e99_name", "crypta_segment-e8222e99_description", "all", "", "549", "1247", "", "", "internal_ad" ],
    [ 2499981378, 2499980074, "Корпоративная телефония", "internal", "crypta_segment-79aa6624_name", "crypta_segment-79aa6624_description", "all", "", "557", "11913352", "", "", "internal_ad" ],
    [ 2499981379, 2499980074, "Корпоративная телефония", "internal", "crypta_segment-79aa6624_name", "crypta_segment-79aa6624_description", "all", "", "549", "1317", "", "", "internal_ad" ],
    [ 2499981380, 2499980074, "Потенциальные клиенты Яндекс.Телефонии", "internal", "crypta_segment-d3ebd890_name", "crypta_segment-d3ebd890_description", "all", "", "281", "169", "", "", "internal_ad" ],
    [ 2499981381, 2499980074, "Потенциальные клиенты Яндекс.Телефонии", "internal", "crypta_segment-d3ebd890_name", "crypta_segment-d3ebd890_description", "all", "", "557", "5994832", "", "", "internal_ad" ],
    [ 2499981382, 2499980074, "Пользователи Яндекс.Телефонии", "internal", "crypta_segment-d89d6dc6_name", "crypta_segment-d89d6dc6_description", "all", "", "549", "1120", "", "", "internal_ad" ],
    [ 2499981383, 2499980074, "Пользователи Яндекс.Телефонии", "internal", "crypta_segment-d89d6dc6_name", "crypta_segment-d89d6dc6_description", "all", "", "557", "11384545", "", "", "internal_ad" ],
    [ 2499981384, 2499980075, "Путешествуют по России и СНГ", "internal", "crypta_segment-0acdac7d_name", "crypta_segment-0acdac7d_description", "all", "", "549", "1261", "", "", "internal_ad" ],
    [ 2499981385, 2499980075, "Заведения общественного питания", "internal", "crypta_segment-17d999e4_name", "crypta_segment-17d999e4_description", "all", "", "549", "1260", "", "", "internal_ad" ],
    [ 2499981386, 2499980075, "Посетители развлекательных площадок для детей", "internal", "crypta_segment-5c38b3e0_name", "crypta_segment-5c38b3e0_description", "all", "", "549", "1262", "", "", "internal_ad" ],
    [ 2499981387, 2499980076, "Пользовались ПП 31—60 дней назад", "internal", "crypta_segment-04d08626_name", "crypta_segment-04d08626_description", "all", "", "549", "1273", "", "", "internal_ad" ],
    [ 2499981388, 2499980076, "Пользовались ПП 7—15 дней назад", "internal", "crypta_segment-256d8ea0_name", "crypta_segment-256d8ea0_description", "all", "", "549", "1651", "", "", "internal_ad" ],
    [ 2499981389, 2499980076, "Потенциальные пользователи АОНа", "internal", "crypta_segment-319661c7_name", "crypta_segment-319661c7_description", "all", "", "549", "1319", "", "", "internal_ad" ],
    [ 2499981390, 2499980076, "Пользователи поискового приложения Яндекса", "internal", "crypta_segment-6c9422d2_name", "crypta_segment-6c9422d2_description", "all", "", "557", "7558426", "", "", "internal_ad" ],
    [ 2499981391, 2499980076, "Пользователи поискового приложения Яндекса", "internal", "crypta_segment-6c9422d2_name", "crypta_segment-6c9422d2_description", "all", "", "549", "1149", "", "", "internal_ad" ],
    [ 2499981392, 2499980076, "Пользовались ПП 0—6 дней назад", "internal", "crypta_segment-9a13ec52_name", "crypta_segment-9a13ec52_description", "all", "", "549", "1650", "", "", "internal_ad" ],
    [ 2499981393, 2499980076, "Пользовались ПП 16—30 дней назад", "internal", "crypta_segment-a9ad3d3c_name", "crypta_segment-a9ad3d3c_description", "all", "", "549", "1272", "", "", "internal_ad" ],
    [ 2499981394, 2499980076, "Пользовались ПП 0—15 дней назад", "internal", "crypta_segment-bc6e4820_name", "crypta_segment-bc6e4820_description", "all", "", "549", "1271", "", "", "internal_ad" ],
    [ 2499981395, 2499980077, "Разработчики в поисках работы", "internal", "crypta_segment-96941e77_name", "crypta_segment-96941e77_description", "all", "", "549", "1322", "", "", "internal_ad" ],
    [ 2499981396, 2499980077, "Разработчики в поисках работы", "internal", "crypta_segment-96941e77_name", "crypta_segment-96941e77_description", "all", "", "557", "12014473", "", "", "internal_ad" ],
    [ 2499981397, 2499980078, "Похожи на тех, кто получал письма с посадочными талонами", "internal", "crypta_segment-122250a4_name", "crypta_segment-122250a4_description", "all", "", "546", "1409", "", "", "internal_ad" ],
    [ 2499981398, 2499980078, "Похожи на тех, кто получал письма с посадочными талонами", "internal", "crypta_segment-122250a4_name", "crypta_segment-122250a4_description", "all", "", "557", "12742504", "", "", "internal_ad" ],
    [ 2499981399, 2499980078, "Похожи на тех, кто получал письма с авиабилетами", "internal", "crypta_segment-165b3041_name", "crypta_segment-165b3041_description", "all", "", "557", "12742489", "", "", "internal_ad" ],
    [ 2499981400, 2499980078, "Похожи на тех, кто получал письма с авиабилетами", "internal", "crypta_segment-165b3041_name", "crypta_segment-165b3041_description", "all", "", "281", "246", "", "", "internal_ad" ],
    [ 2499981401, 2499980078, "Похожи на тех, кто получал письма с авиабилетами", "internal", "crypta_segment-64ea5a48_name", "crypta_segment-64ea5a48_description", "all", "", "546", "1407", "", "", "internal_ad" ],
    [ 2499981402, 2499980078, "Похожи на тех, кто получал письма с авиабилетами", "internal", "crypta_segment-64ea5a48_name", "crypta_segment-64ea5a48_description", "all", "", "557", "12742495", "", "", "internal_ad" ],
    [ 2499981403, 2499980078, "Похожи на тех, кто получал письма с информацией про отели", "internal", "crypta_segment-6a3a5ee0_name", "crypta_segment-6a3a5ee0_description", "all", "", "546", "1408", "", "", "internal_ad" ],
    [ 2499981404, 2499980078, "Похожи на тех, кто получал письма с информацией про отели", "internal", "crypta_segment-6a3a5ee0_name", "crypta_segment-6a3a5ee0_description", "all", "", "557", "12742498", "", "", "internal_ad" ],
    [ 2499981405, 2499980078, "Посещают Москву", "internal", "crypta_segment-8588b1c5_name", "crypta_segment-8588b1c5_description", "all", "", "557", "5305681", "", "", "internal_ad" ],
    [ 2499981406, 2499980078, "Посещают Санкт-Петербург", "internal", "crypta_segment-a57a342c_name", "crypta_segment-a57a342c_description", "all", "", "557", "5305759", "", "", "internal_ad" ],
    [ 2499981407, 2499980078, "Посещают Европу", "internal", "crypta_segment-b84e6087_name", "crypta_segment-b84e6087_description", "all", "", "557", "5305588", "", "", "internal_ad" ],
    [ 2499981408, 2499980078, "Похожи на тех, кто достигал цели на сайте Я.Авиабилетов v2", "internal", "crypta_segment-d0dd27dc_name", "crypta_segment-d0dd27dc_description", "all", "", "557", "12742486", "", "", "internal_ad" ],
    [ 2499981409, 2499980078, "Похожи на тех, кто достигал цели на сайте Я.Авиабилетов v2", "internal", "crypta_segment-d0dd27dc_name", "crypta_segment-d0dd27dc_description", "all", "", "281", "200", "", "", "internal_ad" ],
    [ 2499981410, 2499980079, "Ищущие про виртуальный хостинг (2+ дня)", "internal", "crypta_segment-02a391d0_name", "crypta_segment-02a391d0_description", "all", "", "557", "6401842", "", "", "internal_ad" ],
    [ 2499981411, 2499980079, "1С", "internal", "crypta_segment-15cbd1ec_name", "crypta_segment-15cbd1ec_description", "all", "", "557", "11419672", "", "", "internal_ad" ],
    [ 2499981412, 2499980079, "Облако (developers)", "internal", "crypta_segment-1d1d3c96_name", "crypta_segment-1d1d3c96_description", "all", "", "281", "305", "", "", "internal_ad" ],
    [ 2499981413, 2499980079, "Облако (business)", "internal", "crypta_segment-41231969_name", "crypta_segment-41231969_description", "all", "", "281", "303", "", "", "internal_ad" ],
    [ 2499981414, 2499980079, "LAL Cloud Boost", "internal", "crypta_segment-41d1012d_name", "crypta_segment-41d1012d_description", "all", "", "549", "1297", "", "", "internal_ad" ],
    [ 2499981415, 2499980079, "LAL Cloud Boost", "internal", "crypta_segment-41d1012d_name", "crypta_segment-41d1012d_description", "all", "", "557", "11626936", "", "", "internal_ad" ],
    [ 2499981416, 2499980079, "Битрикс", "internal", "crypta_segment-459973de_name", "crypta_segment-459973de_description", "all", "", "557", "11419681", "", "", "internal_ad" ],
    [ 2499981417, 2499980079, "Облако (competitor sites)", "internal", "crypta_segment-469d5b54_name", "crypta_segment-469d5b54_description", "all", "", "281", "307", "", "", "internal_ad" ],
    [ 2499981418, 2499980079, "Облако (competitor sites)", "internal", "crypta_segment-469d5b54_name", "crypta_segment-469d5b54_description", "all", "", "557", "6936037", "", "", "internal_ad" ],
    [ 2499981419, 2499980079, "Облако (competitors)", "internal", "crypta_segment-60d04ec3_name", "crypta_segment-60d04ec3_description", "all", "", "281", "304", "", "", "internal_ad" ],
    [ 2499981420, 2499980079, "Облако (competitors)", "internal", "crypta_segment-60d04ec3_name", "crypta_segment-60d04ec3_description", "all", "", "557", "12150841", "", "", "internal_ad" ],
    [ 2499981421, 2499980079, "Посещали сайты конференций", "internal", "crypta_segment-9e3c3bd1_name", "crypta_segment-9e3c3bd1_description", "all", "", "549", "1253", "", "", "internal_ad" ],
    [ 2499981422, 2499980079, "Посещали сайты конференций", "internal", "crypta_segment-9e3c3bd1_name", "crypta_segment-9e3c3bd1_description", "all", "", "557", "11244571", "", "", "internal_ad" ],
    [ 2499981423, 2499980079, "Облако (common)", "internal", "crypta_segment-b0eedb84_name", "crypta_segment-b0eedb84_description", "all", "", "281", "306", "", "", "internal_ad" ],
    [ 2499981424, 2499980079, "Ищущие про СУБД (2+ дня)", "internal", "crypta_segment-ce8b608e_name", "crypta_segment-ce8b608e_description", "all", "", "557", "6401845", "", "", "internal_ad" ],
    [ 2499981425, 2499980079, "Похожи на тех, кто достигал целей на сайте Speechkit v2", "internal", "crypta_segment-d7815cc8_name", "crypta_segment-d7815cc8_description", "all", "", "281", "149", "", "", "internal_ad" ],
    [ 2499981426, 2499980079, "Похожи на тех, кто достигал целей на сайте Speechkit", "internal", "crypta_segment-d924b1a8_name", "crypta_segment-d924b1a8_description", "all", "", "281", "148", "", "", "internal_ad" ],
    [ 2499981427, 2499980080, "С большим количеством устройств на одном паспорте", "internal", "crypta_segment-1979999a_name", "crypta_segment-1979999a_description", "all", "", "549", "1396", "", "", "internal_ad" ],
    [ 2499981428, 2499980080, "Интересуются подкастами", "internal", "crypta_segment-1d9ad01e_name", "crypta_segment-1d9ad01e_description", "all", "", "557", "11803345", "", "", "internal_ad" ],
    [ 2499981429, 2499980080, "Интересуются подкастами", "internal", "crypta_segment-1d9ad01e_name", "crypta_segment-1d9ad01e_description", "all", "", "549", "1307", "", "", "internal_ad" ],
    [ 2499981430, 2499980080, "Интересуются подкастами", "internal", "crypta_segment-1d9ad01e_name", "crypta_segment-1d9ad01e_description", "all", "", "546", "1312", "", "", "internal_ad" ],
    [ 2499981431, 2499980080, "Интересуются подкастами", "internal", "crypta_segment-1d9ad01e_name", "crypta_segment-1d9ad01e_description", "all", "", "557", "11695876", "", "", "internal_ad" ],
    [ 2499981432, 2499980080, "Интересуются просмотром фильмов и сериалов онлайн", "internal", "crypta_segment-37885d1d_name", "crypta_segment-37885d1d_description", "all", "", "557", "12150394", "", "", "internal_ad" ],
    [ 2499981433, 2499980080, "Интересуются просмотром фильмов и сериалов онлайн", "internal", "crypta_segment-37885d1d_name", "crypta_segment-37885d1d_description", "all", "", "549", "1224", "", "", "internal_ad" ],
    [ 2499981434, 2499980080, "PLUS-521", "internal", "crypta_segment-3c727cb9_name", "crypta_segment-3c727cb9_description", "all", "", "549", "1177", "", "", "internal_ad" ],
    [ 2499981435, 2499980080, "Залогинены", "internal", "crypta_segment-5b539696_name", "crypta_segment-5b539696_description", "all", "", "557", "6521188", "", "", "internal_ad" ],
    [ 2499981436, 2499980080, "Пользуются или пользовались Диском Про", "internal", "crypta_segment-8795ec6e_name", "crypta_segment-8795ec6e_description", "all", "", "549", "1311", "", "", "internal_ad" ],
    [ 2499981437, 2499980080, "Похожи на пользователей Афиши", "internal", "crypta_segment-88a1e480_name", "crypta_segment-88a1e480_description", "all", "", "546", "1222", "", "", "internal_ad" ],
    [ 2499981438, 2499980080, "Оформили подписку Яндекс.Плюс", "internal", "crypta_segment-97c006ce_name", "crypta_segment-97c006ce_description", "all", "", "557", "4790998", "", "", "internal_ad" ],
    [ 2499981439, 2499980080, "Оформили подписку Яндекс.Плюс", "internal", "crypta_segment-97c006ce_name", "crypta_segment-97c006ce_description", "all", "", "281", "254", "", "", "internal_ad" ],
    [ 2499981440, 2499980080, "Оформили подписку Яндекс.Плюс", "internal", "crypta_segment-97c006ce_name", "crypta_segment-97c006ce_description", "all", "", "546", "1393", "", "", "internal_ad" ],
    [ 2499981441, 2499980080, "Оформили подписку Яндекс.Плюс", "internal", "crypta_segment-97c006ce_name", "crypta_segment-97c006ce_description", "all", "", "557", "12205810", "", "", "internal_ad" ],
    [ 2499981442, 2499980080, "Ищут конкурентов Кинопоиска", "internal", "crypta_segment-c59341bd_name", "crypta_segment-c59341bd_description", "all", "", "549", "1280", "", "", "internal_ad" ],
    [ 2499981443, 2499980080, "Ищут конкурентов Кинопоиска", "internal", "crypta_segment-c59341bd_name", "crypta_segment-c59341bd_description", "all", "", "557", "12150541", "", "", "internal_ad" ],
    [ 2499981444, 2499980080, "Ищут конкурентов Музыки", "internal", "crypta_segment-c79d33ba_name", "crypta_segment-c79d33ba_description", "all", "", "549", "1281", "", "", "internal_ad" ],
    [ 2499981445, 2499980080, "Ищут конкурентов Музыки", "internal", "crypta_segment-c79d33ba_name", "crypta_segment-c79d33ba_description", "all", "", "557", "12150562", "", "", "internal_ad" ],
    [ 2499981446, 2499980080, "Активные пользователи Диска", "internal", "crypta_segment-de981dde_name", "crypta_segment-de981dde_description", "all", "", "557", "12930607", "", "", "internal_ad" ],
    [ 2499981447, 2499980080, "Активные пользователи Диска", "internal", "crypta_segment-de981dde_name", "crypta_segment-de981dde_description", "all", "", "549", "1310", "", "", "internal_ad" ],
    [ 2499981448, 2499980080, "Конкуренты Афиши", "internal", "crypta_segment-e594b97d_name", "crypta_segment-e594b97d_description", "all", "", "549", "1220", "", "", "internal_ad" ],
    [ 2499981449, 2499980081, "Интересуются курсами по программированию и машинному обучению", "internal", "crypta_segment-81c02c41_name", "crypta_segment-81c02c41_description", "all", "", "557", "12318391", "", "", "internal_ad" ],
    [ 2499981450, 2499980082, "Интересуются цирком", "internal", "crypta_segment-0ed2a651_name", "crypta_segment-0ed2a651_description", "all", "", "281", "283", "", "", "internal_ad" ],
    [ 2499981451, 2499980082, "Много читают", "internal", "crypta_segment-483997c1_name", "crypta_segment-483997c1_description", "all", "", "281", "286", "", "", "internal_ad" ],
    [ 2499981452, 2499980082, "Интересуются батутными центрами", "internal", "crypta_segment-75a3bed6_name", "crypta_segment-75a3bed6_description", "all", "", "281", "285", "", "", "internal_ad" ],
    [ 2499981453, 2499980082, "Интересуются боулингом", "internal", "crypta_segment-829d1840_name", "crypta_segment-829d1840_description", "all", "", "281", "284", "", "", "internal_ad" ],
    [ 2499981454, 2499980082, "Любители рынков", "internal", "crypta_segment-ce2dba92_name", "crypta_segment-ce2dba92_description", "all", "", "281", "274", "", "", "internal_ad" ],
    [ 2499981455, 2499980082, "Интересуются караоке", "internal", "crypta_segment-e095aa99_name", "crypta_segment-e095aa99_description", "all", "", "281", "295", "", "", "internal_ad" ],
    [ 2499981456, 2499980083, "Искали ТВ с разрешением 8K", "internal", "crypta_segment-2451c6c4_name", "crypta_segment-2451c6c4_description", "all", "", "557", "9535363", "", "", "internal_ad" ],
    [ 2499981457, 2499980083, "Искали ТВ с диагональю < 43''", "internal", "crypta_segment-27e32abd_name", "crypta_segment-27e32abd_description", "all", "", "557", "9535351", "", "", "internal_ad" ],
    [ 2499981458, 2499980083, "Искали ТВ со Смарт ТВ", "internal", "crypta_segment-36d33b1c_name", "crypta_segment-36d33b1c_description", "all", "", "557", "9535348", "", "", "internal_ad" ],
    [ 2499981459, 2499980083, "Искали ТВ с разрешением 1080 Full HD", "internal", "crypta_segment-644d89db_name", "crypta_segment-644d89db_description", "all", "", "557", "9535357", "", "", "internal_ad" ],
    [ 2499981460, 2499980083, "Самсунг ТВ: Был на лендинге, не перешёл на карточку", "internal", "crypta_segment-64b186a9_name", "crypta_segment-64b186a9_description", "all", "", "557", "11336683", "", "", "internal_ad" ],
    [ 2499981461, 2499980083, "Искали ТВ с разрешением 4K", "internal", "crypta_segment-7148d3eb_name", "crypta_segment-7148d3eb_description", "all", "", "557", "9535360", "", "", "internal_ad" ],
    [ 2499981462, 2499980083, "Искали ТВ с диагональю от 55''", "internal", "crypta_segment-796e898a_name", "crypta_segment-796e898a_description", "all", "", "557", "9535354", "", "", "internal_ad" ],
    [ 2499981463, 2499980083, "Искали ТВ и интересуются дизайном интерьеров", "internal", "crypta_segment-87771838_name", "crypta_segment-87771838_description", "all", "", "557", "9713317", "", "", "internal_ad" ],
    [ 2499981464, 2499980083, "Искали ТВ с диагональю от 43\" до 55''", "internal", "crypta_segment-8d1040da_name", "crypta_segment-8d1040da_description", "all", "", "557", "9535366", "", "", "internal_ad" ],
    [ 2499981465, 2499980083, "Самсунг ТВ: Был на карточке, перешел в магазин", "internal", "crypta_segment-94e636cd_name", "crypta_segment-94e636cd_description", "all", "", "557", "11336677", "", "", "internal_ad" ],
    [ 2499981466, 2499980083, "Самсунг телефон: Был на карточке, перешел в магазин", "internal", "crypta_segment-a6a19a8c_name", "crypta_segment-a6a19a8c_description", "all", "", "557", "11336686", "", "", "internal_ad" ],
    [ 2499981467, 2499980083, "Самсунг ТВ: Был на карточке, но не сделал кликаут", "internal", "crypta_segment-c556cd47_name", "crypta_segment-c556cd47_description", "all", "", "557", "11336680", "", "", "internal_ad" ],
    [ 2499981468, 2499980083, "Самсунг телефон: Был на лендинге, не перешёл на карточку", "internal", "crypta_segment-ceda278a_name", "crypta_segment-ceda278a_description", "all", "", "557", "11336692", "", "", "internal_ad" ],
    [ 2499981469, 2499980083, "Самсунг телефон: Был на карточке, но не сделал кликаут", "internal", "crypta_segment-eed469c2_name", "crypta_segment-eed469c2_description", "all", "", "557", "11336689", "", "", "internal_ad" ],
    [ 2499981470, 2499980084, "Потенциальные авторы в Я.Районе (местные новости)", "internal", "crypta_segment-14dc1808_name", "crypta_segment-14dc1808_description", "all", "", "549", "1227", "", "", "internal_ad" ],
    [ 2499981471, 2499980084, "Потенциальные авторы в Я.Районе (местные новости)", "internal", "crypta_segment-14dc1808_name", "crypta_segment-14dc1808_description", "all", "", "557", "11986825", "", "", "internal_ad" ],
    [ 2499981472, 2499980084, "Потенциальные авторы в Я.Районе (локальные группы в соцсетях)", "internal", "crypta_segment-2c485e8c_name", "crypta_segment-2c485e8c_description", "all", "", "549", "1226", "", "", "internal_ad" ],
    [ 2499981473, 2499980084, "Потенциальные авторы в Я.Районе (локальные группы в соцсетях)", "internal", "crypta_segment-2c485e8c_name", "crypta_segment-2c485e8c_description", "all", "", "557", "11986819", "", "", "internal_ad" ],
    [ 2499981474, 2499980084, "Потенциальные авторы в Я.Районе", "internal", "crypta_segment-5db38d95_name", "crypta_segment-5db38d95_description", "all", "", "549", "1225", "", "", "internal_ad" ],
    [ 2499981475, 2499980085, "Владельцы колонок Elari с Алисой", "internal", "crypta_segment-01403d83_name", "crypta_segment-01403d83_description", "all", "", "547", "1203", "", "", "internal_ad" ],
    [ 2499981476, 2499980085, "Владельцы колонок Elari с Алисой", "internal", "crypta_segment-01403d83_name", "crypta_segment-01403d83_description", "all", "", "557", "11203417", "", "", "internal_ad" ],
    [ 2499981477, 2499980085, "Владельцы дорогих авто", "internal", "crypta_segment-02188e81_name", "crypta_segment-02188e81_description", "all", "", "557", "9412087", "", "", "internal_ad" ],
    [ 2499981478, 2499980085, "Владельцы устройств Irbis с Алисой", "internal", "crypta_segment-0a4deec6_name", "crypta_segment-0a4deec6_description", "all", "", "557", "8062021", "", "", "internal_ad" ],
    [ 2499981479, 2499980085, "Владельцы устройств Irbis с Алисой", "internal", "crypta_segment-0a4deec6_name", "crypta_segment-0a4deec6_description", "all", "", "547", "1163", "", "", "internal_ad" ],
    [ 2499981480, 2499980085, "Интересуются гаджетами", "internal", "crypta_segment-36ea79e3_name", "crypta_segment-36ea79e3_description", "all", "", "557", "7496992", "", "", "internal_ad" ],
    [ 2499981481, 2499980085, "Владельцы Яндекс.Станций", "internal", "crypta_segment-3bcb4998_name", "crypta_segment-3bcb4998_description", "all", "", "547", "1117", "", "", "internal_ad" ],
    [ 2499981482, 2499980085, "Владельцы Яндекс.Станций", "internal", "crypta_segment-3bcb4998_name", "crypta_segment-3bcb4998_description", "all", "", "557", "7435468", "", "", "internal_ad" ],
    [ 2499981483, 2499980085, "Совершают покупки в интернете дороже 5 тысяч рублей", "internal", "crypta_segment-4b26e57b_name", "crypta_segment-4b26e57b_description", "all", "", "557", "8843842", "", "", "internal_ad" ],
    [ 2499981484, 2499980085, "Клиенты Сбербанка", "internal", "crypta_segment-7cc6be10_name", "crypta_segment-7cc6be10_description", "all", "", "557", "9167737", "", "", "internal_ad" ],
    [ 2499981485, 2499980085, "Легко сказать: логопедия для детей", "internal", "crypta_segment-8ccc27c1_name", "crypta_segment-8ccc27c1_description", "all", "", "549", "1649", "", "", "internal_ad" ],
    [ 2499981486, 2499980085, "Легко сказать: воспитатели детский садов, логопеды", "internal", "crypta_segment-a110e568_name", "crypta_segment-a110e568_description", "all", "", "549", "1648", "", "", "internal_ad" ],
    [ 2499981487, 2499980085, "Владельцы Яндекс.CтанцийМини", "internal", "crypta_segment-cbb0617b_name", "crypta_segment-cbb0617b_description", "all", "", "557", "11203264", "", "", "internal_ad" ],
    [ 2499981488, 2499980085, "Владельцы Яндекс.CтанцийМини", "internal", "crypta_segment-cbb0617b_name", "crypta_segment-cbb0617b_description", "all", "", "547", "1202", "", "", "internal_ad" ],
    [ 2499981489, 2499980085, "Владельцы устройств Dexp с Алисой", "internal", "crypta_segment-d59aa02c_name", "crypta_segment-d59aa02c_description", "all", "", "547", "1162", "", "", "internal_ad" ],
    [ 2499981490, 2499980085, "Владельцы устройств Dexp с Алисой", "internal", "crypta_segment-d59aa02c_name", "crypta_segment-d59aa02c_description", "all", "", "557", "8062024", "", "", "internal_ad" ],
    [ 2499981491, 2499980085, "Активные пользователи Алисы", "internal", "crypta_segment-e99a165a_name", "crypta_segment-e99a165a_description", "all", "", "557", "9054388", "", "", "internal_ad" ],
    [ 2499981492, 2499980086, "Похожи на тех, кто интересуется ОФД", "internal", "crypta_segment-b2d63e46_name", "crypta_segment-b2d63e46_description", "all", "", "281", "248", "", "", "internal_ad" ],
    [ 2499981493, 2499980086, "Интересуются ОФД", "internal", "crypta_segment-b839a0e7_name", "crypta_segment-b839a0e7_description", "all", "", "281", "245", "", "", "internal_ad" ],
    [ 2499981494, 2499980086, "Интересуются ОФД", "internal", "crypta_segment-b839a0e7_name", "crypta_segment-b839a0e7_description", "all", "", "557", "3486365", "", "", "internal_ad" ],
    [ 2499981495, 2499980087, "Пользователи каршерингов", "internal", "crypta_segment-b133a55d_name", "crypta_segment-b133a55d_description", "all", "", "557", "4293641", "", "", "internal_ad" ],
    [ 2499981496, 2499980087, "Пользователи каршерингов", "internal", "crypta_segment-b133a55d_name", "crypta_segment-b133a55d_description", "all", "", "281", "269", "", "", "internal_ad" ],
    [ 2499981497, 2499980087, "Пользователи Яндекс.Драйва", "internal", "crypta_segment-e4981099_name", "crypta_segment-e4981099_description", "all", "", "546", "1218", "", "", "internal_ad" ],
    [ 2499981498, 2499980087, "Пользователи Яндекс.Драйва", "internal", "crypta_segment-e4981099_name", "crypta_segment-e4981099_description", "all", "", "281", "270", "", "", "internal_ad" ],
    [ 2499981499, 2499980087, "Пользователи Яндекс.Драйва", "internal", "crypta_segment-e4981099_name", "crypta_segment-e4981099_description", "all", "", "557", "4293620", "", "", "internal_ad" ],
    [ 2499981500, 2499980088, "Ecommerce для Вебмастера", "internal", "crypta_segment-12341daa_name", "crypta_segment-12341daa_description", "all", "", "557", "12045127", "", "", "internal_ad" ],
    [ 2499981501, 2499980088, "Ecommerce для Вебмастера", "internal", "crypta_segment-12341daa_name", "crypta_segment-12341daa_description", "all", "", "549", "1215", "", "", "internal_ad" ],
    [ 2499981502, 2499980088, "Пользователи Вебмастера", "internal", "crypta_segment-3971bd31_name", "crypta_segment-3971bd31_description", "all", "", "549", "1217", "", "", "internal_ad" ],
    [ 2499981503, 2499980088, "Владельцы e-commerce сайтов", "internal", "crypta_segment-40d178cc_name", "crypta_segment-40d178cc_description", "all", "", "549", "1315", "", "", "internal_ad" ],
    [ 2499981504, 2499980088, "Владельцы e-commerce сайтов", "internal", "crypta_segment-40d178cc_name", "crypta_segment-40d178cc_description", "all", "", "557", "12045124", "", "", "internal_ad" ],
    [ 2499981505, 2499980088, "Пользователи Турбо", "internal", "crypta_segment-74d1dc64_name", "crypta_segment-74d1dc64_description", "all", "", "549", "1214", "", "", "internal_ad" ],
    [ 2499981506, 2499980088, "Вебмастера", "internal", "crypta_segment-b852b855_name", "crypta_segment-b852b855_description", "all", "", "549", "1213", "", "", "internal_ad" ],
    [ 2499981507, 2499980089, "Пользовались мобильным браузером 0—15 дней назад", "internal", "crypta_segment-0a08c563_name", "crypta_segment-0a08c563_description", "all", "", "549", "1268", "", "", "internal_ad" ],
    [ 2499981508, 2499980089, "Лояльны к Яндекс.Браузеру в Казахстане", "internal", "crypta_segment-50de8911_name", "crypta_segment-50de8911_description", "all", "", "281", "231", "", "", "internal_ad" ],
    [ 2499981509, 2499980089, "Лояльны к Яндекс.Браузеру в Беларуси", "internal", "crypta_segment-5686565a_name", "crypta_segment-5686565a_description", "all", "", "281", "230", "", "", "internal_ad" ],
    [ 2499981510, 2499980089, "Лояльны к Яндекс.Браузеру в России", "internal", "crypta_segment-979ba25b_name", "crypta_segment-979ba25b_description", "all", "", "281", "218", "", "", "internal_ad" ],
    [ 2499981511, 2499980089, "Пользовались мобильным браузером 31—60 дней назад", "internal", "crypta_segment-aebc8a30_name", "crypta_segment-aebc8a30_description", "all", "", "549", "1270", "", "", "internal_ad" ],
    [ 2499981512, 2499980089, "Пользовались мобильным браузером 16—30 дней назад", "internal", "crypta_segment-ea60cd23_name", "crypta_segment-ea60cd23_description", "all", "", "549", "1269", "", "", "internal_ad" ],
    [ 2499981513, 2499980090, "Пользуются охватными продуктами, но не пользуются аудио", "internal", "crypta_segment-02c99c8b_name", "crypta_segment-02c99c8b_description", "all", "", "557", "12859987", "", "", "internal_ad" ],
    [ 2499981514, 2499980090, "Представители малого и среднего бизнеса без пользователей Директа", "internal", "crypta_segment-17c51a45_name", "crypta_segment-17c51a45_description", "all", "", "557", "12860383", "", "", "internal_ad" ],
    [ 2499981515, 2499980090, "Пользователи Директа", "internal", "crypta_segment-1abdd77a_name", "crypta_segment-1abdd77a_description", "all", "", "549", "1631", "", "", "internal_ad" ],
    [ 2499981516, 2499980090, "Владельцы бизнеса для новогоднего промо", "internal", "crypta_segment-589176a8_name", "crypta_segment-589176a8_description", "all", "", "557", "12050557", "", "", "internal_ad" ],
    [ 2499981517, 2499980090, "Рекламируют домены соцсетей", "internal", "crypta_segment-64818a73_name", "crypta_segment-64818a73_description", "all", "", "557", "12585274", "", "", "internal_ad" ],
    [ 2499981518, 2499980090, "Видео CPC", "internal", "crypta_segment-655d8295_name", "crypta_segment-655d8295_description", "all", "", "549", "1278", "", "", "internal_ad" ],
    [ 2499981519, 2499980090, "Видео CPC", "internal", "crypta_segment-655d8295_name", "crypta_segment-655d8295_description", "all", "", "557", "12871066", "", "", "internal_ad" ],
    [ 2499981520, 2499980090, "Не используют Баннер в приложении Яндекс.Метро", "internal", "crypta_segment-7a33c83b_name", "crypta_segment-7a33c83b_description", "all", "", "557", "12597940", "", "", "internal_ad" ],
    [ 2499981521, 2499980090, "РСЯ", "internal", "crypta_segment-7d94bc9c_name", "crypta_segment-7d94bc9c_description", "all", "", "549", "1277", "", "", "internal_ad" ],
    [ 2499981522, 2499980090, "С бизнесом в социальных сетях", "internal", "crypta_segment-80004980_name", "crypta_segment-80004980_description", "all", "", "557", "12557785", "", "", "internal_ad" ],
    [ 2499981523, 2499980090, "Не пользуются Метрикой", "internal", "crypta_segment-acba0c09_name", "crypta_segment-acba0c09_description", "all", "", "557", "12597877", "", "", "internal_ad" ],
    [ 2499981524, 2499980090, "Не пользуются аудио-рекламой ", "internal", "crypta_segment-b4b4caa0_name", "crypta_segment-b4b4caa0_description", "all", "", "557", "12560353", "", "", "internal_ad" ],
    [ 2499981525, 2499980090, "Пользователи видео рекламы", "internal", "crypta_segment-c7156248_name", "crypta_segment-c7156248_description", "all", "", "546", "1403", "", "", "internal_ad" ],
    [ 2499981526, 2499980090, "Пользователи видео рекламы", "internal", "crypta_segment-c7156248_name", "crypta_segment-c7156248_description", "all", "", "557", "12461728", "", "", "internal_ad" ],
    [ 2499981527, 2499980090, "Ретаргетинг", "internal", "crypta_segment-e34eadce_name", "crypta_segment-e34eadce_description", "all", "", "549", "1276", "", "", "internal_ad" ],
    [ 2499981528, 2499980091, "Смотрели Тимура Сидельникова на Эфире", "internal", "crypta_segment-016640b2_name", "crypta_segment-016640b2_description", "all", "", "557", "12946723", "", "", "internal_ad" ],
    [ 2499981529, 2499980091, "Интересуются wylsacom", "internal", "crypta_segment-117919ee_name", "crypta_segment-117919ee_description", "all", "", "557", "12948157", "", "", "internal_ad" ],
    [ 2499981530, 2499980091, "Интересуются обзорами машин", "internal", "crypta_segment-1e1b5d56_name", "crypta_segment-1e1b5d56_description", "all", "", "557", "12948661", "", "", "internal_ad" ],
    [ 2499981531, 2499980091, "Интересовались Юлией Высоцкой", "internal", "crypta_segment-38360022_name", "crypta_segment-38360022_description", "all", "", "557", "12945619", "", "", "internal_ad" ],
    [ 2499981532, 2499980091, "Слушают Katya Adushkin", "internal", "crypta_segment-3974147e_name", "crypta_segment-3974147e_description", "all", "", "557", "12941752", "", "", "internal_ad" ],
    [ 2499981533, 2499980091, "Интересуются Тимуром Сидельниковым", "internal", "crypta_segment-3be3acd2_name", "crypta_segment-3be3acd2_description", "all", "", "557", "12948406", "", "", "internal_ad" ],
    [ 2499981534, 2499980091, "Смотрели шоу \"Парфенон\"", "internal", "crypta_segment-42c294c7_name", "crypta_segment-42c294c7_description", "all", "", "549", "1229", "", "", "internal_ad" ],
    [ 2499981535, 2499980091, "Смотрели шоу \"Парфенон\"", "internal", "crypta_segment-42c294c7_name", "crypta_segment-42c294c7_description", "all", "", "546", "1251", "", "", "internal_ad" ],
    [ 2499981536, 2499980091, "Интересуются Дудем", "internal", "crypta_segment-448330a5_name", "crypta_segment-448330a5_description", "all", "", "557", "12941623", "", "", "internal_ad" ],
    [ 2499981537, 2499980091, "Интересуются Эдуардом Мацаберидзе", "internal", "crypta_segment-46e961e6_name", "crypta_segment-46e961e6_description", "all", "", "549", "1385", "", "", "internal_ad" ],
    [ 2499981538, 2499980091, "Интересуются Эдуардом Мацаберидзе", "internal", "crypta_segment-46e961e6_name", "crypta_segment-46e961e6_description", "all", "", "557", "12248227", "", "", "internal_ad" ],
    [ 2499981539, 2499980091, "Интересуются тревел шоу", "internal", "crypta_segment-4a29644b_name", "crypta_segment-4a29644b_description", "all", "", "549", "1384", "", "", "internal_ad" ],
    [ 2499981540, 2499980091, "Интересуются тревел шоу", "internal", "crypta_segment-4a29644b_name", "crypta_segment-4a29644b_description", "all", "", "557", "12248236", "", "", "internal_ad" ],
    [ 2499981541, 2499980091, "Смотрели FEDUK / LAB c Антоном Беляевым", "internal", "crypta_segment-59992d8a_name", "crypta_segment-59992d8a_description", "all", "", "557", "12627781", "", "", "internal_ad" ],
    [ 2499981542, 2499980091, "Смотрели FEDUK / LAB c Антоном Беляевым", "internal", "crypta_segment-59992d8a_name", "crypta_segment-59992d8a_description", "all", "", "549", "1620", "", "", "internal_ad" ],
    [ 2499981543, 2499980091, "Смотрели ЕвгенБро на Эфире", "internal", "crypta_segment-59b35807_name", "crypta_segment-59b35807_description", "all", "", "557", "12946714", "", "", "internal_ad" ],
    [ 2499981544, 2499980091, "Интересуются дорамами", "internal", "crypta_segment-5e336be3_name", "crypta_segment-5e336be3_description", "all", "", "557", "11706457", "", "", "internal_ad" ],
    [ 2499981545, 2499980091, "Интересуются дорамами", "internal", "crypta_segment-5e336be3_name", "crypta_segment-5e336be3_description", "all", "", "549", "1306", "", "", "internal_ad" ],
    [ 2499981546, 2499980091, "Интересуются AcademeG", "internal", "crypta_segment-65833e69_name", "crypta_segment-65833e69_description", "all", "", "557", "12948127", "", "", "internal_ad" ],
    [ 2499981547, 2499980091, "Смотрели Монеточка / LAB c Антоном Беляевым", "internal", "crypta_segment-663993cc_name", "crypta_segment-663993cc_description", "all", "", "549", "1618", "", "", "internal_ad" ],
    [ 2499981548, 2499980091, "Смотрели Монеточка / LAB c Антоном Беляевым", "internal", "crypta_segment-663993cc_name", "crypta_segment-663993cc_description", "all", "", "557", "12627793", "", "", "internal_ad" ],
    [ 2499981549, 2499980091, "Интересуются Владом Бумагой", "internal", "crypta_segment-68968c99_name", "crypta_segment-68968c99_description", "all", "", "557", "12941911", "", "", "internal_ad" ],
    [ 2499981550, 2499980091, "Интересуются видео про Майнкрафт", "internal", "crypta_segment-6934a8e4_name", "crypta_segment-6934a8e4_description", "all", "", "557", "12948652", "", "", "internal_ad" ],
    [ 2499981551, 2499980091, "Интересуются Аид [VyacheslavOO]", "internal", "crypta_segment-6aa22a45_name", "crypta_segment-6aa22a45_description", "all", "", "557", "12948184", "", "", "internal_ad" ],
    [ 2499981552, 2499980091, "Интересуются познавательными шоу", "internal", "crypta_segment-74750239_name", "crypta_segment-74750239_description", "all", "", "557", "12248230", "", "", "internal_ad" ],
    [ 2499981553, 2499980091, "Интересуются познавательными шоу", "internal", "crypta_segment-74750239_name", "crypta_segment-74750239_description", "all", "", "549", "1387", "", "", "internal_ad" ],
    [ 2499981554, 2499980091, "Смотрят НХЛ", "internal", "crypta_segment-771eb883_name", "crypta_segment-771eb883_description", "all", "", "549", "1279", "", "", "internal_ad" ],
    [ 2499981555, 2499980091, "Смотрят НХЛ", "internal", "crypta_segment-771eb883_name", "crypta_segment-771eb883_description", "all", "", "557", "11437105", "", "", "internal_ad" ],
    [ 2499981556, 2499980091, "Смотрели Юлию Высоцкую на Эфире", "internal", "crypta_segment-7828782e_name", "crypta_segment-7828782e_description", "all", "", "557", "12946729", "", "", "internal_ad" ],
    [ 2499981557, 2499980091, "Смотрели шоу \"«Не вопрос» с Тимуром Родригезом\"", "internal", "crypta_segment-81a37177_name", "crypta_segment-81a37177_description", "all", "", "549", "1616", "", "", "internal_ad" ],
    [ 2499981558, 2499980091, "Смотрели шоу \"«Не вопрос» с Тимуром Родригезом\"", "internal", "crypta_segment-81a37177_name", "crypta_segment-81a37177_description", "all", "", "557", "12627763", "", "", "internal_ad" ],
    [ 2499981559, 2499980091, "Смотрели Jah Khalib / LAB c Антоном Беляевым", "internal", "crypta_segment-84ccd7a8_name", "crypta_segment-84ccd7a8_description", "all", "", "549", "1619", "", "", "internal_ad" ],
    [ 2499981560, 2499980091, "Смотрели Jah Khalib / LAB c Антоном Беляевым", "internal", "crypta_segment-84ccd7a8_name", "crypta_segment-84ccd7a8_description", "all", "", "557", "12627787", "", "", "internal_ad" ],
    [ 2499981561, 2499980091, "Интересуются Тимуром Родригезом", "internal", "crypta_segment-86ea140b_name", "crypta_segment-86ea140b_description", "all", "", "549", "1383", "", "", "internal_ad" ],
    [ 2499981562, 2499980091, "Интересуются Тимуром Родригезом", "internal", "crypta_segment-86ea140b_name", "crypta_segment-86ea140b_description", "all", "", "557", "12248224", "", "", "internal_ad" ],
    [ 2499981563, 2499980091, "Интересуются обзорами технических новинок", "internal", "crypta_segment-9684cc98_name", "crypta_segment-9684cc98_description", "all", "", "557", "12948667", "", "", "internal_ad" ],
    [ 2499981564, 2499980091, "Смотрели Влада Бумагу на Эфире", "internal", "crypta_segment-9a5175c2_name", "crypta_segment-9a5175c2_description", "all", "", "557", "12946711", "", "", "internal_ad" ],
    [ 2499981565, 2499980091, "Интересуются Сашей Спилберг", "internal", "crypta_segment-a0cdb895_name", "crypta_segment-a0cdb895_description", "all", "", "557", "12945559", "", "", "internal_ad" ],
    [ 2499981566, 2499980091, "Смотрели шоу \"Такая история\"", "internal", "crypta_segment-a3142b0b_name", "crypta_segment-a3142b0b_description", "all", "", "546", "1252", "", "", "internal_ad" ],
    [ 2499981567, 2499980091, "Смотрели шоу \"Такая история\"", "internal", "crypta_segment-a3142b0b_name", "crypta_segment-a3142b0b_description", "all", "", "557", "12256219", "", "", "internal_ad" ],
    [ 2499981568, 2499980091, "Смотрели шоу \"Такая история\"", "internal", "crypta_segment-a3142b0b_name", "crypta_segment-a3142b0b_description", "all", "", "549", "1228", "", "", "internal_ad" ],
    [ 2499981569, 2499980091, "Смотрели Адушкину на Эфире", "internal", "crypta_segment-a594da66_name", "crypta_segment-a594da66_description", "all", "", "557", "12946702", "", "", "internal_ad" ],
    [ 2499981570, 2499980091, "Интересуются КраСавой", "internal", "crypta_segment-a7142516_name", "crypta_segment-a7142516_description", "all", "", "557", "12948313", "", "", "internal_ad" ],
    [ 2499981571, 2499980091, "Интересуются Ксенией Собчак", "internal", "crypta_segment-abbd0dec_name", "crypta_segment-abbd0dec_description", "all", "", "557", "12248263", "", "", "internal_ad" ],
    [ 2499981572, 2499980091, "Интересуются Ксенией Собчак", "internal", "crypta_segment-abbd0dec_name", "crypta_segment-abbd0dec_description", "all", "", "549", "1266", "", "", "internal_ad" ],
    [ 2499981573, 2499980091, "Смотрели обзоры машин на авто.ру", "internal", "crypta_segment-adaea1dd_name", "crypta_segment-adaea1dd_description", "all", "", "557", "12949306", "", "", "internal_ad" ],
    [ 2499981574, 2499980091, "Интересуются Павлом Деревянко", "internal", "crypta_segment-adc192bb_name", "crypta_segment-adc192bb_description", "all", "", "557", "12248215", "", "", "internal_ad" ],
    [ 2499981575, 2499980091, "Интересуются Павлом Деревянко", "internal", "crypta_segment-adc192bb_name", "crypta_segment-adc192bb_description", "all", "", "549", "1386", "", "", "internal_ad" ],
    [ 2499981576, 2499980091, "Смотрели шоу \"Елки-моталки\"", "internal", "crypta_segment-c7ded118_name", "crypta_segment-c7ded118_description", "all", "", "557", "12627772", "", "", "internal_ad" ],
    [ 2499981577, 2499980091, "Смотрели шоу \"Елки-моталки\"", "internal", "crypta_segment-c7ded118_name", "crypta_segment-c7ded118_description", "all", "", "549", "1615", "", "", "internal_ad" ],
    [ 2499981578, 2499980091, "Смотрели вДудь на Эфире", "internal", "crypta_segment-d5d50a8a_name", "crypta_segment-d5d50a8a_description", "all", "", "557", "12946732", "", "", "internal_ad" ],
    [ 2499981579, 2499980091, "Смотрели шоу \"Просто о сложном\"", "internal", "crypta_segment-d717d2ad_name", "crypta_segment-d717d2ad_description", "all", "", "557", "12627775", "", "", "internal_ad" ],
    [ 2499981580, 2499980091, "Смотрели шоу \"Просто о сложном\"", "internal", "crypta_segment-d717d2ad_name", "crypta_segment-d717d2ad_description", "all", "", "549", "1617", "", "", "internal_ad" ],
    [ 2499981581, 2499980091, "Смотрели AcademeG на Эфире", "internal", "crypta_segment-de855b83_name", "crypta_segment-de855b83_description", "all", "", "557", "12946696", "", "", "internal_ad" ],
    [ 2499981582, 2499980091, "Смотрели Сашу Спилберг на Эфире", "internal", "crypta_segment-e140beed_name", "crypta_segment-e140beed_description", "all", "", "557", "12946720", "", "", "internal_ad" ],
    [ 2499981583, 2499980091, "Смотрели КраСава на Эфире", "internal", "crypta_segment-e35b5620_name", "crypta_segment-e35b5620_description", "all", "", "557", "12946717", "", "", "internal_ad" ],
    [ 2499981584, 2499980091, "Интересуются ЕвгенБро", "internal", "crypta_segment-e5679629_name", "crypta_segment-e5679629_description", "all", "", "557", "12948289", "", "", "internal_ad" ],
    [ 2499981585, 2499980091, "Смотрели Полина Гагарина / LAB c Антоном Беляевым", "internal", "crypta_segment-e89a5873_name", "crypta_segment-e89a5873_description", "all", "", "549", "1621", "", "", "internal_ad" ],
    [ 2499981586, 2499980091, "Смотрели Полина Гагарина / LAB c Антоном Беляевым", "internal", "crypta_segment-e89a5873_name", "crypta_segment-e89a5873_description", "all", "", "557", "12627796", "", "", "internal_ad" ],
    [ 2499981587, 2499980091, "Смотрели Аид [VyacheslavOO] на Эфире", "internal", "crypta_segment-eb703a26_name", "crypta_segment-eb703a26_description", "all", "", "557", "12946705", "", "", "internal_ad" ],
    [ 2499981588, 2499980091, "Интересуются Катей Адушкиной", "internal", "crypta_segment-eec9070a_name", "crypta_segment-eec9070a_description", "all", "", "557", "12941869", "", "", "internal_ad" ],
    [ 2499981589, 2499980093, "Интересуются брендами ценовой категории выше среднего", "internal", "crypta_segment-616d031b_name", "crypta_segment-616d031b_description", "all", "", "281", "277", "", "", "internal_ad" ],
    [ 2499981590, 2499980093, "Интересуются брендами ценовой категории выше среднего", "internal", "crypta_segment-616d031b_name", "crypta_segment-616d031b_description", "all", "", "557", "5991403", "", "", "internal_ad" ],
    [ 2499981591, 2499980093, "Интересуются брендами средней ценовой категории", "internal", "crypta_segment-69794b17_name", "crypta_segment-69794b17_description", "all", "", "281", "276", "", "", "internal_ad" ],
    [ 2499981592, 2499980093, "Интересуются брендами средней ценовой категории", "internal", "crypta_segment-69794b17_name", "crypta_segment-69794b17_description", "all", "", "557", "5991400", "", "", "internal_ad" ],
    [ 2499981593, 2499980093, "Интересуются брендами высокой ценовой категории", "internal", "crypta_segment-9a8de03b_name", "crypta_segment-9a8de03b_description", "all", "", "281", "278", "", "", "internal_ad" ],
    [ 2499981594, 2499980093, "Интересуются брендами высокой ценовой категории", "internal", "crypta_segment-9a8de03b_name", "crypta_segment-9a8de03b_description", "all", "", "557", "5991406", "", "", "internal_ad" ],
    [ 2499981595, 2499980093, "Интересуются брендами низкой ценовой категории", "internal", "crypta_segment-aa93b915_name", "crypta_segment-aa93b915_description", "all", "", "281", "275", "", "", "internal_ad" ],
    [ 2499981596, 2499980093, "Интересуются брендами низкой ценовой категории", "internal", "crypta_segment-aa93b915_name", "crypta_segment-aa93b915_description", "all", "", "557", "5991397", "", "", "internal_ad" ],
    [ 2499981597, 2499980093, "Интересуются спортивными брендами", "internal", "crypta_segment-c02926a8_name", "crypta_segment-c02926a8_description", "all", "", "281", "279", "", "", "internal_ad" ],
    [ 2499981598, 2499980093, "Интересуются спортивными брендами", "internal", "crypta_segment-c02926a8_name", "crypta_segment-c02926a8_description", "all", "", "557", "5991409", "", "", "internal_ad" ],
    [ 2499981599, 2499980094, "Кино (для нотифайки)", "internal", "crypta_segment-573421c0_name", "crypta_segment-573421c0_description", "all", "", "549", "1401", "", "", "internal_ad" ],
    [ 2499981600, 2499980094, "Театр (для нотифайки)", "internal", "crypta_segment-dbb336b9_name", "crypta_segment-dbb336b9_description", "all", "", "549", "1402", "", "", "internal_ad" ],
    [ 2499981601, 2499980095, "Успешные мужчины", "internal", "crypta_segment-3720ac6b_name", "crypta_segment-3720ac6b_description", "all", "", "546", "1304", "", "", "internal_ad" ],
    [ 2499981602, 2499980095, "Успешные мужчины", "internal", "crypta_segment-3720ac6b_name", "crypta_segment-3720ac6b_description", "all", "", "557", "12050164", "", "", "internal_ad" ],
    [ 2499981603, 2499980095, "Региональная молодёжь", "internal", "crypta_segment-4936d298_name", "crypta_segment-4936d298_description", "all", "", "557", "12050161", "", "", "internal_ad" ],
    [ 2499981604, 2499980095, "Региональная молодёжь", "internal", "crypta_segment-4936d298_name", "crypta_segment-4936d298_description", "all", "", "546", "1300", "", "", "internal_ad" ],
    [ 2499981605, 2499980095, "Посетители корзины на Aliexpress", "internal", "crypta_segment-54ba41d4_name", "crypta_segment-54ba41d4_description", "all", "", "281", "196", "", "", "internal_ad" ],
    [ 2499981606, 2499980095, "Посетители корзины на Aliexpress", "internal", "crypta_segment-54ba41d4_name", "crypta_segment-54ba41d4_description", "all", "", "557", "2640669", "", "", "internal_ad" ],
    [ 2499981607, 2499980095, "Возрастные консерваторы", "internal", "crypta_segment-5b8ded9d_name", "crypta_segment-5b8ded9d_description", "all", "", "557", "12050149", "", "", "internal_ad" ],
    [ 2499981608, 2499980095, "Возрастные консерваторы", "internal", "crypta_segment-5b8ded9d_name", "crypta_segment-5b8ded9d_description", "all", "", "546", "1305", "", "", "internal_ad" ],
    [ 2499981609, 2499980095, "Активные женщины", "internal", "crypta_segment-60d2b245_name", "crypta_segment-60d2b245_description", "all", "", "557", "12050146", "", "", "internal_ad" ],
    [ 2499981610, 2499980095, "Активные женщины", "internal", "crypta_segment-60d2b245_name", "crypta_segment-60d2b245_description", "all", "", "546", "1303", "", "", "internal_ad" ],
    [ 2499981611, 2499980095, "Ищут кино и сериалы онлайн", "internal", "crypta_segment-b298e062_name", "crypta_segment-b298e062_description", "all", "", "557", "12150949", "", "", "internal_ad" ],
    [ 2499981612, 2499980095, "Активно покупают в интернете", "internal", "crypta_segment-ba3e75d0_name", "crypta_segment-ba3e75d0_description", "all", "", "549", "1199", "", "", "internal_ad" ],
    [ 2499981613, 2499980095, "Продвинутая молодёжь", "internal", "crypta_segment-dc5b5d00_name", "crypta_segment-dc5b5d00_description", "all", "", "546", "1302", "", "", "internal_ad" ],
    [ 2499981614, 2499980095, "Продвинутая молодёжь", "internal", "crypta_segment-dc5b5d00_name", "crypta_segment-dc5b5d00_description", "all", "", "557", "12050158", "", "", "internal_ad" ],
    [ 2499981615, 2499980095, "Мужчины-ремесленники", "internal", "crypta_segment-e0d7bab7_name", "crypta_segment-e0d7bab7_description", "all", "", "557", "12050155", "", "", "internal_ad" ],
    [ 2499981616, 2499980095, "Мужчины-ремесленники", "internal", "crypta_segment-e0d7bab7_name", "crypta_segment-e0d7bab7_description", "all", "", "546", "1301", "", "", "internal_ad" ],
    [ 2499981617, 2499980095, "Мамочки", "internal", "crypta_segment-e993c896_name", "crypta_segment-e993c896_description", "all", "", "557", "12050152", "", "", "internal_ad" ],
    [ 2499981618, 2499980095, "Мамочки", "internal", "crypta_segment-e993c896_name", "crypta_segment-e993c896_description", "all", "", "546", "1299", "", "", "internal_ad" ],
    [ 2499981619, 2499980096, "Автосервисы", "internal", "crypta_segment-visited-car-service_name", "crypta_segment-visited-car-service_description", "all", "", "547", "1070", "", "", "internal_ad" ],
    [ 2499981620, 2499980096, "Продажа автомобилей", "internal", "crypta_segment-visited-cars-sales_name", "crypta_segment-visited-cars-sales_description", "all", "", "557", "11869636", "", "", "internal_ad" ],
    [ 2499981621, 2499980096, "Продажа автомобилей", "internal", "crypta_segment-visited-cars-sales_name", "crypta_segment-visited-cars-sales_description", "all", "", "547", "1067", "", "", "internal_ad" ],
    [ 2499981622, 2499980096, "Заправки и автостоянки", "internal", "crypta_segment-visited-fuel-parking_name", "crypta_segment-visited-fuel-parking_description", "all", "", "557", "11527288", "", "", "internal_ad" ],
    [ 2499981623, 2499980096, "Заправки и автостоянки", "internal", "crypta_segment-visited-fuel-parking_name", "crypta_segment-visited-fuel-parking_description", "all", "", "547", "1068", "", "", "internal_ad" ],
    [ 2499981624, 2499980096, "Магазины запчастей", "internal", "crypta_segment-visited-parts-shops_name", "crypta_segment-visited-parts-shops_description", "all", "", "547", "1069", "", "", "internal_ad" ],
    [ 2499981625, 2499980097, "Фитнес и йога", "internal", "crypta_segment-visited-fitness-yoga_name", "crypta_segment-visited-fitness-yoga_description", "all", "", "547", "1092", "", "", "internal_ad" ],
    [ 2499981626, 2499980097, "Спортивные сооружения", "internal", "crypta_segment-visited-sport-objects_name", "crypta_segment-visited-sport-objects_description", "all", "", "547", "1091", "", "", "internal_ad" ],
    [ 2499981627, 2499980097, "Магазины спортивных товаров", "internal", "crypta_segment-visited-sports-shops_name", "crypta_segment-visited-sports-shops_description", "all", "", "547", "1094", "", "", "internal_ad" ],
    [ 2499981628, 2499980097, "Водный спорт", "internal", "crypta_segment-visited-water-sports_name", "crypta_segment-visited-water-sports_description", "all", "", "547", "1093", "", "", "internal_ad" ],
    [ 2499981629, 2499980098, "Цирки", "internal", "crypta_segment-32b18ad0_name", "crypta_segment-32b18ad0_description", "all", "", "547", "1263", "", "", "internal_ad" ],
    [ 2499981630, 2499980098, "Цирки", "internal", "crypta_segment-32b18ad0_name", "crypta_segment-32b18ad0_description", "all", "", "557", "11706466", "", "", "internal_ad" ],
    [ 2499981631, 2499980098, "Развлекательные комплексы и игротеки для детей", "internal", "crypta_segment-4e27e523_name", "crypta_segment-4e27e523_description", "all", "", "547", "1264", "", "", "internal_ad" ],
    [ 2499981632, 2499980098, "Развлекательные комплексы и игротеки для детей", "internal", "crypta_segment-4e27e523_name", "crypta_segment-4e27e523_description", "all", "", "557", "11706469", "", "", "internal_ad" ],
    [ 2499981633, 2499980098, "Парки аттракционов", "internal", "crypta_segment-697486a3_name", "crypta_segment-697486a3_description", "all", "", "557", "11706475", "", "", "internal_ad" ],
    [ 2499981634, 2499980098, "Парки аттракционов", "internal", "crypta_segment-697486a3_name", "crypta_segment-697486a3_description", "all", "", "547", "1265", "", "", "internal_ad" ],
    [ 2499981635, 2499980098, "Бары", "internal", "crypta_segment-visited-bars_name", "crypta_segment-visited-bars_description", "all", "", "547", "1098", "", "", "internal_ad" ],
    [ 2499981636, 2499980098, "Бани и сауны", "internal", "crypta_segment-visited-bathhouses_name", "crypta_segment-visited-bathhouses_description", "all", "", "547", "1100", "", "", "internal_ad" ],
    [ 2499981637, 2499980098, "Развлекательные центры", "internal", "crypta_segment-visited-entertainment-centers_name", "crypta_segment-visited-entertainment-centers_description", "all", "", "547", "1104", "", "", "internal_ad" ],
    [ 2499981638, 2499980098, "Кальянные", "internal", "crypta_segment-visited-hookah-bars_name", "crypta_segment-visited-hookah-bars_description", "all", "", "547", "1099", "", "", "internal_ad" ],
    [ 2499981639, 2499980098, "Музеи", "internal", "crypta_segment-visited-museums_name", "crypta_segment-visited-museums_description", "all", "", "547", "1097", "", "", "internal_ad" ],
    [ 2499981640, 2499980098, "Ночные клубы", "internal", "crypta_segment-visited-night-clubs_name", "crypta_segment-visited-night-clubs_description", "all", "", "547", "1103", "", "", "internal_ad" ],
    [ 2499981641, 2499980098, "Парки", "internal", "crypta_segment-visited-parks_name", "crypta_segment-visited-parks_description", "all", "", "547", "1102", "", "", "internal_ad" ],
    [ 2499981642, 2499980098, "Театры", "internal", "crypta_segment-visited-theaters_name", "crypta_segment-visited-theaters_description", "all", "", "547", "1096", "", "", "internal_ad" ],
    [ 2499981643, 2499980098, "Зоопарки, дельфинарии, океанариумы", "internal", "crypta_segment-visited-zoos_name", "crypta_segment-visited-zoos_description", "all", "", "547", "1101", "", "", "internal_ad" ],
    [ 2499981644, 2499980098, "Кинотеатры", "internal", "crypta_segment-visited-сinemas_name", "crypta_segment-visited-сinemas_description", "all", "", "547", "1095", "", "", "internal_ad" ],
    [ 2499981645, 2499980098, "Кинотеатры", "internal", "crypta_segment-visited-сinemas_name", "crypta_segment-visited-сinemas_description", "all", "", "557", "11146390", "", "", "internal_ad" ],
    [ 2499981646, 2499980099, "Банки и банкоматы", "internal", "crypta_segment-visited-bank-service_name", "crypta_segment-visited-bank-service_description", "all", "", "547", "1081", "", "", "internal_ad" ],
    [ 2499981647, 2499980099, "Суды", "internal", "crypta_segment-visited-courts-service_name", "crypta_segment-visited-courts-service_description", "all", "", "547", "1083", "", "", "internal_ad" ],
    [ 2499981648, 2499980099, "Юридические услуги", "internal", "crypta_segment-visited-legal-service_name", "crypta_segment-visited-legal-service_description", "all", "", "547", "1082", "", "", "internal_ad" ],
    [ 2499981649, 2499980099, "Почтовые и курьерские службы", "internal", "crypta_segment-visited-post-service_name", "crypta_segment-visited-post-service_description", "all", "", "547", "1080", "", "", "internal_ad" ],
    [ 2499981650, 2499980099, "Уход за внешностью", "internal", "crypta_segment-visited-selfcare-service_name", "crypta_segment-visited-selfcare-service_description", "all", "", "547", "1079", "", "", "internal_ad" ],
    [ 2499981651, 2499980100, "Продажа и аренда коммерческой недвижимости", "internal", "crypta_segment-visited-commercial-property_name", "crypta_segment-visited-commercial-property_description", "all", "", "547", "1114", "", "", "internal_ad" ],
    [ 2499981652, 2499980100, "Офисы продаж квартир в новостройках", "internal", "crypta_segment-visited-new-apartments_name", "crypta_segment-visited-new-apartments_description", "all", "", "547", "1115", "", "", "internal_ad" ],
    [ 2499981653, 2499980100, "Офисы продаж квартир в новостройках", "internal", "crypta_segment-visited-new-apartments_name", "crypta_segment-visited-new-apartments_description", "all", "", "557", "11870818", "", "", "internal_ad" ],
    [ 2499981654, 2499980100, "Агентства недвижимости", "internal", "crypta_segment-visited-property-agencies_name", "crypta_segment-visited-property-agencies_description", "all", "", "557", "11870824", "", "", "internal_ad" ],
    [ 2499981655, 2499980100, "Агентства недвижимости", "internal", "crypta_segment-visited-property-agencies_name", "crypta_segment-visited-property-agencies_description", "all", "", "547", "1116", "", "", "internal_ad" ],
    [ 2499981656, 2499980100, "Ремонт, отделка, стройматериалы, проектирование", "internal", "crypta_segment-visited-repairs_name", "crypta_segment-visited-repairs_description", "all", "", "547", "1113", "", "", "internal_ad" ],
    [ 2499981657, 2499980101, "Дополнительное образование", "internal", "crypta_segment-visited-additional-education_name", "crypta_segment-visited-additional-education_description", "all", "", "547", "1110", "", "", "internal_ad" ],
    [ 2499981658, 2499980101, "Высшее образование", "internal", "crypta_segment-visited-higher-education_name", "crypta_segment-visited-higher-education_description", "all", "", "547", "1111", "", "", "internal_ad" ],
    [ 2499981659, 2499980101, "Детские сады", "internal", "crypta_segment-visited-kindergartens_name", "crypta_segment-visited-kindergartens_description", "all", "", "547", "1108", "", "", "internal_ad" ],
    [ 2499981660, 2499980101, "Школы", "internal", "crypta_segment-visited-schools_name", "crypta_segment-visited-schools_description", "all", "", "547", "1109", "", "", "internal_ad" ],
    [ 2499981661, 2499980101, "Среднее специальное образование", "internal", "crypta_segment-visited-special-education_name", "crypta_segment-visited-special-education_description", "all", "", "547", "1112", "", "", "internal_ad" ],
    [ 2499981662, 2499980102, "Табачные магазины", "internal", "crypta_segment-b5815171_name", "crypta_segment-b5815171_description", "all", "", "547", "1321", "", "", "internal_ad" ],
    [ 2499981663, 2499980102, "Магазины алкоголя", "internal", "crypta_segment-visited-alco-shops_name", "crypta_segment-visited-alco-shops_description", "all", "", "547", "1077", "", "", "internal_ad" ],
    [ 2499981664, 2499980102, "Магазины бытовой техники", "internal", "crypta_segment-visited-appliances-shops_name", "crypta_segment-visited-appliances-shops_description", "all", "", "557", "11436391", "", "", "internal_ad" ],
    [ 2499981665, 2499980102, "Магазины бытовой техники", "internal", "crypta_segment-visited-appliances-shops_name", "crypta_segment-visited-appliances-shops_description", "all", "", "547", "1075", "", "", "internal_ad" ],
    [ 2499981666, 2499980102, "Магазины детских товаров", "internal", "crypta_segment-visited-children-shops_name", "crypta_segment-visited-children-shops_description", "all", "", "557", "12117319", "", "", "internal_ad" ],
    [ 2499981667, 2499980102, "Магазины детских товаров", "internal", "crypta_segment-visited-children-shops_name", "crypta_segment-visited-children-shops_description", "all", "", "547", "1074", "", "", "internal_ad" ],
    [ 2499981668, 2499980102, "Магазины одежды, обуви, аксессуаров", "internal", "crypta_segment-visited-clothes-shops_name", "crypta_segment-visited-clothes-shops_description", "all", "", "547", "1072", "", "", "internal_ad" ],
    [ 2499981669, 2499980102, "Магазины компьютеров", "internal", "crypta_segment-visited-computer-shops_name", "crypta_segment-visited-computer-shops_description", "all", "", "547", "1071", "", "", "internal_ad" ],
    [ 2499981670, 2499980102, "Магазины мебели и предметов интерьера", "internal", "crypta_segment-visited-furniture-shops_name", "crypta_segment-visited-furniture-shops_description", "all", "", "547", "1073", "", "", "internal_ad" ],
    [ 2499981671, 2499980102, "Магазины для домашних животных и ветеринария", "internal", "crypta_segment-visited-pet-shops_name", "crypta_segment-visited-pet-shops_description", "all", "", "547", "1078", "", "", "internal_ad" ],
    [ 2499981672, 2499980103, "Кафе", "internal", "crypta_segment-visited-cafes-houses_name", "crypta_segment-visited-cafes-houses_description", "all", "", "547", "1087", "", "", "internal_ad" ],
    [ 2499981673, 2499980103, "Столовые", "internal", "crypta_segment-visited-canteens-houses_name", "crypta_segment-visited-canteens-houses_description", "all", "", "547", "1089", "", "", "internal_ad" ],
    [ 2499981674, 2499980103, "Кофейни", "internal", "crypta_segment-visited-coffee-houses_name", "crypta_segment-visited-coffee-houses_description", "all", "", "547", "1086", "", "", "internal_ad" ],
    [ 2499981675, 2499980103, "Быстрое питание", "internal", "crypta_segment-visited-fastfood-houses_name", "crypta_segment-visited-fastfood-houses_description", "all", "", "547", "1088", "", "", "internal_ad" ],
    [ 2499981676, 2499980103, "Пиццерии", "internal", "crypta_segment-visited-pizzeria_name", "crypta_segment-visited-pizzeria_description", "all", "", "547", "1084", "", "", "internal_ad" ],
    [ 2499981677, 2499980103, "Рестораны", "internal", "crypta_segment-visited-restaurants_name", "crypta_segment-visited-restaurants_description", "all", "", "547", "1085", "", "", "internal_ad" ],
    [ 2499981678, 2499980103, "Японская кухня", "internal", "crypta_segment-visited-sushi-bars_name", "crypta_segment-visited-sushi-bars_description", "all", "", "547", "1090", "", "", "internal_ad" ],
    [ 2499981679, 2499980104, "Хостелы", "internal", "crypta_segment-visited-hostels_name", "crypta_segment-visited-hostels_description", "all", "", "547", "1107", "", "", "internal_ad" ],
    [ 2499981680, 2499980104, "Гостиницы", "internal", "crypta_segment-visited-hotels_name", "crypta_segment-visited-hotels_description", "all", "", "547", "1105", "", "", "internal_ad" ],
    [ 2499981681, 2499980104, "Санатории и дома отдыха", "internal", "crypta_segment-visited-resorts_name", "crypta_segment-visited-resorts_description", "all", "", "547", "1106", "", "", "internal_ad" ],
    [ 2499981682, 2499980105, "Уход после мытья волос", "internal", "crypta_segment-hair_care_products_name", "crypta_segment-hair_care_products_description", "all", "", "602", "313", "", "", "internal_ad" ],
    [ 2499981683, 2499980105, "Уход после мытья волос", "internal", "crypta_segment-hair_care_products_name", "crypta_segment-hair_care_products_description", "all", "", "601", "313", "", "", "internal_ad" ],
    [ 2499981684, 2499980105, "Окрашивание волос", "internal", "crypta_segment-hair_coloring_products_name", "crypta_segment-hair_coloring_products_description", "all", "", "601", "311", "", "", "internal_ad" ],
    [ 2499981685, 2499980105, "Окрашивание волос", "internal", "crypta_segment-hair_coloring_products_name", "crypta_segment-hair_coloring_products_description", "all", "", "602", "311", "", "", "internal_ad" ],
    [ 2499981686, 2499980105, "Шампуни для волос", "internal", "crypta_segment-hair_shampoos_name", "crypta_segment-hair_shampoos_description", "all", "", "601", "305", "", "", "internal_ad" ],
    [ 2499981687, 2499980105, "Шампуни для волос", "internal", "crypta_segment-hair_shampoos_name", "crypta_segment-hair_shampoos_description", "all", "", "602", "305", "", "", "internal_ad" ],
    [ 2499981688, 2499980105, "Укладка волос", "internal", "crypta_segment-hair_styling_name", "crypta_segment-hair_styling_description", "all", "", "602", "312", "", "", "internal_ad" ],
    [ 2499981689, 2499980105, "Укладка волос", "internal", "crypta_segment-hair_styling_name", "crypta_segment-hair_styling_description", "all", "", "601", "312", "", "", "internal_ad" ],
    [ 2499981690, 2499980106, "Мужская парфюмерия", "internal", "crypta_segment-mens_perfumes_name", "crypta_segment-mens_perfumes_description", "all", "", "601", "160", "", "", "internal_ad" ],
    [ 2499981691, 2499980106, "Мужская парфюмерия", "internal", "crypta_segment-mens_perfumes_name", "crypta_segment-mens_perfumes_description", "all", "", "602", "160", "", "", "internal_ad" ],
    [ 2499981692, 2499980106, "Женская парфюмерия", "internal", "crypta_segment-womens_perfumes_name", "crypta_segment-womens_perfumes_description", "all", "", "602", "188", "", "", "internal_ad" ],
    [ 2499981693, 2499980106, "Женская парфюмерия", "internal", "crypta_segment-womens_perfumes_name", "crypta_segment-womens_perfumes_description", "all", "", "601", "188", "", "", "internal_ad" ],
    [ 2499981694, 2499980107, "Лекарства от аллергии", "internal", "crypta_segment-954d319a_name", "crypta_segment-954d319a_description", "all", "", "602", "251", "", "", "internal_ad" ],
    [ 2499981695, 2499980107, "Лекарства от аллергии", "internal", "crypta_segment-954d319a_name", "crypta_segment-954d319a_description", "all", "", "601", "251", "", "", "internal_ad" ],
    [ 2499981696, 2499980107, "Лекарства от простуды и гриппа", "internal", "crypta_segment-bb246531_name", "crypta_segment-bb246531_description", "all", "", "602", "250", "", "", "internal_ad" ],
    [ 2499981697, 2499980107, "Лекарства от простуды и гриппа", "internal", "crypta_segment-bb246531_name", "crypta_segment-bb246531_description", "all", "", "601", "250", "", "", "internal_ad" ],
    [ 2499981698, 2499980107, "Контактные линзы", "internal", "crypta_segment-contact_lenses_name", "crypta_segment-contact_lenses_description", "all", "", "602", "181", "", "", "internal_ad" ],
    [ 2499981699, 2499980107, "Контактные линзы", "internal", "crypta_segment-contact_lenses_name", "crypta_segment-contact_lenses_description", "all", "", "601", "181", "", "", "internal_ad" ],
    [ 2499981700, 2499980107, "Диагностическое оборудование", "internal", "crypta_segment-diagnostic_equipment_name", "crypta_segment-diagnostic_equipment_description", "all", "", "601", "41", "", "", "internal_ad" ],
    [ 2499981701, 2499980107, "Диагностическое оборудование", "internal", "crypta_segment-diagnostic_equipment_name", "crypta_segment-diagnostic_equipment_description", "all", "", "602", "41", "", "", "internal_ad" ],
    [ 2499981702, 2499980108, "Декоративная косметика для глаз", "internal", "crypta_segment-eye_makeup_name", "crypta_segment-eye_makeup_description", "all", "", "602", "85", "", "", "internal_ad" ],
    [ 2499981703, 2499980108, "Декоративная косметика для глаз", "internal", "crypta_segment-eye_makeup_name", "crypta_segment-eye_makeup_description", "all", "", "601", "85", "", "", "internal_ad" ],
    [ 2499981704, 2499980108, "Декоративная косметика для лица", "internal", "crypta_segment-face_cosmetics_name", "crypta_segment-face_cosmetics_description", "all", "", "601", "65", "", "", "internal_ad" ],
    [ 2499981705, 2499980108, "Декоративная косметика для лица", "internal", "crypta_segment-face_cosmetics_name", "crypta_segment-face_cosmetics_description", "all", "", "602", "65", "", "", "internal_ad" ],
    [ 2499981706, 2499980108, "Декоративная косметика для губ", "internal", "crypta_segment-lips_cosmetics_name", "crypta_segment-lips_cosmetics_description", "all", "", "601", "138", "", "", "internal_ad" ],
    [ 2499981707, 2499980108, "Декоративная косметика для губ", "internal", "crypta_segment-lips_cosmetics_name", "crypta_segment-lips_cosmetics_description", "all", "", "602", "138", "", "", "internal_ad" ],
    [ 2499981708, 2499980108, "Декоративная косметика для ногтей", "internal", "crypta_segment-nails_cosmetics_name", "crypta_segment-nails_cosmetics_description", "all", "", "602", "156", "", "", "internal_ad" ],
    [ 2499981709, 2499980108, "Декоративная косметика для ногтей", "internal", "crypta_segment-nails_cosmetics_name", "crypta_segment-nails_cosmetics_description", "all", "", "601", "156", "", "", "internal_ad" ],
    [ 2499981710, 2499980109, "Сумки и чемоданы", "internal", "crypta_segment-bags_name", "crypta_segment-bags_description", "all", "", "601", "27", "", "", "internal_ad" ],
    [ 2499981711, 2499980109, "Сумки и чемоданы", "internal", "crypta_segment-bags_name", "crypta_segment-bags_description", "all", "", "602", "27", "", "", "internal_ad" ],
    [ 2499981712, 2499980109, "Очки", "internal", "crypta_segment-glasses_name", "crypta_segment-glasses_description", "all", "", "602", "105", "", "", "internal_ad" ],
    [ 2499981713, 2499980109, "Очки", "internal", "crypta_segment-glasses_name", "crypta_segment-glasses_description", "all", "", "601", "105", "", "", "internal_ad" ],
    [ 2499981714, 2499980109, "Ювелирные украшения", "internal", "crypta_segment-jewelry_name", "crypta_segment-jewelry_description", "all", "", "601", "304", "", "", "internal_ad" ],
    [ 2499981715, 2499980109, "Ювелирные украшения", "internal", "crypta_segment-jewelry_name", "crypta_segment-jewelry_description", "all", "", "602", "304", "", "", "internal_ad" ],
    [ 2499981716, 2499980109, "Часы", "internal", "crypta_segment-watches_name", "crypta_segment-watches_description", "all", "", "602", "206", "", "", "internal_ad" ],
    [ 2499981717, 2499980109, "Часы", "internal", "crypta_segment-watches_name", "crypta_segment-watches_description", "all", "", "601", "206", "", "", "internal_ad" ],
    [ 2499981718, 2499980110, "Детская обувь", "internal", "crypta_segment-childrens_shoes_name", "crypta_segment-childrens_shoes_description", "all", "", "602", "16", "", "", "internal_ad" ],
    [ 2499981719, 2499980110, "Детская обувь", "internal", "crypta_segment-childrens_shoes_name", "crypta_segment-childrens_shoes_description", "all", "", "601", "16", "", "", "internal_ad" ],
    [ 2499981720, 2499980110, "Мужская обувь", "internal", "crypta_segment-mens_shoes_name", "crypta_segment-mens_shoes_description", "all", "", "601", "200", "", "", "internal_ad" ],
    [ 2499981721, 2499980110, "Мужская обувь", "internal", "crypta_segment-mens_shoes_name", "crypta_segment-mens_shoes_description", "all", "", "602", "200", "", "", "internal_ad" ],
    [ 2499981722, 2499980110, "Спортивная обувь", "internal", "crypta_segment-sport_shoes_name", "crypta_segment-sport_shoes_description", "all", "", "602", "49", "", "", "internal_ad" ],
    [ 2499981723, 2499980110, "Спортивная обувь", "internal", "crypta_segment-sport_shoes_name", "crypta_segment-sport_shoes_description", "all", "", "601", "49", "", "", "internal_ad" ],
    [ 2499981724, 2499980110, "Женская обувь", "internal", "crypta_segment-womens_shoes_name", "crypta_segment-womens_shoes_description", "all", "", "601", "147", "", "", "internal_ad" ],
    [ 2499981725, 2499980110, "Женская обувь", "internal", "crypta_segment-womens_shoes_name", "crypta_segment-womens_shoes_description", "all", "", "602", "147", "", "", "internal_ad" ],
    [ 2499981726, 2499980111, "Детская одежда", "internal", "crypta_segment-baby_clothes_name", "crypta_segment-baby_clothes_description", "all", "", "602", "99", "", "", "internal_ad" ],
    [ 2499981727, 2499980111, "Детская одежда", "internal", "crypta_segment-baby_clothes_name", "crypta_segment-baby_clothes_description", "all", "", "601", "99", "", "", "internal_ad" ],
    [ 2499981728, 2499980111, "Одежда для малышей", "internal", "crypta_segment-clothes_for_babies_name", "crypta_segment-clothes_for_babies_description", "all", "", "601", "303", "", "", "internal_ad" ],
    [ 2499981729, 2499980111, "Одежда для малышей", "internal", "crypta_segment-clothes_for_babies_name", "crypta_segment-clothes_for_babies_description", "all", "", "602", "303", "", "", "internal_ad" ],
    [ 2499981730, 2499980111, "Мужская одежда", "internal", "crypta_segment-mens_clothing_name", "crypta_segment-mens_clothing_description", "all", "", "602", "220", "", "", "internal_ad" ],
    [ 2499981731, 2499980111, "Мужская одежда", "internal", "crypta_segment-mens_clothing_name", "crypta_segment-mens_clothing_description", "all", "", "601", "220", "", "", "internal_ad" ],
    [ 2499981732, 2499980111, "Верхняя одежда", "internal", "crypta_segment-outerwear_name", "crypta_segment-outerwear_description", "all", "", "602", "212", "", "", "internal_ad" ],
    [ 2499981733, 2499980111, "Верхняя одежда", "internal", "crypta_segment-outerwear_name", "crypta_segment-outerwear_description", "all", "", "601", "212", "", "", "internal_ad" ],
    [ 2499981734, 2499980111, "Спортивная одежда", "internal", "crypta_segment-sportswear_name", "crypta_segment-sportswear_description", "all", "", "601", "159", "", "", "internal_ad" ],
    [ 2499981735, 2499980111, "Спортивная одежда", "internal", "crypta_segment-sportswear_name", "crypta_segment-sportswear_description", "all", "", "602", "159", "", "", "internal_ad" ],
    [ 2499981736, 2499980111, "Женская одежда", "internal", "crypta_segment-womens_clothing_name", "crypta_segment-womens_clothing_description", "all", "", "601", "198", "", "", "internal_ad" ],
    [ 2499981737, 2499980111, "Женская одежда", "internal", "crypta_segment-womens_clothing_name", "crypta_segment-womens_clothing_description", "all", "", "602", "198", "", "", "internal_ad" ],
    [ 2499981738, 2499980112, "Освещение", "internal", "crypta_segment-1162a53a_name", "crypta_segment-1162a53a_description", "all", "", "602", "247", "", "", "internal_ad" ],
    [ 2499981739, 2499980112, "Освещение", "internal", "crypta_segment-1162a53a_name", "crypta_segment-1162a53a_description", "all", "", "601", "247", "", "", "internal_ad" ],
    [ 2499981740, 2499980112, "Ковры", "internal", "crypta_segment-3902bb23_name", "crypta_segment-3902bb23_description", "all", "", "602", "248", "", "", "internal_ad" ],
    [ 2499981741, 2499980112, "Ковры", "internal", "crypta_segment-3902bb23_name", "crypta_segment-3902bb23_description", "all", "", "601", "248", "", "", "internal_ad" ],
    [ 2499981742, 2499980112, "Текстиль", "internal", "crypta_segment-43757160_name", "crypta_segment-43757160_description", "all", "", "601", "245", "", "", "internal_ad" ],
    [ 2499981743, 2499980112, "Текстиль", "internal", "crypta_segment-43757160_name", "crypta_segment-43757160_description", "all", "", "602", "245", "", "", "internal_ad" ],
    [ 2499981744, 2499980112, "Посуда", "internal", "crypta_segment-e77e6bdb_name", "crypta_segment-e77e6bdb_description", "all", "", "601", "246", "", "", "internal_ad" ],
    [ 2499981745, 2499980112, "Посуда", "internal", "crypta_segment-e77e6bdb_name", "crypta_segment-e77e6bdb_description", "all", "", "602", "246", "", "", "internal_ad" ],
    [ 2499981746, 2499980113, "Мебель для ванной", "internal", "crypta_segment-bathroom_furniture_name", "crypta_segment-bathroom_furniture_description", "all", "", "602", "172", "", "", "internal_ad" ],
    [ 2499981747, 2499980113, "Мебель для ванной", "internal", "crypta_segment-bathroom_furniture_name", "crypta_segment-bathroom_furniture_description", "all", "", "601", "172", "", "", "internal_ad" ],
    [ 2499981748, 2499980113, "Мебель для спальни", "internal", "crypta_segment-bedroom_furniture_name", "crypta_segment-bedroom_furniture_description", "all", "", "601", "63", "", "", "internal_ad" ],
    [ 2499981749, 2499980113, "Мебель для спальни", "internal", "crypta_segment-bedroom_furniture_name", "crypta_segment-bedroom_furniture_description", "all", "", "602", "63", "", "", "internal_ad" ],
    [ 2499981750, 2499980113, "Кровати", "internal", "crypta_segment-beds_name", "crypta_segment-beds_description", "all", "", "601", "175", "", "", "internal_ad" ],
    [ 2499981751, 2499980113, "Кровати", "internal", "crypta_segment-beds_name", "crypta_segment-beds_description", "all", "", "602", "175", "", "", "internal_ad" ],
    [ 2499981752, 2499980113, "Шкафы", "internal", "crypta_segment-cabinets_name", "crypta_segment-cabinets_description", "all", "", "602", "22", "", "", "internal_ad" ],
    [ 2499981753, 2499980113, "Шкафы", "internal", "crypta_segment-cabinets_name", "crypta_segment-cabinets_description", "all", "", "601", "22", "", "", "internal_ad" ],
    [ 2499981754, 2499980113, "Стулья", "internal", "crypta_segment-chairs_name", "crypta_segment-chairs_description", "all", "", "602", "221", "", "", "internal_ad" ],
    [ 2499981755, 2499980113, "Стулья", "internal", "crypta_segment-chairs_name", "crypta_segment-chairs_description", "all", "", "601", "221", "", "", "internal_ad" ],
    [ 2499981756, 2499980113, "Мягкая мебель", "internal", "crypta_segment-cushioned_furniture_name", "crypta_segment-cushioned_furniture_description", "all", "", "601", "125", "", "", "internal_ad" ],
    [ 2499981757, 2499980113, "Мягкая мебель", "internal", "crypta_segment-cushioned_furniture_name", "crypta_segment-cushioned_furniture_description", "all", "", "602", "125", "", "", "internal_ad" ],
    [ 2499981758, 2499980113, "Мебель для прихожей", "internal", "crypta_segment-furniture_for_anteroom_name", "crypta_segment-furniture_for_anteroom_description", "all", "", "602", "134", "", "", "internal_ad" ],
    [ 2499981759, 2499980113, "Мебель для прихожей", "internal", "crypta_segment-furniture_for_anteroom_name", "crypta_segment-furniture_for_anteroom_description", "all", "", "601", "134", "", "", "internal_ad" ],
    [ 2499981760, 2499980113, "Мебель для детской", "internal", "crypta_segment-furniture_for_children_name", "crypta_segment-furniture_for_children_description", "all", "", "601", "149", "", "", "internal_ad" ],
    [ 2499981761, 2499980113, "Мебель для детской", "internal", "crypta_segment-furniture_for_children_name", "crypta_segment-furniture_for_children_description", "all", "", "602", "149", "", "", "internal_ad" ],
    [ 2499981762, 2499980113, "Мебель для кухни", "internal", "crypta_segment-furniture_for_kitchen_name", "crypta_segment-furniture_for_kitchen_description", "all", "", "601", "109", "", "", "internal_ad" ],
    [ 2499981763, 2499980113, "Мебель для кухни", "internal", "crypta_segment-furniture_for_kitchen_name", "crypta_segment-furniture_for_kitchen_description", "all", "", "602", "109", "", "", "internal_ad" ],
    [ 2499981764, 2499980113, "Мебель для гостиной", "internal", "crypta_segment-furniture_for_living_room_name", "crypta_segment-furniture_for_living_room_description", "all", "", "601", "126", "", "", "internal_ad" ],
    [ 2499981765, 2499980113, "Мебель для гостиной", "internal", "crypta_segment-furniture_for_living_room_name", "crypta_segment-furniture_for_living_room_description", "all", "", "602", "126", "", "", "internal_ad" ],
    [ 2499981766, 2499980113, "Матрасы", "internal", "crypta_segment-mattresses_name", "crypta_segment-mattresses_description", "all", "", "602", "152", "", "", "internal_ad" ],
    [ 2499981767, 2499980113, "Матрасы", "internal", "crypta_segment-mattresses_name", "crypta_segment-mattresses_description", "all", "", "601", "152", "", "", "internal_ad" ],
    [ 2499981768, 2499980113, "Мебель для офиса и кабинета", "internal", "crypta_segment-office_furniture_name", "crypta_segment-office_furniture_description", "all", "", "601", "171", "", "", "internal_ad" ],
    [ 2499981769, 2499980113, "Мебель для офиса и кабинета", "internal", "crypta_segment-office_furniture_name", "crypta_segment-office_furniture_description", "all", "", "602", "171", "", "", "internal_ad" ],
    [ 2499981770, 2499980113, "Столы", "internal", "crypta_segment-tables_name", "crypta_segment-tables_description", "all", "", "601", "168", "", "", "internal_ad" ],
    [ 2499981771, 2499980113, "Столы", "internal", "crypta_segment-tables_name", "crypta_segment-tables_description", "all", "", "602", "168", "", "", "internal_ad" ],
    [ 2499981772, 2499980114, "Садовая техника", "internal", "crypta_segment-garden_machinery_name", "crypta_segment-garden_machinery_description", "all", "", "602", "203", "", "", "internal_ad" ],
    [ 2499981773, 2499980114, "Садовая техника", "internal", "crypta_segment-garden_machinery_name", "crypta_segment-garden_machinery_description", "all", "", "601", "203", "", "", "internal_ad" ],
    [ 2499981774, 2499980114, "Садовый инвентарь", "internal", "crypta_segment-garden_tools_name", "crypta_segment-garden_tools_description", "all", "", "601", "110", "", "", "internal_ad" ],
    [ 2499981775, 2499980114, "Садовый инвентарь", "internal", "crypta_segment-garden_tools_name", "crypta_segment-garden_tools_description", "all", "", "602", "110", "", "", "internal_ad" ],
    [ 2499981776, 2499980114, "Растения и семена", "internal", "crypta_segment-plants_and_seeds_name", "crypta_segment-plants_and_seeds_description", "all", "", "602", "86", "", "", "internal_ad" ],
    [ 2499981777, 2499980114, "Растения и семена", "internal", "crypta_segment-plants_and_seeds_name", "crypta_segment-plants_and_seeds_description", "all", "", "601", "86", "", "", "internal_ad" ],
    [ 2499981778, 2499980115, "Электрические инструменты", "internal", "crypta_segment-7b147613_name", "crypta_segment-7b147613_description", "all", "", "602", "238", "", "", "internal_ad" ],
    [ 2499981779, 2499980115, "Электрические инструменты", "internal", "crypta_segment-7b147613_name", "crypta_segment-7b147613_description", "all", "", "601", "238", "", "", "internal_ad" ],
    [ 2499981780, 2499980115, "Строительные инструменты", "internal", "crypta_segment-building_tools_name", "crypta_segment-building_tools_description", "all", "", "601", "10", "", "", "internal_ad" ],
    [ 2499981781, 2499980115, "Строительные инструменты", "internal", "crypta_segment-building_tools_name", "crypta_segment-building_tools_description", "all", "", "602", "10", "", "", "internal_ad" ],
    [ 2499981782, 2499980115, "Двери", "internal", "crypta_segment-doors_name", "crypta_segment-doors_description", "all", "", "602", "102", "", "", "internal_ad" ],
    [ 2499981783, 2499980115, "Двери", "internal", "crypta_segment-doors_name", "crypta_segment-doors_description", "all", "", "601", "102", "", "", "internal_ad" ],
    [ 2499981784, 2499980115, "Сайдинг и фасадные панели", "internal", "crypta_segment-facade_panels_name", "crypta_segment-facade_panels_description", "all", "", "601", "215", "", "", "internal_ad" ],
    [ 2499981785, 2499980115, "Сайдинг и фасадные панели", "internal", "crypta_segment-facade_panels_name", "crypta_segment-facade_panels_description", "all", "", "602", "215", "", "", "internal_ad" ],
    [ 2499981786, 2499980115, "Напольные покрытия", "internal", "crypta_segment-floor_coverings_name", "crypta_segment-floor_coverings_description", "all", "", "602", "18", "", "", "internal_ad" ],
    [ 2499981787, 2499980115, "Напольные покрытия", "internal", "crypta_segment-floor_coverings_name", "crypta_segment-floor_coverings_description", "all", "", "601", "18", "", "", "internal_ad" ],
    [ 2499981788, 2499980115, "Лакокрасочные материалы", "internal", "crypta_segment-paints_name", "crypta_segment-paints_description", "all", "", "601", "20", "", "", "internal_ad" ],
    [ 2499981789, 2499980115, "Лакокрасочные материалы", "internal", "crypta_segment-paints_name", "crypta_segment-paints_description", "all", "", "602", "20", "", "", "internal_ad" ],
    [ 2499981790, 2499980115, "Кровля и водосток", "internal", "crypta_segment-roof_and_drain_name", "crypta_segment-roof_and_drain_description", "all", "", "601", "50", "", "", "internal_ad" ],
    [ 2499981791, 2499980115, "Кровля и водосток", "internal", "crypta_segment-roof_and_drain_name", "crypta_segment-roof_and_drain_description", "all", "", "602", "50", "", "", "internal_ad" ],
    [ 2499981792, 2499980115, "Сантехника", "internal", "crypta_segment-sanitary_engineering_name", "crypta_segment-sanitary_engineering_description", "all", "", "602", "13", "", "", "internal_ad" ],
    [ 2499981793, 2499980115, "Сантехника", "internal", "crypta_segment-sanitary_engineering_name", "crypta_segment-sanitary_engineering_description", "all", "", "601", "13", "", "", "internal_ad" ],
    [ 2499981794, 2499980115, "Натяжные потолки", "internal", "crypta_segment-stretch_ceiling_name", "crypta_segment-stretch_ceiling_description", "all", "", "602", "121", "", "", "internal_ad" ],
    [ 2499981795, 2499980115, "Натяжные потолки", "internal", "crypta_segment-stretch_ceiling_name", "crypta_segment-stretch_ceiling_description", "all", "", "601", "121", "", "", "internal_ad" ],
    [ 2499981796, 2499980115, "Плитка", "internal", "crypta_segment-tile_name", "crypta_segment-tile_description", "all", "", "602", "133", "", "", "internal_ad" ],
    [ 2499981797, 2499980115, "Плитка", "internal", "crypta_segment-tile_name", "crypta_segment-tile_description", "all", "", "601", "133", "", "", "internal_ad" ],
    [ 2499981798, 2499980115, "Обои", "internal", "crypta_segment-wallpaper_name", "crypta_segment-wallpaper_description", "all", "", "601", "42", "", "", "internal_ad" ],
    [ 2499981799, 2499980115, "Обои", "internal", "crypta_segment-wallpaper_name", "crypta_segment-wallpaper_description", "all", "", "602", "42", "", "", "internal_ad" ],
    [ 2499981800, 2499980115, "Окна", "internal", "crypta_segment-windows_name", "crypta_segment-windows_description", "all", "", "601", "136", "", "", "internal_ad" ],
    [ 2499981801, 2499980115, "Окна", "internal", "crypta_segment-windows_name", "crypta_segment-windows_description", "all", "", "602", "136", "", "", "internal_ad" ],
    [ 2499981802, 2499980116, "Квадроциклы", "internal", "crypta_segment-atvs_name", "crypta_segment-atvs_description", "all", "", "601", "199", "", "", "internal_ad" ],
    [ 2499981803, 2499980116, "Квадроциклы", "internal", "crypta_segment-atvs_name", "crypta_segment-atvs_description", "all", "", "602", "199", "", "", "internal_ad" ],
    [ 2499981804, 2499980116, "Мопеды", "internal", "crypta_segment-mopeds_name", "crypta_segment-mopeds_description", "all", "", "602", "98", "", "", "internal_ad" ],
    [ 2499981805, 2499980116, "Мопеды", "internal", "crypta_segment-mopeds_name", "crypta_segment-mopeds_description", "all", "", "601", "98", "", "", "internal_ad" ],
    [ 2499981806, 2499980116, "Мотоциклы", "internal", "crypta_segment-motorcycles_name", "crypta_segment-motorcycles_description", "all", "", "601", "218", "", "", "internal_ad" ],
    [ 2499981807, 2499980116, "Мотоциклы", "internal", "crypta_segment-motorcycles_name", "crypta_segment-motorcycles_description", "all", "", "602", "218", "", "", "internal_ad" ],
    [ 2499981808, 2499980116, "Скутеры", "internal", "crypta_segment-scooters_name", "crypta_segment-scooters_description", "all", "", "602", "184", "", "", "internal_ad" ],
    [ 2499981809, 2499980116, "Скутеры", "internal", "crypta_segment-scooters_name", "crypta_segment-scooters_description", "all", "", "601", "184", "", "", "internal_ad" ],
    [ 2499981810, 2499980116, "Снегоходы", "internal", "crypta_segment-snowmobiles_name", "crypta_segment-snowmobiles_description", "all", "", "601", "213", "", "", "internal_ad" ],
    [ 2499981811, 2499980116, "Снегоходы", "internal", "crypta_segment-snowmobiles_name", "crypta_segment-snowmobiles_description", "all", "", "602", "213", "", "", "internal_ad" ],
    [ 2499981812, 2499980117, "Автострахование КАСКО", "internal", "crypta_segment-28b78127_name", "crypta_segment-28b78127_description", "all", "", "601", "240", "", "", "internal_ad" ],
    [ 2499981813, 2499980117, "Автострахование КАСКО", "internal", "crypta_segment-28b78127_name", "crypta_segment-28b78127_description", "all", "", "602", "240", "", "", "internal_ad" ],
    [ 2499981814, 2499980117, "Фуры", "internal", "crypta_segment-8d9ae7ac_name", "crypta_segment-8d9ae7ac_description", "all", "", "602", "276", "", "", "internal_ad" ],
    [ 2499981815, 2499980117, "Фуры", "internal", "crypta_segment-8d9ae7ac_name", "crypta_segment-8d9ae7ac_description", "all", "", "601", "276", "", "", "internal_ad" ],
    [ 2499981816, 2499980117, "Фуры", "internal", "crypta_segment-8d9ae7ac_name", "crypta_segment-8d9ae7ac_description", "all", "", "557", "7991503", "", "", "internal_ad" ],
    [ 2499981817, 2499980117, "Детские автокресла", "internal", "crypta_segment-baby_car_seats_name", "crypta_segment-baby_car_seats_description", "all", "", "557", "9160354", "", "", "internal_ad" ],
    [ 2499981818, 2499980117, "Детские автокресла", "internal", "crypta_segment-baby_car_seats_name", "crypta_segment-baby_car_seats_description", "all", "", "601", "288", "", "", "internal_ad" ],
    [ 2499981819, 2499980117, "Детские автокресла", "internal", "crypta_segment-baby_car_seats_name", "crypta_segment-baby_car_seats_description", "all", "", "602", "288", "", "", "internal_ad" ],
    [ 2499981820, 2499980117, "Автострахование", "internal", "crypta_segment-car_insurance_name", "crypta_segment-car_insurance_description", "all", "", "602", "157", "", "", "internal_ad" ],
    [ 2499981821, 2499980117, "Автострахование", "internal", "crypta_segment-car_insurance_name", "crypta_segment-car_insurance_description", "all", "", "601", "157", "", "", "internal_ad" ],
    [ 2499981822, 2499980117, "Автозапчасти и аксессуары", "internal", "crypta_segment-car_parts_name", "crypta_segment-car_parts_description", "all", "", "602", "38", "", "", "internal_ad" ],
    [ 2499981823, 2499980117, "Автозапчасти и аксессуары", "internal", "crypta_segment-car_parts_name", "crypta_segment-car_parts_description", "all", "", "601", "38", "", "", "internal_ad" ],
    [ 2499981824, 2499980117, "Техобслуживание автомобилей", "internal", "crypta_segment-car_service_name", "crypta_segment-car_service_description", "all", "", "602", "67", "", "", "internal_ad" ],
    [ 2499981825, 2499980117, "Техобслуживание автомобилей", "internal", "crypta_segment-car_service_name", "crypta_segment-car_service_description", "all", "", "601", "67", "", "", "internal_ad" ],
    [ 2499981826, 2499980117, "Автомобили", "internal", "crypta_segment-cars_name", "crypta_segment-cars_description", "all", "", "601", "91", "", "", "internal_ad" ],
    [ 2499981827, 2499980117, "Автомобили", "internal", "crypta_segment-cars_name", "crypta_segment-cars_description", "all", "", "557", "11869642", "", "", "internal_ad" ],
    [ 2499981828, 2499980117, "Автомобили", "internal", "crypta_segment-cars_name", "crypta_segment-cars_description", "all", "", "602", "91", "", "", "internal_ad" ],
    [ 2499981829, 2499980117, "Автомобили бизнес-класса", "internal", "crypta_segment-cars_business_name", "crypta_segment-cars_business_description", "all", "", "557", "11869624", "", "", "internal_ad" ],
    [ 2499981830, 2499980117, "Автомобили бизнес-класса", "internal", "crypta_segment-cars_business_name", "crypta_segment-cars_business_description", "all", "", "601", "232", "", "", "internal_ad" ],
    [ 2499981831, 2499980117, "Автомобили бизнес-класса", "internal", "crypta_segment-cars_business_name", "crypta_segment-cars_business_description", "all", "", "602", "232", "", "", "internal_ad" ],
    [ 2499981832, 2499980117, "Городские автомобили", "internal", "crypta_segment-cars_city_name", "crypta_segment-cars_city_description", "all", "", "601", "228", "", "", "internal_ad" ],
    [ 2499981833, 2499980117, "Городские автомобили", "internal", "crypta_segment-cars_city_name", "crypta_segment-cars_city_description", "all", "", "557", "11869633", "", "", "internal_ad" ],
    [ 2499981834, 2499980117, "Городские автомобили", "internal", "crypta_segment-cars_city_name", "crypta_segment-cars_city_description", "all", "", "602", "228", "", "", "internal_ad" ],
    [ 2499981835, 2499980117, "Автомобили представительского класса", "internal", "crypta_segment-cars_executive_name", "crypta_segment-cars_executive_description", "all", "", "557", "11869630", "", "", "internal_ad" ],
    [ 2499981836, 2499980117, "Автомобили представительского класса", "internal", "crypta_segment-cars_executive_name", "crypta_segment-cars_executive_description", "all", "", "602", "233", "", "", "internal_ad" ],
    [ 2499981837, 2499980117, "Автомобили представительского класса", "internal", "crypta_segment-cars_executive_name", "crypta_segment-cars_executive_description", "all", "", "601", "233", "", "", "internal_ad" ],
    [ 2499981838, 2499980117, "Семейные автомобили", "internal", "crypta_segment-cars_family_name", "crypta_segment-cars_family_description", "all", "", "601", "231", "", "", "internal_ad" ],
    [ 2499981839, 2499980117, "Семейные автомобили", "internal", "crypta_segment-cars_family_name", "crypta_segment-cars_family_description", "all", "", "602", "231", "", "", "internal_ad" ],
    [ 2499981840, 2499980117, "Автомобили среднего класса", "internal", "crypta_segment-cars_middle_name", "crypta_segment-cars_middle_description", "all", "", "557", "11869621", "", "", "internal_ad" ],
    [ 2499981841, 2499980117, "Автомобили среднего класса", "internal", "crypta_segment-cars_middle_name", "crypta_segment-cars_middle_description", "all", "", "602", "230", "", "", "internal_ad" ],
    [ 2499981842, 2499980117, "Автомобили среднего класса", "internal", "crypta_segment-cars_middle_name", "crypta_segment-cars_middle_description", "all", "", "601", "230", "", "", "internal_ad" ],
    [ 2499981843, 2499980117, "Автомобили малого класса", "internal", "crypta_segment-cars_small_name", "crypta_segment-cars_small_description", "all", "", "557", "11869627", "", "", "internal_ad" ],
    [ 2499981844, 2499980117, "Автомобили малого класса", "internal", "crypta_segment-cars_small_name", "crypta_segment-cars_small_description", "all", "", "601", "229", "", "", "internal_ad" ],
    [ 2499981845, 2499980117, "Автомобили малого класса", "internal", "crypta_segment-cars_small_name", "crypta_segment-cars_small_description", "all", "", "602", "229", "", "", "internal_ad" ],
    [ 2499981846, 2499980117, "Спортивные автомобили", "internal", "crypta_segment-cars_sport_name", "crypta_segment-cars_sport_description", "all", "", "601", "234", "", "", "internal_ad" ],
    [ 2499981847, 2499980117, "Спортивные автомобили", "internal", "crypta_segment-cars_sport_name", "crypta_segment-cars_sport_description", "all", "", "602", "234", "", "", "internal_ad" ],
    [ 2499981848, 2499980117, "Автомобили с открытым верхом", "internal", "crypta_segment-cars_with_open_tops_name", "crypta_segment-cars_with_open_tops_description", "all", "", "601", "235", "", "", "internal_ad" ],
    [ 2499981849, 2499980117, "Автомобили с открытым верхом", "internal", "crypta_segment-cars_with_open_tops_name", "crypta_segment-cars_with_open_tops_description", "all", "", "602", "235", "", "", "internal_ad" ],
    [ 2499981850, 2499980117, "Автомобили с открытым верхом", "internal", "crypta_segment-cars_with_open_tops_name", "crypta_segment-cars_with_open_tops_description", "all", "", "557", "11869645", "", "", "internal_ad" ],
    [ 2499981851, 2499980117, "Компактвэны", "internal", "crypta_segment-compact_mpv_name", "crypta_segment-compact_mpv_description", "all", "", "602", "236", "", "", "internal_ad" ],
    [ 2499981852, 2499980117, "Компактвэны", "internal", "crypta_segment-compact_mpv_name", "crypta_segment-compact_mpv_description", "all", "", "601", "236", "", "", "internal_ad" ],
    [ 2499981853, 2499980117, "Подготовка водителей", "internal", "crypta_segment-driver_training_name", "crypta_segment-driver_training_description", "all", "", "602", "64", "", "", "internal_ad" ],
    [ 2499981854, 2499980117, "Подготовка водителей", "internal", "crypta_segment-driver_training_name", "crypta_segment-driver_training_description", "all", "", "601", "64", "", "", "internal_ad" ],
    [ 2499981855, 2499980117, "Лизинг автомобилей и спецтехники", "internal", "crypta_segment-leasing_name", "crypta_segment-leasing_description", "all", "", "602", "287", "", "", "internal_ad" ],
    [ 2499981856, 2499980117, "Лизинг автомобилей и спецтехники", "internal", "crypta_segment-leasing_name", "crypta_segment-leasing_description", "all", "", "601", "287", "", "", "internal_ad" ],
    [ 2499981857, 2499980117, "Минивэны", "internal", "crypta_segment-minivans_name", "crypta_segment-minivans_description", "all", "", "601", "31", "", "", "internal_ad" ],
    [ 2499981858, 2499980117, "Минивэны", "internal", "crypta_segment-minivans_name", "crypta_segment-minivans_description", "all", "", "602", "31", "", "", "internal_ad" ],
    [ 2499981859, 2499980117, "Пикапы", "internal", "crypta_segment-pickup_trucks_name", "crypta_segment-pickup_trucks_description", "all", "", "602", "46", "", "", "internal_ad" ],
    [ 2499981860, 2499980117, "Пикапы", "internal", "crypta_segment-pickup_trucks_name", "crypta_segment-pickup_trucks_description", "all", "", "601", "46", "", "", "internal_ad" ],
    [ 2499981861, 2499980117, "Внедорожники", "internal", "crypta_segment-suvs_name", "crypta_segment-suvs_description", "all", "", "601", "68", "", "", "internal_ad" ],
    [ 2499981862, 2499980117, "Внедорожники", "internal", "crypta_segment-suvs_name", "crypta_segment-suvs_description", "all", "", "602", "68", "", "", "internal_ad" ],
    [ 2499981863, 2499980117, "Внедорожники", "internal", "crypta_segment-suvs_name", "crypta_segment-suvs_description", "all", "", "557", "11869648", "", "", "internal_ad" ],
    [ 2499981864, 2499980117, "Шины и диски", "internal", "crypta_segment-tires_and_wheels_name", "crypta_segment-tires_and_wheels_description", "all", "", "557", "10964761", "", "", "internal_ad" ],
    [ 2499981865, 2499980117, "Шины и диски", "internal", "crypta_segment-tires_and_wheels_name", "crypta_segment-tires_and_wheels_description", "all", "", "601", "132", "", "", "internal_ad" ],
    [ 2499981866, 2499980117, "Шины и диски", "internal", "crypta_segment-tires_and_wheels_name", "crypta_segment-tires_and_wheels_description", "all", "", "602", "132", "", "", "internal_ad" ],
    [ 2499981867, 2499980117, "Подержанные автомобили", "internal", "crypta_segment-used_cars_name", "crypta_segment-used_cars_description", "all", "", "601", "33", "", "", "internal_ad" ],
    [ 2499981868, 2499980117, "Подержанные автомобили", "internal", "crypta_segment-used_cars_name", "crypta_segment-used_cars_description", "all", "", "602", "33", "", "", "internal_ad" ],
    [ 2499981869, 2499980117, "Фургоны", "internal", "crypta_segment-vans_name", "crypta_segment-vans_description", "all", "", "602", "237", "", "", "internal_ad" ],
    [ 2499981870, 2499980117, "Фургоны", "internal", "crypta_segment-vans_name", "crypta_segment-vans_description", "all", "", "601", "237", "", "", "internal_ad" ],
    [ 2499981871, 2499980117, "Универсалы", "internal", "crypta_segment-wagons_name", "crypta_segment-wagons_description", "all", "", "602", "89", "", "", "internal_ad" ],
    [ 2499981872, 2499980117, "Универсалы", "internal", "crypta_segment-wagons_name", "crypta_segment-wagons_description", "all", "", "601", "89", "", "", "internal_ad" ],
    [ 2499981873, 2499980118, "Настольные компьютеры", "internal", "crypta_segment-desktops_name", "crypta_segment-desktops_description", "all", "", "602", "204", "", "", "internal_ad" ],
    [ 2499981874, 2499980118, "Настольные компьютеры", "internal", "crypta_segment-desktops_name", "crypta_segment-desktops_description", "all", "", "557", "12931266", "", "", "internal_ad" ],
    [ 2499981875, 2499980118, "Настольные компьютеры", "internal", "crypta_segment-desktops_name", "crypta_segment-desktops_description", "all", "", "601", "204", "", "", "internal_ad" ],
    [ 2499981876, 2499980118, "Ноутбуки", "internal", "crypta_segment-laptops_name", "crypta_segment-laptops_description", "all", "", "602", "122", "", "", "internal_ad" ],
    [ 2499981877, 2499980118, "Ноутбуки", "internal", "crypta_segment-laptops_name", "crypta_segment-laptops_description", "all", "", "601", "122", "", "", "internal_ad" ],
    [ 2499981878, 2499980118, "Ноутбуки", "internal", "crypta_segment-laptops_name", "crypta_segment-laptops_description", "all", "", "557", "12931272", "", "", "internal_ad" ],
    [ 2499981879, 2499980118, "Мониторы", "internal", "crypta_segment-monitors_name", "crypta_segment-monitors_description", "all", "", "601", "166", "", "", "internal_ad" ],
    [ 2499981880, 2499980118, "Мониторы", "internal", "crypta_segment-monitors_name", "crypta_segment-monitors_description", "all", "", "602", "166", "", "", "internal_ad" ],
    [ 2499981881, 2499980118, "Планшеты", "internal", "crypta_segment-tablets_name", "crypta_segment-tablets_description", "all", "", "601", "169", "", "", "internal_ad" ],
    [ 2499981882, 2499980118, "Планшеты", "internal", "crypta_segment-tablets_name", "crypta_segment-tablets_description", "all", "", "602", "169", "", "", "internal_ad" ],
    [ 2499981883, 2499980118, "Планшеты", "internal", "crypta_segment-tablets_name", "crypta_segment-tablets_description", "all", "", "557", "12931269", "", "", "internal_ad" ],
    [ 2499981884, 2499980119, "Наушники", "internal", "crypta_segment-headphones_name", "crypta_segment-headphones_description", "all", "", "602", "153", "", "", "internal_ad" ],
    [ 2499981885, 2499980119, "Наушники", "internal", "crypta_segment-headphones_name", "crypta_segment-headphones_description", "all", "", "601", "153", "", "", "internal_ad" ],
    [ 2499981886, 2499980119, "Портативная аудиотехника", "internal", "crypta_segment-portable_audio_equipment_name", "crypta_segment-portable_audio_equipment_description", "all", "", "601", "37", "", "", "internal_ad" ],
    [ 2499981887, 2499980119, "Портативная аудиотехника", "internal", "crypta_segment-portable_audio_equipment_name", "crypta_segment-portable_audio_equipment_description", "all", "", "602", "37", "", "", "internal_ad" ],
    [ 2499981888, 2499980119, "Стационарная аудиотехника", "internal", "crypta_segment-stationary_audio_equipment_name", "crypta_segment-stationary_audio_equipment_description", "all", "", "602", "95", "", "", "internal_ad" ],
    [ 2499981889, 2499980119, "Стационарная аудиотехника", "internal", "crypta_segment-stationary_audio_equipment_name", "crypta_segment-stationary_audio_equipment_description", "all", "", "601", "95", "", "", "internal_ad" ],
    [ 2499981890, 2499980119, "Телевизоры и плазменные панели", "internal", "crypta_segment-tv_sets_name", "crypta_segment-tv_sets_description", "all", "", "602", "11", "", "", "internal_ad" ],
    [ 2499981891, 2499980119, "Телевизоры и плазменные панели", "internal", "crypta_segment-tv_sets_name", "crypta_segment-tv_sets_description", "all", "", "601", "11", "", "", "internal_ad" ],
    [ 2499981892, 2499980119, "Телевизоры и плазменные панели", "internal", "crypta_segment-tv_sets_name", "crypta_segment-tv_sets_description", "all", "", "557", "8783974", "", "", "internal_ad" ],
    [ 2499981893, 2499980120, "Мобильные телефоны и смартфоны за 35–50 тыс. руб.", "internal", "crypta_segment-4061a117_name", "crypta_segment-4061a117_description", "all", "", "601", "274", "", "", "internal_ad" ],
    [ 2499981894, 2499980120, "Мобильные телефоны и смартфоны за 35–50 тыс. руб.", "internal", "crypta_segment-4061a117_name", "crypta_segment-4061a117_description", "all", "", "602", "274", "", "", "internal_ad" ],
    [ 2499981895, 2499980120, "Мобильные телефоны и смартфоны за 15–25 тыс. руб.", "internal", "crypta_segment-890a3c73_name", "crypta_segment-890a3c73_description", "all", "", "602", "272", "", "", "internal_ad" ],
    [ 2499981896, 2499980120, "Мобильные телефоны и смартфоны за 15–25 тыс. руб.", "internal", "crypta_segment-890a3c73_name", "crypta_segment-890a3c73_description", "all", "", "601", "272", "", "", "internal_ad" ],
    [ 2499981897, 2499980120, "Мобильные телефоны и смартфоны за 25–35 тыс. руб.", "internal", "crypta_segment-a337e706_name", "crypta_segment-a337e706_description", "all", "", "602", "273", "", "", "internal_ad" ],
    [ 2499981898, 2499980120, "Мобильные телефоны и смартфоны за 25–35 тыс. руб.", "internal", "crypta_segment-a337e706_name", "crypta_segment-a337e706_description", "all", "", "601", "273", "", "", "internal_ad" ],
    [ 2499981899, 2499980120, "Мобильные телефоны и смартфоны до 15 тыс. руб.", "internal", "crypta_segment-c9dab41b_name", "crypta_segment-c9dab41b_description", "all", "", "602", "271", "", "", "internal_ad" ],
    [ 2499981900, 2499980120, "Мобильные телефоны и смартфоны до 15 тыс. руб.", "internal", "crypta_segment-c9dab41b_name", "crypta_segment-c9dab41b_description", "all", "", "601", "271", "", "", "internal_ad" ],
    [ 2499981901, 2499980120, "Мобильные телефоны и смартфоны от 50 тыс. руб.", "internal", "crypta_segment-cb71dc34_name", "crypta_segment-cb71dc34_description", "all", "", "557", "8782816", "", "", "internal_ad" ],
    [ 2499981902, 2499980120, "Мобильные телефоны и смартфоны от 50 тыс. руб.", "internal", "crypta_segment-cb71dc34_name", "crypta_segment-cb71dc34_description", "all", "", "602", "275", "", "", "internal_ad" ],
    [ 2499981903, 2499980120, "Мобильные телефоны и смартфоны от 50 тыс. руб.", "internal", "crypta_segment-cb71dc34_name", "crypta_segment-cb71dc34_description", "all", "", "601", "275", "", "", "internal_ad" ],
    [ 2499981904, 2499980121, "Встраиваемые духовые шкафы", "internal", "crypta_segment-builtin_ovens_name", "crypta_segment-builtin_ovens_description", "all", "", "601", "177", "", "", "internal_ad" ],
    [ 2499981905, 2499980121, "Встраиваемые духовые шкафы", "internal", "crypta_segment-builtin_ovens_name", "crypta_segment-builtin_ovens_description", "all", "", "602", "177", "", "", "internal_ad" ],
    [ 2499981906, 2499980121, "Встраиваемые рабочие поверхности", "internal", "crypta_segment-builtin_work_surfaces_name", "crypta_segment-builtin_work_surfaces_description", "all", "", "602", "28", "", "", "internal_ad" ],
    [ 2499981907, 2499980121, "Встраиваемые рабочие поверхности", "internal", "crypta_segment-builtin_work_surfaces_name", "crypta_segment-builtin_work_surfaces_description", "all", "", "601", "28", "", "", "internal_ad" ],
    [ 2499981908, 2499980121, "Посудомоечные машины", "internal", "crypta_segment-dishwashers_name", "crypta_segment-dishwashers_description", "all", "", "601", "155", "", "", "internal_ad" ],
    [ 2499981909, 2499980121, "Посудомоечные машины", "internal", "crypta_segment-dishwashers_name", "crypta_segment-dishwashers_description", "all", "", "602", "155", "", "", "internal_ad" ],
    [ 2499981910, 2499980121, "Холодильники", "internal", "crypta_segment-fridges_name", "crypta_segment-fridges_description", "all", "", "601", "106", "", "", "internal_ad" ],
    [ 2499981911, 2499980121, "Холодильники", "internal", "crypta_segment-fridges_name", "crypta_segment-fridges_description", "all", "", "602", "106", "", "", "internal_ad" ],
    [ 2499981912, 2499980121, "Кухонные вытяжки", "internal", "crypta_segment-kitchen_hoods_name", "crypta_segment-kitchen_hoods_description", "all", "", "601", "53", "", "", "internal_ad" ],
    [ 2499981913, 2499980121, "Кухонные вытяжки", "internal", "crypta_segment-kitchen_hoods_name", "crypta_segment-kitchen_hoods_description", "all", "", "602", "53", "", "", "internal_ad" ],
    [ 2499981914, 2499980121, "Кухонные плиты", "internal", "crypta_segment-kitchen_stoves_name", "crypta_segment-kitchen_stoves_description", "all", "", "601", "97", "", "", "internal_ad" ],
    [ 2499981915, 2499980121, "Кухонные плиты", "internal", "crypta_segment-kitchen_stoves_name", "crypta_segment-kitchen_stoves_description", "all", "", "602", "97", "", "", "internal_ad" ],
    [ 2499981916, 2499980122, "Блендеры", "internal", "crypta_segment-blenders_name", "crypta_segment-blenders_description", "all", "", "602", "195", "", "", "internal_ad" ],
    [ 2499981917, 2499980122, "Блендеры", "internal", "crypta_segment-blenders_name", "crypta_segment-blenders_description", "all", "", "601", "195", "", "", "internal_ad" ],
    [ 2499981918, 2499980122, "Кофеварки и кофемашины", "internal", "crypta_segment-coffee_machines_name", "crypta_segment-coffee_machines_description", "all", "", "601", "165", "", "", "internal_ad" ],
    [ 2499981919, 2499980122, "Кофеварки и кофемашины", "internal", "crypta_segment-coffee_machines_name", "crypta_segment-coffee_machines_description", "all", "", "602", "165", "", "", "internal_ad" ],
    [ 2499981920, 2499980122, "Мясорубки, кухонные комбайны и измельчители", "internal", "crypta_segment-food_processors_name", "crypta_segment-food_processors_description", "all", "", "601", "140", "", "", "internal_ad" ],
    [ 2499981921, 2499980122, "Мясорубки, кухонные комбайны и измельчители", "internal", "crypta_segment-food_processors_name", "crypta_segment-food_processors_description", "all", "", "602", "140", "", "", "internal_ad" ],
    [ 2499981922, 2499980122, "Соковыжималки", "internal", "crypta_segment-juicers_name", "crypta_segment-juicers_description", "all", "", "601", "139", "", "", "internal_ad" ],
    [ 2499981923, 2499980122, "Соковыжималки", "internal", "crypta_segment-juicers_name", "crypta_segment-juicers_description", "all", "", "602", "139", "", "", "internal_ad" ],
    [ 2499981924, 2499980122, "Пароварки, аэрогрили, мини-печи и ростеры, хлебопечки ", "internal", "crypta_segment-miniovens_name", "crypta_segment-miniovens_description", "all", "", "601", "131", "", "", "internal_ad" ],
    [ 2499981925, 2499980122, "Пароварки, аэрогрили, мини-печи и ростеры, хлебопечки ", "internal", "crypta_segment-miniovens_name", "crypta_segment-miniovens_description", "all", "", "602", "131", "", "", "internal_ad" ],
    [ 2499981926, 2499980122, "Мультиварки", "internal", "crypta_segment-multicooker_name", "crypta_segment-multicooker_description", "all", "", "601", "94", "", "", "internal_ad" ],
    [ 2499981927, 2499980122, "Мультиварки", "internal", "crypta_segment-multicooker_name", "crypta_segment-multicooker_description", "all", "", "602", "94", "", "", "internal_ad" ],
    [ 2499981928, 2499980123, "Климатическое оборудование для дома", "internal", "crypta_segment-air_conditioners_name", "crypta_segment-air_conditioners_description", "all", "", "601", "185", "", "", "internal_ad" ],
    [ 2499981929, 2499980123, "Климатическое оборудование для дома", "internal", "crypta_segment-air_conditioners_name", "crypta_segment-air_conditioners_description", "all", "", "602", "185", "", "", "internal_ad" ],
    [ 2499981930, 2499980123, "Пылесосы", "internal", "crypta_segment-vacuum_cleaners_name", "crypta_segment-vacuum_cleaners_description", "all", "", "602", "150", "", "", "internal_ad" ],
    [ 2499981931, 2499980123, "Пылесосы", "internal", "crypta_segment-vacuum_cleaners_name", "crypta_segment-vacuum_cleaners_description", "all", "", "601", "150", "", "", "internal_ad" ],
    [ 2499981932, 2499980123, "Стиральные машины", "internal", "crypta_segment-washing_machines_name", "crypta_segment-washing_machines_description", "all", "", "601", "196", "", "", "internal_ad" ],
    [ 2499981933, 2499980123, "Стиральные машины", "internal", "crypta_segment-washing_machines_name", "crypta_segment-washing_machines_description", "all", "", "602", "196", "", "", "internal_ad" ],
    [ 2499981934, 2499980124, "Приборы для укладки волос", "internal", "crypta_segment-hair_styling_appliances_name", "crypta_segment-hair_styling_appliances_description", "all", "", "601", "309", "", "", "internal_ad" ],
    [ 2499981935, 2499980124, "Приборы для укладки волос", "internal", "crypta_segment-hair_styling_appliances_name", "crypta_segment-hair_styling_appliances_description", "all", "", "602", "309", "", "", "internal_ad" ],
    [ 2499981936, 2499980124, "Мужские электробритвы", "internal", "crypta_segment-mens_electric_shaver_name", "crypta_segment-mens_electric_shaver_description", "all", "", "602", "308", "", "", "internal_ad" ],
    [ 2499981937, 2499980124, "Мужские электробритвы", "internal", "crypta_segment-mens_electric_shaver_name", "crypta_segment-mens_electric_shaver_description", "all", "", "601", "308", "", "", "internal_ad" ],
    [ 2499981938, 2499980124, "Устройства для ухода за полостью рта", "internal", "crypta_segment-teeth_care_appliances_name", "crypta_segment-teeth_care_appliances_description", "all", "", "602", "310", "", "", "internal_ad" ],
    [ 2499981939, 2499980124, "Устройства для ухода за полостью рта", "internal", "crypta_segment-teeth_care_appliances_name", "crypta_segment-teeth_care_appliances_description", "all", "", "601", "310", "", "", "internal_ad" ],
    [ 2499981940, 2499980124, "Женские электробритвы и эпиляторы", "internal", "crypta_segment-womens_electric_shavers_name", "crypta_segment-womens_electric_shavers_description", "all", "", "601", "307", "", "", "internal_ad" ],
    [ 2499981941, 2499980124, "Женские электробритвы и эпиляторы", "internal", "crypta_segment-womens_electric_shavers_name", "crypta_segment-womens_electric_shavers_description", "all", "", "602", "307", "", "", "internal_ad" ],
    [ 2499981942, 2499980125, "Расчетно-кассовое обслуживание", "internal", "crypta_segment-cash_services_name", "crypta_segment-cash_services_description", "all", "", "601", "191", "", "", "internal_ad" ],
    [ 2499981943, 2499980125, "Расчетно-кассовое обслуживание", "internal", "crypta_segment-cash_services_name", "crypta_segment-cash_services_description", "all", "", "602", "191", "", "", "internal_ad" ],
    [ 2499981944, 2499980125, "Расчетно-кассовое обслуживание", "internal", "crypta_segment-cash_services_name", "crypta_segment-cash_services_description", "all", "", "557", "5994922", "", "", "internal_ad" ],
    [ 2499981945, 2499980125, "Депозиты для бизнеса", "internal", "crypta_segment-deposits_for_business_name", "crypta_segment-deposits_for_business_description", "all", "", "557", "5994880", "", "", "internal_ad" ],
    [ 2499981946, 2499980125, "Депозиты для бизнеса", "internal", "crypta_segment-deposits_for_business_name", "crypta_segment-deposits_for_business_description", "all", "", "602", "59", "", "", "internal_ad" ],
    [ 2499981947, 2499980125, "Депозиты для бизнеса", "internal", "crypta_segment-deposits_for_business_name", "crypta_segment-deposits_for_business_description", "all", "", "601", "59", "", "", "internal_ad" ],
    [ 2499981948, 2499980125, "Кредиты для бизнеса", "internal", "crypta_segment-loans_for_business_name", "crypta_segment-loans_for_business_description", "all", "", "602", "116", "", "", "internal_ad" ],
    [ 2499981949, 2499980125, "Кредиты для бизнеса", "internal", "crypta_segment-loans_for_business_name", "crypta_segment-loans_for_business_description", "all", "", "557", "5994907", "", "", "internal_ad" ],
    [ 2499981950, 2499980125, "Кредиты для бизнеса", "internal", "crypta_segment-loans_for_business_name", "crypta_segment-loans_for_business_description", "all", "", "601", "116", "", "", "internal_ad" ],
    [ 2499981951, 2499980126, "Концерты", "internal", "crypta_segment-concerts_name", "crypta_segment-concerts_description", "all", "", "602", "111", "", "", "internal_ad" ],
    [ 2499981952, 2499980126, "Концерты", "internal", "crypta_segment-concerts_name", "crypta_segment-concerts_description", "all", "", "601", "111", "", "", "internal_ad" ],
    [ 2499981953, 2499980126, "Концерты", "internal", "crypta_segment-concerts_name", "crypta_segment-concerts_description", "all", "", "557", "6924539", "", "", "internal_ad" ],
    [ 2499981954, 2499980126, "Музыкальные инструменты", "internal", "crypta_segment-musical_instruments_name", "crypta_segment-musical_instruments_description", "all", "", "602", "52", "", "", "internal_ad" ],
    [ 2499981955, 2499980126, "Музыкальные инструменты", "internal", "crypta_segment-musical_instruments_name", "crypta_segment-musical_instruments_description", "all", "", "601", "52", "", "", "internal_ad" ],
    [ 2499981956, 2499980127, "Мюзиклы", "internal", "crypta_segment-18c598c7_name", "crypta_segment-18c598c7_description", "all", "", "601", "258", "", "", "internal_ad" ],
    [ 2499981957, 2499980127, "Мюзиклы", "internal", "crypta_segment-18c598c7_name", "crypta_segment-18c598c7_description", "all", "", "602", "258", "", "", "internal_ad" ],
    [ 2499981958, 2499980127, "Исторические фильмы", "internal", "crypta_segment-447d799d_name", "crypta_segment-447d799d_description", "all", "", "602", "260", "", "", "internal_ad" ],
    [ 2499981959, 2499980127, "Исторические фильмы", "internal", "crypta_segment-447d799d_name", "crypta_segment-447d799d_description", "all", "", "601", "260", "", "", "internal_ad" ],
    [ 2499981960, 2499980127, "Детские фильмы", "internal", "crypta_segment-6d1627b1_name", "crypta_segment-6d1627b1_description", "all", "", "601", "259", "", "", "internal_ad" ],
    [ 2499981961, 2499980127, "Детские фильмы", "internal", "crypta_segment-6d1627b1_name", "crypta_segment-6d1627b1_description", "all", "", "602", "259", "", "", "internal_ad" ],
    [ 2499981962, 2499980127, "Фантастика", "internal", "crypta_segment-6d6b003a_name", "crypta_segment-6d6b003a_description", "all", "", "601", "261", "", "", "internal_ad" ],
    [ 2499981963, 2499980127, "Фантастика", "internal", "crypta_segment-6d6b003a_name", "crypta_segment-6d6b003a_description", "all", "", "602", "261", "", "", "internal_ad" ],
    [ 2499981964, 2499980127, "Мелодрамы", "internal", "crypta_segment-7a65033c_name", "crypta_segment-7a65033c_description", "all", "", "602", "256", "", "", "internal_ad" ],
    [ 2499981965, 2499980127, "Мелодрамы", "internal", "crypta_segment-7a65033c_name", "crypta_segment-7a65033c_description", "all", "", "601", "256", "", "", "internal_ad" ],
    [ 2499981966, 2499980127, "Документальные фильмы", "internal", "crypta_segment-875ea56d_name", "crypta_segment-875ea56d_description", "all", "", "601", "264", "", "", "internal_ad" ],
    [ 2499981967, 2499980127, "Документальные фильмы", "internal", "crypta_segment-875ea56d_name", "crypta_segment-875ea56d_description", "all", "", "602", "264", "", "", "internal_ad" ],
    [ 2499981968, 2499980127, "Триллеры", "internal", "crypta_segment-88cb398a_name", "crypta_segment-88cb398a_description", "all", "", "601", "267", "", "", "internal_ad" ],
    [ 2499981969, 2499980127, "Триллеры", "internal", "crypta_segment-88cb398a_name", "crypta_segment-88cb398a_description", "all", "", "602", "267", "", "", "internal_ad" ],
    [ 2499981970, 2499980127, "Билеты в кино", "internal", "crypta_segment-8ad182c0_name", "crypta_segment-8ad182c0_description", "all", "", "601", "252", "", "", "internal_ad" ],
    [ 2499981971, 2499980127, "Билеты в кино", "internal", "crypta_segment-8ad182c0_name", "crypta_segment-8ad182c0_description", "all", "", "602", "252", "", "", "internal_ad" ],
    [ 2499981972, 2499980127, "Ужасы", "internal", "crypta_segment-b115d23e_name", "crypta_segment-b115d23e_description", "all", "", "601", "262", "", "", "internal_ad" ],
    [ 2499981973, 2499980127, "Ужасы", "internal", "crypta_segment-b115d23e_name", "crypta_segment-b115d23e_description", "all", "", "602", "262", "", "", "internal_ad" ],
    [ 2499981974, 2499980127, "Биографии", "internal", "crypta_segment-b173e712_name", "crypta_segment-b173e712_description", "all", "", "602", "265", "", "", "internal_ad" ],
    [ 2499981975, 2499980127, "Биографии", "internal", "crypta_segment-b173e712_name", "crypta_segment-b173e712_description", "all", "", "601", "265", "", "", "internal_ad" ],
    [ 2499981976, 2499980127, "Приключения", "internal", "crypta_segment-b45501ec_name", "crypta_segment-b45501ec_description", "all", "", "602", "266", "", "", "internal_ad" ],
    [ 2499981977, 2499980127, "Приключения", "internal", "crypta_segment-b45501ec_name", "crypta_segment-b45501ec_description", "all", "", "601", "266", "", "", "internal_ad" ],
    [ 2499981978, 2499980127, "Сериалы", "internal", "crypta_segment-bc908122_name", "crypta_segment-bc908122_description", "all", "", "602", "257", "", "", "internal_ad" ],
    [ 2499981979, 2499980127, "Сериалы", "internal", "crypta_segment-bc908122_name", "crypta_segment-bc908122_description", "all", "", "601", "257", "", "", "internal_ad" ],
    [ 2499981980, 2499980127, "Детективы", "internal", "crypta_segment-c062cd56_name", "crypta_segment-c062cd56_description", "all", "", "602", "268", "", "", "internal_ad" ],
    [ 2499981981, 2499980127, "Детективы", "internal", "crypta_segment-c062cd56_name", "crypta_segment-c062cd56_description", "all", "", "601", "268", "", "", "internal_ad" ],
    [ 2499981982, 2499980127, "Драмы", "internal", "crypta_segment-e10ea91d_name", "crypta_segment-e10ea91d_description", "all", "", "602", "255", "", "", "internal_ad" ],
    [ 2499981983, 2499980127, "Драмы", "internal", "crypta_segment-e10ea91d_name", "crypta_segment-e10ea91d_description", "all", "", "601", "255", "", "", "internal_ad" ],
    [ 2499981984, 2499980127, "Боевики", "internal", "crypta_segment-e200a08a_name", "crypta_segment-e200a08a_description", "all", "", "601", "254", "", "", "internal_ad" ],
    [ 2499981985, 2499980127, "Боевики", "internal", "crypta_segment-e200a08a_name", "crypta_segment-e200a08a_description", "all", "", "602", "254", "", "", "internal_ad" ],
    [ 2499981986, 2499980127, "Комедии", "internal", "crypta_segment-e22e8569_name", "crypta_segment-e22e8569_description", "all", "", "602", "263", "", "", "internal_ad" ],
    [ 2499981987, 2499980127, "Комедии", "internal", "crypta_segment-e22e8569_name", "crypta_segment-e22e8569_description", "all", "", "601", "263", "", "", "internal_ad" ],
    [ 2499981988, 2499980128, "Компьютерные игры", "internal", "crypta_segment-computer_games_name", "crypta_segment-computer_games_description", "all", "", "601", "6", "", "", "internal_ad" ],
    [ 2499981989, 2499980128, "Компьютерные игры", "internal", "crypta_segment-computer_games_name", "crypta_segment-computer_games_description", "all", "", "557", "8928481", "", "", "internal_ad" ],
    [ 2499981990, 2499980128, "Компьютерные игры", "internal", "crypta_segment-computer_games_name", "crypta_segment-computer_games_description", "all", "", "602", "6", "", "", "internal_ad" ],
    [ 2499981991, 2499980128, "Консольные игры", "internal", "crypta_segment-console_games_name", "crypta_segment-console_games_description", "all", "", "601", "7", "", "", "internal_ad" ],
    [ 2499981992, 2499980128, "Консольные игры", "internal", "crypta_segment-console_games_name", "crypta_segment-console_games_description", "all", "", "602", "7", "", "", "internal_ad" ],
    [ 2499981993, 2499980128, "Киберспорт", "internal", "crypta_segment-cybersport_name", "crypta_segment-cybersport_description", "all", "", "601", "301", "", "", "internal_ad" ],
    [ 2499981994, 2499980128, "Киберспорт", "internal", "crypta_segment-cybersport_name", "crypta_segment-cybersport_description", "all", "", "557", "8928487", "", "", "internal_ad" ],
    [ 2499981995, 2499980128, "Киберспорт", "internal", "crypta_segment-cybersport_name", "crypta_segment-cybersport_description", "all", "", "602", "301", "", "", "internal_ad" ],
    [ 2499981996, 2499980128, "Мобильные игры", "internal", "crypta_segment-mobile_games_name", "crypta_segment-mobile_games_description", "all", "", "601", "319", "", "", "internal_ad" ],
    [ 2499981997, 2499980128, "Мобильные игры", "internal", "crypta_segment-mobile_games_name", "crypta_segment-mobile_games_description", "all", "", "602", "319", "", "", "internal_ad" ],
    [ 2499981998, 2499980129, "Детские коляски", "internal", "crypta_segment-baby_carriages_name", "crypta_segment-baby_carriages_description", "all", "", "601", "294", "", "", "internal_ad" ],
    [ 2499981999, 2499980129, "Детские коляски", "internal", "crypta_segment-baby_carriages_name", "crypta_segment-baby_carriages_description", "all", "", "602", "294", "", "", "internal_ad" ],
    [ 2499982000, 2499980129, "Детские велосипеды", "internal", "crypta_segment-childrens_bicycles_name", "crypta_segment-childrens_bicycles_description", "all", "", "602", "297", "", "", "internal_ad" ],
    [ 2499982001, 2499980129, "Детские велосипеды", "internal", "crypta_segment-childrens_bicycles_name", "crypta_segment-childrens_bicycles_description", "all", "", "601", "297", "", "", "internal_ad" ],
    [ 2499982002, 2499980129, "Детские книги", "internal", "crypta_segment-childrens_books_name", "crypta_segment-childrens_books_description", "all", "", "602", "295", "", "", "internal_ad" ],
    [ 2499982003, 2499980129, "Детские книги", "internal", "crypta_segment-childrens_books_name", "crypta_segment-childrens_books_description", "all", "", "601", "295", "", "", "internal_ad" ],
    [ 2499982004, 2499980129, "Детские самокаты", "internal", "crypta_segment-childrens_scooters_name", "crypta_segment-childrens_scooters_description", "all", "", "602", "293", "", "", "internal_ad" ],
    [ 2499982005, 2499980129, "Детские самокаты", "internal", "crypta_segment-childrens_scooters_name", "crypta_segment-childrens_scooters_description", "all", "", "601", "293", "", "", "internal_ad" ],
    [ 2499982006, 2499980129, "Детские игрушки", "internal", "crypta_segment-kids_toys_name", "crypta_segment-kids_toys_description", "all", "", "602", "296", "", "", "internal_ad" ],
    [ 2499982007, 2499980129, "Детские игрушки", "internal", "crypta_segment-kids_toys_name", "crypta_segment-kids_toys_description", "all", "", "601", "296", "", "", "internal_ad" ],
    [ 2499982008, 2499980129, "Игрушки для малышей", "internal", "crypta_segment-toys_for_babies_name", "crypta_segment-toys_for_babies_description", "all", "", "601", "292", "", "", "internal_ad" ],
    [ 2499982009, 2499980129, "Игрушки для малышей", "internal", "crypta_segment-toys_for_babies_name", "crypta_segment-toys_for_babies_description", "all", "", "602", "292", "", "", "internal_ad" ],
    [ 2499982010, 2499980130, "Любители семейного кино и мультфильмов", "internal", "crypta_segment-013e53b7_name", "crypta_segment-013e53b7_description", "all", "", "557", "4032914", "", "", "internal_ad" ],
    [ 2499982011, 2499980130, "Любители семейного кино и мультфильмов", "internal", "crypta_segment-013e53b7_name", "crypta_segment-013e53b7_description", "all", "", "216", "713", "", "", "internal_ad" ],
    [ 2499982012, 2499980130, "Любители криминальных фильмов", "internal", "crypta_segment-042ac65a_name", "crypta_segment-042ac65a_description", "all", "", "216", "720", "", "", "internal_ad" ],
    [ 2499982013, 2499980130, "Любители криминальных фильмов", "internal", "crypta_segment-042ac65a_name", "crypta_segment-042ac65a_description", "all", "", "557", "11204761", "", "", "internal_ad" ],
    [ 2499982014, 2499980130, "Любители спортивных фильмов", "internal", "crypta_segment-073b1614_name", "crypta_segment-073b1614_description", "all", "", "216", "735", "", "", "internal_ad" ],
    [ 2499982015, 2499980130, "Любители фильмов для взрослых", "internal", "crypta_segment-095c2300_name", "crypta_segment-095c2300_description", "all", "", "216", "716", "", "", "internal_ad" ],
    [ 2499982016, 2499980130, "Любители фильмов-церемоний", "internal", "crypta_segment-0dbac8ac_name", "crypta_segment-0dbac8ac_description", "all", "", "216", "740", "", "", "internal_ad" ],
    [ 2499982017, 2499980130, "Любители фильмов в жанре игра", "internal", "crypta_segment-157e1458_name", "crypta_segment-157e1458_description", "all", "", "216", "725", "", "", "internal_ad" ],
    [ 2499982018, 2499980130, "Любители фильмов в жанре ток-шоу", "internal", "crypta_segment-1b93d875_name", "crypta_segment-1b93d875_description", "all", "", "216", "736", "", "", "internal_ad" ],
    [ 2499982019, 2499980130, "Любители триллеров", "internal", "crypta_segment-1be10754_name", "crypta_segment-1be10754_description", "all", "", "557", "11204752", "", "", "internal_ad" ],
    [ 2499982020, 2499980130, "Любители триллеров", "internal", "crypta_segment-1be10754_name", "crypta_segment-1be10754_description", "all", "", "216", "737", "", "", "internal_ad" ],
    [ 2499982021, 2499980130, "Любители жанра реальное ТВ", "internal", "crypta_segment-256be0bd_name", "crypta_segment-256be0bd_description", "all", "", "216", "731", "", "", "internal_ad" ],
    [ 2499982022, 2499980130, "Любители драм", "internal", "crypta_segment-2918e696_name", "crypta_segment-2918e696_description", "all", "", "557", "11204734", "", "", "internal_ad" ],
    [ 2499982023, 2499980130, "Любители драм", "internal", "crypta_segment-2918e696_name", "crypta_segment-2918e696_description", "all", "", "216", "722", "", "", "internal_ad" ],
    [ 2499982024, 2499980130, "Любители фильмов-нуар", "internal", "crypta_segment-3035b845_name", "crypta_segment-3035b845_description", "all", "", "216", "724", "", "", "internal_ad" ],
    [ 2499982025, 2499980130, "Любители боевиков", "internal", "crypta_segment-37c6e801_name", "crypta_segment-37c6e801_description", "all", "", "216", "715", "", "", "internal_ad" ],
    [ 2499982026, 2499980130, "Любители боевиков", "internal", "crypta_segment-37c6e801_name", "crypta_segment-37c6e801_description", "all", "", "557", "11204746", "", "", "internal_ad" ],
    [ 2499982027, 2499980130, "Любители мюзиклов", "internal", "crypta_segment-48593157_name", "crypta_segment-48593157_description", "all", "", "216", "728", "", "", "internal_ad" ],
    [ 2499982028, 2499980130, "Любители новостных фильмов", "internal", "crypta_segment-4969198c_name", "crypta_segment-4969198c_description", "all", "", "216", "730", "", "", "internal_ad" ],
    [ 2499982029, 2499980130, "Любители мелодрам", "internal", "crypta_segment-6013c299_name", "crypta_segment-6013c299_description", "all", "", "557", "11204749", "", "", "internal_ad" ],
    [ 2499982030, 2499980130, "Любители мелодрам", "internal", "crypta_segment-6013c299_name", "crypta_segment-6013c299_description", "all", "", "216", "732", "", "", "internal_ad" ],
    [ 2499982031, 2499980130, "Любители биографических фильмов", "internal", "crypta_segment-609d7840_name", "crypta_segment-609d7840_description", "all", "", "216", "718", "", "", "internal_ad" ],
    [ 2499982032, 2499980130, "Любители фильмов-концертов", "internal", "crypta_segment-8957bb16_name", "crypta_segment-8957bb16_description", "all", "", "216", "741", "", "", "internal_ad" ],
    [ 2499982033, 2499980130, "Любители фильмов ужасов", "internal", "crypta_segment-8ccf8ec6_name", "crypta_segment-8ccf8ec6_description", "all", "", "216", "593", "", "", "internal_ad" ],
    [ 2499982034, 2499980130, "Любители фильмов ужасов", "internal", "crypta_segment-8ccf8ec6_name", "crypta_segment-8ccf8ec6_description", "all", "", "557", "11204755", "", "", "internal_ad" ],
    [ 2499982035, 2499980130, "Любители исторических фильмов", "internal", "crypta_segment-91a96e09_name", "crypta_segment-91a96e09_description", "all", "", "557", "12277411", "", "", "internal_ad" ],
    [ 2499982036, 2499980130, "Любители исторических фильмов", "internal", "crypta_segment-91a96e09_name", "crypta_segment-91a96e09_description", "all", "", "216", "726", "", "", "internal_ad" ],
    [ 2499982037, 2499980130, "Любители военных фильмов", "internal", "crypta_segment-97c49297_name", "crypta_segment-97c49297_description", "all", "", "557", "4083125", "", "", "internal_ad" ],
    [ 2499982038, 2499980130, "Любители военных фильмов", "internal", "crypta_segment-97c49297_name", "crypta_segment-97c49297_description", "all", "", "216", "714", "", "", "internal_ad" ],
    [ 2499982039, 2499980130, "Любители музыкальных фильмов", "internal", "crypta_segment-9839331d_name", "crypta_segment-9839331d_description", "all", "", "216", "727", "", "", "internal_ad" ],
    [ 2499982040, 2499980130, "Любители вестернов", "internal", "crypta_segment-9deceb81_name", "crypta_segment-9deceb81_description", "all", "", "216", "738", "", "", "internal_ad" ],
    [ 2499982041, 2499980130, "Любители комедий", "internal", "crypta_segment-a4b80787_name", "crypta_segment-a4b80787_description", "all", "", "557", "11204737", "", "", "internal_ad" ],
    [ 2499982042, 2499980130, "Любители комедий", "internal", "crypta_segment-a4b80787_name", "crypta_segment-a4b80787_description", "all", "", "216", "719", "", "", "internal_ad" ],
    [ 2499982043, 2499980130, "Любители приключенческих фильмов", "internal", "crypta_segment-a97abeb0_name", "crypta_segment-a97abeb0_description", "all", "", "216", "717", "", "", "internal_ad" ],
    [ 2499982044, 2499980130, "Любители российских сериалов", "internal", "crypta_segment-b2144b0c_name", "crypta_segment-b2144b0c_description", "all", "", "557", "11204764", "", "", "internal_ad" ],
    [ 2499982045, 2499980130, "Любители российских сериалов", "internal", "crypta_segment-b2144b0c_name", "crypta_segment-b2144b0c_description", "all", "", "216", "743", "", "", "internal_ad" ],
    [ 2499982046, 2499980130, "Любители короткометражных фильмов", "internal", "crypta_segment-bb439407_name", "crypta_segment-bb439407_description", "all", "", "216", "734", "", "", "internal_ad" ],
    [ 2499982047, 2499980130, "Любители аниме", "internal", "crypta_segment-c012c203_name", "crypta_segment-c012c203_description", "all", "", "216", "739", "", "", "internal_ad" ],
    [ 2499982048, 2499980130, "Любители документальных фильмов", "internal", "crypta_segment-cd31aab0_name", "crypta_segment-cd31aab0_description", "all", "", "216", "721", "", "", "internal_ad" ],
    [ 2499982049, 2499980130, "Любители детективов", "internal", "crypta_segment-d914d4c5_name", "crypta_segment-d914d4c5_description", "all", "", "216", "729", "", "", "internal_ad" ],
    [ 2499982050, 2499980130, "Любители детективов", "internal", "crypta_segment-d914d4c5_name", "crypta_segment-d914d4c5_description", "all", "", "557", "11204740", "", "", "internal_ad" ],
    [ 2499982051, 2499980130, "Любители фэнтези", "internal", "crypta_segment-dd4ab70b_name", "crypta_segment-dd4ab70b_description", "all", "", "216", "723", "", "", "internal_ad" ],
    [ 2499982052, 2499980130, "Любители зарубежных сериалов", "internal", "crypta_segment-dd6791e0_name", "crypta_segment-dd6791e0_description", "all", "", "557", "11204758", "", "", "internal_ad" ],
    [ 2499982053, 2499980130, "Любители зарубежных сериалов", "internal", "crypta_segment-dd6791e0_name", "crypta_segment-dd6791e0_description", "all", "", "216", "744", "", "", "internal_ad" ],
    [ 2499982054, 2499980130, "Любители фильмов в жанре научной фантастики", "internal", "crypta_segment-e5199e6c_name", "crypta_segment-e5199e6c_description", "all", "", "216", "733", "", "", "internal_ad" ],
    [ 2499982055, 2499980131, "Интересуются Федуком", "internal", "crypta_segment-08b51dbd_name", "crypta_segment-08b51dbd_description", "all", "", "557", "12248260", "", "", "internal_ad" ],
    [ 2499982056, 2499980131, "Интересуются Федуком", "internal", "crypta_segment-08b51dbd_name", "crypta_segment-08b51dbd_description", "all", "", "549", "1391", "", "", "internal_ad" ],
    [ 2499982057, 2499980131, "Слушают Оксимирона", "internal", "crypta_segment-11e21a8d_name", "crypta_segment-11e21a8d_description", "all", "", "557", "12633271", "", "", "internal_ad" ],
    [ 2499982058, 2499980131, "Слушают Фэйса", "internal", "crypta_segment-33880b87_name", "crypta_segment-33880b87_description", "all", "", "557", "12633286", "", "", "internal_ad" ],
    [ 2499982059, 2499980131, "Слушают Modern Talking", "internal", "crypta_segment-393a40c8_name", "crypta_segment-393a40c8_description", "all", "", "557", "12633241", "", "", "internal_ad" ],
    [ 2499982060, 2499980131, "Слушают Успенскую", "internal", "crypta_segment-427bd22e_name", "crypta_segment-427bd22e_description", "all", "", "557", "12633280", "", "", "internal_ad" ],
    [ 2499982061, 2499980131, "Слушают ЛСП", "internal", "crypta_segment-43652646_name", "crypta_segment-43652646_description", "all", "", "557", "12633259", "", "", "internal_ad" ],
    [ 2499982062, 2499980131, "Слушают Сюткина", "internal", "crypta_segment-45ce3648_name", "crypta_segment-45ce3648_description", "all", "", "557", "12633277", "", "", "internal_ad" ],
    [ 2499982063, 2499980131, "Слушают Полину Гагарину", "internal", "crypta_segment-4909c3b1_name", "crypta_segment-4909c3b1_description", "all", "", "549", "1287", "", "", "internal_ad" ],
    [ 2499982064, 2499980131, "Слушают Полину Гагарину", "internal", "crypta_segment-4909c3b1_name", "crypta_segment-4909c3b1_description", "all", "", "557", "12169333", "", "", "internal_ad" ],
    [ 2499982065, 2499980131, "Слушают Jan Khalib", "internal", "crypta_segment-4d18516e_name", "crypta_segment-4d18516e_description", "all", "", "549", "1284", "", "", "internal_ad" ],
    [ 2499982066, 2499980131, "Слушают Jan Khalib", "internal", "crypta_segment-4d18516e_name", "crypta_segment-4d18516e_description", "all", "", "557", "12169120", "", "", "internal_ad" ],
    [ 2499982067, 2499980131, "Слушают Фараона", "internal", "crypta_segment-54daae74_name", "crypta_segment-54daae74_description", "all", "", "557", "12633283", "", "", "internal_ad" ],
    [ 2499982068, 2499980131, "Слушают Depeche Mode", "internal", "crypta_segment-5a158a81_name", "crypta_segment-5a158a81_description", "all", "", "557", "12633238", "", "", "internal_ad" ],
    [ 2499982069, 2499980131, "Интересуются Полиной Гагариной", "internal", "crypta_segment-67a443b3_name", "crypta_segment-67a443b3_description", "all", "", "549", "1392", "", "", "internal_ad" ],
    [ 2499982070, 2499980131, "Интересуются Полиной Гагариной", "internal", "crypta_segment-67a443b3_name", "crypta_segment-67a443b3_description", "all", "", "557", "12248257", "", "", "internal_ad" ],
    [ 2499982071, 2499980131, "Слушают Реву", "internal", "crypta_segment-6b76d943_name", "crypta_segment-6b76d943_description", "all", "", "557", "12633274", "", "", "internal_ad" ],
    [ 2499982072, 2499980131, "Интересуются Успенской", "internal", "crypta_segment-6e6565a8_name", "crypta_segment-6e6565a8_description", "all", "", "557", "12633229", "", "", "internal_ad" ],
    [ 2499982073, 2499980131, "Слушают Ленинград", "internal", "crypta_segment-785b2535_name", "crypta_segment-785b2535_description", "all", "", "557", "12633265", "", "", "internal_ad" ],
    [ 2499982074, 2499980131, "Интересуются Реввой", "internal", "crypta_segment-78e04e89_name", "crypta_segment-78e04e89_description", "all", "", "557", "12627880", "", "", "internal_ad" ],
    [ 2499982075, 2499980131, "Интересуются Комеди Клаб или КВН", "internal", "crypta_segment-7cd00ba3_name", "crypta_segment-7cd00ba3_description", "all", "", "557", "12627868", "", "", "internal_ad" ],
    [ 2499982076, 2499980131, "Слушают Антона Беляева", "internal", "crypta_segment-83de9371_name", "crypta_segment-83de9371_description", "all", "", "557", "12169321", "", "", "internal_ad" ],
    [ 2499982077, 2499980131, "Слушают Антона Беляева", "internal", "crypta_segment-83de9371_name", "crypta_segment-83de9371_description", "all", "", "549", "1285", "", "", "internal_ad" ],
    [ 2499982078, 2499980131, "Слушают Браво", "internal", "crypta_segment-8562c977_name", "crypta_segment-8562c977_description", "all", "", "557", "12633247", "", "", "internal_ad" ],
    [ 2499982079, 2499980131, "Интересуются Антоном Беляевым", "internal", "crypta_segment-9a529185_name", "crypta_segment-9a529185_description", "all", "", "549", "1389", "", "", "internal_ad" ],
    [ 2499982080, 2499980131, "Интересуются Антоном Беляевым", "internal", "crypta_segment-9a529185_name", "crypta_segment-9a529185_description", "all", "", "557", "12248248", "", "", "internal_ad" ],
    [ 2499982081, 2499980131, "Слушают Федука", "internal", "crypta_segment-a106ce83_name", "crypta_segment-a106ce83_description", "all", "", "557", "12169336", "", "", "internal_ad" ],
    [ 2499982082, 2499980131, "Слушают Федука", "internal", "crypta_segment-a106ce83_name", "crypta_segment-a106ce83_description", "all", "", "549", "1288", "", "", "internal_ad" ],
    [ 2499982083, 2499980131, "Слушают Ваенгу", "internal", "crypta_segment-a3735d6c_name", "crypta_segment-a3735d6c_description", "all", "", "557", "12633256", "", "", "internal_ad" ],
    [ 2499982084, 2499980131, "Интересуются Агутиным", "internal", "crypta_segment-aca17e29_name", "crypta_segment-aca17e29_description", "all", "", "557", "12627853", "", "", "internal_ad" ],
    [ 2499982085, 2499980131, "Интересуются Jan Khalib", "internal", "crypta_segment-b3161594_name", "crypta_segment-b3161594_description", "all", "", "557", "12248239", "", "", "internal_ad" ],
    [ 2499982086, 2499980131, "Интересуются Jan Khalib", "internal", "crypta_segment-b3161594_name", "crypta_segment-b3161594_description", "all", "", "549", "1388", "", "", "internal_ad" ],
    [ 2499982087, 2499980131, "Слушают Big Russian Boss", "internal", "crypta_segment-b6754e7a_name", "crypta_segment-b6754e7a_description", "all", "", "557", "12640018", "", "", "internal_ad" ],
    [ 2499982088, 2499980131, "Интересуются Горозией (L'One)", "internal", "crypta_segment-b824bde8_name", "crypta_segment-b824bde8_description", "all", "", "557", "12627862", "", "", "internal_ad" ],
    [ 2499982089, 2499980131, "Слушают Balck Star Label", "internal", "crypta_segment-c1871178_name", "crypta_segment-c1871178_description", "all", "", "557", "12633235", "", "", "internal_ad" ],
    [ 2499982090, 2499980131, "Интересуются Леной Темниковой", "internal", "crypta_segment-c4654226_name", "crypta_segment-c4654226_description", "all", "", "549", "1390", "", "", "internal_ad" ],
    [ 2499982091, 2499980131, "Интересуются Леной Темниковой", "internal", "crypta_segment-c4654226_name", "crypta_segment-c4654226_description", "all", "", "557", "12248251", "", "", "internal_ad" ],
    [ 2499982092, 2499980131, "Слушают Лену Темникову", "internal", "crypta_segment-d6b9dc46_name", "crypta_segment-d6b9dc46_description", "all", "", "557", "12169327", "", "", "internal_ad" ],
    [ 2499982093, 2499980131, "Слушают Лену Темникову", "internal", "crypta_segment-d6b9dc46_name", "crypta_segment-d6b9dc46_description", "all", "", "549", "1286", "", "", "internal_ad" ],
    [ 2499982094, 2499980131, "Интересуются Сюткиным и группой Браво", "internal", "crypta_segment-d75b328b_name", "crypta_segment-d75b328b_description", "all", "", "557", "12628135", "", "", "internal_ad" ],
    [ 2499982095, 2499980131, "Интересуются ЛСП", "internal", "crypta_segment-ddde3a6a_name", "crypta_segment-ddde3a6a_description", "all", "", "557", "12627874", "", "", "internal_ad" ],
    [ 2499982096, 2499980131, "Слушают Агутина", "internal", "crypta_segment-e5004d68_name", "crypta_segment-e5004d68_description", "all", "", "557", "12633244", "", "", "internal_ad" ],
    [ 2499982097, 2499980131, "Слушают Михайлова", "internal", "crypta_segment-e8e0cb2a_name", "crypta_segment-e8e0cb2a_description", "all", "", "557", "12633268", "", "", "internal_ad" ]
];

sub insert_data {
    my ($data) = @_;
    $log->out("going to insert:", $data);
    do_mass_insert_sql(PPCDICT, 'insert into crypta_goals (goal_id, parent_goal_id, name, crypta_goal_type, tanker_name_key, tanker_description_key, interest_type, tags, bb_keyword, bb_keyword_value, bb_keyword_short, bb_keyword_value_short, scope) values %s', $data);
}

$log->out('START');

insert_data($CATEGORIES);
insert_data($SEGMENTS);
insert_data($OTHER_SEGMENTS);

$log->out("FINISH");
